/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */

/*++

    Filename:

        hwinit.h

    Purpose:

        This file declares the subroutines that are used to initializate
        the ASIC.
        

--*/

ACIT_UEXACT32
hwi_init_mem_bars(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext,
    PACIT_VOID              osm_handle);

ACIT_UEXACT32
hwi_init_belib_library(
    PACIT_CONTROLLER_WS     pcontroller,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext,
    PBE_FUNCTION_OBJECT     pfo);

ACIT_UEXACT32
hwi_check_ue_at_init(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext);

ACIT_UEXACT32
hwi_check_and_issue_reset(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext,
    PBE_FUNCTION_OBJECT     pfo);

ACIT_UEXACT32
hwi_init_sa_rings(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi);

ACIT_UEXACT32
hwi_init_eq(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext,
    PBE_FUNCTION_OBJECT     pfo);

ACIT_UEXACT32
hwi_init_mgmt_attrib(
    PACIT_CONTROLLER_WS     pc);

ACIT_UEXACT32
hwi_init_mcc_rings(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext,
    PBE_FUNCTION_OBJECT     pfo);

ACIT_UEXACT32
hwi_init_cq(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext,
    PBE_FUNCTION_OBJECT     pfo);

ACIT_UEXACT32
hwi_init_rq(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext,
    PBE_FUNCTION_OBJECT     pfo);

ACIT_UEXACT32
hwi_init_template_headers(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext,
    PBE_FUNCTION_OBJECT     pfo);

ACIT_UEXACT32
hwi_init_sgl_pages(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext,
    PBE_FUNCTION_OBJECT     pfo);

ACIT_UEXACT32
hwi_init_wrb_rings(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi,
    PHWI_CONTEXT_MEMORY     pcontext,
    PBE_FUNCTION_OBJECT     pfo);

#if 0
hwi_init_msi_messages();
#endif

ACIT_VOID
hwi_init_vase_memory(
    PACIT_CONTROLLER_WS     pc,
    PHWI_CONTROLLER_WS      phwi);
