/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// manufacture, use,or sell anything that it may describe, in whole or in part, without   
// thespecific written consent of  EMULEX CORPORATION.  Any reproduction of thissource    
// code without the express written consent of EMULEX CORPORATION is aviolation of the    
// copyrights laws and may subject you to criminal prosecution.                           

// Autogenerated file. Do not edit!
// srcgen version: 0165
#ifndef __sh_iscsi_v2_bmap_h__
#define __sh_iscsi_v2_bmap_h__

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- WCON_SGE_ENUM ---
#define WCON_DATA_SGE_T_V2              (0)       
#define WCON_VSGE_SGE_T_V2              (1)       
#define WCON_CRA_SGE_T_V2               (2)       
#define WCON_NEXT_SGE_T_V2              (3)       
#define WCON_ADDR_SGE_T_V2              (4)       
#define WCON_LSP_SGE_T_V2               (5)       
#define WCON_PEE_ADDR_SGE_T_V2          (6)       
#define WCON_PEE_SEED_SGE_T_V2          (7)       
#define WCON_SEED_SGE_T_V2              (8)       
#define WCON_EE_SGE_T_V2                (9)       
#define WCON_DDR_SGE_T_V2               (10)      
#define WCON_CTX_SGE_T_V2               (11)      
#define WCON_SKIP_SGE_T_V2              (12)      

/*
typedef struct _ISCSI_CHAIN_SGE_V2 {
   union {
      struct { 
         u32 sgl_cra;                             // DWORD 0
         u32 rsvd0[1];                            // DWORDS 1 to 1
         u32 rsvd1 : 27;                          // DWORD 2
         u32 type : 4;                            // DWORD 2
         u32 last : 1;                            // DWORD 2
         u32 rsvd2[1];                            // DWORDS 3 to 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ISCSI_CHAIN_SGE_V2, *PISCSI_CHAIN_SGE_V2;

SG_C_ASSERT(__sizeof__ISCSI_CHAIN_SGE, sizeof (ISCSI_CHAIN_SGE_V2) == 16);
*/

typedef struct _ISCSI_CHAIN_SGE_V2 {
   union {
      struct { 
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 cra : 29;                            // DWORD 1
         u32 rsvd1 : 3;                           // DWORD 1
         u32 rsvd2 : 27;                          // DWORD 2
         u32 type : 4;                            // DWORD 2
         u32 last : 1;                            // DWORD 2
         u32 rsvd3[1];                            // DWORDS 3 to 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ISCSI_CHAIN_SGE_V2, *PISCSI_CHAIN_SGE_V2;

SG_C_ASSERT(__sizeof__ISCSI_CHAIN_SGE_V2, sizeof (ISCSI_CHAIN_SGE_V2) == 16);

typedef struct _ISCSI_SGL_CRA_V2 {
   union {
      struct { 
         u32 offset : 4;                          // DWORD 0
         u32 frag_num : 5;                        // DWORD 0
         u32 sgl_index : 16;                      // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 constant : 2;                        // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK ISCSI_SGL_CRA_V2, *PISCSI_SGL_CRA_V2;

SG_C_ASSERT(__sizeof__ISCSI_SGL_CRA, sizeof (ISCSI_SGL_CRA_V2) == 4);



typedef struct _ISCSI_SKH_CQE_V2 {
   union {
      struct { 
         u32 mode_specific1[2];                   // DWORDS 0 to 1
         u32 code : 6;                            // DWORD 2
         u32 mode_specific2 : 26;                 // DWORD 2
         u32 mode_specific3 : 31;                 // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ISCSI_SKH_CQE_V2, *PISCSI_SKH_CQE_V2;

SG_C_ASSERT(__sizeof__ISCSI_SKH_CQE, sizeof (ISCSI_SKH_CQE_V2) == 16);



typedef struct _I_T_SKH_DPDU_CQE_V2 {
   union {
      struct { 
         u32 db_addr_hi;                          // DWORD 0
         u32 db_addr_lo;                          // DWORD 1
         u32 code : 6;                            // DWORD 2
         u32 num_cons : 1;                        // DWORD 2
         u32 rsvd0 : 8;                           // DWORD 2
         u32 DataPlacementLength : 17;            // DWORD 2
         u32 index : 16;                          // DWORD 3
         u32 cid : 13;                            // DWORD 3
         u32 rsvd1 : 1;                           // DWORD 3
         u32 final : 1;                           // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK I_T_SKH_DPDU_CQE_V2, *PI_T_SKH_DPDU_CQE_V2;

SG_C_ASSERT(__sizeof__I_T_SKH_DPDU_CQE, sizeof (I_T_SKH_DPDU_CQE_V2) == 16);



typedef struct _I_T_SKH_DMSG_CQE_V2 {
   union {
      struct { 
         u32 ack_num;                             // DWORD 0
         u32 pdu_bytes_rcvd;                      // DWORD 1
         u32 code : 6;                            // DWORD 2
         u32 rsvd0 : 10;                          // DWORD 2
         u32 wrb_index : 16;                      // DWORD 2
         u32 rsvd1 : 16;                          // DWORD 3
         u32 cid : 13;                            // DWORD 3
         u32 rsvd2 : 2;                           // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK I_T_SKH_DMSG_CQE_V2, *PI_T_SKH_DMSG_CQE_V2;

SG_C_ASSERT(__sizeof__I_T_SKH_DMSG_CQE, sizeof (I_T_SKH_DMSG_CQE_V2) == 16);



typedef struct _I_SKH_SOL_CQE_V2 {
   union {
      struct { 
         u32 hw_sts : 8;                          // DWORD 0
         u32 i_sts_rsp : 8;                       // DWORD 0
         u32 wrb_index : 16;                      // DWORD 0
         u32 i_exp_cmd_sn;                        // DWORD 1
         u32 code : 6;                            // DWORD 2
         u32 cmd_complete : 1;                    // DWORD 2
         u32 rsvd0 : 1;                           // DWORD 2
         u32 i_cmd_wnd : 8;                       // DWORD 2
         u32 cid : 13;                            // DWORD 2
         u32 u : 1;                               // DWORD 2
         u32 o : 1;                               // DWORD 2
         u32 s : 1;                               // DWORD 2
         u32 i_res_cnt : 31;                      // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK I_SKH_SOL_CQE_V2, *PI_SKH_SOL_CQE_V2;

SG_C_ASSERT(__sizeof__I_SKH_SOL_CQE, sizeof (I_SKH_SOL_CQE_V2) == 16);


typedef struct _ISCSI_SKH_WRB_V2 {
   union {
      struct { 
         u32 r2t_exp_dtl : 25;                    // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 type : 5;                            // DWORD 0
         u32 ptr2NextWrb : 8;                     // DWORD 1
         u32 wrb_idx : 8;                         // DWORD 1
         u32 lun : 16;                            // DWORD 1
         u32 sgl_idx : 16;                        // DWORD 2
         u32 ref_sgl_icd_idx : 16;                // DWORD 2
         u32 exp_data_sn;                         // DWORD 3
         u32 iscsi_bhs_addr_hi;                   // DWORD 4
         u32 iscsi_bhs_addr_lo;                   // DWORD 5
         u32 cq_id : 16;                          // DWORD 6
         u32 BlkSz : 3;                           // DWORD 6
         u32 Opc_Rx : 4;                          // DWORD 6
         u32 rsvd1 : 7;                           // DWORD 6
         u32 rsvd2 : 2;                           // DWORD 6
         u32 cmdsn_itt;                           // DWORD 7
         u32 sge0_addr_hi;                        // DWORD 8
         u32 sge0_addr_lo;                        // DWORD 9
         u32 sge0_offset : 24;                    // DWORD 10
         u32 rsvd3 : 7;                           // DWORD 10
         u32 sge0_last : 1;                       // DWORD 10
         u32 sge0_len : 17;                       // DWORD 11
         u32 rsvd4 : 7;                           // DWORD 11
         u32 dif_enabled : 1;                     // DWORD 11
         u32 undr_run : 1;                        // DWORD 11
         u32 over_run : 1;                        // DWORD 11
         u32 invld : 1;                           // DWORD 11
         u32 dsp : 1;                             // DWORD 11
         u32 dmsg : 1;                            // DWORD 11
         u32 pbs : 1;                             // DWORD 11
         u32 lt : 1;                              // DWORD 11
         u32 sge1_addr_hi;                        // DWORD 12
         u32 sge1_addr_lo;                        // DWORD 13
         u32 sge1_r2t_offset : 24;                // DWORD 14
         u32 rsvd5 : 7;                           // DWORD 14
         u32 sge1_last : 1;                       // DWORD 14
         u32 sge1_len : 17;                       // DWORD 15
         u32 rsvd6 : 15;                          // DWORD 15
      } SG_PACK ; // unnamed struct
      u32 dw[16]; // dword union
   }; // unnamed union
} SG_PACK ISCSI_SKH_WRB_V2, *PISCSI_SKH_WRB_V2;

SG_C_ASSERT(__sizeof__ISCSI_SKH_WRB_V2, sizeof (ISCSI_SKH_WRB_V2) == 64);



typedef struct _WRB_POST_DB_V2 {
   union {
      struct { 
         u32 wrb_cid : 16;                        // DWORD 0
         u32 wrb_index : 8;                       // DWORD 0
         u32 numberPosted : 8;                    // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK WRB_POST_DB_V2, *PWRB_POST_DB_V2;

SG_C_ASSERT(__sizeof__WRB_POST_DB, sizeof (WRB_POST_DB_V2) == 4);



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __sh_iscsi_v2_bmap_h__

