/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// manufacture, use,or sell anything that it may describe, in whole or in part, without   
// thespecific written consent of  EMULEX CORPORATION.  Any reproduction of thissource    
// code without the express written consent of EMULEX CORPORATION is aviolation of the    
// copyrights laws and may subject you to criminal prosecution.                           

// Autogenerated file. Do not edit!
// srcgen version: 0175
#ifndef __cor_nic_cor_bmap_h__
#define __cor_nic_cor_bmap_h__

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif


typedef struct _ETH_RX_COMPL_COR {
   union {
      struct { 
         u32 vlan_tag : 16;                       // DWORD 0
         u32 pktsize : 14;                        // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 ip_opt : 1;                          // DWORD 0
         u32 err : 1;                             // DWORD 1
         u32 rsshp : 1;                           // DWORD 1
         u32 ipf : 1;                             // DWORD 1
         u32 tcpf : 1;                            // DWORD 1
         u32 udpf : 1;                            // DWORD 1
         u32 ipcksm : 1;                          // DWORD 1
         u32 l4_cksm : 1;                         // DWORD 1
         u32 ip_version : 1;                      // DWORD 1
         u32 fragndx : 12;                        // DWORD 1
         u32 rsvd0 : 6;                           // DWORD 1
         u32 ct : 2;                              // DWORD 1
         u32 sw : 1;                              // DWORD 1
         u32 numfrags : 3;                        // DWORD 1
         u32 rss_flush : 1;                       // DWORD 2
         u32 cast_enc : 2;                        // DWORD 2
         u32 QnQ : 1;                             // DWORD 2
         u32 rss_bank : 1;                        // DWORD 2
         u32 port : 3;                            // DWORD 2
         u32 header_len : 8;                      // DWORD 2
         u32 header_split : 2;                    // DWORD 2
         u32 rsvd1 : 4;                           // DWORD 2
         u32 timestamp_present : 1;               // DWORD 2
         u32 push : 1;                            // DWORD 2
         u32 inline_tcp : 1;                      // DWORD 2
         u32 future_headers_present : 5;          // DWORD 2
         u32 tunneled : 1;                        // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 rsshash;                             // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ETH_RX_COMPL_COR, *PETH_RX_COMPL_COR;

SG_C_ASSERT(__sizeof__ETH_RX_COMPL, sizeof (ETH_RX_COMPL_COR) == 16);



typedef struct _ETH_TX_COMPL_COR {
   union {
      struct { 
         u32 wrb_index : 16;                      // DWORD 0
         u32 ct : 2;                              // DWORD 0
         u32 port : 3;                            // DWORD 0
         u32 timestamp_secs : 7;                  // DWORD 0
         u32 status : 4;                          // DWORD 0
         u32 user_bytes : 16;                     // DWORD 1
         u32 nwh_bytes : 8;                       // DWORD 1
         u32 lso : 1;                             // DWORD 1
         u32 cast_enc : 2;                        // DWORD 1
         u32 l3_type : 2;                         // DWORD 1
         u32 timestamp_secs7 : 1;                 // DWORD 1
         u32 timestamp_present : 1;               // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 1
         u32 timestamp_nanosecs;                  // DWORD 2
         u32 pkts : 16;                           // DWORD 3
         u32 ringid : 15;                         // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ETH_TX_COMPL_COR, *PETH_TX_COMPL_COR;

SG_C_ASSERT(__sizeof__ETH_TX_COMPL, sizeof (ETH_TX_COMPL_COR) == 16);



typedef struct _RXFILT_D_COR {
   union {
      struct { 
         u32 l2type : 2;                          // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 mac_id : 10;                         // DWORD 0
         u32 tho : 1;                             // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 l3type : 2;                          // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 dest_id : 13;                        // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 vtag : 16;                           // DWORD 1
         u32 len : 14;                            // DWORD 1
         u32 ct : 2;                              // DWORD 1
         u32 mpacrc;                              // DWORD 2
         u32 fpe : 3;                             // DWORD 3
         u32 zeropayload : 1;                     // DWORD 3
         u32 ack_only : 1;                        // DWORD 3
         u32 ip_opt : 1;                          // DWORD 3
         u32 sw : 1;                              // DWORD 3
         u32 port : 3;                            // DWORD 3
         u32 rsvd0 : 4;                           // DWORD 3
         u32 timestamp : 2;                       // DWORD 3
         u32 tcp_data_len : 16;                   // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK RXFILT_D_COR, *PRXFILT_D_COR;

SG_C_ASSERT(__sizeof__RXFILT_D, sizeof (RXFILT_D_COR) == 16);



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __cor_nic_cor_bmap_h__

