/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// manufacture, use,or sell anything that it may describe, in whole or in part, without   
// thespecific written consent of  EMULEX CORPORATION.  Any reproduction of thissource    
// code without the express written consent of EMULEX CORPORATION is aviolation of the    
// copyrights laws and may subject you to criminal prosecution.                           

// Autogenerated file. Do not edit!
// srcgen version: 0165
#ifndef __ioctl_sli_amap_h__
#define __ioctl_sli_amap_h__

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
typedef struct { BE_BIT native[8]; } BE_u8_SLI_AMAP; // native

typedef struct { BE_BIT native[16]; } BE_u16_SLI_AMAP; // native

typedef struct { BE_BIT native[32]; } BE_u32_SLI_AMAP; // native

typedef struct { BE_BIT native[64]; } BE_u64_SLI_AMAP; // native

typedef struct { BE_BIT native[32]; } BE_void_SLI_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_CHAR_SLI_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_BOOLEAN_SLI_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_EXACT8_SLI_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_UEXACT8_SLI_AMAP; // native

typedef struct { BE_BIT native[16]; } BE_EXACT16_SLI_AMAP; // native

typedef struct { BE_BIT native[16]; } BE_UEXACT16_SLI_AMAP; // native

typedef struct { BE_BIT native[32]; } BE_UEXACT32_SLI_AMAP; // native

typedef struct { BE_BIT native[64]; } BE_UEXACT64_SLI_AMAP; // native

typedef struct {
   BE_BIT lo[32];                                 // DWORD 0
   BE_BIT hi[32];                                 // DWORD 1
} SG_PACK BE_PHYS_ADDR_SLI_AMAP;
typedef struct { u32 dw[2]; } PHYS_ADDR_SLI_AMAP, *PPHYS_ADDR_SLI_AMAP;


typedef struct {
   BE_BIT opcode[8];                              // DWORD 0
   BE_BIT subsystem[8];                           // DWORD 0
   BE_BIT port_number[8];                         // DWORD 0
   BE_BIT domain[8];                              // DWORD 0
   BE_BIT timeout[32];                            // DWORD 1
   BE_BIT request_length[32];                     // DWORD 2
   BE_BIT version[8];                             // DWORD 3
   BE_BIT rsvd0[8];                               // DWORD 3
   BE_BIT pfnumber[10];                           // DWORD 3
   BE_BIT vhnumber[6];                            // DWORD 3
} SG_PACK BE_IOCTL_REQUEST_HEADER_SLI_AMAP;
typedef struct { u32 dw[4]; } IOCTL_REQUEST_HEADER_SLI_AMAP, *PIOCTL_REQUEST_HEADER_SLI_AMAP;


typedef struct {
   BE_BIT opcode[8];                              // DWORD 0
   BE_BIT subsystem[8];                           // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT domain[8];                              // DWORD 0
   BE_BIT status[8];                              // DWORD 1
   BE_BIT additional_status[16];                  // DWORD 1
   BE_BIT rsvd1[8];                               // DWORD 1
   BE_BIT response_length[32];                    // DWORD 2
   BE_BIT actual_response_length[32];             // DWORD 3
} SG_PACK BE_IOCTL_RESPONSE_HEADER_SLI_AMAP;
typedef struct { u32 dw[4]; } IOCTL_RESPONSE_HEADER_SLI_AMAP, *PIOCTL_RESPONSE_HEADER_SLI_AMAP;


typedef union {
   BE_IOCTL_REQUEST_HEADER_SLI_AMAP request;
   BE_IOCTL_RESPONSE_HEADER_SLI_AMAP response;
} SG_PACK BE_IOCTL_HEADER_SLI_AMAP;
typedef struct { u32 dw[4]; } IOCTL_HEADER_SLI_AMAP, *PIOCTL_HEADER_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[12];                              // DWORD 0
   BE_BIT CoalescWM[2];                           // DWORD 0
   BE_BIT NoDelay;                                // DWORD 0
   BE_BIT autovalid;                              // DWORD 0
   BE_BIT rsvd1[11];                              // DWORD 0
   BE_BIT Count[2];                               // DWORD 0
   BE_BIT valid;                                  // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT Eventable;                              // DWORD 0
   BE_BIT EQID[16];                               // DWORD 1
   BE_BIT rsvd3[15];                              // DWORD 1
   BE_BIT Armed;                                  // DWORD 1
   BE_BIT CQE_COUNT[16];                          // DWORD 2
   BE_BIT rsvd4[16];                              // DWORD 2
   BE_BIT rsvd5[32];                              // DWORD 3
} SG_PACK BE_CQ_CTX_V2_SLI_AMAP;
typedef struct { u32 dw[4]; } CQ_CTX_V2_SLI_AMAP, *PCQ_CTX_V2_SLI_AMAP;


typedef struct {
   BE_BIT num_pages[16];                          // DWORD 0
   BE_BIT page_size[8];                           // DWORD 0
   BE_BIT cq_type[4];                             // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_CQ_CTX_V2_SLI_AMAP context;
   BE_PHYS_ADDR_SLI_AMAP pages[8];
} SG_PACK BE_CQ_CREATE_V2_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[21]; } CQ_CREATE_V2_PARAMS_IN_SLI_AMAP, *PCQ_CREATE_V2_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT16_SLI_AMAP cq_id;
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_CQ_CREATE_V2_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } CQ_CREATE_V2_PARAMS_OUT_SLI_AMAP, *PCQ_CREATE_V2_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_CQ_CREATE_V2_PARAMS_IN_SLI_AMAP request;
   BE_CQ_CREATE_V2_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_CQ_CREATE_V2_PARAMS_SLI_AMAP;
typedef struct { u32 dw[21]; } CQ_CREATE_V2_PARAMS_SLI_AMAP, *PCQ_CREATE_V2_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_CQ_CREATE_V2_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_CQ_CREATE_V2_SLI_AMAP;
typedef struct { u32 dw[25]; } IOCTL_COMMON_CQ_CREATE_V2_SLI_AMAP, *PIOCTL_COMMON_CQ_CREATE_V2_SLI_AMAP;


typedef struct {
   BE_BIT num_pages[8];                           // DWORD 0
   BE_BIT ulp_num[8];                             // DWORD 0
   BE_BIT type[8];                                // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT pv_id_valid;                            // DWORD 0
   BE_BIT bind_q;                                 // DWORD 0
   BE_UEXACT16_SLI_AMAP iface_id;
   BE_UEXACT8_SLI_AMAP queue_size;
   BE_BIT rsvd1[8];                               // DWORD 1
   BE_UEXACT8_SLI_AMAP wq_pg_sz;
   BE_BIT rsvd2[8];                               // DWORD 2
   BE_BIT rsvd3[16];                              // DWORD 2
   BE_UEXACT16_SLI_AMAP cq_id;
   BE_UEXACT16_SLI_AMAP pd_id;
   BE_BIT rsvd4[13][32];                          // DWORD 4
   BE_PHYS_ADDR_SLI_AMAP pages[8];
} SG_PACK BE_TX_CREATE_V2_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[33]; } TX_CREATE_V2_PARAMS_IN_SLI_AMAP, *PTX_CREATE_V2_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT16_SLI_AMAP id;
   BE_UEXACT16_SLI_AMAP rid;
   BE_UEXACT32_SLI_AMAP doorbell_offset;
   BE_UEXACT8_SLI_AMAP class_queue_id;
   BE_BIT rsvd0[8];                               // DWORD 2
   BE_UEXACT8_SLI_AMAP db_bar_reg_set;
   BE_UEXACT8_SLI_AMAP db_format;
   BE_UEXACT32_SLI_AMAP dpp_roc_offset;
   BE_BIT dpp_credits[8];                         // DWORD 4
   BE_BIT rsvd1[8];                               // DWORD 4
   BE_BIT dpp_roc_bar_reg_set[8];                 // DWORD 4
   BE_BIT rsvd2[7];                               // DWORD 4
   BE_BIT dpp_en;                                 // DWORD 4
   BE_UEXACT16_SLI_AMAP max_num_wqes;
   BE_UEXACT8_SLI_AMAP roc_queue_pg_count;
   BE_BIT rsvd3[8];                               // DWORD 5
} SG_PACK BE_TX_CREATE_V2_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[6]; } TX_CREATE_V2_PARAMS_OUT_SLI_AMAP, *PTX_CREATE_V2_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_TX_CREATE_V2_PARAMS_IN_SLI_AMAP request;
   BE_TX_CREATE_V2_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_TX_CREATE_V2_PARAMS_SLI_AMAP;
typedef struct { u32 dw[33]; } TX_CREATE_V2_PARAMS_SLI_AMAP, *PTX_CREATE_V2_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_TX_CREATE_V2_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_ETH_TX_CREATE_V2_SLI_AMAP;
typedef struct { u32 dw[37]; } IOCTL_ETH_TX_CREATE_V2_SLI_AMAP, *PIOCTL_ETH_TX_CREATE_V2_SLI_AMAP;


typedef struct {
   BE_UEXACT16_SLI_AMAP id;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT roc;                                    // DWORD 1
   BE_BIT surf;                                   // DWORD 1
   BE_BIT rsvd1[30];                              // DWORD 1
} SG_PACK BE_ETH_TX_DESTROY_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[2]; } ETH_TX_DESTROY_PARAMS_IN_SLI_AMAP, *PETH_TX_DESTROY_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_ETH_TX_DESTROY_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } ETH_TX_DESTROY_PARAMS_OUT_SLI_AMAP, *PETH_TX_DESTROY_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_ETH_TX_DESTROY_PARAMS_IN_SLI_AMAP request;
   BE_ETH_TX_DESTROY_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_ETH_TX_DESTROY_PARAMS_SLI_AMAP;
typedef struct { u32 dw[2]; } ETH_TX_DESTROY_PARAMS_SLI_AMAP, *PETH_TX_DESTROY_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_ETH_TX_DESTROY_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_ETH_TX_DESTROY_SLI_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ETH_TX_DESTROY_SLI_AMAP, *PIOCTL_ETH_TX_DESTROY_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_ACTIVE_PROFILE_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } GET_ACTIVE_PROFILE_PARAMS_IN_SLI_AMAP, *PGET_ACTIVE_PROFILE_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT16_SLI_AMAP active_profile_id;
   BE_UEXACT16_SLI_AMAP next_active_profile_id;
} SG_PACK BE_GET_ACTIVE_PROFILE_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } GET_ACTIVE_PROFILE_PARAMS_OUT_SLI_AMAP, *PGET_ACTIVE_PROFILE_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_GET_ACTIVE_PROFILE_PARAMS_IN_SLI_AMAP request;
   BE_GET_ACTIVE_PROFILE_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_GET_ACTIVE_PROFILE_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } GET_ACTIVE_PROFILE_PARAMS_SLI_AMAP, *PGET_ACTIVE_PROFILE_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_GET_ACTIVE_PROFILE_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_ACTIVE_PROFILE_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_ACTIVE_PROFILE_SLI_AMAP, *PIOCTL_COMMON_GET_ACTIVE_PROFILE_SLI_AMAP;


typedef struct {
   BE_BIT operation[8];                           // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT strip_tunnel_header;                    // DWORD 0
   BE_BIT tenant_id_present;                      // DWORD 0
   BE_BIT vlan_tag_present;                       // DWORD 0
   BE_BIT rsvd1[13];                              // DWORD 0
   BE_UEXACT32_SLI_AMAP tunnel_iface_id;
   BE_UEXACT32_SLI_AMAP target_iface_id;
   BE_UEXACT8_SLI_AMAP mac_address[6];
   BE_UEXACT16_SLI_AMAP vlan_tag;
   BE_UEXACT32_SLI_AMAP tenant_id;
   BE_UEXACT32_SLI_AMAP filter_id;
   BE_UEXACT32_SLI_AMAP cap_flags;
   BE_UEXACT32_SLI_AMAP cap_control_flags;
} SG_PACK BE_NTWK_MANAGE_IFACE_FILTERS_REQUEST_SLI_AMAP;
typedef struct { u32 dw[9]; } NTWK_MANAGE_IFACE_FILTERS_REQUEST_SLI_AMAP, *PNTWK_MANAGE_IFACE_FILTERS_REQUEST_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP if_id;
   BE_UEXACT32_SLI_AMAP filter_id;
   BE_BIT rsvd0[7][32];                           // DWORD 2
} SG_PACK BE_NTWK_MANAGE_IFACE_FILTERS_RESPONSE_SLI_AMAP;
typedef struct { u32 dw[9]; } NTWK_MANAGE_IFACE_FILTERS_RESPONSE_SLI_AMAP, *PNTWK_MANAGE_IFACE_FILTERS_RESPONSE_SLI_AMAP;


typedef union {
   BE_NTWK_MANAGE_IFACE_FILTERS_REQUEST_SLI_AMAP request;
   BE_NTWK_MANAGE_IFACE_FILTERS_RESPONSE_SLI_AMAP response;
} SG_PACK BE_NTWK_MANAGE_IFACE_FILTERS_PARAMS_SLI_AMAP;
typedef struct { u32 dw[9]; } NTWK_MANAGE_IFACE_FILTERS_PARAMS_SLI_AMAP, *PNTWK_MANAGE_IFACE_FILTERS_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_NTWK_MANAGE_IFACE_FILTERS_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI_AMAP;
typedef struct { u32 dw[13]; } IOCTL_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI_AMAP, *PIOCTL_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI_AMAP;


typedef struct {
   BE_BIT res_desc_type[8];                       // DWORD 0
   BE_BIT descriptor_length[8];                   // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
   BE_BIT immediate;                              // DWORD 0
   BE_BIT no_save;                                // DWORD 0
   BE_BIT rsvd1[16];                              // DWORD 1
   BE_BIT pf_number[10];                          // DWORD 1
   BE_BIT rsvd2[6];                               // DWORD 1
   BE_BIT rsvd3[32];                              // DWORD 2
   BE_UEXACT8_SLI_AMAP sriov_state;
   BE_UEXACT8_SLI_AMAP pf_state;
   BE_UEXACT8_SLI_AMAP pf_type;
   BE_BIT rsvd4[8];                               // DWORD 3
   BE_UEXACT16_SLI_AMAP number_vfs;
   BE_BIT rsvd5[16];                              // DWORD 4
   BE_BIT mission_roles[8];                       // DWORD 5
   BE_BIT rsvd6[19];                              // DWORD 5
   BE_BIT presentation_chg;                       // DWORD 5
   BE_BIT sriov_state_chg;                        // DWORD 5
   BE_BIT xrom_chg;                               // DWORD 5
   BE_BIT xrom[2];                                // DWORD 5
   BE_BIT rsvd7[16][32];                          // DWORD 6
} SG_PACK BE_SLI4_RESC_DESC_PCIE_SLI_AMAP;
typedef struct { u32 dw[22]; } SLI4_RESC_DESC_PCIE_SLI_AMAP, *PSLI4_RESC_DESC_PCIE_SLI_AMAP;


typedef struct {
   BE_BIT res_desc_type[8];                       // DWORD 0
   BE_BIT descriptor_length[8];                   // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT pf_pool;                                // DWORD 0
   BE_BIT logical_link_disable_valid;             // DWORD 0
   BE_BIT iface_caps_flags_valid;                 // DWORD 0
   BE_BIT mac_addr_valid;                         // DWORD 0
   BE_BIT vlan_valid;                             // DWORD 0
   BE_BIT vf_template;                            // DWORD 0
   BE_BIT qos_units;                              // DWORD 0
   BE_BIT del;                                    // DWORD 0
   BE_BIT immediate;                              // DWORD 0
   BE_BIT no_save;                                // DWORD 0
   BE_BIT vf_number[8];                           // DWORD 1
   BE_BIT rsvd1[8];                               // DWORD 1
   BE_BIT pf_number[10];                          // DWORD 1
   BE_BIT rsvd2[6];                               // DWORD 1
   BE_UEXACT16_SLI_AMAP mac_unicast_count;
   BE_UEXACT8_SLI_AMAP mac_address[6];
   BE_UEXACT16_SLI_AMAP mq_count;
   BE_UEXACT16_SLI_AMAP vlan_count;
   BE_UEXACT16_SLI_AMAP mac_mcast_count;
   BE_UEXACT16_SLI_AMAP wq_count;
   BE_UEXACT16_SLI_AMAP rq_count;
   BE_UEXACT16_SLI_AMAP rss_queue_count;
   BE_UEXACT16_SLI_AMAP lro_queue_count;
   BE_UEXACT16_SLI_AMAP cq_count;
   BE_UEXACT16_SLI_AMAP toe_conn_count;
   BE_UEXACT16_SLI_AMAP eq_count;
   BE_UEXACT16_SLI_AMAP vlan_id;
   BE_UEXACT16_SLI_AMAP iface_count;
   BE_UEXACT32_SLI_AMAP iface_caps_flags;
   BE_BIT link_number[6];                         // DWORD 11
   BE_BIT link_type[2];                           // DWORD 11
   BE_BIT lmc;                                    // DWORD 11
   BE_BIT lld;                                    // DWORD 11
   BE_BIT rsvd3[6];                               // DWORD 11
   BE_BIT channel_id[12];                         // DWORD 11
   BE_BIT channel_id_type[4];                     // DWORD 11
   BE_UEXACT32_SLI_AMAP bw_min;
   BE_UEXACT32_SLI_AMAP bw_max;
   BE_BIT acpi_pattern_per_port[8];               // DWORD 14
   BE_BIT oob_wol[2];                             // DWORD 14
   BE_BIT wol[2];                                 // DWORD 14
   BE_BIT rsvd4[20];                              // DWORD 14
   BE_UEXACT16_SLI_AMAP tunnel_iface_count;
   BE_UEXACT16_SLI_AMAP direct_tenant_iface_count;
   BE_UEXACT16_SLI_AMAP roc_wq_count;
   BE_UEXACT16_SLI_AMAP dpp_wq_count;
   BE_BIT rsvd5[5][32];                           // DWORD 17
} SG_PACK BE_SLI4_RESC_DESC_NIC_SLI_AMAP;
typedef struct { u32 dw[22]; } SLI4_RESC_DESC_NIC_SLI_AMAP, *PSLI4_RESC_DESC_NIC_SLI_AMAP;


typedef struct {
   BE_BIT res_desc_type[8];                       // DWORD 0
   BE_BIT descriptor_length[8];                   // DWORD 0
   BE_BIT rsvd0[7];                               // DWORD 0
   BE_BIT logical_link_disable_valid;             // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT mac_addr_valid;                         // DWORD 0
   BE_BIT vlan_valid;                             // DWORD 0
   BE_BIT vf_template;                            // DWORD 0
   BE_BIT qos_units;                              // DWORD 0
   BE_BIT del;                                    // DWORD 0
   BE_BIT immediate;                              // DWORD 0
   BE_BIT no_save;                                // DWORD 0
   BE_BIT vf_number[8];                           // DWORD 1
   BE_BIT rsvd2[8];                               // DWORD 1
   BE_BIT pf_number[10];                          // DWORD 1
   BE_BIT rsvd3[6];                               // DWORD 1
   BE_UEXACT16_SLI_AMAP session_count;
   BE_UEXACT16_SLI_AMAP icd_count;
   BE_UEXACT16_SLI_AMAP cq_count;
   BE_UEXACT8_SLI_AMAP iscsi_mac_address[6];
   BE_UEXACT8_SLI_AMAP mq_count;
   BE_BIT rsvd4[8];                               // DWORD 5
   BE_UEXACT16_SLI_AMAP vlan_id;
   BE_UEXACT16_SLI_AMAP connection_count;
   BE_UEXACT16_SLI_AMAP eq_count;
   BE_UEXACT16_SLI_AMAP rbq_count;
   BE_UEXACT16_SLI_AMAP vlan_count;
   BE_BIT link_number[6];                         // DWORD 8
   BE_BIT link_type[2];                           // DWORD 8
   BE_BIT lmc;                                    // DWORD 8
   BE_BIT lld;                                    // DWORD 8
   BE_BIT rsvd5[6];                               // DWORD 8
   BE_BIT channel_id[12];                         // DWORD 8
   BE_BIT channel_id_type[4];                     // DWORD 8
   BE_UEXACT32_SLI_AMAP bw_min;
   BE_UEXACT32_SLI_AMAP bw_max;
   BE_UEXACT32_SLI_AMAP iops_min;
   BE_UEXACT32_SLI_AMAP iops_max;
   BE_BIT rsvd6[9][32];                           // DWORD 13
} SG_PACK BE_SLI4_RESC_DESC_ISCSI_SLI_AMAP;
typedef struct { u32 dw[22]; } SLI4_RESC_DESC_ISCSI_SLI_AMAP, *PSLI4_RESC_DESC_ISCSI_SLI_AMAP;


typedef struct {
   BE_BIT res_desc_type[8];                       // DWORD 0
   BE_BIT descriptor_length[8];                   // DWORD 0
   BE_BIT rsvd0[7];                               // DWORD 0
   BE_BIT logical_link_disable_valid;             // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT macAddr_valid;                          // DWORD 0
   BE_BIT vlan_valid;                             // DWORD 0
   BE_BIT vf_template;                            // DWORD 0
   BE_BIT qos_units;                              // DWORD 0
   BE_BIT del;                                    // DWORD 0
   BE_BIT immediate;                              // DWORD 0
   BE_BIT no_save;                                // DWORD 0
   BE_BIT vf_number[8];                           // DWORD 1
   BE_BIT rsvd2[8];                               // DWORD 1
   BE_BIT pf_number[10];                          // DWORD 1
   BE_BIT rsvd3[6];                               // DWORD 1
   BE_UEXACT16_SLI_AMAP rpi_count;
   BE_UEXACT16_SLI_AMAP xri_count;
   BE_UEXACT16_SLI_AMAP wq_count;
   BE_UEXACT16_SLI_AMAP rq_count;
   BE_UEXACT16_SLI_AMAP cq_count;
   BE_UEXACT16_SLI_AMAP vpi_count;
   BE_UEXACT16_SLI_AMAP fcfi_count;
   BE_UEXACT16_SLI_AMAP vfi_count;
   BE_UEXACT8_SLI_AMAP wwnn[8];
   BE_UEXACT8_SLI_AMAP wwpn[8];
   BE_BIT enode_mac[6][8];                        // DWORD 10
   BE_BIT channel_id[12];                         // DWORD 11
   BE_BIT channel_id_type[4];                     // DWORD 11
   BE_UEXACT16_SLI_AMAP vlan_id;
   BE_BIT rsvd4[16];                              // DWORD 12
   BE_BIT link_number[6];                         // DWORD 13
   BE_BIT link_type[2];                           // DWORD 13
   BE_BIT lmc;                                    // DWORD 13
   BE_BIT lld;                                    // DWORD 13
   BE_BIT rsvd5[6];                               // DWORD 13
   BE_BIT eq_count[16];                           // DWORD 13
   BE_UEXACT32_SLI_AMAP bw_min;
   BE_UEXACT32_SLI_AMAP bw_max;
   BE_UEXACT32_SLI_AMAP iops_min;
   BE_UEXACT32_SLI_AMAP iops_max;
   BE_BIT rsvd6[4][32];                           // DWORD 18
} SG_PACK BE_SLI4_RESC_DESC_FCOE_SLI_AMAP;
typedef struct { u32 dw[22]; } SLI4_RESC_DESC_FCOE_SLI_AMAP, *PSLI4_RESC_DESC_FCOE_SLI_AMAP;


typedef struct {
   BE_BIT res_desc_type[8];                       // DWORD 0
   BE_BIT descriptor_length[8];                   // DWORD 0
   BE_BIT rsvd0[11];                              // DWORD 0
   BE_BIT vf_template;                            // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT del;                                    // DWORD 0
   BE_BIT immediate;                              // DWORD 0
   BE_BIT no_save;                                // DWORD 0
   BE_BIT vf_number[8];                           // DWORD 1
   BE_BIT rsvd2[8];                               // DWORD 1
   BE_BIT pf_number[10];                          // DWORD 1
   BE_BIT rsvd3[6];                               // DWORD 1
   BE_UEXACT32_SLI_AMAP max_qp;
   BE_UEXACT16_SLI_AMAP max_pd;
   BE_UEXACT16_SLI_AMAP max_mr;
   BE_UEXACT16_SLI_AMAP max_mw;
   BE_UEXACT16_SLI_AMAP max_fmr;
   BE_UEXACT16_SLI_AMAP max_frmr;
   BE_UEXACT16_SLI_AMAP max_mcast_group;
   BE_UEXACT16_SLI_AMAP max_dpp_qp;
   BE_UEXACT16_SLI_AMAP max_srq;
   BE_UEXACT16_SLI_AMAP max_rpir_qp;
   BE_UEXACT16_SLI_AMAP max_dpp_pd;
   BE_BIT rsvd4[16];                              // DWORD 8
   BE_UEXACT16_SLI_AMAP max_dpp_credits;
   BE_BIT rsvd5[13][32];                          // DWORD 9
} SG_PACK BE_SLI4_RESC_DESC_RDMA_SLI_AMAP;
typedef struct { u32 dw[22]; } SLI4_RESC_DESC_RDMA_SLI_AMAP, *PSLI4_RESC_DESC_RDMA_SLI_AMAP;


typedef struct {
   BE_BIT res_desc_type[8];                       // DWORD 0
   BE_BIT descriptor_length[8];                   // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
   BE_BIT immediate;                              // DWORD 0
   BE_BIT no_save;                                // DWORD 0
   BE_BIT link_number[6];                         // DWORD 1
   BE_BIT link_type[2];                           // DWORD 1
   BE_BIT mc_type[8];                             // DWORD 1
   BE_BIT rsvd1[16];                              // DWORD 1
   BE_BIT nv_type[2];                             // DWORD 2
   BE_BIT socvid;                                 // DWORD 2
   BE_BIT sicvid;                                 // DWORD 2
   BE_BIT rcvid;                                  // DWORD 2
   BE_BIT dcbx_capability[2];                     // DWORD 2
   BE_BIT rsvd2[9];                               // DWORD 2
   BE_BIT nv_port_protocol[16];                   // DWORD 2
   BE_BIT max_pf_count[12];                       // DWORD 3
   BE_BIT rsvd3[4];                               // DWORD 3
   BE_BIT max_storage_pf_count[12];               // DWORD 3
   BE_BIT rsvd4[4];                               // DWORD 3
   BE_BIT max_nic_pf_count[12];                   // DWORD 4
   BE_BIT rsvd5[4];                               // DWORD 4
   BE_BIT max_roce_pf_count[12];                  // DWORD 4
   BE_BIT rsvd6[4];                               // DWORD 4
   BE_BIT max_iscsi_pf_count[12];                 // DWORD 5
   BE_BIT rsvd7[4];                               // DWORD 5
   BE_BIT max_fcoe_pf_count[12];                  // DWORD 5
   BE_BIT rsvd8[4];                               // DWORD 5
   BE_BIT rsvd9[16][32];                          // DWORD 6
} SG_PACK BE_SLI4_RESC_DESC_PORT_SLI_AMAP;
typedef struct { u32 dw[22]; } SLI4_RESC_DESC_PORT_SLI_AMAP, *PSLI4_RESC_DESC_PORT_SLI_AMAP;


typedef struct {
   BE_BIT res_desc_type[8];                       // DWORD 0
   BE_BIT descriptor_length[8];                   // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT iscsi_tgt;                              // DWORD 1
   BE_BIT iscsi_ini;                              // DWORD 1
   BE_BIT iscsi_DIF;                              // DWORD 1
   BE_BIT rsvd1[29];                              // DWORD 1
   BE_BIT rsvd2[3][32];                           // DWORD 2
   BE_BIT fcoe_tgt;                               // DWORD 5
   BE_BIT fcoe_ini;                               // DWORD 5
   BE_BIT fcoe_DIF;                               // DWORD 5
   BE_BIT rsvd3[29];                              // DWORD 5
   BE_BIT rsvd4[7][32];                           // DWORD 6
   BE_UEXACT8_SLI_AMAP MC_Type[4];
   BE_BIT rsvd5[3][32];                           // DWORD 14
} SG_PACK BE_SLI4_RESC_DESC_ISAP_SLI_AMAP;
typedef struct { u32 dw[17]; } SLI4_RESC_DESC_ISAP_SLI_AMAP, *PSLI4_RESC_DESC_ISAP_SLI_AMAP;


typedef struct {
   BE_BIT profile_id[8];                          // DWORD 0
   BE_BIT config_type[2];                         // DWORD 0
   BE_BIT census_mode;                            // DWORD 0
   BE_BIT rsvd0[21];                              // DWORD 0
} SG_PACK BE_GET_PROFILE_CONFIG_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } GET_PROFILE_CONFIG_PARAMS_IN_SLI_AMAP, *PGET_PROFILE_CONFIG_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP resource_descriptor_count;
   BE_SLI4_RESC_DESC_PCIE_SLI_AMAP resources[1];
} SG_PACK BE_GET_PROFILE_CONFIG_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[23]; } GET_PROFILE_CONFIG_PARAMS_OUT_SLI_AMAP, *PGET_PROFILE_CONFIG_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_GET_PROFILE_CONFIG_PARAMS_IN_SLI_AMAP request;
   BE_GET_PROFILE_CONFIG_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_GET_PROFILE_CONFIG_PARAMS_SLI_AMAP;
typedef struct { u32 dw[23]; } GET_PROFILE_CONFIG_PARAMS_SLI_AMAP, *PGET_PROFILE_CONFIG_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_GET_PROFILE_CONFIG_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PROFILE_CONFIG_SLI_AMAP;
typedef struct { u32 dw[27]; } IOCTL_COMMON_GET_PROFILE_CONFIG_SLI_AMAP, *PIOCTL_COMMON_GET_PROFILE_CONFIG_SLI_AMAP;


typedef struct {
   BE_BIT profile_id[8];                          // DWORD 0
   BE_BIT rsvd0[23];                              // DWORD 0
   BE_BIT ISAP;                                   // DWORD 0
   BE_UEXACT32_SLI_AMAP resource_descriptor_count;
   BE_SLI4_RESC_DESC_PCIE_SLI_AMAP resources[1];
} SG_PACK BE_SET_PROFILE_CONFIG_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[24]; } SET_PROFILE_CONFIG_PARAMS_IN_SLI_AMAP, *PSET_PROFILE_CONFIG_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_PROFILE_CONFIG_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } SET_PROFILE_CONFIG_PARAMS_OUT_SLI_AMAP, *PSET_PROFILE_CONFIG_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_SET_PROFILE_CONFIG_PARAMS_IN_SLI_AMAP request;
   BE_SET_PROFILE_CONFIG_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_SET_PROFILE_CONFIG_PARAMS_SLI_AMAP;
typedef struct { u32 dw[24]; } SET_PROFILE_CONFIG_PARAMS_SLI_AMAP, *PSET_PROFILE_CONFIG_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_SET_PROFILE_CONFIG_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_PROFILE_CONFIG_SLI_AMAP;
typedef struct { u32 dw[28]; } IOCTL_COMMON_SET_PROFILE_CONFIG_SLI_AMAP, *PIOCTL_COMMON_SET_PROFILE_CONFIG_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_FUNCTION_CONFIG_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } GET_FUNCTION_CONFIG_PARAMS_IN_SLI_AMAP, *PGET_FUNCTION_CONFIG_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP resource_descriptor_count;
   BE_SLI4_RESC_DESC_NIC_SLI_AMAP resources[2];
} SG_PACK BE_GET_FUNCTION_CONFIG_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[45]; } GET_FUNCTION_CONFIG_PARAMS_OUT_SLI_AMAP, *PGET_FUNCTION_CONFIG_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_GET_FUNCTION_CONFIG_PARAMS_IN_SLI_AMAP request;
   BE_GET_FUNCTION_CONFIG_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_GET_FUNCTION_CONFIG_PARAMS_SLI_AMAP;
typedef struct { u32 dw[45]; } GET_FUNCTION_CONFIG_PARAMS_SLI_AMAP, *PGET_FUNCTION_CONFIG_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_GET_FUNCTION_CONFIG_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_FUNCTION_CONFIG_SLI_AMAP;
typedef struct { u32 dw[49]; } IOCTL_COMMON_GET_FUNCTION_CONFIG_SLI_AMAP, *PIOCTL_COMMON_GET_FUNCTION_CONFIG_SLI_AMAP;


typedef struct {
   BE_BIT interrupts_enabled;                     // DWORD 0
   BE_BIT rsvd0[31];                              // DWORD 0
} SG_PACK BE_SET_INTERRUPT_ENABLE_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } SET_INTERRUPT_ENABLE_PARAMS_IN_SLI_AMAP, *PSET_INTERRUPT_ENABLE_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_INTERRUPT_ENABLE_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } SET_INTERRUPT_ENABLE_PARAMS_OUT_SLI_AMAP, *PSET_INTERRUPT_ENABLE_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_SET_INTERRUPT_ENABLE_PARAMS_IN_SLI_AMAP request;
   BE_SET_INTERRUPT_ENABLE_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_SET_INTERRUPT_ENABLE_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } SET_INTERRUPT_ENABLE_PARAMS_SLI_AMAP, *PSET_INTERRUPT_ENABLE_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_SET_INTERRUPT_ENABLE_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_INTERRUPT_ENABLE_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_SET_INTERRUPT_ENABLE_SLI_AMAP, *PIOCTL_COMMON_SET_INTERRUPT_ENABLE_SLI_AMAP;


typedef struct {
   BE_UEXACT8_SLI_AMAP caps_desc_type;
   BE_UEXACT8_SLI_AMAP descriptor_length;
   BE_BIT rsvd0[2][8];                            // DWORD 0
} SG_PACK BE_SLI4_CAPS_DESC_HEADER_SLI_AMAP;
typedef struct { u32 dw[1]; } SLI4_CAPS_DESC_HEADER_SLI_AMAP, *PSLI4_CAPS_DESC_HEADER_SLI_AMAP;


typedef struct {
   BE_SLI4_CAPS_DESC_HEADER_SLI_AMAP capHeader;
   BE_UEXACT8_SLI_AMAP max_pf_num;
   BE_BIT rsvd0[8];                               // DWORD 1
   BE_UEXACT8_SLI_AMAP mission_roles;
   BE_BIT rsvd1[8];                               // DWORD 1
   BE_UEXACT16_SLI_AMAP total_func;
   BE_BIT rsvd2[16];                              // DWORD 2
   BE_BIT rsvd3[7][32];                           // DWORD 3
} SG_PACK BE_SLI4_CAPS_DESC_PCIE_SLI_AMAP;
typedef struct { u32 dw[10]; } SLI4_CAPS_DESC_PCIE_SLI_AMAP, *PSLI4_CAPS_DESC_PCIE_SLI_AMAP;


typedef struct {
   BE_SLI4_CAPS_DESC_HEADER_SLI_AMAP capHeader;
   BE_UEXACT16_SLI_AMAP uc_count;
   BE_UEXACT16_SLI_AMAP vlan_count;
   BE_UEXACT16_SLI_AMAP rq_count;
   BE_UEXACT16_SLI_AMAP rss_rq_count;
   BE_UEXACT16_SLI_AMAP cq_count;
   BE_UEXACT16_SLI_AMAP wq_count;
   BE_UEXACT16_SLI_AMAP mq_count;
   BE_UEXACT16_SLI_AMAP eq_count;
   BE_BIT max_function_count[16];                 // DWORD 5
   BE_BIT wamode;                                 // DWORD 5
   BE_BIT rsvd0[15];                              // DWORD 5
   BE_UEXACT32_SLI_AMAP iface_caps_flags;
   BE_UEXACT8_SLI_AMAP acpi_patterns_total;
   BE_UEXACT8_SLI_AMAP nd_dip_total;
   BE_UEXACT8_SLI_AMAP arp_dip_total;
   BE_BIT rsvd1[8];                               // DWORD 7
   BE_UEXACT16_SLI_AMAP iface_count;
   BE_UEXACT16_SLI_AMAP tunnel_iface_count;
   BE_UEXACT16_SLI_AMAP roc_wq_count;
   BE_UEXACT16_SLI_AMAP dpp_wq_count;
} SG_PACK BE_SLI4_CAPS_DESC_NIC_SLI_AMAP;
typedef struct { u32 dw[10]; } SLI4_CAPS_DESC_NIC_SLI_AMAP, *PSLI4_CAPS_DESC_NIC_SLI_AMAP;


typedef struct {
   BE_SLI4_CAPS_DESC_HEADER_SLI_AMAP capHeader;
   BE_UEXACT16_SLI_AMAP session_count;
   BE_UEXACT16_SLI_AMAP icd_count;
   BE_UEXACT16_SLI_AMAP cq_count;
   BE_UEXACT16_SLI_AMAP connection_count;
   BE_UEXACT16_SLI_AMAP eq_count;
   BE_UEXACT16_SLI_AMAP rbq_count;
   BE_BIT rsvd0[16];                              // DWORD 4
   BE_UEXACT16_SLI_AMAP icd_alloc_units;
   BE_BIT max_function_count[16];                 // DWORD 5
   BE_BIT target;                                 // DWORD 5
   BE_BIT initiator;                              // DWORD 5
   BE_BIT DIF;                                    // DWORD 5
   BE_BIT rsvd1[13];                              // DWORD 5
   BE_BIT rsvd2[4][32];                           // DWORD 6
} SG_PACK BE_SLI4_CAPS_DESC_ISCSI_SLI_AMAP;
typedef struct { u32 dw[10]; } SLI4_CAPS_DESC_ISCSI_SLI_AMAP, *PSLI4_CAPS_DESC_ISCSI_SLI_AMAP;


typedef struct {
   BE_SLI4_CAPS_DESC_HEADER_SLI_AMAP capHeader;
   BE_UEXACT16_SLI_AMAP xri_count;
   BE_UEXACT16_SLI_AMAP xri_alloc_units;
   BE_UEXACT16_SLI_AMAP rpi_count;
   BE_UEXACT16_SLI_AMAP rpi_alloc_units;
   BE_UEXACT16_SLI_AMAP vpi_count;
   BE_UEXACT16_SLI_AMAP vpi_alloc_units;
   BE_UEXACT16_SLI_AMAP vfi_count;
   BE_UEXACT16_SLI_AMAP vfi_alloc_units;
   BE_UEXACT16_SLI_AMAP max_function_count;
   BE_UEXACT16_SLI_AMAP eq_count;
   BE_UEXACT16_SLI_AMAP wq_count;
   BE_UEXACT16_SLI_AMAP cq_count;
   BE_UEXACT16_SLI_AMAP rq_count;
   BE_UEXACT16_SLI_AMAP fcfi_count;
   BE_BIT rsvd0[16];                              // DWORD 8
   BE_BIT target;                                 // DWORD 8
   BE_BIT initiator;                              // DWORD 8
   BE_BIT DIF;                                    // DWORD 8
   BE_BIT rsvd1[13];                              // DWORD 8
   BE_BIT rsvd2[32];                              // DWORD 9
} SG_PACK BE_SLI4_CAPS_DESC_FCOE_SLI_AMAP;
typedef struct { u32 dw[10]; } SLI4_CAPS_DESC_FCOE_SLI_AMAP, *PSLI4_CAPS_DESC_FCOE_SLI_AMAP;


typedef struct {
   BE_SLI4_CAPS_DESC_HEADER_SLI_AMAP capHeader;
   BE_UEXACT32_SLI_AMAP max_qp;
   BE_UEXACT16_SLI_AMAP max_pd;
   BE_UEXACT16_SLI_AMAP max_mr;
   BE_UEXACT16_SLI_AMAP max_mw;
   BE_UEXACT16_SLI_AMAP max_fmr;
   BE_UEXACT16_SLI_AMAP max_frmr;
   BE_UEXACT16_SLI_AMAP max_mcast_group;
   BE_UEXACT16_SLI_AMAP max_dpp_qp;
   BE_UEXACT16_SLI_AMAP max_srq;
   BE_UEXACT16_SLI_AMAP max_rpir_qp;
   BE_UEXACT16_SLI_AMAP max_dpp_pd;
   BE_UEXACT16_SLI_AMAP max_dpp_qp_per_pd;
   BE_UEXACT16_SLI_AMAP max_dpp_credits;
   BE_BIT rsvd0[2][32];                           // DWORD 8
} SG_PACK BE_SLI4_CAPS_DESC_RDMA_SLI_AMAP;
typedef struct { u32 dw[10]; } SLI4_CAPS_DESC_RDMA_SLI_AMAP, *PSLI4_CAPS_DESC_RDMA_SLI_AMAP;


typedef struct {
   BE_UEXACT8_SLI_AMAP profile_id;
   BE_BIT rsvd0[3][8];                            // DWORD 0
} SG_PACK BE_GET_PROFILE_CAPACITIES_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } GET_PROFILE_CAPACITIES_PARAMS_IN_SLI_AMAP, *PGET_PROFILE_CAPACITIES_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP capacity_descriptor_count;
   BE_SLI4_CAPS_DESC_PCIE_SLI_AMAP capacity_descriptor[1];
} SG_PACK BE_GET_PROFILE_CAPACITIES_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[11]; } GET_PROFILE_CAPACITIES_PARAMS_OUT_SLI_AMAP, *PGET_PROFILE_CAPACITIES_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_GET_PROFILE_CAPACITIES_PARAMS_IN_SLI_AMAP request;
   BE_GET_PROFILE_CAPACITIES_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_GET_PROFILE_CAPACITIES_PARAMS_SLI_AMAP;
typedef struct { u32 dw[11]; } GET_PROFILE_CAPACITIES_PARAMS_SLI_AMAP, *PGET_PROFILE_CAPACITIES_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_GET_PROFILE_CAPACITIES_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PROFILE_CAPACITIES_SLI_AMAP;
typedef struct { u32 dw[15]; } IOCTL_COMMON_GET_PROFILE_CAPACITIES_SLI_AMAP, *PIOCTL_COMMON_GET_PROFILE_CAPACITIES_SLI_AMAP;


typedef struct {
   BE_UEXACT8_SLI_AMAP profile_id;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT8_SLI_AMAP profile_index;
   BE_BIT rsvd1[8];                               // DWORD 0
   BE_UEXACT32_SLI_AMAP profile_description_string[128];
} SG_PACK BE_SLI4_PROFILE_DESC_SLI_AMAP;
typedef struct { u32 dw[129]; } SLI4_PROFILE_DESC_SLI_AMAP, *PSLI4_PROFILE_DESC_SLI_AMAP;


typedef struct {
   BE_UEXACT8_SLI_AMAP start_profile_index;
   BE_BIT rsvd0[3][8];                            // DWORD 0
} SG_PACK BE_GET_PROFILE_PARAMS_LIST_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } GET_PROFILE_PARAMS_LIST_IN_SLI_AMAP, *PGET_PROFILE_PARAMS_LIST_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP profile_descriptor_count;
   BE_SLI4_PROFILE_DESC_SLI_AMAP profile_descriptor[1];
} SG_PACK BE_GET_PROFILE_LIST_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[130]; } GET_PROFILE_LIST_PARAMS_OUT_SLI_AMAP, *PGET_PROFILE_LIST_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_GET_PROFILE_PARAMS_LIST_IN_SLI_AMAP request;
   BE_GET_PROFILE_LIST_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_GET_PROFILE_LIST_PARAMS_SLI_AMAP;
typedef struct { u32 dw[130]; } GET_PROFILE_LIST_PARAMS_SLI_AMAP, *PGET_PROFILE_LIST_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_GET_PROFILE_LIST_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PROFILE_LIST_SLI_AMAP;
typedef struct { u32 dw[134]; } IOCTL_COMMON_GET_PROFILE_LIST_SLI_AMAP, *PIOCTL_COMMON_GET_PROFILE_LIST_SLI_AMAP;


typedef struct {
   BE_BIT active_profile_id[8];                   // DWORD 0
   BE_BIT rsvd0[23];                              // DWORD 0
   BE_BIT factory_default;                        // DWORD 0
} SG_PACK BE_SET_ACTIVE_PROFILE_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } SET_ACTIVE_PROFILE_PARAMS_IN_SLI_AMAP, *PSET_ACTIVE_PROFILE_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_ACTIVE_PROFILE_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } SET_ACTIVE_PROFILE_PARAMS_OUT_SLI_AMAP, *PSET_ACTIVE_PROFILE_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_SET_ACTIVE_PROFILE_PARAMS_IN_SLI_AMAP request;
   BE_SET_ACTIVE_PROFILE_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_SET_ACTIVE_PROFILE_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } SET_ACTIVE_PROFILE_PARAMS_SLI_AMAP, *PSET_ACTIVE_PROFILE_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_SET_ACTIVE_PROFILE_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_ACTIVE_PROFILE_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_SET_ACTIVE_PROFILE_SLI_AMAP, *PIOCTL_COMMON_SET_ACTIVE_PROFILE_SLI_AMAP;


typedef union {
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } request;
   struct {
      BE_UEXACT32_SLI_AMAP capabilities;
      BE_UEXACT32_SLI_AMAP switch_type;
      BE_BIT rsvd0[32];                           // DWORD 2
   } response;
} SG_PACK BE_IOCTL_COMMON_GET_CAPABILITY_PARAMS_SLI_AMAP;
typedef struct { u32 dw[3]; } IOCTL_COMMON_GET_CAPABILITY_PARAMS_SLI_AMAP, *PIOCTL_COMMON_GET_CAPABILITY_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_IOCTL_COMMON_GET_CAPABILITY_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_CAPABILITY_SLI_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_GET_CAPABILITY_SLI_AMAP, *PIOCTL_COMMON_GET_CAPABILITY_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP ulp_mode;
   BE_UEXACT32_SLI_AMAP etx_base;
   BE_UEXACT32_SLI_AMAP etx_count;
   BE_UEXACT32_SLI_AMAP sq_base;
   BE_UEXACT32_SLI_AMAP sq_count;
   BE_UEXACT32_SLI_AMAP rq_base;
   BE_UEXACT32_SLI_AMAP rq_count;
   BE_UEXACT32_SLI_AMAP dq_base;
   BE_UEXACT32_SLI_AMAP dq_count;
   BE_UEXACT32_SLI_AMAP lro_base;
   BE_UEXACT32_SLI_AMAP lro_count;
   BE_UEXACT32_SLI_AMAP icd_base;
   BE_UEXACT32_SLI_AMAP icd_count;
} SG_PACK BE_BE_ULP_FW_CFG_SLI_AMAP;
typedef struct { u32 dw[13]; } BE_ULP_FW_CFG_SLI_AMAP, *PBE_ULP_FW_CFG_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP chain_base;
   BE_UEXACT32_SLI_AMAP chain_count;
} SG_PACK BE_BE_ULP_CHAIN_ICD_SLI_AMAP;
typedef struct { u32 dw[2]; } BE_ULP_CHAIN_ICD_SLI_AMAP, *PBE_ULP_CHAIN_ICD_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP be_config_number;
   BE_UEXACT32_SLI_AMAP asic_revision;
   BE_UEXACT32_SLI_AMAP phys_port;
   BE_UEXACT32_SLI_AMAP function_mode;
   BE_BE_ULP_FW_CFG_SLI_AMAP ulp[2];
   BE_UEXACT32_SLI_AMAP function_caps;
   BE_UEXACT32_SLI_AMAP cqid_base;
   BE_UEXACT32_SLI_AMAP cqid_count;
   BE_UEXACT32_SLI_AMAP eqid_base;
   BE_UEXACT32_SLI_AMAP eqid_count;
   BE_BE_ULP_CHAIN_ICD_SLI_AMAP ulp_chain_icd[2];
} SG_PACK BE_BE_FW_CFG_SLI_AMAP;
typedef struct { u32 dw[39]; } BE_FW_CFG_SLI_AMAP, *PBE_FW_CFG_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } request;
      BE_BE_FW_CFG_SLI_AMAP response;
   } params;
} SG_PACK BE_IOCTL_COMMON_QUERY_FIRMWARE_CONFIG_SLI_AMAP;
typedef struct { u32 dw[43]; } IOCTL_COMMON_QUERY_FIRMWARE_CONFIG_SLI_AMAP, *PIOCTL_COMMON_QUERY_FIRMWARE_CONFIG_SLI_AMAP;


typedef struct {
   BE_BIT physical_port[6];                       // DWORD 0
   BE_BIT pt[2];                                  // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_GET_LINK_SPEED_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } GET_LINK_SPEED_PARAMS_IN_SLI_AMAP, *PGET_LINK_SPEED_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_u16_SLI_AMAP mac_speed;
   BE_u16_SLI_AMAP dac_cable_length;
} SG_PACK BE_GET_LINK_SPEED_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } GET_LINK_SPEED_PARAMS_OUT_SLI_AMAP, *PGET_LINK_SPEED_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_GET_LINK_SPEED_PARAMS_IN_SLI_AMAP request;
   BE_GET_LINK_SPEED_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_GET_LINK_SPEED_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } GET_LINK_SPEED_PARAMS_SLI_AMAP, *PGET_LINK_SPEED_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_GET_LINK_SPEED_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_GET_LINK_SPEED_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_NTWK_GET_LINK_SPEED_SLI_AMAP, *PIOCTL_COMMON_NTWK_GET_LINK_SPEED_SLI_AMAP;


typedef struct {
   BE_u16_SLI_AMAP cid;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_u8_SLI_AMAP ulp_num;
   BE_u32_SLI_AMAP doorbell_offset;
   BE_u16_SLI_AMAP pci_register_set;
   BE_u16_SLI_AMAP doorbell_format;
} SG_PACK BE_ISCSI_WRBQ_CREATE_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[3]; } ISCSI_WRBQ_CREATE_PARAMS_OUT_SLI_AMAP, *PISCSI_WRBQ_CREATE_PARAMS_OUT_SLI_AMAP;


typedef struct {
   BE_BIT num_pages[16];                          // DWORD 0
   BE_BIT ulp_num[8];                             // DWORD 0
   BE_BIT dual_ulp_aware;                         // DWORD 0
   BE_BIT bind_q_to_ulp;                          // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_PHYS_ADDR_SLI_AMAP pages[8];
} SG_PACK BE_ISCSI_WRBQ_CREATE_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[17]; } ISCSI_WRBQ_CREATE_PARAMS_IN_SLI_AMAP, *PISCSI_WRBQ_CREATE_PARAMS_IN_SLI_AMAP;


typedef union {
   BE_ISCSI_WRBQ_CREATE_PARAMS_IN_SLI_AMAP request;
   BE_ISCSI_WRBQ_CREATE_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_ISCSI_WRBQ_CREATE_PARAMS_SLI_AMAP;
typedef struct { u32 dw[17]; } ISCSI_WRBQ_CREATE_PARAMS_SLI_AMAP, *PISCSI_WRBQ_CREATE_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_ISCSI_WRBQ_CREATE_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_WRBQ_CREATE_SLI_AMAP;
typedef struct { u32 dw[21]; } IOCTL_COMMON_ISCSI_WRBQ_CREATE_SLI_AMAP, *PIOCTL_COMMON_ISCSI_WRBQ_CREATE_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT ring_size[4];                           // DWORD 0
   BE_BIT rsvd1[12];                              // DWORD 0
   BE_BIT rsvd2[22];                              // DWORD 1
   BE_BIT rx_pdid[9];                             // DWORD 1
   BE_BIT rx_pdid_valid;                          // DWORD 1
   BE_UEXACT16_SLI_AMAP default_buffer_size;
   BE_UEXACT16_SLI_AMAP cq_id_recv;
   BE_BIT rsvd3[32];                              // DWORD 3
} SG_PACK BE_ISCSI_DEFQ_CONTEXT_SLI_AMAP;
typedef struct { u32 dw[4]; } ISCSI_DEFQ_CONTEXT_SLI_AMAP, *PISCSI_DEFQ_CONTEXT_SLI_AMAP;


typedef struct {
   BE_BIT num_pages[16];                          // DWORD 0
   BE_BIT ulp_num[8];                             // DWORD 0
   BE_BIT dual_ulp_aware;                         // DWORD 0
   BE_BIT bind_q_to_ulp;                          // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_ISCSI_DEFQ_CONTEXT_SLI_AMAP context;
   BE_PHYS_ADDR_SLI_AMAP pages[8];
} SG_PACK BE_ISCSI_DEFQ_CREATE_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[21]; } ISCSI_DEFQ_CREATE_PARAMS_IN_SLI_AMAP, *PISCSI_DEFQ_CREATE_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_u16_SLI_AMAP id;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_u8_SLI_AMAP ulp_num;
   BE_u32_SLI_AMAP doorbell_offset;
   BE_u16_SLI_AMAP pci_register_set;
   BE_u16_SLI_AMAP doorbell_format;
} SG_PACK BE_ISCSI_DEFQ_CREATE_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[3]; } ISCSI_DEFQ_CREATE_PARAMS_OUT_SLI_AMAP, *PISCSI_DEFQ_CREATE_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_ISCSI_DEFQ_CREATE_PARAMS_IN_SLI_AMAP request;
   BE_ISCSI_DEFQ_CREATE_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_ISCSI_DEFQ_CREATE_PARAMS_SLI_AMAP;
typedef struct { u32 dw[21]; } ISCSI_DEFQ_CREATE_PARAMS_SLI_AMAP, *PISCSI_DEFQ_CREATE_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_ISCSI_DEFQ_CREATE_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_DEFQ_CREATE_SLI_AMAP;
typedef struct { u32 dw[25]; } IOCTL_COMMON_ISCSI_DEFQ_CREATE_SLI_AMAP, *PIOCTL_COMMON_ISCSI_DEFQ_CREATE_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   union {
      struct {
         BE_UEXACT16_SLI_AMAP icd_start;
         BE_UEXACT16_SLI_AMAP icd_count;
         BE_PHYS_ADDR_SLI_AMAP pages[1];
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1_SLI_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1_SLI_AMAP, *PIOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   union {
      struct {
         BE_BIT cq_id[16];                        // DWORD 4
         BE_BIT rsvd0[13];                        // DWORD 4
         BE_BIT cwm_ctrl[2];                      // DWORD 4
         BE_BIT eq_id_valid;                      // DWORD 4
         BE_u8_SLI_AMAP coalesc_cwm;
         BE_BIT rsvd1[8];                         // DWORD 5
         BE_u16_SLI_AMAP eq_id;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_MODIFY_CQ_SLI_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_MODIFY_CQ_SLI_AMAP, *PIOCTL_COMMON_MODIFY_CQ_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT event_code[8];                          // DWORD 0
   BE_BIT event_type[8];                          // DWORD 0
   BE_BIT rsvd1[6];                               // DWORD 0
   BE_BIT async_event;                            // DWORD 0
   BE_BIT valid;                                  // DWORD 0
} SG_PACK BE_ASYNC_EVENT_TRAILER_SLI_AMAP;
typedef struct { u32 dw[1]; } ASYNC_EVENT_TRAILER_SLI_AMAP, *PASYNC_EVENT_TRAILER_SLI_AMAP;


typedef struct {
   BE_BIT learn_enable;                           // DWORD 0
   BE_BIT learn_disable;                          // DWORD 0
   BE_BIT mgmt_enable;                            // DWORD 0
   BE_BIT mgmt_disable;                           // DWORD 0
   BE_BIT rsvd0[12];                              // DWORD 0
   BE_BIT vlan_tag[16];                           // DWORD 0
   BE_BIT bcast_filt_arp;                         // DWORD 1
   BE_BIT bcast_filt_dhcp_client;                 // DWORD 1
   BE_BIT bcast_filt_dhcp_server;                 // DWORD 1
   BE_BIT bcast_filt_netbios;                     // DWORD 1
   BE_BIT rsvd1[3];                               // DWORD 1
   BE_BIT bcast_enable;                           // DWORD 1
   BE_BIT mcast_ipv6_nbr;                         // DWORD 1
   BE_BIT mcast_ipv6_ra;                          // DWORD 1
   BE_BIT mcast_ipv6_dhcp6;                       // DWORD 1
   BE_BIT rsvd2[4];                               // DWORD 1
   BE_BIT mcast_enable;                           // DWORD 1
   BE_BIT rsvd3[16];                              // DWORD 1
   BE_UEXACT32_SLI_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_GRP_5_SHARED_VLAN_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_GRP_5_SHARED_VLAN_SLI_AMAP, *PASYNC_EVENT_GRP_5_SHARED_VLAN_SLI_AMAP;


typedef struct {
   BE_BIT query;                                  // DWORD 0
   BE_BIT rsvd0[31];                              // DWORD 0
   BE_BIT eth_pfc_pg_feature;                     // DWORD 1
   BE_BIT eth_tx_side_scaling;                    // DWORD 1
   BE_BIT rsvd1[30];                              // DWORD 1
} SG_PACK BE_PG_FEATURE_QUERY_REQUEST_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[2]; } PG_FEATURE_QUERY_REQUEST_PARAMS_IN_SLI_AMAP, *PPG_FEATURE_QUERY_REQUEST_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT eth_pfc_pg_feature;                     // DWORD 0
   BE_BIT eth_tx_side_scaling;                    // DWORD 0
   BE_BIT rsvd0[30];                              // DWORD 0
   BE_BIT num_tx_rings[32];                       // DWORD 1
} SG_PACK BE_PG_FEATURE_QUERY_REQUEST_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[2]; } PG_FEATURE_QUERY_REQUEST_PARAMS_OUT_SLI_AMAP, *PPG_FEATURE_QUERY_REQUEST_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_PG_FEATURE_QUERY_REQUEST_PARAMS_IN_SLI_AMAP request;
   BE_PG_FEATURE_QUERY_REQUEST_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_PG_FEATURE_QUERY_REQUEST_PARAMS_SLI_AMAP;
typedef struct { u32 dw[2]; } PG_FEATURE_QUERY_REQUEST_PARAMS_SLI_AMAP, *PPG_FEATURE_QUERY_REQUEST_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_PG_FEATURE_QUERY_REQUEST_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_ETH_PG_FEATURE_QUERY_REQUEST_SLI_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ETH_PG_FEATURE_QUERY_REQUEST_SLI_AMAP, *PIOCTL_ETH_PG_FEATURE_QUERY_REQUEST_SLI_AMAP;


typedef struct {
   BE_UEXACT16_SLI_AMAP cq_id;
   BE_UEXACT8_SLI_AMAP frag_size;
   BE_UEXACT8_SLI_AMAP num_pages;
   BE_UEXACT32_SLI_AMAP if_id;
   BE_UEXACT16_SLI_AMAP max_frame_size;
   BE_UEXACT16_SLI_AMAP page_size;
   BE_UEXACT16_SLI_AMAP pd_id;
   BE_BIT rsvd0[8];                               // DWORD 3
   BE_UEXACT8_SLI_AMAP ulp_num;
   BE_UEXACT16_SLI_AMAP rq_flags;
   BE_BIT rsvd1[16];                              // DWORD 4
   BE_UEXACT8_SLI_AMAP hds_frag;
   BE_UEXACT8_SLI_AMAP hds_start;
   BE_UEXACT16_SLI_AMAP hds_fixed_offset;
   BE_UEXACT16_SLI_AMAP hds_frag_size;
   BE_UEXACT16_SLI_AMAP hds_backfill_size;
   BE_BIT rsvd2[9][32];                           // DWORD 7
   BE_PHYS_ADDR_SLI_AMAP pages[2];
} SG_PACK BE_ETH_RX_CREATE_V2_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[20]; } ETH_RX_CREATE_V2_PARAMS_IN_SLI_AMAP, *PETH_RX_CREATE_V2_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT16_SLI_AMAP rq_id;
   BE_UEXACT8_SLI_AMAP rss_cpu_id;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT rsvd1[16];                              // DWORD 1
   BE_UEXACT8_SLI_AMAP db_bar_reg_set;
   BE_UEXACT8_SLI_AMAP db_format;
   BE_UEXACT32_SLI_AMAP db_offset;
   BE_BIT rsvd2[16];                              // DWORD 3
   BE_BIT rsvd3[8];                               // DWORD 3
   BE_UEXACT8_SLI_AMAP ulp_num;
   BE_UEXACT16_SLI_AMAP rq_flags;
   BE_BIT rsvd4[16];                              // DWORD 4
} SG_PACK BE_ETH_RX_CREATE_V2_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[5]; } ETH_RX_CREATE_V2_PARAMS_OUT_SLI_AMAP, *PETH_RX_CREATE_V2_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_ETH_RX_CREATE_V2_PARAMS_IN_SLI_AMAP request;
   BE_ETH_RX_CREATE_V2_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_ETH_RX_CREATE_V2_PARAMS_SLI_AMAP;
typedef struct { u32 dw[20]; } ETH_RX_CREATE_V2_PARAMS_SLI_AMAP, *PETH_RX_CREATE_V2_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_ETH_RX_CREATE_V2_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_ETH_RX_CREATE_V2_SLI_AMAP;
typedef struct { u32 dw[24]; } IOCTL_ETH_RX_CREATE_V2_SLI_AMAP, *PIOCTL_ETH_RX_CREATE_V2_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[5][32];                           // DWORD 0
} SG_PACK BE_ETH_QUERY_LRO_CONFIG_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[5]; } ETH_QUERY_LRO_CONFIG_PARAMS_IN_SLI_AMAP, *PETH_QUERY_LRO_CONFIG_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP lro_flags;
   BE_BIT rsvd0[16];                              // DWORD 1
   BE_UEXACT16_SLI_AMAP lro_rq_count;
   BE_BIT rsvd1[4][32];                           // DWORD 2
} SG_PACK BE_ETH_QUERY_LRO_CONFIG_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[6]; } ETH_QUERY_LRO_CONFIG_PARAMS_OUT_SLI_AMAP, *PETH_QUERY_LRO_CONFIG_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_ETH_QUERY_LRO_CONFIG_PARAMS_IN_SLI_AMAP request;
   BE_ETH_QUERY_LRO_CONFIG_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_ETH_QUERY_LRO_CONFIG_PARAMS_SLI_AMAP;
typedef struct { u32 dw[6]; } ETH_QUERY_LRO_CONFIG_PARAMS_SLI_AMAP, *PETH_QUERY_LRO_CONFIG_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_ETH_QUERY_LRO_CONFIG_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_ETH_QUERY_LRO_CONFIG_SLI_AMAP;
typedef struct { u32 dw[10]; } IOCTL_ETH_QUERY_LRO_CONFIG_SLI_AMAP, *PIOCTL_ETH_QUERY_LRO_CONFIG_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP lro_flags;
   BE_UEXACT32_SLI_AMAP if_id;
   BE_UEXACT32_SLI_AMAP max_clsc_byte_count;
   BE_UEXACT32_SLI_AMAP max_clsc_segment_count;
   BE_UEXACT32_SLI_AMAP max_clsc_usec_delay;
   BE_UEXACT32_SLI_AMAP min_clsc_frame_byte_count;
   BE_BIT rsvd0[2][32];                           // DWORD 6
} SG_PACK BE_ETH_SET_IFACE_LRO_CONFIG_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[8]; } ETH_SET_IFACE_LRO_CONFIG_PARAMS_IN_SLI_AMAP, *PETH_SET_IFACE_LRO_CONFIG_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP lro_flags;
   BE_BIT rsvd0[7][32];                           // DWORD 1
} SG_PACK BE_ETH_SET_IFACE_LRO_CONFIG_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[8]; } ETH_SET_IFACE_LRO_CONFIG_PARAMS_OUT_SLI_AMAP, *PETH_SET_IFACE_LRO_CONFIG_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_ETH_SET_IFACE_LRO_CONFIG_PARAMS_IN_SLI_AMAP request;
   BE_ETH_SET_IFACE_LRO_CONFIG_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_ETH_SET_IFACE_LRO_CONFIG_PARAMS_SLI_AMAP;
typedef struct { u32 dw[8]; } ETH_SET_IFACE_LRO_CONFIG_PARAMS_SLI_AMAP, *PETH_SET_IFACE_LRO_CONFIG_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_ETH_SET_IFACE_LRO_CONFIG_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_ETH_SET_IFACE_LRO_CONFIG_SLI_AMAP;
typedef struct { u32 dw[12]; } IOCTL_ETH_SET_IFACE_LRO_CONFIG_SLI_AMAP, *PIOCTL_ETH_SET_IFACE_LRO_CONFIG_SLI_AMAP;


typedef struct {
   BE_UEXACT16_SLI_AMAP id;
   BE_UEXACT16_SLI_AMAP bypass_flush;
   BE_UEXACT16_SLI_AMAP rq_flags;
   BE_BIT rsvd0[16];                              // DWORD 1
} SG_PACK BE_ETH_RX_DESTROY_V1_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[2]; } ETH_RX_DESTROY_V1_PARAMS_IN_SLI_AMAP, *PETH_RX_DESTROY_V1_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_ETH_RX_DESTROY_V1_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } ETH_RX_DESTROY_V1_PARAMS_OUT_SLI_AMAP, *PETH_RX_DESTROY_V1_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_ETH_RX_DESTROY_V1_PARAMS_IN_SLI_AMAP request;
   BE_ETH_RX_DESTROY_V1_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_ETH_RX_DESTROY_V1_PARAMS_SLI_AMAP;
typedef struct { u32 dw[2]; } ETH_RX_DESTROY_V1_PARAMS_SLI_AMAP, *PETH_RX_DESTROY_V1_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_ETH_RX_DESTROY_V1_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_ETH_RX_DESTROY_V1_SLI_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ETH_RX_DESTROY_V1_SLI_AMAP, *PIOCTL_ETH_RX_DESTROY_V1_SLI_AMAP;


typedef struct {
   BE_UEXACT8_SLI_AMAP module_;
   BE_UEXACT8_SLI_AMAP module_event_id;
   BE_UEXACT16_SLI_AMAP reserve;
   BE_UEXACT32_SLI_AMAP debug_data;
   BE_UEXACT32_SLI_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_GRP_5_DEBUG_DATA_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_GRP_5_DEBUG_DATA_SLI_AMAP, *PASYNC_EVENT_GRP_5_DEBUG_DATA_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT cq_id[16];                              // DWORD 1
   BE_BIT rsvd1[15];                              // DWORD 1
   BE_BIT cq_valid;                               // DWORD 1
   BE_UEXACT32_SLI_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_RDMA_CQ_ERROR_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_RDMA_CQ_ERROR_SLI_AMAP, *PASYNC_EVENT_RDMA_CQ_ERROR_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT cq_id[16];                              // DWORD 1
   BE_BIT rsvd1[15];                              // DWORD 1
   BE_BIT cq_valid;                               // DWORD 1
   BE_UEXACT32_SLI_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_RDMA_CQ_OVERRUN_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_RDMA_CQ_OVERRUN_SLI_AMAP, *PASYNC_EVENT_RDMA_CQ_OVERRUN_SLI_AMAP;


typedef struct {
   BE_BIT qp_id[16];                              // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT qp_valid;                               // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_UEXACT32_SLI_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_RDMA_QP_CAT_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_RDMA_QP_CAT_SLI_AMAP, *PASYNC_EVENT_RDMA_QP_CAT_SLI_AMAP;


typedef struct {
   BE_BIT qp_id[16];                              // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT qp_valid;                               // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_UEXACT32_SLI_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_RDMA_QP_ACCESS_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_RDMA_QP_ACCESS_SLI_AMAP, *PASYNC_EVENT_RDMA_QP_ACCESS_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_UEXACT32_SLI_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_RDMA_DEVICE_FATAL_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_RDMA_DEVICE_FATAL_SLI_AMAP, *PASYNC_EVENT_RDMA_DEVICE_FATAL_SLI_AMAP;


typedef struct {
   BE_BIT srq_id[16];                             // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
   BE_BIT srq_valid;                              // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT rsvd2[32];                              // DWORD 1
   BE_UEXACT32_SLI_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_RDMA_SRQ_CAT_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_RDMA_SRQ_CAT_SLI_AMAP, *PASYNC_EVENT_RDMA_SRQ_CAT_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT srq_valid;                              // DWORD 0
   BE_BIT rsvd1[14];                              // DWORD 0
   BE_BIT srq_id[16];                             // DWORD 0
   BE_BIT rsvd2[32];                              // DWORD 1
   BE_UEXACT32_SLI_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_RDMA_SRQ_LIMIT_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_RDMA_SRQ_LIMIT_SLI_AMAP, *PASYNC_EVENT_RDMA_SRQ_LIMIT_SLI_AMAP;


typedef struct {
   BE_BIT qp_id[16];                              // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT qp_valid;                               // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_UEXACT32_SLI_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_RDMA_QP_LAST_WQE_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_RDMA_QP_LAST_WQE_SLI_AMAP, *PASYNC_EVENT_RDMA_QP_LAST_WQE_SLI_AMAP;


typedef struct {
   BE_UEXACT8_SLI_AMAP priority;
   BE_BIT rsvd0[3][8];                            // DWORD 0
   BE_BIT rsvd1[64];                              // DWORD 1
   BE_ASYNC_EVENT_TRAILER_SLI_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_RDMA_COS_NOTIFY_SLI_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_RDMA_COS_NOTIFY_SLI_AMAP, *PASYNC_EVENT_RDMA_COS_NOTIFY_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_RDMA_QUERY_CONFIG_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_QUERY_CONFIG_PARAMS_IN_SLI_AMAP, *PRDMA_QUERY_CONFIG_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT ord_hot_modify;                         // DWORD 0
   BE_BIT ird_hot_modify;                         // DWORD 0
   BE_BIT cq_overflow;                            // DWORD 0
   BE_BIT srq_supported;                          // DWORD 0
   BE_BIT cq_autovalid;                           // DWORD 0
   BE_BIT ird_ring_required;                      // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT max_qp[24];                             // DWORD 0
   BE_UEXACT8_SLI_AMAP pad;
   BE_UEXACT8_SLI_AMAP local_ca_ack_delay;
   BE_UEXACT16_SLI_AMAP max_pd;
   BE_UEXACT16_SLI_AMAP max_send_sge;
   BE_UEXACT16_SLI_AMAP max_rq_recv_sge;
   BE_UEXACT16_SLI_AMAP max_ord_per_qp;
   BE_UEXACT16_SLI_AMAP max_ird_per_qp;
   BE_UEXACT16_SLI_AMAP max_shared_ord;
   BE_UEXACT16_SLI_AMAP max_shared_ird;
   BE_UEXACT32_SLI_AMAP max_mr;
   BE_UEXACT32_SLI_AMAP max_mr_size_hi;
   BE_UEXACT32_SLI_AMAP max_mr_size_lo;
   BE_UEXACT32_SLI_AMAP max_pbls_per_mr;
   BE_UEXACT32_SLI_AMAP max_mw;
   BE_UEXACT32_SLI_AMAP max_fmr;
   BE_UEXACT32_SLI_AMAP max_map_per_fmr;
   BE_UEXACT32_SLI_AMAP max_mcast_group;
   BE_UEXACT32_SLI_AMAP max_mcast_qp_attach;
   BE_UEXACT32_SLI_AMAP max_total_mcast_qp_attach;
   BE_UEXACT16_SLI_AMAP max_dpp_qps;
   BE_UEXACT8_SLI_AMAP rq_wqe_stride;
   BE_UEXACT8_SLI_AMAP sq_wqe_stride;
   BE_UEXACT16_SLI_AMAP max_rpir_qps;
   BE_UEXACT16_SLI_AMAP max_srq;
   BE_UEXACT16_SLI_AMAP max_dpp_credits;
   BE_UEXACT16_SLI_AMAP max_dpp_pds;
   BE_UEXACT16_SLI_AMAP max_dpp_qps_per_pd;
   BE_UEXACT16_SLI_AMAP max_dpp_credits_per_qp;
   BE_UEXACT16_SLI_AMAP max_rqes_per_rq;
   BE_UEXACT16_SLI_AMAP max_wqes_per_wq;
   BE_UEXACT16_SLI_AMAP max_cqes_per_cq;
   BE_UEXACT16_SLI_AMAP max_cq;
   BE_UEXACT16_SLI_AMAP max_srq_sge;
   BE_UEXACT16_SLI_AMAP max_srq_rqe;
   BE_UEXACT16_SLI_AMAP max_read_sge;
   BE_UEXACT16_SLI_AMAP max_write_sge;
   BE_UEXACT16_SLI_AMAP num_ird_pages;
   BE_UEXACT16_SLI_AMAP ird_page_size;
} SG_PACK BE_RDMA_QUERY_CONFIG_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[24]; } RDMA_QUERY_CONFIG_PARAMS_OUT_SLI_AMAP, *PRDMA_QUERY_CONFIG_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_QUERY_CONFIG_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_QUERY_CONFIG_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_QUERY_CONFIG_PARAMS_SLI_AMAP;
typedef struct { u32 dw[24]; } RDMA_QUERY_CONFIG_PARAMS_SLI_AMAP, *PRDMA_QUERY_CONFIG_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_QUERY_CONFIG_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_QUERY_CONFIG_SLI_AMAP;
typedef struct { u32 dw[28]; } IOCTL_RDMA_QUERY_CONFIG_SLI_AMAP, *PIOCTL_RDMA_QUERY_CONFIG_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT page_size[3];                           // DWORD 0
   BE_BIT num_pages[4];                           // DWORD 0
   BE_BIT av_size[9];                             // DWORD 0
   BE_PHYS_ADDR_SLI_AMAP pages[8];
} SG_PACK BE_RDMA_CREATE_AHR_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[17]; } RDMA_CREATE_AHR_PARAMS_IN_SLI_AMAP, *PRDMA_CREATE_AHR_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP ahr_id;
} SG_PACK BE_RDMA_CREATE_AHR_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_CREATE_AHR_PARAMS_OUT_SLI_AMAP, *PRDMA_CREATE_AHR_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_CREATE_AHR_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_CREATE_AHR_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_CREATE_AHR_PARAMS_SLI_AMAP;
typedef struct { u32 dw[17]; } RDMA_CREATE_AHR_PARAMS_SLI_AMAP, *PRDMA_CREATE_AHR_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_CREATE_AHR_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_CREATE_AHR_SLI_AMAP;
typedef struct { u32 dw[21]; } IOCTL_RDMA_CREATE_AHR_SLI_AMAP, *PIOCTL_RDMA_CREATE_AHR_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP ahr_id;
} SG_PACK BE_RDMA_DESTROY_AHR_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_AHR_PARAMS_IN_SLI_AMAP, *PRDMA_DESTROY_AHR_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_RDMA_DESTROY_AHR_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_AHR_PARAMS_OUT_SLI_AMAP, *PRDMA_DESTROY_AHR_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_DESTROY_AHR_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_DESTROY_AHR_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_DESTROY_AHR_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_AHR_PARAMS_SLI_AMAP, *PRDMA_DESTROY_AHR_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_DESTROY_AHR_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_DESTROY_AHR_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_RDMA_DESTROY_AHR_SLI_AMAP, *PIOCTL_RDMA_DESTROY_AHR_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT enable_dpp;                             // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_RDMA_ALLOC_PD_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_ALLOC_PD_PARAMS_IN_SLI_AMAP, *PRDMA_ALLOC_PD_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT pd_id[16];                              // DWORD 0
   BE_BIT dpp_enabled;                            // DWORD 0
   BE_BIT dpp_page_index[15];                     // DWORD 0
} SG_PACK BE_RDMA_ALLOC_PD_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_ALLOC_PD_PARAMS_OUT_SLI_AMAP, *PRDMA_ALLOC_PD_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_ALLOC_PD_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_ALLOC_PD_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_ALLOC_PD_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_ALLOC_PD_PARAMS_SLI_AMAP, *PRDMA_ALLOC_PD_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_ALLOC_PD_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_ALLOC_PD_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_RDMA_ALLOC_PD_SLI_AMAP, *PIOCTL_RDMA_ALLOC_PD_SLI_AMAP;


typedef struct {
   BE_UEXACT16_SLI_AMAP pd_id;
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_RDMA_DEALLOC_PD_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DEALLOC_PD_PARAMS_IN_SLI_AMAP, *PRDMA_DEALLOC_PD_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_RDMA_DEALLOC_PD_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DEALLOC_PD_PARAMS_OUT_SLI_AMAP, *PRDMA_DEALLOC_PD_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_DEALLOC_PD_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_DEALLOC_PD_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_DEALLOC_PD_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DEALLOC_PD_PARAMS_SLI_AMAP, *PRDMA_DEALLOC_PD_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_DEALLOC_PD_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_DEALLOC_PD_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_RDMA_DEALLOC_PD_SLI_AMAP, *PIOCTL_RDMA_DEALLOC_PD_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_UEXACT16_SLI_AMAP page_size;
   BE_UEXACT16_SLI_AMAP num_phy_pages;
   BE_PHYS_ADDR_SLI_AMAP pages[8];
} SG_PACK BE_RDMA_CREATE_RBQ_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[18]; } RDMA_CREATE_RBQ_PARAMS_IN_SLI_AMAP, *PRDMA_CREATE_RBQ_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP rbq_id;
} SG_PACK BE_RDMA_CREATE_RBQ_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_CREATE_RBQ_PARAMS_OUT_SLI_AMAP, *PRDMA_CREATE_RBQ_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_CREATE_RBQ_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_CREATE_RBQ_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_CREATE_RBQ_PARAMS_SLI_AMAP;
typedef struct { u32 dw[18]; } RDMA_CREATE_RBQ_PARAMS_SLI_AMAP, *PRDMA_CREATE_RBQ_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_CREATE_RBQ_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_CREATE_RBQ_SLI_AMAP;
typedef struct { u32 dw[22]; } IOCTL_RDMA_CREATE_RBQ_SLI_AMAP, *PIOCTL_RDMA_CREATE_RBQ_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP rbq_id;
} SG_PACK BE_RDMA_DESTROY_RBQ_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_RBQ_PARAMS_IN_SLI_AMAP, *PRDMA_DESTROY_RBQ_PARAMS_IN_SLI_AMAP;


typedef union {
   BE_RDMA_DESTROY_RBQ_PARAMS_IN_SLI_AMAP request;
} SG_PACK BE_RDMA_DESTROY_RBQ_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_RBQ_PARAMS_SLI_AMAP, *PRDMA_DESTROY_RBQ_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_DESTROY_RBQ_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_DESTROY_RBQ_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_RDMA_DESTROY_RBQ_SLI_AMAP, *PIOCTL_RDMA_DESTROY_RBQ_SLI_AMAP;


typedef struct {
   BE_BIT pd_id[16];                              // DWORD 0
   BE_BIT sq_page_size[3];                        // DWORD 0
   BE_BIT rq_page_size[3];                        // DWORD 0
   BE_BIT rpir_blk_size[4];                       // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT transport_type[3];                      // DWORD 0
   BE_UEXACT16_SLI_AMAP max_rqe;
   BE_UEXACT16_SLI_AMAP max_wqe;
   BE_UEXACT16_SLI_AMAP max_sge_write;
   BE_UEXACT16_SLI_AMAP max_sge_send;
   BE_BIT fmr_en;                                 // DWORD 3
   BE_BIT zero_stagen;                            // DWORD 3
   BE_BIT bind_memwin;                            // DWORD 3
   BE_BIT inb_wren;                               // DWORD 3
   BE_BIT inb_rden;                               // DWORD 3
   BE_BIT use_srq;                                // DWORD 3
   BE_BIT enable_rpir;                            // DWORD 3
   BE_BIT enable_dpp;                             // DWORD 3
   BE_BIT enable_dpp_cqe;                         // DWORD 3
   BE_BIT signaled_qp;                            // DWORD 3
   BE_BIT rsvd1[6];                               // DWORD 3
   BE_BIT max_sge_recv[16];                       // DWORD 3
   BE_UEXACT16_SLI_AMAP max_ird;
   BE_UEXACT16_SLI_AMAP max_ord;
   BE_UEXACT16_SLI_AMAP num_rq_pages;
   BE_UEXACT16_SLI_AMAP num_wq_pages;
   BE_UEXACT16_SLI_AMAP rqe_size;
   BE_UEXACT16_SLI_AMAP wqe_size;
   BE_UEXACT16_SLI_AMAP rq_cqid;
   BE_UEXACT16_SLI_AMAP wq_cqid;
   BE_PHYS_ADDR_SLI_AMAP wq_addr[8];
   BE_PHYS_ADDR_SLI_AMAP rq_addr[8];
   BE_UEXACT16_SLI_AMAP dpp_cqid;
   BE_UEXACT16_SLI_AMAP dpp_credits;
   BE_UEXACT32_SLI_AMAP rbq_id;
   BE_PHYS_ADDR_SLI_AMAP r2t_addr[4];
} SG_PACK BE_RDMA_CREATE_QP_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[50]; } RDMA_CREATE_QP_PARAMS_IN_SLI_AMAP, *PRDMA_CREATE_QP_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT qp_id[16];                              // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT16_SLI_AMAP max_rqe;
   BE_UEXACT16_SLI_AMAP max_wqe;
   BE_UEXACT16_SLI_AMAP max_sge_write;
   BE_UEXACT16_SLI_AMAP max_sge_send;
   BE_BIT rsvd1[16];                              // DWORD 3
   BE_BIT max_sge_recv[16];                       // DWORD 3
   BE_UEXACT16_SLI_AMAP max_ird;
   BE_UEXACT16_SLI_AMAP max_ord;
   BE_UEXACT16_SLI_AMAP rq_id;
   BE_UEXACT16_SLI_AMAP sq_id;
   BE_BIT dpp_enabled;                            // DWORD 6
   BE_BIT dpp_page_offset[15];                    // DWORD 6
   BE_BIT dpp_credits[16];                        // DWORD 6
} SG_PACK BE_RDMA_CREATE_QP_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[7]; } RDMA_CREATE_QP_PARAMS_OUT_SLI_AMAP, *PRDMA_CREATE_QP_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_CREATE_QP_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_CREATE_QP_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_CREATE_QP_PARAMS_SLI_AMAP;
typedef struct { u32 dw[50]; } RDMA_CREATE_QP_PARAMS_SLI_AMAP, *PRDMA_CREATE_QP_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_CREATE_QP_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_CREATE_QP_SLI_AMAP;
typedef struct { u32 dw[54]; } IOCTL_RDMA_CREATE_QP_SLI_AMAP, *PIOCTL_RDMA_CREATE_QP_SLI_AMAP;


typedef struct {
   BE_BIT qp_id[16];                              // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_RDMA_QUERY_QP_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_QUERY_QP_PARAMS_IN_SLI_AMAP, *PRDMA_QUERY_QP_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT srq_id[16];                             // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT16_SLI_AMAP max_rqe;
   BE_UEXACT16_SLI_AMAP max_wqe;
   BE_UEXACT16_SLI_AMAP max_sge_write;
   BE_UEXACT16_SLI_AMAP max_sge_send;
   BE_BIT fmr_en;                                 // DWORD 3
   BE_BIT zero_stagen;                            // DWORD 3
   BE_BIT bind_memwin;                            // DWORD 3
   BE_BIT inb_wren;                               // DWORD 3
   BE_BIT inb_rden;                               // DWORD 3
   BE_BIT qp_state[3];                            // DWORD 3
   BE_BIT rsvd1[8];                               // DWORD 3
   BE_BIT max_sge_recv[16];                       // DWORD 3
   BE_UEXACT16_SLI_AMAP max_ird;
   BE_UEXACT16_SLI_AMAP max_ord;
   BE_UEXACT16_SLI_AMAP rq_cqid;
   BE_UEXACT16_SLI_AMAP wq_cqid;
   BE_BIT rq_psn[24];                             // DWORD 6
   BE_BIT hop_cnt[8];                             // DWORD 6
   BE_BIT sq_psn[24];                             // DWORD 7
   BE_BIT tclass[8];                              // DWORD 7
   BE_BIT dest_qp_id[24];                         // DWORD 8
   BE_BIT rnr_retry_cnt[3];                       // DWORD 8
   BE_BIT ack_timeout[5];                         // DWORD 8
   BE_BIT pkey_index[16];                         // DWORD 9
   BE_BIT rsvd2[2];                               // DWORD 9
   BE_BIT path_mtu[14];                           // DWORD 9
   BE_BIT flow_label[20];                         // DWORD 10
   BE_BIT sl[4];                                  // DWORD 10
   BE_BIT retry_cnt[3];                           // DWORD 10
   BE_BIT rnr_nak_timer[5];                       // DWORD 10
   BE_UEXACT8_SLI_AMAP sgid[16];
   BE_UEXACT8_SLI_AMAP dgid[16];
   BE_UEXACT32_SLI_AMAP dmac_b0_to_b3;
   BE_BIT dmac_b4_to_b5[16];                      // DWORD 20
   BE_BIT rsvd3[16];                              // DWORD 20
   BE_UEXACT32_SLI_AMAP qkey;
} SG_PACK BE_RDMA_QUERY_QP_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[22]; } RDMA_QUERY_QP_PARAMS_OUT_SLI_AMAP, *PRDMA_QUERY_QP_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_QUERY_QP_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_QUERY_QP_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_QUERY_QP_PARAMS_SLI_AMAP;
typedef struct { u32 dw[22]; } RDMA_QUERY_QP_PARAMS_SLI_AMAP, *PRDMA_QUERY_QP_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_QUERY_QP_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_QUERY_QP_SLI_AMAP;
typedef struct { u32 dw[26]; } IOCTL_RDMA_QUERY_QP_SLI_AMAP, *PIOCTL_RDMA_QUERY_QP_SLI_AMAP;


typedef struct {
   BE_BIT qp_id[16];                              // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT16_SLI_AMAP max_rqe;
   BE_UEXACT16_SLI_AMAP max_wqe;
   BE_UEXACT16_SLI_AMAP max_sge_write;
   BE_UEXACT16_SLI_AMAP max_sge_send;
   BE_BIT fmr_en;                                 // DWORD 3
   BE_BIT zero_stag_en;                           // DWORD 3
   BE_BIT bind_mw_en;                             // DWORD 3
   BE_BIT inbwr_en;                               // DWORD 3
   BE_BIT inbrd_en;                               // DWORD 3
   BE_BIT qp_state[3];                            // DWORD 3
   BE_BIT sqd_async;                              // DWORD 3
   BE_BIT inb_aten;                               // DWORD 3
   BE_BIT rsvd1[6];                               // DWORD 3
   BE_BIT max_sge_recv[16];                       // DWORD 3
   BE_UEXACT16_SLI_AMAP max_ird;
   BE_UEXACT16_SLI_AMAP max_ord;
   BE_UEXACT16_SLI_AMAP rq_cqid;
   BE_UEXACT16_SLI_AMAP wq_cqid;
   BE_BIT rq_psn[24];                             // DWORD 6
   BE_BIT hop_lmt[8];                             // DWORD 6
   BE_BIT sq_psn[24];                             // DWORD 7
   BE_BIT tclass[8];                              // DWORD 7
   BE_BIT dest_qp_id[24];                         // DWORD 8
   BE_BIT rnr_retry_cnt[3];                       // DWORD 8
   BE_BIT ack_timeout[5];                         // DWORD 8
   BE_BIT pkey_index[16];                         // DWORD 9
   BE_BIT rsvd2[2];                               // DWORD 9
   BE_BIT path_mtu[14];                           // DWORD 9
   BE_BIT flow_label[20];                         // DWORD 10
   BE_BIT sl[4];                                  // DWORD 10
   BE_BIT retry_cnt[3];                           // DWORD 10
   BE_BIT rnr_nak_timer[5];                       // DWORD 10
   BE_UEXACT8_SLI_AMAP sgid[16];
   BE_UEXACT8_SLI_AMAP dgid[16];
   BE_UEXACT32_SLI_AMAP dmac_b0_to_b3;
   BE_UEXACT16_SLI_AMAP dmac_b4_to_b5;
   BE_UEXACT16_SLI_AMAP vlan_id;
   BE_UEXACT32_SLI_AMAP qkey;
   BE_BIT next_qp_state;                          // DWORD 22
   BE_BIT sqd_async_valid;                        // DWORD 22
   BE_BIT pkey_index_valid;                       // DWORD 22
   BE_BIT q_key_valid;                            // DWORD 22
   BE_BIT pmtu_valid;                             // DWORD 22
   BE_BIT ack_to_valid;                           // DWORD 22
   BE_BIT retry_cnt_valid;                        // DWORD 22
   BE_BIT rrc_valid;                              // DWORD 22
   BE_BIT rq_psn_valid;                           // DWORD 22
   BE_BIT max_ird_valid;                          // DWORD 22
   BE_BIT max_ord_valid;                          // DWORD 22
   BE_BIT rnt_valid;                              // DWORD 22
   BE_BIT sq_psn_valid;                           // DWORD 22
   BE_BIT dest_qpid_valid;                        // DWORD 22
   BE_BIT max_wqe_valid;                          // DWORD 22
   BE_BIT max_rqe_valid;                          // DWORD 22
   BE_BIT sge_send_valid;                         // DWORD 22
   BE_BIT sge_recv_valid;                         // DWORD 22
   BE_BIT write_sge_valid;                        // DWORD 22
   BE_BIT inb_rden_valid;                         // DWORD 22
   BE_BIT inb_wren_valid;                         // DWORD 22
   BE_BIT flow_label_valid;                       // DWORD 22
   BE_BIT bind_en_valid;                          // DWORD 22
   BE_BIT zstag_en_valid;                         // DWORD 22
   BE_BIT fmr_en_valid;                           // DWORD 22
   BE_BIT inb_aten_valid;                         // DWORD 22
   BE_BIT vlan_valid;                             // DWORD 22
   BE_BIT rsvd3[5];                               // DWORD 22
} SG_PACK BE_RDMA_MODIFY_QP_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[23]; } RDMA_MODIFY_QP_PARAMS_IN_SLI_AMAP, *PRDMA_MODIFY_QP_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT16_SLI_AMAP max_rqe;
   BE_UEXACT16_SLI_AMAP max_wqe;
} SG_PACK BE_RDMA_MODIFY_QP_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_MODIFY_QP_PARAMS_OUT_SLI_AMAP, *PRDMA_MODIFY_QP_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_MODIFY_QP_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_MODIFY_QP_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_MODIFY_QP_PARAMS_SLI_AMAP;
typedef struct { u32 dw[23]; } RDMA_MODIFY_QP_PARAMS_SLI_AMAP, *PRDMA_MODIFY_QP_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_MODIFY_QP_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_MODIFY_QP_SLI_AMAP;
typedef struct { u32 dw[27]; } IOCTL_RDMA_MODIFY_QP_SLI_AMAP, *PIOCTL_RDMA_MODIFY_QP_SLI_AMAP;


typedef struct {
   BE_BIT qp_id[16];                              // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_RDMA_DESTROY_QP_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_QP_PARAMS_IN_SLI_AMAP, *PRDMA_DESTROY_QP_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_RDMA_DESTROY_QP_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_QP_PARAMS_OUT_SLI_AMAP, *PRDMA_DESTROY_QP_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_DESTROY_QP_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_DESTROY_QP_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_DESTROY_QP_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_QP_PARAMS_SLI_AMAP, *PRDMA_DESTROY_QP_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_DESTROY_QP_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_DESTROY_QP_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_RDMA_DESTROY_QP_SLI_AMAP, *PIOCTL_RDMA_DESTROY_QP_SLI_AMAP;


typedef struct {
   BE_BIT pd_id[16];                              // DWORD 0
   BE_BIT rq_page_size[3];                        // DWORD 0
   BE_BIT rpir_blk_size[4];                       // DWORD 0
   BE_BIT enable_rpir;                            // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT16_SLI_AMAP max_rqe;
   BE_UEXACT16_SLI_AMAP max_sge_recv;
   BE_UEXACT16_SLI_AMAP rqe_size;
   BE_UEXACT16_SLI_AMAP max_srq_pages;
   BE_PHYS_ADDR_SLI_AMAP wq_addr[8];
   BE_UEXACT32_SLI_AMAP rbq_id;
} SG_PACK BE_RDMA_CREATE_SRQ_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[20]; } RDMA_CREATE_SRQ_PARAMS_IN_SLI_AMAP, *PRDMA_CREATE_SRQ_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT srq_id[24];                             // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT16_SLI_AMAP max_rqe_alloc;
   BE_UEXACT16_SLI_AMAP max_sge_recv_alloc;
} SG_PACK BE_RDMA_CREATE_SRQ_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_CREATE_SRQ_PARAMS_OUT_SLI_AMAP, *PRDMA_CREATE_SRQ_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_CREATE_SRQ_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_CREATE_SRQ_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_CREATE_SRQ_PARAMS_SLI_AMAP;
typedef struct { u32 dw[20]; } RDMA_CREATE_SRQ_PARAMS_SLI_AMAP, *PRDMA_CREATE_SRQ_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_CREATE_SRQ_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_CREATE_SRQ_SLI_AMAP;
typedef struct { u32 dw[24]; } IOCTL_RDMA_CREATE_SRQ_SLI_AMAP, *PIOCTL_RDMA_CREATE_SRQ_SLI_AMAP;


typedef struct {
   BE_BIT srq_id[24];                             // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_RDMA_QUERY_SRQ_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_QUERY_SRQ_PARAMS_IN_SLI_AMAP, *PRDMA_QUERY_SRQ_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT16_SLI_AMAP pd_id;
   BE_UEXACT16_SLI_AMAP max_rqe;
   BE_UEXACT16_SLI_AMAP max_sge_recv;
   BE_UEXACT16_SLI_AMAP srq_limit;
   BE_BIT rsvd0[24];                              // DWORD 2
   BE_BIT rpir_enabled;                           // DWORD 2
   BE_BIT rsvd1;                                  // DWORD 2
   BE_BIT rpir_blk_size[4];                       // DWORD 2
   BE_BIT rsvd2[2];                               // DWORD 2
   BE_UEXACT32_SLI_AMAP rbq_id;
} SG_PACK BE_RDMA_QUERY_SRQ_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[4]; } RDMA_QUERY_SRQ_PARAMS_OUT_SLI_AMAP, *PRDMA_QUERY_SRQ_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_QUERY_SRQ_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_QUERY_SRQ_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_QUERY_SRQ_PARAMS_SLI_AMAP;
typedef struct { u32 dw[4]; } RDMA_QUERY_SRQ_PARAMS_SLI_AMAP, *PRDMA_QUERY_SRQ_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_QUERY_SRQ_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_QUERY_SRQ_SLI_AMAP;
typedef struct { u32 dw[8]; } IOCTL_RDMA_QUERY_SRQ_SLI_AMAP, *PIOCTL_RDMA_QUERY_SRQ_SLI_AMAP;


typedef struct {
   BE_BIT srq_id[24];                             // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT16_SLI_AMAP max_rqe;
   BE_UEXACT16_SLI_AMAP srq_limit;
} SG_PACK BE_RDMA_MODIFY_SRQ_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_MODIFY_SRQ_PARAMS_IN_SLI_AMAP, *PRDMA_MODIFY_SRQ_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT max_rqe[16];                            // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_RDMA_MODIFY_SRQ_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_MODIFY_SRQ_PARAMS_OUT_SLI_AMAP, *PRDMA_MODIFY_SRQ_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_MODIFY_SRQ_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_MODIFY_SRQ_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_MODIFY_SRQ_PARAMS_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_MODIFY_SRQ_PARAMS_SLI_AMAP, *PRDMA_MODIFY_SRQ_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_MODIFY_SRQ_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_MODIFY_SRQ_SLI_AMAP;
typedef struct { u32 dw[6]; } IOCTL_RDMA_MODIFY_SRQ_SLI_AMAP, *PIOCTL_RDMA_MODIFY_SRQ_SLI_AMAP;


typedef struct {
   BE_BIT srq_id[24];                             // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_RDMA_DESTROY_SRQ_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_SRQ_PARAMS_IN_SLI_AMAP, *PRDMA_DESTROY_SRQ_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_RDMA_DESTROY_SRQ_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_SRQ_PARAMS_OUT_SLI_AMAP, *PRDMA_DESTROY_SRQ_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_DESTROY_SRQ_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_DESTROY_SRQ_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_DESTROY_SRQ_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DESTROY_SRQ_PARAMS_SLI_AMAP, *PRDMA_DESTROY_SRQ_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_DESTROY_SRQ_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_DESTROY_SRQ_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_RDMA_DESTROY_SRQ_SLI_AMAP, *PIOCTL_RDMA_DESTROY_SRQ_SLI_AMAP;


typedef struct {
   BE_BIT pd_id[16];                              // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT addr_check;                             // DWORD 1
   BE_BIT fmr;                                    // DWORD 1
   BE_BIT remote_inv;                             // DWORD 1
   BE_BIT remote_wr;                              // DWORD 1
   BE_BIT remote_rd;                              // DWORD 1
   BE_BIT local_wr;                               // DWORD 1
   BE_BIT remote_atomic;                          // DWORD 1
   BE_BIT rsvd1[9];                               // DWORD 1
   BE_BIT pbl_size[16];                           // DWORD 1
} SG_PACK BE_RDMA_ALLOC_STAG_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_ALLOC_STAG_PARAMS_IN_SLI_AMAP, *PRDMA_ALLOC_STAG_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP lrkey_index;
   BE_BIT rsvd0[16];                              // DWORD 1
   BE_BIT pbl_size[16];                           // DWORD 1
} SG_PACK BE_RDMA_ALLOC_STAG_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_ALLOC_STAG_PARAMS_OUT_SLI_AMAP, *PRDMA_ALLOC_STAG_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_ALLOC_STAG_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_ALLOC_STAG_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_ALLOC_STAG_PARAMS_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_ALLOC_STAG_PARAMS_SLI_AMAP, *PRDMA_ALLOC_STAG_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_ALLOC_STAG_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_ALLOC_STAG_SLI_AMAP;
typedef struct { u32 dw[6]; } IOCTL_RDMA_ALLOC_STAG_SLI_AMAP, *PIOCTL_RDMA_ALLOC_STAG_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP lrkey_index;
   BE_BIT fmr;                                    // DWORD 1
   BE_BIT rsvd0[31];                              // DWORD 1
} SG_PACK BE_RDMA_DEALLOC_STAG_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_DEALLOC_STAG_PARAMS_IN_SLI_AMAP, *PRDMA_DEALLOC_STAG_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_RDMA_DEALLOC_STAG_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_DEALLOC_STAG_PARAMS_OUT_SLI_AMAP, *PRDMA_DEALLOC_STAG_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_DEALLOC_STAG_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_DEALLOC_STAG_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_DEALLOC_STAG_PARAMS_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_DEALLOC_STAG_PARAMS_SLI_AMAP, *PRDMA_DEALLOC_STAG_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_DEALLOC_STAG_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_DEALLOC_STAG_SLI_AMAP;
typedef struct { u32 dw[6]; } IOCTL_RDMA_DEALLOC_STAG_SLI_AMAP, *PIOCTL_RDMA_DEALLOC_STAG_SLI_AMAP;


typedef struct {
   BE_BIT frmr;                                   // DWORD 0
   BE_BIT rsvd0[31];                              // DWORD 0
   BE_UEXACT16_SLI_AMAP pd_id;
   BE_UEXACT16_SLI_AMAP num_pbl;
   BE_BIT pbe_size[16];                           // DWORD 2
   BE_BIT hpage_size[8];                          // DWORD 2
   BE_BIT bind_memwin;                            // DWORD 2
   BE_BIT zb_offset;                              // DWORD 2
   BE_BIT remote_inv;                             // DWORD 2
   BE_BIT remote_wr;                              // DWORD 2
   BE_BIT remote_rd;                              // DWORD 2
   BE_BIT local_wr;                               // DWORD 2
   BE_BIT remote_atomic;                          // DWORD 2
   BE_BIT last;                                   // DWORD 2
   BE_UEXACT32_SLI_AMAP totlen_low;
   BE_UEXACT32_SLI_AMAP totlen_high;
   BE_UEXACT32_SLI_AMAP fbo_low;
   BE_UEXACT32_SLI_AMAP fbo_high;
   BE_UEXACT32_SLI_AMAP va_loaddr;
   BE_UEXACT32_SLI_AMAP va_hiaddr;
   BE_PHYS_ADDR_SLI_AMAP pbl_addr[22];
} SG_PACK BE_RDMA_REGISTER_NSMR_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[53]; } RDMA_REGISTER_NSMR_PARAMS_IN_SLI_AMAP, *PRDMA_REGISTER_NSMR_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP stag;
   BE_BIT rsvd0[16];                              // DWORD 1
   BE_BIT num_pbl[16];                            // DWORD 1
} SG_PACK BE_RDMA_REGISTER_NSMR_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_REGISTER_NSMR_PARAMS_OUT_SLI_AMAP, *PRDMA_REGISTER_NSMR_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_REGISTER_NSMR_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_REGISTER_NSMR_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_REGISTER_NSMR_PARAMS_SLI_AMAP;
typedef struct { u32 dw[53]; } RDMA_REGISTER_NSMR_PARAMS_SLI_AMAP, *PRDMA_REGISTER_NSMR_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_REGISTER_NSMR_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_REGISTER_NSMR_SLI_AMAP;
typedef struct { u32 dw[57]; } IOCTL_RDMA_REGISTER_NSMR_SLI_AMAP, *PIOCTL_RDMA_REGISTER_NSMR_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP stag;
   BE_UEXACT16_SLI_AMAP pbl_offset;
   BE_UEXACT16_SLI_AMAP num_pbl;
   BE_BIT rsvd0[31];                              // DWORD 2
   BE_BIT last;                                   // DWORD 2
   BE_PHYS_ADDR_SLI_AMAP pbl_addr[22];
} SG_PACK BE_RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[47]; } RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI_AMAP, *PRDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP stag;
} SG_PACK BE_RDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI_AMAP, *PRDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_REGISTER_NSMR_CONT_PARAMS_SLI_AMAP;
typedef struct { u32 dw[47]; } RDMA_REGISTER_NSMR_CONT_PARAMS_SLI_AMAP, *PRDMA_REGISTER_NSMR_CONT_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_REGISTER_NSMR_CONT_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_REGISTER_NSMR_CONT_SLI_AMAP;
typedef struct { u32 dw[51]; } IOCTL_RDMA_REGISTER_NSMR_CONT_SLI_AMAP, *PIOCTL_RDMA_REGISTER_NSMR_CONT_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP lkey;
} SG_PACK BE_RDMA_QUERY_NSMR_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_QUERY_NSMR_PARAMS_IN_SLI_AMAP, *PRDMA_QUERY_NSMR_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP lkey;
   BE_BIT pd_id[16];                              // DWORD 1
   BE_BIT rsvd0[8];                               // DWORD 1
   BE_BIT bind_memwin;                            // DWORD 1
   BE_BIT zb_offset;                              // DWORD 1
   BE_BIT remote_inv;                             // DWORD 1
   BE_BIT remote_wr;                              // DWORD 1
   BE_BIT remote_rd;                              // DWORD 1
   BE_BIT local_wr;                               // DWORD 1
   BE_BIT local_rd;                               // DWORD 1
   BE_BIT valid;                                  // DWORD 1
   BE_BIT num_pbl[16];                            // DWORD 2
   BE_BIT rsvd1[16];                              // DWORD 2
} SG_PACK BE_RDMA_QUERY_NSMR_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[3]; } RDMA_QUERY_NSMR_PARAMS_OUT_SLI_AMAP, *PRDMA_QUERY_NSMR_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_QUERY_NSMR_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_QUERY_NSMR_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_QUERY_NSMR_PARAMS_SLI_AMAP;
typedef struct { u32 dw[3]; } RDMA_QUERY_NSMR_PARAMS_SLI_AMAP, *PRDMA_QUERY_NSMR_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_QUERY_NSMR_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_QUERY_NSMR_SLI_AMAP;
typedef struct { u32 dw[7]; } IOCTL_RDMA_QUERY_NSMR_SLI_AMAP, *PIOCTL_RDMA_QUERY_NSMR_SLI_AMAP;


typedef struct {
   BE_BIT pd_id[16];                              // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_RDMA_ALLOC_MW_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_ALLOC_MW_PARAMS_IN_SLI_AMAP, *PRDMA_ALLOC_MW_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP lkey;
} SG_PACK BE_RDMA_ALLOC_MW_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_ALLOC_MW_PARAMS_OUT_SLI_AMAP, *PRDMA_ALLOC_MW_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_ALLOC_MW_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_ALLOC_MW_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_ALLOC_MW_PARAMS_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_ALLOC_MW_PARAMS_SLI_AMAP, *PRDMA_ALLOC_MW_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_ALLOC_MW_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_ALLOC_MW_SLI_AMAP;
typedef struct { u32 dw[5]; } IOCTL_RDMA_ALLOC_MW_SLI_AMAP, *PIOCTL_RDMA_ALLOC_MW_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP lkey;
} SG_PACK BE_RDMA_QUERY_MW_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_QUERY_MW_PARAMS_IN_SLI_AMAP, *PRDMA_QUERY_MW_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP lkey;
   BE_BIT pd_id[16];                              // DWORD 1
   BE_BIT rsvd0[13];                              // DWORD 1
   BE_BIT remote_wr;                              // DWORD 1
   BE_BIT remote_rd;                              // DWORD 1
   BE_BIT valid;                                  // DWORD 1
} SG_PACK BE_RDMA_QUERY_MW_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_QUERY_MW_PARAMS_OUT_SLI_AMAP, *PRDMA_QUERY_MW_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_QUERY_MW_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_QUERY_MW_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_QUERYMW_PARAMS_SLI_AMAP;
typedef struct { u32 dw[2]; } RDMA_QUERYMW_PARAMS_SLI_AMAP, *PRDMA_QUERYMW_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_QUERYMW_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_QUERY_MW_SLI_AMAP;
typedef struct { u32 dw[6]; } IOCTL_RDMA_QUERY_MW_SLI_AMAP, *PIOCTL_RDMA_QUERY_MW_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP active_dpp_pds;
   BE_UEXACT32_SLI_AMAP active_non_dpp_pds;
   BE_UEXACT32_SLI_AMAP active_rc_dpp_qps;
   BE_UEXACT32_SLI_AMAP active_uc_dpp_qps;
   BE_UEXACT32_SLI_AMAP active_ud_dpp_qps;
   BE_UEXACT32_SLI_AMAP active_rc_non_dpp_qps;
   BE_BIT rsvd0[32];                              // DWORD 6
   BE_UEXACT32_SLI_AMAP active_uc_non_dpp_qps;
   BE_UEXACT32_SLI_AMAP active_ud_non_dpp_qps;
   BE_BIT rsvd1[32];                              // DWORD 9
   BE_UEXACT32_SLI_AMAP active_srqs;
   BE_UEXACT32_SLI_AMAP active_rbqs;
   BE_UEXACT32_SLI_AMAP active_64K_nsmr;
   BE_UEXACT32_SLI_AMAP active_64K_to_2M_nsmr;
   BE_UEXACT32_SLI_AMAP active_2M_to_44M_nsmr;
   BE_UEXACT32_SLI_AMAP active_44M_to_1G_nsmr;
   BE_UEXACT32_SLI_AMAP active_1G_to_4G_nsmr;
   BE_UEXACT32_SLI_AMAP active_nsmr_count_4G_to_32G;
   BE_UEXACT32_SLI_AMAP active_32G_to_64G_nsmr;
   BE_UEXACT32_SLI_AMAP active_64G_to_128G_nsmr;
   BE_UEXACT32_SLI_AMAP active_128G_to_higher_nsmr;
   BE_UEXACT32_SLI_AMAP active_embedded_nsmr;
   BE_UEXACT32_SLI_AMAP active_frmr;
   BE_UEXACT32_SLI_AMAP active_prefetch_qps;
   BE_UEXACT32_SLI_AMAP active_ondemand_qps;
   BE_BIT rsvd2[9][32];                           // DWORD 25
} SG_PACK BE_ACTIVE_RESOURCE_STATS_SLI_AMAP;
typedef struct { u32 dw[34]; } ACTIVE_RESOURCE_STATS_SLI_AMAP, *PACTIVE_RESOURCE_STATS_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP sq_doorbell_errors;
   BE_UEXACT32_SLI_AMAP cq_doorbell_errors;
   BE_UEXACT32_SLI_AMAP rq_srq_doorbell_errors;
   BE_UEXACT32_SLI_AMAP cq_overflow_errors;
   BE_BIT rsvd0[4][32];                           // DWORD 4
} SG_PACK BE_DB_ERROR_STATS_SLI_AMAP;
typedef struct { u32 dw[8]; } DB_ERROR_STATS_SLI_AMAP, *PDB_ERROR_STATS_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP large_send_rc_wqes_lo;
   BE_UEXACT32_SLI_AMAP large_send_rc_wqee_hi;
   BE_UEXACT32_SLI_AMAP large_write_rc_wqe_lo;
   BE_UEXACT32_SLI_AMAP large_write_rc_wqe_hi;
   BE_BIT rsvd0[4][32];                           // DWORD 4
   BE_UEXACT32_SLI_AMAP read_wqes_lo;
   BE_UEXACT32_SLI_AMAP read_wqes_hi;
   BE_UEXACT32_SLI_AMAP frmr_wqes_lo;
   BE_UEXACT32_SLI_AMAP frmr_wqes_hi;
   BE_UEXACT32_SLI_AMAP mw_bind_wqes_lo;
   BE_UEXACT32_SLI_AMAP mw_bind_wqes_hi;
   BE_UEXACT32_SLI_AMAP invalidate_wqes_lo;
   BE_UEXACT32_SLI_AMAP invalidate_wqes_hi;
   BE_BIT rsvd1[2][32];                           // DWORD 16
   BE_UEXACT32_SLI_AMAP dpp_wqe_drops;
   BE_BIT rsvd2[5][32];                           // DWORD 19
} SG_PACK BE_WQE_STATS_SLI_AMAP;
typedef struct { u32 dw[24]; } WQE_STATS_SLI_AMAP, *PWQE_STATS_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP send_pkts_lo;
   BE_UEXACT32_SLI_AMAP send_pkts_hi;
   BE_UEXACT32_SLI_AMAP write_pkts_lo;
   BE_UEXACT32_SLI_AMAP write_pkts_hi;
   BE_UEXACT32_SLI_AMAP read_pkts_lo;
   BE_UEXACT32_SLI_AMAP read_pkts_hi;
   BE_UEXACT32_SLI_AMAP read_resp_pkts_lo;
   BE_UEXACT32_SLI_AMAP read_resp_pkts_hi;
   BE_UEXACT32_SLI_AMAP ack_pkts_lo;
   BE_UEXACT32_SLI_AMAP ack_pkts_hi;
   BE_UEXACT32_SLI_AMAP send_bytes_lo;
   BE_UEXACT32_SLI_AMAP send_bytes_hi;
   BE_UEXACT32_SLI_AMAP write_bytes_lo;
   BE_UEXACT32_SLI_AMAP write_bytes_hi;
   BE_UEXACT32_SLI_AMAP read_req_bytes_lo;
   BE_UEXACT32_SLI_AMAP read_req_bytes_hi;
   BE_UEXACT32_SLI_AMAP read_rsp_bytes_lo;
   BE_UEXACT32_SLI_AMAP read_rsp_bytes_hi;
   BE_UEXACT32_SLI_AMAP ack_timeouts;
   BE_BIT rsvd0[5][32];                           // DWORD 19
} SG_PACK BE_TX_STATS_SLI_AMAP;
typedef struct { u32 dw[24]; } TX_STATS_SLI_AMAP, *PTX_STATS_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP local_length_errors;
   BE_UEXACT32_SLI_AMAP local_protection_errors;
   BE_UEXACT32_SLI_AMAP local_qp_operation_errors;
   BE_UEXACT32_SLI_AMAP retry_count_exceeded_errors;
   BE_UEXACT32_SLI_AMAP rnr_retry_count_exceeded_errors;
   BE_BIT rsvd0[3][32];                           // DWORD 5
} SG_PACK BE_TX_QP_ERROR_STATS_SLI_AMAP;
typedef struct { u32 dw[8]; } TX_QP_ERROR_STATS_SLI_AMAP, *PTX_QP_ERROR_STATS_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP roce_frame_bytes_lo;
   BE_UEXACT32_SLI_AMAP roce_frame_bytes_hi;
   BE_UEXACT32_SLI_AMAP roce_frame_icrc_drops;
   BE_UEXACT32_SLI_AMAP roce_frame_payload_len_drops;
   BE_UEXACT32_SLI_AMAP ud_drops;
   BE_UEXACT32_SLI_AMAP qp1_drops;
   BE_UEXACT32_SLI_AMAP psn_error_request_packets;
   BE_UEXACT32_SLI_AMAP psn_error_resp_packets;
   BE_UEXACT32_SLI_AMAP rnr_nak_timeouts;
   BE_UEXACT32_SLI_AMAP rnr_nak_receives;
   BE_UEXACT32_SLI_AMAP roce_frame_rxmt_drops;
   BE_UEXACT32_SLI_AMAP nak_count_psn_sequence_errors;
   BE_UEXACT32_SLI_AMAP rc_drop_count_lookup_errors;
   BE_UEXACT32_SLI_AMAP rq_rnr_naks;
   BE_UEXACT32_SLI_AMAP srq_rnr_naks;
   BE_UEXACT32_SLI_AMAP roce_frames_lo;
   BE_UEXACT32_SLI_AMAP roce_frames_hi;
   BE_BIT rsvd0[32];                              // DWORD 17
} SG_PACK BE_RX_STATS_SLI_AMAP;
typedef struct { u32 dw[18]; } RX_STATS_SLI_AMAP, *PRX_STATS_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP nak_invalid_requst_errors;
   BE_UEXACT32_SLI_AMAP nak_remote_operation_errors;
   BE_UEXACT32_SLI_AMAP nak_count_remote_access_errors;
   BE_UEXACT32_SLI_AMAP local_length_errors;
   BE_UEXACT32_SLI_AMAP local_protection_errors;
   BE_UEXACT32_SLI_AMAP local_qp_operation_errors;
   BE_BIT rsvd0[2][32];                           // DWORD 6
} SG_PACK BE_RX_QP_ERROR_STATS_SLI_AMAP;
typedef struct { u32 dw[8]; } RX_QP_ERROR_STATS_SLI_AMAP, *PRX_QP_ERROR_STATS_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP debug_stats[100];
} SG_PACK BE_TX_DEBUG_STATS_SLI_AMAP;
typedef struct { u32 dw[100]; } TX_DEBUG_STATS_SLI_AMAP, *PTX_DEBUG_STATS_SLI_AMAP;


typedef struct {
   BE_UEXACT32_SLI_AMAP debug_stats[200];
} SG_PACK BE_RX_DEBUG_STATS_SLI_AMAP;
typedef struct { u32 dw[200]; } RX_DEBUG_STATS_SLI_AMAP, *PRX_DEBUG_STATS_SLI_AMAP;


typedef struct {
   BE_BIT reset_stat[8];                          // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_RDMA_GET_STATS_PARAMS_IN_SLI_AMAP;
typedef struct { u32 dw[1]; } RDMA_GET_STATS_PARAMS_IN_SLI_AMAP, *PRDMA_GET_STATS_PARAMS_IN_SLI_AMAP;


typedef struct {
   BE_ACTIVE_RESOURCE_STATS_SLI_AMAP active_res;
   BE_DB_ERROR_STATS_SLI_AMAP db_errs;
   BE_WQE_STATS_SLI_AMAP wqe_stats;
   BE_TX_STATS_SLI_AMAP tx_stats;
   BE_TX_QP_ERROR_STATS_SLI_AMAP tx_qp_errs;
   BE_RX_STATS_SLI_AMAP rx_stats;
   BE_RX_QP_ERROR_STATS_SLI_AMAP rx_qp_errs;
   BE_TX_DEBUG_STATS_SLI_AMAP tx_dbg_stats;
   BE_RX_DEBUG_STATS_SLI_AMAP rx_dbg_stats;
} SG_PACK BE_RDMA_GET_STATS_PARAMS_OUT_SLI_AMAP;
typedef struct { u32 dw[424]; } RDMA_GET_STATS_PARAMS_OUT_SLI_AMAP, *PRDMA_GET_STATS_PARAMS_OUT_SLI_AMAP;


typedef union {
   BE_RDMA_GET_STATS_PARAMS_IN_SLI_AMAP request;
   BE_RDMA_GET_STATS_PARAMS_OUT_SLI_AMAP response;
} SG_PACK BE_RDMA_GET_STATS_PARAMS_SLI_AMAP;
typedef struct { u32 dw[424]; } RDMA_GET_STATS_PARAMS_SLI_AMAP, *PRDMA_GET_STATS_PARAMS_SLI_AMAP;


typedef struct {
   BE_IOCTL_HEADER_SLI_AMAP header;
   BE_RDMA_GET_STATS_PARAMS_SLI_AMAP params;
} SG_PACK BE_IOCTL_RDMA_GET_STATS_SLI_AMAP;
typedef struct { u32 dw[428]; } IOCTL_RDMA_GET_STATS_SLI_AMAP, *PIOCTL_RDMA_GET_STATS_SLI_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_sli_amap_h__

