/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// manufacture, use,or sell anything that it may describe, in whole or in part, without   
// thespecific written consent of  EMULEX CORPORATION.  Any reproduction of thissource    
// code without the express written consent of EMULEX CORPORATION is aviolation of the    
// copyrights laws and may subject you to criminal prosecution.                           

// Autogenerated file. Do not edit!
// srcgen version: 0165
#ifndef __ioctl_sli_bmap_h__
#define __ioctl_sli_bmap_h__

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif


typedef struct _PHYS_ADDR_SLI {
   union {
      struct { 
         u32 lo;                                  // DWORD 0
         u32 hi;                                  // DWORD 1
      } SG_PACK ; // unnamed struct
      u32 dw[2]; // dword union
   }; // unnamed union
} SG_PACK PHYS_ADDR_SLI, *PPHYS_ADDR_SLI;

SG_C_ASSERT(__sizeof__PHYS_ADDR, sizeof (PHYS_ADDR_SLI) == 8);


// --- IOCTL_SUBSYSTEMS ---
#define IOCTL_SUBSYSTEM_RSVD_SLI        (0)       
#define IOCTL_SUBSYSTEM_COMMON_SLI      (1)       
#define IOCTL_SUBSYSTEM_COMMON_ISCSI_SLI (2)      
#define IOCTL_SUBSYSTEM_ETH_SLI         (3)       
#define IOCTL_SUBSYSTEM_TOE_SLI         (4)       
#define IOCTL_SUBSYSTEM_PXE_UNDI_SLI    (5)       
#define IOCTL_SUBSYSTEM_ISCSI_INI_SLI   (6)       
#define IOCTL_SUBSYSTEM_ISCSI_TGT_SLI   (7)       
#define IOCTL_SUBSYSTEM_MILI_PTL_SLI    (8)       
#define IOCTL_SUBSYSTEM_MILI_TMD_SLI    (9)       
#define IOCTL_SUBSYSTEM_RDMA_SLI        (10)      
#define IOCTL_SUBSYSTEM_LOWLEVEL_SLI    (11)      
#define IOCTL_SUBSYSTEM_COMMON_FCOE_SLI (12)      
#define IOCTL_SUBSYSTEM_LRO_SLI         (13)      
#define IOCTL_SUBSYSTEM_DAL_SLI         (14)      
#define IOCTL_SUBSYSTEM_LLDP_SLI        (15)      
#define IOCTL_SUBSYSTEM_DCBX_SLI        (16)      
#define IOCTL_SUBSYSTEM_DMTF_SLI        (17)      
#define IOCTL_SUBSYSTEM_DIAG_SLI        (18)      
#define IOCTL_SUBSYSTEM_VENDOR_SLI      (19)      
#define IOCTL_SUBSYSTEM_VNTAG_SLI       (20)      
#define IOCTL_SUBSYSTEM_OEM_SLI         (21)      
#define IOCTL_SUBSYSTEM_SURF_SLI        (22)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* ioctl_subsystems_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case IOCTL_SUBSYSTEM_RSVD_SLI:
            return "IOCTL_SUBSYSTEM_RSVD_SLI";
         case IOCTL_SUBSYSTEM_COMMON_SLI:
            return "IOCTL_SUBSYSTEM_COMMON_SLI";
         case IOCTL_SUBSYSTEM_COMMON_ISCSI_SLI:
            return "IOCTL_SUBSYSTEM_COMMON_ISCSI_SLI";
         case IOCTL_SUBSYSTEM_ETH_SLI:
            return "IOCTL_SUBSYSTEM_ETH_SLI";
         case IOCTL_SUBSYSTEM_TOE_SLI:
            return "IOCTL_SUBSYSTEM_TOE_SLI";
         case IOCTL_SUBSYSTEM_PXE_UNDI_SLI:
            return "IOCTL_SUBSYSTEM_PXE_UNDI_SLI";
         case IOCTL_SUBSYSTEM_ISCSI_INI_SLI:
            return "IOCTL_SUBSYSTEM_ISCSI_INI_SLI";
         case IOCTL_SUBSYSTEM_ISCSI_TGT_SLI:
            return "IOCTL_SUBSYSTEM_ISCSI_TGT_SLI";
         case IOCTL_SUBSYSTEM_MILI_PTL_SLI:
            return "IOCTL_SUBSYSTEM_MILI_PTL_SLI";
         case IOCTL_SUBSYSTEM_MILI_TMD_SLI:
            return "IOCTL_SUBSYSTEM_MILI_TMD_SLI";
         case IOCTL_SUBSYSTEM_RDMA_SLI:
            return "IOCTL_SUBSYSTEM_RDMA_SLI";
         case IOCTL_SUBSYSTEM_LOWLEVEL_SLI:
            return "IOCTL_SUBSYSTEM_LOWLEVEL_SLI";
         case IOCTL_SUBSYSTEM_COMMON_FCOE_SLI:
            return "IOCTL_SUBSYSTEM_COMMON_FCOE_SLI";
         case IOCTL_SUBSYSTEM_LRO_SLI:
            return "IOCTL_SUBSYSTEM_LRO_SLI";
         case IOCTL_SUBSYSTEM_DAL_SLI:
            return "IOCTL_SUBSYSTEM_DAL_SLI";
         case IOCTL_SUBSYSTEM_LLDP_SLI:
            return "IOCTL_SUBSYSTEM_LLDP_SLI";
         case IOCTL_SUBSYSTEM_DCBX_SLI:
            return "IOCTL_SUBSYSTEM_DCBX_SLI";
         case IOCTL_SUBSYSTEM_DMTF_SLI:
            return "IOCTL_SUBSYSTEM_DMTF_SLI";
         case IOCTL_SUBSYSTEM_DIAG_SLI:
            return "IOCTL_SUBSYSTEM_DIAG_SLI";
         case IOCTL_SUBSYSTEM_VENDOR_SLI:
            return "IOCTL_SUBSYSTEM_VENDOR_SLI";
         case IOCTL_SUBSYSTEM_VNTAG_SLI:
            return "IOCTL_SUBSYSTEM_VNTAG_SLI";
         case IOCTL_SUBSYSTEM_OEM_SLI:
            return "IOCTL_SUBSYSTEM_OEM_SLI";
         case IOCTL_SUBSYSTEM_SURF_SLI:
            return "IOCTL_SUBSYSTEM_SURF_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_SUBSYSTEM_OPCODES ---
#define OPCODE_COMMON_NTWK_MAC_QUERY_SLI (1)      
#define SUBSYSTEM_COMMON_NTWK_MAC_QUERY_SLI (1)   
#define SUBSYSTEM_COMMON_NTWK_MAC_SET_SLI (1)     
#define SUBSYSTEM_COMMON_NTWK_MULTICAST_SET_SLI (1) 
#define SUBSYSTEM_COMMON_NTWK_VLAN_CONFIG_SLI (1) 
#define SUBSYSTEM_COMMON_NTWK_LINK_STATUS_QUERY_SLI (1) 
#define SUBSYSTEM_COMMON_READ_FLASHROM_SLI (1)    
#define SUBSYSTEM_COMMON_WRITE_FLASHROM_SLI (1)   
#define SUBSYSTEM_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_SLI (1) 
#define SUBSYSTEM_COMMON_ADD_PAGE_TABLES_SLI (1)  
#define SUBSYSTEM_COMMON_REMOVE_PAGE_TABLES_SLI (1) 
#define SUBSYSTEM_COMMON_CQ_CREATE_SLI  (1)       
#define SUBSYSTEM_COMMON_EQ_CREATE_SLI  (1)       
#define SUBSYSTEM_COMMON_MCC_CREATE_SLI (1)       
#define SUBSYSTEM_COMMON_JELL_CONFIG_SLI (1)      
#define SUBSYSTEM_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_SLI (1) 
#define SUBSYSTEM_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_SLI (1) 
#define SUBSYSTEM_COMMON_POST_ZERO_BUFFER_SLI (1) 
#define SUBSYSTEM_COMMON_GET_QOS_SLI    (1)       
#define SUBSYSTEM_COMMON_SET_QOS_SLI    (1)       
#define SUBSYSTEM_COMMON_TCP_GET_STATISTICS_SLI (1) 
#define SUBSYSTEM_COMMON_SEEPROM_READ_SLI (1)     
#define SUBSYSTEM_COMMON_TCP_STATE_QUERY_SLI (1)  
#define SUBSYSTEM_COMMON_GET_CNTL_ATTRIBUTES_SLI (1) 
#define SUBSYSTEM_COMMON_NOP_SLI        (1)       
#define SUBSYSTEM_COMMON_NTWK_RX_FILTER_SLI (1)   
#define SUBSYSTEM_COMMON_GET_FW_VERSION_SLI (1)   
#define SUBSYSTEM_COMMON_SET_FLOW_CONTROL_SLI (1) 
#define SUBSYSTEM_COMMON_GET_FLOW_CONTROL_SLI (1) 
#define SUBSYSTEM_COMMON_SET_TCP_PARAMETERS_SLI (1) 
#define SUBSYSTEM_COMMON_SET_FRAME_SIZE_SLI (1)   
#define SUBSYSTEM_COMMON_GET_FAT_SLI    (1)       
#define SUBSYSTEM_COMMON_MODIFY_EQ_DELAY_SLI (1)  
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_DOMAINS_SLI (1) 
#define SUBSYSTEM_COMMON_GET_DOMAIN_CONFIG_SLI (1) 
#define SUBSYSTEM_COMMON_GET_PORT_EQUALIZATION_SLI (1) 
#define SUBSYSTEM_COMMON_SET_PORT_EQUALIZATION_SLI (1) 
#define SUBSYSTEM_COMMON_RED_CONFIG_SLI (1)       
#define SUBSYSTEM_COMMON_NTWK_INTERFACE_CREATE_SLI (1) 
#define SUBSYSTEM_COMMON_NTWK_INTERFACE_DESTROY_SLI (1) 
#define SUBSYSTEM_COMMON_CEV_MODIFY_MSI_MESSAGES_SLI (1) 
#define SUBSYSTEM_COMMON_MCC_DESTROY_SLI (1)      
#define SUBSYSTEM_COMMON_CQ_DESTROY_SLI (1)       
#define SUBSYSTEM_COMMON_EQ_DESTROY_SLI (1)       
#define SUBSYSTEM_COMMON_TCP_UPLOAD_SLI (1)       
#define SUBSYSTEM_COMMON_NTWK_SET_LINK_SPEED_SLI (1) 
#define SUBSYSTEM_COMMON_QUERY_FIRMWARE_CONFIG_SLI (1) 
#define SUBSYSTEM_COMMON_NTWK_PMAC_ADD_SLI (1)    
#define SUBSYSTEM_COMMON_NTWK_PMAC_DEL_SLI (1)    
#define SUBSYSTEM_COMMON_FUNCTION_RESET_SLI (1)   
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_PORT_SLI (1) 
#define SUBSYSTEM_COMMON_GET_PORT_CAPABILITY_SLI (1) 
#define SUBSYSTEM_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_SLI (1) 
#define SUBSYSTEM_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_SLI (1) 
#define SUBSYSTEM_COMMON_GET_BOOT_CONFIG_SLI (1)  
#define SUBSYSTEM_COMMON_SET_BOOT_CONFIG_SLI (1)  
#define SUBSYSTEM_COMMON_MANAGE_FAT_SLI (1)       
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_BEACON_SLI (1) 
#define SUBSYSTEM_COMMON_GET_BEACON_STATE_SLI (1) 
#define SUBSYSTEM_COMMON_GET_PORT_STATUS_SLI (1)  
#define SUBSYSTEM_COMMON_READ_PCI_CONFIG_SPACE_SLI (1) 
#define SUBSYSTEM_COMMON_READ_TRANSRECEIVER_DATA_SLI (1) 
#define SUBSYSTEM_COMMON_GET_OEM_ATTRIBUTES_SLI (1) 
#define SUBSYSTEM_COMMON_GET_PORT_NAME_SLI (1)    
#define SUBSYSTEM_COMMON_GET_CONFIG_SIGNATURE_SLI (1) 
#define SUBSYSTEM_COMMON_SET_CONFIG_SIGNATURE_SLI (1) 
#define SUBSYSTEM_COMMON_FUNCTION_LINK_CONFIG_SLI (1) 
#define SUBSYSTEM_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_SLI (1) 
#define SUBSYSTEM_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_SLI (1) 
#define SUBSYSTEM_COMMON_GET_PCI_FUNCTION_MAPPING_SLI (1) 
#define SUBSYSTEM_COMMON_QUERY_PERSONALITY_CHANGE_SLI (1) 
#define SUBSYSTEM_COMMON_QUERY_CHIP_SERIAL_NUMBER_SLI (1) 
#define SUBSYSTEM_COMMON_GET_NCSI_CONFIGURATION_SLI (1) 
#define SUBSYSTEM_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_SLI (1) 
#define SUBSYSTEM_COMMON_START_MANAGEMENT_SERVICE_SLI (1) 
#define SUBSYSTEM_COMMON_SET_INTERRUPT_ENABLE_SLI (1) 
#define SUBSYSTEM_COMMON_MCC_CREATE_EXT_SLI (1)   
#define SUBSYSTEM_COMMON_GET_VPD_DATA_SLI (1)     
#define SUBSYSTEM_COMMON_SET_VPD_DATA_SLI (1)     
#define SUBSYSTEM_COMMON_SET_FUNCTION_PRIVILEGES_SLI (1) 
#define SUBSYSTEM_COMMON_SET_VF_PORT_TYPE_SLI (1) 
#define SUBSYSTEM_COMMON_GET_PHY_DETAILS_SLI (1)  
#define SUBSYSTEM_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_SLI (1) 
#define SUBSYSTEM_COMMON_GET_ADAPTER_ID_SLI (1)   
#define SUBSYSTEM_COMMON_GET_UPGRADE_FEATURES_SLI (1) 
#define SUBSYSTEM_COMMON_GET_INSTALLED_FEATURES_SLI (1) 
#define SUBSYSTEM_COMMON_GET_AVAILABLE_PERSONALITIES_SLI (1) 
#define SUBSYSTEM_COMMON_GET_CONFIGURED_PERSONALITY_SLI (1) 
#define SUBSYSTEM_COMMON_SEND_ACTIVATION_SLI (1)  
#define SUBSYSTEM_COMMON_RESET_LICENSES_SLI (1)   
#define SUBSYSTEM_COMMON_GET_FUNCTION_NAME_INFO_SLI (1) 
#define SUBSYSTEM_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_SLI (1) 
#define SUBSYSTEM_COMMON_GET_CAPABILITY_SLI (1)   
#define SUBSYSTEM_COMMON_SET_SWITCH_TYPE_SLI (1)  
#define SUBSYSTEM_COMMON_GET_EXT_FAT_CAPABILITES_SLI (1) 
#define SUBSYSTEM_COMMON_SET_EXT_FAT_CAPABILITES_SLI (1) 
#define SUBSYSTEM_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_SLI (1) 
#define SUBSYSTEM_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_SLI (1) 
#define SUBSYSTEM_COMMON_DMA_HOST_BUFFERS_SLI (1) 
#define SUBSYSTEM_COMMON_EXT_FAT_READ_STRING_TABLE_SLI (1) 
#define SUBSYSTEM_COMMON_POPULATE_SENSOR_CFG_INFO_SLI (1) 
#define SUBSYSTEM_COMMON_SET_TX_THROTTLE_SLI (1)  
#define SUBSYSTEM_COMMON_GET_TX_THROTTLE_SLI (1)  
#define SUBSYSTEM_COMMON_NTWK_GET_LINK_SPEED_SLI (1) 
#define SUBSYSTEM_COMMON_NTWK_GET_MAC_LIST_SLI (1) 
#define SUBSYSTEM_COMMON_NTWK_SET_MAC_LIST_SLI (1) 
#define SUBSYSTEM_COMMON_MODIFY_CQ_SLI  (1)       
#define SUBSYSTEM_COMMON_NTWK_GET_VLAN_LIST_SLI (1) 
#define SUBSYSTEM_COMMON_NTWK_SET_VLAN_LIST_SLI (1) 
#define SUBSYSTEM_COMMON_GET_HSW_CONFIG_SLI (1)   
#define SUBSYSTEM_COMMON_SET_HSW_CONFIG_SLI (1)   
#define SUBSYSTEM_COMMON_GET_FUNCTION_CONFIG_SLI (1) 
#define SUBSYSTEM_COMMON_GET_PROFILE_CAPACITIES_SLI (1) 
#define SUBSYSTEM_COMMON_GET_PROFILE_CONFIG_SLI (1) 
#define SUBSYSTEM_COMMON_SET_PROFILE_CONFIG_SLI (1) 
#define SUBSYSTEM_COMMON_GET_PROFILE_LIST_SLI (1) 
#define SUBSYSTEM_COMMON_GET_ACTIVE_PROFILE_SLI (1) 
#define SUBSYSTEM_COMMON_SET_ACTIVE_PROFILE_SLI (1) 
#define SUBSYSTEM_COMMON_SET_FACTORY_PROFILE_CONFIG_SLI (1) 
#define SUBSYSTEM_COMMON_GET_FUNCTION_PRIVILEGES_SLI (1) 
#define SUBSYSTEM_COMMON_READ_OBJECT_SLI (1)      
#define SUBSYSTEM_COMMON_WRITE_OBJECT_SLI (1)     
#define SUBSYSTEM_COMMON_GET_DEVICE_UTILIZATION_SLI (1) 
#define SUBSYSTEM_COMMON_GET_SLI4_PARAMETERS_SLI (1) 
#define SUBSYSTEM_COMMON_POPULATE_OCBB_CFG_INFO_SLI (1) 
#define SUBSYSTEM_COMMON_MODIFY_ASYNC_EVENTS_SLI (1) 
#define SUBSYSTEM_COMMON_MANAGE_FFV_SLI (1)       
#define SUBSYSTEM_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI (1) 
#define SUBSYSTEM_COMMON_GET_IFACE_LIST_SLI (1)   
#define SUBSYSTEM_COMMON_WQ_CONTROL_SLI (1)       
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_VF_SLI (1) 
#define SUBSYSTEM_COMMON_ALLOC_PD_SLI   (1)       
#define SUBSYSTEM_COMMON_DEALLOC_PD_SLI (1)       
#define SUBSYSTEM_COMMON_GET_RECONFIG_LINK_INFO_SLI (1) 
#define SUBSYSTEM_COMMON_SET_RECONFIG_LINK_ID_SLI (1) 
#define OPCODE_COMMON_NTWK_MAC_SET_SLI  (2)       
#define OPCODE_COMMON_NTWK_MULTICAST_SET_SLI (3)  
#define OPCODE_COMMON_NTWK_VLAN_CONFIG_SLI (4)    
#define OPCODE_COMMON_NTWK_LINK_STATUS_QUERY_SLI (5) 
#define OPCODE_COMMON_READ_FLASHROM_SLI (6)       
#define OPCODE_COMMON_WRITE_FLASHROM_SLI (7)      
#define OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_SLI (8) 
#define OPCODE_COMMON_ADD_PAGE_TABLES_SLI (9)     
#define OPCODE_COMMON_REMOVE_PAGE_TABLES_SLI (10) 
#define OPCODE_COMMON_CQ_CREATE_SLI     (12)      
#define OPCODE_COMMON_EQ_CREATE_SLI     (13)      
#define OPCODE_COMMON_MCC_CREATE_SLI    (21)      
#define OPCODE_COMMON_JELL_CONFIG_SLI   (22)      
#define OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_SLI (24) 
#define OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_SLI (25) 
#define OPCODE_COMMON_POST_ZERO_BUFFER_SLI (26)   
#define OPCODE_COMMON_GET_QOS_SLI       (27)      
#define OPCODE_COMMON_SET_QOS_SLI       (28)      
#define OPCODE_COMMON_TCP_GET_STATISTICS_SLI (29) 
#define OPCODE_COMMON_SEEPROM_READ_SLI  (30)      
#define OPCODE_COMMON_TCP_STATE_QUERY_SLI (31)    
#define OPCODE_COMMON_GET_CNTL_ATTRIBUTES_SLI (32) 
#define OPCODE_COMMON_NOP_SLI           (33)      
#define OPCODE_COMMON_NTWK_RX_FILTER_SLI (34)     
#define OPCODE_COMMON_GET_FW_VERSION_SLI (35)     
#define OPCODE_COMMON_SET_FLOW_CONTROL_SLI (36)   
#define OPCODE_COMMON_GET_FLOW_CONTROL_SLI (37)   
#define OPCODE_COMMON_SET_TCP_PARAMETERS_SLI (38) 
#define OPCODE_COMMON_SET_FRAME_SIZE_SLI (39)     
#define OPCODE_COMMON_GET_FAT_SLI       (40)      
#define OPCODE_COMMON_MODIFY_EQ_DELAY_SLI (41)    
#define OPCODE_COMMON_ENABLE_DISABLE_DOMAINS_SLI (43) 
#define OPCODE_COMMON_GET_DOMAIN_CONFIG_SLI (44)  
#define OPCODE_COMMON_GET_PORT_EQUALIZATION_SLI (47) 
#define OPCODE_COMMON_SET_PORT_EQUALIZATION_SLI (48) 
#define OPCODE_COMMON_RED_CONFIG_SLI    (49)      
#define OPCODE_COMMON_NTWK_INTERFACE_CREATE_SLI (50) 
#define OPCODE_COMMON_NTWK_INTERFACE_DESTROY_SLI (51) 
#define OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES_SLI (52) 
#define OPCODE_COMMON_MCC_DESTROY_SLI   (53)      
#define OPCODE_COMMON_CQ_DESTROY_SLI    (54)      
#define OPCODE_COMMON_EQ_DESTROY_SLI    (55)      
#define OPCODE_COMMON_TCP_UPLOAD_SLI    (56)      
#define OPCODE_COMMON_NTWK_SET_LINK_SPEED_SLI (57) 
#define OPCODE_COMMON_QUERY_FIRMWARE_CONFIG_SLI (58) 
#define OPCODE_COMMON_NTWK_PMAC_ADD_SLI (59)      
#define OPCODE_COMMON_NTWK_PMAC_DEL_SLI (60)      
#define OPCODE_COMMON_FUNCTION_RESET_SLI (61)     
#define OPCODE_COMMON_ENABLE_DISABLE_PORT_SLI (62) 
#define OPCODE_COMMON_GET_PORT_CAPABILITY_SLI (63) 
#define OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_SLI (64) 
#define OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_SLI (65) 
#define OPCODE_COMMON_GET_BOOT_CONFIG_SLI (66)    
#define OPCODE_COMMON_SET_BOOT_CONFIG_SLI (67)    
#define OPCODE_COMMON_MANAGE_FAT_SLI    (68)      
#define OPCODE_COMMON_ENABLE_DISABLE_BEACON_SLI (69) 
#define OPCODE_COMMON_GET_BEACON_STATE_SLI (70)   
#define OPCODE_COMMON_GET_PORT_STATUS_SLI (71)    
#define OPCODE_COMMON_READ_PCI_CONFIG_SPACE_SLI (72) 
#define OPCODE_COMMON_READ_TRANSRECEIVER_DATA_SLI (73) 
#define OPCODE_COMMON_GET_OEM_ATTRIBUTES_SLI (76) 
#define OPCODE_COMMON_GET_PORT_NAME_SLI (77)      
#define OPCODE_COMMON_GET_CONFIG_SIGNATURE_SLI (78) 
#define OPCODE_COMMON_SET_CONFIG_SIGNATURE_SLI (79) 
#define OPCODE_COMMON_FUNCTION_LINK_CONFIG_SLI (80) 
#define OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_SLI (81) 
#define OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_SLI (82) 
#define OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING_SLI (83) 
#define OPCODE_COMMON_QUERY_PERSONALITY_CHANGE_SLI (84) 
#define OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER_SLI (85) 
#define OPCODE_COMMON_GET_NCSI_CONFIGURATION_SLI (86) 
#define OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_SLI (87) 
#define OPCODE_COMMON_START_MANAGEMENT_SERVICE_SLI (88) 
#define OPCODE_COMMON_SET_INTERRUPT_ENABLE_SLI (89) 
#define OPCODE_COMMON_MCC_CREATE_EXT_SLI (90)     
#define OPCODE_COMMON_GET_VPD_DATA_SLI  (91)      
#define OPCODE_COMMON_SET_VPD_DATA_SLI  (92)      
#define OPCODE_COMMON_SET_FUNCTION_PRIVILEGES_SLI (100) 
#define OPCODE_COMMON_SET_VF_PORT_TYPE_SLI (101)  
#define OPCODE_COMMON_GET_PHY_DETAILS_SLI (102)   
#define OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_SLI (103) 
#define OPCODE_COMMON_GET_ADAPTER_ID_SLI (110)    
#define OPCODE_COMMON_GET_UPGRADE_FEATURES_SLI (111) 
#define OPCODE_COMMON_GET_INSTALLED_FEATURES_SLI (112) 
#define OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES_SLI (113) 
#define OPCODE_COMMON_GET_CONFIGURED_PERSONALITY_SLI (114) 
#define OPCODE_COMMON_SEND_ACTIVATION_SLI (115)   
#define OPCODE_COMMON_RESET_LICENSES_SLI (116)    
#define OPCODE_COMMON_GET_FUNCTION_NAME_INFO_SLI (120) 
#define OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_SLI (121) 
#define OPCODE_COMMON_GET_CAPABILITY_SLI (123)    
#define OPCODE_COMMON_SET_SWITCH_TYPE_SLI (124)   
#define OPCODE_COMMON_GET_EXT_FAT_CAPABILITES_SLI (125) 
#define OPCODE_COMMON_SET_EXT_FAT_CAPABILITES_SLI (126) 
#define OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_SLI (127) 
#define OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_SLI (128) 
#define OPCODE_COMMON_DMA_HOST_BUFFERS_SLI (129)  
#define OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE_SLI (130) 
#define OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO_SLI (131) 
#define OPCODE_COMMON_SET_TX_THROTTLE_SLI (132)   
#define OPCODE_COMMON_GET_TX_THROTTLE_SLI (133)   
#define OPCODE_COMMON_NTWK_GET_LINK_SPEED_SLI (134) 
#define OPCODE_COMMON_NTWK_GET_MAC_LIST_SLI (147) 
#define OPCODE_COMMON_NTWK_SET_MAC_LIST_SLI (148) 
#define OPCODE_COMMON_MODIFY_CQ_SLI     (149)     
#define OPCODE_COMMON_NTWK_GET_VLAN_LIST_SLI (150) 
#define OPCODE_COMMON_NTWK_SET_VLAN_LIST_SLI (151) 
#define OPCODE_COMMON_GET_HSW_CONFIG_SLI (152)    
#define OPCODE_COMMON_SET_HSW_CONFIG_SLI (153)    
#define OPCODE_COMMON_GET_FUNCTION_CONFIG_SLI (160) 
#define OPCODE_COMMON_GET_PROFILE_CAPACITIES_SLI (161) 
#define OPCODE_COMMON_GET_PROFILE_CONFIG_SLI (164) 
#define OPCODE_COMMON_SET_PROFILE_CONFIG_SLI (165) 
#define OPCODE_COMMON_GET_PROFILE_LIST_SLI (166)  
#define OPCODE_COMMON_GET_ACTIVE_PROFILE_SLI (167) 
#define OPCODE_COMMON_SET_ACTIVE_PROFILE_SLI (168) 
#define OPCODE_COMMON_SET_FACTORY_PROFILE_CONFIG_SLI (169) 
#define OPCODE_COMMON_GET_FUNCTION_PRIVILEGES_SLI (170) 
#define OPCODE_COMMON_READ_OBJECT_SLI   (171)     
#define OPCODE_COMMON_WRITE_OBJECT_SLI  (172)     
#define OPCODE_COMMON_GET_DEVICE_UTILIZATION_SLI (178) 
#define OPCODE_COMMON_GET_SLI4_PARAMETERS_SLI (181) 
#define OPCODE_COMMON_POPULATE_OCBB_CFG_INFO_SLI (182) 
#define OPCODE_COMMON_MODIFY_ASYNC_EVENTS_SLI (185) 
#define OPCODE_COMMON_MANAGE_FFV_SLI    (192)     
#define OPCODE_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI (193) 
#define OPCODE_COMMON_GET_IFACE_LIST_SLI (194)    
#define OPCODE_COMMON_WQ_CONTROL_SLI    (195)     
#define OPCODE_COMMON_ENABLE_DISABLE_VF_SLI (196) 
#define OPCODE_COMMON_ALLOC_PD_SLI      (197)     
#define OPCODE_COMMON_DEALLOC_PD_SLI    (198)     
#define OPCODE_COMMON_GET_RECONFIG_LINK_INFO_SLI (201) 
#define OPCODE_COMMON_SET_RECONFIG_LINK_ID_SLI (202) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_NTWK_MAC_QUERY_SLI:
            return "OPCODE_COMMON_NTWK_MAC_QUERY_SLI";
         case OPCODE_COMMON_NTWK_MAC_SET_SLI:
            return "OPCODE_COMMON_NTWK_MAC_SET_SLI";
         case OPCODE_COMMON_NTWK_MULTICAST_SET_SLI:
            return "OPCODE_COMMON_NTWK_MULTICAST_SET_SLI";
         case OPCODE_COMMON_NTWK_VLAN_CONFIG_SLI:
            return "OPCODE_COMMON_NTWK_VLAN_CONFIG_SLI";
         case OPCODE_COMMON_NTWK_LINK_STATUS_QUERY_SLI:
            return "OPCODE_COMMON_NTWK_LINK_STATUS_QUERY_SLI";
         case OPCODE_COMMON_READ_FLASHROM_SLI:
            return "OPCODE_COMMON_READ_FLASHROM_SLI";
         case OPCODE_COMMON_WRITE_FLASHROM_SLI:
            return "OPCODE_COMMON_WRITE_FLASHROM_SLI";
         case OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_SLI:
            return "OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_SLI";
         case OPCODE_COMMON_ADD_PAGE_TABLES_SLI:
            return "OPCODE_COMMON_ADD_PAGE_TABLES_SLI";
         case OPCODE_COMMON_REMOVE_PAGE_TABLES_SLI:
            return "OPCODE_COMMON_REMOVE_PAGE_TABLES_SLI";
         case OPCODE_COMMON_CQ_CREATE_SLI:
            return "OPCODE_COMMON_CQ_CREATE_SLI";
         case OPCODE_COMMON_EQ_CREATE_SLI:
            return "OPCODE_COMMON_EQ_CREATE_SLI";
         case OPCODE_COMMON_MCC_CREATE_SLI:
            return "OPCODE_COMMON_MCC_CREATE_SLI";
         case OPCODE_COMMON_JELL_CONFIG_SLI:
            return "OPCODE_COMMON_JELL_CONFIG_SLI";
         case OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_SLI:
            return "OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_SLI";
         case OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_SLI:
            return "OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_SLI";
         case OPCODE_COMMON_POST_ZERO_BUFFER_SLI:
            return "OPCODE_COMMON_POST_ZERO_BUFFER_SLI";
         case OPCODE_COMMON_GET_QOS_SLI:
            return "OPCODE_COMMON_GET_QOS_SLI";
         case OPCODE_COMMON_SET_QOS_SLI:
            return "OPCODE_COMMON_SET_QOS_SLI";
         case OPCODE_COMMON_TCP_GET_STATISTICS_SLI:
            return "OPCODE_COMMON_TCP_GET_STATISTICS_SLI";
         case OPCODE_COMMON_SEEPROM_READ_SLI:
            return "OPCODE_COMMON_SEEPROM_READ_SLI";
         case OPCODE_COMMON_TCP_STATE_QUERY_SLI:
            return "OPCODE_COMMON_TCP_STATE_QUERY_SLI";
         case OPCODE_COMMON_GET_CNTL_ATTRIBUTES_SLI:
            return "OPCODE_COMMON_GET_CNTL_ATTRIBUTES_SLI";
         case OPCODE_COMMON_NOP_SLI:
            return "OPCODE_COMMON_NOP_SLI";
         case OPCODE_COMMON_NTWK_RX_FILTER_SLI:
            return "OPCODE_COMMON_NTWK_RX_FILTER_SLI";
         case OPCODE_COMMON_GET_FW_VERSION_SLI:
            return "OPCODE_COMMON_GET_FW_VERSION_SLI";
         case OPCODE_COMMON_SET_FLOW_CONTROL_SLI:
            return "OPCODE_COMMON_SET_FLOW_CONTROL_SLI";
         case OPCODE_COMMON_GET_FLOW_CONTROL_SLI:
            return "OPCODE_COMMON_GET_FLOW_CONTROL_SLI";
         case OPCODE_COMMON_SET_TCP_PARAMETERS_SLI:
            return "OPCODE_COMMON_SET_TCP_PARAMETERS_SLI";
         case OPCODE_COMMON_SET_FRAME_SIZE_SLI:
            return "OPCODE_COMMON_SET_FRAME_SIZE_SLI";
         case OPCODE_COMMON_GET_FAT_SLI:
            return "OPCODE_COMMON_GET_FAT_SLI";
         case OPCODE_COMMON_MODIFY_EQ_DELAY_SLI:
            return "OPCODE_COMMON_MODIFY_EQ_DELAY_SLI";
         case OPCODE_COMMON_ENABLE_DISABLE_DOMAINS_SLI:
            return "OPCODE_COMMON_ENABLE_DISABLE_DOMAINS_SLI";
         case OPCODE_COMMON_GET_DOMAIN_CONFIG_SLI:
            return "OPCODE_COMMON_GET_DOMAIN_CONFIG_SLI";
         case OPCODE_COMMON_GET_PORT_EQUALIZATION_SLI:
            return "OPCODE_COMMON_GET_PORT_EQUALIZATION_SLI";
         case OPCODE_COMMON_SET_PORT_EQUALIZATION_SLI:
            return "OPCODE_COMMON_SET_PORT_EQUALIZATION_SLI";
         case OPCODE_COMMON_RED_CONFIG_SLI:
            return "OPCODE_COMMON_RED_CONFIG_SLI";
         case OPCODE_COMMON_NTWK_INTERFACE_CREATE_SLI:
            return "OPCODE_COMMON_NTWK_INTERFACE_CREATE_SLI";
         case OPCODE_COMMON_NTWK_INTERFACE_DESTROY_SLI:
            return "OPCODE_COMMON_NTWK_INTERFACE_DESTROY_SLI";
         case OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES_SLI:
            return "OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES_SLI";
         case OPCODE_COMMON_MCC_DESTROY_SLI:
            return "OPCODE_COMMON_MCC_DESTROY_SLI";
         case OPCODE_COMMON_CQ_DESTROY_SLI:
            return "OPCODE_COMMON_CQ_DESTROY_SLI";
         case OPCODE_COMMON_EQ_DESTROY_SLI:
            return "OPCODE_COMMON_EQ_DESTROY_SLI";
         case OPCODE_COMMON_TCP_UPLOAD_SLI:
            return "OPCODE_COMMON_TCP_UPLOAD_SLI";
         case OPCODE_COMMON_NTWK_SET_LINK_SPEED_SLI:
            return "OPCODE_COMMON_NTWK_SET_LINK_SPEED_SLI";
         case OPCODE_COMMON_QUERY_FIRMWARE_CONFIG_SLI:
            return "OPCODE_COMMON_QUERY_FIRMWARE_CONFIG_SLI";
         case OPCODE_COMMON_NTWK_PMAC_ADD_SLI:
            return "OPCODE_COMMON_NTWK_PMAC_ADD_SLI";
         case OPCODE_COMMON_NTWK_PMAC_DEL_SLI:
            return "OPCODE_COMMON_NTWK_PMAC_DEL_SLI";
         case OPCODE_COMMON_FUNCTION_RESET_SLI:
            return "OPCODE_COMMON_FUNCTION_RESET_SLI";
         case OPCODE_COMMON_ENABLE_DISABLE_PORT_SLI:
            return "OPCODE_COMMON_ENABLE_DISABLE_PORT_SLI";
         case OPCODE_COMMON_GET_PORT_CAPABILITY_SLI:
            return "OPCODE_COMMON_GET_PORT_CAPABILITY_SLI";
         case OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_SLI:
            return "OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_SLI";
         case OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_SLI:
            return "OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_SLI";
         case OPCODE_COMMON_GET_BOOT_CONFIG_SLI:
            return "OPCODE_COMMON_GET_BOOT_CONFIG_SLI";
         case OPCODE_COMMON_SET_BOOT_CONFIG_SLI:
            return "OPCODE_COMMON_SET_BOOT_CONFIG_SLI";
         case OPCODE_COMMON_MANAGE_FAT_SLI:
            return "OPCODE_COMMON_MANAGE_FAT_SLI";
         case OPCODE_COMMON_ENABLE_DISABLE_BEACON_SLI:
            return "OPCODE_COMMON_ENABLE_DISABLE_BEACON_SLI";
         case OPCODE_COMMON_GET_BEACON_STATE_SLI:
            return "OPCODE_COMMON_GET_BEACON_STATE_SLI";
         case OPCODE_COMMON_GET_PORT_STATUS_SLI:
            return "OPCODE_COMMON_GET_PORT_STATUS_SLI";
         case OPCODE_COMMON_READ_PCI_CONFIG_SPACE_SLI:
            return "OPCODE_COMMON_READ_PCI_CONFIG_SPACE_SLI";
         case OPCODE_COMMON_READ_TRANSRECEIVER_DATA_SLI:
            return "OPCODE_COMMON_READ_TRANSRECEIVER_DATA_SLI";
         case OPCODE_COMMON_GET_OEM_ATTRIBUTES_SLI:
            return "OPCODE_COMMON_GET_OEM_ATTRIBUTES_SLI";
         case OPCODE_COMMON_GET_PORT_NAME_SLI:
            return "OPCODE_COMMON_GET_PORT_NAME_SLI";
         case OPCODE_COMMON_GET_CONFIG_SIGNATURE_SLI:
            return "OPCODE_COMMON_GET_CONFIG_SIGNATURE_SLI";
         case OPCODE_COMMON_SET_CONFIG_SIGNATURE_SLI:
            return "OPCODE_COMMON_SET_CONFIG_SIGNATURE_SLI";
         case OPCODE_COMMON_FUNCTION_LINK_CONFIG_SLI:
            return "OPCODE_COMMON_FUNCTION_LINK_CONFIG_SLI";
         case OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_SLI:
            return "OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_SLI";
         case OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_SLI:
            return "OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_SLI";
         case OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING_SLI:
            return "OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING_SLI";
         case OPCODE_COMMON_QUERY_PERSONALITY_CHANGE_SLI:
            return "OPCODE_COMMON_QUERY_PERSONALITY_CHANGE_SLI";
         case OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER_SLI:
            return "OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER_SLI";
         case OPCODE_COMMON_GET_NCSI_CONFIGURATION_SLI:
            return "OPCODE_COMMON_GET_NCSI_CONFIGURATION_SLI";
         case OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_SLI:
            return "OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_SLI";
         case OPCODE_COMMON_START_MANAGEMENT_SERVICE_SLI:
            return "OPCODE_COMMON_START_MANAGEMENT_SERVICE_SLI";
         case OPCODE_COMMON_SET_INTERRUPT_ENABLE_SLI:
            return "OPCODE_COMMON_SET_INTERRUPT_ENABLE_SLI";
         case OPCODE_COMMON_MCC_CREATE_EXT_SLI:
            return "OPCODE_COMMON_MCC_CREATE_EXT_SLI";
         case OPCODE_COMMON_GET_VPD_DATA_SLI:
            return "OPCODE_COMMON_GET_VPD_DATA_SLI";
         case OPCODE_COMMON_SET_VPD_DATA_SLI:
            return "OPCODE_COMMON_SET_VPD_DATA_SLI";
         case OPCODE_COMMON_SET_FUNCTION_PRIVILEGES_SLI:
            return "OPCODE_COMMON_SET_FUNCTION_PRIVILEGES_SLI";
         case OPCODE_COMMON_SET_VF_PORT_TYPE_SLI:
            return "OPCODE_COMMON_SET_VF_PORT_TYPE_SLI";
         case OPCODE_COMMON_GET_PHY_DETAILS_SLI:
            return "OPCODE_COMMON_GET_PHY_DETAILS_SLI";
         case OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_SLI:
            return "OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_SLI";
         case OPCODE_COMMON_GET_ADAPTER_ID_SLI:
            return "OPCODE_COMMON_GET_ADAPTER_ID_SLI";
         case OPCODE_COMMON_GET_UPGRADE_FEATURES_SLI:
            return "OPCODE_COMMON_GET_UPGRADE_FEATURES_SLI";
         case OPCODE_COMMON_GET_INSTALLED_FEATURES_SLI:
            return "OPCODE_COMMON_GET_INSTALLED_FEATURES_SLI";
         case OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES_SLI:
            return "OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES_SLI";
         case OPCODE_COMMON_GET_CONFIGURED_PERSONALITY_SLI:
            return "OPCODE_COMMON_GET_CONFIGURED_PERSONALITY_SLI";
         case OPCODE_COMMON_SEND_ACTIVATION_SLI:
            return "OPCODE_COMMON_SEND_ACTIVATION_SLI";
         case OPCODE_COMMON_RESET_LICENSES_SLI:
            return "OPCODE_COMMON_RESET_LICENSES_SLI";
         case OPCODE_COMMON_GET_FUNCTION_NAME_INFO_SLI:
            return "OPCODE_COMMON_GET_FUNCTION_NAME_INFO_SLI";
         case OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_SLI:
            return "OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_SLI";
         case OPCODE_COMMON_GET_CAPABILITY_SLI:
            return "OPCODE_COMMON_GET_CAPABILITY_SLI";
         case OPCODE_COMMON_SET_SWITCH_TYPE_SLI:
            return "OPCODE_COMMON_SET_SWITCH_TYPE_SLI";
         case OPCODE_COMMON_GET_EXT_FAT_CAPABILITES_SLI:
            return "OPCODE_COMMON_GET_EXT_FAT_CAPABILITES_SLI";
         case OPCODE_COMMON_SET_EXT_FAT_CAPABILITES_SLI:
            return "OPCODE_COMMON_SET_EXT_FAT_CAPABILITES_SLI";
         case OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_SLI:
            return "OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_SLI";
         case OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_SLI:
            return "OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_SLI";
         case OPCODE_COMMON_DMA_HOST_BUFFERS_SLI:
            return "OPCODE_COMMON_DMA_HOST_BUFFERS_SLI";
         case OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE_SLI:
            return "OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE_SLI";
         case OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO_SLI:
            return "OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO_SLI";
         case OPCODE_COMMON_SET_TX_THROTTLE_SLI:
            return "OPCODE_COMMON_SET_TX_THROTTLE_SLI";
         case OPCODE_COMMON_GET_TX_THROTTLE_SLI:
            return "OPCODE_COMMON_GET_TX_THROTTLE_SLI";
         case OPCODE_COMMON_NTWK_GET_LINK_SPEED_SLI:
            return "OPCODE_COMMON_NTWK_GET_LINK_SPEED_SLI";
         case OPCODE_COMMON_NTWK_GET_MAC_LIST_SLI:
            return "OPCODE_COMMON_NTWK_GET_MAC_LIST_SLI";
         case OPCODE_COMMON_NTWK_SET_MAC_LIST_SLI:
            return "OPCODE_COMMON_NTWK_SET_MAC_LIST_SLI";
         case OPCODE_COMMON_MODIFY_CQ_SLI:
            return "OPCODE_COMMON_MODIFY_CQ_SLI";
         case OPCODE_COMMON_NTWK_GET_VLAN_LIST_SLI:
            return "OPCODE_COMMON_NTWK_GET_VLAN_LIST_SLI";
         case OPCODE_COMMON_NTWK_SET_VLAN_LIST_SLI:
            return "OPCODE_COMMON_NTWK_SET_VLAN_LIST_SLI";
         case OPCODE_COMMON_GET_HSW_CONFIG_SLI:
            return "OPCODE_COMMON_GET_HSW_CONFIG_SLI";
         case OPCODE_COMMON_SET_HSW_CONFIG_SLI:
            return "OPCODE_COMMON_SET_HSW_CONFIG_SLI";
         case OPCODE_COMMON_GET_FUNCTION_CONFIG_SLI:
            return "OPCODE_COMMON_GET_FUNCTION_CONFIG_SLI";
         case OPCODE_COMMON_GET_PROFILE_CAPACITIES_SLI:
            return "OPCODE_COMMON_GET_PROFILE_CAPACITIES_SLI";
         case OPCODE_COMMON_GET_PROFILE_CONFIG_SLI:
            return "OPCODE_COMMON_GET_PROFILE_CONFIG_SLI";
         case OPCODE_COMMON_SET_PROFILE_CONFIG_SLI:
            return "OPCODE_COMMON_SET_PROFILE_CONFIG_SLI";
         case OPCODE_COMMON_GET_PROFILE_LIST_SLI:
            return "OPCODE_COMMON_GET_PROFILE_LIST_SLI";
         case OPCODE_COMMON_GET_ACTIVE_PROFILE_SLI:
            return "OPCODE_COMMON_GET_ACTIVE_PROFILE_SLI";
         case OPCODE_COMMON_SET_ACTIVE_PROFILE_SLI:
            return "OPCODE_COMMON_SET_ACTIVE_PROFILE_SLI";
         case OPCODE_COMMON_SET_FACTORY_PROFILE_CONFIG_SLI:
            return "OPCODE_COMMON_SET_FACTORY_PROFILE_CONFIG_SLI";
         case OPCODE_COMMON_GET_FUNCTION_PRIVILEGES_SLI:
            return "OPCODE_COMMON_GET_FUNCTION_PRIVILEGES_SLI";
         case OPCODE_COMMON_READ_OBJECT_SLI:
            return "OPCODE_COMMON_READ_OBJECT_SLI";
         case OPCODE_COMMON_WRITE_OBJECT_SLI:
            return "OPCODE_COMMON_WRITE_OBJECT_SLI";
         case OPCODE_COMMON_GET_DEVICE_UTILIZATION_SLI:
            return "OPCODE_COMMON_GET_DEVICE_UTILIZATION_SLI";
         case OPCODE_COMMON_GET_SLI4_PARAMETERS_SLI:
            return "OPCODE_COMMON_GET_SLI4_PARAMETERS_SLI";
         case OPCODE_COMMON_POPULATE_OCBB_CFG_INFO_SLI:
            return "OPCODE_COMMON_POPULATE_OCBB_CFG_INFO_SLI";
         case OPCODE_COMMON_MODIFY_ASYNC_EVENTS_SLI:
            return "OPCODE_COMMON_MODIFY_ASYNC_EVENTS_SLI";
         case OPCODE_COMMON_MANAGE_FFV_SLI:
            return "OPCODE_COMMON_MANAGE_FFV_SLI";
         case OPCODE_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI:
            return "OPCODE_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI";
         case OPCODE_COMMON_GET_IFACE_LIST_SLI:
            return "OPCODE_COMMON_GET_IFACE_LIST_SLI";
         case OPCODE_COMMON_WQ_CONTROL_SLI:
            return "OPCODE_COMMON_WQ_CONTROL_SLI";
         case OPCODE_COMMON_ENABLE_DISABLE_VF_SLI:
            return "OPCODE_COMMON_ENABLE_DISABLE_VF_SLI";
         case OPCODE_COMMON_ALLOC_PD_SLI:
            return "OPCODE_COMMON_ALLOC_PD_SLI";
         case OPCODE_COMMON_DEALLOC_PD_SLI:
            return "OPCODE_COMMON_DEALLOC_PD_SLI";
         case OPCODE_COMMON_GET_RECONFIG_LINK_INFO_SLI:
            return "OPCODE_COMMON_GET_RECONFIG_LINK_INFO_SLI";
         case OPCODE_COMMON_SET_RECONFIG_LINK_ID_SLI:
            return "OPCODE_COMMON_SET_RECONFIG_LINK_ID_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_ISCSI_SUBSYSTEM_OPCODES ---
#define OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_SLI (1) 
#define SUBSYSTEM_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_SLI (2) 
#define OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_POST_SGL_PAGES_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_PING_SLI (2)  
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ARP_TABLE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_ARP_TABLE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_IFACE_CREATE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_IFACE_DELETE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_VLAN_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_PING_STATE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_PING_STATE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_IF_INFO_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_CLEANUP_SLI (2)    
#define SUBSYSTEM_COMMON_ISCSI_ADD_8BYTE_LUN_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_READ_EVENT_LOG_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_DEFQ_CREATE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_DEFQ_DESTROY_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_WRBQ_CREATE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_WRBQ_DESTROY_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_MTU_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_MTU_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_TCP_DISCONNECT_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_SET_TCP_PARAMETERS_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_CONNECTION_UPDATE_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_GET_CONNECTION_INFO_SLI (2) 
#define OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_SLI (3) 
#define OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_SLI (4) 
#define OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_SLI (5) 
#define OPCODE_COMMON_ISCSI_NTWK_PING_SLI (6)     
#define OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_SLI (7) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE_SLI (8) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE_SLI (9) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_SLI (10) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_SLI (11) 
#define OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE_SLI (12) 
#define OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE_SLI (13) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_VLAN_SLI (14) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE_SLI (15) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE_SLI (16) 
#define OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_SLI (17) 
#define OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_SLI (18) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_SLI (19) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_SLI (20) 
#define OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_SLI (21) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_SLI (22) 
#define OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_SLI (23) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_SLI (24) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO_SLI (25) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_SLI (26) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_SLI (27) 
#define OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_SLI (28) 
#define OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_SLI (29) 
#define OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_SLI (30) 
#define OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_SLI (31) 
#define OPCODE_COMMON_ISCSI_CLEANUP_SLI (59)      
#define OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN_SLI (60) 
#define OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_SLI (61) 
#define OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_SLI (62) 
#define OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG_SLI (63) 
#define OPCODE_COMMON_ISCSI_DEFQ_CREATE_SLI (64)  
#define OPCODE_COMMON_ISCSI_DEFQ_DESTROY_SLI (65) 
#define OPCODE_COMMON_ISCSI_WRBQ_CREATE_SLI (66)  
#define OPCODE_COMMON_ISCSI_WRBQ_DESTROY_SLI (67) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_MTU_SLI (68) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_MTU_SLI (69) 
#define OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_SLI (70) 
#define OPCODE_COMMON_ISCSI_TCP_DISCONNECT_SLI (71) 
#define OPCODE_COMMON_ISCSI_SET_TCP_PARAMETERS_SLI (72) 
#define OPCODE_COMMON_ISCSI_CONNECTION_UPDATE_SLI (73) 
#define OPCODE_COMMON_ISCSI_GET_CONNECTION_INFO_SLI (74) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_iscsi_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_SLI:
            return "OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_SLI";
         case OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES_SLI:
            return "OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES_SLI";
         case OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_SLI:
            return "OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_SLI";
         case OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_SLI:
            return "OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_SLI";
         case OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_SLI:
            return "OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_PING_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_PING_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_SET_VLAN_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_VLAN_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_SLI";
         case OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_SLI:
            return "OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_SLI";
         case OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_SLI:
            return "OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_SLI";
         case OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_SLI:
            return "OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_SLI";
         case OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_SLI:
            return "OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_SLI";
         case OPCODE_COMMON_ISCSI_CLEANUP_SLI:
            return "OPCODE_COMMON_ISCSI_CLEANUP_SLI";
         case OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN_SLI:
            return "OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN_SLI";
         case OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_SLI:
            return "OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_SLI";
         case OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_SLI:
            return "OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_SLI";
         case OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG_SLI:
            return "OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG_SLI";
         case OPCODE_COMMON_ISCSI_DEFQ_CREATE_SLI:
            return "OPCODE_COMMON_ISCSI_DEFQ_CREATE_SLI";
         case OPCODE_COMMON_ISCSI_DEFQ_DESTROY_SLI:
            return "OPCODE_COMMON_ISCSI_DEFQ_DESTROY_SLI";
         case OPCODE_COMMON_ISCSI_WRBQ_CREATE_SLI:
            return "OPCODE_COMMON_ISCSI_WRBQ_CREATE_SLI";
         case OPCODE_COMMON_ISCSI_WRBQ_DESTROY_SLI:
            return "OPCODE_COMMON_ISCSI_WRBQ_DESTROY_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_SET_MTU_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_MTU_SLI";
         case OPCODE_COMMON_ISCSI_NTWK_GET_MTU_SLI:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_MTU_SLI";
         case OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_SLI:
            return "OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_SLI";
         case OPCODE_COMMON_ISCSI_TCP_DISCONNECT_SLI:
            return "OPCODE_COMMON_ISCSI_TCP_DISCONNECT_SLI";
         case OPCODE_COMMON_ISCSI_SET_TCP_PARAMETERS_SLI:
            return "OPCODE_COMMON_ISCSI_SET_TCP_PARAMETERS_SLI";
         case OPCODE_COMMON_ISCSI_CONNECTION_UPDATE_SLI:
            return "OPCODE_COMMON_ISCSI_CONNECTION_UPDATE_SLI";
         case OPCODE_COMMON_ISCSI_GET_CONNECTION_INFO_SLI:
            return "OPCODE_COMMON_ISCSI_GET_CONNECTION_INFO_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ISCSI_INI_SUBSYSTEM_OPCODES ---
#define OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_SLI (1) 
#define OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_SLI (2) 
#define OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_SLI (4) 
#define OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT_SLI (5) 
#define SUBSYSTEM_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_COUNT_SLI (6) 
#define OPCODE_ISCSI_INI_CFG_GET_HBA_NAME_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_NAME_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_SET_HBA_NAME_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_SET_HBA_TIME_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_CHAP_SECRET_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_SET_CHAP_SECRET_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_STATUS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_SESSIONS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_SESSION_LIST_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_A_SESSION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_CONFIGURATION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_SET_CONFIGURATION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_CLOSE_CONNECTION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_LOGIN_TARGET_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_LOGOUT_TARGET_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_SEND_TARGETS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_A_SESSION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_A_CONN_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_OFFLOAD_SESSION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_OFFLOAD_CONN_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BOOT_TARGET_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BOOT_TARGET_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BOOT_LUN_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BOOT_LUN_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_READ_WRITE_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SCSI_PASS_THRU_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_SLI (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_PCIE_INFO_SLI (6) 
#define OPCODE_ISCSI_INI_CFG_SET_HBA_NAME_SLI (7) 
#define OPCODE_ISCSI_INI_CFG_SET_HBA_TIME_SLI (8) 
#define OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET_SLI (9) 
#define OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET_SLI (10) 
#define OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS_SLI (11) 
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS_SLI (12) 
#define OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST_SLI (13) 
#define OPCODE_ISCSI_INI_SESSION_GET_A_SESSION_SLI (14) 
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_SLI (15) 
#define OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_SLI (16) 
#define OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION_SLI (17) 
#define OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_SLI (18) 
#define OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_SLI (19) 
#define OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_SLI (20) 
#define OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_SLI (21) 
#define OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION_SLI (22) 
#define OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET_SLI (23) 
#define OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET_SLI (24) 
#define OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_SLI (25) 
#define OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_SLI (26) 
#define OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_SLI (27) 
#define OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_SLI (28) 
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_SLI (29) 
#define OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_SLI (30) 
#define OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_SLI (31) 
#define OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_SLI (32) 
#define OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS_SLI (33) 
#define OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_SLI (34) 
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION_SLI (35) 
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_SLI (36) 
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN_SLI (37) 
#define OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_SLI (38) 
#define OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_SLI (39) 
#define OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_SLI (40) 
#define OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION_SLI (41) 
#define OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_SLI (42) 
#define OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN_SLI (43) 
#define OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_SLI (44) 
#define OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_SLI (45) 
#define OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_SLI (46) 
#define OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_SLI (47) 
#define OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_SLI (48) 
#define OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_SLI (49) 
#define OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_SLI (50) 
#define OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_SLI (51) 
#define OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET_SLI (52) 
#define OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET_SLI (53) 
#define OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN_SLI (54) 
#define OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN_SLI (55) 
#define OPCODE_ISCSI_INI_BOOT_READ_WRITE_SLI (56) 
#define OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_SLI (57) 
#define OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_SLI (58) 
#define OPCODE_ISCSI_INI_SCSI_PASS_THRU_SLI (59)  
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_SLI (60) 
#define OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_SLI (61) 
#define OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO_SLI (62) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* iscsi_ini_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_SLI:
            return "OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_SLI";
         case OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_SLI:
            return "OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_SLI";
         case OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_SLI:
            return "OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_SLI";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT_SLI:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT_SLI";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_NAME_SLI:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_NAME_SLI";
         case OPCODE_ISCSI_INI_CFG_SET_HBA_NAME_SLI:
            return "OPCODE_ISCSI_INI_CFG_SET_HBA_NAME_SLI";
         case OPCODE_ISCSI_INI_CFG_SET_HBA_TIME_SLI:
            return "OPCODE_ISCSI_INI_CFG_SET_HBA_TIME_SLI";
         case OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET_SLI:
            return "OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET_SLI";
         case OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET_SLI:
            return "OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET_SLI";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS_SLI:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS_SLI";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS_SLI:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS_SLI";
         case OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST_SLI:
            return "OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST_SLI";
         case OPCODE_ISCSI_INI_SESSION_GET_A_SESSION_SLI:
            return "OPCODE_ISCSI_INI_SESSION_GET_A_SESSION_SLI";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_SLI:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_SLI";
         case OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_SLI:
            return "OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_SLI";
         case OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION_SLI:
            return "OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION_SLI";
         case OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_SLI:
            return "OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_SLI";
         case OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_SLI:
            return "OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_SLI";
         case OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_SLI:
            return "OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_SLI";
         case OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_SLI:
            return "OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_SLI";
         case OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION_SLI:
            return "OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION_SLI";
         case OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET_SLI:
            return "OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET_SLI";
         case OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET_SLI:
            return "OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET_SLI";
         case OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_SLI:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_SLI";
         case OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_SLI:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_SLI";
         case OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_SLI:
            return "OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_SLI";
         case OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_SLI:
            return "OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_SLI";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_SLI:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_SLI";
         case OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_SLI:
            return "OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_SLI";
         case OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_SLI:
            return "OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_SLI";
         case OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_SLI:
            return "OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_SLI";
         case OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS_SLI:
            return "OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS_SLI";
         case OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_SLI:
            return "OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_SLI";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION_SLI:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION_SLI";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_SLI:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_SLI";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN_SLI:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN_SLI";
         case OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_SLI:
            return "OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_SLI";
         case OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_SLI:
            return "OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_SLI";
         case OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_SLI:
            return "OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_SLI";
         case OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION_SLI:
            return "OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION_SLI";
         case OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_SLI:
            return "OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_SLI";
         case OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN_SLI:
            return "OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN_SLI";
         case OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_SLI:
            return "OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_SLI";
         case OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_SLI:
            return "OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_SLI";
         case OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_SLI:
            return "OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_SLI";
         case OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_SLI:
            return "OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_SLI";
         case OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_SLI:
            return "OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_SLI";
         case OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_SLI:
            return "OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_SLI";
         case OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_SLI:
            return "OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_SLI";
         case OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_SLI:
            return "OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_SLI";
         case OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET_SLI:
            return "OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET_SLI";
         case OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET_SLI:
            return "OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET_SLI";
         case OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN_SLI:
            return "OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN_SLI";
         case OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN_SLI:
            return "OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN_SLI";
         case OPCODE_ISCSI_INI_BOOT_READ_WRITE_SLI:
            return "OPCODE_ISCSI_INI_BOOT_READ_WRITE_SLI";
         case OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_SLI:
            return "OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_SLI";
         case OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_SLI:
            return "OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_SLI";
         case OPCODE_ISCSI_INI_SCSI_PASS_THRU_SLI:
            return "OPCODE_ISCSI_INI_SCSI_PASS_THRU_SLI";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_SLI:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_SLI";
         case OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_SLI:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_SLI";
         case OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO_SLI:
            return "OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ISCSI_TGT_SUBSYSTEM_OPCODES ---
#define OPCODE_ISCSI_TGT_START_LISTEN_SERVER_SLI (1) 
#define OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER_SLI (2) 
#define OPCODE_ISCSI_TGT_GET_CONNECTION_INFO_SLI (3) 
#define OPCODE_ISCSI_TGT_CONNECTION_REJECT_SLI (4) 
#define OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION_SLI (5) 
#define OPCODE_ISCSI_TGT_ISNS_SEND_PACKET_SLI (6) 
#define SUBSYSTEM_ISCSI_TGT_START_LISTEN_SERVER_SLI (7) 
#define SUBSYSTEM_ISCSI_TGT_STOP_LISTEN_SERVER_SLI (7) 
#define SUBSYSTEM_ISCSI_TGT_GET_CONNECTION_INFO_SLI (7) 
#define SUBSYSTEM_ISCSI_TGT_CONNECTION_REJECT_SLI (7) 
#define SUBSYSTEM_ISCSI_TGT_OFFLOAD_CONNECTION_SLI (7) 
#define SUBSYSTEM_ISCSI_TGT_ISNS_SEND_PACKET_SLI (7) 
#define OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION_SLI (7) 
#define SUBSYSTEM_ISCSI_TGT_INVALIDATE_CONNECTION_SLI (7) 
#define SUBSYSTEM_ISCSI_TGT_ADD_IP_ADDR_SLI (7)   
#define SUBSYSTEM_ISCSI_TGT_DELETE_IP_ADDR_SLI (7) 
#define SUBSYSTEM_ISCSI_TGT_LIST_IP_ADDR_SLI (7)  
#define SUBSYSTEM_ISCSI_TGT_START_ESI_LISTEN_SLI (7) 
#define SUBSYSTEM_ISCSI_TGT_STOP_ESI_LISTEN_SLI (7) 
#define SUBSYSTEM_ISCSI_TGT_SLP_REGISTER_SLI (7)  
#define SUBSYSTEM_ISCSI_TGT_SLP_DEREGISTER_SLI (7) 
#define OPCODE_ISCSI_TGT_ADD_IP_ADDR_SLI (8)      
#define OPCODE_ISCSI_TGT_DELETE_IP_ADDR_SLI (9)   
#define OPCODE_ISCSI_TGT_LIST_IP_ADDR_SLI (10)    
#define OPCODE_ISCSI_TGT_START_ESI_LISTEN_SLI (11) 
#define OPCODE_ISCSI_TGT_STOP_ESI_LISTEN_SLI (12) 
#define OPCODE_ISCSI_TGT_SLP_REGISTER_SLI (13)    
#define OPCODE_ISCSI_TGT_SLP_DEREGISTER_SLI (14)  

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* iscsi_tgt_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ISCSI_TGT_START_LISTEN_SERVER_SLI:
            return "OPCODE_ISCSI_TGT_START_LISTEN_SERVER_SLI";
         case OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER_SLI:
            return "OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER_SLI";
         case OPCODE_ISCSI_TGT_GET_CONNECTION_INFO_SLI:
            return "OPCODE_ISCSI_TGT_GET_CONNECTION_INFO_SLI";
         case OPCODE_ISCSI_TGT_CONNECTION_REJECT_SLI:
            return "OPCODE_ISCSI_TGT_CONNECTION_REJECT_SLI";
         case OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION_SLI:
            return "OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION_SLI";
         case OPCODE_ISCSI_TGT_ISNS_SEND_PACKET_SLI:
            return "OPCODE_ISCSI_TGT_ISNS_SEND_PACKET_SLI";
         case OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION_SLI:
            return "OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION_SLI";
         case OPCODE_ISCSI_TGT_ADD_IP_ADDR_SLI:
            return "OPCODE_ISCSI_TGT_ADD_IP_ADDR_SLI";
         case OPCODE_ISCSI_TGT_DELETE_IP_ADDR_SLI:
            return "OPCODE_ISCSI_TGT_DELETE_IP_ADDR_SLI";
         case OPCODE_ISCSI_TGT_LIST_IP_ADDR_SLI:
            return "OPCODE_ISCSI_TGT_LIST_IP_ADDR_SLI";
         case OPCODE_ISCSI_TGT_START_ESI_LISTEN_SLI:
            return "OPCODE_ISCSI_TGT_START_ESI_LISTEN_SLI";
         case OPCODE_ISCSI_TGT_STOP_ESI_LISTEN_SLI:
            return "OPCODE_ISCSI_TGT_STOP_ESI_LISTEN_SLI";
         case OPCODE_ISCSI_TGT_SLP_REGISTER_SLI:
            return "OPCODE_ISCSI_TGT_SLP_REGISTER_SLI";
         case OPCODE_ISCSI_TGT_SLP_DEREGISTER_SLI:
            return "OPCODE_ISCSI_TGT_SLP_DEREGISTER_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- MILI_PTL_SUBSYSTEM_OPCODES ---
#define OPCODE_MILI_PTL_CREATE_PORTAL_SLI (1)     
#define OPCODE_MILI_PTL_DELETE_PORTAL_SLI (2)     
#define OPCODE_MILI_PTL_CREATE_PORTAL_GROUP_SLI (3) 
#define OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_SLI (4) 
#define OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_SLI (5) 
#define OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_SLI (6) 
#define OPCODE_MILI_PTL_ADD_TARGET_SLI  (7)       
#define SUBSYSTEM_MILI_PTL_CREATE_PORTAL_SLI (8)  
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_SLI (8)  
#define SUBSYSTEM_MILI_PTL_CREATE_PORTAL_GROUP_SLI (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_GROUP_SLI (8) 
#define SUBSYSTEM_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_SLI (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_SLI (8) 
#define SUBSYSTEM_MILI_PTL_ADD_TARGET_SLI (8)     
#define OPCODE_MILI_PTL_DELETE_TARGET_SLI (8)     
#define SUBSYSTEM_MILI_PTL_DELETE_TARGET_SLI (8)  
#define SUBSYSTEM_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_SLI (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_SLI (8) 
#define SUBSYSTEM_MILI_PTL_SET_TARGET_LOGIN_PARAMS_SLI (8) 
#define SUBSYSTEM_MILI_PTL_START_LISTEN_SERVER_SLI (8) 
#define SUBSYSTEM_MILI_PTL_STOP_LISTEN_SERVER_SLI (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_SLI (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_SLI (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_SLI (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_SLI (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_SLI (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_SLI (8) 
#define SUBSYSTEM_MILI_PTL_GET_ISCSI_SESSION_LIST_SLI (8) 
#define SUBSYSTEM_MILI_PTL_KILL_SESSION_SLI (8)   
#define OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_SLI (9) 
#define OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_SLI (10) 
#define OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS_SLI (11) 
#define OPCODE_MILI_PTL_START_LISTEN_SERVER_SLI (12) 
#define OPCODE_MILI_PTL_STOP_LISTEN_SERVER_SLI (13) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_SLI (14) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_SLI (15) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_SLI (16) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_SLI (17) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_SLI (18) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_SLI (19) 
#define OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST_SLI (20) 
#define OPCODE_MILI_PTL_KILL_SESSION_SLI (21)     

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mili_ptl_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_MILI_PTL_CREATE_PORTAL_SLI:
            return "OPCODE_MILI_PTL_CREATE_PORTAL_SLI";
         case OPCODE_MILI_PTL_DELETE_PORTAL_SLI:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_SLI";
         case OPCODE_MILI_PTL_CREATE_PORTAL_GROUP_SLI:
            return "OPCODE_MILI_PTL_CREATE_PORTAL_GROUP_SLI";
         case OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_SLI:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_SLI";
         case OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_SLI:
            return "OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_SLI";
         case OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_SLI:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_SLI";
         case OPCODE_MILI_PTL_ADD_TARGET_SLI:
            return "OPCODE_MILI_PTL_ADD_TARGET_SLI";
         case OPCODE_MILI_PTL_DELETE_TARGET_SLI:
            return "OPCODE_MILI_PTL_DELETE_TARGET_SLI";
         case OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_SLI:
            return "OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_SLI";
         case OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_SLI:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_SLI";
         case OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS_SLI:
            return "OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS_SLI";
         case OPCODE_MILI_PTL_START_LISTEN_SERVER_SLI:
            return "OPCODE_MILI_PTL_START_LISTEN_SERVER_SLI";
         case OPCODE_MILI_PTL_STOP_LISTEN_SERVER_SLI:
            return "OPCODE_MILI_PTL_STOP_LISTEN_SERVER_SLI";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_SLI:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_SLI";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_SLI:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_SLI";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_SLI:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_SLI";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_SLI:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_SLI";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_SLI:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_SLI";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_SLI:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_SLI";
         case OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST_SLI:
            return "OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST_SLI";
         case OPCODE_MILI_PTL_KILL_SESSION_SLI:
            return "OPCODE_MILI_PTL_KILL_SESSION_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- MILI_TMD_SUBSYSTEM_OPCODES ---
#define OPCODE_MILI_TMD_ADD_TARGET_SLI  (1)       
#define OPCODE_MILI_TMD_DELETE_TARGET_SLI (2)     
#define OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_SLI (3) 
#define OPCODE_MILI_TMD_ADD_INITIATOR_SLI (4)     
#define OPCODE_MILI_TMD_DELETE_INITIATOR_SLI (5)  
#define OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_SLI (6) 
#define OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET_SLI (7) 
#define OPCODE_MILI_TMD_DELETE_IT_BINDING_SLI (8) 
#define SUBSYSTEM_MILI_TMD_ADD_TARGET_SLI (9)     
#define SUBSYSTEM_MILI_TMD_DELETE_TARGET_SLI (9)  
#define SUBSYSTEM_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_SLI (9) 
#define SUBSYSTEM_MILI_TMD_ADD_INITIATOR_SLI (9)  
#define SUBSYSTEM_MILI_TMD_DELETE_INITIATOR_SLI (9) 
#define SUBSYSTEM_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_SLI (9) 
#define SUBSYSTEM_MILI_TMD_BIND_INITIATOR_TO_TARGET_SLI (9) 
#define SUBSYSTEM_MILI_TMD_DELETE_IT_BINDING_SLI (9) 
#define OPCODE_MILI_TMD_ACTIVATE_TARGET_SLI (9)   
#define SUBSYSTEM_MILI_TMD_ACTIVATE_TARGET_SLI (9) 
#define SUBSYSTEM_MILI_TMD_DEACTIVATE_TARGET_SLI (9) 
#define SUBSYSTEM_MILI_TMD_SET_INITIATOR_QOS_SLI (9) 
#define OPCODE_MILI_TMD_DEACTIVATE_TARGET_SLI (10) 
#define OPCODE_MILI_TMD_SET_INITIATOR_QOS_SLI (11) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mili_tmd_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_MILI_TMD_ADD_TARGET_SLI:
            return "OPCODE_MILI_TMD_ADD_TARGET_SLI";
         case OPCODE_MILI_TMD_DELETE_TARGET_SLI:
            return "OPCODE_MILI_TMD_DELETE_TARGET_SLI";
         case OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_SLI:
            return "OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_SLI";
         case OPCODE_MILI_TMD_ADD_INITIATOR_SLI:
            return "OPCODE_MILI_TMD_ADD_INITIATOR_SLI";
         case OPCODE_MILI_TMD_DELETE_INITIATOR_SLI:
            return "OPCODE_MILI_TMD_DELETE_INITIATOR_SLI";
         case OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_SLI:
            return "OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_SLI";
         case OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET_SLI:
            return "OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET_SLI";
         case OPCODE_MILI_TMD_DELETE_IT_BINDING_SLI:
            return "OPCODE_MILI_TMD_DELETE_IT_BINDING_SLI";
         case OPCODE_MILI_TMD_ACTIVATE_TARGET_SLI:
            return "OPCODE_MILI_TMD_ACTIVATE_TARGET_SLI";
         case OPCODE_MILI_TMD_DEACTIVATE_TARGET_SLI:
            return "OPCODE_MILI_TMD_DEACTIVATE_TARGET_SLI";
         case OPCODE_MILI_TMD_SET_INITIATOR_QOS_SLI:
            return "OPCODE_MILI_TMD_SET_INITIATOR_QOS_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- VNTAG_SUBSYSTEM_OPCODES ---
#define OPCODE_VNTAG_GET_CAPABILITY_SLI (1)       
#define OPCODE_VNTAG_SET_CAPABILITY_SLI (2)       
#define OPCODE_VNTAG_GET_PROVISIONING_INFO_SLI (3) 
#define OPCODE_VNTAG_SET_PROVISIONING_INFO_SLI (4) 
#define SUBSYSTEM_VNTAG_GET_CAPABILITY_SLI (20)   
#define SUBSYSTEM_VNTAG_SET_CAPABILITY_SLI (20)   
#define SUBSYSTEM_VNTAG_GET_PROVISIONING_INFO_SLI (20) 
#define SUBSYSTEM_VNTAG_SET_PROVISIONING_INFO_SLI (20) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* vntag_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_VNTAG_GET_CAPABILITY_SLI:
            return "OPCODE_VNTAG_GET_CAPABILITY_SLI";
         case OPCODE_VNTAG_SET_CAPABILITY_SLI:
            return "OPCODE_VNTAG_SET_CAPABILITY_SLI";
         case OPCODE_VNTAG_GET_PROVISIONING_INFO_SLI:
            return "OPCODE_VNTAG_GET_PROVISIONING_INFO_SLI";
         case OPCODE_VNTAG_SET_PROVISIONING_INFO_SLI:
            return "OPCODE_VNTAG_SET_PROVISIONING_INFO_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ETH_SUBSYSTEM_OPCODES ---
#define OPCODE_ETH_RSS_CONFIG_SLI       (1)       
#define OPCODE_ETH_ACPI_CONFIG_SLI      (2)       
#define SUBSYSTEM_ETH_RSS_CONFIG_SLI    (3)       
#define SUBSYSTEM_ETH_ACPI_CONFIG_SLI   (3)       
#define OPCODE_ETH_PROMISCUOUS_SLI      (3)       
#define SUBSYSTEM_ETH_PROMISCUOUS_SLI   (3)       
#define SUBSYSTEM_ETH_GET_STATISTICS_SLI (3)      
#define SUBSYSTEM_ETH_TX_CREATE_SLI     (3)       
#define SUBSYSTEM_ETH_RX_CREATE_SLI     (3)       
#define SUBSYSTEM_ETH_TX_DESTROY_SLI    (3)       
#define SUBSYSTEM_ETH_RX_DESTROY_SLI    (3)       
#define SUBSYSTEM_ETH_GET_QPGE_STATISTICS_SLI (3) 
#define SUBSYSTEM_ETH_ACPI_WOL_MAGIC_CONFIG_SLI (3) 
#define SUBSYSTEM_ETH_NETWORK_STATS_SLI (3)       
#define SUBSYSTEM_ETH_GET_PPORT_STATS_SLI (3)     
#define SUBSYSTEM_ETH_PG_FEATURE_QUERY_REQUEST_SLI (3) 
#define SUBSYSTEM_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_SLI (3) 
#define SUBSYSTEM_ETH_QUERY_LRO_CONFIG_SLI (3)    
#define SUBSYSTEM_ETH_GET_IFACE_LRO_CONFIG_SLI (3) 
#define SUBSYSTEM_ETH_OFFLOAD_PLRO_SLI  (3)       
#define SUBSYSTEM_ETH_UPLOAD_PLRO_SLI   (3)       
#define SUBSYSTEM_ETH_SET_IFACE_LRO_CONFIG_SLI (3) 
#define SUBSYSTEM_ETH_GET_LRO_STATS_SLI (3)       
#define OPCODE_ETH_GET_STATISTICS_SLI   (4)       
#define OPCODE_ETH_TX_CREATE_SLI        (7)       
#define OPCODE_ETH_RX_CREATE_SLI        (8)       
#define OPCODE_ETH_TX_DESTROY_SLI       (9)       
#define OPCODE_ETH_RX_DESTROY_SLI       (10)      
#define OPCODE_ETH_GET_QPGE_STATISTICS_SLI (11)   
#define OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG_SLI (12) 
#define OPCODE_ETH_NETWORK_STATS_SLI    (13)      
#define OPCODE_ETH_GET_PPORT_STATS_SLI  (18)      
#define OPCODE_ETH_PG_FEATURE_QUERY_REQUEST_SLI (23) 
#define OPCODE_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_SLI (24) 
#define OPCODE_ETH_QUERY_LRO_CONFIG_SLI (32)      
#define OPCODE_ETH_GET_IFACE_LRO_CONFIG_SLI (35)  
#define OPCODE_ETH_OFFLOAD_PLRO_SLI     (36)      
#define OPCODE_ETH_UPLOAD_PLRO_SLI      (37)      
#define OPCODE_ETH_SET_IFACE_LRO_CONFIG_SLI (38)  
#define OPCODE_ETH_GET_LRO_STATS_SLI    (39)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* eth_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ETH_RSS_CONFIG_SLI:
            return "OPCODE_ETH_RSS_CONFIG_SLI";
         case OPCODE_ETH_ACPI_CONFIG_SLI:
            return "OPCODE_ETH_ACPI_CONFIG_SLI";
         case OPCODE_ETH_PROMISCUOUS_SLI:
            return "OPCODE_ETH_PROMISCUOUS_SLI";
         case OPCODE_ETH_GET_STATISTICS_SLI:
            return "OPCODE_ETH_GET_STATISTICS_SLI";
         case OPCODE_ETH_TX_CREATE_SLI:
            return "OPCODE_ETH_TX_CREATE_SLI";
         case OPCODE_ETH_RX_CREATE_SLI:
            return "OPCODE_ETH_RX_CREATE_SLI";
         case OPCODE_ETH_TX_DESTROY_SLI:
            return "OPCODE_ETH_TX_DESTROY_SLI";
         case OPCODE_ETH_RX_DESTROY_SLI:
            return "OPCODE_ETH_RX_DESTROY_SLI";
         case OPCODE_ETH_GET_QPGE_STATISTICS_SLI:
            return "OPCODE_ETH_GET_QPGE_STATISTICS_SLI";
         case OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG_SLI:
            return "OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG_SLI";
         case OPCODE_ETH_NETWORK_STATS_SLI:
            return "OPCODE_ETH_NETWORK_STATS_SLI";
         case OPCODE_ETH_GET_PPORT_STATS_SLI:
            return "OPCODE_ETH_GET_PPORT_STATS_SLI";
         case OPCODE_ETH_PG_FEATURE_QUERY_REQUEST_SLI:
            return "OPCODE_ETH_PG_FEATURE_QUERY_REQUEST_SLI";
         case OPCODE_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_SLI:
            return "OPCODE_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_SLI";
         case OPCODE_ETH_QUERY_LRO_CONFIG_SLI:
            return "OPCODE_ETH_QUERY_LRO_CONFIG_SLI";
         case OPCODE_ETH_GET_IFACE_LRO_CONFIG_SLI:
            return "OPCODE_ETH_GET_IFACE_LRO_CONFIG_SLI";
         case OPCODE_ETH_OFFLOAD_PLRO_SLI:
            return "OPCODE_ETH_OFFLOAD_PLRO_SLI";
         case OPCODE_ETH_UPLOAD_PLRO_SLI:
            return "OPCODE_ETH_UPLOAD_PLRO_SLI";
         case OPCODE_ETH_SET_IFACE_LRO_CONFIG_SLI:
            return "OPCODE_ETH_SET_IFACE_LRO_CONFIG_SLI";
         case OPCODE_ETH_GET_LRO_STATS_SLI:
            return "OPCODE_ETH_GET_LRO_STATS_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LRO_SUBSYSTEM_OPCODES ---
#define OPCODE_LRO_RING_CREATE_SLI      (1)       
#define OPCODE_LRO_CONFIG_SLI           (2)       
#define OPCODE_LRO_GET_STATISTICS_SLI   (3)       
#define OPCODE_LRO_RING_DESTROY_SLI     (4)       
#define SUBSYSTEM_LRO_RING_CREATE_SLI   (13)      
#define SUBSYSTEM_LRO_CONFIG_SLI        (13)      
#define SUBSYSTEM_LRO_GET_STATISTICS_SLI (13)     
#define SUBSYSTEM_LRO_RING_DESTROY_SLI  (13)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lro_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LRO_RING_CREATE_SLI:
            return "OPCODE_LRO_RING_CREATE_SLI";
         case OPCODE_LRO_CONFIG_SLI:
            return "OPCODE_LRO_CONFIG_SLI";
         case OPCODE_LRO_GET_STATISTICS_SLI:
            return "OPCODE_LRO_GET_STATISTICS_SLI";
         case OPCODE_LRO_RING_DESTROY_SLI:
            return "OPCODE_LRO_RING_DESTROY_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DAL_SUBSYSTEM_OPCODES ---
#define OPCODE_DAL_GET_PARAMETERS_SLI   (1)       
#define OPCODE_DAL_DRIVER_LOAD_SLI      (2)       
#define OPCODE_DAL_DRIVER_UNLOAD_SLI    (3)       
#define OPCODE_DAL_QP_CREATE_SLI        (4)       
#define OPCODE_DAL_QP_DESTROY_SLI       (5)       
#define OPCODE_DAL_MR_REGISTER_SLI      (6)       
#define OPCODE_DAL_MR_UNREGISTER_SLI    (7)       
#define OPCODE_DAL_QP_MODIFY_RTS_SLI    (8)       
#define OPCODE_DAL_QP_MODIFY_RTR_SLI    (9)       
#define OPCODE_DAL_MULTICAST_JOIN_SLI   (10)      
#define OPCODE_DAL_MULTICAST_LEAVE_SLI  (11)      
#define SUBSYSTEM_DAL_GET_PARAMETERS_SLI (14)     
#define SUBSYSTEM_DAL_DRIVER_LOAD_SLI   (14)      
#define SUBSYSTEM_DAL_DRIVER_UNLOAD_SLI (14)      
#define SUBSYSTEM_DAL_QP_CREATE_SLI     (14)      
#define SUBSYSTEM_DAL_QP_DESTROY_SLI    (14)      
#define SUBSYSTEM_DAL_MR_REGISTER_SLI   (14)      
#define SUBSYSTEM_DAL_MR_UNREGISTER_SLI (14)      
#define SUBSYSTEM_DAL_QP_MODIFY_RTS_SLI (14)      
#define SUBSYSTEM_DAL_QP_MODIFY_RTR_SLI (14)      
#define SUBSYSTEM_DAL_MULTICAST_JOIN_SLI (14)     
#define SUBSYSTEM_DAL_MULTICAST_LEAVE_SLI (14)    

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dal_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DAL_GET_PARAMETERS_SLI:
            return "OPCODE_DAL_GET_PARAMETERS_SLI";
         case OPCODE_DAL_DRIVER_LOAD_SLI:
            return "OPCODE_DAL_DRIVER_LOAD_SLI";
         case OPCODE_DAL_DRIVER_UNLOAD_SLI:
            return "OPCODE_DAL_DRIVER_UNLOAD_SLI";
         case OPCODE_DAL_QP_CREATE_SLI:
            return "OPCODE_DAL_QP_CREATE_SLI";
         case OPCODE_DAL_QP_DESTROY_SLI:
            return "OPCODE_DAL_QP_DESTROY_SLI";
         case OPCODE_DAL_MR_REGISTER_SLI:
            return "OPCODE_DAL_MR_REGISTER_SLI";
         case OPCODE_DAL_MR_UNREGISTER_SLI:
            return "OPCODE_DAL_MR_UNREGISTER_SLI";
         case OPCODE_DAL_QP_MODIFY_RTS_SLI:
            return "OPCODE_DAL_QP_MODIFY_RTS_SLI";
         case OPCODE_DAL_QP_MODIFY_RTR_SLI:
            return "OPCODE_DAL_QP_MODIFY_RTR_SLI";
         case OPCODE_DAL_MULTICAST_JOIN_SLI:
            return "OPCODE_DAL_MULTICAST_JOIN_SLI";
         case OPCODE_DAL_MULTICAST_LEAVE_SLI:
            return "OPCODE_DAL_MULTICAST_LEAVE_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- TOE_SUBSYSTEM_OPCODES ---
#define OPCODE_TOE_CONNECTION_OFFLOAD_SLI (1)     
#define OPCODE_TOE_CONNECTION_UPDATE_SLI (3)      
#define SUBSYSTEM_TOE_CONNECTION_OFFLOAD_SLI (4)  
#define SUBSYSTEM_TOE_CONNECTION_UPDATE_SLI (4)   
#define OPCODE_TOE_GET_STATISTICS_SLI   (4)       
#define SUBSYSTEM_TOE_GET_STATISTICS_SLI (4)      
#define SUBSYSTEM_TOE_CONNECTION_QUERY_SLI (4)    
#define SUBSYSTEM_TOE_WRBQ_CREATE_SLI   (4)       
#define SUBSYSTEM_TOE_RQ_CREATE_SLI     (4)       
#define SUBSYSTEM_TOE_DEFQ_CREATE_SLI   (4)       
#define SUBSYSTEM_TOE_WRBQ_DESTROY_SLI  (4)       
#define SUBSYSTEM_TOE_RQ_DESTROY_SLI    (4)       
#define SUBSYSTEM_TOE_DEFQ_DESTROY_SLI  (4)       
#define OPCODE_TOE_CONNECTION_QUERY_SLI (5)       
#define OPCODE_TOE_WRBQ_CREATE_SLI      (6)       
#define OPCODE_TOE_RQ_CREATE_SLI        (7)       
#define OPCODE_TOE_DEFQ_CREATE_SLI      (8)       
#define OPCODE_TOE_WRBQ_DESTROY_SLI     (9)       
#define OPCODE_TOE_RQ_DESTROY_SLI       (10)      
#define OPCODE_TOE_DEFQ_DESTROY_SLI     (11)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* toe_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_TOE_CONNECTION_OFFLOAD_SLI:
            return "OPCODE_TOE_CONNECTION_OFFLOAD_SLI";
         case OPCODE_TOE_CONNECTION_UPDATE_SLI:
            return "OPCODE_TOE_CONNECTION_UPDATE_SLI";
         case OPCODE_TOE_GET_STATISTICS_SLI:
            return "OPCODE_TOE_GET_STATISTICS_SLI";
         case OPCODE_TOE_CONNECTION_QUERY_SLI:
            return "OPCODE_TOE_CONNECTION_QUERY_SLI";
         case OPCODE_TOE_WRBQ_CREATE_SLI:
            return "OPCODE_TOE_WRBQ_CREATE_SLI";
         case OPCODE_TOE_RQ_CREATE_SLI:
            return "OPCODE_TOE_RQ_CREATE_SLI";
         case OPCODE_TOE_DEFQ_CREATE_SLI:
            return "OPCODE_TOE_DEFQ_CREATE_SLI";
         case OPCODE_TOE_WRBQ_DESTROY_SLI:
            return "OPCODE_TOE_WRBQ_DESTROY_SLI";
         case OPCODE_TOE_RQ_DESTROY_SLI:
            return "OPCODE_TOE_RQ_DESTROY_SLI";
         case OPCODE_TOE_DEFQ_DESTROY_SLI:
            return "OPCODE_TOE_DEFQ_DESTROY_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- PXE_UNDI_SUBSYSTEM_OPCODES ---
#define OPCODE_PXE_UNDI_CONTROL_SLI     (1)       
#define OPCODE_PXE_UNDI_TRANSMIT_SLI    (2)       
#define OPCODE_PXE_UNDI_RECEIVE_SLI     (3)       
#define OPCODE_PXE_UNDI_GET_STATISTICS_SLI (4)    
#define SUBSYSTEM_PXE_UNDI_CONTROL_SLI  (5)       
#define SUBSYSTEM_PXE_UNDI_TRANSMIT_SLI (5)       
#define SUBSYSTEM_PXE_UNDI_RECEIVE_SLI  (5)       
#define SUBSYSTEM_PXE_UNDI_GET_STATISTICS_SLI (5) 
#define OPCODE_PXE_UNDI_SET_VLAN_SLI    (5)       
#define SUBSYSTEM_PXE_UNDI_SET_VLAN_SLI (5)       
#define SUBSYSTEM_PXE_UNDI_GET_VLAN_SLI (5)       
#define OPCODE_PXE_UNDI_GET_VLAN_SLI    (6)       

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* pxe_undi_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_PXE_UNDI_CONTROL_SLI:
            return "OPCODE_PXE_UNDI_CONTROL_SLI";
         case OPCODE_PXE_UNDI_TRANSMIT_SLI:
            return "OPCODE_PXE_UNDI_TRANSMIT_SLI";
         case OPCODE_PXE_UNDI_RECEIVE_SLI:
            return "OPCODE_PXE_UNDI_RECEIVE_SLI";
         case OPCODE_PXE_UNDI_GET_STATISTICS_SLI:
            return "OPCODE_PXE_UNDI_GET_STATISTICS_SLI";
         case OPCODE_PXE_UNDI_SET_VLAN_SLI:
            return "OPCODE_PXE_UNDI_SET_VLAN_SLI";
         case OPCODE_PXE_UNDI_GET_VLAN_SLI:
            return "OPCODE_PXE_UNDI_GET_VLAN_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- RDMA_SUBSYSTEM_OPCODES ---
#define OPCODE_RDMA_QUERY_CONFIG_SLI    (1)       
#define OPCODE_RDMA_ALLOC_PD_SLI        (2)       
#define OPCODE_RDMA_DEALLOC_PD_SLI      (3)       
#define OPCODE_RDMA_CREATE_AHR_SLI      (4)       
#define OPCODE_RDMA_DESTROY_AHR_SLI     (5)       
#define OPCODE_RDMA_CREATE_QP_SLI       (6)       
#define OPCODE_RDMA_QUERY_QP_SLI        (7)       
#define OPCODE_RDMA_MODIFY_QP_SLI       (8)       
#define OPCODE_RDMA_DESTROY_QP_SLI      (9)       
#define SUBSYSTEM_RDMA_QUERY_CONFIG_SLI (10)      
#define SUBSYSTEM_RDMA_ALLOC_PD_SLI     (10)      
#define SUBSYSTEM_RDMA_DEALLOC_PD_SLI   (10)      
#define SUBSYSTEM_RDMA_CREATE_AHR_SLI   (10)      
#define SUBSYSTEM_RDMA_DESTROY_AHR_SLI  (10)      
#define SUBSYSTEM_RDMA_CREATE_QP_SLI    (10)      
#define SUBSYSTEM_RDMA_QUERY_QP_SLI     (10)      
#define SUBSYSTEM_RDMA_MODIFY_QP_SLI    (10)      
#define SUBSYSTEM_RDMA_DESTROY_QP_SLI   (10)      
#define OPCODE_RDMA_MODIFY_CQ_SLI       (10)      
#define SUBSYSTEM_RDMA_MODIFY_CQ_SLI    (10)      
#define SUBSYSTEM_RDMA_ALLOC_STAG_SLI   (10)      
#define SUBSYSTEM_RDMA_DEALLOC_STAG_SLI (10)      
#define SUBSYSTEM_RDMA_REGISTER_NSMR_SLI (10)     
#define SUBSYSTEM_RDMA_REREGISTER_NSMR_SLI (10)   
#define SUBSYSTEM_RDMA_REGISTER_NSMR_CONT_SLI (10) 
#define SUBSYSTEM_RDMA_QUERY_NSMR_SLI   (10)      
#define SUBSYSTEM_RDMA_ALLOC_MW_SLI     (10)      
#define SUBSYSTEM_RDMA_QUERY_MW_SLI     (10)      
#define SUBSYSTEM_RDMA_CREATE_SRQ_SLI   (10)      
#define SUBSYSTEM_RDMA_QUERY_SRQ_SLI    (10)      
#define SUBSYSTEM_RDMA_MODIFY_SRQ_SLI   (10)      
#define SUBSYSTEM_RDMA_DESTROY_SRQ_SLI  (10)      
#define SUBSYSTEM_RDMA_ATTACH_MGID_SLI  (10)      
#define SUBSYSTEM_RDMA_DETACH_MGID_SLI  (10)      
#define SUBSYSTEM_RDMA_CREATE_RBQ_SLI   (10)      
#define SUBSYSTEM_RDMA_DESTROY_RBQ_SLI  (10)      
#define SUBSYSTEM_RDMA_GET_STATS_SLI    (10)      
#define OPCODE_RDMA_ALLOC_STAG_SLI      (11)      
#define OPCODE_RDMA_DEALLOC_STAG_SLI    (12)      
#define OPCODE_RDMA_REGISTER_NSMR_SLI   (13)      
#define OPCODE_RDMA_REREGISTER_NSMR_SLI (14)      
#define OPCODE_RDMA_REGISTER_NSMR_CONT_SLI (15)   
#define OPCODE_RDMA_QUERY_NSMR_SLI      (16)      
#define OPCODE_RDMA_ALLOC_MW_SLI        (17)      
#define OPCODE_RDMA_QUERY_MW_SLI        (18)      
#define OPCODE_RDMA_CREATE_SRQ_SLI      (19)      
#define OPCODE_RDMA_QUERY_SRQ_SLI       (20)      
#define OPCODE_RDMA_MODIFY_SRQ_SLI      (21)      
#define OPCODE_RDMA_DESTROY_SRQ_SLI     (22)      
#define OPCODE_RDMA_ATTACH_MGID_SLI     (23)      
#define OPCODE_RDMA_DETACH_MGID_SLI     (24)      
#define OPCODE_RDMA_CREATE_RBQ_SLI      (25)      
#define OPCODE_RDMA_DESTROY_RBQ_SLI     (26)      
#define OPCODE_RDMA_GET_STATS_SLI       (27)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* rdma_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_RDMA_QUERY_CONFIG_SLI:
            return "OPCODE_RDMA_QUERY_CONFIG_SLI";
         case OPCODE_RDMA_ALLOC_PD_SLI:
            return "OPCODE_RDMA_ALLOC_PD_SLI";
         case OPCODE_RDMA_DEALLOC_PD_SLI:
            return "OPCODE_RDMA_DEALLOC_PD_SLI";
         case OPCODE_RDMA_CREATE_AHR_SLI:
            return "OPCODE_RDMA_CREATE_AHR_SLI";
         case OPCODE_RDMA_DESTROY_AHR_SLI:
            return "OPCODE_RDMA_DESTROY_AHR_SLI";
         case OPCODE_RDMA_CREATE_QP_SLI:
            return "OPCODE_RDMA_CREATE_QP_SLI";
         case OPCODE_RDMA_QUERY_QP_SLI:
            return "OPCODE_RDMA_QUERY_QP_SLI";
         case OPCODE_RDMA_MODIFY_QP_SLI:
            return "OPCODE_RDMA_MODIFY_QP_SLI";
         case OPCODE_RDMA_DESTROY_QP_SLI:
            return "OPCODE_RDMA_DESTROY_QP_SLI";
         case OPCODE_RDMA_MODIFY_CQ_SLI:
            return "OPCODE_RDMA_MODIFY_CQ_SLI";
         case OPCODE_RDMA_ALLOC_STAG_SLI:
            return "OPCODE_RDMA_ALLOC_STAG_SLI";
         case OPCODE_RDMA_DEALLOC_STAG_SLI:
            return "OPCODE_RDMA_DEALLOC_STAG_SLI";
         case OPCODE_RDMA_REGISTER_NSMR_SLI:
            return "OPCODE_RDMA_REGISTER_NSMR_SLI";
         case OPCODE_RDMA_REREGISTER_NSMR_SLI:
            return "OPCODE_RDMA_REREGISTER_NSMR_SLI";
         case OPCODE_RDMA_REGISTER_NSMR_CONT_SLI:
            return "OPCODE_RDMA_REGISTER_NSMR_CONT_SLI";
         case OPCODE_RDMA_QUERY_NSMR_SLI:
            return "OPCODE_RDMA_QUERY_NSMR_SLI";
         case OPCODE_RDMA_ALLOC_MW_SLI:
            return "OPCODE_RDMA_ALLOC_MW_SLI";
         case OPCODE_RDMA_QUERY_MW_SLI:
            return "OPCODE_RDMA_QUERY_MW_SLI";
         case OPCODE_RDMA_CREATE_SRQ_SLI:
            return "OPCODE_RDMA_CREATE_SRQ_SLI";
         case OPCODE_RDMA_QUERY_SRQ_SLI:
            return "OPCODE_RDMA_QUERY_SRQ_SLI";
         case OPCODE_RDMA_MODIFY_SRQ_SLI:
            return "OPCODE_RDMA_MODIFY_SRQ_SLI";
         case OPCODE_RDMA_DESTROY_SRQ_SLI:
            return "OPCODE_RDMA_DESTROY_SRQ_SLI";
         case OPCODE_RDMA_ATTACH_MGID_SLI:
            return "OPCODE_RDMA_ATTACH_MGID_SLI";
         case OPCODE_RDMA_DETACH_MGID_SLI:
            return "OPCODE_RDMA_DETACH_MGID_SLI";
         case OPCODE_RDMA_CREATE_RBQ_SLI:
            return "OPCODE_RDMA_CREATE_RBQ_SLI";
         case OPCODE_RDMA_DESTROY_RBQ_SLI:
            return "OPCODE_RDMA_DESTROY_RBQ_SLI";
         case OPCODE_RDMA_GET_STATS_SLI:
            return "OPCODE_RDMA_GET_STATS_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LOWLEVEL_SUBSYSTEM_OPCODES ---
#define OPCODE_LOWLEVEL_CONFIG_DT_ENTRY_SLI (1)   
#define OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY_SLI (2) 
#define OPCODE_LOWLEVEL_ACCESS_MEMORY_SLI (3)     
#define OPCODE_LOWLEVEL_ACCESS_REGISTERS_SLI (4)  
#define OPCODE_LOWLEVEL_OFFLOAD_ENABLE_SLI (5)    
#define OPCODE_LOWLEVEL_CONFIG_TCP_STATE_SLI (6)  
#define OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER_SLI (7) 
#define OPCODE_LOWLEVEL_CONFIG_ISCSI_SLI (8)      
#define OPCODE_LOWLEVEL_CONFIG_TOE_SLI  (9)       
#define OPCODE_LOWLEVEL_ISCSI_OFFLOAD_SLI (10)    
#define SUBSYSTEM_LOWLEVEL_CONFIG_DT_ENTRY_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_INVALIDATE_PT_ENTRY_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_ACCESS_MEMORY_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_ACCESS_REGISTERS_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_OFFLOAD_ENABLE_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_CONFIG_TCP_STATE_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_CONFIG_TEMPLATE_HEADER_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_CONFIG_ISCSI_SLI (11)  
#define SUBSYSTEM_LOWLEVEL_CONFIG_TOE_SLI (11)    
#define SUBSYSTEM_LOWLEVEL_ISCSI_OFFLOAD_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_MAP_UT_PAGES_SLI (11)  
#define SUBSYSTEM_LOWLEVEL_UNMAP_UT_PAGES_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_MGMT_DEBUG_LEVEL_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_MEASURE_DMA_BANDWIDTH_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_HOST_DDR_DMA_SLI (11)  
#define SUBSYSTEM_LOWLEVEL_LOOPBACK_TEST_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_SET_LOOPBACK_MODE_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_GET_LOOPBACK_MODE_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_PROPERTIES_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_SEGMENT_SLI (11) 
#define SUBSYSTEM_LOWLEVEL_QUERY_SFP_SIGNALS_SLI (11) 
#define OPCODE_LOWLEVEL_MAP_UT_PAGES_SLI (13)     
#define OPCODE_LOWLEVEL_UNMAP_UT_PAGES_SLI (14)   
#define OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL_SLI (15) 
#define OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH_SLI (16) 
#define OPCODE_LOWLEVEL_HOST_DDR_DMA_SLI (17)     
#define OPCODE_LOWLEVEL_LOOPBACK_TEST_SLI (18)    
#define OPCODE_LOWLEVEL_SET_LOOPBACK_MODE_SLI (19) 
#define OPCODE_LOWLEVEL_GET_LOOPBACK_MODE_SLI (20) 
#define OPCODE_LOWLEVEL_GET_COREDUMP_PROPERTIES_SLI (21) 
#define OPCODE_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_SLI (22) 
#define OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_SLI (23) 
#define OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_SLI (24) 
#define OPCODE_LOWLEVEL_QUERY_SFP_SIGNALS_SLI (25) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lowlevel_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LOWLEVEL_CONFIG_DT_ENTRY_SLI:
            return "OPCODE_LOWLEVEL_CONFIG_DT_ENTRY_SLI";
         case OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY_SLI:
            return "OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY_SLI";
         case OPCODE_LOWLEVEL_ACCESS_MEMORY_SLI:
            return "OPCODE_LOWLEVEL_ACCESS_MEMORY_SLI";
         case OPCODE_LOWLEVEL_ACCESS_REGISTERS_SLI:
            return "OPCODE_LOWLEVEL_ACCESS_REGISTERS_SLI";
         case OPCODE_LOWLEVEL_OFFLOAD_ENABLE_SLI:
            return "OPCODE_LOWLEVEL_OFFLOAD_ENABLE_SLI";
         case OPCODE_LOWLEVEL_CONFIG_TCP_STATE_SLI:
            return "OPCODE_LOWLEVEL_CONFIG_TCP_STATE_SLI";
         case OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER_SLI:
            return "OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER_SLI";
         case OPCODE_LOWLEVEL_CONFIG_ISCSI_SLI:
            return "OPCODE_LOWLEVEL_CONFIG_ISCSI_SLI";
         case OPCODE_LOWLEVEL_CONFIG_TOE_SLI:
            return "OPCODE_LOWLEVEL_CONFIG_TOE_SLI";
         case OPCODE_LOWLEVEL_ISCSI_OFFLOAD_SLI:
            return "OPCODE_LOWLEVEL_ISCSI_OFFLOAD_SLI";
         case OPCODE_LOWLEVEL_MAP_UT_PAGES_SLI:
            return "OPCODE_LOWLEVEL_MAP_UT_PAGES_SLI";
         case OPCODE_LOWLEVEL_UNMAP_UT_PAGES_SLI:
            return "OPCODE_LOWLEVEL_UNMAP_UT_PAGES_SLI";
         case OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL_SLI:
            return "OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL_SLI";
         case OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH_SLI:
            return "OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH_SLI";
         case OPCODE_LOWLEVEL_HOST_DDR_DMA_SLI:
            return "OPCODE_LOWLEVEL_HOST_DDR_DMA_SLI";
         case OPCODE_LOWLEVEL_LOOPBACK_TEST_SLI:
            return "OPCODE_LOWLEVEL_LOOPBACK_TEST_SLI";
         case OPCODE_LOWLEVEL_SET_LOOPBACK_MODE_SLI:
            return "OPCODE_LOWLEVEL_SET_LOOPBACK_MODE_SLI";
         case OPCODE_LOWLEVEL_GET_LOOPBACK_MODE_SLI:
            return "OPCODE_LOWLEVEL_GET_LOOPBACK_MODE_SLI";
         case OPCODE_LOWLEVEL_GET_COREDUMP_PROPERTIES_SLI:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_PROPERTIES_SLI";
         case OPCODE_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_SLI:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_SLI";
         case OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_SLI:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_SLI";
         case OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_SLI:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_SLI";
         case OPCODE_LOWLEVEL_QUERY_SFP_SIGNALS_SLI:
            return "OPCODE_LOWLEVEL_QUERY_SFP_SIGNALS_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_FCOE_SUBSYSTEM_OPCODES ---
#define OPCODE_COMMON_FCOE_WRBQ_CREATE_SLI (1)    
#define OPCODE_COMMON_FCOE_WRBQ_DESTROY_SLI (2)   
#define OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES_SLI (3) 
#define OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_SLI (4) 
#define OPCODE_COMMON_FCOE_DEFQ_CREATE_SLI (5)    
#define OPCODE_COMMON_FCOE_DEFQ_DESTROY_SLI (6)   
#define OPCODE_COMMON_FCOE_READ_FCF_TABLE_SLI (8) 
#define OPCODE_COMMON_FCOE_ADD_FCF_SLI  (9)       
#define OPCODE_COMMON_FCOE_DELETE_FCF_SLI (10)    
#define OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES_SLI (11) 
#define SUBSYSTEM_COMMON_FCOE_WRBQ_CREATE_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_WRBQ_DESTROY_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_CFG_POST_SGL_PAGES_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_DEFQ_CREATE_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_DEFQ_DESTROY_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_READ_FCF_TABLE_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_ADD_FCF_SLI (12)    
#define SUBSYSTEM_COMMON_FCOE_DELETE_FCF_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_POST_HDR_TEMPLATES_SLI (12) 
#define OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_REMOVE_HDR_TEMPLATES_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_IO_INIT_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_REQUEST_COMPLETION_SLI (12) 
#define SUBSYSTEM_COMMON_FCOE_REDISCOVER_FCF_SLI (12) 
#define OPCODE_COMMON_FCOE_MBOX_IO_INIT_SLI (13)  
#define OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_SLI (14) 
#define OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION_SLI (15) 
#define OPCODE_COMMON_FCOE_REDISCOVER_FCF_SLI (16) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_fcoe_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_FCOE_WRBQ_CREATE_SLI:
            return "OPCODE_COMMON_FCOE_WRBQ_CREATE_SLI";
         case OPCODE_COMMON_FCOE_WRBQ_DESTROY_SLI:
            return "OPCODE_COMMON_FCOE_WRBQ_DESTROY_SLI";
         case OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES_SLI:
            return "OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES_SLI";
         case OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_SLI:
            return "OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_SLI";
         case OPCODE_COMMON_FCOE_DEFQ_CREATE_SLI:
            return "OPCODE_COMMON_FCOE_DEFQ_CREATE_SLI";
         case OPCODE_COMMON_FCOE_DEFQ_DESTROY_SLI:
            return "OPCODE_COMMON_FCOE_DEFQ_DESTROY_SLI";
         case OPCODE_COMMON_FCOE_READ_FCF_TABLE_SLI:
            return "OPCODE_COMMON_FCOE_READ_FCF_TABLE_SLI";
         case OPCODE_COMMON_FCOE_ADD_FCF_SLI:
            return "OPCODE_COMMON_FCOE_ADD_FCF_SLI";
         case OPCODE_COMMON_FCOE_DELETE_FCF_SLI:
            return "OPCODE_COMMON_FCOE_DELETE_FCF_SLI";
         case OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES_SLI:
            return "OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES_SLI";
         case OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES_SLI:
            return "OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES_SLI";
         case OPCODE_COMMON_FCOE_MBOX_IO_INIT_SLI:
            return "OPCODE_COMMON_FCOE_MBOX_IO_INIT_SLI";
         case OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_SLI:
            return "OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_SLI";
         case OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION_SLI:
            return "OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION_SLI";
         case OPCODE_COMMON_FCOE_REDISCOVER_FCF_SLI:
            return "OPCODE_COMMON_FCOE_REDISCOVER_FCF_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LLDP_SUBSYSTEM_OPCODES ---
#define OPCODE_LLDP_GET_LLDP_CFG_SLI    (1)       
#define OPCODE_LLDP_SET_LLDP_CFG_SLI    (2)       
#define OPCODE_LLDP_GET_LLDP_STATS_SLI  (3)       
#define SUBSYSTEM_LLDP_GET_LLDP_CFG_SLI (15)      
#define SUBSYSTEM_LLDP_SET_LLDP_CFG_SLI (15)      
#define SUBSYSTEM_LLDP_GET_LLDP_STATS_SLI (15)    

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lldp_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LLDP_GET_LLDP_CFG_SLI:
            return "OPCODE_LLDP_GET_LLDP_CFG_SLI";
         case OPCODE_LLDP_SET_LLDP_CFG_SLI:
            return "OPCODE_LLDP_SET_LLDP_CFG_SLI";
         case OPCODE_LLDP_GET_LLDP_STATS_SLI:
            return "OPCODE_LLDP_GET_LLDP_STATS_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DCBX_SUBSYSTEM_OPCODES ---
#define OPCODE_DCBX_GET_DCBX_CFG_SLI    (1)       
#define OPCODE_DCBX_SET_DCBX_CFG_SLI    (2)       
#define OPCODE_DCBX_GET_DCBX_MIB_INFO_SLI (3)     
#define OPCODE_DCBX_GET_DCBX_MODE_SLI   (4)       
#define OPCODE_DCBX_SET_DCBX_MODE_SLI   (5)       
#define SUBSYSTEM_DCBX_GET_DCBX_CFG_SLI (16)      
#define SUBSYSTEM_DCBX_SET_DCBX_CFG_SLI (16)      
#define SUBSYSTEM_DCBX_GET_DCBX_MIB_INFO_SLI (16) 
#define SUBSYSTEM_DCBX_GET_DCBX_MODE_SLI (16)     
#define SUBSYSTEM_DCBX_SET_DCBX_MODE_SLI (16)     

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dcbx_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DCBX_GET_DCBX_CFG_SLI:
            return "OPCODE_DCBX_GET_DCBX_CFG_SLI";
         case OPCODE_DCBX_SET_DCBX_CFG_SLI:
            return "OPCODE_DCBX_SET_DCBX_CFG_SLI";
         case OPCODE_DCBX_GET_DCBX_MIB_INFO_SLI:
            return "OPCODE_DCBX_GET_DCBX_MIB_INFO_SLI";
         case OPCODE_DCBX_GET_DCBX_MODE_SLI:
            return "OPCODE_DCBX_GET_DCBX_MODE_SLI";
         case OPCODE_DCBX_SET_DCBX_MODE_SLI:
            return "OPCODE_DCBX_SET_DCBX_MODE_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DMTF_SUBSYSTEM_OPCODES ---
#define OPCODE_DMTF_EXECUTE_CMD_SLI     (1)       
#define SUBSYSTEM_DMTF_EXECUTE_CMD_SLI  (17)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dmtf_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DMTF_EXECUTE_CMD_SLI:
            return "OPCODE_DMTF_EXECUTE_CMD_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DIAG_SUBSYSTEM_OPCODES ---
#define OPCODE_DIAG_DMA_SLI             (1)       
#define OPCODE_DIAG_MDIO_SLI            (2)       
#define OPCODE_DIAG_NLB_SLI             (3)       
#define OPCODE_DIAG_ATT_SLI             (4)       
#define OPCODE_DIAG_GETMAC_SLI          (5)       
#define OPCODE_DIAG_8051_CMD_SLI        (6)       
#define OPCODE_DIAG_RESET_PHY_SLI       (7)       
#define OPCODE_DIAG_10GBASET_STATS_SLI  (8)       
#define OPCODE_DIAG_RUN_10GBASET_SELFTEST_SLI (9) 
#define OPCODE_DIAG_SET_10GBASET_NVPVALUE_SLI (10) 
#define OPCODE_DIAG_RUN_TDR_SLI         (11)      
#define OPCODE_DIAG_GET_10GBASET_NVPVALUE_SLI (12) 
#define OPCODE_DIAG_SET_EMI_CANCELLER_SLI (13)    
#define SUBSYSTEM_DIAG_DMA_SLI          (18)      
#define SUBSYSTEM_DIAG_MDIO_SLI         (18)      
#define SUBSYSTEM_DIAG_NLB_SLI          (18)      
#define SUBSYSTEM_DIAG_ATT_SLI          (18)      
#define SUBSYSTEM_DIAG_GETMAC_SLI       (18)      
#define SUBSYSTEM_DIAG_8051_CMD_SLI     (18)      
#define SUBSYSTEM_DIAG_RESET_PHY_SLI    (18)      
#define SUBSYSTEM_DIAG_10GBASET_STATS_SLI (18)    
#define SUBSYSTEM_DIAG_RUN_10GBASET_SELFTEST_SLI (18) 
#define SUBSYSTEM_DIAG_SET_10GBASET_NVPVALUE_SLI (18) 
#define SUBSYSTEM_DIAG_RUN_TDR_SLI      (18)      
#define SUBSYSTEM_DIAG_GET_10GBASET_NVPVALUE_SLI (18) 
#define SUBSYSTEM_DIAG_SET_EMI_CANCELLER_SLI (18) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* diag_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DIAG_DMA_SLI:
            return "OPCODE_DIAG_DMA_SLI";
         case OPCODE_DIAG_MDIO_SLI:
            return "OPCODE_DIAG_MDIO_SLI";
         case OPCODE_DIAG_NLB_SLI:
            return "OPCODE_DIAG_NLB_SLI";
         case OPCODE_DIAG_ATT_SLI:
            return "OPCODE_DIAG_ATT_SLI";
         case OPCODE_DIAG_GETMAC_SLI:
            return "OPCODE_DIAG_GETMAC_SLI";
         case OPCODE_DIAG_8051_CMD_SLI:
            return "OPCODE_DIAG_8051_CMD_SLI";
         case OPCODE_DIAG_RESET_PHY_SLI:
            return "OPCODE_DIAG_RESET_PHY_SLI";
         case OPCODE_DIAG_10GBASET_STATS_SLI:
            return "OPCODE_DIAG_10GBASET_STATS_SLI";
         case OPCODE_DIAG_RUN_10GBASET_SELFTEST_SLI:
            return "OPCODE_DIAG_RUN_10GBASET_SELFTEST_SLI";
         case OPCODE_DIAG_SET_10GBASET_NVPVALUE_SLI:
            return "OPCODE_DIAG_SET_10GBASET_NVPVALUE_SLI";
         case OPCODE_DIAG_RUN_TDR_SLI:
            return "OPCODE_DIAG_RUN_TDR_SLI";
         case OPCODE_DIAG_GET_10GBASET_NVPVALUE_SLI:
            return "OPCODE_DIAG_GET_10GBASET_NVPVALUE_SLI";
         case OPCODE_DIAG_SET_EMI_CANCELLER_SLI:
            return "OPCODE_DIAG_SET_EMI_CANCELLER_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- VENDOR_SUBSYSTEM_OPCODES ---
#define OPCODE_VENDOR_SLI_SLI           (1)       
#define OPCODE_VENDOR_MANAGE_FFV_SLI    (2)       
#define OPCODE_VENDOR_READ_FRU_EEPROM_SLI (3)     
#define OPCODE_VENDOR_WRITE_FRU_EEPROM_SLI (4)    
#define SUBSYSTEM_VENDOR_SLI_SLI        (19)      
#define SUBSYSTEM_VENDOR_MANAGE_FFV_SLI (19)      
#define SUBSYSTEM_VENDOR_READ_FRU_EEPROM_SLI (19) 
#define SUBSYSTEM_VENDOR_WRITE_FRU_EEPROM_SLI (19) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* vendor_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_VENDOR_SLI_SLI:
            return "OPCODE_VENDOR_SLI_SLI";
         case OPCODE_VENDOR_MANAGE_FFV_SLI:
            return "OPCODE_VENDOR_MANAGE_FFV_SLI";
         case OPCODE_VENDOR_READ_FRU_EEPROM_SLI:
            return "OPCODE_VENDOR_READ_FRU_EEPROM_SLI";
         case OPCODE_VENDOR_WRITE_FRU_EEPROM_SLI:
            return "OPCODE_VENDOR_WRITE_FRU_EEPROM_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- OEM_SUBSYSTEM_OPCODES ---
#define OPCODE_OEM_QUERY_FOD_SLI        (1)       
#define OPCODE_OEM_QUERY_FOD_V1_SLI     (1)       
#define OPCODE_OEM_VALIDATE_FOD_LICENSE_KEYS_SLI (2) 
#define OPCODE_OEM_QUERY_OCSD_STATUS_SLI (3)      
#define SUBSYSTEM_OEM_QUERY_FOD_SLI     (21)      
#define SUBSYSTEM_OEM_QUERY_FOD_V1_SLI  (21)      
#define SUBSYSTEM_OEM_VALIDATE_FOD_LICENSE_KEYS_SLI (21) 
#define SUBSYSTEM_OEM_QUERY_OCSD_STATUS_SLI (21)  

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* oem_subsystem_opcodes_sli_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_OEM_QUERY_FOD_SLI:
            return "OPCODE_OEM_QUERY_FOD_SLI";
         case OPCODE_OEM_VALIDATE_FOD_LICENSE_KEYS_SLI:
            return "OPCODE_OEM_VALIDATE_FOD_LICENSE_KEYS_SLI";
         case OPCODE_OEM_QUERY_OCSD_STATUS_SLI:
            return "OPCODE_OEM_QUERY_OCSD_STATUS_SLI";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- SURF_SUBSYSTEM_OPCODES ---
#define OPCODE_SURF_CREATE_CLIENT_SLI   (1)       
#define OPCODE_SURF_DESTROY_CLIENT_SLI  (2)       
#define OPCODE_SURF_CREATE_RQ_SLI       (3)       
#define OPCODE_SURF_DESTROY_RQ_SLI      (4)       
#define OPCODE_SURF_CREATE_TARGET_SLI   (5)       
#define OPCODE_SURF_DESTROY_TARGET_SLI  (6)       
#define OPCODE_SURF_MAKE_RULE_SLI       (7)       
#define OPCODE_SURF_MOD_RULE_SLI        (8)       
#define OPCODE_SURF_DEL_RULE_SLI        (9)       
#define OPCODE_SURF_CREATE_WQ_SLI       (10)      
#define OPCODE_SURF_CREATE_CQ_SLI       (11)      
#define OPCODE_SURF_CREATE_EQ_SLI       (12)      
#define OPCODE_SURF_CREATE_MQ_SLI       (13)      
#define OPCODE_SURF_ALLOC_PD_SLI        (14)      
#define OPCODE_SURF_DEALLOC_PD_SLI      (15)      
#define OPCODE_SURF_QUERY_CONFIG_SLI    (16)      
#define OPCODE_SURF_INSTALL_CUSTOM_HANDLER_SLI (17) 
#define OPCODE_SURF_GET_CUSTOM_HANDLER_DATA_SLI (18) 
#define SUBSYSTEM_SURF_CREATE_CLIENT_SLI (22)     
#define SUBSYSTEM_SURF_DESTROY_CLIENT_SLI (22)    
#define SUBSYSTEM_SURF_CREATE_RQ_SLI    (22)      
#define SUBSYSTEM_SURF_DESTROY_RQ_SLI   (22)      
#define SUBSYSTEM_SURF_CREATE_TARGET_SLI (22)     
#define SUBSYSTEM_SURF_DESTROY_TARGET_SLI (22)    
#define SUBSYSTEM_SURF_MAKE_RULE_SLI    (22)      
#define SUBSYSTEM_SURF_MOD_RULE_SLI     (22)      
#define SUBSYSTEM_SURF_DEL_RULE_SLI     (22)      
#define SUBSYSTEM_SURF_CREATE_WQ_SLI    (22)      
#define SUBSYSTEM_SURF_CREATE_CQ_SLI    (22)      
#define SUBSYSTEM_SURF_CREATE_EQ_SLI    (22)      
#define SUBSYSTEM_SURF_CREATE_MQ_SLI    (22)      
#define SUBSYSTEM_SURF_ALLOC_PD_SLI     (22)      
#define SUBSYSTEM_SURF_DEALLOC_PD_SLI   (22)      
#define SUBSYSTEM_SURF_QUERY_CONFIG_SLI (22)      
#define SUBSYSTEM_SURF_INSTALL_CUSTOM_HANDLER_SLI (22) 
#define SUBSYSTEM_SURF_GET_CUSTOM_HANDLER_DATA_SLI (22) 


typedef struct _IOCTL_REQUEST_HEADER_SLI {
   union {
      struct { 
         u32 opcode : 8;                          // DWORD 0
         u32 subsystem : 8;                       // DWORD 0
         u32 port_number : 8;                     // DWORD 0
         u32 domain : 8;                          // DWORD 0
         u32 timeout;                             // DWORD 1
         u32 request_length;                      // DWORD 2
         u32 version : 8;                         // DWORD 3
         u32 rsvd0 : 8;                           // DWORD 3
         u32 pfnumber : 10;                       // DWORD 3
         u32 vhnumber : 6;                        // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_REQUEST_HEADER_SLI, *PIOCTL_REQUEST_HEADER_SLI;

SG_C_ASSERT(__sizeof__IOCTL_REQUEST_HEADER, sizeof (IOCTL_REQUEST_HEADER_SLI) == 16);



typedef struct _IOCTL_RESPONSE_HEADER_SLI {
   union {
      struct { 
         u32 opcode : 8;                          // DWORD 0
         u32 subsystem : 8;                       // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 domain : 8;                          // DWORD 0
         u32 status : 8;                          // DWORD 1
         u32 additional_status : 16;              // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
         u32 response_length;                     // DWORD 2
         u32 actual_response_length;              // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_RESPONSE_HEADER_SLI, *PIOCTL_RESPONSE_HEADER_SLI;

SG_C_ASSERT(__sizeof__IOCTL_RESPONSE_HEADER, sizeof (IOCTL_RESPONSE_HEADER_SLI) == 16);



typedef struct _IOCTL_HEADER_SLI {
   union {
      union { 
         IOCTL_REQUEST_HEADER_SLI request;
         IOCTL_RESPONSE_HEADER_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_HEADER_SLI, *PIOCTL_HEADER_SLI;

SG_C_ASSERT(__sizeof__IOCTL_HEADER, sizeof (IOCTL_HEADER_SLI) == 16);


// --- CQ_CTX_CNT_ENUM ---
#define CQ_CTX_CNT_256_SLI              (0)       
#define CQ_CTX_CNT_512_SLI              (1)       
#define CQ_CTX_CNT_1024_SLI             (2)       
#define CQ_CTX_CNT_EXT_SLI              (3)       

// --- CQ_CREATE_TYPE ---
#define CQ_CREATE_TYPE_NORMAL_SLI       (0)       
#define CQ_CREATE_TYPE_DPP_SLI          (1)       
#define CQ_CREATE_TYPE_NORMAL_DIRECT_MSIX_SLI (2) 


typedef struct _CQ_CTX_V2_SLI {
   union {
      struct { 
         u32 rsvd0 : 12;                          // DWORD 0
         u32 CoalescWM : 2;                       // DWORD 0
         u32 NoDelay : 1;                         // DWORD 0
         u32 autovalid : 1;                       // DWORD 0
         u32 rsvd1 : 11;                          // DWORD 0
         u32 Count : 2;                           // DWORD 0
         u32 valid : 1;                           // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 Eventable : 1;                       // DWORD 0
         u32 EQID : 16;                           // DWORD 1
         u32 rsvd3 : 15;                          // DWORD 1
         u32 Armed : 1;                           // DWORD 1
         u32 CQE_COUNT : 16;                      // DWORD 2
         u32 rsvd4 : 16;                          // DWORD 2
         u32 rsvd5[1];                            // DWORDS 3 to 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK CQ_CTX_V2_SLI, *PCQ_CTX_V2_SLI;

SG_C_ASSERT(__sizeof__CQ_CTX_V2, sizeof (CQ_CTX_V2_SLI) == 16);



typedef struct _CQ_CREATE_V2_PARAMS_IN_SLI {
   union {
      struct { 
         u32 num_pages : 16;                      // DWORD 0
         u32 page_size : 8;                       // DWORD 0
         u32 cq_type : 4;                         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         CQ_CTX_V2_SLI context;
         PHYS_ADDR_SLI pages[8];
      } SG_PACK ; // unnamed struct
      u32 dw[21]; // dword union
   }; // unnamed union
} SG_PACK CQ_CREATE_V2_PARAMS_IN_SLI, *PCQ_CREATE_V2_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__CQ_CREATE_V2_PARAMS_IN, sizeof (CQ_CREATE_V2_PARAMS_IN_SLI) == 84);



typedef struct _CQ_CREATE_V2_PARAMS_OUT_SLI {
   UEXACT16 cq_id;
   UEXACT16 rsvd0;
} SG_PACK CQ_CREATE_V2_PARAMS_OUT_SLI, *PCQ_CREATE_V2_PARAMS_OUT_SLI;




typedef struct _CQ_CREATE_V2_PARAMS_SLI {
   union {
      union { 
         CQ_CREATE_V2_PARAMS_IN_SLI request;
         CQ_CREATE_V2_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[21]; // dword union
   }; // unnamed union
} SG_PACK CQ_CREATE_V2_PARAMS_SLI, *PCQ_CREATE_V2_PARAMS_SLI;

SG_C_ASSERT(__sizeof__CQ_CREATE_V2_PARAMS, sizeof (CQ_CREATE_V2_PARAMS_SLI) == 84);



typedef struct _IOCTL_COMMON_CQ_CREATE_V2_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         CQ_CREATE_V2_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[25]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_CQ_CREATE_V2_SLI, *PIOCTL_COMMON_CQ_CREATE_V2_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_CQ_CREATE_V2, sizeof (IOCTL_COMMON_CQ_CREATE_V2_SLI) == 100);



typedef struct _TX_CREATE_V2_PARAMS_IN_SLI {
   union {
      struct { 
         u32 num_pages : 8;                       // DWORD 0
         u32 ulp_num : 8;                         // DWORD 0
         u32 type : 8;                            // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 pv_id_valid : 1;                     // DWORD 0
         u32 bind_q : 1;                          // DWORD 0
         UEXACT16 iface_id;
         UEXACT8 queue_size;
         UEXACT8 rsvd1;
         UEXACT8 wq_pg_sz;
         UEXACT8 rsvd2;
         UEXACT16 rsvd3;
         UEXACT16 cq_id;
         UEXACT16 pd_id;
         UEXACT32 rsvd4[13];
         PHYS_ADDR_SLI pages[8];
      } SG_PACK ; // unnamed struct
      u32 dw[33]; // dword union
   }; // unnamed union
} SG_PACK TX_CREATE_V2_PARAMS_IN_SLI, *PTX_CREATE_V2_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__TX_CREATE_V2_PARAMS_IN, sizeof (TX_CREATE_V2_PARAMS_IN_SLI) == 132);



typedef struct _TX_CREATE_V2_PARAMS_OUT_SLI {
   union {
      struct { 
         UEXACT16 id;
         UEXACT16 rid;
         UEXACT32 doorbell_offset;
         UEXACT8 class_queue_id;
         UEXACT8 rsvd0;
         UEXACT8 db_bar_reg_set;
         UEXACT8 db_format;
         UEXACT32 dpp_roc_offset;
         u32 dpp_credits : 8;                     // DWORD 4
         u32 rsvd1 : 8;                           // DWORD 4
         u32 dpp_roc_bar_reg_set : 8;             // DWORD 4
         u32 rsvd2 : 7;                           // DWORD 4
         u32 dpp_en : 1;                          // DWORD 4
         UEXACT16 max_num_wqes;
         UEXACT8 roc_queue_pg_count;
         UEXACT8 rsvd3;
      } SG_PACK ; // unnamed struct
      u32 dw[6]; // dword union
   }; // unnamed union
} SG_PACK TX_CREATE_V2_PARAMS_OUT_SLI, *PTX_CREATE_V2_PARAMS_OUT_SLI;

SG_C_ASSERT(__sizeof__TX_CREATE_V2_PARAMS_OUT, sizeof (TX_CREATE_V2_PARAMS_OUT_SLI) == 24);



typedef struct _TX_CREATE_V2_PARAMS_SLI {
   union {
      union { 
         TX_CREATE_V2_PARAMS_IN_SLI request;
         TX_CREATE_V2_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[33]; // dword union
   }; // unnamed union
} SG_PACK TX_CREATE_V2_PARAMS_SLI, *PTX_CREATE_V2_PARAMS_SLI;

SG_C_ASSERT(__sizeof__TX_CREATE_V2_PARAMS, sizeof (TX_CREATE_V2_PARAMS_SLI) == 132);



typedef struct _IOCTL_ETH_TX_CREATE_V2_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         TX_CREATE_V2_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[37]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_TX_CREATE_V2_SLI, *PIOCTL_ETH_TX_CREATE_V2_SLI;

SG_C_ASSERT(__sizeof__IOCTL_ETH_TX_CREATE_V2, sizeof (IOCTL_ETH_TX_CREATE_V2_SLI) == 148);



typedef struct _ETH_TX_DESTROY_PARAMS_IN_SLI {
   union {
      struct { 
         UEXACT16 id;
         UEXACT16 rsvd0;
         u32 roc : 1;                             // DWORD 1
         u32 surf : 1;                            // DWORD 1
         u32 rsvd1 : 30;                          // DWORD 1
      } SG_PACK ; // unnamed struct
      u32 dw[2]; // dword union
   }; // unnamed union
} SG_PACK ETH_TX_DESTROY_PARAMS_IN_SLI, *PETH_TX_DESTROY_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__ETH_TX_DESTROY_PARAMS_IN, sizeof (ETH_TX_DESTROY_PARAMS_IN_SLI) == 8);



typedef struct _ETH_TX_DESTROY_PARAMS_OUT_SLI {
   UEXACT32 rsvd0;
} SG_PACK ETH_TX_DESTROY_PARAMS_OUT_SLI, *PETH_TX_DESTROY_PARAMS_OUT_SLI;




typedef struct _ETH_TX_DESTROY_PARAMS_SLI {
   union {
      union { 
         ETH_TX_DESTROY_PARAMS_IN_SLI request;
         ETH_TX_DESTROY_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[2]; // dword union
   }; // unnamed union
} SG_PACK ETH_TX_DESTROY_PARAMS_SLI, *PETH_TX_DESTROY_PARAMS_SLI;

SG_C_ASSERT(__sizeof__ETH_TX_DESTROY_PARAMS, sizeof (ETH_TX_DESTROY_PARAMS_SLI) == 8);



typedef struct _IOCTL_ETH_TX_DESTROY_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         ETH_TX_DESTROY_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[6]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_TX_DESTROY_SLI, *PIOCTL_ETH_TX_DESTROY_SLI;

SG_C_ASSERT(__sizeof__IOCTL_ETH_TX_DESTROY, sizeof (IOCTL_ETH_TX_DESTROY_SLI) == 24);



typedef struct _GET_ACTIVE_PROFILE_PARAMS_IN_SLI {
   UEXACT32 rsvd0;
} SG_PACK GET_ACTIVE_PROFILE_PARAMS_IN_SLI, *PGET_ACTIVE_PROFILE_PARAMS_IN_SLI;




typedef struct _GET_ACTIVE_PROFILE_PARAMS_OUT_SLI {
   UEXACT16 active_profile_id;
   UEXACT16 next_active_profile_id;
} SG_PACK GET_ACTIVE_PROFILE_PARAMS_OUT_SLI, *PGET_ACTIVE_PROFILE_PARAMS_OUT_SLI;




typedef union _GET_ACTIVE_PROFILE_PARAMS_SLI {
   GET_ACTIVE_PROFILE_PARAMS_IN_SLI request;
   GET_ACTIVE_PROFILE_PARAMS_OUT_SLI response;
} SG_PACK GET_ACTIVE_PROFILE_PARAMS_SLI, *PGET_ACTIVE_PROFILE_PARAMS_SLI;




typedef struct _IOCTL_COMMON_GET_ACTIVE_PROFILE_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         GET_ACTIVE_PROFILE_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[5]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_GET_ACTIVE_PROFILE_SLI, *PIOCTL_COMMON_GET_ACTIVE_PROFILE_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_ACTIVE_PROFILE, sizeof (IOCTL_COMMON_GET_ACTIVE_PROFILE_SLI) == 20);


// --- NTWK_MANAGE_IFACE_FILTERS_OPERATION_ENUM ---
#define NORMAL_TO_TUNNEL_SLI            (0)       
#define TUNNEL_TO_NORMAL_SLI            (1)       
#define NORMAL_TO_TENANT_SLI            (2)       
#define TENANT_TO_NORMAL_SLI            (3)       
#define DIRECT_TENANT_IFACE_CREATE_SLI  (4)       
#define ADD_SOFT_FILTER_TO_TENANT_SLI   (5)       
#define DEL_SOFT_FILTER_FROM_TENANT_SLI (6)       

// --- SLI4_IFACE_CAPS_FLAGS_ENUM ---
#define SLI4_IF_CAPS_FLAGS_RSS_SLI      (4)       
#define SLI4_IF_CAPS_FLAGS_PROMISCUOUS_SLI (8)    
#define SLI4_IF_CAPS_FLAGS_BROADCAST_SLI (16)     
#define SLI4_IF_CAPS_FLAGS_UNTAGGED_SLI (32)      
#define SLI4_IF_CAPS_FLAGS_ULP_SLI      (64)      
#define SLI4_IF_CAPS_FLAGS_VLAN_PROMISCUOUS_SLI (128) 
#define SLI4_IF_CAPS_FLAGS_VLAN_SLI     (256)     
#define SLI4_IF_CAPS_FLAGS_MCAST_PROMISCUOUS_SLI (512) 
#define SLI4_IF_CAPS_FLAGS_PASS_L2_ERRORS_SLI (1024) 
#define SLI4_IF_CAPS_FLAGS_PASS_L3L4_ERRORS_SLI (2048) 
#define SLI4_IF_CAPS_FLAGS_MULTICAST_SLI (4096)   
#define SLI4_IF_CAPS_FLAGS_MULTICAST_HASH_SLI (8192) 
#define SLI4_IF_CAPS_FLAGS_HDS_SLI      (16384)   
#define SLI4_IF_CAPS_FLAGS_DIRECTED_SLI (32768)   
#define SLI4_IF_CAPS_FLAGS_VMQ_SLI      (65536)   
#define SLI4_IF_CAPS_FLAGS_NETQ_SLI     (131072)  
#define SLI4_IF_CAPS_FLAGS_QGROUPS_SLI  (262144)  
#define SLI4_IF_CAPS_FLAGS_LSO_SLI      (524288)  
#define SLI4_IF_CAPS_FLAGS_LRO_SLI      (1048576) 
#define SLI4_IF_CAPS_FLAGS_TOE_SLI      (2097152) 
#define SLI4_IF_CAPS_FLAGS_RDMA_SLI     (4194304) 
#define SLI4_IF_CAPS_FLAGS_VLAN_OFFLOAD_SLI (8388608) 
#define SLI4_IF_CAPS_FLAGS_QINQ_SLI     (16777216) 
#define SLI4_IF_CAPS_FLAGS_MRV_SLI      (33554432) 


typedef struct _NTWK_MANAGE_IFACE_FILTERS_REQUEST_SLI {
   union {
      struct { 
         u32 operation : 8;                       // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 strip_tunnel_header : 1;             // DWORD 0
         u32 tenant_id_present : 1;               // DWORD 0
         u32 vlan_tag_present : 1;                // DWORD 0
         u32 rsvd1 : 13;                          // DWORD 0
         UEXACT32 tunnel_iface_id;
         UEXACT32 target_iface_id;
         UEXACT8 mac_address[6];
         UEXACT16 vlan_tag;
         UEXACT32 tenant_id;
         UEXACT32 filter_id;
         UEXACT32 cap_flags;
         UEXACT32 cap_control_flags;
      } SG_PACK ; // unnamed struct
      u32 dw[9]; // dword union
   }; // unnamed union
} SG_PACK NTWK_MANAGE_IFACE_FILTERS_REQUEST_SLI, *PNTWK_MANAGE_IFACE_FILTERS_REQUEST_SLI;

SG_C_ASSERT(__sizeof__NTWK_MANAGE_IFACE_FILTERS_REQUEST, sizeof (NTWK_MANAGE_IFACE_FILTERS_REQUEST_SLI) == 36);



typedef struct _NTWK_MANAGE_IFACE_FILTERS_RESPONSE_SLI {
   UEXACT32 if_id;
   UEXACT32 filter_id;
   UEXACT32 rsvd0[7];
} SG_PACK NTWK_MANAGE_IFACE_FILTERS_RESPONSE_SLI, *PNTWK_MANAGE_IFACE_FILTERS_RESPONSE_SLI;




typedef struct _NTWK_MANAGE_IFACE_FILTERS_PARAMS_SLI {
   union {
      union { 
         NTWK_MANAGE_IFACE_FILTERS_REQUEST_SLI request;
         NTWK_MANAGE_IFACE_FILTERS_RESPONSE_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[9]; // dword union
   }; // unnamed union
} SG_PACK NTWK_MANAGE_IFACE_FILTERS_PARAMS_SLI, *PNTWK_MANAGE_IFACE_FILTERS_PARAMS_SLI;

SG_C_ASSERT(__sizeof__NTWK_MANAGE_IFACE_FILTERS_PARAMS, sizeof (NTWK_MANAGE_IFACE_FILTERS_PARAMS_SLI) == 36);



typedef struct _IOCTL_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         NTWK_MANAGE_IFACE_FILTERS_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[13]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI, *PIOCTL_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_MANAGE_IFACE_FILTERS, sizeof (IOCTL_COMMON_NTWK_MANAGE_IFACE_FILTERS_SLI) == 52);


// --- SUPPORTED_MODES ---
#define TOE_MODE_SLI                    (1)       
#define NIC_MODE_SLI                    (2)       
#define RDMA_MODE_SLI                   (4)       
#define VM_MODE_SLI                     (8)       
#define ISCSI_INI_MODE_SLI              (16)      
#define ISCSI_TGT_MODE_SLI              (32)      
#define FCOE_INI_MODE_SLI               (64)      
#define FCOE_TGT_MODE_SLI               (128)     
#define DAL_MODE_SLI                    (256)     
#define LRO_MODE_SLI                    (512)     
#define FLEX10_MODE_SLI                 (1024)    
#define QINQ_MODE_SLI                   (1024)    
#define NCSI_MODE_SLI                   (2048)    
#define DUA_MODE_SLI                    (2048)    
#define IPV6_MODE_SLI                   (4096)    
#define BE2_COMPAT_MODE_SLI             (8192)    
#define SRIOV_MODE_SLI                  (16384)   
#define INVALID_MODE_SLI                (32768)   
#define BE3_COMPAT_MODE_SLI             (65536)   
#define VNIC_MODE_SLI                   (131072)  
#define VNTAG_MODE_SLI                  (262144)  
#define UMC_MODE_SLI                    (524288)  
#define UMC_DEF_EN_SLI                  (1048576) 
#define ONE_GB_DEF_EN_SLI               (2097152) 
#define VNIC_DEF_VALID_SLI              (4194304) 
#define VNIC_DEF_EN_SLI                 (8388608) 
#define UMC_MODE_ENABLED_SLI            (16777216) 
#define SURF_MODE_ENABLED_SLI           (33554432) 

// --- SLI4_VH_CAPS_QUERY_TYPE_ENUM ---
#define SLI4_VH_CAPS_QUERY_SAVED_SLI    (0)       
#define SLI4_VH_CAPS_QUERY_DEFAULT_SLI  (1)       
#define SLI4_VH_CAPS_QUERY_RUNTIME_SLI  (2)       

// --- SLI4_RESC_DESC_TYPE_ENUM ---
#define SLI4_RESC_DESC_TYPE_PCIE_SLI    (80)      
#define SLI4_RESC_DESC_TYPE_NIC_SLI     (81)      
#define SLI4_RESC_DESC_TYPE_ISCSI_SLI   (82)      
#define SLI4_RESC_DESC_TYPE_FCOE_SLI    (83)      
#define SLI4_RESC_DESC_TYPE_RDMA_SLI    (84)      
#define SLI4_RESC_DESC_TYPE_PORT_SLI    (85)      
#define SLI4_RESC_DESC_TYPE_ISAP_SLI    (86)      

// --- SLI4_RESC_IMMEDIATE_STATE_ENUM ---
#define SLI4_RESC_IMM_STATE_NOT_TO_BE_APPLIED_SLI (0) 
#define SLI4_RESC_IMM_STATE_APPLIED_SLI (1)       

// --- SLI4_RESC_NOSV_ENUM ---
#define SLI4_RESC_NOSV_TO_BE_SAVED_SLI  (0)       
#define SLI4_RESC_NOSV_NOT_TO_BE_SAVED_SLI (1)    

// --- SLI4_RESC_SRIOV_STATE_ENUM ---
#define SLI4_RESC_SRIOV_STATE_DISABLED_SLI (0)    
#define SLI4_RESC_SRIOV_STATE_ENABLED_SLI (1)     
#define SLI4_RESC_SRIOV_STATE_PRESERVED_SLI (255) 

// --- SLI4_RESC_PF_STATE_ENUM ---
#define SLI4_RESC_PF_STATE_DISABLED_SLI (0)       
#define SLI4_RESC_PF_STATE_ENABLED_SLI  (1)       
#define SLI4_RESC_PF_STATE_PRESERVED_SLI (255)    

// --- SLI4_RESC_PF_TYPE_ENUM ---
#define SLI4_RESC_PF_FUNCTION_TYPE_NIC_SLI (1)    
#define SLI4_RESC_PF_FUNCTION_TYPE_ISCSI_SLI (2)  
#define SLI4_RESC_PF_FUNCTION_TYPE_FCOE_SLI (4)   
#define SLI4_RESC_PF_FUNCTION_TYPE_RDMA_SLI (8)   
#define SLI4_RESC_PF_FUNCTION_TYPE_FC_SLI (16)    
#define SLI4_RESC_PF_FUNCTION_TYPE_PRESERVED_SLI (255) 

// --- SLI4_RESC_PCHG_STATE_ENUM ---
#define SLI4_RESC_PCHG_STATE_CANNOT_BE_CHANGED_SLI (0) 
#define SLI4_RESC_PCHG_STATE_CAN_BE_CHANGED_SLI (1) 

// --- SLI4_RESC_SCHG_STATE_ENUM ---
#define SLI4_RESC_SCHG_STATE_CANNOT_BE_CHANGED_SLI (0) 
#define SLI4_RESC_SCHG_STATE_CAN_BE_CHANGED_SLI (1) 

// --- SLI4_RESC_XCHG_STATE_ENUM ---
#define SLI4_RESC_XCHG_STATE_CANNOT_BE_CHANGED_SLI (0) 
#define SLI4_RESC_XCHG_STATE_CAN_BE_CHANGED_SLI (1) 

// --- SLI4_RESC_XROM_RRES_SUPPORT_ENUM ---
#define SLI4_RESC_XROM_PRES_NOT_TO_BE_CHANGED_SLI (0) 
#define SLI4_RESC_XROM_PRES_NOT_ENABLED_SLI (1)   
#define SLI4_RESC_XROM_PRES_VISIBLE_SLI (2)       
#define SLI4_RESC_XROM_PRES_NOT_TO_BE_CHANGED_2_SLI (3) 

// --- SLI4_RESC_DELETE_STATE_ENUM ---
#define SLI4_RESC_NOT_BE_DELETED_SLI    (0)       
#define SLI4_RESC_TO_BE_DELETED_SLI     (1)       

// --- SLI4_RESC_PHYSICAL_LINK_TYPE_ENUM ---
#define SLI4_RESC_PHY_LINK_ETH_SLI      (0)       
#define SLI4_RESC_PHY_LINK_FC_SLI       (1)       
#define SLI4_RESC_PHY_PRESERVED_SLI     (3)       

// --- SLI4_RESC_LINK_MAPPING_CHANGE_CAPS_ENUM ---
#define SLI4_RESC_LINK_MAPPING_NOT_CHANGEABLE_SLI (0) 
#define SLI4_RESC_LINK_MAPPING_CHANGEABLE_SLI (1) 

// --- SLI4_RESC_LOGICAL_LINK_DISABLE_CAPS_ENUM ---
#define SLI4_RESC_LOGICAL_LINK_ENABLE_SLI (0)     
#define SLI4_RESC_LOGICAL_LINK_DISABLE_SLI (1)    

// --- SLI4_RESC_CHANNEL_ID_TYPE_ENUM ---
#define SLI4_RESC_CHANNEL_ID_SCID_SLI   (0)       
#define SLI4_RESC_CHANNEL_ID_SVID_SLI   (1)       
#define SLI4_RESC_CHANNEL_ID_INVALID_SLI (15)     

// --- SLI4_RESC_MULTI_CHANNEL_TYPE_ENUM ---
#define SLI4_RESC_MULTI_CHANNEL_NONE_SLI (0)      
#define SLI4_RESC_MULTI_CHANNEL_DISABLE_SLI (1)   
#define SLI4_RESC_MULTI_CHANNEL_UMC_ENABLED_SLI (2) 
#define SLI4_RESC_MULTI_CHANNEL_HP_FLEX10_ENABLED_SLI (3) 
#define SLI4_RESC_MULTI_CHANNEL_IBM_VNIC_ENABLED_SLI (4) 
#define SLI4_RESC_MULTI_CHANNEL_DELL_NPAR_ENABLED_SLI (5) 
#define SLI4_RESC_MULTI_CHANNEL_UFP_ENABLED_SLI (6) 
#define SLI4_RESC_MULTI_CHANNEL_IBM_VNIC2_ENABLED_SLI (7) 

// --- SLI4_RESC_NETWORK_VIRTUALIZATION_TYPE_ENUM ---
#define SLI4_RESC_NETWORK_VIRTUALIZATION_NONE_SLI (0) 
#define SLI4_RESC_NETWORK_VIRTUALIZATION_DISABLE_SLI (1) 
#define SLI4_RESC_NETWORK_VIRTUALIZATION_NVGRE_ENABLED_SLI (2) 
#define SLI4_RESC_NETWORK_VIRTUALIZATION_VXLAN_ENABLED_SLI (3) 

// --- SLI4_RESC_STRIP_OUTER_CHANNEL_VID_TYPE_ENUM ---
#define SLI4_RESC_SOCVID_RETAIN_SLI     (0)       
#define SLI4_RESC_SOCVID_STRIP_SLI      (1)       

// --- SLI4_RESC_STRIP_INNER_CHANNEL_VID_TYPE_ENUM ---
#define SLI4_RESC_SICVID_RETAIN_SLI     (0)       
#define SLI4_RESC_SICVID_STRIP_SLI      (1)       

// --- SLI4_RESC_REPORT_CHANNEL_VID_TYPE_ENUM ---
#define SLI4_RESC_RCVID_INNER_SLI       (0)       
#define SLI4_RESC_RCVID_OUTER_SLI       (1)       


typedef struct _SLI4_RESC_DESC_PCIE_SLI {
   union {
      struct { 
         u32 res_desc_type : 8;                   // DWORD 0
         u32 descriptor_length : 8;               // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 immediate : 1;                       // DWORD 0
         u32 no_save : 1;                         // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 1
         u32 pf_number : 10;                      // DWORD 1
         u32 rsvd2 : 6;                           // DWORD 1
         UEXACT32 rsvd3;
         UEXACT8 sriov_state;
         UEXACT8 pf_state;
         UEXACT8 pf_type;
         UEXACT8 rsvd4;
         UEXACT16 number_vfs;
         UEXACT16 rsvd5;
         u32 mission_roles : 8;                   // DWORD 5
         u32 rsvd6 : 19;                          // DWORD 5
         u32 presentation_chg : 1;                // DWORD 5
         u32 sriov_state_chg : 1;                 // DWORD 5
         u32 xrom_chg : 1;                        // DWORD 5
         u32 xrom : 2;                            // DWORD 5
         UEXACT32 rsvd7[16];
      } SG_PACK ; // unnamed struct
      u32 dw[22]; // dword union
   }; // unnamed union
} SG_PACK SLI4_RESC_DESC_PCIE_SLI, *PSLI4_RESC_DESC_PCIE_SLI;

SG_C_ASSERT(__sizeof__SLI4_RESC_DESC_PCIE, sizeof (SLI4_RESC_DESC_PCIE_SLI) == 88);



typedef struct _SLI4_RESC_DESC_NIC_SLI {
   union {
      struct { 
         u32 res_desc_type : 8;                   // DWORD 0
         u32 descriptor_length : 8;               // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 pf_pool : 1;                         // DWORD 0
         u32 logical_link_disable_valid : 1;      // DWORD 0
         u32 iface_caps_flags_valid : 1;          // DWORD 0
         u32 mac_addr_valid : 1;                  // DWORD 0
         u32 vlan_valid : 1;                      // DWORD 0
         u32 vf_template : 1;                     // DWORD 0
         u32 qos_units : 1;                       // DWORD 0
         u32 del : 1;                             // DWORD 0
         u32 immediate : 1;                       // DWORD 0
         u32 no_save : 1;                         // DWORD 0
         u32 vf_number : 8;                       // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
         u32 pf_number : 10;                      // DWORD 1
         u32 rsvd2 : 6;                           // DWORD 1
         UEXACT16 mac_unicast_count;
         UEXACT8 mac_address[6];
         UEXACT16 mq_count;
         UEXACT16 vlan_count;
         UEXACT16 mac_mcast_count;
         UEXACT16 wq_count;
         UEXACT16 rq_count;
         UEXACT16 rss_queue_count;
         UEXACT16 lro_queue_count;
         UEXACT16 cq_count;
         UEXACT16 toe_conn_count;
         UEXACT16 eq_count;
         UEXACT16 vlan_id;
         UEXACT16 iface_count;
         UEXACT32 iface_caps_flags;
         u32 link_number : 6;                     // DWORD 11
         u32 link_type : 2;                       // DWORD 11
         u32 lmc : 1;                             // DWORD 11
         u32 lld : 1;                             // DWORD 11
         u32 rsvd3 : 6;                           // DWORD 11
         u32 channel_id : 12;                     // DWORD 11
         u32 channel_id_type : 4;                 // DWORD 11
         UEXACT32 bw_min;
         UEXACT32 bw_max;
         u32 acpi_pattern_per_port : 8;           // DWORD 14
         u32 oob_wol : 2;                         // DWORD 14
         u32 wol : 2;                             // DWORD 14
         u32 rsvd4 : 20;                          // DWORD 14
         UEXACT16 tunnel_iface_count;
         UEXACT16 direct_tenant_iface_count;
         UEXACT16 roc_wq_count;
         UEXACT16 dpp_wq_count;
         UEXACT32 rsvd5[5];
      } SG_PACK ; // unnamed struct
      u32 dw[22]; // dword union
   }; // unnamed union
} SG_PACK SLI4_RESC_DESC_NIC_SLI, *PSLI4_RESC_DESC_NIC_SLI;

SG_C_ASSERT(__sizeof__SLI4_RESC_DESC_NIC, sizeof (SLI4_RESC_DESC_NIC_SLI) == 88);



typedef struct _SLI4_RESC_DESC_ISCSI_SLI {
   union {
      struct { 
         u32 res_desc_type : 8;                   // DWORD 0
         u32 descriptor_length : 8;               // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 logical_link_disable_valid : 1;      // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 mac_addr_valid : 1;                  // DWORD 0
         u32 vlan_valid : 1;                      // DWORD 0
         u32 vf_template : 1;                     // DWORD 0
         u32 qos_units : 1;                       // DWORD 0
         u32 del : 1;                             // DWORD 0
         u32 immediate : 1;                       // DWORD 0
         u32 no_save : 1;                         // DWORD 0
         u32 vf_number : 8;                       // DWORD 1
         u32 rsvd2 : 8;                           // DWORD 1
         u32 pf_number : 10;                      // DWORD 1
         u32 rsvd3 : 6;                           // DWORD 1
         UEXACT16 session_count;
         UEXACT16 icd_count;
         UEXACT16 cq_count;
         UEXACT8 iscsi_mac_address[6];
         UEXACT8 mq_count;
         UEXACT8 rsvd4;
         UEXACT16 vlan_id;
         UEXACT16 connection_count;
         UEXACT16 eq_count;
         UEXACT16 rbq_count;
         UEXACT16 vlan_count;
         u32 link_number : 6;                     // DWORD 8
         u32 link_type : 2;                       // DWORD 8
         u32 lmc : 1;                             // DWORD 8
         u32 lld : 1;                             // DWORD 8
         u32 rsvd5 : 6;                           // DWORD 8
         u32 channel_id : 12;                     // DWORD 8
         u32 channel_id_type : 4;                 // DWORD 8
         UEXACT32 bw_min;
         UEXACT32 bw_max;
         UEXACT32 iops_min;
         UEXACT32 iops_max;
         UEXACT32 rsvd6[9];
      } SG_PACK ; // unnamed struct
      u32 dw[22]; // dword union
   }; // unnamed union
} SG_PACK SLI4_RESC_DESC_ISCSI_SLI, *PSLI4_RESC_DESC_ISCSI_SLI;

SG_C_ASSERT(__sizeof__SLI4_RESC_DESC_ISCSI, sizeof (SLI4_RESC_DESC_ISCSI_SLI) == 88);



typedef struct _SLI4_RESC_DESC_FCOE_SLI {
   union {
      struct { 
         u32 res_desc_type : 8;                   // DWORD 0
         u32 descriptor_length : 8;               // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 logical_link_disable_valid : 1;      // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 macAddr_valid : 1;                   // DWORD 0
         u32 vlan_valid : 1;                      // DWORD 0
         u32 vf_template : 1;                     // DWORD 0
         u32 qos_units : 1;                       // DWORD 0
         u32 del : 1;                             // DWORD 0
         u32 immediate : 1;                       // DWORD 0
         u32 no_save : 1;                         // DWORD 0
         u32 vf_number : 8;                       // DWORD 1
         u32 rsvd2 : 8;                           // DWORD 1
         u32 pf_number : 10;                      // DWORD 1
         u32 rsvd3 : 6;                           // DWORD 1
         UEXACT16 rpi_count;
         UEXACT16 xri_count;
         UEXACT16 wq_count;
         UEXACT16 rq_count;
         UEXACT16 cq_count;
         UEXACT16 vpi_count;
         UEXACT16 fcfi_count;
         UEXACT16 vfi_count;
         UEXACT8 wwnn[8];
         UEXACT8 wwpn[8];
         u32 enode_mac[1];                        // DWORDS 10 to 10
         u32 enode_mac_end : 16;                  // DWORD 11
         u32 channel_id : 12;                     // DWORD 11
         u32 channel_id_type : 4;                 // DWORD 11
         UEXACT16 vlan_id;
         UEXACT16 rsvd4;
         u32 link_number : 6;                     // DWORD 13
         u32 link_type : 2;                       // DWORD 13
         u32 lmc : 1;                             // DWORD 13
         u32 lld : 1;                             // DWORD 13
         u32 rsvd5 : 6;                           // DWORD 13
         u32 eq_count : 16;                       // DWORD 13
         UEXACT32 bw_min;
         UEXACT32 bw_max;
         UEXACT32 iops_min;
         UEXACT32 iops_max;
         UEXACT32 rsvd6[4];
      } SG_PACK ; // unnamed struct
      u32 dw[22]; // dword union
   }; // unnamed union
} SG_PACK SLI4_RESC_DESC_FCOE_SLI, *PSLI4_RESC_DESC_FCOE_SLI;

SG_C_ASSERT(__sizeof__SLI4_RESC_DESC_FCOE, sizeof (SLI4_RESC_DESC_FCOE_SLI) == 88);



typedef struct _SLI4_RESC_DESC_RDMA_SLI {
   union {
      struct { 
         u32 res_desc_type : 8;                   // DWORD 0
         u32 descriptor_length : 8;               // DWORD 0
         u32 rsvd0 : 11;                          // DWORD 0
         u32 vf_template : 1;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 del : 1;                             // DWORD 0
         u32 immediate : 1;                       // DWORD 0
         u32 no_save : 1;                         // DWORD 0
         u32 vf_number : 8;                       // DWORD 1
         u32 rsvd2 : 8;                           // DWORD 1
         u32 pf_number : 10;                      // DWORD 1
         u32 rsvd3 : 6;                           // DWORD 1
         UEXACT32 max_qp;
         UEXACT16 max_pd;
         UEXACT16 max_mr;
         UEXACT16 max_mw;
         UEXACT16 max_fmr;
         UEXACT16 max_frmr;
         UEXACT16 max_mcast_group;
         UEXACT16 max_dpp_qp;
         UEXACT16 max_srq;
         UEXACT16 max_rpir_qp;
         UEXACT16 max_dpp_pd;
         UEXACT16 rsvd4;
         UEXACT16 max_dpp_credits;
         UEXACT32 rsvd5[13];
      } SG_PACK ; // unnamed struct
      u32 dw[22]; // dword union
   }; // unnamed union
} SG_PACK SLI4_RESC_DESC_RDMA_SLI, *PSLI4_RESC_DESC_RDMA_SLI;

SG_C_ASSERT(__sizeof__SLI4_RESC_DESC_RDMA, sizeof (SLI4_RESC_DESC_RDMA_SLI) == 88);



typedef struct _SLI4_RESC_DESC_PORT_SLI {
   union {
      struct { 
         u32 res_desc_type : 8;                   // DWORD 0
         u32 descriptor_length : 8;               // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 immediate : 1;                       // DWORD 0
         u32 no_save : 1;                         // DWORD 0
         u32 link_number : 6;                     // DWORD 1
         u32 link_type : 2;                       // DWORD 1
         u32 mc_type : 8;                         // DWORD 1
         u32 rsvd1 : 16;                          // DWORD 1
         u32 nv_type : 2;                         // DWORD 2
         u32 socvid : 1;                          // DWORD 2
         u32 sicvid : 1;                          // DWORD 2
         u32 rcvid : 1;                           // DWORD 2
         u32 dcbx_capability : 2;                 // DWORD 2
         u32 rsvd2 : 9;                           // DWORD 2
         u32 nv_port_protocol : 16;               // DWORD 2
         u32 max_pf_count : 12;                   // DWORD 3
         u32 rsvd3 : 4;                           // DWORD 3
         u32 max_storage_pf_count : 12;           // DWORD 3
         u32 rsvd4 : 4;                           // DWORD 3
         u32 max_nic_pf_count : 12;               // DWORD 4
         u32 rsvd5 : 4;                           // DWORD 4
         u32 max_roce_pf_count : 12;              // DWORD 4
         u32 rsvd6 : 4;                           // DWORD 4
         u32 max_iscsi_pf_count : 12;             // DWORD 5
         u32 rsvd7 : 4;                           // DWORD 5
         u32 max_fcoe_pf_count : 12;              // DWORD 5
         u32 rsvd8 : 4;                           // DWORD 5
         UEXACT32 rsvd9[16];
      } SG_PACK ; // unnamed struct
      u32 dw[22]; // dword union
   }; // unnamed union
} SG_PACK SLI4_RESC_DESC_PORT_SLI, *PSLI4_RESC_DESC_PORT_SLI;

SG_C_ASSERT(__sizeof__SLI4_RESC_DESC_PORT, sizeof (SLI4_RESC_DESC_PORT_SLI) == 88);



typedef struct _SLI4_RESC_DESC_ISAP_SLI {
   union {
      struct { 
         u32 res_desc_type : 8;                   // DWORD 0
         u32 descriptor_length : 8;               // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 iscsi_tgt : 1;                       // DWORD 1
         u32 iscsi_ini : 1;                       // DWORD 1
         u32 iscsi_DIF : 1;                       // DWORD 1
         u32 rsvd1 : 29;                          // DWORD 1
         UEXACT32 rsvd2[3];
         u32 fcoe_tgt : 1;                        // DWORD 5
         u32 fcoe_ini : 1;                        // DWORD 5
         u32 fcoe_DIF : 1;                        // DWORD 5
         u32 rsvd3 : 29;                          // DWORD 5
         UEXACT32 rsvd4[7];
         UEXACT8 MC_Type[4];
         UEXACT32 rsvd5[3];
      } SG_PACK ; // unnamed struct
      u32 dw[17]; // dword union
   }; // unnamed union
} SG_PACK SLI4_RESC_DESC_ISAP_SLI, *PSLI4_RESC_DESC_ISAP_SLI;

SG_C_ASSERT(__sizeof__SLI4_RESC_DESC_ISAP, sizeof (SLI4_RESC_DESC_ISAP_SLI) == 68);



typedef struct _GET_PROFILE_CONFIG_PARAMS_IN_SLI {
   union {
      struct { 
         u32 profile_id : 8;                      // DWORD 0
         u32 config_type : 2;                     // DWORD 0
         u32 census_mode : 1;                     // DWORD 0
         u32 rsvd0 : 21;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK GET_PROFILE_CONFIG_PARAMS_IN_SLI, *PGET_PROFILE_CONFIG_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__GET_PROFILE_CONFIG_PARAMS_IN, sizeof (GET_PROFILE_CONFIG_PARAMS_IN_SLI) == 4);



typedef struct _GET_PROFILE_CONFIG_PARAMS_OUT_SLI {
   union {
      struct { 
         UEXACT32 resource_descriptor_count;
         SLI4_RESC_DESC_PCIE_SLI resources[1];
      } SG_PACK ; // unnamed struct
      u32 dw[23]; // dword union
   }; // unnamed union
} SG_PACK GET_PROFILE_CONFIG_PARAMS_OUT_SLI, *PGET_PROFILE_CONFIG_PARAMS_OUT_SLI;

SG_C_ASSERT(__sizeof__GET_PROFILE_CONFIG_PARAMS_OUT, sizeof (GET_PROFILE_CONFIG_PARAMS_OUT_SLI) == 92);



typedef struct _GET_PROFILE_CONFIG_PARAMS_SLI {
   union {
      union { 
         GET_PROFILE_CONFIG_PARAMS_IN_SLI request;
         GET_PROFILE_CONFIG_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[23]; // dword union
   }; // unnamed union
} SG_PACK GET_PROFILE_CONFIG_PARAMS_SLI, *PGET_PROFILE_CONFIG_PARAMS_SLI;

SG_C_ASSERT(__sizeof__GET_PROFILE_CONFIG_PARAMS, sizeof (GET_PROFILE_CONFIG_PARAMS_SLI) == 92);



typedef struct _IOCTL_COMMON_GET_PROFILE_CONFIG_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         GET_PROFILE_CONFIG_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[27]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_GET_PROFILE_CONFIG_SLI, *PIOCTL_COMMON_GET_PROFILE_CONFIG_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PROFILE_CONFIG, sizeof (IOCTL_COMMON_GET_PROFILE_CONFIG_SLI) == 108);



typedef struct _SET_PROFILE_CONFIG_PARAMS_IN_SLI {
   union {
      struct { 
         u32 profile_id : 8;                      // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
         u32 ISAP : 1;                            // DWORD 0
         UEXACT32 resource_descriptor_count;
         SLI4_RESC_DESC_PCIE_SLI resources[1];
      } SG_PACK ; // unnamed struct
      u32 dw[24]; // dword union
   }; // unnamed union
} SG_PACK SET_PROFILE_CONFIG_PARAMS_IN_SLI, *PSET_PROFILE_CONFIG_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__SET_PROFILE_CONFIG_PARAMS_IN, sizeof (SET_PROFILE_CONFIG_PARAMS_IN_SLI) == 96);



typedef struct _SET_PROFILE_CONFIG_PARAMS_OUT_SLI {
   UEXACT32 rsvd0;
} SG_PACK SET_PROFILE_CONFIG_PARAMS_OUT_SLI, *PSET_PROFILE_CONFIG_PARAMS_OUT_SLI;




typedef struct _SET_PROFILE_CONFIG_PARAMS_SLI {
   union {
      union { 
         SET_PROFILE_CONFIG_PARAMS_IN_SLI request;
         SET_PROFILE_CONFIG_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[24]; // dword union
   }; // unnamed union
} SG_PACK SET_PROFILE_CONFIG_PARAMS_SLI, *PSET_PROFILE_CONFIG_PARAMS_SLI;

SG_C_ASSERT(__sizeof__SET_PROFILE_CONFIG_PARAMS, sizeof (SET_PROFILE_CONFIG_PARAMS_SLI) == 96);



typedef struct _IOCTL_COMMON_SET_PROFILE_CONFIG_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         SET_PROFILE_CONFIG_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[28]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_SET_PROFILE_CONFIG_SLI, *PIOCTL_COMMON_SET_PROFILE_CONFIG_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_PROFILE_CONFIG, sizeof (IOCTL_COMMON_SET_PROFILE_CONFIG_SLI) == 112);



typedef struct _GET_FUNCTION_CONFIG_PARAMS_IN_SLI {
   UEXACT32 rsvd0;
} SG_PACK GET_FUNCTION_CONFIG_PARAMS_IN_SLI, *PGET_FUNCTION_CONFIG_PARAMS_IN_SLI;




typedef struct _GET_FUNCTION_CONFIG_PARAMS_OUT_SLI {
   union {
      struct { 
         UEXACT32 resource_descriptor_count;
         SLI4_RESC_DESC_NIC_SLI resources[2];
      } SG_PACK ; // unnamed struct
      u32 dw[45]; // dword union
   }; // unnamed union
} SG_PACK GET_FUNCTION_CONFIG_PARAMS_OUT_SLI, *PGET_FUNCTION_CONFIG_PARAMS_OUT_SLI;

SG_C_ASSERT(__sizeof__GET_FUNCTION_CONFIG_PARAMS_OUT, sizeof (GET_FUNCTION_CONFIG_PARAMS_OUT_SLI) == 180);



typedef struct _GET_FUNCTION_CONFIG_PARAMS_SLI {
   union {
      union { 
         GET_FUNCTION_CONFIG_PARAMS_IN_SLI request;
         GET_FUNCTION_CONFIG_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[45]; // dword union
   }; // unnamed union
} SG_PACK GET_FUNCTION_CONFIG_PARAMS_SLI, *PGET_FUNCTION_CONFIG_PARAMS_SLI;

SG_C_ASSERT(__sizeof__GET_FUNCTION_CONFIG_PARAMS, sizeof (GET_FUNCTION_CONFIG_PARAMS_SLI) == 180);



typedef struct _IOCTL_COMMON_GET_FUNCTION_CONFIG_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         GET_FUNCTION_CONFIG_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[49]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_GET_FUNCTION_CONFIG_SLI, *PIOCTL_COMMON_GET_FUNCTION_CONFIG_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_FUNCTION_CONFIG, sizeof (IOCTL_COMMON_GET_FUNCTION_CONFIG_SLI) == 196);



typedef struct _SET_INTERRUPT_ENABLE_PARAMS_IN_SLI {
   union {
      struct { 
         u32 interrupts_enabled : 1;              // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK SET_INTERRUPT_ENABLE_PARAMS_IN_SLI, *PSET_INTERRUPT_ENABLE_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__SET_INTERRUPT_ENABLE_PARAMS_IN, sizeof (SET_INTERRUPT_ENABLE_PARAMS_IN_SLI) == 4);



typedef struct _SET_INTERRUPT_ENABLE_PARAMS_OUT_SLI {
   UEXACT32 rsvd0;
} SG_PACK SET_INTERRUPT_ENABLE_PARAMS_OUT_SLI, *PSET_INTERRUPT_ENABLE_PARAMS_OUT_SLI;




typedef struct _SET_INTERRUPT_ENABLE_PARAMS_SLI {
   union {
      union { 
         SET_INTERRUPT_ENABLE_PARAMS_IN_SLI request;
         SET_INTERRUPT_ENABLE_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK SET_INTERRUPT_ENABLE_PARAMS_SLI, *PSET_INTERRUPT_ENABLE_PARAMS_SLI;

SG_C_ASSERT(__sizeof__SET_INTERRUPT_ENABLE_PARAMS, sizeof (SET_INTERRUPT_ENABLE_PARAMS_SLI) == 4);



typedef struct _IOCTL_COMMON_SET_INTERRUPT_ENABLE_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         SET_INTERRUPT_ENABLE_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[5]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_SET_INTERRUPT_ENABLE_SLI, *PIOCTL_COMMON_SET_INTERRUPT_ENABLE_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_INTERRUPT_ENABLE, sizeof (IOCTL_COMMON_SET_INTERRUPT_ENABLE_SLI) == 20);


// --- SLI4_CAPS_DESC_TYPE_ENUM_V0 ---
#define SLI4_CAPS_DESC_TYPE_PCIE_V0_SLI (128)     
#define SLI4_CAPS_DESC_TYPE_NIC_V0_SLI  (129)     
#define SLI4_CAPS_DESC_TYPE_ISCSI_V0_SLI (130)    
#define SLI4_CAPS_DESC_TYPE_FCOE_V0_SLI (131)     
#define SLI4_CAPS_DESC_TYPE_RDMA_V0_SLI (132)     
#define SLI4_CAPS_DESC_TYPE_MR_V0_SLI   (240)     

// --- SLI4_CAPS_DESC_TYPE_ENUM ---
#define SLI4_CAPS_DESC_TYPE_PCIE_SLI    (144)     
#define SLI4_CAPS_DESC_TYPE_NIC_SLI     (145)     
#define SLI4_CAPS_DESC_TYPE_ISCSI_SLI   (146)     
#define SLI4_CAPS_DESC_TYPE_FCOE_SLI    (147)     
#define SLI4_CAPS_DESC_TYPE_RDMA_SLI    (148)     

// --- SLI4_CAPS_MISSION_ROLES_ENUM ---
#define SLI4_CAPS_MISSION_ROLES_NIC_TOE_SLI (1)   
#define SLI4_CAPS_MISSION_ROLES_ISCSI_SLI (2)     
#define SLI4_CAPS_MISSION_ROLES_FCOE_SLI (4)      
#define SLI4_CAPS_MISSION_ROLES_NIC_TOE_RDMA_SLI (8) 
#define SLI4_CAPS_MISSION_ROLES_FC_SLI  (16)      
#define SLI4_CAPS_MISSION_ROLES_PRESERVED_SLI (255) 


typedef struct _SLI4_CAPS_DESC_HEADER_SLI {
   UEXACT8 caps_desc_type;
   UEXACT8 descriptor_length;
   UEXACT8 rsvd0[2];
} SG_PACK SLI4_CAPS_DESC_HEADER_SLI, *PSLI4_CAPS_DESC_HEADER_SLI;




typedef struct _SLI4_CAPS_DESC_PCIE_SLI {
   SLI4_CAPS_DESC_HEADER_SLI capHeader;
   UEXACT8 max_pf_num;
   UEXACT8 rsvd0;
   UEXACT8 mission_roles;
   UEXACT8 rsvd1;
   UEXACT16 total_func;
   UEXACT16 rsvd2;
   UEXACT32 rsvd3[7];
} SG_PACK SLI4_CAPS_DESC_PCIE_SLI, *PSLI4_CAPS_DESC_PCIE_SLI;




typedef struct _SLI4_CAPS_DESC_NIC_SLI {
   union {
      struct { 
         SLI4_CAPS_DESC_HEADER_SLI capHeader;
         UEXACT16 uc_count;
         UEXACT16 vlan_count;
         UEXACT16 rq_count;
         UEXACT16 rss_rq_count;
         UEXACT16 cq_count;
         UEXACT16 wq_count;
         UEXACT16 mq_count;
         UEXACT16 eq_count;
         u32 max_function_count : 16;             // DWORD 5
         u32 wamode : 1;                          // DWORD 5
         u32 rsvd0 : 15;                          // DWORD 5
         UEXACT32 iface_caps_flags;
         UEXACT8 acpi_patterns_total;
         UEXACT8 nd_dip_total;
         UEXACT8 arp_dip_total;
         UEXACT8 rsvd1;
         UEXACT16 iface_count;
         UEXACT16 tunnel_iface_count;
         UEXACT16 roc_wq_count;
         UEXACT16 dpp_wq_count;
      } SG_PACK ; // unnamed struct
      u32 dw[10]; // dword union
   }; // unnamed union
} SG_PACK SLI4_CAPS_DESC_NIC_SLI, *PSLI4_CAPS_DESC_NIC_SLI;

SG_C_ASSERT(__sizeof__SLI4_CAPS_DESC_NIC, sizeof (SLI4_CAPS_DESC_NIC_SLI) == 40);



typedef struct _SLI4_CAPS_DESC_ISCSI_SLI {
   union {
      struct { 
         SLI4_CAPS_DESC_HEADER_SLI capHeader;
         UEXACT16 session_count;
         UEXACT16 icd_count;
         UEXACT16 cq_count;
         UEXACT16 connection_count;
         UEXACT16 eq_count;
         UEXACT16 rbq_count;
         UEXACT16 rsvd0;
         UEXACT16 icd_alloc_units;
         u32 max_function_count : 16;             // DWORD 5
         u32 target : 1;                          // DWORD 5
         u32 initiator : 1;                       // DWORD 5
         u32 DIF : 1;                             // DWORD 5
         u32 rsvd1 : 13;                          // DWORD 5
         UEXACT32 rsvd2[4];
      } SG_PACK ; // unnamed struct
      u32 dw[10]; // dword union
   }; // unnamed union
} SG_PACK SLI4_CAPS_DESC_ISCSI_SLI, *PSLI4_CAPS_DESC_ISCSI_SLI;

SG_C_ASSERT(__sizeof__SLI4_CAPS_DESC_ISCSI, sizeof (SLI4_CAPS_DESC_ISCSI_SLI) == 40);



typedef struct _SLI4_CAPS_DESC_FCOE_SLI {
   union {
      struct { 
         SLI4_CAPS_DESC_HEADER_SLI capHeader;
         UEXACT16 xri_count;
         UEXACT16 xri_alloc_units;
         UEXACT16 rpi_count;
         UEXACT16 rpi_alloc_units;
         UEXACT16 vpi_count;
         UEXACT16 vpi_alloc_units;
         UEXACT16 vfi_count;
         UEXACT16 vfi_alloc_units;
         UEXACT16 max_function_count;
         UEXACT16 eq_count;
         UEXACT16 wq_count;
         UEXACT16 cq_count;
         UEXACT16 rq_count;
         UEXACT16 fcfi_count;
         u32 rsvd0 : 16;                          // DWORD 8
         u32 target : 1;                          // DWORD 8
         u32 initiator : 1;                       // DWORD 8
         u32 DIF : 1;                             // DWORD 8
         u32 rsvd1 : 13;                          // DWORD 8
         UEXACT32 rsvd2;
      } SG_PACK ; // unnamed struct
      u32 dw[10]; // dword union
   }; // unnamed union
} SG_PACK SLI4_CAPS_DESC_FCOE_SLI, *PSLI4_CAPS_DESC_FCOE_SLI;

SG_C_ASSERT(__sizeof__SLI4_CAPS_DESC_FCOE, sizeof (SLI4_CAPS_DESC_FCOE_SLI) == 40);



typedef struct _SLI4_CAPS_DESC_RDMA_SLI {
   SLI4_CAPS_DESC_HEADER_SLI capHeader;
   UEXACT32 max_qp;
   UEXACT16 max_pd;
   UEXACT16 max_mr;
   UEXACT16 max_mw;
   UEXACT16 max_fmr;
   UEXACT16 max_frmr;
   UEXACT16 max_mcast_group;
   UEXACT16 max_dpp_qp;
   UEXACT16 max_srq;
   UEXACT16 max_rpir_qp;
   UEXACT16 max_dpp_pd;
   UEXACT16 max_dpp_qp_per_pd;
   UEXACT16 max_dpp_credits;
   UEXACT32 rsvd0[2];
} SG_PACK SLI4_CAPS_DESC_RDMA_SLI, *PSLI4_CAPS_DESC_RDMA_SLI;




typedef struct _GET_PROFILE_CAPACITIES_PARAMS_IN_SLI {
   UEXACT8 profile_id;
   UEXACT8 rsvd0[3];
} SG_PACK GET_PROFILE_CAPACITIES_PARAMS_IN_SLI, *PGET_PROFILE_CAPACITIES_PARAMS_IN_SLI;




typedef struct _GET_PROFILE_CAPACITIES_PARAMS_OUT_SLI {
   UEXACT32 capacity_descriptor_count;
   SLI4_CAPS_DESC_PCIE_SLI capacity_descriptor[1];
} SG_PACK GET_PROFILE_CAPACITIES_PARAMS_OUT_SLI, *PGET_PROFILE_CAPACITIES_PARAMS_OUT_SLI;




typedef union _GET_PROFILE_CAPACITIES_PARAMS_SLI {
   GET_PROFILE_CAPACITIES_PARAMS_IN_SLI request;
   GET_PROFILE_CAPACITIES_PARAMS_OUT_SLI response;
} SG_PACK GET_PROFILE_CAPACITIES_PARAMS_SLI, *PGET_PROFILE_CAPACITIES_PARAMS_SLI;




typedef struct _IOCTL_COMMON_GET_PROFILE_CAPACITIES_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         GET_PROFILE_CAPACITIES_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[15]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_GET_PROFILE_CAPACITIES_SLI, *PIOCTL_COMMON_GET_PROFILE_CAPACITIES_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PROFILE_CAPACITIES, sizeof (IOCTL_COMMON_GET_PROFILE_CAPACITIES_SLI) == 60);



typedef struct _SLI4_PROFILE_DESC_SLI {
   UEXACT8 profile_id;
   UEXACT8 rsvd0;
   UEXACT8 profile_index;
   UEXACT8 rsvd1;
   UEXACT32 profile_description_string[128];
} SG_PACK SLI4_PROFILE_DESC_SLI, *PSLI4_PROFILE_DESC_SLI;




typedef struct _GET_PROFILE_PARAMS_LIST_IN_SLI {
   UEXACT8 start_profile_index;
   UEXACT8 rsvd0[3];
} SG_PACK GET_PROFILE_PARAMS_LIST_IN_SLI, *PGET_PROFILE_PARAMS_LIST_IN_SLI;




typedef struct _GET_PROFILE_LIST_PARAMS_OUT_SLI {
   UEXACT32 profile_descriptor_count;
   SLI4_PROFILE_DESC_SLI profile_descriptor[1];
} SG_PACK GET_PROFILE_LIST_PARAMS_OUT_SLI, *PGET_PROFILE_LIST_PARAMS_OUT_SLI;




typedef union _GET_PROFILE_LIST_PARAMS_SLI {
   GET_PROFILE_PARAMS_LIST_IN_SLI request;
   GET_PROFILE_LIST_PARAMS_OUT_SLI response;
} SG_PACK GET_PROFILE_LIST_PARAMS_SLI, *PGET_PROFILE_LIST_PARAMS_SLI;




typedef struct _IOCTL_COMMON_GET_PROFILE_LIST_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         GET_PROFILE_LIST_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[134]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_GET_PROFILE_LIST_SLI, *PIOCTL_COMMON_GET_PROFILE_LIST_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PROFILE_LIST, sizeof (IOCTL_COMMON_GET_PROFILE_LIST_SLI) == 536);



typedef struct _SET_ACTIVE_PROFILE_PARAMS_IN_SLI {
   union {
      struct { 
         u32 active_profile_id : 8;               // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
         u32 factory_default : 1;                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK SET_ACTIVE_PROFILE_PARAMS_IN_SLI, *PSET_ACTIVE_PROFILE_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__SET_ACTIVE_PROFILE_PARAMS_IN, sizeof (SET_ACTIVE_PROFILE_PARAMS_IN_SLI) == 4);



typedef struct _SET_ACTIVE_PROFILE_PARAMS_OUT_SLI {
   UEXACT32 rsvd0;
} SG_PACK SET_ACTIVE_PROFILE_PARAMS_OUT_SLI, *PSET_ACTIVE_PROFILE_PARAMS_OUT_SLI;




typedef struct _SET_ACTIVE_PROFILE_PARAMS_SLI {
   union {
      union { 
         SET_ACTIVE_PROFILE_PARAMS_IN_SLI request;
         SET_ACTIVE_PROFILE_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK SET_ACTIVE_PROFILE_PARAMS_SLI, *PSET_ACTIVE_PROFILE_PARAMS_SLI;

SG_C_ASSERT(__sizeof__SET_ACTIVE_PROFILE_PARAMS, sizeof (SET_ACTIVE_PROFILE_PARAMS_SLI) == 4);



typedef struct _IOCTL_COMMON_SET_ACTIVE_PROFILE_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         SET_ACTIVE_PROFILE_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[5]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_SET_ACTIVE_PROFILE_SLI, *PIOCTL_COMMON_SET_ACTIVE_PROFILE_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_ACTIVE_PROFILE, sizeof (IOCTL_COMMON_SET_ACTIVE_PROFILE_SLI) == 20);


// --- CAPABILITIES ---
#define UMC_CAPABLE_SLI                 (1)       
#define SRIOV_CAPABLE_SLI               (2)       
#define VNTAG_CAPABLE_SLI               (4)       
#define NPAR_CAPABLE_SLI                (8)       
#define VNIC1_CAPABLE_SLI               (16)      
#define VNIC2_CAPABLE_SLI               (32)      
#define UFP_CAPABLE_SLI                 (64)      
#define PORT_RECONFIG_CAPABLE_SLI       (2147483648) 

// --- SWITCH_TYPE ---
#define ST_Normal_SLI                   (0)       
#define ST_VNIC_SLI                     (1)       
#define ST_VNTAG_SLI                    (2)       
#define ST_QBG_SLI                      (3)       
#define ST_UFP_SLI                      (4)       
#define ST_1x40G_4x10G_SLI              (2147483648) 


typedef union _IOCTL_COMMON_GET_CAPABILITY_PARAMS_SLI {
   struct {
      UEXACT32 rsvd0;
   } request;
   struct {
      UEXACT32 capabilities;
      UEXACT32 switch_type;
      UEXACT32 rsvd0;
   } response;
} SG_PACK IOCTL_COMMON_GET_CAPABILITY_PARAMS_SLI, *PIOCTL_COMMON_GET_CAPABILITY_PARAMS_SLI;




typedef struct _IOCTL_COMMON_GET_CAPABILITY_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         IOCTL_COMMON_GET_CAPABILITY_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[7]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_GET_CAPABILITY_SLI, *PIOCTL_COMMON_GET_CAPABILITY_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CAPABILITY, sizeof (IOCTL_COMMON_GET_CAPABILITY_SLI) == 28);


// --- ULP_SUPPORTED_MODES ---
#define ULP_TOE_MODE_SLI                (1)       
#define ULP_NIC_MODE_SLI                (2)       
#define ULP_RDMA_MODE_SLI               (4)       
#define ULP_ISCSI_INI_MODE_SLI          (16)      
#define ULP_ISCSI_TGT_MODE_SLI          (32)      
#define ULP_FCOE_INI_MODE_SLI           (64)      
#define ULP_FCOE_TGT_MODE_SLI           (128)     
#define ULP_DAL_MODE_SLI                (256)     
#define ULP_LRO_MODE_SLI                (512)     


typedef struct _BE_ULP_FW_CFG_SLI {
   UEXACT32 ulp_mode;
   UEXACT32 etx_base;
   UEXACT32 etx_count;
   UEXACT32 sq_base;
   UEXACT32 sq_count;
   UEXACT32 rq_base;
   UEXACT32 rq_count;
   UEXACT32 dq_base;
   UEXACT32 dq_count;
   UEXACT32 lro_base;
   UEXACT32 lro_count;
   UEXACT32 icd_base;
   UEXACT32 icd_count;
} SG_PACK BE_ULP_FW_CFG_SLI, *PBE_ULP_FW_CFG_SLI;



// --- ASIC_REV_ENUM ---
#define ASIC_REV_A0_SLI                 (0)       
#define ASIC_REV_A1_SLI                 (1)       
#define ASIC_REV_A2_SLI                 (2)       
#define ASIC_REV_A3_SLI                 (3)       
#define ASIC_REV_R_SLI                  (16)      

// --- ASIC_GEN_ENUM ---
#define ASIC_GEN_BE2_SLI                (0)       
#define ASIC_GEN_BE3_SLI                (3)       
#define ASIC_GEN_SH_SLI                 (4)       
#define ASIC_GEN_CORSAIR_SLI            (5)       
#define ASIC_GEN_LANCER_SLI             (8)       

// --- BE_FUNCTION_CAPS ---
#define BE_FUNCTION_CAPS_UNCLASSIFIED_STATS_SLI (1) 
#define BE_FUNCTION_CAPS_RSS_SLI        (2)       
#define BE_FUNCTION_CAPS_PROMISCUOUS_SLI (4)      
#define BE_FUNCTION_CAPS_LEGACY_MODE_SLI (8)      
#define BE_FUNCTION_CAPS_SHARED_IP_SLI  (16)      
#define FUNCTION_CAPS_MULTI_CHANNEL_SLI (32)      
#define FUNCTION_CAPS_SUPER_NIC_SLI     (64)      


typedef struct _BE_ULP_CHAIN_ICD_SLI {
   UEXACT32 chain_base;
   UEXACT32 chain_count;
} SG_PACK BE_ULP_CHAIN_ICD_SLI, *PBE_ULP_CHAIN_ICD_SLI;




typedef struct _BE_FW_CFG_SLI {
   UEXACT32 be_config_number;
   UEXACT32 asic_revision;
   UEXACT32 phys_port;
   UEXACT32 function_mode;
   BE_ULP_FW_CFG_SLI ulp[2];
   UEXACT32 function_caps;
   UEXACT32 cqid_base;
   UEXACT32 cqid_count;
   UEXACT32 eqid_base;
   UEXACT32 eqid_count;
   BE_ULP_CHAIN_ICD_SLI ulp_chain_icd[2];
} SG_PACK BE_FW_CFG_SLI, *PBE_FW_CFG_SLI;




typedef struct _IOCTL_COMMON_QUERY_FIRMWARE_CONFIG_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         union {
            struct {
               UEXACT32 rsvd0;
            } request;
            BE_FW_CFG_SLI response;
         } params;
      } SG_PACK ; // unnamed struct
      u32 dw[43]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_QUERY_FIRMWARE_CONFIG_SLI, *PIOCTL_COMMON_QUERY_FIRMWARE_CONFIG_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_FIRMWARE_CONFIG, sizeof (IOCTL_COMMON_QUERY_FIRMWARE_CONFIG_SLI) == 172);


// --- NTWK_PHYS_PORT ---
#define NTWK_PORT_A_SLI                 (0)       
#define NTWK_PORT_B_SLI                 (1)       
#define NTWK_PORT_C_SLI                 (2)       
#define NTWK_PORT_D_SLI                 (3)       

// --- NTWK_MAC_LINK_SPEED ---
#define SPEED_DEFAULT_SLI               (0)       
#define SPEED_FORCED_10GB_SLI           (1)       
#define SPEED_FORCED_1GB_SLI            (2)       
#define SPEED_AUTONEG_10GB_SLI          (3)       
#define SPEED_AUTONEG_1GB_SLI           (4)       
#define SPEED_AUTONEG_100MB_SLI         (5)       
#define SPEED_AUTONEG_10GB_1GB_SLI      (6)       
#define SPEED_AUTONEG_10GB_1GB_100MB_SLI (7)      
#define SPEED_AUTONEG_1GB_100MB_SLI     (8)       
#define SPEED_AUTONEG_10MB_SLI          (9)       
#define SPEED_AUTONEG_1GB_100MB_10MB_SLI (10)     
#define SPEED_AUTONEG_100MB_10MB_SLI    (11)      
#define SPEED_FORCED_100MB_SLI          (12)      
#define SPEED_FORCED_10MB_SLI           (13)      
#define SPEED_FORCED_40G_SLI            (14)      
#define SPEED_AUTONEG_40G_SLI           (15)      


typedef struct _GET_LINK_SPEED_PARAMS_IN_SLI {
   union {
      struct { 
         u32 physical_port : 6;                   // DWORD 0
         u32 pt : 2;                              // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK GET_LINK_SPEED_PARAMS_IN_SLI, *PGET_LINK_SPEED_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__GET_LINK_SPEED_PARAMS_IN, sizeof (GET_LINK_SPEED_PARAMS_IN_SLI) == 4);



typedef struct _GET_LINK_SPEED_PARAMS_OUT_SLI {
   u16 mac_speed;
   u16 dac_cable_length;
} SG_PACK GET_LINK_SPEED_PARAMS_OUT_SLI, *PGET_LINK_SPEED_PARAMS_OUT_SLI;




typedef struct _GET_LINK_SPEED_PARAMS_SLI {
   union {
      union { 
         GET_LINK_SPEED_PARAMS_IN_SLI request;
         GET_LINK_SPEED_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK GET_LINK_SPEED_PARAMS_SLI, *PGET_LINK_SPEED_PARAMS_SLI;

SG_C_ASSERT(__sizeof__GET_LINK_SPEED_PARAMS, sizeof (GET_LINK_SPEED_PARAMS_SLI) == 4);



typedef struct _IOCTL_COMMON_NTWK_GET_LINK_SPEED_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         GET_LINK_SPEED_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[5]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_NTWK_GET_LINK_SPEED_SLI, *PIOCTL_COMMON_NTWK_GET_LINK_SPEED_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_GET_LINK_SPEED, sizeof (IOCTL_COMMON_NTWK_GET_LINK_SPEED_SLI) == 20);


// --- PCI_BAR_REGISTER_ENUM ---
#define PCI_BAR_REGISTER_0_SLI          (0)       
#define PCI_BAR_REGISTER_1_SLI          (1)       
#define PCI_BAR_REGISTER_2_SLI          (2)       

// --- DOORBELL_FORMAT_ENUM ---
#define DOORBELL_FORMAT_LIST_SLI        (1)       
#define DOORBELL_FORMAT_RING_SLI        (2)       

// --- BE_ULP_NUM ---
#define BE_ULP0_NUM_SLI                 (0)       
#define BE_ULP1_NUM_SLI                 (1)       

// --- BE_ULP_MASK ---
#define BE_ULP0_MASK_SLI                (1)       
#define BE_ULP1_MASK_SLI                (2)       


typedef struct _ISCSI_WRBQ_CREATE_PARAMS_OUT_SLI {
   u16 cid;
   u8 rsvd0;
   u8 ulp_num;
   u32 doorbell_offset;
   u16 pci_register_set;
   u16 doorbell_format;
} SG_PACK ISCSI_WRBQ_CREATE_PARAMS_OUT_SLI, *PISCSI_WRBQ_CREATE_PARAMS_OUT_SLI;




typedef struct _ISCSI_WRBQ_CREATE_PARAMS_IN_SLI {
   union {
      struct { 
         u32 num_pages : 16;                      // DWORD 0
         u32 ulp_num : 8;                         // DWORD 0
         u32 dual_ulp_aware : 1;                  // DWORD 0
         u32 bind_q_to_ulp : 1;                   // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         PHYS_ADDR_SLI pages[8];
      } SG_PACK ; // unnamed struct
      u32 dw[17]; // dword union
   }; // unnamed union
} SG_PACK ISCSI_WRBQ_CREATE_PARAMS_IN_SLI, *PISCSI_WRBQ_CREATE_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__ISCSI_WRBQ_CREATE_PARAMS_IN, sizeof (ISCSI_WRBQ_CREATE_PARAMS_IN_SLI) == 68);



typedef struct _ISCSI_WRBQ_CREATE_PARAMS_SLI {
   union {
      union { 
         ISCSI_WRBQ_CREATE_PARAMS_IN_SLI request;
         ISCSI_WRBQ_CREATE_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[17]; // dword union
   }; // unnamed union
} SG_PACK ISCSI_WRBQ_CREATE_PARAMS_SLI, *PISCSI_WRBQ_CREATE_PARAMS_SLI;

SG_C_ASSERT(__sizeof__ISCSI_WRBQ_CREATE_PARAMS, sizeof (ISCSI_WRBQ_CREATE_PARAMS_SLI) == 68);



typedef struct _IOCTL_COMMON_ISCSI_WRBQ_CREATE_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         ISCSI_WRBQ_CREATE_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[21]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_ISCSI_WRBQ_CREATE_SLI, *PIOCTL_COMMON_ISCSI_WRBQ_CREATE_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_ISCSI_WRBQ_CREATE, sizeof (IOCTL_COMMON_ISCSI_WRBQ_CREATE_SLI) == 84);



typedef struct _ISCSI_DEFQ_CONTEXT_SLI {
   union {
      struct { 
         u32 rsvd0 : 16;                          // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 rsvd1 : 12;                          // DWORD 0
         u32 rsvd2 : 22;                          // DWORD 1
         u32 rx_pdid : 9;                         // DWORD 1
         u32 rx_pdid_valid : 1;                   // DWORD 1
         UEXACT16 default_buffer_size;
         UEXACT16 cq_id_recv;
         u32 rsvd3[1];                            // DWORDS 3 to 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ISCSI_DEFQ_CONTEXT_SLI, *PISCSI_DEFQ_CONTEXT_SLI;

SG_C_ASSERT(__sizeof__ISCSI_DEFQ_CONTEXT, sizeof (ISCSI_DEFQ_CONTEXT_SLI) == 16);



typedef struct _ISCSI_DEFQ_CREATE_PARAMS_IN_SLI {
   union {
      struct { 
         u32 num_pages : 16;                      // DWORD 0
         u32 ulp_num : 8;                         // DWORD 0
         u32 dual_ulp_aware : 1;                  // DWORD 0
         u32 bind_q_to_ulp : 1;                   // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         ISCSI_DEFQ_CONTEXT_SLI context;
         PHYS_ADDR_SLI pages[8];
      } SG_PACK ; // unnamed struct
      u32 dw[21]; // dword union
   }; // unnamed union
} SG_PACK ISCSI_DEFQ_CREATE_PARAMS_IN_SLI, *PISCSI_DEFQ_CREATE_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__ISCSI_DEFQ_CREATE_PARAMS_IN, sizeof (ISCSI_DEFQ_CREATE_PARAMS_IN_SLI) == 84);



typedef struct _ISCSI_DEFQ_CREATE_PARAMS_OUT_SLI {
   u16 id;
   u8 rsvd0;
   u8 ulp_num;
   u32 doorbell_offset;
   u16 pci_register_set;
   u16 doorbell_format;
} SG_PACK ISCSI_DEFQ_CREATE_PARAMS_OUT_SLI, *PISCSI_DEFQ_CREATE_PARAMS_OUT_SLI;




typedef struct _ISCSI_DEFQ_CREATE_PARAMS_SLI {
   union {
      union { 
         ISCSI_DEFQ_CREATE_PARAMS_IN_SLI request;
         ISCSI_DEFQ_CREATE_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[21]; // dword union
   }; // unnamed union
} SG_PACK ISCSI_DEFQ_CREATE_PARAMS_SLI, *PISCSI_DEFQ_CREATE_PARAMS_SLI;

SG_C_ASSERT(__sizeof__ISCSI_DEFQ_CREATE_PARAMS, sizeof (ISCSI_DEFQ_CREATE_PARAMS_SLI) == 84);



typedef struct _IOCTL_COMMON_ISCSI_DEFQ_CREATE_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         ISCSI_DEFQ_CREATE_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[25]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_ISCSI_DEFQ_CREATE_SLI, *PIOCTL_COMMON_ISCSI_DEFQ_CREATE_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_ISCSI_DEFQ_CREATE, sizeof (IOCTL_COMMON_ISCSI_DEFQ_CREATE_SLI) == 100);



typedef struct _IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         union {
            struct {
               UEXACT16 icd_start;
               UEXACT16 icd_count;
               PHYS_ADDR_SLI pages[1];
            } request;
            struct {
               UEXACT32 rsvd0;
            } response;
         } params;
      } SG_PACK ; // unnamed struct
      u32 dw[7]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1_SLI, *PIOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1, sizeof (IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1_SLI) == 28);


// --- SG_WORKAROUND ---
#define SUBSYSTEM_COMMON_CQ_CREATE_V2_SLI (1)     
#define OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1_SLI (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1_SLI (2) 
#define SUBSYSTEM_ETH_TX_CREATE_V2_SLI  (3)       
#define SUBSYSTEM_ETH_RX_CREATE_V2_SLI  (3)       
#define SUBSYSTEM_ETH_RX_DESTROY_V1_SLI (3)       
#define OPCODE_ETH_TX_CREATE_V2_SLI     (7)       
#define OPCODE_ETH_RX_CREATE_V2_SLI     (8)       
#define OPCODE_ETH_RX_DESTROY_V1_SLI    (10)      
#define OPCODE_COMMON_CQ_CREATE_V2_SLI  (12)      

// --- SUPPORTED_SPEEDS_BMAP ---
#define SUPPORTED_SPEED_NONE_SLI        (0)       
#define SUPPORTED_SPEED_10MBPS_SLI      (1)       
#define SUPPORTED_SPEED_100MBPS_SLI     (2)       
#define SUPPORTED_SPEED_1GBPS_SLI       (4)       
#define SUPPORTED_SPEED_10GBPS_SLI      (8)       
#define SUPPORTED_SPEED_20GBPS_SLI      (16)      
#define SUPPORTED_SPEED_40GBPS_SLI      (32)      

// --- CWM_CTRL_ENUM ---
#define MOD_CQ_DIS_WM_COALESC_INVD_SLI  (0)       
#define MOD_CQ_DIS_WM_COALESC_VALID_SLI (1)       
#define MOD_CQ_EN_WM_COALESC_INVD_SLI   (2)       
#define MOD_CQ_EN_WM_COALESC_VALID_SLI  (3)       


typedef struct _IOCTL_COMMON_MODIFY_CQ_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         union {
            struct {
               u32 cq_id : 16;                    // DWORD 4
               u32 rsvd0 : 13;                    // DWORD 4
               u32 cwm_ctrl : 2;                  // DWORD 4
               u32 eq_id_valid : 1;               // DWORD 4
               u8 coalesc_cwm;
               u8 rsvd1;
               u16 eq_id;
            } request;
            struct {
               u32 rsvd0;
            } response;
         } params;
      } SG_PACK ; // unnamed struct
      u32 dw[6]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_MODIFY_CQ_SLI, *PIOCTL_COMMON_MODIFY_CQ_SLI;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_MODIFY_CQ, sizeof (IOCTL_COMMON_MODIFY_CQ_SLI) == 24);



typedef struct _ASYNC_EVENT_TRAILER_SLI {
   union {
      struct { 
         u32 rsvd0 : 8;                           // DWORD 0
         u32 event_code : 8;                      // DWORD 0
         u32 event_type : 8;                      // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
         u32 async_event : 1;                     // DWORD 0
         u32 valid : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK ASYNC_EVENT_TRAILER_SLI, *PASYNC_EVENT_TRAILER_SLI;

SG_C_ASSERT(__sizeof__ASYNC_EVENT_TRAILER, sizeof (ASYNC_EVENT_TRAILER_SLI) == 4);


// --- ASYNC_GRP_5_EVENTS ---
#define ASYNC_GRP_5_EVENT_QOS_SPEED_SLI (1)       
#define ASYNC_GRP_5_EVENT_COS_PRIORITY_SLI (2)    
#define ASYNC_GRP_5_EVENT_PVID_STATE_SLI (3)      
#define ASYNC_GRP_5_EVENT_PRIORITY_CLASS_QUEUE_MAP_SLI (4) 
#define ASYNC_GRP_5_EVENT_SHARED_VLAN_SLI (5)     
#define ASYNC_GRP_5_EVENT_DEBUG_DATA_SLI (6)      


typedef struct _ASYNC_EVENT_GRP_5_SHARED_VLAN_SLI {
   union {
      struct { 
         u32 learn_enable : 1;                    // DWORD 0
         u32 learn_disable : 1;                   // DWORD 0
         u32 mgmt_enable : 1;                     // DWORD 0
         u32 mgmt_disable : 1;                    // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 vlan_tag : 16;                       // DWORD 0
         u32 bcast_filt_arp : 1;                  // DWORD 1
         u32 bcast_filt_dhcp_client : 1;          // DWORD 1
         u32 bcast_filt_dhcp_server : 1;          // DWORD 1
         u32 bcast_filt_netbios : 1;              // DWORD 1
         u32 rsvd1 : 3;                           // DWORD 1
         u32 bcast_enable : 1;                    // DWORD 1
         u32 mcast_ipv6_nbr : 1;                  // DWORD 1
         u32 mcast_ipv6_ra : 1;                   // DWORD 1
         u32 mcast_ipv6_dhcp6 : 1;                // DWORD 1
         u32 rsvd2 : 4;                           // DWORD 1
         u32 mcast_enable : 1;                    // DWORD 1
         u32 rsvd3 : 16;                          // DWORD 1
         UEXACT32 event_tag;
         ASYNC_EVENT_TRAILER_SLI trailer;
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ASYNC_EVENT_GRP_5_SHARED_VLAN_SLI, *PASYNC_EVENT_GRP_5_SHARED_VLAN_SLI;

SG_C_ASSERT(__sizeof__ASYNC_EVENT_GRP_5_SHARED_VLAN, sizeof (ASYNC_EVENT_GRP_5_SHARED_VLAN_SLI) == 16);



typedef struct _PG_FEATURE_QUERY_REQUEST_PARAMS_IN_SLI {
   union {
      struct { 
         u32 query : 1;                           // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
         u32 eth_pfc_pg_feature : 1;              // DWORD 1
         u32 eth_tx_side_scaling : 1;             // DWORD 1
         u32 rsvd1 : 30;                          // DWORD 1
      } SG_PACK ; // unnamed struct
      u32 dw[2]; // dword union
   }; // unnamed union
} SG_PACK PG_FEATURE_QUERY_REQUEST_PARAMS_IN_SLI, *PPG_FEATURE_QUERY_REQUEST_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__PG_FEATURE_QUERY_REQUEST_PARAMS_IN, sizeof (PG_FEATURE_QUERY_REQUEST_PARAMS_IN_SLI) == 8);



typedef struct _PG_FEATURE_QUERY_REQUEST_PARAMS_OUT_SLI {
   union {
      struct { 
         u32 eth_pfc_pg_feature : 1;              // DWORD 0
         u32 eth_tx_side_scaling : 1;             // DWORD 0
         u32 rsvd0 : 30;                          // DWORD 0
         u32 num_tx_rings;                        // DWORD 1
      } SG_PACK ; // unnamed struct
      u32 dw[2]; // dword union
   }; // unnamed union
} SG_PACK PG_FEATURE_QUERY_REQUEST_PARAMS_OUT_SLI, *PPG_FEATURE_QUERY_REQUEST_PARAMS_OUT_SLI;

SG_C_ASSERT(__sizeof__PG_FEATURE_QUERY_REQUEST_PARAMS_OUT, sizeof (PG_FEATURE_QUERY_REQUEST_PARAMS_OUT_SLI) == 8);



typedef struct _PG_FEATURE_QUERY_REQUEST_PARAMS_SLI {
   union {
      union { 
         PG_FEATURE_QUERY_REQUEST_PARAMS_IN_SLI request;
         PG_FEATURE_QUERY_REQUEST_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[2]; // dword union
   }; // unnamed union
} SG_PACK PG_FEATURE_QUERY_REQUEST_PARAMS_SLI, *PPG_FEATURE_QUERY_REQUEST_PARAMS_SLI;

SG_C_ASSERT(__sizeof__PG_FEATURE_QUERY_REQUEST_PARAMS, sizeof (PG_FEATURE_QUERY_REQUEST_PARAMS_SLI) == 8);



typedef struct _IOCTL_ETH_PG_FEATURE_QUERY_REQUEST_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         PG_FEATURE_QUERY_REQUEST_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[6]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_PG_FEATURE_QUERY_REQUEST_SLI, *PIOCTL_ETH_PG_FEATURE_QUERY_REQUEST_SLI;

SG_C_ASSERT(__sizeof__IOCTL_ETH_PG_FEATURE_QUERY_REQUEST, sizeof (IOCTL_ETH_PG_FEATURE_QUERY_REQUEST_SLI) == 24);


// --- LRO_FLAGS_ENUM ---
#define LRO_FLAGS_HASH_MODE_SLI         (1)       
#define LRO_FLAGS_RSS_MODE_SLI          (4)       
#define LRO_FLAGS_COALESCE_IPV4_SLI     (16)      
#define LRO_FLAGS_COALESCE_IPV6_SLI     (32)      
#define LRO_FLAGS_PURE_ACK_WU_SLI       (256)     
#define LRO_FLAGS_TIMESTAMP_EXACT_SLI   (512)     
#define LRO_FLAGS_PURE_ACK_ADV_SLI      (1024)    
#define LRO_FLAGS_DUP_ACK_SLI           (2048)    
#define LRO_FLAGS_SPAN_BUFFER_SLI       (4096)    

// --- NIC_RQ_FLAGS_ENUM ---
#define NIC_RQ_FLAGS_RSS_SLI            (1)       
#define NIC_RQ_FLAGS_HDS_SLI            (2)       
#define NIC_RQ_FLAGS_PDV_SLI            (16)      
#define NIC_RQ_FLAGS_LRO_SLI            (32)      


typedef struct _ETH_RX_CREATE_V2_PARAMS_IN_SLI {
   union {
      struct { 
         UEXACT16 cq_id;
         UEXACT8 frag_size;
         UEXACT8 num_pages;
         UEXACT32 if_id;
         UEXACT16 max_frame_size;
         UEXACT16 page_size;
         UEXACT16 pd_id;
         UEXACT8 rsvd0;
         UEXACT8 ulp_num;
         UEXACT16 rq_flags;
         UEXACT16 rsvd1;
         UEXACT8 hds_frag;
         UEXACT8 hds_start;
         UEXACT16 hds_fixed_offset;
         UEXACT16 hds_frag_size;
         UEXACT16 hds_backfill_size;
         UEXACT32 rsvd2[9];
         PHYS_ADDR_SLI pages[2];
      } SG_PACK ; // unnamed struct
      u32 dw[20]; // dword union
   }; // unnamed union
} SG_PACK ETH_RX_CREATE_V2_PARAMS_IN_SLI, *PETH_RX_CREATE_V2_PARAMS_IN_SLI;

SG_C_ASSERT(__sizeof__ETH_RX_CREATE_V2_PARAMS_IN, sizeof (ETH_RX_CREATE_V2_PARAMS_IN_SLI) == 80);



typedef struct _ETH_RX_CREATE_V2_PARAMS_OUT_SLI {
   UEXACT16 rq_id;
   UEXACT8 rss_cpu_id;
   UEXACT8 rsvd0;
   UEXACT16 rsvd1;
   UEXACT8 db_bar_reg_set;
   UEXACT8 db_format;
   UEXACT32 db_offset;
   UEXACT16 rsvd2;
   UEXACT8 rsvd3;
   UEXACT8 ulp_num;
   UEXACT16 rq_flags;
   UEXACT16 rsvd4;
} SG_PACK ETH_RX_CREATE_V2_PARAMS_OUT_SLI, *PETH_RX_CREATE_V2_PARAMS_OUT_SLI;




typedef struct _ETH_RX_CREATE_V2_PARAMS_SLI {
   union {
      union { 
         ETH_RX_CREATE_V2_PARAMS_IN_SLI request;
         ETH_RX_CREATE_V2_PARAMS_OUT_SLI response;
      } SG_PACK ; // unnamed struct
      u32 dw[20]; // dword union
   }; // unnamed union
} SG_PACK ETH_RX_CREATE_V2_PARAMS_SLI, *PETH_RX_CREATE_V2_PARAMS_SLI;

SG_C_ASSERT(__sizeof__ETH_RX_CREATE_V2_PARAMS, sizeof (ETH_RX_CREATE_V2_PARAMS_SLI) == 80);



typedef struct _IOCTL_ETH_RX_CREATE_V2_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         ETH_RX_CREATE_V2_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[24]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_RX_CREATE_V2_SLI, *PIOCTL_ETH_RX_CREATE_V2_SLI;

SG_C_ASSERT(__sizeof__IOCTL_ETH_RX_CREATE_V2, sizeof (IOCTL_ETH_RX_CREATE_V2_SLI) == 96);



typedef struct _ETH_QUERY_LRO_CONFIG_PARAMS_IN_SLI {
   UEXACT32 rsvd0[5];
} SG_PACK ETH_QUERY_LRO_CONFIG_PARAMS_IN_SLI, *PETH_QUERY_LRO_CONFIG_PARAMS_IN_SLI;




typedef struct _ETH_QUERY_LRO_CONFIG_PARAMS_OUT_SLI {
   UEXACT32 lro_flags;
   UEXACT16 rsvd0;
   UEXACT16 lro_rq_count;
   UEXACT32 rsvd1[4];
} SG_PACK ETH_QUERY_LRO_CONFIG_PARAMS_OUT_SLI, *PETH_QUERY_LRO_CONFIG_PARAMS_OUT_SLI;




typedef union _ETH_QUERY_LRO_CONFIG_PARAMS_SLI {
   ETH_QUERY_LRO_CONFIG_PARAMS_IN_SLI request;
   ETH_QUERY_LRO_CONFIG_PARAMS_OUT_SLI response;
} SG_PACK ETH_QUERY_LRO_CONFIG_PARAMS_SLI, *PETH_QUERY_LRO_CONFIG_PARAMS_SLI;




typedef struct _IOCTL_ETH_QUERY_LRO_CONFIG_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         ETH_QUERY_LRO_CONFIG_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[10]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_QUERY_LRO_CONFIG_SLI, *PIOCTL_ETH_QUERY_LRO_CONFIG_SLI;

SG_C_ASSERT(__sizeof__IOCTL_ETH_QUERY_LRO_CONFIG, sizeof (IOCTL_ETH_QUERY_LRO_CONFIG_SLI) == 40);



typedef struct _ETH_SET_IFACE_LRO_CONFIG_PARAMS_IN_SLI {
   UEXACT32 lro_flags;
   UEXACT32 if_id;
   UEXACT32 max_clsc_byte_count;
   UEXACT32 max_clsc_segment_count;
   UEXACT32 max_clsc_usec_delay;
   UEXACT32 min_clsc_frame_byte_count;
   UEXACT32 rsvd0[2];
} SG_PACK ETH_SET_IFACE_LRO_CONFIG_PARAMS_IN_SLI, *PETH_SET_IFACE_LRO_CONFIG_PARAMS_IN_SLI;




typedef struct _ETH_SET_IFACE_LRO_CONFIG_PARAMS_OUT_SLI {
   UEXACT32 lro_flags;
   UEXACT32 rsvd0[7];
} SG_PACK ETH_SET_IFACE_LRO_CONFIG_PARAMS_OUT_SLI, *PETH_SET_IFACE_LRO_CONFIG_PARAMS_OUT_SLI;




typedef union _ETH_SET_IFACE_LRO_CONFIG_PARAMS_SLI {
   ETH_SET_IFACE_LRO_CONFIG_PARAMS_IN_SLI request;
   ETH_SET_IFACE_LRO_CONFIG_PARAMS_OUT_SLI response;
} SG_PACK ETH_SET_IFACE_LRO_CONFIG_PARAMS_SLI, *PETH_SET_IFACE_LRO_CONFIG_PARAMS_SLI;




typedef struct _IOCTL_ETH_SET_IFACE_LRO_CONFIG_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         ETH_SET_IFACE_LRO_CONFIG_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[12]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_SET_IFACE_LRO_CONFIG_SLI, *PIOCTL_ETH_SET_IFACE_LRO_CONFIG_SLI;

SG_C_ASSERT(__sizeof__IOCTL_ETH_SET_IFACE_LRO_CONFIG, sizeof (IOCTL_ETH_SET_IFACE_LRO_CONFIG_SLI) == 48);



typedef struct _ETH_RX_DESTROY_V1_PARAMS_IN_SLI {
   UEXACT16 id;
   UEXACT16 bypass_flush;
   UEXACT16 rq_flags;
   UEXACT16 rsvd0;
} SG_PACK ETH_RX_DESTROY_V1_PARAMS_IN_SLI, *PETH_RX_DESTROY_V1_PARAMS_IN_SLI;




typedef struct _ETH_RX_DESTROY_V1_PARAMS_OUT_SLI {
   UEXACT32 rsvd0;
} SG_PACK ETH_RX_DESTROY_V1_PARAMS_OUT_SLI, *PETH_RX_DESTROY_V1_PARAMS_OUT_SLI;




typedef union _ETH_RX_DESTROY_V1_PARAMS_SLI {
   ETH_RX_DESTROY_V1_PARAMS_IN_SLI request;
   ETH_RX_DESTROY_V1_PARAMS_OUT_SLI response;
} SG_PACK ETH_RX_DESTROY_V1_PARAMS_SLI, *PETH_RX_DESTROY_V1_PARAMS_SLI;




typedef struct _IOCTL_ETH_RX_DESTROY_V1_SLI {
   union {
      struct { 
         IOCTL_HEADER_SLI header;
         ETH_RX_DESTROY_V1_PARAMS_SLI params;
      } SG_PACK ; // unnamed struct
      u32 dw[6]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_RX_DESTROY_V1_SLI, *PIOCTL_ETH_RX_DESTROY_V1_SLI;

SG_C_ASSERT(__sizeof__IOCTL_ETH_RX_DESTROY_V1, sizeof (IOCTL_ETH_RX_DESTROY_V1_SLI) == 24);



typedef struct _ASYNC_EVENT_GRP_5_DEBUG_DATA_SLI {
   union {
      struct { 
         UEXACT8 module_;
         UEXACT8 module_event_id;
         UEXACT16 reserve;
         UEXACT32 debug_data;
         UEXACT32 event_tag;
         ASYNC_EVENT_TRAILER_SLI trailer;
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ASYNC_EVENT_GRP_5_DEBUG_DATA_SLI, *PASYNC_EVENT_GRP_5_DEBUG_DATA_SLI;

SG_C_ASSERT(__sizeof__ASYNC_EVENT_GRP_5_DEBUG_DATA, sizeof (ASYNC_EVENT_GRP_5_DEBUG_DATA_SLI) == 16);


// --- ASYNC_EVENT_CODES ---
#define ASYNC_EVENT_CODE_LINK_STATE_SLI (1)       
#define ASYNC_EVENT_CODE_FCOE_FIP_SLI   (2)       
#define ASYNC_EVENT_CODE_DCBX_SLI       (3)       
#define ASYNC_EVENT_CODE_ISCSI_SLI      (4)       
#define ASYNC_EVENT_CODE_GRP_5_SLI      (5)       
#define ASYNC_EVENT_CODE_DEBUG_SLI      (6)       
#define ASYNC_EVENT_CODE_FC_SLI         (16)      
#define ASYNC_EVENT_CODE_SLI_PORT_SLI   (17)      
#define ASYNC_EVENT_CODE_VF_SLI         (18)      
#define ASYNC_EVENT_CODE_MR_SLI         (19)      
#define ASYNC_EVENT_CODE_RDMA_SLI       (20)      

// --- ASYNC_RDMA_EVENTS ---
#define ASYNC_RDMA_EVENT_CQ_ERROR_SLI   (0)       
#define ASYNC_RDMA_EVENT_CQ_OVERRUN_ERROR_SLI (1) 
#define ASYNC_RDMA_EVENT_QP_CAT_ERROR_SLI (2)     
#define ASYNC_RDMA_EVENT_QP_ACCESS_ERROR_SLI (3)  
#define ASYNC_RDMA_EVENT_QP_COMM_EST_SLI (4)      
#define ASYNC_RDMA_EVENT_COS_NOTIFY_SLI (5)       
#define ASYNC_RDMA_EVENT_DEVICE_FATAL_SLI (8)     
#define ASYNC_RDMA_EVENT_SRQ_CAT_ERROR_SLI (14)   
#define ASYNC_RDMA_EVENT_SRQ_LIMIT_ERROR_SLI (15) 
#define ASYNC_RDMA_EVENT_QP_LAST_WQE_REACHED_SLI (16) 

#if defined(SG_REVERSE_ENDIAN)

   typedef struct _ASYNC_EVENT_RDMA_CQ_ERROR_SLI {
      union {
         struct { 
            UEXACT32 rsvd0;
            u32 cq_valid : 1;                     // DWORD 1
            u32 rsvd1 : 15;                       // DWORD 1
            u32 cq_id : 16;                       // DWORD 1
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_CQ_ERROR_SLI, *PASYNC_EVENT_RDMA_CQ_ERROR_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_CQ_ERROR, sizeof (ASYNC_EVENT_RDMA_CQ_ERROR_SLI) == 16);


#else

   typedef struct _ASYNC_EVENT_RDMA_CQ_ERROR_SLI {
      union {
         struct { 
            UEXACT32 rsvd0;
            u32 cq_id : 16;                       // DWORD 1
            u32 rsvd1 : 15;                       // DWORD 1
            u32 cq_valid : 1;                     // DWORD 1
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_CQ_ERROR_SLI, *PASYNC_EVENT_RDMA_CQ_ERROR_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_CQ_ERROR, sizeof (ASYNC_EVENT_RDMA_CQ_ERROR_SLI) == 16);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _ASYNC_EVENT_RDMA_CQ_OVERRUN_SLI {
      union {
         struct { 
            UEXACT32 rsvd0;
            u32 cq_valid : 1;                     // DWORD 1
            u32 rsvd1 : 15;                       // DWORD 1
            u32 cq_id : 16;                       // DWORD 1
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_CQ_OVERRUN_SLI, *PASYNC_EVENT_RDMA_CQ_OVERRUN_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_CQ_OVERRUN, sizeof (ASYNC_EVENT_RDMA_CQ_OVERRUN_SLI) == 16);


#else

   typedef struct _ASYNC_EVENT_RDMA_CQ_OVERRUN_SLI {
      union {
         struct { 
            UEXACT32 rsvd0;
            u32 cq_id : 16;                       // DWORD 1
            u32 rsvd1 : 15;                       // DWORD 1
            u32 cq_valid : 1;                     // DWORD 1
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_CQ_OVERRUN_SLI, *PASYNC_EVENT_RDMA_CQ_OVERRUN_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_CQ_OVERRUN, sizeof (ASYNC_EVENT_RDMA_CQ_OVERRUN_SLI) == 16);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _ASYNC_EVENT_RDMA_QP_CAT_SLI {
      union {
         struct { 
            u32 qp_valid : 1;                     // DWORD 0
            u32 rsvd0 : 15;                       // DWORD 0
            u32 qp_id : 16;                       // DWORD 0
            UEXACT32 rsvd1;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_QP_CAT_SLI, *PASYNC_EVENT_RDMA_QP_CAT_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_QP_CAT, sizeof (ASYNC_EVENT_RDMA_QP_CAT_SLI) == 16);


#else

   typedef struct _ASYNC_EVENT_RDMA_QP_CAT_SLI {
      union {
         struct { 
            u32 qp_id : 16;                       // DWORD 0
            u32 rsvd0 : 15;                       // DWORD 0
            u32 qp_valid : 1;                     // DWORD 0
            UEXACT32 rsvd1;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_QP_CAT_SLI, *PASYNC_EVENT_RDMA_QP_CAT_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_QP_CAT, sizeof (ASYNC_EVENT_RDMA_QP_CAT_SLI) == 16);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _ASYNC_EVENT_RDMA_QP_ACCESS_SLI {
      union {
         struct { 
            u32 qp_valid : 1;                     // DWORD 0
            u32 rsvd0 : 15;                       // DWORD 0
            u32 qp_id : 16;                       // DWORD 0
            UEXACT32 rsvd1;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_QP_ACCESS_SLI, *PASYNC_EVENT_RDMA_QP_ACCESS_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_QP_ACCESS, sizeof (ASYNC_EVENT_RDMA_QP_ACCESS_SLI) == 16);


#else

   typedef struct _ASYNC_EVENT_RDMA_QP_ACCESS_SLI {
      union {
         struct { 
            u32 qp_id : 16;                       // DWORD 0
            u32 rsvd0 : 15;                       // DWORD 0
            u32 qp_valid : 1;                     // DWORD 0
            UEXACT32 rsvd1;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_QP_ACCESS_SLI, *PASYNC_EVENT_RDMA_QP_ACCESS_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_QP_ACCESS, sizeof (ASYNC_EVENT_RDMA_QP_ACCESS_SLI) == 16);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _ASYNC_EVENT_RDMA_DEVICE_FATAL_SLI {
      union {
         struct { 
            UEXACT32 rsvd0;
            UEXACT32 rsvd1;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_DEVICE_FATAL_SLI, *PASYNC_EVENT_RDMA_DEVICE_FATAL_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_DEVICE_FATAL, sizeof (ASYNC_EVENT_RDMA_DEVICE_FATAL_SLI) == 16);


#else

   typedef struct _ASYNC_EVENT_RDMA_DEVICE_FATAL_SLI {
      union {
         struct { 
            UEXACT32 rsvd0;
            UEXACT32 rsvd1;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_DEVICE_FATAL_SLI, *PASYNC_EVENT_RDMA_DEVICE_FATAL_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_DEVICE_FATAL, sizeof (ASYNC_EVENT_RDMA_DEVICE_FATAL_SLI) == 16);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _ASYNC_EVENT_RDMA_SRQ_CAT_SLI {
      union {
         struct { 
            u32 rsvd1 : 1;                        // DWORD 0
            u32 srq_valid : 1;                    // DWORD 0
            u32 rsvd0 : 14;                       // DWORD 0
            u32 srq_id : 16;                      // DWORD 0
            UEXACT32 rsvd2;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_SRQ_CAT_SLI, *PASYNC_EVENT_RDMA_SRQ_CAT_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_SRQ_CAT, sizeof (ASYNC_EVENT_RDMA_SRQ_CAT_SLI) == 16);


#else

   typedef struct _ASYNC_EVENT_RDMA_SRQ_CAT_SLI {
      union {
         struct { 
            u32 srq_id : 16;                      // DWORD 0
            u32 rsvd0 : 14;                       // DWORD 0
            u32 srq_valid : 1;                    // DWORD 0
            u32 rsvd1 : 1;                        // DWORD 0
            UEXACT32 rsvd2;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_SRQ_CAT_SLI, *PASYNC_EVENT_RDMA_SRQ_CAT_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_SRQ_CAT, sizeof (ASYNC_EVENT_RDMA_SRQ_CAT_SLI) == 16);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _ASYNC_EVENT_RDMA_SRQ_LIMIT_SLI {
      union {
         struct { 
            u32 srq_id : 16;                      // DWORD 0
            u32 rsvd1 : 14;                       // DWORD 0
            u32 srq_valid : 1;                    // DWORD 0
            u32 rsvd0 : 1;                        // DWORD 0
            UEXACT32 rsvd2;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_SRQ_LIMIT_SLI, *PASYNC_EVENT_RDMA_SRQ_LIMIT_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_SRQ_LIMIT, sizeof (ASYNC_EVENT_RDMA_SRQ_LIMIT_SLI) == 16);


#else

   typedef struct _ASYNC_EVENT_RDMA_SRQ_LIMIT_SLI {
      union {
         struct { 
            u32 rsvd0 : 1;                        // DWORD 0
            u32 srq_valid : 1;                    // DWORD 0
            u32 rsvd1 : 14;                       // DWORD 0
            u32 srq_id : 16;                      // DWORD 0
            UEXACT32 rsvd2;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_SRQ_LIMIT_SLI, *PASYNC_EVENT_RDMA_SRQ_LIMIT_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_SRQ_LIMIT, sizeof (ASYNC_EVENT_RDMA_SRQ_LIMIT_SLI) == 16);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _ASYNC_EVENT_RDMA_QP_LAST_WQE_SLI {
      union {
         struct { 
            u32 qp_valid : 1;                     // DWORD 0
            u32 rsvd0 : 15;                       // DWORD 0
            u32 qp_id : 16;                       // DWORD 0
            UEXACT32 rsvd1;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_QP_LAST_WQE_SLI, *PASYNC_EVENT_RDMA_QP_LAST_WQE_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_QP_LAST_WQE, sizeof (ASYNC_EVENT_RDMA_QP_LAST_WQE_SLI) == 16);


#else

   typedef struct _ASYNC_EVENT_RDMA_QP_LAST_WQE_SLI {
      union {
         struct { 
            u32 qp_id : 16;                       // DWORD 0
            u32 rsvd0 : 15;                       // DWORD 0
            u32 qp_valid : 1;                     // DWORD 0
            UEXACT32 rsvd1;
            UEXACT32 event_tag;
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_QP_LAST_WQE_SLI, *PASYNC_EVENT_RDMA_QP_LAST_WQE_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_QP_LAST_WQE, sizeof (ASYNC_EVENT_RDMA_QP_LAST_WQE_SLI) == 16);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _ASYNC_EVENT_RDMA_COS_NOTIFY_SLI {
      union {
         struct { 
            UEXACT8 priority;
            UEXACT8 rsvd0[3];
            u32 rsvd1[2];                         // DWORDS 1 to 2
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_COS_NOTIFY_SLI, *PASYNC_EVENT_RDMA_COS_NOTIFY_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_COS_NOTIFY, sizeof (ASYNC_EVENT_RDMA_COS_NOTIFY_SLI) == 16);


#else

   typedef struct _ASYNC_EVENT_RDMA_COS_NOTIFY_SLI {
      union {
         struct { 
            UEXACT8 priority;
            UEXACT8 rsvd0[3];
            u32 rsvd1[2];                         // DWORDS 1 to 2
            ASYNC_EVENT_TRAILER_SLI trailer;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK ASYNC_EVENT_RDMA_COS_NOTIFY_SLI, *PASYNC_EVENT_RDMA_COS_NOTIFY_SLI;

   SG_C_ASSERT(__sizeof__ASYNC_EVENT_RDMA_COS_NOTIFY, sizeof (ASYNC_EVENT_RDMA_COS_NOTIFY_SLI) == 16);


#endif
// --- RDMA_QUERY_CONFIG_FLAGS ---
#define RDMA_ORD_HOT_MODIFY_FLAG_SLI    (1)       
#define RDMA_IRD_HOT_MODIFY_FLAG_SLI    (2)       
#define RDMA_CQ_OVERFLOW_FLAG_SLI       (4)       
#define RDMA_SRQ_SUPPPORTED_FLAG_SLI    (8)       

#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_CONFIG_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_CONFIG_PARAMS_IN_SLI, *PRDMA_QUERY_CONFIG_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_CONFIG_PARAMS_IN, sizeof (RDMA_QUERY_CONFIG_PARAMS_IN_SLI) == 4);


#else

   typedef struct _RDMA_QUERY_CONFIG_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_CONFIG_PARAMS_IN_SLI, *PRDMA_QUERY_CONFIG_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_CONFIG_PARAMS_IN, sizeof (RDMA_QUERY_CONFIG_PARAMS_IN_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_CONFIG_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 max_qp : 24;                      // DWORD 0
            u32 rsvd0 : 2;                        // DWORD 0
            u32 ird_ring_required : 1;            // DWORD 0
            u32 cq_autovalid : 1;                 // DWORD 0
            u32 srq_supported : 1;                // DWORD 0
            u32 cq_overflow : 1;                  // DWORD 0
            u32 ird_hot_modify : 1;               // DWORD 0
            u32 ord_hot_modify : 1;               // DWORD 0
            UEXACT8 pad;
            UEXACT8 local_ca_ack_delay;
            UEXACT16 max_pd;
            UEXACT16 max_send_sge;
            UEXACT16 max_rq_recv_sge;
            UEXACT16 max_ord_per_qp;
            UEXACT16 max_ird_per_qp;
            UEXACT16 max_shared_ord;
            UEXACT16 max_shared_ird;
            UEXACT32 max_mr;
            UEXACT32 max_mr_size_hi;
            UEXACT32 max_mr_size_lo;
            UEXACT32 max_pbls_per_mr;
            UEXACT32 max_mw;
            UEXACT32 max_fmr;
            UEXACT32 max_map_per_fmr;
            UEXACT32 max_mcast_group;
            UEXACT32 max_mcast_qp_attach;
            UEXACT32 max_total_mcast_qp_attach;
            UEXACT16 max_dpp_qps;
            UEXACT8 rq_wqe_stride;
            UEXACT8 sq_wqe_stride;
            UEXACT16 max_rpir_qps;
            UEXACT16 max_srq;
            UEXACT16 max_dpp_credits;
            UEXACT16 max_dpp_pds;
            UEXACT16 max_dpp_qps_per_pd;
            UEXACT16 max_dpp_credits_per_qp;
            UEXACT16 max_rqes_per_rq;
            UEXACT16 max_wqes_per_wq;
            UEXACT16 max_cqes_per_cq;
            UEXACT16 max_cq;
            UEXACT16 max_srq_sge;
            UEXACT16 max_srq_rqe;
            UEXACT16 max_read_sge;
            UEXACT16 max_write_sge;
            UEXACT16 num_ird_pages;
            UEXACT16 ird_page_size;
         } SG_PACK ; // unnamed struct
         u32 dw[24]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_CONFIG_PARAMS_OUT_SLI, *PRDMA_QUERY_CONFIG_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_CONFIG_PARAMS_OUT, sizeof (RDMA_QUERY_CONFIG_PARAMS_OUT_SLI) == 96);


#else

   typedef struct _RDMA_QUERY_CONFIG_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 ord_hot_modify : 1;               // DWORD 0
            u32 ird_hot_modify : 1;               // DWORD 0
            u32 cq_overflow : 1;                  // DWORD 0
            u32 srq_supported : 1;                // DWORD 0
            u32 cq_autovalid : 1;                 // DWORD 0
            u32 ird_ring_required : 1;            // DWORD 0
            u32 rsvd0 : 2;                        // DWORD 0
            u32 max_qp : 24;                      // DWORD 0
            UEXACT8 pad;
            UEXACT8 local_ca_ack_delay;
            UEXACT16 max_pd;
            UEXACT16 max_send_sge;
            UEXACT16 max_rq_recv_sge;
            UEXACT16 max_ord_per_qp;
            UEXACT16 max_ird_per_qp;
            UEXACT16 max_shared_ord;
            UEXACT16 max_shared_ird;
            UEXACT32 max_mr;
            UEXACT32 max_mr_size_hi;
            UEXACT32 max_mr_size_lo;
            UEXACT32 max_pbls_per_mr;
            UEXACT32 max_mw;
            UEXACT32 max_fmr;
            UEXACT32 max_map_per_fmr;
            UEXACT32 max_mcast_group;
            UEXACT32 max_mcast_qp_attach;
            UEXACT32 max_total_mcast_qp_attach;
            UEXACT16 max_dpp_qps;
            UEXACT8 rq_wqe_stride;
            UEXACT8 sq_wqe_stride;
            UEXACT16 max_rpir_qps;
            UEXACT16 max_srq;
            UEXACT16 max_dpp_credits;
            UEXACT16 max_dpp_pds;
            UEXACT16 max_dpp_qps_per_pd;
            UEXACT16 max_dpp_credits_per_qp;
            UEXACT16 max_rqes_per_rq;
            UEXACT16 max_wqes_per_wq;
            UEXACT16 max_cqes_per_cq;
            UEXACT16 max_cq;
            UEXACT16 max_srq_sge;
            UEXACT16 max_srq_rqe;
            UEXACT16 max_read_sge;
            UEXACT16 max_write_sge;
            UEXACT16 num_ird_pages;
            UEXACT16 ird_page_size;
         } SG_PACK ; // unnamed struct
         u32 dw[24]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_CONFIG_PARAMS_OUT_SLI, *PRDMA_QUERY_CONFIG_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_CONFIG_PARAMS_OUT, sizeof (RDMA_QUERY_CONFIG_PARAMS_OUT_SLI) == 96);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_CONFIG_PARAMS_SLI {
      union {
         union { 
            RDMA_QUERY_CONFIG_PARAMS_IN_SLI request;
            RDMA_QUERY_CONFIG_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[24]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_CONFIG_PARAMS_SLI, *PRDMA_QUERY_CONFIG_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_CONFIG_PARAMS, sizeof (RDMA_QUERY_CONFIG_PARAMS_SLI) == 96);


#else

   typedef struct _RDMA_QUERY_CONFIG_PARAMS_SLI {
      union {
         union { 
            RDMA_QUERY_CONFIG_PARAMS_IN_SLI request;
            RDMA_QUERY_CONFIG_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[24]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_CONFIG_PARAMS_SLI, *PRDMA_QUERY_CONFIG_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_CONFIG_PARAMS, sizeof (RDMA_QUERY_CONFIG_PARAMS_SLI) == 96);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_QUERY_CONFIG_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_QUERY_CONFIG_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[28]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_QUERY_CONFIG_SLI, *PIOCTL_RDMA_QUERY_CONFIG_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_QUERY_CONFIG, sizeof (IOCTL_RDMA_QUERY_CONFIG_SLI) == 112);


#else

   typedef struct _IOCTL_RDMA_QUERY_CONFIG_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_QUERY_CONFIG_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[28]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_QUERY_CONFIG_SLI, *PIOCTL_RDMA_QUERY_CONFIG_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_QUERY_CONFIG, sizeof (IOCTL_RDMA_QUERY_CONFIG_SLI) == 112);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_AHR_PARAMS_IN_SLI {
      union {
         struct { 
            u32 av_size : 9;                      // DWORD 0
            u32 num_pages : 4;                    // DWORD 0
            u32 page_size : 3;                    // DWORD 0
            u32 rsvd0 : 16;                       // DWORD 0
            PHYS_ADDR_SLI pages[8];
         } SG_PACK ; // unnamed struct
         u32 dw[17]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_AHR_PARAMS_IN_SLI, *PRDMA_CREATE_AHR_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_AHR_PARAMS_IN, sizeof (RDMA_CREATE_AHR_PARAMS_IN_SLI) == 68);


#else

   typedef struct _RDMA_CREATE_AHR_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 16;                       // DWORD 0
            u32 page_size : 3;                    // DWORD 0
            u32 num_pages : 4;                    // DWORD 0
            u32 av_size : 9;                      // DWORD 0
            PHYS_ADDR_SLI pages[8];
         } SG_PACK ; // unnamed struct
         u32 dw[17]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_AHR_PARAMS_IN_SLI, *PRDMA_CREATE_AHR_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_AHR_PARAMS_IN, sizeof (RDMA_CREATE_AHR_PARAMS_IN_SLI) == 68);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_AHR_PARAMS_OUT_SLI {
      UEXACT32 ahr_id;
   } SG_PACK RDMA_CREATE_AHR_PARAMS_OUT_SLI, *PRDMA_CREATE_AHR_PARAMS_OUT_SLI;



#else

   typedef struct _RDMA_CREATE_AHR_PARAMS_OUT_SLI {
      UEXACT32 ahr_id;
   } SG_PACK RDMA_CREATE_AHR_PARAMS_OUT_SLI, *PRDMA_CREATE_AHR_PARAMS_OUT_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_AHR_PARAMS_SLI {
      union {
         union { 
            RDMA_CREATE_AHR_PARAMS_IN_SLI request;
            RDMA_CREATE_AHR_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[17]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_AHR_PARAMS_SLI, *PRDMA_CREATE_AHR_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_AHR_PARAMS, sizeof (RDMA_CREATE_AHR_PARAMS_SLI) == 68);


#else

   typedef struct _RDMA_CREATE_AHR_PARAMS_SLI {
      union {
         union { 
            RDMA_CREATE_AHR_PARAMS_IN_SLI request;
            RDMA_CREATE_AHR_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[17]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_AHR_PARAMS_SLI, *PRDMA_CREATE_AHR_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_AHR_PARAMS, sizeof (RDMA_CREATE_AHR_PARAMS_SLI) == 68);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_CREATE_AHR_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_CREATE_AHR_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[21]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_CREATE_AHR_SLI, *PIOCTL_RDMA_CREATE_AHR_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_CREATE_AHR, sizeof (IOCTL_RDMA_CREATE_AHR_SLI) == 84);


#else

   typedef struct _IOCTL_RDMA_CREATE_AHR_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_CREATE_AHR_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[21]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_CREATE_AHR_SLI, *PIOCTL_RDMA_CREATE_AHR_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_CREATE_AHR, sizeof (IOCTL_RDMA_CREATE_AHR_SLI) == 84);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DESTROY_AHR_PARAMS_IN_SLI {
      UEXACT32 ahr_id;
   } SG_PACK RDMA_DESTROY_AHR_PARAMS_IN_SLI, *PRDMA_DESTROY_AHR_PARAMS_IN_SLI;



#else

   typedef struct _RDMA_DESTROY_AHR_PARAMS_IN_SLI {
      UEXACT32 ahr_id;
   } SG_PACK RDMA_DESTROY_AHR_PARAMS_IN_SLI, *PRDMA_DESTROY_AHR_PARAMS_IN_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DESTROY_AHR_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_AHR_PARAMS_OUT_SLI, *PRDMA_DESTROY_AHR_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_AHR_PARAMS_OUT, sizeof (RDMA_DESTROY_AHR_PARAMS_OUT_SLI) == 4);


#else

   typedef struct _RDMA_DESTROY_AHR_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_AHR_PARAMS_OUT_SLI, *PRDMA_DESTROY_AHR_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_AHR_PARAMS_OUT, sizeof (RDMA_DESTROY_AHR_PARAMS_OUT_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DESTROY_AHR_PARAMS_SLI {
      union {
         union { 
            RDMA_DESTROY_AHR_PARAMS_IN_SLI request;
            RDMA_DESTROY_AHR_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_AHR_PARAMS_SLI, *PRDMA_DESTROY_AHR_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_AHR_PARAMS, sizeof (RDMA_DESTROY_AHR_PARAMS_SLI) == 4);


#else

   typedef struct _RDMA_DESTROY_AHR_PARAMS_SLI {
      union {
         union { 
            RDMA_DESTROY_AHR_PARAMS_IN_SLI request;
            RDMA_DESTROY_AHR_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_AHR_PARAMS_SLI, *PRDMA_DESTROY_AHR_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_AHR_PARAMS, sizeof (RDMA_DESTROY_AHR_PARAMS_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_DESTROY_AHR_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DESTROY_AHR_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DESTROY_AHR_SLI, *PIOCTL_RDMA_DESTROY_AHR_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DESTROY_AHR, sizeof (IOCTL_RDMA_DESTROY_AHR_SLI) == 20);


#else

   typedef struct _IOCTL_RDMA_DESTROY_AHR_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DESTROY_AHR_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DESTROY_AHR_SLI, *PIOCTL_RDMA_DESTROY_AHR_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DESTROY_AHR, sizeof (IOCTL_RDMA_DESTROY_AHR_SLI) == 20);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_ALLOC_PD_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd1 : 15;                       // DWORD 0
            u32 enable_dpp : 1;                   // DWORD 0
            u32 rsvd0 : 16;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_PD_PARAMS_IN_SLI, *PRDMA_ALLOC_PD_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_PD_PARAMS_IN, sizeof (RDMA_ALLOC_PD_PARAMS_IN_SLI) == 4);


#else

   typedef struct _RDMA_ALLOC_PD_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 16;                       // DWORD 0
            u32 enable_dpp : 1;                   // DWORD 0
            u32 rsvd1 : 15;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_PD_PARAMS_IN_SLI, *PRDMA_ALLOC_PD_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_PD_PARAMS_IN, sizeof (RDMA_ALLOC_PD_PARAMS_IN_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_ALLOC_PD_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 dpp_page_index : 15;              // DWORD 0
            u32 dpp_enabled : 1;                  // DWORD 0
            u32 pd_id : 16;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_PD_PARAMS_OUT_SLI, *PRDMA_ALLOC_PD_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_PD_PARAMS_OUT, sizeof (RDMA_ALLOC_PD_PARAMS_OUT_SLI) == 4);


#else

   typedef struct _RDMA_ALLOC_PD_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 pd_id : 16;                       // DWORD 0
            u32 dpp_enabled : 1;                  // DWORD 0
            u32 dpp_page_index : 15;              // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_PD_PARAMS_OUT_SLI, *PRDMA_ALLOC_PD_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_PD_PARAMS_OUT, sizeof (RDMA_ALLOC_PD_PARAMS_OUT_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_ALLOC_PD_PARAMS_SLI {
      union {
         union { 
            RDMA_ALLOC_PD_PARAMS_IN_SLI request;
            RDMA_ALLOC_PD_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_PD_PARAMS_SLI, *PRDMA_ALLOC_PD_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_PD_PARAMS, sizeof (RDMA_ALLOC_PD_PARAMS_SLI) == 4);


#else

   typedef struct _RDMA_ALLOC_PD_PARAMS_SLI {
      union {
         union { 
            RDMA_ALLOC_PD_PARAMS_IN_SLI request;
            RDMA_ALLOC_PD_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_PD_PARAMS_SLI, *PRDMA_ALLOC_PD_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_PD_PARAMS, sizeof (RDMA_ALLOC_PD_PARAMS_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_ALLOC_PD_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_ALLOC_PD_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_ALLOC_PD_SLI, *PIOCTL_RDMA_ALLOC_PD_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_ALLOC_PD, sizeof (IOCTL_RDMA_ALLOC_PD_SLI) == 20);


#else

   typedef struct _IOCTL_RDMA_ALLOC_PD_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_ALLOC_PD_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_ALLOC_PD_SLI, *PIOCTL_RDMA_ALLOC_PD_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_ALLOC_PD, sizeof (IOCTL_RDMA_ALLOC_PD_SLI) == 20);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DEALLOC_PD_PARAMS_IN_SLI {
      UEXACT16 pd_id;
      UEXACT16 rsvd0;
   } SG_PACK RDMA_DEALLOC_PD_PARAMS_IN_SLI, *PRDMA_DEALLOC_PD_PARAMS_IN_SLI;



#else

   typedef struct _RDMA_DEALLOC_PD_PARAMS_IN_SLI {
      UEXACT16 pd_id;
      UEXACT16 rsvd0;
   } SG_PACK RDMA_DEALLOC_PD_PARAMS_IN_SLI, *PRDMA_DEALLOC_PD_PARAMS_IN_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DEALLOC_PD_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DEALLOC_PD_PARAMS_OUT_SLI, *PRDMA_DEALLOC_PD_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DEALLOC_PD_PARAMS_OUT, sizeof (RDMA_DEALLOC_PD_PARAMS_OUT_SLI) == 4);


#else

   typedef struct _RDMA_DEALLOC_PD_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DEALLOC_PD_PARAMS_OUT_SLI, *PRDMA_DEALLOC_PD_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DEALLOC_PD_PARAMS_OUT, sizeof (RDMA_DEALLOC_PD_PARAMS_OUT_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DEALLOC_PD_PARAMS_SLI {
      union {
         union { 
            RDMA_DEALLOC_PD_PARAMS_IN_SLI request;
            RDMA_DEALLOC_PD_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DEALLOC_PD_PARAMS_SLI, *PRDMA_DEALLOC_PD_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DEALLOC_PD_PARAMS, sizeof (RDMA_DEALLOC_PD_PARAMS_SLI) == 4);


#else

   typedef struct _RDMA_DEALLOC_PD_PARAMS_SLI {
      union {
         union { 
            RDMA_DEALLOC_PD_PARAMS_IN_SLI request;
            RDMA_DEALLOC_PD_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DEALLOC_PD_PARAMS_SLI, *PRDMA_DEALLOC_PD_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DEALLOC_PD_PARAMS, sizeof (RDMA_DEALLOC_PD_PARAMS_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_DEALLOC_PD_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DEALLOC_PD_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DEALLOC_PD_SLI, *PIOCTL_RDMA_DEALLOC_PD_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DEALLOC_PD, sizeof (IOCTL_RDMA_DEALLOC_PD_SLI) == 20);


#else

   typedef struct _IOCTL_RDMA_DEALLOC_PD_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DEALLOC_PD_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DEALLOC_PD_SLI, *PIOCTL_RDMA_DEALLOC_PD_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DEALLOC_PD, sizeof (IOCTL_RDMA_DEALLOC_PD_SLI) == 20);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_RBQ_PARAMS_IN_SLI {
      union {
         struct { 
            UEXACT32 rsvd0;
            UEXACT16 page_size;
            UEXACT16 num_phy_pages;
            PHYS_ADDR_SLI pages[8];
         } SG_PACK ; // unnamed struct
         u32 dw[18]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_RBQ_PARAMS_IN_SLI, *PRDMA_CREATE_RBQ_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_RBQ_PARAMS_IN, sizeof (RDMA_CREATE_RBQ_PARAMS_IN_SLI) == 72);


#else

   typedef struct _RDMA_CREATE_RBQ_PARAMS_IN_SLI {
      union {
         struct { 
            UEXACT32 rsvd0;
            UEXACT16 page_size;
            UEXACT16 num_phy_pages;
            PHYS_ADDR_SLI pages[8];
         } SG_PACK ; // unnamed struct
         u32 dw[18]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_RBQ_PARAMS_IN_SLI, *PRDMA_CREATE_RBQ_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_RBQ_PARAMS_IN, sizeof (RDMA_CREATE_RBQ_PARAMS_IN_SLI) == 72);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_RBQ_PARAMS_OUT_SLI {
      UEXACT32 rbq_id;
   } SG_PACK RDMA_CREATE_RBQ_PARAMS_OUT_SLI, *PRDMA_CREATE_RBQ_PARAMS_OUT_SLI;



#else

   typedef struct _RDMA_CREATE_RBQ_PARAMS_OUT_SLI {
      UEXACT32 rbq_id;
   } SG_PACK RDMA_CREATE_RBQ_PARAMS_OUT_SLI, *PRDMA_CREATE_RBQ_PARAMS_OUT_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_RBQ_PARAMS_SLI {
      union {
         union { 
            RDMA_CREATE_RBQ_PARAMS_IN_SLI request;
            RDMA_CREATE_RBQ_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[18]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_RBQ_PARAMS_SLI, *PRDMA_CREATE_RBQ_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_RBQ_PARAMS, sizeof (RDMA_CREATE_RBQ_PARAMS_SLI) == 72);


#else

   typedef struct _RDMA_CREATE_RBQ_PARAMS_SLI {
      union {
         union { 
            RDMA_CREATE_RBQ_PARAMS_IN_SLI request;
            RDMA_CREATE_RBQ_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[18]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_RBQ_PARAMS_SLI, *PRDMA_CREATE_RBQ_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_RBQ_PARAMS, sizeof (RDMA_CREATE_RBQ_PARAMS_SLI) == 72);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_CREATE_RBQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_CREATE_RBQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[22]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_CREATE_RBQ_SLI, *PIOCTL_RDMA_CREATE_RBQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_CREATE_RBQ, sizeof (IOCTL_RDMA_CREATE_RBQ_SLI) == 88);


#else

   typedef struct _IOCTL_RDMA_CREATE_RBQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_CREATE_RBQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[22]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_CREATE_RBQ_SLI, *PIOCTL_RDMA_CREATE_RBQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_CREATE_RBQ, sizeof (IOCTL_RDMA_CREATE_RBQ_SLI) == 88);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DESTROY_RBQ_PARAMS_IN_SLI {
      UEXACT32 rbq_id;
   } SG_PACK RDMA_DESTROY_RBQ_PARAMS_IN_SLI, *PRDMA_DESTROY_RBQ_PARAMS_IN_SLI;



#else

   typedef struct _RDMA_DESTROY_RBQ_PARAMS_IN_SLI {
      UEXACT32 rbq_id;
   } SG_PACK RDMA_DESTROY_RBQ_PARAMS_IN_SLI, *PRDMA_DESTROY_RBQ_PARAMS_IN_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef union _RDMA_DESTROY_RBQ_PARAMS_SLI {
      RDMA_DESTROY_RBQ_PARAMS_IN_SLI request;
   } SG_PACK RDMA_DESTROY_RBQ_PARAMS_SLI, *PRDMA_DESTROY_RBQ_PARAMS_SLI;



#else

   typedef union _RDMA_DESTROY_RBQ_PARAMS_SLI {
      RDMA_DESTROY_RBQ_PARAMS_IN_SLI request;
   } SG_PACK RDMA_DESTROY_RBQ_PARAMS_SLI, *PRDMA_DESTROY_RBQ_PARAMS_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_DESTROY_RBQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DESTROY_RBQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DESTROY_RBQ_SLI, *PIOCTL_RDMA_DESTROY_RBQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DESTROY_RBQ, sizeof (IOCTL_RDMA_DESTROY_RBQ_SLI) == 20);


#else

   typedef struct _IOCTL_RDMA_DESTROY_RBQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DESTROY_RBQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DESTROY_RBQ_SLI, *PIOCTL_RDMA_DESTROY_RBQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DESTROY_RBQ, sizeof (IOCTL_RDMA_DESTROY_RBQ_SLI) == 20);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_QP_PARAMS_IN_SLI {
      union {
         struct { 
            u32 transport_type : 3;               // DWORD 0
            u32 rsvd0 : 3;                        // DWORD 0
            u32 rpir_blk_size : 4;                // DWORD 0
            u32 rq_page_size : 3;                 // DWORD 0
            u32 sq_page_size : 3;                 // DWORD 0
            u32 pd_id : 16;                       // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 max_wqe;
            UEXACT16 max_sge_write;
            UEXACT16 max_sge_send;
            u32 max_sge_recv : 16;                // DWORD 3
            u32 rsvd1 : 6;                        // DWORD 3
            u32 signaled_qp : 1;                  // DWORD 3
            u32 enable_dpp_cqe : 1;               // DWORD 3
            u32 enable_dpp : 1;                   // DWORD 3
            u32 enable_rpir : 1;                  // DWORD 3
            u32 use_srq : 1;                      // DWORD 3
            u32 inb_rden : 1;                     // DWORD 3
            u32 inb_wren : 1;                     // DWORD 3
            u32 bind_memwin : 1;                  // DWORD 3
            u32 zero_stagen : 1;                  // DWORD 3
            u32 fmr_en : 1;                       // DWORD 3
            UEXACT16 max_ird;
            UEXACT16 max_ord;
            UEXACT16 num_rq_pages;
            UEXACT16 num_wq_pages;
            UEXACT16 rqe_size;
            UEXACT16 wqe_size;
            UEXACT16 rq_cqid;
            UEXACT16 wq_cqid;
            PHYS_ADDR_SLI wq_addr[8];
            PHYS_ADDR_SLI rq_addr[8];
            UEXACT16 dpp_cqid;
            UEXACT16 dpp_credits;
            UEXACT32 rbq_id;
            PHYS_ADDR_SLI r2t_addr[4];
         } SG_PACK ; // unnamed struct
         u32 dw[50]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_QP_PARAMS_IN_SLI, *PRDMA_CREATE_QP_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_QP_PARAMS_IN, sizeof (RDMA_CREATE_QP_PARAMS_IN_SLI) == 200);


#else

   typedef struct _RDMA_CREATE_QP_PARAMS_IN_SLI {
      union {
         struct { 
            u32 pd_id : 16;                       // DWORD 0
            u32 sq_page_size : 3;                 // DWORD 0
            u32 rq_page_size : 3;                 // DWORD 0
            u32 rpir_blk_size : 4;                // DWORD 0
            u32 rsvd0 : 3;                        // DWORD 0
            u32 transport_type : 3;               // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 max_wqe;
            UEXACT16 max_sge_write;
            UEXACT16 max_sge_send;
            u32 fmr_en : 1;                       // DWORD 3
            u32 zero_stagen : 1;                  // DWORD 3
            u32 bind_memwin : 1;                  // DWORD 3
            u32 inb_wren : 1;                     // DWORD 3
            u32 inb_rden : 1;                     // DWORD 3
            u32 use_srq : 1;                      // DWORD 3
            u32 enable_rpir : 1;                  // DWORD 3
            u32 enable_dpp : 1;                   // DWORD 3
            u32 enable_dpp_cqe : 1;               // DWORD 3
            u32 signaled_qp : 1;                  // DWORD 3
            u32 rsvd1 : 6;                        // DWORD 3
            u32 max_sge_recv : 16;                // DWORD 3
            UEXACT16 max_ird;
            UEXACT16 max_ord;
            UEXACT16 num_rq_pages;
            UEXACT16 num_wq_pages;
            UEXACT16 rqe_size;
            UEXACT16 wqe_size;
            UEXACT16 rq_cqid;
            UEXACT16 wq_cqid;
            PHYS_ADDR_SLI wq_addr[8];
            PHYS_ADDR_SLI rq_addr[8];
            UEXACT16 dpp_cqid;
            UEXACT16 dpp_credits;
            UEXACT32 rbq_id;
            PHYS_ADDR_SLI r2t_addr[4];
         } SG_PACK ; // unnamed struct
         u32 dw[50]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_QP_PARAMS_IN_SLI, *PRDMA_CREATE_QP_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_QP_PARAMS_IN, sizeof (RDMA_CREATE_QP_PARAMS_IN_SLI) == 200);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_QP_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0 : 16;                       // DWORD 0
            u32 qp_id : 16;                       // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 max_wqe;
            UEXACT16 max_sge_write;
            UEXACT16 max_sge_send;
            u32 max_sge_recv : 16;                // DWORD 3
            u32 rsvd1 : 16;                       // DWORD 3
            UEXACT16 max_ird;
            UEXACT16 max_ord;
            UEXACT16 rq_id;
            UEXACT16 sq_id;
            u32 dpp_credits : 16;                 // DWORD 6
            u32 dpp_page_offset : 15;             // DWORD 6
            u32 dpp_enabled : 1;                  // DWORD 6
         } SG_PACK ; // unnamed struct
         u32 dw[7]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_QP_PARAMS_OUT_SLI, *PRDMA_CREATE_QP_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_QP_PARAMS_OUT, sizeof (RDMA_CREATE_QP_PARAMS_OUT_SLI) == 28);


#else

   typedef struct _RDMA_CREATE_QP_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 qp_id : 16;                       // DWORD 0
            u32 rsvd0 : 16;                       // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 max_wqe;
            UEXACT16 max_sge_write;
            UEXACT16 max_sge_send;
            u32 rsvd1 : 16;                       // DWORD 3
            u32 max_sge_recv : 16;                // DWORD 3
            UEXACT16 max_ird;
            UEXACT16 max_ord;
            UEXACT16 rq_id;
            UEXACT16 sq_id;
            u32 dpp_enabled : 1;                  // DWORD 6
            u32 dpp_page_offset : 15;             // DWORD 6
            u32 dpp_credits : 16;                 // DWORD 6
         } SG_PACK ; // unnamed struct
         u32 dw[7]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_QP_PARAMS_OUT_SLI, *PRDMA_CREATE_QP_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_QP_PARAMS_OUT, sizeof (RDMA_CREATE_QP_PARAMS_OUT_SLI) == 28);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_QP_PARAMS_SLI {
      union {
         union { 
            RDMA_CREATE_QP_PARAMS_IN_SLI request;
            RDMA_CREATE_QP_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[50]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_QP_PARAMS_SLI, *PRDMA_CREATE_QP_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_QP_PARAMS, sizeof (RDMA_CREATE_QP_PARAMS_SLI) == 200);


#else

   typedef struct _RDMA_CREATE_QP_PARAMS_SLI {
      union {
         union { 
            RDMA_CREATE_QP_PARAMS_IN_SLI request;
            RDMA_CREATE_QP_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[50]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_QP_PARAMS_SLI, *PRDMA_CREATE_QP_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_QP_PARAMS, sizeof (RDMA_CREATE_QP_PARAMS_SLI) == 200);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_CREATE_QP_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_CREATE_QP_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[54]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_CREATE_QP_SLI, *PIOCTL_RDMA_CREATE_QP_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_CREATE_QP, sizeof (IOCTL_RDMA_CREATE_QP_SLI) == 216);


#else

   typedef struct _IOCTL_RDMA_CREATE_QP_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_CREATE_QP_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[54]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_CREATE_QP_SLI, *PIOCTL_RDMA_CREATE_QP_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_CREATE_QP, sizeof (IOCTL_RDMA_CREATE_QP_SLI) == 216);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_QP_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 16;                       // DWORD 0
            u32 qp_id : 16;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_QP_PARAMS_IN_SLI, *PRDMA_QUERY_QP_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_QP_PARAMS_IN, sizeof (RDMA_QUERY_QP_PARAMS_IN_SLI) == 4);


#else

   typedef struct _RDMA_QUERY_QP_PARAMS_IN_SLI {
      union {
         struct { 
            u32 qp_id : 16;                       // DWORD 0
            u32 rsvd0 : 16;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_QP_PARAMS_IN_SLI, *PRDMA_QUERY_QP_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_QP_PARAMS_IN, sizeof (RDMA_QUERY_QP_PARAMS_IN_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_QP_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0 : 16;                       // DWORD 0
            u32 srq_id : 16;                      // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 max_wqe;
            UEXACT16 max_sge_write;
            UEXACT16 max_sge_send;
            u32 max_sge_recv : 16;                // DWORD 3
            u32 rsvd1 : 8;                        // DWORD 3
            u32 qp_state : 3;                     // DWORD 3
            u32 inb_rden : 1;                     // DWORD 3
            u32 inb_wren : 1;                     // DWORD 3
            u32 bind_memwin : 1;                  // DWORD 3
            u32 zero_stagen : 1;                  // DWORD 3
            u32 fmr_en : 1;                       // DWORD 3
            UEXACT16 max_ird;
            UEXACT16 max_ord;
            UEXACT16 rq_cqid;
            UEXACT16 wq_cqid;
            u32 hop_cnt : 8;                      // DWORD 6
            u32 rq_psn : 24;                      // DWORD 6
            u32 tclass : 8;                       // DWORD 7
            u32 sq_psn : 24;                      // DWORD 7
            u32 ack_timeout : 5;                  // DWORD 8
            u32 rnr_retry_cnt : 3;                // DWORD 8
            u32 dest_qp_id : 24;                  // DWORD 8
            u32 path_mtu : 14;                    // DWORD 9
            u32 rsvd2 : 2;                        // DWORD 9
            u32 pkey_index : 16;                  // DWORD 9
            u32 rnr_nak_timer : 5;                // DWORD 10
            u32 retry_cnt : 3;                    // DWORD 10
            u32 sl : 4;                           // DWORD 10
            u32 flow_label : 20;                  // DWORD 10
            UEXACT8 sgid[16];
            UEXACT8 dgid[16];
            UEXACT32 dmac_b0_to_b3;
            u32 rsvd3 : 16;                       // DWORD 20
            u32 dmac_b4_to_b5 : 16;               // DWORD 20
            UEXACT32 qkey;
         } SG_PACK ; // unnamed struct
         u32 dw[22]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_QP_PARAMS_OUT_SLI, *PRDMA_QUERY_QP_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_QP_PARAMS_OUT, sizeof (RDMA_QUERY_QP_PARAMS_OUT_SLI) == 88);


#else

   typedef struct _RDMA_QUERY_QP_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 srq_id : 16;                      // DWORD 0
            u32 rsvd0 : 16;                       // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 max_wqe;
            UEXACT16 max_sge_write;
            UEXACT16 max_sge_send;
            u32 fmr_en : 1;                       // DWORD 3
            u32 zero_stagen : 1;                  // DWORD 3
            u32 bind_memwin : 1;                  // DWORD 3
            u32 inb_wren : 1;                     // DWORD 3
            u32 inb_rden : 1;                     // DWORD 3
            u32 qp_state : 3;                     // DWORD 3
            u32 rsvd1 : 8;                        // DWORD 3
            u32 max_sge_recv : 16;                // DWORD 3
            UEXACT16 max_ird;
            UEXACT16 max_ord;
            UEXACT16 rq_cqid;
            UEXACT16 wq_cqid;
            u32 rq_psn : 24;                      // DWORD 6
            u32 hop_cnt : 8;                      // DWORD 6
            u32 sq_psn : 24;                      // DWORD 7
            u32 tclass : 8;                       // DWORD 7
            u32 dest_qp_id : 24;                  // DWORD 8
            u32 rnr_retry_cnt : 3;                // DWORD 8
            u32 ack_timeout : 5;                  // DWORD 8
            u32 pkey_index : 16;                  // DWORD 9
            u32 rsvd2 : 2;                        // DWORD 9
            u32 path_mtu : 14;                    // DWORD 9
            u32 flow_label : 20;                  // DWORD 10
            u32 sl : 4;                           // DWORD 10
            u32 retry_cnt : 3;                    // DWORD 10
            u32 rnr_nak_timer : 5;                // DWORD 10
            UEXACT8 sgid[16];
            UEXACT8 dgid[16];
            UEXACT32 dmac_b0_to_b3;
            u32 dmac_b4_to_b5 : 16;               // DWORD 20
            u32 rsvd3 : 16;                       // DWORD 20
            UEXACT32 qkey;
         } SG_PACK ; // unnamed struct
         u32 dw[22]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_QP_PARAMS_OUT_SLI, *PRDMA_QUERY_QP_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_QP_PARAMS_OUT, sizeof (RDMA_QUERY_QP_PARAMS_OUT_SLI) == 88);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_QP_PARAMS_SLI {
      union {
         union { 
            RDMA_QUERY_QP_PARAMS_IN_SLI request;
            RDMA_QUERY_QP_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[22]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_QP_PARAMS_SLI, *PRDMA_QUERY_QP_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_QP_PARAMS, sizeof (RDMA_QUERY_QP_PARAMS_SLI) == 88);


#else

   typedef struct _RDMA_QUERY_QP_PARAMS_SLI {
      union {
         union { 
            RDMA_QUERY_QP_PARAMS_IN_SLI request;
            RDMA_QUERY_QP_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[22]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_QP_PARAMS_SLI, *PRDMA_QUERY_QP_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_QP_PARAMS, sizeof (RDMA_QUERY_QP_PARAMS_SLI) == 88);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_QUERY_QP_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_QUERY_QP_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[26]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_QUERY_QP_SLI, *PIOCTL_RDMA_QUERY_QP_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_QUERY_QP, sizeof (IOCTL_RDMA_QUERY_QP_SLI) == 104);


#else

   typedef struct _IOCTL_RDMA_QUERY_QP_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_QUERY_QP_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[26]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_QUERY_QP_SLI, *PIOCTL_RDMA_QUERY_QP_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_QUERY_QP, sizeof (IOCTL_RDMA_QUERY_QP_SLI) == 104);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_MODIFY_QP_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 16;                       // DWORD 0
            u32 qp_id : 16;                       // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 max_wqe;
            UEXACT16 max_sge_write;
            UEXACT16 max_sge_send;
            u32 max_sge_recv : 16;                // DWORD 3
            u32 rsvd1 : 6;                        // DWORD 3
            u32 inb_aten : 1;                     // DWORD 3
            u32 sqd_async : 1;                    // DWORD 3
            u32 qp_state : 3;                     // DWORD 3
            u32 inbrd_en : 1;                     // DWORD 3
            u32 inbwr_en : 1;                     // DWORD 3
            u32 bind_mw_en : 1;                   // DWORD 3
            u32 zero_stag_en : 1;                 // DWORD 3
            u32 fmr_en : 1;                       // DWORD 3
            UEXACT16 max_ird;
            UEXACT16 max_ord;
            UEXACT16 rq_cqid;
            UEXACT16 wq_cqid;
            u32 hop_lmt : 8;                      // DWORD 6
            u32 rq_psn : 24;                      // DWORD 6
            u32 tclass : 8;                       // DWORD 7
            u32 sq_psn : 24;                      // DWORD 7
            u32 ack_timeout : 5;                  // DWORD 8
            u32 rnr_retry_cnt : 3;                // DWORD 8
            u32 dest_qp_id : 24;                  // DWORD 8
            u32 path_mtu : 14;                    // DWORD 9
            u32 rsvd2 : 2;                        // DWORD 9
            u32 pkey_index : 16;                  // DWORD 9
            u32 rnr_nak_timer : 5;                // DWORD 10
            u32 retry_cnt : 3;                    // DWORD 10
            u32 sl : 4;                           // DWORD 10
            u32 flow_label : 20;                  // DWORD 10
            UEXACT8 sgid[16];
            UEXACT8 dgid[16];
            UEXACT32 dmac_b0_to_b3;
            UEXACT16 dmac_b4_to_b5;
            UEXACT16 vlan_id;
            UEXACT32 qkey;
            u32 rsvd3 : 5;                        // DWORD 22
            u32 vlan_valid : 1;                   // DWORD 22
            u32 inb_aten_valid : 1;               // DWORD 22
            u32 fmr_en_valid : 1;                 // DWORD 22
            u32 zstag_en_valid : 1;               // DWORD 22
            u32 bind_en_valid : 1;                // DWORD 22
            u32 flow_label_valid : 1;             // DWORD 22
            u32 inb_wren_valid : 1;               // DWORD 22
            u32 inb_rden_valid : 1;               // DWORD 22
            u32 write_sge_valid : 1;              // DWORD 22
            u32 sge_recv_valid : 1;               // DWORD 22
            u32 sge_send_valid : 1;               // DWORD 22
            u32 max_rqe_valid : 1;                // DWORD 22
            u32 max_wqe_valid : 1;                // DWORD 22
            u32 dest_qpid_valid : 1;              // DWORD 22
            u32 sq_psn_valid : 1;                 // DWORD 22
            u32 rnt_valid : 1;                    // DWORD 22
            u32 max_ord_valid : 1;                // DWORD 22
            u32 max_ird_valid : 1;                // DWORD 22
            u32 rq_psn_valid : 1;                 // DWORD 22
            u32 rrc_valid : 1;                    // DWORD 22
            u32 retry_cnt_valid : 1;              // DWORD 22
            u32 ack_to_valid : 1;                 // DWORD 22
            u32 pmtu_valid : 1;                   // DWORD 22
            u32 q_key_valid : 1;                  // DWORD 22
            u32 pkey_index_valid : 1;             // DWORD 22
            u32 sqd_async_valid : 1;              // DWORD 22
            u32 next_qp_state : 1;                // DWORD 22
         } SG_PACK ; // unnamed struct
         u32 dw[23]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_MODIFY_QP_PARAMS_IN_SLI, *PRDMA_MODIFY_QP_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_MODIFY_QP_PARAMS_IN, sizeof (RDMA_MODIFY_QP_PARAMS_IN_SLI) == 92);


#else

   typedef struct _RDMA_MODIFY_QP_PARAMS_IN_SLI {
      union {
         struct { 
            u32 qp_id : 16;                       // DWORD 0
            u32 rsvd0 : 16;                       // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 max_wqe;
            UEXACT16 max_sge_write;
            UEXACT16 max_sge_send;
            u32 fmr_en : 1;                       // DWORD 3
            u32 zero_stag_en : 1;                 // DWORD 3
            u32 bind_mw_en : 1;                   // DWORD 3
            u32 inbwr_en : 1;                     // DWORD 3
            u32 inbrd_en : 1;                     // DWORD 3
            u32 qp_state : 3;                     // DWORD 3
            u32 sqd_async : 1;                    // DWORD 3
            u32 inb_aten : 1;                     // DWORD 3
            u32 rsvd1 : 6;                        // DWORD 3
            u32 max_sge_recv : 16;                // DWORD 3
            UEXACT16 max_ird;
            UEXACT16 max_ord;
            UEXACT16 rq_cqid;
            UEXACT16 wq_cqid;
            u32 rq_psn : 24;                      // DWORD 6
            u32 hop_lmt : 8;                      // DWORD 6
            u32 sq_psn : 24;                      // DWORD 7
            u32 tclass : 8;                       // DWORD 7
            u32 dest_qp_id : 24;                  // DWORD 8
            u32 rnr_retry_cnt : 3;                // DWORD 8
            u32 ack_timeout : 5;                  // DWORD 8
            u32 pkey_index : 16;                  // DWORD 9
            u32 rsvd2 : 2;                        // DWORD 9
            u32 path_mtu : 14;                    // DWORD 9
            u32 flow_label : 20;                  // DWORD 10
            u32 sl : 4;                           // DWORD 10
            u32 retry_cnt : 3;                    // DWORD 10
            u32 rnr_nak_timer : 5;                // DWORD 10
            UEXACT8 sgid[16];
            UEXACT8 dgid[16];
            UEXACT32 dmac_b0_to_b3;
            UEXACT16 dmac_b4_to_b5;
            UEXACT16 vlan_id;
            UEXACT32 qkey;
            u32 next_qp_state : 1;                // DWORD 22
            u32 sqd_async_valid : 1;              // DWORD 22
            u32 pkey_index_valid : 1;             // DWORD 22
            u32 q_key_valid : 1;                  // DWORD 22
            u32 pmtu_valid : 1;                   // DWORD 22
            u32 ack_to_valid : 1;                 // DWORD 22
            u32 retry_cnt_valid : 1;              // DWORD 22
            u32 rrc_valid : 1;                    // DWORD 22
            u32 rq_psn_valid : 1;                 // DWORD 22
            u32 max_ird_valid : 1;                // DWORD 22
            u32 max_ord_valid : 1;                // DWORD 22
            u32 rnt_valid : 1;                    // DWORD 22
            u32 sq_psn_valid : 1;                 // DWORD 22
            u32 dest_qpid_valid : 1;              // DWORD 22
            u32 max_wqe_valid : 1;                // DWORD 22
            u32 max_rqe_valid : 1;                // DWORD 22
            u32 sge_send_valid : 1;               // DWORD 22
            u32 sge_recv_valid : 1;               // DWORD 22
            u32 write_sge_valid : 1;              // DWORD 22
            u32 inb_rden_valid : 1;               // DWORD 22
            u32 inb_wren_valid : 1;               // DWORD 22
            u32 flow_label_valid : 1;             // DWORD 22
            u32 bind_en_valid : 1;                // DWORD 22
            u32 zstag_en_valid : 1;               // DWORD 22
            u32 fmr_en_valid : 1;                 // DWORD 22
            u32 inb_aten_valid : 1;               // DWORD 22
            u32 vlan_valid : 1;                   // DWORD 22
            u32 rsvd3 : 5;                        // DWORD 22
         } SG_PACK ; // unnamed struct
         u32 dw[23]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_MODIFY_QP_PARAMS_IN_SLI, *PRDMA_MODIFY_QP_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_MODIFY_QP_PARAMS_IN, sizeof (RDMA_MODIFY_QP_PARAMS_IN_SLI) == 92);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_MODIFY_QP_PARAMS_OUT_SLI {
      UEXACT16 max_rqe;
      UEXACT16 max_wqe;
   } SG_PACK RDMA_MODIFY_QP_PARAMS_OUT_SLI, *PRDMA_MODIFY_QP_PARAMS_OUT_SLI;



#else

   typedef struct _RDMA_MODIFY_QP_PARAMS_OUT_SLI {
      UEXACT16 max_rqe;
      UEXACT16 max_wqe;
   } SG_PACK RDMA_MODIFY_QP_PARAMS_OUT_SLI, *PRDMA_MODIFY_QP_PARAMS_OUT_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_MODIFY_QP_PARAMS_SLI {
      union {
         union { 
            RDMA_MODIFY_QP_PARAMS_IN_SLI request;
            RDMA_MODIFY_QP_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[23]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_MODIFY_QP_PARAMS_SLI, *PRDMA_MODIFY_QP_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_MODIFY_QP_PARAMS, sizeof (RDMA_MODIFY_QP_PARAMS_SLI) == 92);


#else

   typedef struct _RDMA_MODIFY_QP_PARAMS_SLI {
      union {
         union { 
            RDMA_MODIFY_QP_PARAMS_IN_SLI request;
            RDMA_MODIFY_QP_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[23]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_MODIFY_QP_PARAMS_SLI, *PRDMA_MODIFY_QP_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_MODIFY_QP_PARAMS, sizeof (RDMA_MODIFY_QP_PARAMS_SLI) == 92);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_MODIFY_QP_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_MODIFY_QP_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[27]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_MODIFY_QP_SLI, *PIOCTL_RDMA_MODIFY_QP_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_MODIFY_QP, sizeof (IOCTL_RDMA_MODIFY_QP_SLI) == 108);


#else

   typedef struct _IOCTL_RDMA_MODIFY_QP_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_MODIFY_QP_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[27]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_MODIFY_QP_SLI, *PIOCTL_RDMA_MODIFY_QP_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_MODIFY_QP, sizeof (IOCTL_RDMA_MODIFY_QP_SLI) == 108);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DESTROY_QP_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 16;                       // DWORD 0
            u32 qp_id : 16;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_QP_PARAMS_IN_SLI, *PRDMA_DESTROY_QP_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_QP_PARAMS_IN, sizeof (RDMA_DESTROY_QP_PARAMS_IN_SLI) == 4);


#else

   typedef struct _RDMA_DESTROY_QP_PARAMS_IN_SLI {
      union {
         struct { 
            u32 qp_id : 16;                       // DWORD 0
            u32 rsvd0 : 16;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_QP_PARAMS_IN_SLI, *PRDMA_DESTROY_QP_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_QP_PARAMS_IN, sizeof (RDMA_DESTROY_QP_PARAMS_IN_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DESTROY_QP_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_QP_PARAMS_OUT_SLI, *PRDMA_DESTROY_QP_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_QP_PARAMS_OUT, sizeof (RDMA_DESTROY_QP_PARAMS_OUT_SLI) == 4);


#else

   typedef struct _RDMA_DESTROY_QP_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_QP_PARAMS_OUT_SLI, *PRDMA_DESTROY_QP_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_QP_PARAMS_OUT, sizeof (RDMA_DESTROY_QP_PARAMS_OUT_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DESTROY_QP_PARAMS_SLI {
      union {
         union { 
            RDMA_DESTROY_QP_PARAMS_IN_SLI request;
            RDMA_DESTROY_QP_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_QP_PARAMS_SLI, *PRDMA_DESTROY_QP_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_QP_PARAMS, sizeof (RDMA_DESTROY_QP_PARAMS_SLI) == 4);


#else

   typedef struct _RDMA_DESTROY_QP_PARAMS_SLI {
      union {
         union { 
            RDMA_DESTROY_QP_PARAMS_IN_SLI request;
            RDMA_DESTROY_QP_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_QP_PARAMS_SLI, *PRDMA_DESTROY_QP_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_QP_PARAMS, sizeof (RDMA_DESTROY_QP_PARAMS_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_DESTROY_QP_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DESTROY_QP_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DESTROY_QP_SLI, *PIOCTL_RDMA_DESTROY_QP_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DESTROY_QP, sizeof (IOCTL_RDMA_DESTROY_QP_SLI) == 20);


#else

   typedef struct _IOCTL_RDMA_DESTROY_QP_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DESTROY_QP_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DESTROY_QP_SLI, *PIOCTL_RDMA_DESTROY_QP_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DESTROY_QP, sizeof (IOCTL_RDMA_DESTROY_QP_SLI) == 20);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_SRQ_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 8;                        // DWORD 0
            u32 enable_rpir : 1;                  // DWORD 0
            u32 rpir_blk_size : 4;                // DWORD 0
            u32 rq_page_size : 3;                 // DWORD 0
            u32 pd_id : 16;                       // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 max_sge_recv;
            UEXACT16 rqe_size;
            UEXACT16 max_srq_pages;
            PHYS_ADDR_SLI wq_addr[8];
            UEXACT32 rbq_id;
         } SG_PACK ; // unnamed struct
         u32 dw[20]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_SRQ_PARAMS_IN_SLI, *PRDMA_CREATE_SRQ_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_SRQ_PARAMS_IN, sizeof (RDMA_CREATE_SRQ_PARAMS_IN_SLI) == 80);


#else

   typedef struct _RDMA_CREATE_SRQ_PARAMS_IN_SLI {
      union {
         struct { 
            u32 pd_id : 16;                       // DWORD 0
            u32 rq_page_size : 3;                 // DWORD 0
            u32 rpir_blk_size : 4;                // DWORD 0
            u32 enable_rpir : 1;                  // DWORD 0
            u32 rsvd0 : 8;                        // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 max_sge_recv;
            UEXACT16 rqe_size;
            UEXACT16 max_srq_pages;
            PHYS_ADDR_SLI wq_addr[8];
            UEXACT32 rbq_id;
         } SG_PACK ; // unnamed struct
         u32 dw[20]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_SRQ_PARAMS_IN_SLI, *PRDMA_CREATE_SRQ_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_SRQ_PARAMS_IN, sizeof (RDMA_CREATE_SRQ_PARAMS_IN_SLI) == 80);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_SRQ_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0 : 8;                        // DWORD 0
            u32 srq_id : 24;                      // DWORD 0
            UEXACT16 max_rqe_alloc;
            UEXACT16 max_sge_recv_alloc;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_SRQ_PARAMS_OUT_SLI, *PRDMA_CREATE_SRQ_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_SRQ_PARAMS_OUT, sizeof (RDMA_CREATE_SRQ_PARAMS_OUT_SLI) == 8);


#else

   typedef struct _RDMA_CREATE_SRQ_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 srq_id : 24;                      // DWORD 0
            u32 rsvd0 : 8;                        // DWORD 0
            UEXACT16 max_rqe_alloc;
            UEXACT16 max_sge_recv_alloc;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_SRQ_PARAMS_OUT_SLI, *PRDMA_CREATE_SRQ_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_SRQ_PARAMS_OUT, sizeof (RDMA_CREATE_SRQ_PARAMS_OUT_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_CREATE_SRQ_PARAMS_SLI {
      union {
         union { 
            RDMA_CREATE_SRQ_PARAMS_IN_SLI request;
            RDMA_CREATE_SRQ_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[20]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_SRQ_PARAMS_SLI, *PRDMA_CREATE_SRQ_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_SRQ_PARAMS, sizeof (RDMA_CREATE_SRQ_PARAMS_SLI) == 80);


#else

   typedef struct _RDMA_CREATE_SRQ_PARAMS_SLI {
      union {
         union { 
            RDMA_CREATE_SRQ_PARAMS_IN_SLI request;
            RDMA_CREATE_SRQ_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[20]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_CREATE_SRQ_PARAMS_SLI, *PRDMA_CREATE_SRQ_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_CREATE_SRQ_PARAMS, sizeof (RDMA_CREATE_SRQ_PARAMS_SLI) == 80);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_CREATE_SRQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_CREATE_SRQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[24]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_CREATE_SRQ_SLI, *PIOCTL_RDMA_CREATE_SRQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_CREATE_SRQ, sizeof (IOCTL_RDMA_CREATE_SRQ_SLI) == 96);


#else

   typedef struct _IOCTL_RDMA_CREATE_SRQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_CREATE_SRQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[24]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_CREATE_SRQ_SLI, *PIOCTL_RDMA_CREATE_SRQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_CREATE_SRQ, sizeof (IOCTL_RDMA_CREATE_SRQ_SLI) == 96);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_SRQ_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 8;                        // DWORD 0
            u32 srq_id : 24;                      // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_SRQ_PARAMS_IN_SLI, *PRDMA_QUERY_SRQ_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_SRQ_PARAMS_IN, sizeof (RDMA_QUERY_SRQ_PARAMS_IN_SLI) == 4);


#else

   typedef struct _RDMA_QUERY_SRQ_PARAMS_IN_SLI {
      union {
         struct { 
            u32 srq_id : 24;                      // DWORD 0
            u32 rsvd0 : 8;                        // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_SRQ_PARAMS_IN_SLI, *PRDMA_QUERY_SRQ_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_SRQ_PARAMS_IN, sizeof (RDMA_QUERY_SRQ_PARAMS_IN_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_SRQ_PARAMS_OUT_SLI {
      union {
         struct { 
            UEXACT16 pd_id;
            UEXACT16 max_rqe;
            UEXACT16 max_sge_recv;
            UEXACT16 srq_limit;
            u32 rsvd2 : 2;                        // DWORD 2
            u32 rpir_blk_size : 4;                // DWORD 2
            u32 rsvd1 : 1;                        // DWORD 2
            u32 rpir_enabled : 1;                 // DWORD 2
            u32 rsvd0 : 24;                       // DWORD 2
            UEXACT32 rbq_id;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_SRQ_PARAMS_OUT_SLI, *PRDMA_QUERY_SRQ_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_SRQ_PARAMS_OUT, sizeof (RDMA_QUERY_SRQ_PARAMS_OUT_SLI) == 16);


#else

   typedef struct _RDMA_QUERY_SRQ_PARAMS_OUT_SLI {
      union {
         struct { 
            UEXACT16 pd_id;
            UEXACT16 max_rqe;
            UEXACT16 max_sge_recv;
            UEXACT16 srq_limit;
            u32 rsvd0 : 24;                       // DWORD 2
            u32 rpir_enabled : 1;                 // DWORD 2
            u32 rsvd1 : 1;                        // DWORD 2
            u32 rpir_blk_size : 4;                // DWORD 2
            u32 rsvd2 : 2;                        // DWORD 2
            UEXACT32 rbq_id;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_SRQ_PARAMS_OUT_SLI, *PRDMA_QUERY_SRQ_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_SRQ_PARAMS_OUT, sizeof (RDMA_QUERY_SRQ_PARAMS_OUT_SLI) == 16);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_SRQ_PARAMS_SLI {
      union {
         union { 
            RDMA_QUERY_SRQ_PARAMS_IN_SLI request;
            RDMA_QUERY_SRQ_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_SRQ_PARAMS_SLI, *PRDMA_QUERY_SRQ_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_SRQ_PARAMS, sizeof (RDMA_QUERY_SRQ_PARAMS_SLI) == 16);


#else

   typedef struct _RDMA_QUERY_SRQ_PARAMS_SLI {
      union {
         union { 
            RDMA_QUERY_SRQ_PARAMS_IN_SLI request;
            RDMA_QUERY_SRQ_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[4]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_SRQ_PARAMS_SLI, *PRDMA_QUERY_SRQ_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_SRQ_PARAMS, sizeof (RDMA_QUERY_SRQ_PARAMS_SLI) == 16);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_QUERY_SRQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_QUERY_SRQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[8]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_QUERY_SRQ_SLI, *PIOCTL_RDMA_QUERY_SRQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_QUERY_SRQ, sizeof (IOCTL_RDMA_QUERY_SRQ_SLI) == 32);


#else

   typedef struct _IOCTL_RDMA_QUERY_SRQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_QUERY_SRQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[8]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_QUERY_SRQ_SLI, *PIOCTL_RDMA_QUERY_SRQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_QUERY_SRQ, sizeof (IOCTL_RDMA_QUERY_SRQ_SLI) == 32);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_MODIFY_SRQ_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 8;                        // DWORD 0
            u32 srq_id : 24;                      // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 srq_limit;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_MODIFY_SRQ_PARAMS_IN_SLI, *PRDMA_MODIFY_SRQ_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_MODIFY_SRQ_PARAMS_IN, sizeof (RDMA_MODIFY_SRQ_PARAMS_IN_SLI) == 8);


#else

   typedef struct _RDMA_MODIFY_SRQ_PARAMS_IN_SLI {
      union {
         struct { 
            u32 srq_id : 24;                      // DWORD 0
            u32 rsvd0 : 8;                        // DWORD 0
            UEXACT16 max_rqe;
            UEXACT16 srq_limit;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_MODIFY_SRQ_PARAMS_IN_SLI, *PRDMA_MODIFY_SRQ_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_MODIFY_SRQ_PARAMS_IN, sizeof (RDMA_MODIFY_SRQ_PARAMS_IN_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_MODIFY_SRQ_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0 : 16;                       // DWORD 0
            u32 max_rqe : 16;                     // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_MODIFY_SRQ_PARAMS_OUT_SLI, *PRDMA_MODIFY_SRQ_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_MODIFY_SRQ_PARAMS_OUT, sizeof (RDMA_MODIFY_SRQ_PARAMS_OUT_SLI) == 4);


#else

   typedef struct _RDMA_MODIFY_SRQ_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 max_rqe : 16;                     // DWORD 0
            u32 rsvd0 : 16;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_MODIFY_SRQ_PARAMS_OUT_SLI, *PRDMA_MODIFY_SRQ_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_MODIFY_SRQ_PARAMS_OUT, sizeof (RDMA_MODIFY_SRQ_PARAMS_OUT_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_MODIFY_SRQ_PARAMS_SLI {
      union {
         union { 
            RDMA_MODIFY_SRQ_PARAMS_IN_SLI request;
            RDMA_MODIFY_SRQ_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_MODIFY_SRQ_PARAMS_SLI, *PRDMA_MODIFY_SRQ_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_MODIFY_SRQ_PARAMS, sizeof (RDMA_MODIFY_SRQ_PARAMS_SLI) == 8);


#else

   typedef struct _RDMA_MODIFY_SRQ_PARAMS_SLI {
      union {
         union { 
            RDMA_MODIFY_SRQ_PARAMS_IN_SLI request;
            RDMA_MODIFY_SRQ_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_MODIFY_SRQ_PARAMS_SLI, *PRDMA_MODIFY_SRQ_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_MODIFY_SRQ_PARAMS, sizeof (RDMA_MODIFY_SRQ_PARAMS_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_MODIFY_SRQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_MODIFY_SRQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[6]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_MODIFY_SRQ_SLI, *PIOCTL_RDMA_MODIFY_SRQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_MODIFY_SRQ, sizeof (IOCTL_RDMA_MODIFY_SRQ_SLI) == 24);


#else

   typedef struct _IOCTL_RDMA_MODIFY_SRQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_MODIFY_SRQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[6]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_MODIFY_SRQ_SLI, *PIOCTL_RDMA_MODIFY_SRQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_MODIFY_SRQ, sizeof (IOCTL_RDMA_MODIFY_SRQ_SLI) == 24);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DESTROY_SRQ_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 8;                        // DWORD 0
            u32 srq_id : 24;                      // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_SRQ_PARAMS_IN_SLI, *PRDMA_DESTROY_SRQ_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_SRQ_PARAMS_IN, sizeof (RDMA_DESTROY_SRQ_PARAMS_IN_SLI) == 4);


#else

   typedef struct _RDMA_DESTROY_SRQ_PARAMS_IN_SLI {
      union {
         struct { 
            u32 srq_id : 24;                      // DWORD 0
            u32 rsvd0 : 8;                        // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_SRQ_PARAMS_IN_SLI, *PRDMA_DESTROY_SRQ_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_SRQ_PARAMS_IN, sizeof (RDMA_DESTROY_SRQ_PARAMS_IN_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DESTROY_SRQ_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_SRQ_PARAMS_OUT_SLI, *PRDMA_DESTROY_SRQ_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_SRQ_PARAMS_OUT, sizeof (RDMA_DESTROY_SRQ_PARAMS_OUT_SLI) == 4);


#else

   typedef struct _RDMA_DESTROY_SRQ_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_SRQ_PARAMS_OUT_SLI, *PRDMA_DESTROY_SRQ_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_SRQ_PARAMS_OUT, sizeof (RDMA_DESTROY_SRQ_PARAMS_OUT_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DESTROY_SRQ_PARAMS_SLI {
      union {
         union { 
            RDMA_DESTROY_SRQ_PARAMS_IN_SLI request;
            RDMA_DESTROY_SRQ_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_SRQ_PARAMS_SLI, *PRDMA_DESTROY_SRQ_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_SRQ_PARAMS, sizeof (RDMA_DESTROY_SRQ_PARAMS_SLI) == 4);


#else

   typedef struct _RDMA_DESTROY_SRQ_PARAMS_SLI {
      union {
         union { 
            RDMA_DESTROY_SRQ_PARAMS_IN_SLI request;
            RDMA_DESTROY_SRQ_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DESTROY_SRQ_PARAMS_SLI, *PRDMA_DESTROY_SRQ_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DESTROY_SRQ_PARAMS, sizeof (RDMA_DESTROY_SRQ_PARAMS_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_DESTROY_SRQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DESTROY_SRQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DESTROY_SRQ_SLI, *PIOCTL_RDMA_DESTROY_SRQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DESTROY_SRQ, sizeof (IOCTL_RDMA_DESTROY_SRQ_SLI) == 20);


#else

   typedef struct _IOCTL_RDMA_DESTROY_SRQ_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DESTROY_SRQ_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DESTROY_SRQ_SLI, *PIOCTL_RDMA_DESTROY_SRQ_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DESTROY_SRQ, sizeof (IOCTL_RDMA_DESTROY_SRQ_SLI) == 20);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_ALLOC_STAG_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 16;                       // DWORD 0
            u32 pd_id : 16;                       // DWORD 0
            u32 pbl_size : 16;                    // DWORD 1
            u32 rsvd1 : 9;                        // DWORD 1
            u32 remote_atomic : 1;                // DWORD 1
            u32 local_wr : 1;                     // DWORD 1
            u32 remote_rd : 1;                    // DWORD 1
            u32 remote_wr : 1;                    // DWORD 1
            u32 remote_inv : 1;                   // DWORD 1
            u32 fmr : 1;                          // DWORD 1
            u32 addr_check : 1;                   // DWORD 1
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_STAG_PARAMS_IN_SLI, *PRDMA_ALLOC_STAG_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_STAG_PARAMS_IN, sizeof (RDMA_ALLOC_STAG_PARAMS_IN_SLI) == 8);


#else

   typedef struct _RDMA_ALLOC_STAG_PARAMS_IN_SLI {
      union {
         struct { 
            u32 pd_id : 16;                       // DWORD 0
            u32 rsvd0 : 16;                       // DWORD 0
            u32 addr_check : 1;                   // DWORD 1
            u32 fmr : 1;                          // DWORD 1
            u32 remote_inv : 1;                   // DWORD 1
            u32 remote_wr : 1;                    // DWORD 1
            u32 remote_rd : 1;                    // DWORD 1
            u32 local_wr : 1;                     // DWORD 1
            u32 remote_atomic : 1;                // DWORD 1
            u32 rsvd1 : 9;                        // DWORD 1
            u32 pbl_size : 16;                    // DWORD 1
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_STAG_PARAMS_IN_SLI, *PRDMA_ALLOC_STAG_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_STAG_PARAMS_IN, sizeof (RDMA_ALLOC_STAG_PARAMS_IN_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_ALLOC_STAG_PARAMS_OUT_SLI {
      union {
         struct { 
            UEXACT32 lrkey_index;
            u32 pbl_size : 16;                    // DWORD 1
            u32 rsvd0 : 16;                       // DWORD 1
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_STAG_PARAMS_OUT_SLI, *PRDMA_ALLOC_STAG_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_STAG_PARAMS_OUT, sizeof (RDMA_ALLOC_STAG_PARAMS_OUT_SLI) == 8);


#else

   typedef struct _RDMA_ALLOC_STAG_PARAMS_OUT_SLI {
      union {
         struct { 
            UEXACT32 lrkey_index;
            u32 rsvd0 : 16;                       // DWORD 1
            u32 pbl_size : 16;                    // DWORD 1
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_STAG_PARAMS_OUT_SLI, *PRDMA_ALLOC_STAG_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_STAG_PARAMS_OUT, sizeof (RDMA_ALLOC_STAG_PARAMS_OUT_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_ALLOC_STAG_PARAMS_SLI {
      union {
         union { 
            RDMA_ALLOC_STAG_PARAMS_IN_SLI request;
            RDMA_ALLOC_STAG_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_STAG_PARAMS_SLI, *PRDMA_ALLOC_STAG_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_STAG_PARAMS, sizeof (RDMA_ALLOC_STAG_PARAMS_SLI) == 8);


#else

   typedef struct _RDMA_ALLOC_STAG_PARAMS_SLI {
      union {
         union { 
            RDMA_ALLOC_STAG_PARAMS_IN_SLI request;
            RDMA_ALLOC_STAG_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_STAG_PARAMS_SLI, *PRDMA_ALLOC_STAG_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_STAG_PARAMS, sizeof (RDMA_ALLOC_STAG_PARAMS_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_ALLOC_STAG_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_ALLOC_STAG_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[6]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_ALLOC_STAG_SLI, *PIOCTL_RDMA_ALLOC_STAG_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_ALLOC_STAG, sizeof (IOCTL_RDMA_ALLOC_STAG_SLI) == 24);


#else

   typedef struct _IOCTL_RDMA_ALLOC_STAG_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_ALLOC_STAG_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[6]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_ALLOC_STAG_SLI, *PIOCTL_RDMA_ALLOC_STAG_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_ALLOC_STAG, sizeof (IOCTL_RDMA_ALLOC_STAG_SLI) == 24);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DEALLOC_STAG_PARAMS_IN_SLI {
      union {
         struct { 
            UEXACT32 lrkey_index;
            u32 rsvd0 : 31;                       // DWORD 1
            u32 fmr : 1;                          // DWORD 1
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DEALLOC_STAG_PARAMS_IN_SLI, *PRDMA_DEALLOC_STAG_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DEALLOC_STAG_PARAMS_IN, sizeof (RDMA_DEALLOC_STAG_PARAMS_IN_SLI) == 8);


#else

   typedef struct _RDMA_DEALLOC_STAG_PARAMS_IN_SLI {
      union {
         struct { 
            UEXACT32 lrkey_index;
            u32 fmr : 1;                          // DWORD 1
            u32 rsvd0 : 31;                       // DWORD 1
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DEALLOC_STAG_PARAMS_IN_SLI, *PRDMA_DEALLOC_STAG_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DEALLOC_STAG_PARAMS_IN, sizeof (RDMA_DEALLOC_STAG_PARAMS_IN_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DEALLOC_STAG_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DEALLOC_STAG_PARAMS_OUT_SLI, *PRDMA_DEALLOC_STAG_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DEALLOC_STAG_PARAMS_OUT, sizeof (RDMA_DEALLOC_STAG_PARAMS_OUT_SLI) == 4);


#else

   typedef struct _RDMA_DEALLOC_STAG_PARAMS_OUT_SLI {
      union {
         struct { 
            u32 rsvd0[1];                         // DWORDS 0 to 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DEALLOC_STAG_PARAMS_OUT_SLI, *PRDMA_DEALLOC_STAG_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DEALLOC_STAG_PARAMS_OUT, sizeof (RDMA_DEALLOC_STAG_PARAMS_OUT_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_DEALLOC_STAG_PARAMS_SLI {
      union {
         union { 
            RDMA_DEALLOC_STAG_PARAMS_IN_SLI request;
            RDMA_DEALLOC_STAG_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DEALLOC_STAG_PARAMS_SLI, *PRDMA_DEALLOC_STAG_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DEALLOC_STAG_PARAMS, sizeof (RDMA_DEALLOC_STAG_PARAMS_SLI) == 8);


#else

   typedef struct _RDMA_DEALLOC_STAG_PARAMS_SLI {
      union {
         union { 
            RDMA_DEALLOC_STAG_PARAMS_IN_SLI request;
            RDMA_DEALLOC_STAG_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_DEALLOC_STAG_PARAMS_SLI, *PRDMA_DEALLOC_STAG_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_DEALLOC_STAG_PARAMS, sizeof (RDMA_DEALLOC_STAG_PARAMS_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_DEALLOC_STAG_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DEALLOC_STAG_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[6]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DEALLOC_STAG_SLI, *PIOCTL_RDMA_DEALLOC_STAG_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DEALLOC_STAG, sizeof (IOCTL_RDMA_DEALLOC_STAG_SLI) == 24);


#else

   typedef struct _IOCTL_RDMA_DEALLOC_STAG_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_DEALLOC_STAG_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[6]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_DEALLOC_STAG_SLI, *PIOCTL_RDMA_DEALLOC_STAG_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_DEALLOC_STAG, sizeof (IOCTL_RDMA_DEALLOC_STAG_SLI) == 24);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_REGISTER_NSMR_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 31;                       // DWORD 0
            u32 frmr : 1;                         // DWORD 0
            UEXACT16 pd_id;
            UEXACT16 num_pbl;
            u32 last : 1;                         // DWORD 2
            u32 remote_atomic : 1;                // DWORD 2
            u32 local_wr : 1;                     // DWORD 2
            u32 remote_rd : 1;                    // DWORD 2
            u32 remote_wr : 1;                    // DWORD 2
            u32 remote_inv : 1;                   // DWORD 2
            u32 zb_offset : 1;                    // DWORD 2
            u32 bind_memwin : 1;                  // DWORD 2
            u32 hpage_size : 8;                   // DWORD 2
            u32 pbe_size : 16;                    // DWORD 2
            UEXACT32 totlen_low;
            UEXACT32 totlen_high;
            UEXACT32 fbo_low;
            UEXACT32 fbo_high;
            UEXACT32 va_loaddr;
            UEXACT32 va_hiaddr;
            PHYS_ADDR_SLI pbl_addr[22];
         } SG_PACK ; // unnamed struct
         u32 dw[53]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_REGISTER_NSMR_PARAMS_IN_SLI, *PRDMA_REGISTER_NSMR_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_REGISTER_NSMR_PARAMS_IN, sizeof (RDMA_REGISTER_NSMR_PARAMS_IN_SLI) == 212);


#else

   typedef struct _RDMA_REGISTER_NSMR_PARAMS_IN_SLI {
      union {
         struct { 
            u32 frmr : 1;                         // DWORD 0
            u32 rsvd0 : 31;                       // DWORD 0
            UEXACT16 pd_id;
            UEXACT16 num_pbl;
            u32 pbe_size : 16;                    // DWORD 2
            u32 hpage_size : 8;                   // DWORD 2
            u32 bind_memwin : 1;                  // DWORD 2
            u32 zb_offset : 1;                    // DWORD 2
            u32 remote_inv : 1;                   // DWORD 2
            u32 remote_wr : 1;                    // DWORD 2
            u32 remote_rd : 1;                    // DWORD 2
            u32 local_wr : 1;                     // DWORD 2
            u32 remote_atomic : 1;                // DWORD 2
            u32 last : 1;                         // DWORD 2
            UEXACT32 totlen_low;
            UEXACT32 totlen_high;
            UEXACT32 fbo_low;
            UEXACT32 fbo_high;
            UEXACT32 va_loaddr;
            UEXACT32 va_hiaddr;
            PHYS_ADDR_SLI pbl_addr[22];
         } SG_PACK ; // unnamed struct
         u32 dw[53]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_REGISTER_NSMR_PARAMS_IN_SLI, *PRDMA_REGISTER_NSMR_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_REGISTER_NSMR_PARAMS_IN, sizeof (RDMA_REGISTER_NSMR_PARAMS_IN_SLI) == 212);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_REGISTER_NSMR_PARAMS_OUT_SLI {
      union {
         struct { 
            UEXACT32 stag;
            u32 num_pbl : 16;                     // DWORD 1
            u32 rsvd0 : 16;                       // DWORD 1
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_REGISTER_NSMR_PARAMS_OUT_SLI, *PRDMA_REGISTER_NSMR_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_REGISTER_NSMR_PARAMS_OUT, sizeof (RDMA_REGISTER_NSMR_PARAMS_OUT_SLI) == 8);


#else

   typedef struct _RDMA_REGISTER_NSMR_PARAMS_OUT_SLI {
      union {
         struct { 
            UEXACT32 stag;
            u32 rsvd0 : 16;                       // DWORD 1
            u32 num_pbl : 16;                     // DWORD 1
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_REGISTER_NSMR_PARAMS_OUT_SLI, *PRDMA_REGISTER_NSMR_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_REGISTER_NSMR_PARAMS_OUT, sizeof (RDMA_REGISTER_NSMR_PARAMS_OUT_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_REGISTER_NSMR_PARAMS_SLI {
      union {
         union { 
            RDMA_REGISTER_NSMR_PARAMS_IN_SLI request;
            RDMA_REGISTER_NSMR_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[53]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_REGISTER_NSMR_PARAMS_SLI, *PRDMA_REGISTER_NSMR_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_REGISTER_NSMR_PARAMS, sizeof (RDMA_REGISTER_NSMR_PARAMS_SLI) == 212);


#else

   typedef struct _RDMA_REGISTER_NSMR_PARAMS_SLI {
      union {
         union { 
            RDMA_REGISTER_NSMR_PARAMS_IN_SLI request;
            RDMA_REGISTER_NSMR_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[53]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_REGISTER_NSMR_PARAMS_SLI, *PRDMA_REGISTER_NSMR_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_REGISTER_NSMR_PARAMS, sizeof (RDMA_REGISTER_NSMR_PARAMS_SLI) == 212);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_REGISTER_NSMR_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_REGISTER_NSMR_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[57]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_REGISTER_NSMR_SLI, *PIOCTL_RDMA_REGISTER_NSMR_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_REGISTER_NSMR, sizeof (IOCTL_RDMA_REGISTER_NSMR_SLI) == 228);


#else

   typedef struct _IOCTL_RDMA_REGISTER_NSMR_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_REGISTER_NSMR_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[57]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_REGISTER_NSMR_SLI, *PIOCTL_RDMA_REGISTER_NSMR_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_REGISTER_NSMR, sizeof (IOCTL_RDMA_REGISTER_NSMR_SLI) == 228);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI {
      union {
         struct { 
            UEXACT32 stag;
            UEXACT16 pbl_offset;
            UEXACT16 num_pbl;
            u32 last : 1;                         // DWORD 2
            u32 rsvd0 : 31;                       // DWORD 2
            PHYS_ADDR_SLI pbl_addr[22];
         } SG_PACK ; // unnamed struct
         u32 dw[47]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI, *PRDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_REGISTER_NSMR_CONT_PARAMS_IN, sizeof (RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI) == 188);


#else

   typedef struct _RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI {
      union {
         struct { 
            UEXACT32 stag;
            UEXACT16 pbl_offset;
            UEXACT16 num_pbl;
            u32 rsvd0 : 31;                       // DWORD 2
            u32 last : 1;                         // DWORD 2
            PHYS_ADDR_SLI pbl_addr[22];
         } SG_PACK ; // unnamed struct
         u32 dw[47]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI, *PRDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_REGISTER_NSMR_CONT_PARAMS_IN, sizeof (RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI) == 188);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI {
      UEXACT32 stag;
   } SG_PACK RDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI, *PRDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI;



#else

   typedef struct _RDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI {
      UEXACT32 stag;
   } SG_PACK RDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI, *PRDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_REGISTER_NSMR_CONT_PARAMS_SLI {
      union {
         union { 
            RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI request;
            RDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[47]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_REGISTER_NSMR_CONT_PARAMS_SLI, *PRDMA_REGISTER_NSMR_CONT_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_REGISTER_NSMR_CONT_PARAMS, sizeof (RDMA_REGISTER_NSMR_CONT_PARAMS_SLI) == 188);


#else

   typedef struct _RDMA_REGISTER_NSMR_CONT_PARAMS_SLI {
      union {
         union { 
            RDMA_REGISTER_NSMR_CONT_PARAMS_IN_SLI request;
            RDMA_REGISTER_NSMR_CONT_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[47]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_REGISTER_NSMR_CONT_PARAMS_SLI, *PRDMA_REGISTER_NSMR_CONT_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_REGISTER_NSMR_CONT_PARAMS, sizeof (RDMA_REGISTER_NSMR_CONT_PARAMS_SLI) == 188);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_REGISTER_NSMR_CONT_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_REGISTER_NSMR_CONT_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[51]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_REGISTER_NSMR_CONT_SLI, *PIOCTL_RDMA_REGISTER_NSMR_CONT_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_REGISTER_NSMR_CONT, sizeof (IOCTL_RDMA_REGISTER_NSMR_CONT_SLI) == 204);


#else

   typedef struct _IOCTL_RDMA_REGISTER_NSMR_CONT_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_REGISTER_NSMR_CONT_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[51]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_REGISTER_NSMR_CONT_SLI, *PIOCTL_RDMA_REGISTER_NSMR_CONT_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_REGISTER_NSMR_CONT, sizeof (IOCTL_RDMA_REGISTER_NSMR_CONT_SLI) == 204);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_NSMR_PARAMS_IN_SLI {
      UEXACT32 lkey;
   } SG_PACK RDMA_QUERY_NSMR_PARAMS_IN_SLI, *PRDMA_QUERY_NSMR_PARAMS_IN_SLI;



#else

   typedef struct _RDMA_QUERY_NSMR_PARAMS_IN_SLI {
      UEXACT32 lkey;
   } SG_PACK RDMA_QUERY_NSMR_PARAMS_IN_SLI, *PRDMA_QUERY_NSMR_PARAMS_IN_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_NSMR_PARAMS_OUT_SLI {
      union {
         struct { 
            UEXACT32 lkey;
            u32 valid : 1;                        // DWORD 1
            u32 local_rd : 1;                     // DWORD 1
            u32 local_wr : 1;                     // DWORD 1
            u32 remote_rd : 1;                    // DWORD 1
            u32 remote_wr : 1;                    // DWORD 1
            u32 remote_inv : 1;                   // DWORD 1
            u32 zb_offset : 1;                    // DWORD 1
            u32 bind_memwin : 1;                  // DWORD 1
            u32 rsvd0 : 8;                        // DWORD 1
            u32 pd_id : 16;                       // DWORD 1
            u32 rsvd1 : 16;                       // DWORD 2
            u32 num_pbl : 16;                     // DWORD 2
         } SG_PACK ; // unnamed struct
         u32 dw[3]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_NSMR_PARAMS_OUT_SLI, *PRDMA_QUERY_NSMR_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_NSMR_PARAMS_OUT, sizeof (RDMA_QUERY_NSMR_PARAMS_OUT_SLI) == 12);


#else

   typedef struct _RDMA_QUERY_NSMR_PARAMS_OUT_SLI {
      union {
         struct { 
            UEXACT32 lkey;
            u32 pd_id : 16;                       // DWORD 1
            u32 rsvd0 : 8;                        // DWORD 1
            u32 bind_memwin : 1;                  // DWORD 1
            u32 zb_offset : 1;                    // DWORD 1
            u32 remote_inv : 1;                   // DWORD 1
            u32 remote_wr : 1;                    // DWORD 1
            u32 remote_rd : 1;                    // DWORD 1
            u32 local_wr : 1;                     // DWORD 1
            u32 local_rd : 1;                     // DWORD 1
            u32 valid : 1;                        // DWORD 1
            u32 num_pbl : 16;                     // DWORD 2
            u32 rsvd1 : 16;                       // DWORD 2
         } SG_PACK ; // unnamed struct
         u32 dw[3]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_NSMR_PARAMS_OUT_SLI, *PRDMA_QUERY_NSMR_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_NSMR_PARAMS_OUT, sizeof (RDMA_QUERY_NSMR_PARAMS_OUT_SLI) == 12);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_NSMR_PARAMS_SLI {
      union {
         union { 
            RDMA_QUERY_NSMR_PARAMS_IN_SLI request;
            RDMA_QUERY_NSMR_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[3]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_NSMR_PARAMS_SLI, *PRDMA_QUERY_NSMR_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_NSMR_PARAMS, sizeof (RDMA_QUERY_NSMR_PARAMS_SLI) == 12);


#else

   typedef struct _RDMA_QUERY_NSMR_PARAMS_SLI {
      union {
         union { 
            RDMA_QUERY_NSMR_PARAMS_IN_SLI request;
            RDMA_QUERY_NSMR_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[3]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_NSMR_PARAMS_SLI, *PRDMA_QUERY_NSMR_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_NSMR_PARAMS, sizeof (RDMA_QUERY_NSMR_PARAMS_SLI) == 12);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_QUERY_NSMR_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_QUERY_NSMR_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[7]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_QUERY_NSMR_SLI, *PIOCTL_RDMA_QUERY_NSMR_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_QUERY_NSMR, sizeof (IOCTL_RDMA_QUERY_NSMR_SLI) == 28);


#else

   typedef struct _IOCTL_RDMA_QUERY_NSMR_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_QUERY_NSMR_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[7]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_QUERY_NSMR_SLI, *PIOCTL_RDMA_QUERY_NSMR_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_QUERY_NSMR, sizeof (IOCTL_RDMA_QUERY_NSMR_SLI) == 28);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_ALLOC_MW_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 16;                       // DWORD 0
            u32 pd_id : 16;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_MW_PARAMS_IN_SLI, *PRDMA_ALLOC_MW_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_MW_PARAMS_IN, sizeof (RDMA_ALLOC_MW_PARAMS_IN_SLI) == 4);


#else

   typedef struct _RDMA_ALLOC_MW_PARAMS_IN_SLI {
      union {
         struct { 
            u32 pd_id : 16;                       // DWORD 0
            u32 rsvd0 : 16;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_MW_PARAMS_IN_SLI, *PRDMA_ALLOC_MW_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_MW_PARAMS_IN, sizeof (RDMA_ALLOC_MW_PARAMS_IN_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_ALLOC_MW_PARAMS_OUT_SLI {
      UEXACT32 lkey;
   } SG_PACK RDMA_ALLOC_MW_PARAMS_OUT_SLI, *PRDMA_ALLOC_MW_PARAMS_OUT_SLI;



#else

   typedef struct _RDMA_ALLOC_MW_PARAMS_OUT_SLI {
      UEXACT32 lkey;
   } SG_PACK RDMA_ALLOC_MW_PARAMS_OUT_SLI, *PRDMA_ALLOC_MW_PARAMS_OUT_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_ALLOC_MW_PARAMS_SLI {
      union {
         union { 
            RDMA_ALLOC_MW_PARAMS_IN_SLI request;
            RDMA_ALLOC_MW_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_MW_PARAMS_SLI, *PRDMA_ALLOC_MW_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_MW_PARAMS, sizeof (RDMA_ALLOC_MW_PARAMS_SLI) == 4);


#else

   typedef struct _RDMA_ALLOC_MW_PARAMS_SLI {
      union {
         union { 
            RDMA_ALLOC_MW_PARAMS_IN_SLI request;
            RDMA_ALLOC_MW_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_ALLOC_MW_PARAMS_SLI, *PRDMA_ALLOC_MW_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_ALLOC_MW_PARAMS, sizeof (RDMA_ALLOC_MW_PARAMS_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_ALLOC_MW_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_ALLOC_MW_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_ALLOC_MW_SLI, *PIOCTL_RDMA_ALLOC_MW_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_ALLOC_MW, sizeof (IOCTL_RDMA_ALLOC_MW_SLI) == 20);


#else

   typedef struct _IOCTL_RDMA_ALLOC_MW_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_ALLOC_MW_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[5]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_ALLOC_MW_SLI, *PIOCTL_RDMA_ALLOC_MW_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_ALLOC_MW, sizeof (IOCTL_RDMA_ALLOC_MW_SLI) == 20);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_MW_PARAMS_IN_SLI {
      UEXACT32 lkey;
   } SG_PACK RDMA_QUERY_MW_PARAMS_IN_SLI, *PRDMA_QUERY_MW_PARAMS_IN_SLI;



#else

   typedef struct _RDMA_QUERY_MW_PARAMS_IN_SLI {
      UEXACT32 lkey;
   } SG_PACK RDMA_QUERY_MW_PARAMS_IN_SLI, *PRDMA_QUERY_MW_PARAMS_IN_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERY_MW_PARAMS_OUT_SLI {
      union {
         struct { 
            UEXACT32 lkey;
            u32 valid : 1;                        // DWORD 1
            u32 remote_rd : 1;                    // DWORD 1
            u32 remote_wr : 1;                    // DWORD 1
            u32 rsvd0 : 13;                       // DWORD 1
            u32 pd_id : 16;                       // DWORD 1
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_MW_PARAMS_OUT_SLI, *PRDMA_QUERY_MW_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_MW_PARAMS_OUT, sizeof (RDMA_QUERY_MW_PARAMS_OUT_SLI) == 8);


#else

   typedef struct _RDMA_QUERY_MW_PARAMS_OUT_SLI {
      union {
         struct { 
            UEXACT32 lkey;
            u32 pd_id : 16;                       // DWORD 1
            u32 rsvd0 : 13;                       // DWORD 1
            u32 remote_wr : 1;                    // DWORD 1
            u32 remote_rd : 1;                    // DWORD 1
            u32 valid : 1;                        // DWORD 1
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERY_MW_PARAMS_OUT_SLI, *PRDMA_QUERY_MW_PARAMS_OUT_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERY_MW_PARAMS_OUT, sizeof (RDMA_QUERY_MW_PARAMS_OUT_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_QUERYMW_PARAMS_SLI {
      union {
         union { 
            RDMA_QUERY_MW_PARAMS_IN_SLI request;
            RDMA_QUERY_MW_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERYMW_PARAMS_SLI, *PRDMA_QUERYMW_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERYMW_PARAMS, sizeof (RDMA_QUERYMW_PARAMS_SLI) == 8);


#else

   typedef struct _RDMA_QUERYMW_PARAMS_SLI {
      union {
         union { 
            RDMA_QUERY_MW_PARAMS_IN_SLI request;
            RDMA_QUERY_MW_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[2]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_QUERYMW_PARAMS_SLI, *PRDMA_QUERYMW_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_QUERYMW_PARAMS, sizeof (RDMA_QUERYMW_PARAMS_SLI) == 8);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_QUERY_MW_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_QUERYMW_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[6]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_QUERY_MW_SLI, *PIOCTL_RDMA_QUERY_MW_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_QUERY_MW, sizeof (IOCTL_RDMA_QUERY_MW_SLI) == 24);


#else

   typedef struct _IOCTL_RDMA_QUERY_MW_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_QUERYMW_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[6]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_QUERY_MW_SLI, *PIOCTL_RDMA_QUERY_MW_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_QUERY_MW, sizeof (IOCTL_RDMA_QUERY_MW_SLI) == 24);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _ACTIVE_RESOURCE_STATS_SLI {
      UEXACT32 active_dpp_pds;
      UEXACT32 active_non_dpp_pds;
      UEXACT32 active_rc_dpp_qps;
      UEXACT32 active_uc_dpp_qps;
      UEXACT32 active_ud_dpp_qps;
      UEXACT32 active_rc_non_dpp_qps;
      UEXACT32 rsvd0;
      UEXACT32 active_uc_non_dpp_qps;
      UEXACT32 active_ud_non_dpp_qps;
      UEXACT32 rsvd1;
      UEXACT32 active_srqs;
      UEXACT32 active_rbqs;
      UEXACT32 active_64K_nsmr;
      UEXACT32 active_64K_to_2M_nsmr;
      UEXACT32 active_2M_to_44M_nsmr;
      UEXACT32 active_44M_to_1G_nsmr;
      UEXACT32 active_1G_to_4G_nsmr;
      UEXACT32 active_nsmr_count_4G_to_32G;
      UEXACT32 active_32G_to_64G_nsmr;
      UEXACT32 active_64G_to_128G_nsmr;
      UEXACT32 active_128G_to_higher_nsmr;
      UEXACT32 active_embedded_nsmr;
      UEXACT32 active_frmr;
      UEXACT32 active_prefetch_qps;
      UEXACT32 active_ondemand_qps;
      UEXACT32 rsvd2[9];
   } SG_PACK ACTIVE_RESOURCE_STATS_SLI, *PACTIVE_RESOURCE_STATS_SLI;



#else

   typedef struct _ACTIVE_RESOURCE_STATS_SLI {
      UEXACT32 active_dpp_pds;
      UEXACT32 active_non_dpp_pds;
      UEXACT32 active_rc_dpp_qps;
      UEXACT32 active_uc_dpp_qps;
      UEXACT32 active_ud_dpp_qps;
      UEXACT32 active_rc_non_dpp_qps;
      UEXACT32 rsvd0;
      UEXACT32 active_uc_non_dpp_qps;
      UEXACT32 active_ud_non_dpp_qps;
      UEXACT32 rsvd1;
      UEXACT32 active_srqs;
      UEXACT32 active_rbqs;
      UEXACT32 active_64K_nsmr;
      UEXACT32 active_64K_to_2M_nsmr;
      UEXACT32 active_2M_to_44M_nsmr;
      UEXACT32 active_44M_to_1G_nsmr;
      UEXACT32 active_1G_to_4G_nsmr;
      UEXACT32 active_nsmr_count_4G_to_32G;
      UEXACT32 active_32G_to_64G_nsmr;
      UEXACT32 active_64G_to_128G_nsmr;
      UEXACT32 active_128G_to_higher_nsmr;
      UEXACT32 active_embedded_nsmr;
      UEXACT32 active_frmr;
      UEXACT32 active_prefetch_qps;
      UEXACT32 active_ondemand_qps;
      UEXACT32 rsvd2[9];
   } SG_PACK ACTIVE_RESOURCE_STATS_SLI, *PACTIVE_RESOURCE_STATS_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _DB_ERROR_STATS_SLI {
      UEXACT32 sq_doorbell_errors;
      UEXACT32 cq_doorbell_errors;
      UEXACT32 rq_srq_doorbell_errors;
      UEXACT32 cq_overflow_errors;
      UEXACT32 rsvd0[4];
   } SG_PACK DB_ERROR_STATS_SLI, *PDB_ERROR_STATS_SLI;



#else

   typedef struct _DB_ERROR_STATS_SLI {
      UEXACT32 sq_doorbell_errors;
      UEXACT32 cq_doorbell_errors;
      UEXACT32 rq_srq_doorbell_errors;
      UEXACT32 cq_overflow_errors;
      UEXACT32 rsvd0[4];
   } SG_PACK DB_ERROR_STATS_SLI, *PDB_ERROR_STATS_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _WQE_STATS_SLI {
      UEXACT32 large_send_rc_wqes_lo;
      UEXACT32 large_send_rc_wqee_hi;
      UEXACT32 large_write_rc_wqe_lo;
      UEXACT32 large_write_rc_wqe_hi;
      UEXACT32 rsvd0[4];
      UEXACT32 read_wqes_lo;
      UEXACT32 read_wqes_hi;
      UEXACT32 frmr_wqes_lo;
      UEXACT32 frmr_wqes_hi;
      UEXACT32 mw_bind_wqes_lo;
      UEXACT32 mw_bind_wqes_hi;
      UEXACT32 invalidate_wqes_lo;
      UEXACT32 invalidate_wqes_hi;
      UEXACT32 rsvd1[2];
      UEXACT32 dpp_wqe_drops;
      UEXACT32 rsvd2[5];
   } SG_PACK WQE_STATS_SLI, *PWQE_STATS_SLI;



#else

   typedef struct _WQE_STATS_SLI {
      UEXACT32 large_send_rc_wqes_lo;
      UEXACT32 large_send_rc_wqee_hi;
      UEXACT32 large_write_rc_wqe_lo;
      UEXACT32 large_write_rc_wqe_hi;
      UEXACT32 rsvd0[4];
      UEXACT32 read_wqes_lo;
      UEXACT32 read_wqes_hi;
      UEXACT32 frmr_wqes_lo;
      UEXACT32 frmr_wqes_hi;
      UEXACT32 mw_bind_wqes_lo;
      UEXACT32 mw_bind_wqes_hi;
      UEXACT32 invalidate_wqes_lo;
      UEXACT32 invalidate_wqes_hi;
      UEXACT32 rsvd1[2];
      UEXACT32 dpp_wqe_drops;
      UEXACT32 rsvd2[5];
   } SG_PACK WQE_STATS_SLI, *PWQE_STATS_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _TX_STATS_SLI {
      UEXACT32 send_pkts_lo;
      UEXACT32 send_pkts_hi;
      UEXACT32 write_pkts_lo;
      UEXACT32 write_pkts_hi;
      UEXACT32 read_pkts_lo;
      UEXACT32 read_pkts_hi;
      UEXACT32 read_resp_pkts_lo;
      UEXACT32 read_resp_pkts_hi;
      UEXACT32 ack_pkts_lo;
      UEXACT32 ack_pkts_hi;
      UEXACT32 send_bytes_lo;
      UEXACT32 send_bytes_hi;
      UEXACT32 write_bytes_lo;
      UEXACT32 write_bytes_hi;
      UEXACT32 read_req_bytes_lo;
      UEXACT32 read_req_bytes_hi;
      UEXACT32 read_rsp_bytes_lo;
      UEXACT32 read_rsp_bytes_hi;
      UEXACT32 ack_timeouts;
      UEXACT32 rsvd0[5];
   } SG_PACK TX_STATS_SLI, *PTX_STATS_SLI;



#else

   typedef struct _TX_STATS_SLI {
      UEXACT32 send_pkts_lo;
      UEXACT32 send_pkts_hi;
      UEXACT32 write_pkts_lo;
      UEXACT32 write_pkts_hi;
      UEXACT32 read_pkts_lo;
      UEXACT32 read_pkts_hi;
      UEXACT32 read_resp_pkts_lo;
      UEXACT32 read_resp_pkts_hi;
      UEXACT32 ack_pkts_lo;
      UEXACT32 ack_pkts_hi;
      UEXACT32 send_bytes_lo;
      UEXACT32 send_bytes_hi;
      UEXACT32 write_bytes_lo;
      UEXACT32 write_bytes_hi;
      UEXACT32 read_req_bytes_lo;
      UEXACT32 read_req_bytes_hi;
      UEXACT32 read_rsp_bytes_lo;
      UEXACT32 read_rsp_bytes_hi;
      UEXACT32 ack_timeouts;
      UEXACT32 rsvd0[5];
   } SG_PACK TX_STATS_SLI, *PTX_STATS_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _TX_QP_ERROR_STATS_SLI {
      UEXACT32 local_length_errors;
      UEXACT32 local_protection_errors;
      UEXACT32 local_qp_operation_errors;
      UEXACT32 retry_count_exceeded_errors;
      UEXACT32 rnr_retry_count_exceeded_errors;
      UEXACT32 rsvd0[3];
   } SG_PACK TX_QP_ERROR_STATS_SLI, *PTX_QP_ERROR_STATS_SLI;



#else

   typedef struct _TX_QP_ERROR_STATS_SLI {
      UEXACT32 local_length_errors;
      UEXACT32 local_protection_errors;
      UEXACT32 local_qp_operation_errors;
      UEXACT32 retry_count_exceeded_errors;
      UEXACT32 rnr_retry_count_exceeded_errors;
      UEXACT32 rsvd0[3];
   } SG_PACK TX_QP_ERROR_STATS_SLI, *PTX_QP_ERROR_STATS_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RX_STATS_SLI {
      UEXACT32 roce_frame_bytes_lo;
      UEXACT32 roce_frame_bytes_hi;
      UEXACT32 roce_frame_icrc_drops;
      UEXACT32 roce_frame_payload_len_drops;
      UEXACT32 ud_drops;
      UEXACT32 qp1_drops;
      UEXACT32 psn_error_request_packets;
      UEXACT32 psn_error_resp_packets;
      UEXACT32 rnr_nak_timeouts;
      UEXACT32 rnr_nak_receives;
      UEXACT32 roce_frame_rxmt_drops;
      UEXACT32 nak_count_psn_sequence_errors;
      UEXACT32 rc_drop_count_lookup_errors;
      UEXACT32 rq_rnr_naks;
      UEXACT32 srq_rnr_naks;
      UEXACT32 roce_frames_lo;
      UEXACT32 roce_frames_hi;
      UEXACT32 rsvd0;
   } SG_PACK RX_STATS_SLI, *PRX_STATS_SLI;



#else

   typedef struct _RX_STATS_SLI {
      UEXACT32 roce_frame_bytes_lo;
      UEXACT32 roce_frame_bytes_hi;
      UEXACT32 roce_frame_icrc_drops;
      UEXACT32 roce_frame_payload_len_drops;
      UEXACT32 ud_drops;
      UEXACT32 qp1_drops;
      UEXACT32 psn_error_request_packets;
      UEXACT32 psn_error_resp_packets;
      UEXACT32 rnr_nak_timeouts;
      UEXACT32 rnr_nak_receives;
      UEXACT32 roce_frame_rxmt_drops;
      UEXACT32 nak_count_psn_sequence_errors;
      UEXACT32 rc_drop_count_lookup_errors;
      UEXACT32 rq_rnr_naks;
      UEXACT32 srq_rnr_naks;
      UEXACT32 roce_frames_lo;
      UEXACT32 roce_frames_hi;
      UEXACT32 rsvd0;
   } SG_PACK RX_STATS_SLI, *PRX_STATS_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RX_QP_ERROR_STATS_SLI {
      UEXACT32 nak_invalid_requst_errors;
      UEXACT32 nak_remote_operation_errors;
      UEXACT32 nak_count_remote_access_errors;
      UEXACT32 local_length_errors;
      UEXACT32 local_protection_errors;
      UEXACT32 local_qp_operation_errors;
      UEXACT32 rsvd0[2];
   } SG_PACK RX_QP_ERROR_STATS_SLI, *PRX_QP_ERROR_STATS_SLI;



#else

   typedef struct _RX_QP_ERROR_STATS_SLI {
      UEXACT32 nak_invalid_requst_errors;
      UEXACT32 nak_remote_operation_errors;
      UEXACT32 nak_count_remote_access_errors;
      UEXACT32 local_length_errors;
      UEXACT32 local_protection_errors;
      UEXACT32 local_qp_operation_errors;
      UEXACT32 rsvd0[2];
   } SG_PACK RX_QP_ERROR_STATS_SLI, *PRX_QP_ERROR_STATS_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _TX_DEBUG_STATS_SLI {
      UEXACT32 debug_stats[100];
   } SG_PACK TX_DEBUG_STATS_SLI, *PTX_DEBUG_STATS_SLI;



#else

   typedef struct _TX_DEBUG_STATS_SLI {
      UEXACT32 debug_stats[100];
   } SG_PACK TX_DEBUG_STATS_SLI, *PTX_DEBUG_STATS_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RX_DEBUG_STATS_SLI {
      UEXACT32 debug_stats[200];
   } SG_PACK RX_DEBUG_STATS_SLI, *PRX_DEBUG_STATS_SLI;



#else

   typedef struct _RX_DEBUG_STATS_SLI {
      UEXACT32 debug_stats[200];
   } SG_PACK RX_DEBUG_STATS_SLI, *PRX_DEBUG_STATS_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_GET_STATS_PARAMS_IN_SLI {
      union {
         struct { 
            u32 rsvd0 : 24;                       // DWORD 0
            u32 reset_stat : 8;                   // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_GET_STATS_PARAMS_IN_SLI, *PRDMA_GET_STATS_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_GET_STATS_PARAMS_IN, sizeof (RDMA_GET_STATS_PARAMS_IN_SLI) == 4);


#else

   typedef struct _RDMA_GET_STATS_PARAMS_IN_SLI {
      union {
         struct { 
            u32 reset_stat : 8;                   // DWORD 0
            u32 rsvd0 : 24;                       // DWORD 0
         } SG_PACK ; // unnamed struct
         u32 dw; // dword union
      }; // unnamed union
   } SG_PACK RDMA_GET_STATS_PARAMS_IN_SLI, *PRDMA_GET_STATS_PARAMS_IN_SLI;

   SG_C_ASSERT(__sizeof__RDMA_GET_STATS_PARAMS_IN, sizeof (RDMA_GET_STATS_PARAMS_IN_SLI) == 4);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_GET_STATS_PARAMS_OUT_SLI {
      ACTIVE_RESOURCE_STATS_SLI active_res;
      DB_ERROR_STATS_SLI db_errs;
      WQE_STATS_SLI wqe_stats;
      TX_STATS_SLI tx_stats;
      TX_QP_ERROR_STATS_SLI tx_qp_errs;
      RX_STATS_SLI rx_stats;
      RX_QP_ERROR_STATS_SLI rx_qp_errs;
      TX_DEBUG_STATS_SLI tx_dbg_stats;
      RX_DEBUG_STATS_SLI rx_dbg_stats;
   } SG_PACK RDMA_GET_STATS_PARAMS_OUT_SLI, *PRDMA_GET_STATS_PARAMS_OUT_SLI;



#else

   typedef struct _RDMA_GET_STATS_PARAMS_OUT_SLI {
      ACTIVE_RESOURCE_STATS_SLI active_res;
      DB_ERROR_STATS_SLI db_errs;
      WQE_STATS_SLI wqe_stats;
      TX_STATS_SLI tx_stats;
      TX_QP_ERROR_STATS_SLI tx_qp_errs;
      RX_STATS_SLI rx_stats;
      RX_QP_ERROR_STATS_SLI rx_qp_errs;
      TX_DEBUG_STATS_SLI tx_dbg_stats;
      RX_DEBUG_STATS_SLI rx_dbg_stats;
   } SG_PACK RDMA_GET_STATS_PARAMS_OUT_SLI, *PRDMA_GET_STATS_PARAMS_OUT_SLI;



#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _RDMA_GET_STATS_PARAMS_SLI {
      union {
         union { 
            RDMA_GET_STATS_PARAMS_IN_SLI request;
            RDMA_GET_STATS_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[424]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_GET_STATS_PARAMS_SLI, *PRDMA_GET_STATS_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_GET_STATS_PARAMS, sizeof (RDMA_GET_STATS_PARAMS_SLI) == 1696);


#else

   typedef struct _RDMA_GET_STATS_PARAMS_SLI {
      union {
         union { 
            RDMA_GET_STATS_PARAMS_IN_SLI request;
            RDMA_GET_STATS_PARAMS_OUT_SLI response;
         } SG_PACK ; // unnamed struct
         u32 dw[424]; // dword union
      }; // unnamed union
   } SG_PACK RDMA_GET_STATS_PARAMS_SLI, *PRDMA_GET_STATS_PARAMS_SLI;

   SG_C_ASSERT(__sizeof__RDMA_GET_STATS_PARAMS, sizeof (RDMA_GET_STATS_PARAMS_SLI) == 1696);


#endif
#if defined(SG_REVERSE_ENDIAN)

   typedef struct _IOCTL_RDMA_GET_STATS_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_GET_STATS_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[428]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_GET_STATS_SLI, *PIOCTL_RDMA_GET_STATS_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_GET_STATS, sizeof (IOCTL_RDMA_GET_STATS_SLI) == 1712);


#else

   typedef struct _IOCTL_RDMA_GET_STATS_SLI {
      union {
         struct { 
            IOCTL_HEADER_SLI header;
            RDMA_GET_STATS_PARAMS_SLI params;
         } SG_PACK ; // unnamed struct
         u32 dw[428]; // dword union
      }; // unnamed union
   } SG_PACK IOCTL_RDMA_GET_STATS_SLI, *PIOCTL_RDMA_GET_STATS_SLI;

   SG_C_ASSERT(__sizeof__IOCTL_RDMA_GET_STATS, sizeof (IOCTL_RDMA_GET_STATS_SLI) == 1712);


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_sli_bmap_h__

