/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// manufacture, use,or sell anything that it may describe, in whole or in part, without   
// thespecific written consent of  EMULEX CORPORATION.  Any reproduction of thissource    
// code without the express written consent of EMULEX CORPORATION is aviolation of the    
// copyrights laws and may subject you to criminal prosecution.                           

// Autogenerated file. Do not edit!
// srcgen version: 0165
#ifndef __sh_nic_v2_amap_h__
#define __sh_nic_v2_amap_h__

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
typedef struct { BE_BIT native[8]; } BE_u8_V2_AMAP; // native

typedef struct { BE_BIT native[16]; } BE_u16_V2_AMAP; // native

typedef struct { BE_BIT native[32]; } BE_u32_V2_AMAP; // native

typedef struct { BE_BIT native[64]; } BE_u64_V2_AMAP; // native

typedef struct { BE_BIT native[32]; } BE_void_V2_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_CHAR_V2_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_BOOLEAN_V2_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_EXACT8_V2_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_UEXACT8_V2_AMAP; // native

typedef struct { BE_BIT native[16]; } BE_EXACT16_V2_AMAP; // native

typedef struct { BE_BIT native[16]; } BE_UEXACT16_V2_AMAP; // native

typedef struct { BE_BIT native[32]; } BE_UEXACT32_V2_AMAP; // native

typedef struct { BE_BIT native[64]; } BE_UEXACT64_V2_AMAP; // native

typedef struct {
   BE_BIT lo[32];                                 // DWORD 0
   BE_BIT hi[32];                                 // DWORD 1
} SG_PACK BE_PHYS_ADDR_V2_AMAP;
typedef struct { u32 dw[2]; } PHYS_ADDR_V2_AMAP, *PPHYS_ADDR_V2_AMAP;


typedef struct {
   BE_BIT opcode[8];                              // DWORD 0
   BE_BIT subsystem[8];                           // DWORD 0
   BE_BIT port_number[8];                         // DWORD 0
   BE_BIT domain[8];                              // DWORD 0
   BE_BIT timeout[32];                            // DWORD 1
   BE_BIT request_length[32];                     // DWORD 2
   BE_BIT version[8];                             // DWORD 3
   BE_BIT rsvd0[8];                               // DWORD 3
   BE_BIT pfnumber[10];                           // DWORD 3
   BE_BIT vhnumber[6];                            // DWORD 3
} SG_PACK BE_IOCTL_REQUEST_HEADER_V2_AMAP;
typedef struct { u32 dw[4]; } IOCTL_REQUEST_HEADER_V2_AMAP, *PIOCTL_REQUEST_HEADER_V2_AMAP;


typedef struct {
   BE_BIT opcode[8];                              // DWORD 0
   BE_BIT subsystem[8];                           // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT domain[8];                              // DWORD 0
   BE_BIT status[8];                              // DWORD 1
   BE_BIT additional_status[16];                  // DWORD 1
   BE_BIT rsvd1[8];                               // DWORD 1
   BE_BIT response_length[32];                    // DWORD 2
   BE_BIT actual_response_length[32];             // DWORD 3
} SG_PACK BE_IOCTL_RESPONSE_HEADER_V2_AMAP;
typedef struct { u32 dw[4]; } IOCTL_RESPONSE_HEADER_V2_AMAP, *PIOCTL_RESPONSE_HEADER_V2_AMAP;


typedef union {
   BE_IOCTL_REQUEST_HEADER_V2_AMAP request;
   BE_IOCTL_RESPONSE_HEADER_V2_AMAP response;
} SG_PACK BE_IOCTL_HEADER_V2_AMAP;
typedef struct { u32 dw[4]; } IOCTL_HEADER_V2_AMAP, *PIOCTL_HEADER_V2_AMAP;


typedef struct {
   BE_BIT qid[9];                                 // DWORD 0
   BE_BIT ClearInt;                               // DWORD 0
   BE_BIT event;                                  // DWORD 0
   BE_BIT qid_msb;                                // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT num_popped[13];                         // DWORD 0
   BE_BIT rearm;                                  // DWORD 0
   BE_BIT r2i_dly_mult_enc[2];                    // DWORD 0
} SG_PACK BE_EQ_DB_V2_AMAP;
typedef struct { u32 dw[1]; } EQ_DB_V2_AMAP, *PEQ_DB_V2_AMAP;


typedef struct {
   BE_BIT qid[10];                                // DWORD 0
   BE_BIT event;                                  // DWORD 0
   BE_BIT qid_msb;                                // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT num_popped[13];                         // DWORD 0
   BE_BIT rearm;                                  // DWORD 0
   BE_BIT irpt;                                   // DWORD 0
   BE_BIT db_solicited;                           // DWORD 0
} SG_PACK BE_CQ_DB_V2_AMAP;
typedef struct { u32 dw[1]; } CQ_DB_V2_AMAP, *PCQ_DB_V2_AMAP;


typedef struct {
   BE_BIT vlan_tag[16];                           // DWORD 0
   BE_BIT pktsize[14];                            // DWORD 0
   BE_BIT vtp;                                    // DWORD 0
   BE_BIT ip_opt;                                 // DWORD 0
   BE_BIT err;                                    // DWORD 1
   BE_BIT rsshp;                                  // DWORD 1
   BE_BIT ipf;                                    // DWORD 1
   BE_BIT tcpf;                                   // DWORD 1
   BE_BIT udpf;                                   // DWORD 1
   BE_BIT ipcksm;                                 // DWORD 1
   BE_BIT l4_cksm;                                // DWORD 1
   BE_BIT ip_version;                             // DWORD 1
   BE_BIT macdst[8];                              // DWORD 1
   BE_BIT fragndx[10];                            // DWORD 1
   BE_BIT ct[2];                                  // DWORD 1
   BE_BIT sw;                                     // DWORD 1
   BE_BIT numfrags[3];                            // DWORD 1
   BE_BIT rss_flush;                              // DWORD 2
   BE_BIT cast_enc[2];                            // DWORD 2
   BE_BIT QnQ;                                    // DWORD 2
   BE_BIT rss_bank;                               // DWORD 2
   BE_BIT port[2];                                // DWORD 2
   BE_BIT vntagp;                                 // DWORD 2
   BE_BIT header_len[8];                          // DWORD 2
   BE_BIT header_split[2];                        // DWORD 2
   BE_BIT rss_policy[4];                          // DWORD 2
   BE_BIT timestamp_present;                      // DWORD 2
   BE_BIT push;                                   // DWORD 2
   BE_BIT rsvd0;                                  // DWORD 2
   BE_BIT future_headers_present[5];              // DWORD 2
   BE_BIT tunneled;                               // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT rsshash[32];                            // DWORD 3
} SG_PACK BE_ETH_RX_COMPL_V2_AMAP;
typedef struct { u32 dw[4]; } ETH_RX_COMPL_V2_AMAP, *PETH_RX_COMPL_V2_AMAP;


typedef struct {
   BE_UEXACT16_V2_AMAP cq_id;
   BE_UEXACT8_V2_AMAP frag_size;
   BE_UEXACT8_V2_AMAP num_pages;
   BE_PHYS_ADDR_V2_AMAP pages[2];
   BE_UEXACT32_V2_AMAP interface_id;
   BE_UEXACT16_V2_AMAP max_frame_size;
   BE_BIT rsvd0[16];                              // DWORD 6
   BE_UEXACT32_V2_AMAP rss_queue;
   BE_UEXACT8_V2_AMAP header_split;
   BE_UEXACT8_V2_AMAP header_dma;
   BE_UEXACT8_V2_AMAP split_location;
   BE_UEXACT8_V2_AMAP dca;
   BE_UEXACT16_V2_AMAP header_size;
   BE_UEXACT16_V2_AMAP backfill;
   BE_UEXACT16_V2_AMAP fixed_split_location;
   BE_BIT rsvd1[16];                              // DWORD 10
} SG_PACK BE_ETH_RX_CREATE_PARAMS_IN_V2_AMAP;
typedef struct { u32 dw[11]; } ETH_RX_CREATE_PARAMS_IN_V2_AMAP, *PETH_RX_CREATE_PARAMS_IN_V2_AMAP;


typedef struct {
   BE_UEXACT16_V2_AMAP id;
   BE_UEXACT8_V2_AMAP cpu_id;
   BE_UEXACT8_V2_AMAP ep_based_ring;
} SG_PACK BE_ETH_RX_CREATE_PARAMS_OUT_V2_AMAP;
typedef struct { u32 dw[1]; } ETH_RX_CREATE_PARAMS_OUT_V2_AMAP, *PETH_RX_CREATE_PARAMS_OUT_V2_AMAP;


typedef union {
   BE_ETH_RX_CREATE_PARAMS_IN_V2_AMAP request;
   BE_ETH_RX_CREATE_PARAMS_OUT_V2_AMAP response;
} SG_PACK BE_ETH_RX_CREATE_PARAMS_V2_AMAP;
typedef struct { u32 dw[11]; } ETH_RX_CREATE_PARAMS_V2_AMAP, *PETH_RX_CREATE_PARAMS_V2_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V2_AMAP header;
   BE_ETH_RX_CREATE_PARAMS_V2_AMAP params;
} SG_PACK BE_IOCTL_ETH_RX_CREATE_V2_AMAP;
typedef struct { u32 dw[15]; } IOCTL_ETH_RX_CREATE_V2_AMAP, *PIOCTL_ETH_RX_CREATE_V2_AMAP;


typedef struct {
   BE_BIT rx_bytes_lsd[32];                       // DWORD 0
   BE_BIT rx_bytes_msd[32];                       // DWORD 1
   BE_BIT rx_ipv4_bytes_lsd[32];                  // DWORD 2
   BE_BIT rx_ipv4_bytes_msd[32];                  // DWORD 3
   BE_BIT rx_ipv6_bytes_lsd[32];                  // DWORD 4
   BE_BIT rx_ipv6_bytes_msd[32];                  // DWORD 5
   BE_BIT tx_bytes_lsd[32];                       // DWORD 6
   BE_BIT tx_bytes_msd[32];                       // DWORD 7
   BE_BIT fcoe_bytes_received_lsd[32];            // DWORD 8
   BE_BIT fcoe_bytes_received_msd[32];            // DWORD 9
   BE_BIT roce_bytes_received_lsd[32];            // DWORD 10
   BE_BIT roce_bytes_received_msd[32];            // DWORD 11
   BE_BIT rx_total_frames[32];                    // DWORD 12
   BE_BIT rx_non_switched_unicast_frames[32];     // DWORD 13
   BE_BIT rx_non_switched_multicast_frames[32];   // DWORD 14
   BE_BIT rx_non_switched_broadcast_frames[32];   // DWORD 15
   BE_BIT fcoe_frames_received[32];               // DWORD 16
   BE_BIT roce_frames_received[32];               // DWORD 17
   BE_BIT rx_crc_errors[32];                      // DWORD 18
   BE_BIT rx_alignment_symbol_errors[32];         // DWORD 19
   BE_BIT rx_pause_frames[32];                    // DWORD 20
   BE_BIT rx_priority_pause_frames[32];           // DWORD 21
   BE_BIT rx_control_frames[32];                  // DWORD 22
   BE_BIT rx_in_range_errors[32];                 // DWORD 23
   BE_BIT rx_out_range_errors[32];                // DWORD 24
   BE_BIT rx_frame_too_long[32];                  // DWORD 25
   BE_BIT rx_address_match_errors[32];            // DWORD 26
   BE_BIT rx_dropped_too_small[32];               // DWORD 27
   BE_BIT rx_dropped_too_short[32];               // DWORD 28
   BE_BIT rx_dropped_header_too_small[32];        // DWORD 29
   BE_BIT rx_dropped_tcp_length[32];              // DWORD 30
   BE_BIT rx_dropped_runt[32];                    // DWORD 31
   BE_BIT rx_64_byte_packets[32];                 // DWORD 32
   BE_BIT rx_65_127_byte_packets[32];             // DWORD 33
   BE_BIT rx_128_256_byte_packets[32];            // DWORD 34
   BE_BIT rx_256_511_byte_packets[32];            // DWORD 35
   BE_BIT rx_512_1023_byte_packets[32];           // DWORD 36
   BE_BIT rx_1024_1518_byte_packets[32];          // DWORD 37
   BE_BIT rx_1519_2047_byte_packets[32];          // DWORD 38
   BE_BIT rx_2048_4095_byte_packets[32];          // DWORD 39
   BE_BIT rx_4096_8191_byte_packets[32];          // DWORD 40
   BE_BIT rx_8192_9216_byte_packets[32];          // DWORD 41
   BE_BIT rx_ip_checksum_errs[32];                // DWORD 42
   BE_BIT rx_tcp_checksum_errs[32];               // DWORD 43
   BE_BIT rx_udp_checksum_errs[32];               // DWORD 44
   BE_BIT rx_non_rss_packets[32];                 // DWORD 45
   BE_BIT rx_ipv4_packets[32];                    // DWORD 46
   BE_BIT rx_ipv6_packets[32];                    // DWORD 47
   BE_BIT rx_chute1_packets[32];                  // DWORD 48
   BE_BIT rx_chute2_packets[32];                  // DWORD 49
   BE_BIT rx_chute3_packets[32];                  // DWORD 50
   BE_BIT rx_management_packets[32];              // DWORD 51
   BE_BIT rx_switched_unicast_packets[32];        // DWORD 52
   BE_BIT rx_switched_multicast_packets[32];      // DWORD 53
   BE_BIT rx_switched_broadcast_packets[32];      // DWORD 54
   BE_BIT tx_unicastframes[32];                   // DWORD 55
   BE_BIT tx_multicastframes[32];                 // DWORD 56
   BE_BIT tx_broadcastframes[32];                 // DWORD 57
   BE_BIT tx_pauseframes[32];                     // DWORD 58
   BE_BIT tx_priority_pauseframes[32];            // DWORD 59
   BE_BIT tx_controlframes[32];                   // DWORD 60
   BE_BIT tx_64_byte_packets[32];                 // DWORD 61
   BE_BIT tx_65_127_byte_packets[32];             // DWORD 62
   BE_BIT tx_128_256_byte_packets[32];            // DWORD 63
   BE_BIT tx_256_511_byteb_packets[32];           // DWORD 64
   BE_BIT tx_512_1023_byte_packets[32];           // DWORD 65
   BE_BIT tx_1024_1518_byte_packets[32];          // DWORD 66
   BE_BIT tx_1519_2047_byte_packets[32];          // DWORD 67
   BE_BIT tx_2048_4095_byte_packets[32];          // DWORD 68
   BE_BIT tx_4096_8191_byte_packets[32];          // DWORD 69
   BE_BIT tx_8192_9216_byte_packets[32];          // DWORD 70
   BE_BIT rxpp_fifo_overflow_drop[32];            // DWORD 71
   BE_BIT rx_input_fifo_overflow_drop[32];        // DWORD 72
   BE_BIT pmem_fifo_overflow_drop[32];            // DWORD 73
   BE_BIT jabber_events[32];                      // DWORD 74
   BE_BIT vntag_wrong_dir[32];                    // DWORD 75
   BE_BIT vntag_exceeds_vif[32];                  // DWORD 76
   BE_BIT vntag_exceeds_vif_list[32];             // DWORD 77
   BE_BIT rx_drops_payload_size[32];              // DWORD 78
   BE_BIT rx_drops_clipped_header[32];            // DWORD 79
   BE_BIT rx_drops_crc[32];                       // DWORD 80
   BE_BIT roce_drops_payload_len[32];             // DWORD 81
   BE_BIT roce_drops_crc[32];                     // DWORD 82
   BE_BIT pfc0_xoff_since_last_xon[32];           // DWORD 83
   BE_BIT pfc1_xoff_since_last_xon[32];           // DWORD 84
   BE_BIT pfc2_xoff_since_last_xon[32];           // DWORD 85
   BE_BIT pfc3_xoff_since_last_xon[32];           // DWORD 86
   BE_BIT pfc4_xoff_since_last_xon[32];           // DWORD 87
   BE_BIT pfc5_xoff_since_last_xon[32];           // DWORD 88
   BE_BIT pfc6_xoff_since_last_xon[32];           // DWORD 89
   BE_BIT pfc7_xoff_since_last_xon[32];           // DWORD 90
   BE_BIT ptp_pkts_received[32];                  // DWORD 91
   BE_BIT tunneled_pkts_received[32];             // DWORD 92
   BE_BIT ethernet_tpre_pkts_received[32];        // DWORD 93
   BE_BIT lroed_packets_received[32];             // DWORD 94
   BE_BIT resrvd_stat0[32];                       // DWORD 95
   BE_BIT resrvd_stat1[32];                       // DWORD 96
   BE_BIT resrvd_stat2[32];                       // DWORD 97
   BE_BIT resrvd_stat3[32];                       // DWORD 98
   BE_BIT resrvd_stat4[32];                       // DWORD 99
   BE_BIT resrvd_stat5[32];                       // DWORD 100
   BE_BIT resrvd_stat6[32];                       // DWORD 101
} SG_PACK BE_HW_PORT_RXF_STATS_V2_V2_AMAP;
typedef struct { u32 dw[102]; } HW_PORT_RXF_STATS_V2_V2_AMAP, *PHW_PORT_RXF_STATS_V2_V2_AMAP;


typedef struct {
   BE_HW_PORT_RXF_STATS_V2_V2_AMAP port[4];
   BE_BIT management_rx_port_bytes[32];           // DWORD 408
   BE_BIT management_tx_port_bytes[32];           // DWORD 409
   BE_BIT rx_drops_no_pbuf[32];                   // DWORD 410
   BE_BIT rx_drops_no_txpb[32];                   // DWORD 411
   BE_BIT rx_drops_no_erx_descr[32];              // DWORD 412
   BE_BIT rx_drops_no_tpre_descr[32];             // DWORD 413
   BE_BIT management_rx_port_packets[32];         // DWORD 414
   BE_BIT management_rx_port_pause_frames[32];    // DWORD 415
   BE_BIT management_rx_port_errors[32];          // DWORD 416
   BE_BIT management_tx_port_packets[32];         // DWORD 417
   BE_BIT management_tx_port_pause[32];           // DWORD 418
   BE_BIT mgmt_rx_port_pmem_fifo_overflow[32];    // DWORD 419
   BE_BIT rx_drops_too_many_frags[32];            // DWORD 420
   BE_BIT rx_drops_invalid_ring[32];              // DWORD 421
   BE_BIT forwarded_packets[32];                  // DWORD 422
   BE_BIT rx_drops_mtu[32];                       // DWORD 423
   BE_BIT mgmt_rx_port_rxpp_fifo_overflow[32];    // DWORD 424
   BE_BIT rxpp_drops_too_big_for_mgmt[32];        // DWORD 425
   BE_BIT overflow_fifo_part0_taildrop[32];       // DWORD 426
   BE_BIT overflow_fifo_part1_taildrop[32];       // DWORD 427
   BE_BIT overflow_fifo_part2_taildrop[32];       // DWORD 428
   BE_BIT overflow_fifo_part3_taildrop[32];       // DWORD 429
   BE_BIT overflow_fifo_part4_taildrop[32];       // DWORD 430
   BE_BIT overflow_fifo_part5_taildrop[32];       // DWORD 431
   BE_BIT overflow_fifo_part6_taildrop[32];       // DWORD 432
   BE_BIT overflow_fifo_part7_taildrop[32];       // DWORD 433
   BE_BIT overflow_fifo_part8_taildrop[32];       // DWORD 434
   BE_BIT overflow_fifo_part9_taildrop[32];       // DWORD 435
   BE_BIT overflow_fifo_part10_taildrop[32];      // DWORD 436
   BE_BIT overflow_fifo_part11_taildrop[32];      // DWORD 437
   BE_BIT overflow_fifo_part12_taildrop[32];      // DWORD 438
   BE_BIT overflow_fifo_part13_taildrop[32];      // DWORD 439
   BE_BIT overflow_fifo_part14_taildrop[32];      // DWORD 440
   BE_BIT overflow_fifo_part15_taildrop[32];      // DWORD 441
   BE_BIT overflow_pmem_part0[32];                // DWORD 442
   BE_BIT overflow_pmem_part1[32];                // DWORD 443
   BE_BIT overflow_pmem_part2[32];                // DWORD 444
   BE_BIT overflow_pmem_part3[32];                // DWORD 445
   BE_BIT overflow_pmem_part4[32];                // DWORD 446
   BE_BIT overflow_pmem_part5[32];                // DWORD 447
   BE_BIT overflow_pmem_part6[32];                // DWORD 448
   BE_BIT overflow_pmem_part7[32];                // DWORD 449
   BE_BIT overflow_pmem_part8[32];                // DWORD 450
   BE_BIT overflow_pmem_part9[32];                // DWORD 451
   BE_BIT overflow_pmem_part10[32];               // DWORD 452
   BE_BIT overflow_pmem_part11[32];               // DWORD 453
   BE_BIT overflow_pmem_part12[32];               // DWORD 454
   BE_BIT overflow_pmem_part13[32];               // DWORD 455
   BE_BIT overflow_pmem_part14[32];               // DWORD 456
   BE_BIT overflow_pmem_part15[32];               // DWORD 457
   BE_BIT mgmt_filter_mismtach[32];               // DWORD 458
} SG_PACK BE_HW_RXF_STATS_V2_V2_AMAP;
typedef struct { u32 dw[459]; } HW_RXF_STATS_V2_V2_AMAP, *PHW_RXF_STATS_V2_V2_AMAP;


typedef struct {
   BE_BIT packets[32];                            // DWORD 0
   BE_BIT lsd[32];                                // DWORD 1
   BE_BIT msd[32];                                // DWORD 2
} SG_PACK BE_HW_TXP_SW_STAT_V2_AMAP;
typedef struct { u32 dw[3]; } HW_TXP_SW_STAT_V2_AMAP, *PHW_TXP_SW_STAT_V2_AMAP;


typedef struct {
   struct {
      struct {
         BE_HW_TXP_SW_STAT_V2_AMAP xmt_ipv4_ctrs;
         BE_HW_TXP_SW_STAT_V2_AMAP xmt_ipv6_ctrs;
         BE_HW_TXP_SW_STAT_V2_AMAP rexmt_ipv4_ctrs;
         BE_HW_TXP_SW_STAT_V2_AMAP rexmt_ipv6_ctrs;
      } port[2];
   } chute[2];
} SG_PACK BE_HW_TXP_SW_COUNTERS_V2_AMAP;
typedef struct { u32 dw[48]; } HW_TXP_SW_COUNTERS_V2_AMAP, *PHW_TXP_SW_COUNTERS_V2_AMAP;


typedef struct {
   BE_BIT rx_drops_no_fragments[136][32];         // DWORD 0
   BE_BIT debug_wdma_sent_hold[32];               // DWORD 136
   BE_BIT debug_wdma_pbfree_sent_hold[32];        // DWORD 137
   BE_BIT debug_wdma_zerobyte_pbfree_sent_hold[32]; // DWORD 138
} SG_PACK BE_HW_ERX_STATS_V2_V2_AMAP;
typedef struct { u32 dw[139]; } HW_ERX_STATS_V2_V2_AMAP, *PHW_ERX_STATS_V2_V2_AMAP;


typedef struct {
   BE_u32_V2_AMAP eth_red_drops;
   BE_u32_V2_AMAP lro_red_drops;
   BE_u32_V2_AMAP ulp0_red_drops;
   BE_u32_V2_AMAP ulp1_red_drops;
   BE_BIT rsvd0[32];                              // DWORD 4
   BE_u32_V2_AMAP global_red_drops;
} SG_PACK BE_HW_PMEM_STATS_V2_AMAP;
typedef struct { u32 dw[6]; } HW_PMEM_STATS_V2_AMAP, *PHW_PMEM_STATS_V2_AMAP;


typedef struct {
   BE_u16_V2_AMAP perf_idle_average;
   BE_u16_V2_AMAP perf_loading_average;
   BE_u16_V2_AMAP perf_busy_average;
   BE_u16_V2_AMAP perf_unloading_average;
   BE_u16_V2_AMAP perf_wt4bank_average;
   BE_u16_V2_AMAP perf_wt4unload_average;
} SG_PACK BE_HW_EP_STATS_V2_AMAP;
typedef struct { u32 dw[3]; } HW_EP_STATS_V2_AMAP, *PHW_EP_STATS_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_STATISTICS_V2_PARAMS_IN_V2_AMAP;
typedef struct { u32 dw[1]; } GET_STATISTICS_V2_PARAMS_IN_V2_AMAP, *PGET_STATISTICS_V2_PARAMS_IN_V2_AMAP;


typedef struct {
   BE_HW_RXF_STATS_V2_V2_AMAP rxf;
   BE_HW_TXP_SW_COUNTERS_V2_AMAP txp;
   BE_HW_ERX_STATS_V2_V2_AMAP erx;
   BE_HW_PMEM_STATS_V2_AMAP pmem;
   BE_HW_EP_STATS_V2_AMAP ep[6];
} SG_PACK BE_GET_STATISTICS_V2_PARAMS_OUT_V2_AMAP;
typedef struct { u32 dw[670]; } GET_STATISTICS_V2_PARAMS_OUT_V2_AMAP, *PGET_STATISTICS_V2_PARAMS_OUT_V2_AMAP;


typedef union {
   BE_GET_STATISTICS_V2_PARAMS_IN_V2_AMAP request;
   BE_GET_STATISTICS_V2_PARAMS_OUT_V2_AMAP response;
} SG_PACK BE_GET_STATISTICS_V2_PARAMS_V2_AMAP;
typedef struct { u32 dw[670]; } GET_STATISTICS_V2_PARAMS_V2_AMAP, *PGET_STATISTICS_V2_PARAMS_V2_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V2_AMAP header;
   BE_GET_STATISTICS_V2_PARAMS_V2_AMAP params;
} SG_PACK BE_IOCTL_ETH_GET_STATISTICS_V2_V2_AMAP;
typedef struct { u32 dw[674]; } IOCTL_ETH_GET_STATISTICS_V2_V2_AMAP, *PIOCTL_ETH_GET_STATISTICS_V2_V2_AMAP;


typedef struct {
   BE_UEXACT32_V2_AMAP valid_capability_flags;
   BE_UEXACT32_V2_AMAP capability_flags;
   BE_UEXACT8_V2_AMAP sbz[212];
} SG_PACK BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V2_AMAP;
typedef struct { u32 dw[55]; } SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V2_AMAP, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V2_AMAP;


typedef struct {
   BE_UEXACT32_V2_AMAP valid_capability_flags;
   BE_UEXACT32_V2_AMAP capability_flags;
   BE_UEXACT8_V2_AMAP sbz[212];
} SG_PACK BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V2_AMAP;
typedef struct { u32 dw[55]; } SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V2_AMAP, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V2_AMAP;


typedef union {
   BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V2_AMAP request;
   BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V2_AMAP response;
} SG_PACK BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V2_AMAP;
typedef struct { u32 dw[55]; } SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V2_AMAP, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V2_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V2_AMAP header;
   BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V2_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2_AMAP;
typedef struct { u32 dw[59]; } IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2_AMAP, *PIOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2_AMAP;
typedef struct { u32 dw[1]; } GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2_AMAP, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2_AMAP;


typedef struct {
   BE_UEXACT32_V2_AMAP privilege_mask;
} SG_PACK BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2_AMAP;
typedef struct { u32 dw[1]; } GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2_AMAP, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2_AMAP;


typedef union {
   BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2_AMAP request;
   BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2_AMAP response;
} SG_PACK BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2_AMAP;
typedef struct { u32 dw[1]; } GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2_AMAP, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V2_AMAP header;
   BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V2_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V2_AMAP, *PIOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V2_AMAP;


typedef struct {
   BE_UEXACT32_V2_AMAP privilege_mask;
   BE_UEXACT32_V2_AMAP PRIVILEGE_MASK;
} SG_PACK BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2_AMAP;
typedef struct { u32 dw[2]; } SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2_AMAP, *PSET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2_AMAP;


typedef struct {
   BE_UEXACT32_V2_AMAP old_privilege_mask;
} SG_PACK BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2_AMAP;
typedef struct { u32 dw[1]; } SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2_AMAP, *PSET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2_AMAP;


typedef union {
   BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2_AMAP request;
   BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2_AMAP response;
} SG_PACK BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2_AMAP;
typedef struct { u32 dw[2]; } SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2_AMAP, *PSET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V2_AMAP header;
   BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_FUNCTION_PRIVILEGES_V2_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_SET_FUNCTION_PRIVILEGES_V2_AMAP, *PIOCTL_COMMON_SET_FUNCTION_PRIVILEGES_V2_AMAP;


typedef struct {
   BE_BIT intf_pport_id[16];                      // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
   BE_BIT pvid_valid;                             // DWORD 0
   BE_BIT pport;                                  // DWORD 0
   BE_BIT ingress_vlan_type[3];                   // DWORD 1
   BE_BIT egress_vlan_type[3];                    // DWORD 1
   BE_BIT port_fwd_type[3];                       // DWORD 1
   BE_BIT idp_valid;                              // DWORD 1
   BE_BIT rx_sniffer_valid;                       // DWORD 1
   BE_BIT tx_sniffer_valid;                       // DWORD 1
   BE_BIT promisc;                                // DWORD 1
   BE_BIT vlan_check;                             // DWORD 1
   BE_BIT mac_spoof_check;                        // DWORD 1
   BE_BIT uplink_port;                            // DWORD 1
   BE_BIT pvid[16];                               // DWORD 1
   BE_UEXACT16_V2_AMAP rx_sniffer_cq_id;
   BE_UEXACT16_V2_AMAP rx_sniffer_iface_id;
   BE_UEXACT16_V2_AMAP tx_sniffer_cq_id;
   BE_UEXACT16_V2_AMAP tx_sniffer_iface_id;
   BE_UEXACT16_V2_AMAP idp_cq_id;
   BE_UEXACT16_V2_AMAP promisc_cq_id;
} SG_PACK BE_SET_HSW_CONFIG_PARAMS_IN_V2_AMAP;
typedef struct { u32 dw[5]; } SET_HSW_CONFIG_PARAMS_IN_V2_AMAP, *PSET_HSW_CONFIG_PARAMS_IN_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_HSW_CONFIG_PARAMS_OUT_V2_AMAP;
typedef struct { u32 dw[1]; } SET_HSW_CONFIG_PARAMS_OUT_V2_AMAP, *PSET_HSW_CONFIG_PARAMS_OUT_V2_AMAP;


typedef union {
   BE_SET_HSW_CONFIG_PARAMS_IN_V2_AMAP request;
   BE_SET_HSW_CONFIG_PARAMS_OUT_V2_AMAP response;
} SG_PACK BE_SET_HSW_CONFIG_PARAMS_V2_AMAP;
typedef struct { u32 dw[5]; } SET_HSW_CONFIG_PARAMS_V2_AMAP, *PSET_HSW_CONFIG_PARAMS_V2_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V2_AMAP header;
   BE_SET_HSW_CONFIG_PARAMS_V2_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_HSW_CONFIG_V2_AMAP;
typedef struct { u32 dw[9]; } IOCTL_COMMON_SET_HSW_CONFIG_V2_AMAP, *PIOCTL_COMMON_SET_HSW_CONFIG_V2_AMAP;


typedef struct {
   BE_BIT intf_pport_id[16];                      // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
   BE_BIT pvid_valid;                             // DWORD 0
   BE_BIT pport;                                  // DWORD 0
} SG_PACK BE_GET_HSW_CONFIG_PARAMS_IN_V2_AMAP;
typedef struct { u32 dw[1]; } GET_HSW_CONFIG_PARAMS_IN_V2_AMAP, *PGET_HSW_CONFIG_PARAMS_IN_V2_AMAP;


typedef struct {
   BE_BIT ingress_vlan_type[3];                   // DWORD 0
   BE_BIT egress_vlan_type[3];                    // DWORD 0
   BE_BIT port_fwd_type[3];                       // DWORD 0
   BE_BIT idp_valid;                              // DWORD 0
   BE_BIT rx_sniffer_valid;                       // DWORD 0
   BE_BIT tx_sniffer_valid;                       // DWORD 0
   BE_BIT promisc;                                // DWORD 0
   BE_BIT vlan_check;                             // DWORD 0
   BE_BIT mac_spoof_check;                        // DWORD 0
   BE_BIT uplink_port;                            // DWORD 0
   BE_BIT pvid[16];                               // DWORD 0
   BE_UEXACT16_V2_AMAP rx_sniffer_cq_id;
   BE_UEXACT16_V2_AMAP rx_sniffer_iface_id;
   BE_UEXACT16_V2_AMAP tx_sniffer_cq_id;
   BE_UEXACT16_V2_AMAP tx_sniffer_iface_id;
   BE_UEXACT16_V2_AMAP idp_cq_id;
   BE_UEXACT16_V2_AMAP promisc_cq_id;
} SG_PACK BE_GET_HSW_CONFIG_PARAMS_OUT_V2_AMAP;
typedef struct { u32 dw[4]; } GET_HSW_CONFIG_PARAMS_OUT_V2_AMAP, *PGET_HSW_CONFIG_PARAMS_OUT_V2_AMAP;


typedef union {
   BE_GET_HSW_CONFIG_PARAMS_IN_V2_AMAP request;
   BE_GET_HSW_CONFIG_PARAMS_OUT_V2_AMAP response;
} SG_PACK BE_GET_HSW_CONFIG_PARAMS_V2_AMAP;
typedef struct { u32 dw[4]; } GET_HSW_CONFIG_PARAMS_V2_AMAP, *PGET_HSW_CONFIG_PARAMS_V2_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V2_AMAP header;
   BE_GET_HSW_CONFIG_PARAMS_V2_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_HSW_CONFIG_V2_AMAP;
typedef struct { u32 dw[8]; } IOCTL_COMMON_GET_HSW_CONFIG_V2_AMAP, *PIOCTL_COMMON_GET_HSW_CONFIG_V2_AMAP;


typedef struct {
   BE_BIT l2type[2];                              // DWORD 0
   BE_BIT qinq;                                   // DWORD 0
   BE_BIT mac_id[7];                              // DWORD 0
   BE_BIT port[2];                                // DWORD 0
   BE_BIT tho;                                    // DWORD 0
   BE_BIT snap;                                   // DWORD 0
   BE_BIT l3type[2];                              // DWORD 0
   BE_BIT ip_version;                             // DWORD 0
   BE_BIT dest_id[13];                            // DWORD 0
   BE_BIT vtp;                                    // DWORD 0
   BE_BIT sw;                                     // DWORD 0
   BE_BIT vtag[16];                               // DWORD 1
   BE_BIT len[14];                                // DWORD 1
   BE_BIT ct[2];                                  // DWORD 1
   BE_BIT mpacrc[32];                             // DWORD 2
   BE_BIT fpe[3];                                 // DWORD 3
   BE_BIT zeropayload;                            // DWORD 3
   BE_BIT ack_only;                               // DWORD 3
   BE_BIT ip_opt;                                 // DWORD 3
   BE_BIT rsvd0[8];                               // DWORD 3
   BE_BIT timestamp[2];                           // DWORD 3
   BE_BIT tcp_data_len[16];                       // DWORD 3
} SG_PACK BE_RXFILT_D_V2_AMAP;
typedef struct { u32 dw[4]; } RXFILT_D_V2_AMAP, *PRXFILT_D_V2_AMAP;


typedef struct {
   BE_BIT vendorid[16];                           // DWORD 0
   BE_BIT deviceid[16];                           // DWORD 0
} SG_PACK BE_PCICFG_ID_F0_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ID_F0_CSR_V2_AMAP, *PPCICFG_ID_F0_CSR_V2_AMAP;


typedef struct {
   BE_BIT vendorid[16];                           // DWORD 0
   BE_BIT deviceid[16];                           // DWORD 0
} SG_PACK BE_PCICFG_ID_F1_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ID_F1_CSR_V2_AMAP, *PPCICFG_ID_F1_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT memen;                                  // DWORD 0
   BE_BIT bmen;                                   // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT perrsp;                                 // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT serren;                                 // DWORD 0
   BE_BIT rsvd3;                                  // DWORD 0
   BE_BIT intxdisable;                            // DWORD 0
   BE_BIT rsvd4[5];                               // DWORD 0
   BE_BIT rsvd5[3];                               // DWORD 0
   BE_BIT intstat;                                // DWORD 0
   BE_BIT cap;                                    // DWORD 0
   BE_BIT rsvd6;                                  // DWORD 0
   BE_BIT rsvd7;                                  // DWORD 0
   BE_BIT rsvd8;                                  // DWORD 0
   BE_BIT dpderr;                                 // DWORD 0
   BE_BIT rsvd9[2];                               // DWORD 0
   BE_BIT stabt;                                  // DWORD 0
   BE_BIT rtabt;                                  // DWORD 0
   BE_BIT rmabt;                                  // DWORD 0
   BE_BIT sserr;                                  // DWORD 0
   BE_BIT dperr;                                  // DWORD 0
} SG_PACK BE_PCICFG_COMMAND_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_COMMAND_STATUS_CSR_V2_AMAP, *PPCICFG_COMMAND_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT dmtf_clp;                               // DWORD 0
   BE_BIT pxe_init;                               // DWORD 0
   BE_BIT iscsi_init;                             // DWORD 0
   BE_BIT arm_fw_hang;                            // DWORD 0
   BE_BIT bios_future_use[4];                     // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_PCICFG_OPTION_ROM_BIOS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_OPTION_ROM_BIOS_CSR_V2_AMAP, *PPCICFG_OPTION_ROM_BIOS_CSR_V2_AMAP;


typedef struct {
   BE_BIT asic_rev_num[8];                        // DWORD 0
   BE_BIT asic_gen_num[8];                        // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_PCICFG_ASIC_ID_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ASIC_ID_CSR_V2_AMAP, *PPCICFG_ASIC_ID_CSR_V2_AMAP;


typedef struct {
   BE_BIT rev[8];                                 // DWORD 0
   BE_BIT prgintf[8];                             // DWORD 0
   BE_BIT subclass[8];                            // DWORD 0
   BE_BIT baseclass[8];                           // DWORD 0
} SG_PACK BE_PCICFG_CLASS_REV_F0_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CLASS_REV_F0_CSR_V2_AMAP, *PPCICFG_CLASS_REV_F0_CSR_V2_AMAP;


typedef struct {
   BE_BIT rev[8];                                 // DWORD 0
   BE_BIT prgintf[8];                             // DWORD 0
   BE_BIT subclass[8];                            // DWORD 0
   BE_BIT baseclass[8];                           // DWORD 0
} SG_PACK BE_PCICFG_CLASS_REV_F1_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CLASS_REV_F1_CSR_V2_AMAP, *PPCICFG_CLASS_REV_F1_CSR_V2_AMAP;


typedef struct {
   BE_BIT cache_size[8];                          // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT rsvd1[5];                               // DWORD 0
   BE_BIT header_type[8];                         // DWORD 0
   BE_BIT bist[8];                                // DWORD 0
} SG_PACK BE_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CACHE_TMR_HDR_BIST_CSR_V2_AMAP, *PPCICFG_CACHE_TMR_HDR_BIST_CSR_V2_AMAP;


typedef struct {
   BE_BIT iospace;                                // DWORD 0
   BE_BIT rsvd0[7];                               // DWORD 0
   BE_BIT iobar[24];                              // DWORD 0
} SG_PACK BE_PCICFG_IOBAR_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IOBAR_CSR_V2_AMAP, *PPCICFG_IOBAR_CSR_V2_AMAP;


typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
   BE_BIT membar0[18];                            // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR0_LO_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR0_LO_CSR_V2_AMAP, *PPCICFG_MEMBAR0_LO_CSR_V2_AMAP;


typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[13];                              // DWORD 0
   BE_BIT membar1lo[15];                          // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR1_LO_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR1_LO_CSR_V2_AMAP, *PPCICFG_MEMBAR1_LO_CSR_V2_AMAP;


typedef struct {
   BE_BIT membar0hi[32];                          // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR0_HI_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR0_HI_CSR_V2_AMAP, *PPCICFG_MEMBAR0_HI_CSR_V2_AMAP;


typedef struct {
   BE_BIT membar1hi[32];                          // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR1_HI_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR1_HI_CSR_V2_AMAP, *PPCICFG_MEMBAR1_HI_CSR_V2_AMAP;


typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[13];                              // DWORD 0
   BE_BIT memsp_pgsize_0;                         // DWORD 0
   BE_BIT memsp_pgsize_1;                         // DWORD 0
   BE_BIT memsp_pgsize_2;                         // DWORD 0
   BE_BIT memsp_pgsize_3;                         // DWORD 0
   BE_BIT membar2lo[11];                          // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR2_LO_F0_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR2_LO_F0_CSR_V2_AMAP, *PPCICFG_MEMBAR2_LO_F0_CSR_V2_AMAP;


typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[18];                              // DWORD 0
   BE_BIT memsp_pgsize_0;                         // DWORD 0
   BE_BIT memsp_pgsize_1;                         // DWORD 0
   BE_BIT memsp_pgsize_2;                         // DWORD 0
   BE_BIT memsp_pgsize_3;                         // DWORD 0
   BE_BIT membar2lo[6];                           // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR2_LO_F1_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR2_LO_F1_CSR_V2_AMAP, *PPCICFG_MEMBAR2_LO_F1_CSR_V2_AMAP;


typedef struct {
   BE_BIT membar2hi[32];                          // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR2_HI_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR2_HI_CSR_V2_AMAP, *PPCICFG_MEMBAR2_HI_CSR_V2_AMAP;


typedef struct {
   BE_BIT subsys_vendor_id[16];                   // DWORD 0
   BE_BIT subsys_id[16];                          // DWORD 0
} SG_PACK BE_PCICFG_SUBSYSTEM_ID_F0_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SUBSYSTEM_ID_F0_CSR_V2_AMAP, *PPCICFG_SUBSYSTEM_ID_F0_CSR_V2_AMAP;


typedef struct {
   BE_BIT subsys_vendor_id[16];                   // DWORD 0
   BE_BIT subsys_id[16];                          // DWORD 0
} SG_PACK BE_PCICFG_SUBSYSTEM_ID_F1_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SUBSYSTEM_ID_F1_CSR_V2_AMAP, *PPCICFG_SUBSYSTEM_ID_F1_CSR_V2_AMAP;


typedef struct {
   BE_BIT exprombarenable;                        // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT exprombar[16];                          // DWORD 0
} SG_PACK BE_PCICFG_EXP_ROM_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_EXP_ROM_CSR_V2_AMAP, *PPCICFG_EXP_ROM_CSR_V2_AMAP;


typedef struct {
   BE_BIT capptr[8];                              // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_PCICFG_CAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CAP_CSR_V2_AMAP, *PPCICFG_CAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT int_line[8];                            // DWORD 0
   BE_BIT int_pin[8];                             // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_PCICFG_LATENCY_INT_F0_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_LATENCY_INT_F0_CSR_V2_AMAP, *PPCICFG_LATENCY_INT_F0_CSR_V2_AMAP;


typedef struct {
   BE_BIT int_line[8];                            // DWORD 0
   BE_BIT int_pin[8];                             // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_PCICFG_LATENCY_INT_F1_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_LATENCY_INT_F1_CSR_V2_AMAP, *PPCICFG_LATENCY_INT_F1_CSR_V2_AMAP;


typedef struct {
   BE_BIT locked;                                 // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT scratchpad[16];                         // DWORD 0
} SG_PACK BE_PCICFG_SEMAPHORE_SCRATCH_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SEMAPHORE_SCRATCH_CSR_V2_AMAP, *PPCICFG_SEMAPHORE_SCRATCH_CSR_V2_AMAP;


typedef struct {
   BE_BIT locked;                                 // DWORD 0
   BE_BIT rsvd0[31];                              // DWORD 0
} SG_PACK BE_PCICFG_SEMAPHORE_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SEMAPHORE_CSR_V2_AMAP, *PPCICFG_SEMAPHORE_CSR_V2_AMAP;


typedef struct {
   BE_BIT locked;                                 // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT rrm_host_softack;                       // DWORD 0
   BE_BIT ncsi_softreset_reqack;                  // DWORD 0
   BE_BIT softreset;                              // DWORD 0
   BE_BIT ncsi_softreset_ctrl;                    // DWORD 0
   BE_BIT wait_ncsi_softreset_reqack;             // DWORD 0
   BE_BIT exception_oe;                           // DWORD 0
   BE_BIT d3_softreset_ctrl;                      // DWORD 0
   BE_BIT wait_rrm_softreset_reqack;              // DWORD 0
   BE_BIT dbg_all_reqs_62_48[11];                 // DWORD 0
   BE_BIT driver_ue;                              // DWORD 0
   BE_BIT future_scratchpad[7];                   // DWORD 0
} SG_PACK BE_PCICFG_SOFT_RESET_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SOFT_RESET_CSR_V2_AMAP, *PPCICFG_SOFT_RESET_CSR_V2_AMAP;


typedef struct {
   BE_BIT debugselect[8];                         // DWORD 0
   BE_BIT debugblock[8];                          // DWORD 0
   BE_BIT debugchain[4];                          // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT rgpio_32bits;                           // DWORD 0
   BE_BIT rsvd1[6];                               // DWORD 0
   BE_BIT debugin;                                // DWORD 0
   BE_BIT debugout;                               // DWORD 0
} SG_PACK BE_PCICFG_DEBUG_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_DEBUG_CSR_V2_AMAP, *PPCICFG_DEBUG_CSR_V2_AMAP;


typedef struct {
   BE_BIT PFNUM[8];                               // DWORD 0
   BE_BIT periph_host_ctrl[16];                   // DWORD 0
   BE_BIT host_periph_ctrl[8];                    // DWORD 0
} SG_PACK BE_PCICFG_FUNCTION_IDENTIFIER_F1_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_FUNCTION_IDENTIFIER_F1_V2_AMAP, *PPCICFG_FUNCTION_IDENTIFIER_F1_V2_AMAP;


typedef struct {
   BE_BIT PFNUM[8];                               // DWORD 0
   BE_BIT future_scratchpad;                      // DWORD 0
   BE_BIT func15to8en[8];                         // DWORD 0
   BE_BIT id_based_routing_en;                    // DWORD 0
   BE_BIT vf_256v_cev_int_line_en1;               // DWORD 0
   BE_BIT msix_256v_funcnum1[4];                  // DWORD 0
   BE_BIT f15_f8_4MB_db_bar[8];                   // DWORD 0
   BE_BIT ignore_ARI_for_pfs;                     // DWORD 0
} SG_PACK BE_PCICFG_FUNCTION_IDENTIFIER_F0_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_FUNCTION_IDENTIFIER_F0_V2_AMAP, *PPCICFG_FUNCTION_IDENTIFIER_F0_V2_AMAP;


typedef struct {
   BE_BIT winmode;                                // DWORD 0
   BE_BIT membarwinen;                            // DWORD 0
   BE_BIT winaddr[18];                            // DWORD 0
   BE_BIT sliport_error1[2];                      // DWORD 0
   BE_BIT SLI_STATUS_ERR;                         // DWORD 0
   BE_BIT SLI_STATUS_RN;                          // DWORD 0
   BE_BIT vf_256v_cev_int_line_en0;               // DWORD 0
   BE_BIT vf_cev_int_line_en;                     // DWORD 0
   BE_BIT drv_mpu_msg[2];                         // DWORD 0
   BE_BIT shadow_FLR;                             // DWORD 0
   BE_BIT hostintr;                               // DWORD 0
   BE_BIT winselect[2];                           // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2_AMAP, *PPCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2_AMAP;


typedef struct {
   BE_BIT gpi[32];                                // DWORD 0
} SG_PACK BE_PCICFG_GPI_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GPI_CSR_V2_AMAP, *PPCICFG_GPI_CSR_V2_AMAP;


typedef struct {
   BE_BIT gpo[32];                                // DWORD 0
} SG_PACK BE_PCICFG_GPO_LOW_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GPO_LOW_CSR_V2_AMAP, *PPCICFG_GPO_LOW_CSR_V2_AMAP;


typedef struct {
   BE_BIT gpo[32];                                // DWORD 0
} SG_PACK BE_PCICFG_GPO_HI_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GPO_HI_CSR_V2_AMAP, *PPCICFG_GPO_HI_CSR_V2_AMAP;


typedef struct {
   BE_BIT gpiomux[32];                            // DWORD 0
} SG_PACK BE_PCICFG_GPIOMUX_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GPIOMUX_CSR_V2_AMAP, *PPCICFG_GPIOMUX_CSR_V2_AMAP;


typedef struct {
   BE_BIT gpomap[32];                             // DWORD 0
} SG_PACK BE_PCICFG_GPIOMAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GPIOMAP_CSR_V2_AMAP, *PPCICFG_GPIOMAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT exception_oe;                           // DWORD 0
   BE_BIT host_dbg_mux_data_core_46_16[31];       // DWORD 0
} SG_PACK BE_PCIECFG_BE_EXCEPTION_CTRL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCIECFG_BE_EXCEPTION_CTRL_CSR_V2_AMAP, *PPCIECFG_BE_EXCEPTION_CTRL_CSR_V2_AMAP;


typedef struct {
   BE_BIT softrst;                                // DWORD 0
   BE_BIT softrst_d3;                             // DWORD 0
   BE_BIT pcie_linkdn_change;                     // DWORD 0
   BE_BIT gpiintr;                                // DWORD 0
   BE_BIT gpirsvd_intr;                           // DWORD 0
   BE_BIT pcie_linkdn;                            // DWORD 0
   BE_BIT pcie_speed_change;                      // DWORD 0
   BE_BIT pcie_powerdown_change;                  // DWORD 0
   BE_BIT func_pwr_state_reset;                   // DWORD 0
   BE_BIT l2t_eval_phase_not_optimal;             // DWORD 0
   BE_BIT pf7_pf0_pm_change;                      // DWORD 0
   BE_BIT pf15_pf8_pm_change;                     // DWORD 0
   BE_BIT unplanned_shutdown_change;              // DWORD 0
   BE_BIT d3_clk_stop_change;                     // DWORD 0
   BE_BIT d3_resource_word_intr;                  // DWORD 0
   BE_BIT d3_resource_byte_intr;                  // DWORD 0
   BE_BIT mask_d0_data_change_1to0;               // DWORD 0
   BE_BIT mask_d0_data_change_0to1;               // DWORD 0
   BE_BIT be_block1_rstgen_st_change;             // DWORD 0
   BE_BIT pad_rst_fund_n_change_1to0;             // DWORD 0
   BE_BIT pad_rst_fund_n_change_0to1;             // DWORD 0
   BE_BIT netc_issued_softrst;                    // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
} SG_PACK BE_PCICFG_HOSTD3_INT_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOSTD3_INT_STATUS_CSR_V2_AMAP, *PPCICFG_HOSTD3_INT_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT softrst;                                // DWORD 0
   BE_BIT softrst_d3;                             // DWORD 0
   BE_BIT pcie_linkdn_change;                     // DWORD 0
   BE_BIT gpiintr;                                // DWORD 0
   BE_BIT gpirsvd_intr;                           // DWORD 0
   BE_BIT pcie_linkdn;                            // DWORD 0
   BE_BIT pcie_speed_change;                      // DWORD 0
   BE_BIT pcie_powerdown_change;                  // DWORD 0
   BE_BIT func_pwr_state_reset;                   // DWORD 0
   BE_BIT l2t_eval_phase_not_optimal;             // DWORD 0
   BE_BIT pf7_pf0_pm_change;                      // DWORD 0
   BE_BIT pf15_pf8_pm_change;                     // DWORD 0
   BE_BIT unplanned_shutdown_change;              // DWORD 0
   BE_BIT d3_clk_stop_change;                     // DWORD 0
   BE_BIT d3_resource_word;                       // DWORD 0
   BE_BIT d3_resource_byte;                       // DWORD 0
   BE_BIT mask_d0_data_change_1to0;               // DWORD 0
   BE_BIT mask_d0_data_change;                    // DWORD 0
   BE_BIT be_block1_rstgen_st_change;             // DWORD 0
   BE_BIT pad_rst_fund_n_change_1to0;             // DWORD 0
   BE_BIT pad_rst_fund_n_change_0to1;             // DWORD 0
   BE_BIT netc_issued_softrst;                    // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
} SG_PACK BE_PCICFG_HOSTD3_INT_MASK_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOSTD3_INT_MASK_CSR_V2_AMAP, *PPCICFG_HOSTD3_INT_MASK_CSR_V2_AMAP;


typedef struct {
   BE_BIT softrst;                                // DWORD 0
   BE_BIT softrst_d3;                             // DWORD 0
   BE_BIT pcie_linkdn;                            // DWORD 0
   BE_BIT gpiintr;                                // DWORD 0
   BE_BIT gpirsvd_intr;                           // DWORD 0
   BE_BIT pcie_speed[2];                          // DWORD 0
   BE_BIT pcie_powerdown[2];                      // DWORD 0
   BE_BIT unplanned_shutdown;                     // DWORD 0
   BE_BIT d3_clk_stop;                            // DWORD 0
   BE_BIT mask_d0_data;                           // DWORD 0
   BE_BIT pad_rst_fund_n;                         // DWORD 0
   BE_BIT hostd3_ncsi_intr;                       // DWORD 0
   BE_BIT rsvd0[18];                              // DWORD 0
} SG_PACK BE_PCICFG_HOSTD3_INT_LIVE_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOSTD3_INT_LIVE_CSR_V2_AMAP, *PPCICFG_HOSTD3_INT_LIVE_CSR_V2_AMAP;


typedef struct {
   BE_BIT bmen_state_change;                      // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT tph_disable;                            // DWORD 0
   BE_BIT rsvd1[7];                               // DWORD 0
   BE_BIT flr_intren_rst;                         // DWORD 0
   BE_BIT rsvd2[7];                               // DWORD 0
} SG_PACK BE_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_INT_MASK2_CSR_V2_AMAP, *PPCICFG_HOST_INT_MASK2_CSR_V2_AMAP;


typedef struct {
   BE_BIT bmen_state_change;                      // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT sliport_error2;                         // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_PCICFG_HOST_INT_STATUS2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_INT_STATUS2_CSR_V2_AMAP, *PPCICFG_HOST_INT_STATUS2_CSR_V2_AMAP;


typedef struct {
   BE_BIT tmr;                                    // DWORD 0
   BE_BIT err;                                    // DWORD 0
   BE_BIT softrst;                                // DWORD 0
   BE_BIT pcie_linkdn;                            // DWORD 0
   BE_BIT pcie_replay_rollover;                   // DWORD 0
   BE_BIT gpiintr;                                // DWORD 0
   BE_BIT pwrstate_change_intr;                   // DWORD 0
   BE_BIT FLR_intr;                               // DWORD 0
   BE_BIT ats_en_change_intr;                     // DWORD 0
   BE_BIT msixtbl_perr_intr;                      // DWORD 0
   BE_BIT link_error_max_intr;                    // DWORD 0
   BE_BIT aspm_change_intr;                       // DWORD 0
   BE_BIT LTSSM_L0_state_change_intr;             // DWORD 0
   BE_BIT tph_req_en_change_intr;                 // DWORD 0
   BE_BIT ats_invalid_req_intr;                   // DWORD 0
   BE_BIT ats_cmpl_avail;                         // DWORD 0
   BE_BIT pf_vpd_req_intr;                        // DWORD 0
   BE_BIT vfs_vpd_req_intr_0;                     // DWORD 0
   BE_BIT ARI_en_change_intr;                     // DWORD 0
   BE_BIT msi_en_change_intr;                     // DWORD 0
   BE_BIT tph_st_mdoe_sel_change_intr;            // DWORD 0
   BE_BIT cmpl_tmout_disable_change_intr;         // DWORD 0
   BE_BIT vfs_vpd_req_intr_1;                     // DWORD 0
   BE_BIT l2t_int;                                // DWORD 0
   BE_BIT TL_INT;                                 // DWORD 0
   BE_BIT RXB_PERR;                               // DWORD 0
   BE_BIT TXB_PERR;                               // DWORD 0
   BE_BIT cust_pfs_vpd_req_intr;                  // DWORD 0
   BE_BIT l2t_hotreset;                           // DWORD 0
   BE_BIT lltxulp_perr;                           // DWORD 0
   BE_BIT wdma_perr;                              // DWORD 0
   BE_BIT resource_arbiter_word_intr;             // DWORD 0
} SG_PACK BE_PCICFG_HOST_INT_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_INT_STATUS_CSR_V2_AMAP, *PPCICFG_HOST_INT_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT tmr;                                    // DWORD 0
   BE_BIT err;                                    // DWORD 0
   BE_BIT softrst;                                // DWORD 0
   BE_BIT pcie_linkdn;                            // DWORD 0
   BE_BIT pcie_replay_rollover;                   // DWORD 0
   BE_BIT gpiintr;                                // DWORD 0
   BE_BIT pwrstate_change;                        // DWORD 0
   BE_BIT FLR_intr;                               // DWORD 0
   BE_BIT ats_en_change;                          // DWORD 0
   BE_BIT msixtbl_perr;                           // DWORD 0
   BE_BIT link_error_max;                         // DWORD 0
   BE_BIT aspm_change;                            // DWORD 0
   BE_BIT LTSSM_L0_state_change;                  // DWORD 0
   BE_BIT tph_req_en_change;                      // DWORD 0
   BE_BIT ats_invalid_req;                        // DWORD 0
   BE_BIT ats_cmpl_avail;                         // DWORD 0
   BE_BIT pf_vpd_req;                             // DWORD 0
   BE_BIT vfs_vpd_req_intr_0;                     // DWORD 0
   BE_BIT ARI_en_change;                          // DWORD 0
   BE_BIT msi_en_change;                          // DWORD 0
   BE_BIT tph_st_mdoe_sel_change;                 // DWORD 0
   BE_BIT cmpl_tmout_disable_change;              // DWORD 0
   BE_BIT vfs_vpd_req_intr_1;                     // DWORD 0
   BE_BIT l2t_int;                                // DWORD 0
   BE_BIT TL_INT;                                 // DWORD 0
   BE_BIT RXB_PERR;                               // DWORD 0
   BE_BIT TXB_PERR;                               // DWORD 0
   BE_BIT cust_pfs_vpd_req_intr;                  // DWORD 0
   BE_BIT l2t_hotreset;                           // DWORD 0
   BE_BIT lltxulp_perr;                           // DWORD 0
   BE_BIT wdma_perr;                              // DWORD 0
   BE_BIT resource_arbiter_word_intr;             // DWORD 0
} SG_PACK BE_PCICFG_HOST_INT_MASK_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_INT_MASK_CSR_V2_AMAP, *PPCICFG_HOST_INT_MASK_CSR_V2_AMAP;


typedef struct {
   BE_BIT netc_mpu_ue;                            // DWORD 0
   BE_BIT rr_ue_err;                              // DWORD 0
   BE_BIT rr_ue_nomatch;                          // DWORD 0
   BE_BIT mgmt_ue;                                // DWORD 0
   BE_BIT periph_gpio_ue;                         // DWORD 0
   BE_BIT d0block_global_ue;                      // DWORD 0
   BE_BIT rsvd0[26];                              // DWORD 0
} SG_PACK BE_PCICFG_HOSTD3_UE_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOSTD3_UE_STATUS_CSR_V2_AMAP, *PPCICFG_HOSTD3_UE_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT netc_mpu_ue;                            // DWORD 0
   BE_BIT rr_ue_err;                              // DWORD 0
   BE_BIT rr_ue_nomatch;                          // DWORD 0
   BE_BIT mgmt_ue;                                // DWORD 0
   BE_BIT periph_gpio_ue;                         // DWORD 0
   BE_BIT d0block_global_ue;                      // DWORD 0
   BE_BIT rsvd0[26];                              // DWORD 0
} SG_PACK BE_PCICFG_HOSTD3_UE_MASK_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOSTD3_UE_MASK_CSR_V2_AMAP, *PPCICFG_HOSTD3_UE_MASK_CSR_V2_AMAP;


typedef struct {
   BE_BIT cev_ue_status;                          // DWORD 0
   BE_BIT ctx_ue_status;                          // DWORD 0
   BE_BIT dbuf_ue_status;                         // DWORD 0
   BE_BIT erx_ue_status;                          // DWORD 0
   BE_BIT host_ue_status;                         // DWORD 0
   BE_BIT mpu_ue_status;                          // DWORD 0
   BE_BIT ndma_ue_status;                         // DWORD 0
   BE_BIT ptc_ue_status;                          // DWORD 0
   BE_BIT rdma_ue_status;                         // DWORD 0
   BE_BIT rxf_ue_status;                          // DWORD 0
   BE_BIT rxips_ue_status;                        // DWORD 0
   BE_BIT rxulp0_ue_status;                       // DWORD 0
   BE_BIT rxulp1_ue_status;                       // DWORD 0
   BE_BIT rxulp2_ue_status;                       // DWORD 0
   BE_BIT tim_ue_status;                          // DWORD 0
   BE_BIT tpost_ue_status;                        // DWORD 0
   BE_BIT tpre_ue_status;                         // DWORD 0
   BE_BIT txips_ue_status;                        // DWORD 0
   BE_BIT txulp0_ue_status;                       // DWORD 0
   BE_BIT txulp1_ue_status;                       // DWORD 0
   BE_BIT uc_ue_status;                           // DWORD 0
   BE_BIT wdma_ue_status;                         // DWORD 0
   BE_BIT txulp2_ue_status;                       // DWORD 0
   BE_BIT host1_ue_status;                        // DWORD 0
   BE_BIT p0_ob_link_ue_status;                   // DWORD 0
   BE_BIT p1_ob_link_ue_status;                   // DWORD 0
   BE_BIT host_gpio_ue_status;                    // DWORD 0
   BE_BIT mbox_ue_status;                         // DWORD 0
   BE_BIT erx2_ue_status;                         // DWORD 0
   BE_BIT spare_ue_status;                        // DWORD 0
   BE_BIT jtag_ue_status;                         // DWORD 0
   BE_BIT mpu_intpend_ue_status;                  // DWORD 0
} SG_PACK BE_PCICFG_UE_STATUS_LOW_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_UE_STATUS_LOW_CSR_V2_AMAP, *PPCICFG_UE_STATUS_LOW_CSR_V2_AMAP;


typedef struct {
   BE_BIT lpcmemhost_ue_status;                   // DWORD 0
   BE_BIT mgmt_mac_ue_status;                     // DWORD 0
   BE_BIT pcs0online_ue_status;                   // DWORD 0
   BE_BIT mpu_iram_ue_status;                     // DWORD 0
   BE_BIT pcs1online_ue_status;                   // DWORD 0
   BE_BIT pctl0_ue_status;                        // DWORD 0
   BE_BIT pctl1_ue_status;                        // DWORD 0
   BE_BIT pmem_ue_status;                         // DWORD 0
   BE_BIT rr_ue_status;                           // DWORD 0
   BE_BIT txpb_ue_status;                         // DWORD 0
   BE_BIT rxpp_ue_status;                         // DWORD 0
   BE_BIT xaui_ue_status;                         // DWORD 0
   BE_BIT txp_ue_status;                          // DWORD 0
   BE_BIT arm_ue_status;                          // DWORD 0
   BE_BIT ipc_ue_status;                          // DWORD 0
   BE_BIT host2_ue_status;                        // DWORD 0
   BE_BIT host3_ue_status;                        // DWORD 0
   BE_BIT host4_ue_status;                        // DWORD 0
   BE_BIT host5_ue_status;                        // DWORD 0
   BE_BIT host6_ue_status;                        // DWORD 0
   BE_BIT host7_ue_status;                        // DWORD 0
   BE_BIT host8_ue_status;                        // DWORD 0
   BE_BIT host9_ue_status;                        // DWORD 0
   BE_BIT netc_ue_status;                         // DWORD 0
   BE_BIT periph_ue_status;                       // DWORD 0
   BE_BIT lltxulp_ue_status;                      // DWORD 0
   BE_BIT d2p_ue_status;                          // DWORD 0
   BE_BIT rcon_ue_status;                         // DWORD 0
   BE_BIT ldma_ue_status;                         // DWORD 0
   BE_BIT lltxp_ue_status;                        // DWORD 0
   BE_BIT lltxpb_ue_status;                       // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
} SG_PACK BE_PCICFG_UE_STATUS_HI_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_UE_STATUS_HI_CSR_V2_AMAP, *PPCICFG_UE_STATUS_HI_CSR_V2_AMAP;


typedef struct {
   BE_BIT cev_ue_mask;                            // DWORD 0
   BE_BIT ctx_ue_mask;                            // DWORD 0
   BE_BIT dbuf_ue_mask;                           // DWORD 0
   BE_BIT erx_ue_mask;                            // DWORD 0
   BE_BIT host_ue_mask;                           // DWORD 0
   BE_BIT mpu_ue_mask;                            // DWORD 0
   BE_BIT ndma_ue_mask;                           // DWORD 0
   BE_BIT ptc_ue_mask;                            // DWORD 0
   BE_BIT rdma_ue_mask;                           // DWORD 0
   BE_BIT rxf_ue_mask;                            // DWORD 0
   BE_BIT rxips_ue_mask;                          // DWORD 0
   BE_BIT rxulp0_ue_mask;                         // DWORD 0
   BE_BIT rxulp1_ue_mask;                         // DWORD 0
   BE_BIT rxulp2_ue_mask;                         // DWORD 0
   BE_BIT tim_ue_mask;                            // DWORD 0
   BE_BIT tpost_ue_mask;                          // DWORD 0
   BE_BIT tpre_ue_mask;                           // DWORD 0
   BE_BIT txips_ue_mask;                          // DWORD 0
   BE_BIT txulp0_ue_mask;                         // DWORD 0
   BE_BIT txulp1_ue_mask;                         // DWORD 0
   BE_BIT uc_ue_mask;                             // DWORD 0
   BE_BIT wdma_ue_mask;                           // DWORD 0
   BE_BIT txulp2_ue_mask;                         // DWORD 0
   BE_BIT host1_ue_mask;                          // DWORD 0
   BE_BIT p0_ob_link_ue_mask;                     // DWORD 0
   BE_BIT p1_ob_link_ue_mask;                     // DWORD 0
   BE_BIT host_gpio_ue_mask;                      // DWORD 0
   BE_BIT mbox_ue_mask;                           // DWORD 0
   BE_BIT erx2_ue_mask;                           // DWORD 0
   BE_BIT spare_ue_mask;                          // DWORD 0
   BE_BIT jtag_ue_mask;                           // DWORD 0
   BE_BIT mpu_intpend_ue_mask;                    // DWORD 0
} SG_PACK BE_PCICFG_UE_STATUS_LOW_MASK_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_UE_STATUS_LOW_MASK_CSR_V2_AMAP, *PPCICFG_UE_STATUS_LOW_MASK_CSR_V2_AMAP;


typedef struct {
   BE_BIT lpcmemhost_ue_mask;                     // DWORD 0
   BE_BIT mgmt_mac_ue_mask;                       // DWORD 0
   BE_BIT pcs0online_ue_mask;                     // DWORD 0
   BE_BIT mpu_iram_ue_mask;                       // DWORD 0
   BE_BIT pcs1online_ue_mask;                     // DWORD 0
   BE_BIT pctl0_ue_mask;                          // DWORD 0
   BE_BIT pctl1_ue_mask;                          // DWORD 0
   BE_BIT pmem_ue_mask;                           // DWORD 0
   BE_BIT rr_ue_mask;                             // DWORD 0
   BE_BIT txpb_ue_mask;                           // DWORD 0
   BE_BIT rxpp_ue_mask;                           // DWORD 0
   BE_BIT xaui_ue_mask;                           // DWORD 0
   BE_BIT txp_ue_mask;                            // DWORD 0
   BE_BIT arm_ue_mask;                            // DWORD 0
   BE_BIT ipc_ue_mask;                            // DWORD 0
   BE_BIT host2_ue_mask;                          // DWORD 0
   BE_BIT host3_ue_mask;                          // DWORD 0
   BE_BIT host4_ue_mask;                          // DWORD 0
   BE_BIT host5_ue_mask;                          // DWORD 0
   BE_BIT host6_ue_mask;                          // DWORD 0
   BE_BIT host7_ue_mask;                          // DWORD 0
   BE_BIT host8_ue_mask;                          // DWORD 0
   BE_BIT host9_ue_mask;                          // DWORD 0
   BE_BIT netc_ue_mask;                           // DWORD 0
   BE_BIT periph_ue_mask;                         // DWORD 0
   BE_BIT lltxulp_ue_mask;                        // DWORD 0
   BE_BIT d2p_ue_mask;                            // DWORD 0
   BE_BIT rcon_ue_mask;                           // DWORD 0
   BE_BIT ldma_ue_mask;                           // DWORD 0
   BE_BIT lltxp_ue_mask;                          // DWORD 0
   BE_BIT lltxpb_ue_mask;                         // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
} SG_PACK BE_PCICFG_UE_STATUS_HI_MASK_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_UE_STATUS_HI_MASK_CSR_V2_AMAP, *PPCICFG_UE_STATUS_HI_MASK_CSR_V2_AMAP;


typedef struct {
   BE_BIT cev_online;                             // DWORD 0
   BE_BIT ctx_online;                             // DWORD 0
   BE_BIT dbuf_online;                            // DWORD 0
   BE_BIT erx_online;                             // DWORD 0
   BE_BIT host_online;                            // DWORD 0
   BE_BIT mpu_online;                             // DWORD 0
   BE_BIT ndma_online;                            // DWORD 0
   BE_BIT ptc_online;                             // DWORD 0
   BE_BIT rdma_online;                            // DWORD 0
   BE_BIT rxf_online;                             // DWORD 0
   BE_BIT rxips_online;                           // DWORD 0
   BE_BIT rxulp0_online;                          // DWORD 0
   BE_BIT rxulp1_online;                          // DWORD 0
   BE_BIT rxulp2_online;                          // DWORD 0
   BE_BIT tim_online;                             // DWORD 0
   BE_BIT tpost_online;                           // DWORD 0
   BE_BIT tpre_online;                            // DWORD 0
   BE_BIT txips_online;                           // DWORD 0
   BE_BIT txulp0_online;                          // DWORD 0
   BE_BIT txulp1_online;                          // DWORD 0
   BE_BIT uc_online;                              // DWORD 0
   BE_BIT wdma_online;                            // DWORD 0
   BE_BIT txulp2_online;                          // DWORD 0
   BE_BIT host1_online;                           // DWORD 0
   BE_BIT p0_ob_link_online;                      // DWORD 0
   BE_BIT p1_ob_link_online;                      // DWORD 0
   BE_BIT host_gpio_online;                       // DWORD 0
   BE_BIT mbox_online;                            // DWORD 0
   BE_BIT erx2_online;                            // DWORD 0
   BE_BIT spare_online;                           // DWORD 0
   BE_BIT jtag_online;                            // DWORD 0
   BE_BIT mpu_intpend_online;                     // DWORD 0
} SG_PACK BE_PCICFG_ONLINE0_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ONLINE0_CSR_V2_AMAP, *PPCICFG_ONLINE0_CSR_V2_AMAP;


typedef struct {
   BE_BIT lpcmemhost_online;                      // DWORD 0
   BE_BIT mgmt_mac_online;                        // DWORD 0
   BE_BIT pcs0online_online;                      // DWORD 0
   BE_BIT mpu_iram_online;                        // DWORD 0
   BE_BIT pcs1online_online;                      // DWORD 0
   BE_BIT pctl0_online;                           // DWORD 0
   BE_BIT pctl1_online;                           // DWORD 0
   BE_BIT pmem_online;                            // DWORD 0
   BE_BIT rr_online;                              // DWORD 0
   BE_BIT txpb_online;                            // DWORD 0
   BE_BIT rxpp_online;                            // DWORD 0
   BE_BIT xaui_online;                            // DWORD 0
   BE_BIT txp_online;                             // DWORD 0
   BE_BIT arm_online;                             // DWORD 0
   BE_BIT ipc_online;                             // DWORD 0
   BE_BIT host2_online;                           // DWORD 0
   BE_BIT host3_online;                           // DWORD 0
   BE_BIT host4_online;                           // DWORD 0
   BE_BIT host5_online;                           // DWORD 0
   BE_BIT host6_online;                           // DWORD 0
   BE_BIT host7_online;                           // DWORD 0
   BE_BIT host8_online;                           // DWORD 0
   BE_BIT host9_online;                           // DWORD 0
   BE_BIT netc_online;                            // DWORD 0
   BE_BIT periph_online;                          // DWORD 0
   BE_BIT lltxulp_online;                         // DWORD 0
   BE_BIT d2p_online;                             // DWORD 0
   BE_BIT rcon_online;                            // DWORD 0
   BE_BIT ldma_online;                            // DWORD 0
   BE_BIT lltxp_online;                           // DWORD 0
   BE_BIT lltxpb_online;                          // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
} SG_PACK BE_PCICFG_ONLINE1_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ONLINE1_CSR_V2_AMAP, *PPCICFG_ONLINE1_CSR_V2_AMAP;


typedef struct {
   BE_BIT cev_gclk_core_en;                       // DWORD 0
   BE_BIT ctx_gclk_core_en;                       // DWORD 0
   BE_BIT dbuf_gclk_core_en;                      // DWORD 0
   BE_BIT erx_gclk_core_en;                       // DWORD 0
   BE_BIT host_gclk_core_en;                      // DWORD 0
   BE_BIT mpu_gclk_core_en;                       // DWORD 0
   BE_BIT ndma_gclk_core_en;                      // DWORD 0
   BE_BIT ptc_gclk_core_en;                       // DWORD 0
   BE_BIT rdma_gclk_core_en;                      // DWORD 0
   BE_BIT rxf_gclk_core_en;                       // DWORD 0
   BE_BIT rxips_gclk_core_en;                     // DWORD 0
   BE_BIT rxulp0_gclk_core_en;                    // DWORD 0
   BE_BIT rxulp1_gclk_core_en;                    // DWORD 0
   BE_BIT rxulp2_gclk_core_en;                    // DWORD 0
   BE_BIT tim_gclk_core_en;                       // DWORD 0
   BE_BIT tpost_gclk_core_en;                     // DWORD 0
   BE_BIT tpre_gclk_core_en;                      // DWORD 0
   BE_BIT txips_gclk_core_en;                     // DWORD 0
   BE_BIT txulp0_gclk_core_en;                    // DWORD 0
   BE_BIT txulp1_gclk_core_en;                    // DWORD 0
   BE_BIT uc_gclk_core_en;                        // DWORD 0
   BE_BIT wdma_gclk_core_en;                      // DWORD 0
   BE_BIT txulp2_gclk_core_en;                    // DWORD 0
   BE_BIT host1_gclk_core_en;                     // DWORD 0
   BE_BIT p0_ob_link_gclk_core_en;                // DWORD 0
   BE_BIT p1_ob_link_gclk_core_en;                // DWORD 0
   BE_BIT host_gpio_gclk_core_en;                 // DWORD 0
   BE_BIT mbox_gclk_core_en;                      // DWORD 0
   BE_BIT erx2_gclk_core_en;                      // DWORD 0
   BE_BIT spare_gclk_core_en;                     // DWORD 0
   BE_BIT jtag_gclk_core_en;                      // DWORD 0
   BE_BIT mpu_intpend_gclk_core_en;               // DWORD 0
} SG_PACK BE_PCICFG_GCLK_CORE_EN0_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GCLK_CORE_EN0_CSR_V2_AMAP, *PPCICFG_GCLK_CORE_EN0_CSR_V2_AMAP;


typedef struct {
   BE_BIT lpcmemhost_gclk_core_en;                // DWORD 0
   BE_BIT mgmt_mac_gclk_core_en;                  // DWORD 0
   BE_BIT pcs0online_gclk_core_en;                // DWORD 0
   BE_BIT mpu_iram_gclk_core_en;                  // DWORD 0
   BE_BIT pcs1online_gclk_core_en;                // DWORD 0
   BE_BIT pctl0_gclk_core_en;                     // DWORD 0
   BE_BIT pctl1_gclk_core_en;                     // DWORD 0
   BE_BIT pmem_gclk_core_en;                      // DWORD 0
   BE_BIT rr_gclk_core_en;                        // DWORD 0
   BE_BIT txpb_gclk_core_en;                      // DWORD 0
   BE_BIT rxpp_gclk_core_en;                      // DWORD 0
   BE_BIT xaui_gclk_core_en;                      // DWORD 0
   BE_BIT txp_gclk_core_en;                       // DWORD 0
   BE_BIT arm_gclk_core_en;                       // DWORD 0
   BE_BIT ipc_gclk_core_en;                       // DWORD 0
   BE_BIT host2_gclk_core_en;                     // DWORD 0
   BE_BIT host3_gclk_core_en;                     // DWORD 0
   BE_BIT host4_gclk_core_en;                     // DWORD 0
   BE_BIT host5_gclk_core_en;                     // DWORD 0
   BE_BIT host6_gclk_core_en;                     // DWORD 0
   BE_BIT host7_gclk_core_en;                     // DWORD 0
   BE_BIT host8_gclk_core_en;                     // DWORD 0
   BE_BIT host9_gclk_core_en;                     // DWORD 0
   BE_BIT netc_gclk_core_en;                      // DWORD 0
   BE_BIT periph_gclk_core_en;                    // DWORD 0
   BE_BIT lltxulp_gclk_core_en;                   // DWORD 0
   BE_BIT d2p_gclk_core_en;                       // DWORD 0
   BE_BIT rcon_gclk_core_en;                      // DWORD 0
   BE_BIT ldma_gclk_core_en;                      // DWORD 0
   BE_BIT lltxp_gclk_core_en;                     // DWORD 0
   BE_BIT lltxpb_gclk_core_en;                    // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
} SG_PACK BE_PCICFG_GCLK_CORE_EN1_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GCLK_CORE_EN1_CSR_V2_AMAP, *PPCICFG_GCLK_CORE_EN1_CSR_V2_AMAP;


typedef struct {
   BE_BIT phy0_offset[16];                        // DWORD 0
   BE_BIT phy1_offset[16];                        // DWORD 0
} SG_PACK BE_PCICFG_PHY_FLASH_OFFSET_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PHY_FLASH_OFFSET_CSR_V2_AMAP, *PPCICFG_PHY_FLASH_OFFSET_CSR_V2_AMAP;


typedef struct {
   BE_BIT PLL_TXCDREN;                            // DWORD 0
   BE_BIT PLL_TXCDRCH[3];                         // DWORD 0
   BE_BIT PLLB_SELI[3];                           // DWORD 0
   BE_BIT PLLA_SELI[3];                           // DWORD 0
   BE_BIT PLL_SLCTRL[3];                          // DWORD 0
   BE_BIT PLL_CMUVR[3];                           // DWORD 0
   BE_BIT PLL_BGTC[3];                            // DWORD 0
   BE_BIT PLL_BGSV[3];                            // DWORD 0
   BE_BIT PLL_RES[3];                             // DWORD 0
   BE_BIT PLL_RBCAP[2];                           // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
} SG_PACK BE_PCICFG_SERDES_PLL_CONTROL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SERDES_PLL_CONTROL_V2_AMAP, *PPCICFG_SERDES_PLL_CONTROL_V2_AMAP;


typedef struct {
   BE_BIT max_contiguous_count[8];                // DWORD 0
   BE_BIT disable_func0_hp;                       // DWORD 0
   BE_BIT rsvd0[22];                              // DWORD 0
   BE_BIT greedy_flash_en;                        // DWORD 0
} SG_PACK BE_PCICFG_FLASH_GREED_CTRL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_FLASH_GREED_CTRL_CSR_V2_AMAP, *PPCICFG_FLASH_GREED_CTRL_CSR_V2_AMAP;


typedef struct {
   BE_BIT hosttimer[24];                          // DWORD 0
   BE_BIT vf_fun_shared_reg_wr_access;            // DWORD 0
   BE_BIT d3block_shared_reg_wr_access;           // DWORD 0
   BE_BIT clr_pcie_stats;                         // DWORD 0
   BE_BIT ui_enter_l1;                            // DWORD 0
   BE_BIT lpcism_rrm_lpc;                         // DWORD 0
   BE_BIT membar1_cfg_alias_reg_wr_access;        // DWORD 0
   BE_BIT ndma_wrb_factor[2];                     // DWORD 0
} SG_PACK BE_PCICFG_HOST_TIMER_INT_CTRL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_TIMER_INT_CTRL_CSR_V2_AMAP, *PPCICFG_HOST_TIMER_INT_CTRL_CSR_V2_AMAP;


typedef struct {
   BE_BIT d3_PM_PME_en_D0;                        // DWORD 0
   BE_BIT d3_PM_PME_en_D3;                        // DWORD 0
   BE_BIT d3_PM_PME_en_openbox;                   // DWORD 0
   BE_BIT ncss_softrst_ctrl;                      // DWORD 0
   BE_BIT en_softrst_cleanup;                     // DWORD 0
   BE_BIT en_default_pwr_save;                    // DWORD 0
   BE_BIT ncss_softrst_qualify;                   // DWORD 0
   BE_BIT rsvd0[17];                              // DWORD 0
   BE_BIT pme_busnum[8];                          // DWORD 0
} SG_PACK BE_PCICFG_HOST_D3_CONTROL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_D3_CONTROL_CSR_V2_AMAP, *PPCICFG_HOST_D3_CONTROL_CSR_V2_AMAP;


typedef struct {
   BE_BIT vf_fun_shared_reg_wr_access;            // DWORD 0
   BE_BIT rsvd0[7];                               // DWORD 0
   BE_BIT ddr_refresh_ctrl[3];                    // DWORD 0
   BE_BIT ddr_refresh_status[5];                  // DWORD 0
   BE_BIT host_d3_reg_access_func_limit[8];       // DWORD 0
   BE_BIT rsvd1[8];                               // DWORD 0
} SG_PACK BE_PCICFG_HOST_D3CONTROL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_D3CONTROL_CSR_V2_AMAP, *PPCICFG_HOST_D3CONTROL_CSR_V2_AMAP;


typedef struct {
   BE_BIT single_bar_support;                     // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT roce_support;                           // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_PCICFG_HOST_BAR_STATUS_PF1_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_BAR_STATUS_PF1_CSR_V2_AMAP, *PPCICFG_HOST_BAR_STATUS_PF1_CSR_V2_AMAP;


typedef struct {
   BE_BIT single_bar_support[16];                 // DWORD 0
   BE_BIT roce_support[16];                       // DWORD 0
} SG_PACK BE_PCICFG_HOST_CONTROL1_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_CONTROL1_CSR_V2_AMAP, *PPCICFG_HOST_CONTROL1_CSR_V2_AMAP;


typedef struct {
   BE_BIT dpp_cfg_pgsize[3];                      // DWORD 0
   BE_BIT roce_dpp_bar_32MB;                      // DWORD 0
   BE_BIT roce_db_bar_32MB;                       // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT pci_global_revid[8];                    // DWORD 0
   BE_BIT pci_global_revid_valid;                 // DWORD 0
   BE_BIT pci_sli4_revid_valid;                   // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
   BE_BIT msix_256v_funcnum0[4];                  // DWORD 0
   BE_BIT pcicfg_all_extend_membar_wr_access;     // DWORD 0
   BE_BIT vf_pcicfg_membar_wr_access;             // DWORD 0
   BE_BIT mask_rrm_host_nomatch;                  // DWORD 0
   BE_BIT mask_rrm_host_error;                    // DWORD 0
   BE_BIT mask_rrm_host_nomatch_vf_only;          // DWORD 0
   BE_BIT mask_rrm_host_error_vf_only;            // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
} SG_PACK BE_PCICFG_PF0_HOST_CONTROL2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PF0_HOST_CONTROL2_CSR_V2_AMAP, *PPCICFG_PF0_HOST_CONTROL2_CSR_V2_AMAP;


typedef struct {
   BE_BIT dpp_cfg_pgsize[3];                      // DWORD 0
   BE_BIT roce_dpp_bar_32MB;                      // DWORD 0
   BE_BIT roce_db_bar_32MB;                       // DWORD 0
   BE_BIT rsvd0[27];                              // DWORD 0
} SG_PACK BE_PCICFG_HOST_CONTROL2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_CONTROL2_CSR_V2_AMAP, *PPCICFG_HOST_CONTROL2_CSR_V2_AMAP;


typedef struct {
   BE_BIT func4en;                                // DWORD 0
   BE_BIT func5en;                                // DWORD 0
   BE_BIT func6en;                                // DWORD 0
   BE_BIT func7en;                                // DWORD 0
   BE_BIT f3_f0_4MB_db_bar[4];                    // DWORD 0
   BE_BIT hostoqdepth[3];                         // DWORD 0
   BE_BIT hostoqempty;                            // DWORD 0
   BE_BIT hostoqrdpasswren;                       // DWORD 0
   BE_BIT driver_ue_en_pcie_error;                // DWORD 0
   BE_BIT func3en;                                // DWORD 0
   BE_BIT func2en;                                // DWORD 0
   BE_BIT f5_f4_4MB_db_bar[2];                    // DWORD 0
   BE_BIT iqrdflushoqwren;                        // DWORD 0
   BE_BIT cev_swacken;                            // DWORD 0
   BE_BIT pcie_linkdn_ue_source;                  // DWORD 0
   BE_BIT pcie_retry_buf_ecc_ue_source;           // DWORD 0
   BE_BIT pcie_linkdn_ue_mask;                    // DWORD 0
   BE_BIT pcie_retry_buf_ecc_ue_mask;             // DWORD 0
   BE_BIT lpcismtranserr;                         // DWORD 0
   BE_BIT lpcismstaterr;                          // DWORD 0
   BE_BIT fwbootfail;                             // DWORD 0
   BE_BIT expromdisable;                          // DWORD 0
   BE_BIT ARI_spec_en;                            // DWORD 0
   BE_BIT f7_f6_4MB_db_bar[2];                    // DWORD 0
   BE_BIT func1en;                                // DWORD 0
} SG_PACK BE_PCICFG_HOST_CONTROL_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_CONTROL_STATUS_CSR_V2_AMAP, *PPCICFG_HOST_CONTROL_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT lpc_addr[32];                           // DWORD 0
} SG_PACK BE_PCICFG_LPC_ADDR_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_LPC_ADDR_CSR_V2_AMAP, *PPCICFG_LPC_ADDR_CSR_V2_AMAP;


typedef struct {
   BE_BIT lpc_data[32];                           // DWORD 0
} SG_PACK BE_PCICFG_LPC_DATA_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_LPC_DATA_CSR_V2_AMAP, *PPCICFG_LPC_DATA_CSR_V2_AMAP;


typedef struct {
   BE_BIT be[4];                                  // DWORD 0
   BE_BIT wr;                                     // DWORD 0
   BE_BIT req;                                    // DWORD 0
   BE_BIT err;                                    // DWORD 0
   BE_BIT reg;                                    // DWORD 0
   BE_BIT abort;                                  // DWORD 0
   BE_BIT rst;                                    // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
   BE_BIT bus_num[8];                             // DWORD 0
} SG_PACK BE_PCICFG_LPC_COMMAND_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_LPC_COMMAND_CSR_V2_AMAP, *PPCICFG_LPC_COMMAND_CSR_V2_AMAP;


typedef struct {
   BE_BIT rmii[3];                                // DWORD 0
   BE_BIT eth[3];                                 // DWORD 0
   BE_BIT gpio[3];                                // DWORD 0
   BE_BIT spi[3];                                 // DWORD 0
   BE_BIT vport[3];                               // DWORD 0
   BE_BIT rmii_clk[3];                            // DWORD 0
   BE_BIT spi_clk[3];                             // DWORD 0
   BE_BIT DBG_CLK_OUT[3];                         // DWORD 0
   BE_BIT dvsr_pads[3];                           // DWORD 0
   BE_BIT scratchpad[5];                          // DWORD 0
} SG_PACK BE_PCICFG_SLEW_RATE_CTRL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SLEW_RATE_CTRL_V2_AMAP, *PPCICFG_SLEW_RATE_CTRL_V2_AMAP;


typedef struct {
   BE_BIT timestamp[32];                          // DWORD 0
} SG_PACK BE_PCICFG_TIMESTAMP_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_TIMESTAMP_V2_AMAP, *PPCICFG_TIMESTAMP_V2_AMAP;


typedef struct {
   BE_BIT VF_identifier;                          // DWORD 0
   BE_BIT scratchpad[31];                         // DWORD 0
} SG_PACK BE_PCICFG_SCRATCHPAD_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SCRATCHPAD_CSR_V2_AMAP, *PPCICFG_SCRATCHPAD_CSR_V2_AMAP;


typedef struct {
   BE_BIT scratchpad[32];                         // DWORD 0
} SG_PACK BE_PCICFG_CUST_SCRATCHPAD_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CUST_SCRATCHPAD_CSR_V2_AMAP, *PPCICFG_CUST_SCRATCHPAD_CSR_V2_AMAP;


typedef struct {
   BE_BIT stride[31];                             // DWORD 0
   BE_BIT stride_en;                              // DWORD 0
} SG_PACK BE_PCICFG_VF_BAR_STRIDE_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VF_BAR_STRIDE_V2_AMAP, *PPCICFG_VF_BAR_STRIDE_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT supported[4];                           // DWORD 0
   BE_BIT rsvd1[12];                              // DWORD 0
} SG_PACK BE_PCICFG_VF_BAR_STRIDE_SUPPORTED_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VF_BAR_STRIDE_SUPPORTED_V2_AMAP, *PPCICFG_VF_BAR_STRIDE_SUPPORTED_V2_AMAP;


typedef struct {
   BE_BIT capid[8];                               // DWORD 0
   BE_BIT nextcap[8];                             // DWORD 0
   BE_BIT capver[4];                              // DWORD 0
   BE_BIT devport[4];                             // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
} SG_PACK BE_PCICFG_PCIE_CAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_CAP_CSR_V2_AMAP, *PPCICFG_PCIE_CAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT capid[8];                               // DWORD 0
   BE_BIT nextcap[8];                             // DWORD 0
   BE_BIT addr[15];                               // DWORD 0
   BE_BIT flag;                                   // DWORD 0
} SG_PACK BE_PCICFG_VPD_CAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VPD_CAP_CSR_V2_AMAP, *PPCICFG_VPD_CAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_PCICFG_VPD_DATA_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VPD_DATA_CSR_V2_AMAP, *PPCICFG_VPD_DATA_CSR_V2_AMAP;


typedef struct {
   BE_BIT payload[3];                             // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT tag;                                    // DWORD 0
   BE_BIT lo_lat[3];                              // DWORD 0
   BE_BIT l1_lat[3];                              // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT ROLE_ERR_REP;                           // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
   BE_BIT pwr_value[8];                           // DWORD 0
   BE_BIT pwr_scale[2];                           // DWORD 0
   BE_BIT FLR;                                    // DWORD 0
   BE_BIT rsvd3[3];                               // DWORD 0
} SG_PACK BE_PCICFG_PCIE_DEVCAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_DEVCAP_CSR_V2_AMAP, *PPCICFG_PCIE_DEVCAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT CorrErrReportEn;                        // DWORD 0
   BE_BIT NonFatalErrReportEn;                    // DWORD 0
   BE_BIT FatalErrReportEn;                       // DWORD 0
   BE_BIT UnsuppReqReportEn;                      // DWORD 0
   BE_BIT EnableRelaxOrder;                       // DWORD 0
   BE_BIT Max_Payload_Size[3];                    // DWORD 0
   BE_BIT ExtendTagFieldEnable;                   // DWORD 0
   BE_BIT PhantomFnEnable;                        // DWORD 0
   BE_BIT AuxPwrPMEnable;                         // DWORD 0
   BE_BIT EnableNoSnoop;                          // DWORD 0
   BE_BIT Max_Read_Req_Size[3];                   // DWORD 0
   BE_BIT INITIATE_FLR;                           // DWORD 0
   BE_BIT CorrErrDetect;                          // DWORD 0
   BE_BIT NonFatalErrDetect;                      // DWORD 0
   BE_BIT FatalErrDetect;                         // DWORD 0
   BE_BIT UnsuppReqDetect;                        // DWORD 0
   BE_BIT AuxPwrDetect;                           // DWORD 0
   BE_BIT TransPending;                           // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_CONTROL_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_CONTROL_STATUS_CSR_V2_AMAP, *PPCICFG_PCIE_CONTROL_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT MaxLinkSpeed[4];                        // DWORD 0
   BE_BIT MaxLinkWidth[6];                        // DWORD 0
   BE_BIT ASPMSupport[2];                         // DWORD 0
   BE_BIT L0sExitLat[3];                          // DWORD 0
   BE_BIT L1ExitLat[3];                           // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT aspm_opt_cmp;                           // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT PortNum[8];                             // DWORD 0
} SG_PACK BE_PCICFG_PCIE_LINK_CAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_LINK_CAP_CSR_V2_AMAP, *PPCICFG_PCIE_LINK_CAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT ASPMCtl[2];                             // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT ReadCmplBndry;                          // DWORD 0
   BE_BIT LinkDisable;                            // DWORD 0
   BE_BIT RetrainLink;                            // DWORD 0
   BE_BIT CommonClkConfig;                        // DWORD 0
   BE_BIT ExtendSync;                             // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT hw_autonomous_width_dis;                // DWORD 0
   BE_BIT rsvd2[6];                               // DWORD 0
   BE_BIT LinkSpeed[4];                           // DWORD 0
   BE_BIT NegLinkWidth[6];                        // DWORD 0
   BE_BIT LinkTrainErr;                           // DWORD 0
   BE_BIT LinkTrain;                              // DWORD 0
   BE_BIT SlotClkConfig;                          // DWORD 0
   BE_BIT rsvd3[3];                               // DWORD 0
} SG_PACK BE_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP, *PPCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT cmpl_tmout_sup[4];                      // DWORD 0
   BE_BIT cmpl_tmout_dis_sup;                     // DWORD 0
   BE_BIT rsvd0[27];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_DEVCAP2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_DEVCAP2_CSR_V2_AMAP, *PPCICFG_PCIE_DEVCAP2_CSR_V2_AMAP;


typedef struct {
   BE_BIT cmpl_tmout_value[4];                    // DWORD 0
   BE_BIT cmpl_tmout_dis;                         // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT IDO_request_en;                         // DWORD 0
   BE_BIT IDO_cmpl_en;                            // DWORD 0
   BE_BIT rsvd1[22];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP, *PPCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT link_speed_vector[7];                   // DWORD 0
   BE_BIT rsvd1[24];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_LINK_CAP2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_LINK_CAP2_CSR_V2_AMAP, *PPCICFG_PCIE_LINK_CAP2_CSR_V2_AMAP;


typedef struct {
   BE_BIT link_speed[4];                          // DWORD 0
   BE_BIT enter_compliance;                       // DWORD 0
   BE_BIT hw_autonomous_speed_dis;                // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT transmit_margin[3];                     // DWORD 0
   BE_BIT enter_mod_compliance;                   // DWORD 0
   BE_BIT compliance_SOS;                         // DWORD 0
   BE_BIT compliance_preset_deemphasis[4];        // DWORD 0
   BE_BIT current_de_emphasis;                    // DWORD 0
   BE_BIT equalization_complete;                  // DWORD 0
   BE_BIT equalization_phase1_success;            // DWORD 0
   BE_BIT equalization_phase2_success;            // DWORD 0
   BE_BIT equalization_phase3_success;            // DWORD 0
   BE_BIT link_equalization_request;              // DWORD 0
   BE_BIT rsvd1[10];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP, *PPCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT current_de_emphasis;                    // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_LINK_STATUS2_CSR_F1_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_LINK_STATUS2_CSR_F1_V2_AMAP, *PPCICFG_PCIE_LINK_STATUS2_CSR_F1_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_PCICFG_RETURN_ZEROS_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_RETURN_ZEROS_V2_AMAP, *PPCICFG_RETURN_ZEROS_V2_AMAP;


typedef struct {
   BE_BIT capid[8];                               // DWORD 0
   BE_BIT nextptr[8];                             // DWORD 0
   BE_BIT tablesize[11];                          // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT funcmask;                               // DWORD 0
   BE_BIT en;                                     // DWORD 0
} SG_PACK BE_PCICFG_MSIX_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_CSR_V2_AMAP, *PPCICFG_MSIX_CSR_V2_AMAP;


typedef struct {
   BE_BIT tablebir[3];                            // DWORD 0
   BE_BIT offset[29];                             // DWORD 0
} SG_PACK BE_PCICFG_MSIX_TABLE_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_TABLE_CSR_V2_AMAP, *PPCICFG_MSIX_TABLE_CSR_V2_AMAP;


typedef struct {
   BE_BIT pbabir[3];                              // DWORD 0
   BE_BIT offset[29];                             // DWORD 0
} SG_PACK BE_PCICFG_MSIX_PBA_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_PBA_CSR_V2_AMAP, *PPCICFG_MSIX_PBA_CSR_V2_AMAP;


typedef struct {
   BE_BIT mask;                                   // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT st_lower[8];                            // DWORD 0
   BE_BIT st_upper[8];                            // DWORD 0
} SG_PACK BE_PCICFG_MSIX_VECTOR_CONTROL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_VECTOR_CONTROL_CSR_V2_AMAP, *PPCICFG_MSIX_VECTOR_CONTROL_CSR_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_PCICFG_MSIX_MSG_DATA_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_MSG_DATA_CSR_V2_AMAP, *PPCICFG_MSIX_MSG_DATA_CSR_V2_AMAP;


typedef struct {
   BE_BIT addr[32];                               // DWORD 0
} SG_PACK BE_PCICFG_MSIX_MSG_ADDR_HI_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_MSG_ADDR_HI_CSR_V2_AMAP, *PPCICFG_MSIX_MSG_ADDR_HI_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT addr[30];                               // DWORD 0
} SG_PACK BE_PCICFG_MSIX_MSG_ADDR_LO_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_MSG_ADDR_LO_CSR_V2_AMAP, *PPCICFG_MSIX_MSG_ADDR_LO_CSR_V2_AMAP;


typedef struct {
   BE_BIT pba[32];                                // DWORD 0
} SG_PACK BE_PCICFG_MSIX_PBA_STRUCT_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_PBA_STRUCT_CSR_V2_AMAP, *PPCICFG_MSIX_PBA_STRUCT_CSR_V2_AMAP;


typedef struct {
   BE_BIT mode_loopback_bist_result_7_0[8];       // DWORD 0
   BE_BIT ltssm_state[7];                         // DWORD 0
   BE_BIT wake_on_pme_tmr_expiry_en;              // DWORD 0
   BE_BIT future_scratchpad1[10];                 // DWORD 0
   BE_BIT future_scratchpad2[4];                  // DWORD 0
   BE_BIT BME_pf_to_vf_FLR;                       // DWORD 0
   BE_BIT periph_host_d3ism_done;                 // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_0_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_0_CSR_V2_AMAP, *PPCICFG_IP_CONTROL_STATUS_0_CSR_V2_AMAP;


typedef struct {
   BE_BIT mode_tx_drv_en;                         // DWORD 0
   BE_BIT vc0_negotiation_pending;                // DWORD 0
   BE_BIT future_scratchpad1[2];                  // DWORD 0
   BE_BIT PCIE_mdio_phyadr[5];                    // DWORD 0
   BE_BIT future_scratchpad3[3];                  // DWORD 0
   BE_BIT future_scratchpad2[17];                 // DWORD 0
   BE_BIT mode_loopback_master_enable;            // DWORD 0
   BE_BIT future_scratchpad0[2];                  // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_1_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_1_CSR_V2_AMAP, *PPCICFG_IP_CONTROL_STATUS_1_CSR_V2_AMAP;


typedef struct {
   BE_BIT ERR_BADDLLP;                            // DWORD 0
   BE_BIT ERR_BADTLP;                             // DWORD 0
   BE_BIT ERR_RECEIVERERROR;                      // DWORD 0
   BE_BIT ERR_DLPERR;                             // DWORD 0
   BE_BIT ERR_NULLTLP;                            // DWORD 0
   BE_BIT ERR_REPLAY;                             // DWORD 0
   BE_BIT ERR_REPLAY_NUM[2];                      // DWORD 0
   BE_BIT ERR_RPC_REPLAY_ROLLOVR;                 // DWORD 0
   BE_BIT ERR_RPC_REPLAY_TIMEOUT;                 // DWORD 0
   BE_BIT ERR_RPC_REPLAYFIFO_PERR;                // DWORD 0
   BE_BIT ERR_REPLAY_UPPER_UNCORRECTABLE_ERROR;   // DWORD 0
   BE_BIT ERR_REPLAY_LOWER_UNCORRECTABLE_ERROR;   // DWORD 0
   BE_BIT ERR_REPLAY_UPPER_CORRECTABLE_ERROR;     // DWORD 0
   BE_BIT ERR_REPLAY_LOWER_CORRECTABLE_ERROR;     // DWORD 0
   BE_BIT REPLAY_SYNDROME_UPPER[8];               // DWORD 0
   BE_BIT REPLAY_SYNDROME_LOWER[8];               // DWORD 0
   BE_BIT TXB_PARITY_ERR;                         // DWORD 0
} SG_PACK BE_PCICFG_ERR_REPLAY_MONITOR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ERR_REPLAY_MONITOR_V2_AMAP, *PPCICFG_ERR_REPLAY_MONITOR_V2_AMAP;


typedef struct {
   BE_BIT target_link_speed;                      // DWORD 0
   BE_BIT target_link_speed_req;                  // DWORD 0
   BE_BIT target_link_width[8];                   // DWORD 0
   BE_BIT target_link_width_req;                  // DWORD 0
   BE_BIT target_link_autonomous_req;             // DWORD 0
   BE_BIT clr_link_error_count;                   // DWORD 0
   BE_BIT cfg_aspm_l1_dllp_interval_time_limit[3]; // DWORD 0
   BE_BIT target_link_error_cnt[16];              // DWORD 0
} SG_PACK BE_PCICFG_IP_SPEED_WIDTH_CTRL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_SPEED_WIDTH_CTRL_V2_AMAP, *PPCICFG_IP_SPEED_WIDTH_CTRL_V2_AMAP;


typedef struct {
   BE_BIT future_scratchpad0;                     // DWORD 0
   BE_BIT future_scratch_rw1c_0;                  // DWORD 0
   BE_BIT future_scratchpad1[8];                  // DWORD 0
   BE_BIT future_scratch_rw1c_1;                  // DWORD 0
   BE_BIT future_scratchpad2;                     // DWORD 0
   BE_BIT clr_link_error_count;                   // DWORD 0
   BE_BIT cfg_aspm_l1_dllp_interval_time_limit[3]; // DWORD 0
   BE_BIT target_link_error_cnt[16];              // DWORD 0
} SG_PACK BE_PCICFG_IP_LINK_ERROR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_LINK_ERROR_V2_AMAP, *PPCICFG_IP_LINK_ERROR_V2_AMAP;


typedef struct {
   BE_BIT LINK_STATE[5];                          // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT STATE_LANE_ERROR[8];                    // DWORD 0
   BE_BIT rsvd1[4];                               // DWORD 0
   BE_BIT COSPLLOCK;                              // DWORD 0
   BE_BIT EXT_PLL_LOCK;                           // DWORD 0
   BE_BIT logic_analyzer_cal;                     // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
   BE_BIT rsvd3;                                  // DWORD 0
   BE_BIT LINK_ERROR_MAXED[8];                    // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_5_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_5_CSR_V2_AMAP, *PPCICFG_IP_CONTROL_STATUS_5_CSR_V2_AMAP;


typedef struct {
   BE_BIT scratchpad[28];                         // DWORD 0
   BE_BIT pf0_sli4_if_type[4];                    // DWORD 0
} SG_PACK BE_PCICFG_VF_SLI4_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VF_SLI4_CSR_V2_AMAP, *PPCICFG_VF_SLI4_CSR_V2_AMAP;


typedef struct {
   BE_BIT STATE_NEGOTIATED_LANE_START[4];         // DWORD 0
   BE_BIT STATE_NEGOTIATED_LANE_END[4];           // DWORD 0
   BE_BIT STATE_DATA_RATE_IDENTIFIER_RECEIVED[8]; // DWORD 0
   BE_BIT STATE_RECEIVER_DETECTED[8];             // DWORD 0
   BE_BIT STATE_ELECTRICAL_IDLE_BROKEN[8];        // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_4_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_4_CSR_V2_AMAP, *PPCICFG_IP_CONTROL_STATUS_4_CSR_V2_AMAP;


typedef struct {
   BE_BIT future_scratchpad[29];                  // DWORD 0
   BE_BIT pad_fund_rst_n_sync;                    // DWORD 0
   BE_BIT future_scratch_rw1c_0[2];               // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_2_CSR_V2_AMAP, *PPCICFG_IP_CONTROL_STATUS_2_CSR_V2_AMAP;


typedef struct {
   BE_BIT LTSSM_state_from_L0[7];                 // DWORD 0
   BE_BIT cfg_pgsize[3];                          // DWORD 0
   BE_BIT disable_ecrc;                           // DWORD 0
   BE_BIT disable_cfg_retry;                      // DWORD 0
   BE_BIT cust_pf_ecrc_gen_en;                    // DWORD 0
   BE_BIT dma_tph_disable;                        // DWORD 0
   BE_BIT dma_steering_disable;                   // DWORD 0
   BE_BIT dpp_big_endian;                         // DWORD 0
   BE_BIT down_stream_write_count[8];             // DWORD 0
   BE_BIT down_stream_read_count[8];              // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_3_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_3_CSR_V2_AMAP, *PPCICFG_IP_CONTROL_STATUS_3_CSR_V2_AMAP;


typedef struct {
   BE_BIT pmcapid[8];                             // DWORD 0
   BE_BIT pmnextptr[8];                           // DWORD 0
   BE_BIT version[3];                             // DWORD 0
   BE_BIT pme_clk;                                // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT dsi;                                    // DWORD 0
   BE_BIT aux_current[3];                         // DWORD 0
   BE_BIT d1;                                     // DWORD 0
   BE_BIT d2;                                     // DWORD 0
   BE_BIT pme[5];                                 // DWORD 0
} SG_PACK BE_PCICFG_PMC_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PMC_CSR_V2_AMAP, *PPCICFG_PMC_CSR_V2_AMAP;


typedef struct {
   BE_BIT f0_pwr_state[2];                        // DWORD 0
   BE_BIT f0_pme_en;                              // DWORD 0
   BE_BIT f0_pme_status;                          // DWORD 0
   BE_BIT f1_pwr_state[2];                        // DWORD 0
   BE_BIT f1_pme_en;                              // DWORD 0
   BE_BIT f1_pme_status;                          // DWORD 0
   BE_BIT f2_pwr_state[2];                        // DWORD 0
   BE_BIT f2_pme_en;                              // DWORD 0
   BE_BIT f2_pme_status;                          // DWORD 0
   BE_BIT f3_pwr_state[2];                        // DWORD 0
   BE_BIT f3_pme_en;                              // DWORD 0
   BE_BIT f3_pme_status;                          // DWORD 0
   BE_BIT f4_pwr_state[2];                        // DWORD 0
   BE_BIT f4_pme_en;                              // DWORD 0
   BE_BIT f4_pme_status;                          // DWORD 0
   BE_BIT f5_pwr_state[2];                        // DWORD 0
   BE_BIT f5_pme_en;                              // DWORD 0
   BE_BIT f5_pme_status;                          // DWORD 0
   BE_BIT f6_pwr_state[2];                        // DWORD 0
   BE_BIT f6_pme_en;                              // DWORD 0
   BE_BIT f6_pme_status;                          // DWORD 0
   BE_BIT f7_pwr_state[2];                        // DWORD 0
   BE_BIT f7_pme_en;                              // DWORD 0
   BE_BIT f7_pme_status;                          // DWORD 0
} SG_PACK BE_PCICFG_D3_PM_CONTROL_MON_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_D3_PM_CONTROL_MON_V2_AMAP, *PPCICFG_D3_PM_CONTROL_MON_V2_AMAP;


typedef struct {
   BE_BIT pwr_state[2];                           // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT rsvd1[4];                               // DWORD 0
   BE_BIT pme_en;                                 // DWORD 0
   BE_BIT rsvd2[4];                               // DWORD 0
   BE_BIT rsvd3[2];                               // DWORD 0
   BE_BIT pme_status;                             // DWORD 0
   BE_BIT rsvd4[6];                               // DWORD 0
   BE_BIT rsvd5;                                  // DWORD 0
   BE_BIT rsvd6;                                  // DWORD 0
   BE_BIT rsvd7[8];                               // DWORD 0
} SG_PACK BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP, *PPCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP;


typedef struct {
   BE_BIT pwr_state[2];                           // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT device_specific;                        // DWORD 0
   BE_BIT rsvd1[4];                               // DWORD 0
   BE_BIT pme_en;                                 // DWORD 0
   BE_BIT data_select[4];                         // DWORD 0
   BE_BIT data_scale[2];                          // DWORD 0
   BE_BIT pme_status;                             // DWORD 0
   BE_BIT rsvd2[6];                               // DWORD 0
   BE_BIT b2_b3;                                  // DWORD 0
   BE_BIT bpcc_en;                                // DWORD 0
   BE_BIT pmdata[8];                              // DWORD 0
} SG_PACK BE_PCICFG_PM_CONTROL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PM_CONTROL_V2_AMAP, *PPCICFG_PM_CONTROL_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_ERR_ENHANCED_CAP_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_ERR_ENHANCED_CAP_V2_AMAP, *PPCIE_ERR_ENHANCED_CAP_V2_AMAP;


typedef struct {
   BE_BIT mfvc_fg_capability;                     // DWORD 0
   BE_BIT acs_fg_capability;                      // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT next_fun_num[8];                        // DWORD 0
   BE_BIT rsvd1[16];                              // DWORD 0
} SG_PACK BE_PCIE_ARI_CAPABILITY_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_ARI_CAPABILITY_V2_AMAP, *PPCIE_ARI_CAPABILITY_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_ARI_ENHANCED_CAP_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_ARI_ENHANCED_CAP_V2_AMAP, *PPCIE_ARI_ENHANCED_CAP_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_VSEC_CAP_HDR_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_VSEC_CAP_HDR_V2_AMAP, *PPCIE_VSEC_CAP_HDR_V2_AMAP;


typedef struct {
   BE_BIT vsec_id[16];                            // DWORD 0
   BE_BIT vsec_rev[4];                            // DWORD 0
   BE_BIT vsec_length[12];                        // DWORD 0
} SG_PACK BE_PCIE_VSEC_BAR_STRIDE_HDR_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_VSEC_BAR_STRIDE_HDR_V2_AMAP, *PPCIE_VSEC_BAR_STRIDE_HDR_V2_AMAP;


typedef struct {
   BE_BIT vsec_id[16];                            // DWORD 0
   BE_BIT vsec_rev[4];                            // DWORD 0
   BE_BIT vsec_length[12];                        // DWORD 0
} SG_PACK BE_PCIE_VSEC_HDR_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_VSEC_HDR_V2_AMAP, *PPCIE_VSEC_HDR_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP, *PPCIE_DEV_SERIAL_CAP_HDR_V2_AMAP;


typedef struct {
   BE_BIT slnum_low[32];                          // DWORD 0
} SG_PACK BE_PCIE_DEV_SERIAL_NUM_LOW_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_DEV_SERIAL_NUM_LOW_V2_AMAP, *PPCIE_DEV_SERIAL_NUM_LOW_V2_AMAP;


typedef struct {
   BE_BIT slnum_high[32];                         // DWORD 0
} SG_PACK BE_PCIE_DEV_SERIAL_NUM_HIGH_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_DEV_SERIAL_NUM_HIGH_V2_AMAP, *PPCIE_DEV_SERIAL_NUM_HIGH_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_ATS_ENHANCED_CAP_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_ATS_ENHANCED_CAP_V2_AMAP, *PPCIE_ATS_ENHANCED_CAP_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_TPH_REQ_CAP_HDR_F0_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_TPH_REQ_CAP_HDR_F0_V2_AMAP, *PPCIE_TPH_REQ_CAP_HDR_F0_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_TPH_REQ_CAP_HDR_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_TPH_REQ_CAP_HDR_V2_AMAP, *PPCIE_TPH_REQ_CAP_HDR_V2_AMAP;


typedef struct {
   BE_BIT no_st_mode;                             // DWORD 0
   BE_BIT intr_vec_mode;                          // DWORD 0
   BE_BIT dev_specific_mode;                      // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT st_tbl_loc[2];                          // DWORD 0
   BE_BIT rsvd1[5];                               // DWORD 0
   BE_BIT st_tbl_size[11];                        // DWORD 0
   BE_BIT rsvd2[5];                               // DWORD 0
} SG_PACK BE_PCIE_TPH_CAPABILITY_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_TPH_CAPABILITY_V2_AMAP, *PPCIE_TPH_CAPABILITY_V2_AMAP;


typedef struct {
   BE_BIT st_mode_sel[3];                         // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT tph_req_enable[2];                      // DWORD 0
   BE_BIT rsvd1[22];                              // DWORD 0
} SG_PACK BE_PCIE_TPH_CONTROL_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_TPH_CONTROL_V2_AMAP, *PPCIE_TPH_CONTROL_V2_AMAP;


typedef struct {
   BE_BIT inval_queue_depth[5];                   // DWORD 0
   BE_BIT page_align_request;                     // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
   BE_BIT stu[5];                                 // DWORD 0
   BE_BIT rsvd1[10];                              // DWORD 0
   BE_BIT ats_enable;                             // DWORD 0
} SG_PACK BE_PCIE_ATS_CAPABILITY_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_ATS_CAPABILITY_V2_AMAP, *PPCIE_ATS_CAPABILITY_V2_AMAP;


typedef struct {
   BE_BIT training_err;                           // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT data_link_prot_err;                     // DWORD 0
   BE_BIT rsvd1[7];                               // DWORD 0
   BE_BIT poison_tlp_err;                         // DWORD 0
   BE_BIT flow_ctl_prot_err;                      // DWORD 0
   BE_BIT cpl_timeout_err;                        // DWORD 0
   BE_BIT cmpltr_abort_err;                       // DWORD 0
   BE_BIT unexp_cpl_err;                          // DWORD 0
   BE_BIT rcvr_overflow_err;                      // DWORD 0
   BE_BIT malformed_tlp_err;                      // DWORD 0
   BE_BIT ecrc_err;                               // DWORD 0
   BE_BIT unsupp_req_err;                         // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT internal_ue_err;                        // DWORD 0
   BE_BIT rsvd3[9];                               // DWORD 0
} SG_PACK BE_PCIE_UNCORR_ERR_STATUS_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_UNCORR_ERR_STATUS_V2_AMAP, *PPCIE_UNCORR_ERR_STATUS_V2_AMAP;


typedef struct {
   BE_BIT training_err;                           // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT data_link_prot_err;                     // DWORD 0
   BE_BIT rsvd1[7];                               // DWORD 0
   BE_BIT poison_tlp_err;                         // DWORD 0
   BE_BIT flow_ctl_prot_err;                      // DWORD 0
   BE_BIT cpl_timeout_err;                        // DWORD 0
   BE_BIT cmpltr_abort_err;                       // DWORD 0
   BE_BIT unexp_cpl_err;                          // DWORD 0
   BE_BIT rcvr_overflow_err;                      // DWORD 0
   BE_BIT malformed_tlp_err;                      // DWORD 0
   BE_BIT ecrc_err;                               // DWORD 0
   BE_BIT unsupp_req_err;                         // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT internal_ue_err;                        // DWORD 0
   BE_BIT rsvd3[9];                               // DWORD 0
} SG_PACK BE_PCIE_UNCORR_ERR_MASK_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_UNCORR_ERR_MASK_V2_AMAP, *PPCIE_UNCORR_ERR_MASK_V2_AMAP;


typedef struct {
   BE_BIT training_err;                           // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT data_link_prot_err;                     // DWORD 0
   BE_BIT rsvd1[7];                               // DWORD 0
   BE_BIT poison_tlp_err;                         // DWORD 0
   BE_BIT flow_ctl_prot_err;                      // DWORD 0
   BE_BIT cpl_timeout_err;                        // DWORD 0
   BE_BIT cmpltr_abort_err;                       // DWORD 0
   BE_BIT unexp_cpl_err;                          // DWORD 0
   BE_BIT rcvr_overflow_err;                      // DWORD 0
   BE_BIT malformed_tlp_err;                      // DWORD 0
   BE_BIT ecrc_err;                               // DWORD 0
   BE_BIT unsupp_req_err;                         // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT internal_ue_err;                        // DWORD 0
   BE_BIT rsvd3[9];                               // DWORD 0
} SG_PACK BE_PCIE_UNCORR_ERR_SEVERITY_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_UNCORR_ERR_SEVERITY_V2_AMAP, *PPCIE_UNCORR_ERR_SEVERITY_V2_AMAP;


typedef struct {
   BE_BIT rcvr_err;                               // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT bad_tlp_err;                            // DWORD 0
   BE_BIT bad_dllp_err;                           // DWORD 0
   BE_BIT replay_num_rollover_err;                // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT replay_timer_timeout_err;               // DWORD 0
   BE_BIT advisory_no_fatal_error_status;         // DWORD 0
   BE_BIT rsvd2[18];                              // DWORD 0
} SG_PACK BE_PCIE_CORR_ERR_STATUS_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_CORR_ERR_STATUS_V2_AMAP, *PPCIE_CORR_ERR_STATUS_V2_AMAP;


typedef struct {
   BE_BIT rcvr_err;                               // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT bad_tlp_err;                            // DWORD 0
   BE_BIT bad_dllp_err;                           // DWORD 0
   BE_BIT replay_num_rollover_err;                // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT replay_timer_timeout_err;               // DWORD 0
   BE_BIT advisory_no_fatal_error_mask;           // DWORD 0
   BE_BIT rsvd2[18];                              // DWORD 0
} SG_PACK BE_PCIE_CORR_ERR_MASK_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_CORR_ERR_MASK_V2_AMAP, *PPCIE_CORR_ERR_MASK_V2_AMAP;


typedef struct {
   BE_BIT first_uncorr_err_ptr[5];                // DWORD 0
   BE_BIT ecrc_gen_cap;                           // DWORD 0
   BE_BIT ecrc_gen_en;                            // DWORD 0
   BE_BIT ecrc_chk_cap;                           // DWORD 0
   BE_BIT ecrc_chk_en;                            // DWORD 0
   BE_BIT rsvd0[23];                              // DWORD 0
} SG_PACK BE_PCIE_ERR_CAP_CONTROL_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_ERR_CAP_CONTROL_V2_AMAP, *PPCIE_ERR_CAP_CONTROL_V2_AMAP;


typedef struct {
   BE_BIT failheader[32];                         // DWORD 0
} SG_PACK BE_PCIE_HEADER_REGISTER_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_HEADER_REGISTER_V2_AMAP, *PPCIE_HEADER_REGISTER_V2_AMAP;


typedef struct {
   BE_BIT sr_iov_capid[16];                       // DWORD 0
   BE_BIT sr_iov_capver[4];                       // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_SR_IOV_ENHANCED_CAP_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SR_IOV_ENHANCED_CAP_V2_AMAP, *PPCIE_SR_IOV_ENHANCED_CAP_V2_AMAP;


typedef struct {
   BE_BIT vf_migration;                           // DWORD 0
   BE_BIT ARI_cap_hier;                           // DWORD 0
   BE_BIT rsvd0[19];                              // DWORD 0
   BE_BIT vf_migration_intr_msg_no[11];           // DWORD 0
} SG_PACK BE_PCIE_SR_IOV_CAPABILITIES_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SR_IOV_CAPABILITIES_V2_AMAP, *PPCIE_SR_IOV_CAPABILITIES_V2_AMAP;


typedef struct {
   BE_BIT VF_enable;                              // DWORD 0
   BE_BIT VF_migration_enable;                    // DWORD 0
   BE_BIT VF_migration_intr_enable;               // DWORD 0
   BE_BIT VF_memory_space_enable;                 // DWORD 0
   BE_BIT VF_ARI_enable;                          // DWORD 0
   BE_BIT rsvd0[11];                              // DWORD 0
   BE_BIT VF_migration_status;                    // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_PCIE_SR_IOV_STATUS_CONTROL_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SR_IOV_STATUS_CONTROL_V2_AMAP, *PPCIE_SR_IOV_STATUS_CONTROL_V2_AMAP;


typedef struct {
   BE_BIT initial_VFs[16];                        // DWORD 0
   BE_BIT total_VFs[16];                          // DWORD 0
} SG_PACK BE_PCIE_TOTAL_INITIAL_VFs_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_TOTAL_INITIAL_VFs_V2_AMAP, *PPCIE_TOTAL_INITIAL_VFs_V2_AMAP;


typedef struct {
   BE_BIT num_VFs[16];                            // DWORD 0
   BE_BIT function_dependency_link[8];            // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_PCIE_NUM_VFs_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_NUM_VFs_V2_AMAP, *PPCIE_NUM_VFs_V2_AMAP;


typedef struct {
   BE_BIT first_VF_offset[16];                    // DWORD 0
   BE_BIT VF_stride[16];                          // DWORD 0
} SG_PACK BE_PCIE_VF_STRIDE_OFFSET_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_VF_STRIDE_OFFSET_V2_AMAP, *PPCIE_VF_STRIDE_OFFSET_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT VF_device_id[16];                       // DWORD 0
} SG_PACK BE_PCIE_VF_DEVICE_ID_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_VF_DEVICE_ID_V2_AMAP, *PPCIE_VF_DEVICE_ID_V2_AMAP;


typedef struct {
   BE_BIT VF_system_page_size_supported[32];      // DWORD 0
} SG_PACK BE_PCIE_VF_SYSTEM_PAGE_SUPPORTED_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_VF_SYSTEM_PAGE_SUPPORTED_V2_AMAP, *PPCIE_VF_SYSTEM_PAGE_SUPPORTED_V2_AMAP;


typedef struct {
   BE_BIT VF_system_page_size[11];                // DWORD 0
   BE_BIT rsvd0[21];                              // DWORD 0
} SG_PACK BE_PCIE_VF_SYSTEM_PAGE_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_VF_SYSTEM_PAGE_V2_AMAP, *PPCIE_VF_SYSTEM_PAGE_V2_AMAP;


typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
   BE_BIT system_page_decode_0;                   // DWORD 0
   BE_BIT system_page_decode_1;                   // DWORD 0
   BE_BIT system_page_decode_2;                   // DWORD 0
   BE_BIT system_page_decode_3;                   // DWORD 0
   BE_BIT system_page_decode_4;                   // DWORD 0
   BE_BIT system_page_decode_5;                   // DWORD 0
   BE_BIT system_page_decode_6;                   // DWORD 0
   BE_BIT system_page_decode_7;                   // DWORD 0
   BE_BIT system_page_decode_8;                   // DWORD 0
   BE_BIT system_page_decode_9;                   // DWORD 0
   BE_BIT membar1lo[8];                           // DWORD 0
} SG_PACK BE_PCICFG_VF_MEMBAR0_LO_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VF_MEMBAR0_LO_V2_AMAP, *PPCICFG_VF_MEMBAR0_LO_V2_AMAP;


typedef struct {
   BE_BIT membar1hi[32];                          // DWORD 0
} SG_PACK BE_PCICFG_VF_MEMBAR0_HI_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VF_MEMBAR0_HI_V2_AMAP, *PPCICFG_VF_MEMBAR0_HI_V2_AMAP;


typedef struct {
   BE_BIT deviceid[16];                           // DWORD 0
   BE_BIT requesterid[16];                        // DWORD 0
} SG_PACK BE_PCIE_ATS_INVALID_REQUESTERID_DEVID_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_ATS_INVALID_REQUESTERID_DEVID_V2_AMAP, *PPCIE_ATS_INVALID_REQUESTERID_DEVID_V2_AMAP;


typedef struct {
   BE_BIT ITAG[8];                                // DWORD 0
   BE_BIT addr[24];                               // DWORD 0
} SG_PACK BE_PCIE_ATS_INVALID_ADDR_LOW_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_ATS_INVALID_ADDR_LOW_V2_AMAP, *PPCIE_ATS_INVALID_ADDR_LOW_V2_AMAP;


typedef struct {
   BE_BIT addr[32];                               // DWORD 0
} SG_PACK BE_PCIE_ATS_INVALID_ADDR_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_ATS_INVALID_ADDR_V2_AMAP, *PPCIE_ATS_INVALID_ADDR_V2_AMAP;


typedef struct {
   BE_BIT length[13];                             // DWORD 0
   BE_BIT AT[2];                                  // DWORD 0
   BE_BIT type[4];                                // DWORD 0
   BE_BIT tag[5];                                 // DWORD 0
   BE_BIT msgroute[3];                            // DWORD 0
   BE_BIT wr;                                     // DWORD 0
   BE_BIT th;                                     // DWORD 0
   BE_BIT msix;                                   // DWORD 0
   BE_BIT ats2bme_empty;                          // DWORD 0
   BE_BIT req;                                    // DWORD 0
} SG_PACK BE_PCIE_BME_TLP_COMMON_HDR0_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_BME_TLP_COMMON_HDR0_V2_AMAP, *PPCIE_BME_TLP_COMMON_HDR0_V2_AMAP;


typedef struct {
   BE_BIT msgcode[8];                             // DWORD 0
   BE_BIT tph_hint[2];                            // DWORD 0
   BE_BIT tph_st[5];                              // DWORD 0
   BE_BIT immdata_upper_valid;                    // DWORD 0
   BE_BIT funcnum[8];                             // DWORD 0
   BE_BIT busnum[8];                              // DWORD 0
} SG_PACK BE_PCIE_BME_TLP_COMMON_HDR1_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_BME_TLP_COMMON_HDR1_V2_AMAP, *PPCIE_BME_TLP_COMMON_HDR1_V2_AMAP;


typedef struct {
   BE_BIT addr[32];                               // DWORD 0
} SG_PACK BE_PCIE_BME_ATS_REQ_TLP_ADDR_HIGH_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_BME_ATS_REQ_TLP_ADDR_HIGH_V2_AMAP, *PPCIE_BME_ATS_REQ_TLP_ADDR_HIGH_V2_AMAP;


typedef struct {
   BE_BIT W_R_NW[2];                              // DWORD 0
   BE_BIT U;                                      // DWORD 0
   BE_BIT ats_cmpl_err;                           // DWORD 0
   BE_BIT ats_cmpl_err_status[3];                 // DWORD 0
   BE_BIT ats2bme_reqerr;                         // DWORD 0
   BE_BIT dvsr_future[2];                         // DWORD 0
   BE_BIT N;                                      // DWORD 0
   BE_BIT S;                                      // DWORD 0
   BE_BIT addr[20];                               // DWORD 0
} SG_PACK BE_PCIE_BME_ATS_REQ_TLP_ADDR_LOW_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_BME_ATS_REQ_TLP_ADDR_LOW_V2_AMAP, *PPCIE_BME_ATS_REQ_TLP_ADDR_LOW_V2_AMAP;


typedef struct {
   BE_BIT pclk[8];                                // DWORD 0
   BE_BIT core_d3[8];                             // DWORD 0
   BE_BIT core[8];                                // DWORD 0
   BE_BIT future_scratchpad[3];                   // DWORD 0
   BE_BIT cfg_attr_en;                            // DWORD 0
   BE_BIT cfg_msi_support;                        // DWORD 0
   BE_BIT msix_regen_dis;                         // DWORD 0
   BE_BIT future_scratchpad0;                     // DWORD 0
   BE_BIT sriov_pf_to_vf_bits;                    // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_SHIFT_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_SHIFT_V2_AMAP, *PPCICFG_HWDBG_SHIFT_V2_AMAP;


typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_0_PCLK_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_0_PCLK_V2_AMAP, *PPCICFG_HWDBG_MASK_0_PCLK_V2_AMAP;


typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_1_PCLK_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_1_PCLK_V2_AMAP, *PPCICFG_HWDBG_MASK_1_PCLK_V2_AMAP;


typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_0_CORE_D3_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_0_CORE_D3_V2_AMAP, *PPCICFG_HWDBG_MASK_0_CORE_D3_V2_AMAP;


typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_1_CORE_D3_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_1_CORE_D3_V2_AMAP, *PPCICFG_HWDBG_MASK_1_CORE_D3_V2_AMAP;


typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_0_CORE_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_0_CORE_V2_AMAP, *PPCICFG_HWDBG_MASK_0_CORE_V2_AMAP;


typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_1_CORE_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_1_CORE_V2_AMAP, *PPCICFG_HWDBG_MASK_1_CORE_V2_AMAP;


typedef struct {
   BE_BIT pclk[8];                                // DWORD 0
   BE_BIT core_d3[8];                             // DWORD 0
   BE_BIT core[8];                                // DWORD 0
   BE_BIT up_stream_write_count[8];               // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_REGSEL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_REGSEL_V2_AMAP, *PPCICFG_HWDBG_REGSEL_V2_AMAP;


typedef struct {
   BE_BIT ats_tag_num[8];                         // DWORD 0
   BE_BIT ats_tag_bit_5_6[2];                     // DWORD 0
   BE_BIT ats_relaxorder;                         // DWORD 0
   BE_BIT ats_nosnoop;                            // DWORD 0
   BE_BIT ats_idorder_dis;                        // DWORD 0
   BE_BIT rsvd0[19];                              // DWORD 0
} SG_PACK BE_PCICFG_F1_HOST_DEBUG1_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_F1_HOST_DEBUG1_V2_AMAP, *PPCICFG_F1_HOST_DEBUG1_V2_AMAP;


typedef struct {
   BE_BIT cfg_extend_tag_en;                      // DWORD 0
   BE_BIT ldma_hostoqdepth[4];                    // DWORD 0
   BE_BIT pad_ismoff_i;                           // DWORD 0
   BE_BIT pad_core_ismoff_i;                      // DWORD 0
   BE_BIT pad_crchashchkoff_i;                    // DWORD 0
   BE_BIT pads_debugout_i;                        // DWORD 0
   BE_BIT pad_flashboot;                          // DWORD 0
   BE_BIT pads_host_fgen1_i;                      // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT mpu_host_server_int;                    // DWORD 0
   BE_BIT dbg_ats2bme;                            // DWORD 0
   BE_BIT dma_tag_limit[8];                       // DWORD 0
   BE_BIT ndma_hostoqdepth[4];                    // DWORD 0
   BE_BIT rdma_hostoqdepth[4];                    // DWORD 0
   BE_BIT wdma_hostoqdepth_bit3;                  // DWORD 0
   BE_BIT pads_host_fgen2_i;                      // DWORD 0
} SG_PACK BE_PCICFG_F1_HOST_DEBUG_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_F1_HOST_DEBUG_V2_AMAP, *PPCICFG_F1_HOST_DEBUG_V2_AMAP;


typedef struct {
   BE_BIT pad_straps[32];                         // DWORD 0
} SG_PACK BE_PCICFG_STRAP_PINS_REG_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_STRAP_PINS_REG_V2_AMAP, *PPCICFG_STRAP_PINS_REG_V2_AMAP;


typedef struct {
   BE_BIT pad_ismoff;                             // DWORD 0
   BE_BIT pad_core_ismoff;                        // DWORD 0
   BE_BIT pad_crchashchkoff;                      // DWORD 0
   BE_BIT pads_debugout;                          // DWORD 0
   BE_BIT pad_flashboot;                          // DWORD 0
   BE_BIT pads_host_fgen1;                        // DWORD 0
   BE_BIT STRAP_PCIE_IOGB40G_RST_CTRL;            // DWORD 0
   BE_BIT STRAP_PCIE_LINK_FUND_RST_CTRL;          // DWORD 0
   BE_BIT STRAP_PCIE_SER_FUND_RST_CTRL;           // DWORD 0
   BE_BIT STRAP_PCIE_MODE_SLOT_CLOCK_CONFIG;      // DWORD 0
   BE_BIT STRAP_PCIE_MODE_WIDTH[2];               // DWORD 0
   BE_BIT pads_host_fgen2;                        // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT pads_host_wake_in_n;                    // DWORD 0
   BE_BIT rsvd1[17];                              // DWORD 0
} SG_PACK BE_PCICFG_STRAPS_REG_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_STRAPS_REG_V2_AMAP, *PPCICFG_STRAPS_REG_V2_AMAP;


typedef struct {
   BE_BIT pclk;                                   // DWORD 0
   BE_BIT mor_tag[5];                             // DWORD 0
   BE_BIT mor_ep_out;                             // DWORD 0
   BE_BIT mor_status_latch;                       // DWORD 0
   BE_BIT core_d3;                                // DWORD 0
   BE_BIT mor_err_status[3];                      // DWORD 0
   BE_BIT mor_tag_bits7_5[3];                     // DWORD 0
   BE_BIT rdma_err;                               // DWORD 0
   BE_BIT core;                                   // DWORD 0
   BE_BIT rdma_tag[5];                            // DWORD 0
   BE_BIT rdma_prty[2];                           // DWORD 0
   BE_BIT up_stream_read_count[8];                // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_ENABLE_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_ENABLE_V2_AMAP, *PPCICFG_HWDBG_ENABLE_V2_AMAP;


typedef struct {
   BE_BIT host_dbg_mux_data_core_o_31_0[32];      // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_0_V2_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_0_V2_AMAP, *Phwdbg_cfgreg_i_0_V2_AMAP;


typedef struct {
   BE_BIT host_dbg_mux_data_core_o_63_32[32];     // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_1_V2_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_1_V2_AMAP, *Phwdbg_cfgreg_i_1_V2_AMAP;


typedef struct {
   BE_BIT host_dbg_mux_data_core_d3_o_31_0[32];   // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_2_V2_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_2_V2_AMAP, *Phwdbg_cfgreg_i_2_V2_AMAP;


typedef struct {
   BE_BIT hw_ats_inv_en;                          // DWORD 0
   BE_BIT plbsel;                                 // DWORD 0
   BE_BIT lane_rev;                               // DWORD 0
   BE_BIT beacon_en;                              // DWORD 0
   BE_BIT pcicfg_override;                        // DWORD 0
   BE_BIT fcp_timer[13];                          // DWORD 0
   BE_BIT fcp_timer_force;                        // DWORD 0
   BE_BIT mode_link_upcfg_cap_dis_force;          // DWORD 0
   BE_BIT mode_link_upcfg_cap_dis;                // DWORD 0
   BE_BIT future_scratpad0[3];                    // DWORD 0
   BE_BIT nec_ll_ui_enter_txl0s;                  // DWORD 0
   BE_BIT future_scratpad1[2];                    // DWORD 0
   BE_BIT nec_ll_f0_mode_selectable_deemphasis;   // DWORD 0
   BE_BIT enable_secondary_exception;             // DWORD 0
   BE_BIT secondary_exception;                    // DWORD 0
   BE_BIT disable_auto_load_vf_funnum_offset;     // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
} SG_PACK BE_PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_V2_AMAP, *PPCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_V2_AMAP;


typedef struct {
   BE_BIT vpd_translation_addr[13];               // DWORD 0
   BE_BIT vpd_ddr_mode;                           // DWORD 0
   BE_BIT exprom_size[2];                         // DWORD 0
   BE_BIT exprom_translation_addr[16];            // DWORD 0
} SG_PACK BE_PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_V2_AMAP, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F0_V2_AMAP;


typedef struct {
   BE_BIT func_en[16];                            // DWORD 0
   BE_BIT vpd_translation_addr[16];               // DWORD 0
} SG_PACK BE_PCICFG_CUST_PF_CONTROL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CUST_PF_CONTROL_CSR_V2_AMAP, *PPCICFG_CUST_PF_CONTROL_CSR_V2_AMAP;


typedef struct {
   BE_BIT protocol[32];                           // DWORD 0
} SG_PACK BE_PCICFG_VPD_PROTOCOL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VPD_PROTOCOL_CSR_V2_AMAP, *PPCICFG_VPD_PROTOCOL_CSR_V2_AMAP;


typedef struct {
   BE_BIT cust_pf_24eq_to_pf_intrenable[16];      // DWORD 0
   BE_BIT cust_pf_16eq_to_pf_intrenable[16];      // DWORD 0
} SG_PACK BE_PCICFG_PF_24EQ_16EQ_CTRL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PF_24EQ_16EQ_CTRL_V2_AMAP, *PPCICFG_PF_24EQ_16EQ_CTRL_V2_AMAP;


typedef struct {
   BE_BIT shared_reg_access_func_limit[8];        // DWORD 0
   BE_BIT cfg_membar_access_func_limit[8];        // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_PCICFG_SHARED_REG_FUNC_LIMIT_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SHARED_REG_FUNC_LIMIT_V2_AMAP, *PPCICFG_SHARED_REG_FUNC_LIMIT_V2_AMAP;


typedef struct {
   BE_BIT mpu_assert_bme_vfgroup_no[5];           // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT mpu_assert_bme_pf_flr_to_vf;            // DWORD 0
   BE_BIT rsvd1[24];                              // DWORD 0
} SG_PACK BE_PCICFG_PF_8VF_BME_FLR_CONTROL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PF_8VF_BME_FLR_CONTROL_V2_AMAP, *PPCICFG_PF_8VF_BME_FLR_CONTROL_V2_AMAP;


typedef struct {
   BE_BIT pf_flr_to_8vfs_control[28];             // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
} SG_PACK BE_PCICFG_PF_8VF_FLR_CONTROL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PF_8VF_FLR_CONTROL_V2_AMAP, *PPCICFG_PF_8VF_FLR_CONTROL_V2_AMAP;


typedef struct {
   BE_BIT vf_roce_bar_control[16];                // DWORD 0
   BE_BIT vf_roce_pdid_control[16];               // DWORD 0
} SG_PACK BE_PCICFG_VF_ROCE_BAR_CTRL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VF_ROCE_BAR_CTRL_V2_AMAP, *PPCICFG_VF_ROCE_BAR_CTRL_V2_AMAP;


typedef struct {
   BE_BIT pf8to15_32eq_to_pf_intrenable[8];       // DWORD 0
   BE_BIT vf160to255_4eq_to_vf_intrenable;        // DWORD 0
   BE_BIT rsvd0[23];                              // DWORD 0
} SG_PACK BE_PCICFG_PF_32EQ_CTRL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PF_32EQ_CTRL_V2_AMAP, *PPCICFG_PF_32EQ_CTRL_V2_AMAP;


typedef struct {
   BE_BIT ats_invalid_cmpl_rd_error;              // DWORD 0
   BE_BIT ats_invalid_cmpl_wr_error;              // DWORD 0
   BE_BIT ats_invalid_cmpl_parity_error;          // DWORD 0
   BE_BIT dmtf_downstream_parity_error;           // DWORD 0
   BE_BIT dmtf_downstream_rd_error;               // DWORD 0
   BE_BIT dmtf_downstream_wr_error;               // DWORD 0
   BE_BIT dmtf_upstream_cmd_rd_error;             // DWORD 0
   BE_BIT dmtf_upstream_cmd_wr_error;             // DWORD 0
   BE_BIT dmtf_upstream_parity_error;             // DWORD 0
   BE_BIT dmtf_upstream_rd_error;                 // DWORD 0
   BE_BIT dmtf_upstream_wr_error;                 // DWORD 0
   BE_BIT rsvd0[21];                              // DWORD 0
} SG_PACK BE_PCICFG_DMTF_ATS_ERRORS_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_DMTF_ATS_ERRORS_V2_AMAP, *PPCICFG_DMTF_ATS_ERRORS_V2_AMAP;


typedef struct {
   BE_BIT vpd_vf_group0_translation_addr[16];     // DWORD 0
   BE_BIT vpd_vf_group1_translation_addr[16];     // DWORD 0
} SG_PACK BE_PCICFG_VF_VPD_LOC_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VF_VPD_LOC_CSR_V2_AMAP, *PPCICFG_VF_VPD_LOC_CSR_V2_AMAP;


typedef struct {
   BE_BIT ltssm_stage4[7];                        // DWORD 0
   BE_BIT ltssm_stage5[7];                        // DWORD 0
   BE_BIT ltssm_stage6[7];                        // DWORD 0
   BE_BIT ltssm_stage7[7];                        // DWORD 0
   BE_BIT periph_host_d3ism_done;                 // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT ltssm_detect_latch;                     // DWORD 0
} SG_PACK BE_PCIE_LTSSM_STAGES7_4_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_LTSSM_STAGES7_4_V2_AMAP, *PPCIE_LTSSM_STAGES7_4_V2_AMAP;


typedef struct {
   BE_BIT ltssm_stage0[7];                        // DWORD 0
   BE_BIT ltssm_stage1[7];                        // DWORD 0
   BE_BIT ltssm_stage2[7];                        // DWORD 0
   BE_BIT ltssm_stage3[7];                        // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT ltssm_recovery_latch;                   // DWORD 0
} SG_PACK BE_PCIE_LTSSM_STAGES3_0_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_LTSSM_STAGES3_0_V2_AMAP, *PPCIE_LTSSM_STAGES3_0_V2_AMAP;


typedef struct {
   BE_BIT disable_ecrc;                           // DWORD 0
   BE_BIT rsvd0[13];                              // DWORD 0
   BE_BIT exprom_size[2];                         // DWORD 0
   BE_BIT exprom_translation_addr[16];            // DWORD 0
} SG_PACK BE_PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_V2_AMAP, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F1_V2_AMAP;


typedef struct {
   BE_BIT ari_next_cap_offset[12];                // DWORD 0
   BE_BIT rsvd0[20];                              // DWORD 0
} SG_PACK BE_PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_V2_AMAP, *PPCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_V2_AMAP;


typedef struct {
   BE_BIT req;                                    // DWORD 0
   BE_BIT wr;                                     // DWORD 0
   BE_BIT ahb_phy;                                // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT ahb_done;                               // DWORD 0
   BE_BIT rsvd1[8];                               // DWORD 0
   BE_BIT address[16];                            // DWORD 0
} SG_PACK BE_PCIE_SERDES_MDIO_COMMAND_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_MDIO_COMMAND_V2_AMAP, *PPCIE_SERDES_MDIO_COMMAND_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_PCIE_SERDES_MDIO_DATA_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_MDIO_DATA_V2_AMAP, *PPCIE_SERDES_MDIO_DATA_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_PCICFG_SLI_IF_TYPE_PROG_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SLI_IF_TYPE_PROG_CSR_V2_AMAP, *PPCICFG_SLI_IF_TYPE_PROG_CSR_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_PCICFG_SLI_IF_TYPE_VAL1_PROG_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SLI_IF_TYPE_VAL1_PROG_CSR_V2_AMAP, *PPCICFG_SLI_IF_TYPE_VAL1_PROG_CSR_V2_AMAP;


typedef struct {
   BE_BIT pf_msix_pba_39_8[16];                   // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_PCIE_PF_MSIX_PBA_39_8_ZEROS_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_PF_MSIX_PBA_39_8_ZEROS_V2_AMAP, *PPCIE_PF_MSIX_PBA_39_8_ZEROS_V2_AMAP;


typedef struct {
   BE_BIT pf0_vf_msix_tablesize_share[2];         // DWORD 0
   BE_BIT pf1_vf_msix_tablesize_share[2];         // DWORD 0
   BE_BIT pf2_vf_msix_tablesize_share[2];         // DWORD 0
   BE_BIT pf3_vf_msix_tablesize_share[2];         // DWORD 0
   BE_BIT pf4_vf_msix_tablesize_share[2];         // DWORD 0
   BE_BIT pf5_vf_msix_tablesize_share[2];         // DWORD 0
   BE_BIT pf6_vf_msix_tablesize_share[2];         // DWORD 0
   BE_BIT pf7_vf_msix_tablesize_share[2];         // DWORD 0
   BE_BIT pf8_vf_msix_tablesize_share[2];         // DWORD 0
   BE_BIT pf9_vf_msix_tablesize_share[2];         // DWORD 0
   BE_BIT pf10_vf_msix_tablesize_share[2];        // DWORD 0
   BE_BIT pf11_vf_msix_tablesize_share[2];        // DWORD 0
   BE_BIT pf12_vf_msix_tablesize_share[2];        // DWORD 0
   BE_BIT pf13_vf_msix_tablesize_share[2];        // DWORD 0
   BE_BIT pf14_vf_msix_tablesize_share[2];        // DWORD 0
   BE_BIT pf15_vf_msix_tablesize_share[2];        // DWORD 0
} SG_PACK BE_PCIE_PF_MSIX_TABLE_SIZE_SHARE_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_PF_MSIX_TABLE_SIZE_SHARE_V2_AMAP, *PPCIE_PF_MSIX_TABLE_SIZE_SHARE_V2_AMAP;


typedef struct {
   BE_BIT vf_msix_tbl_size[8];                    // DWORD 0
   BE_BIT pf_msix_tablesize_share_vf_cev[8];      // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT rsvd1[6];                               // DWORD 0
   BE_BIT vf_msix_tbl_to_ctx;                     // DWORD 0
   BE_BIT pf_msix_tbl_to_ctx;                     // DWORD 0
} SG_PACK BE_PCIE_MSIX_TBL_TO_CTX_CTRL_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_MSIX_TBL_TO_CTX_CTRL_V2_AMAP, *PPCIE_MSIX_TBL_TO_CTX_CTRL_V2_AMAP;


typedef struct {
   BE_BIT pf_range_low[8];                        // DWORD 0
   BE_BIT pf_range_high[8];                       // DWORD 0
   BE_BIT vf_range_low[8];                        // DWORD 0
   BE_BIT vf_range_high[8];                       // DWORD 0
} SG_PACK BE_PCIE_MSIX_TBL_TO_CTX_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_MSIX_TBL_TO_CTX_V2_AMAP, *PPCIE_MSIX_TBL_TO_CTX_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_SEC_PCIE_EXT_CAP_HDR_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SEC_PCIE_EXT_CAP_HDR_V2_AMAP, *PPCIE_SEC_PCIE_EXT_CAP_HDR_V2_AMAP;


typedef struct {
   BE_BIT perform_equalization;                   // DWORD 0
   BE_BIT link_eq_int_enable;                     // DWORD 0
   BE_BIT rsvd0[30];                              // DWORD 0
} SG_PACK BE_PCIE_LINK_CTRL_3_REG_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_LINK_CTRL_3_REG_V2_AMAP, *PPCIE_LINK_CTRL_3_REG_V2_AMAP;


typedef struct {
   BE_BIT lane0_error_status;                     // DWORD 0
   BE_BIT lane1_error_status;                     // DWORD 0
   BE_BIT lane2_error_status;                     // DWORD 0
   BE_BIT lane3_error_status;                     // DWORD 0
   BE_BIT lane4_error_status;                     // DWORD 0
   BE_BIT lane5_error_status;                     // DWORD 0
   BE_BIT lane6_error_status;                     // DWORD 0
   BE_BIT lane7_error_status;                     // DWORD 0
   BE_BIT lane0_RX_ESERRTRGR;                     // DWORD 0
   BE_BIT lane1_RX_ESERRTRGR;                     // DWORD 0
   BE_BIT lane2_RX_ESERRTRGR;                     // DWORD 0
   BE_BIT lane3_RX_ESERRTRGR;                     // DWORD 0
   BE_BIT lane4_RX_ESERRTRGR;                     // DWORD 0
   BE_BIT lane5_RX_ESERRTRGR;                     // DWORD 0
   BE_BIT lane6_RX_ESERRTRGR;                     // DWORD 0
   BE_BIT lane7_RX_ESERRTRGR;                     // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_PCIE_LANE_ERROR_STATUS_REG_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_LANE_ERROR_STATUS_REG_V2_AMAP, *PPCIE_LANE_ERROR_STATUS_REG_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT upstream_tx_preset_lane_n[4];           // DWORD 0
   BE_BIT upstream_rx_preset_hint_lane_n[3];      // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT rsvd2[8];                               // DWORD 0
   BE_BIT upstream_tx_preset_lane_nplus1[4];      // DWORD 0
   BE_BIT upstream_rx_preset_hint_lane_nplus1[3]; // DWORD 0
   BE_BIT rsvd3;                                  // DWORD 0
} SG_PACK BE_PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2_AMAP, *PPCIE_LANE_1_0_EQUALIZATION_CONTROL_V2_AMAP;


typedef struct {
   BE_BIT t2l_coeff_mf0_prec[3];                  // DWORD 0
   BE_BIT t2l_coeff_mf1_prec[3];                  // DWORD 0
   BE_BIT t2l_coeff_mf0_postc[3];                 // DWORD 0
   BE_BIT t2l_coeff_mf1_postc[3];                 // DWORD 0
   BE_BIT t2l_coeff_mf_method;                    // DWORD 0
   BE_BIT t2l_eval_ph_fail_ena;                   // DWORD 0
   BE_BIT t2l_eval_dither_count[3];               // DWORD 0
   BE_BIT t2l_eval_window_size[5];                // DWORD 0
   BE_BIT t2l_prec_update_count[4];               // DWORD 0
   BE_BIT t2l_postc_update_count[4];              // DWORD 0
   BE_BIT t2p_coeff_pingpong_disable;             // DWORD 0
   BE_BIT l2t_eval_phase_not_optimal;             // DWORD 0
} SG_PACK BE_PCICFG_BCA_CTRL0_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_BCA_CTRL0_V2_AMAP, *PPCICFG_BCA_CTRL0_V2_AMAP;


typedef struct {
   BE_BIT pcie_t2l_debug_sel[16];                 // DWORD 0
   BE_BIT sys_lresetn;                            // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
} SG_PACK BE_PCICFG_SERDES_DBG_CTRL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SERDES_DBG_CTRL_V2_AMAP, *PPCICFG_SERDES_DBG_CTRL_V2_AMAP;


typedef struct {
   BE_BIT SER_LPBK_ENA[8];                        // DWORD 0
   BE_BIT TX_INV[8];                              // DWORD 0
   BE_BIT MODE_RXPOL_INV_EN;                      // DWORD 0
   BE_BIT MODE_SCRAMBLE_GEN12_DISABLE;            // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
} SG_PACK BE_PCICFG_SERDES_LANE_CTRL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SERDES_LANE_CTRL_V2_AMAP, *PPCICFG_SERDES_LANE_CTRL_V2_AMAP;


typedef struct {
   BE_BIT t2l_eq_fs[6];                           // DWORD 0
   BE_BIT t2l_eq_maxpre[6];                       // DWORD 0
   BE_BIT t2l_eq_lf[6];                           // DWORD 0
   BE_BIT t2l_g3_spare_in_default_preset[4];      // DWORD 0
   BE_BIT force_t2l_req_preset_vld[8];            // DWORD 0
   BE_BIT force_t2s_coeff_enbl;                   // DWORD 0
   BE_BIT t2l_g3_spare_in_bca_disable;            // DWORD 0
} SG_PACK BE_PCICFG_EQUALIZATION_CTRL0_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_EQUALIZATION_CTRL0_V2_AMAP, *PPCICFG_EQUALIZATION_CTRL0_V2_AMAP;


typedef struct {
   BE_BIT force_lane0_t2l_req_preset[4];          // DWORD 0
   BE_BIT force_lane1_t2l_req_preset[4];          // DWORD 0
   BE_BIT force_lane2_t2l_req_preset[4];          // DWORD 0
   BE_BIT force_lane3_t2l_req_preset[4];          // DWORD 0
   BE_BIT force_lane4_t2l_req_preset[4];          // DWORD 0
   BE_BIT force_lane5_t2l_req_preset[4];          // DWORD 0
   BE_BIT force_lane6_t2l_req_preset[4];          // DWORD 0
   BE_BIT force_lane7_t2l_req_preset[4];          // DWORD 0
} SG_PACK BE_PCICFG_REQ_PRESET_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_REQ_PRESET_V2_AMAP, *PPCICFG_REQ_PRESET_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT force_t2sMaincCoeff[6];                 // DWORD 0
   BE_BIT force_t2sPrecCoeff[6];                  // DWORD 0
   BE_BIT force_t2sPostcCoeff[6];                 // DWORD 0
   BE_BIT rsvd1[10];                              // DWORD 0
} SG_PACK BE_PCICFG_REQ_COEFF_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_REQ_COEFF_V2_AMAP, *PPCICFG_REQ_COEFF_V2_AMAP;


typedef struct {
   BE_BIT PCIE_IOGB40G_CNTPUP[10];                // DWORD 0
   BE_BIT PCIE_IOGB40G_CNTSET[3];                 // DWORD 0
   BE_BIT PCIE_IOGB40G_PDDIS;                     // DWORD 0
   BE_BIT PCIE_IOGB40G_TESTMODE;                  // DWORD 0
   BE_BIT PCIE_IOGB40G_RTRIMFRC[4];               // DWORD 0
   BE_BIT PCIE_IOGB40G_RTRIM[4];                  // DWORD 0
   BE_BIT PCIE_IOGB40G_TRIMDONE;                  // DWORD 0
   BE_BIT PCIE_IOGB40G_RNGERR;                    // DWORD 0
   BE_BIT PCIE_IOGB40G_SW_CTRL_RST_N;             // DWORD 0
   BE_BIT PCIE_LINK_SW_CTRL_FUND_RST_N;           // DWORD 0
   BE_BIT PCIE_SER_SW_CTRL_FUND_RST_N;            // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
} SG_PACK BE_PCICFG_SERDES_IOGB_CTRL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SERDES_IOGB_CTRL_V2_AMAP, *PPCICFG_SERDES_IOGB_CTRL_V2_AMAP;


typedef struct {
   BE_BIT bme_ndma_purge_disable;                 // DWORD 0
   BE_BIT bme_ndma_purge_reqerr_disable;          // DWORD 0
   BE_BIT bme_rdma_purge_disable;                 // DWORD 0
   BE_BIT bme_rdma_purge_reqerr_disable;          // DWORD 0
   BE_BIT bme_ldma_purge_disable;                 // DWORD 0
   BE_BIT bme_ldma_purge_reqerr_disable;          // DWORD 0
   BE_BIT en_softrst_cleanup;                     // DWORD 0
   BE_BIT propagate_pf_flr_to_vf;                 // DWORD 0
   BE_BIT bme_wdma_purge_loading_disable;         // DWORD 0
   BE_BIT bme_ndma_purge_loading_disable;         // DWORD 0
   BE_BIT bme_rdma_purge_loading_disable;         // DWORD 0
   BE_BIT bme_ldma_purge_loading_disable;         // DWORD 0
   BE_BIT relaxorder_disable;                     // DWORD 0
   BE_BIT ro_tx_disable;                          // DWORD 0
   BE_BIT cfg_dma2bme_wropti_disable;             // DWORD 0
   BE_BIT wdma_len_err;                           // DWORD 0
   BE_BIT wdma_PURGE_err;                         // DWORD 0
   BE_BIT rdma_wrb_factor[2];                     // DWORD 0
   BE_BIT nec_blb0_digest;                        // DWORD 0
   BE_BIT nec_PM_PME_en_D0;                       // DWORD 0
   BE_BIT nec_PM_PME_en_D3;                       // DWORD 0
   BE_BIT cfg_bmearb_reqmsk_disable;              // DWORD 0
   BE_BIT PM_ARI_spec_en;                         // DWORD 0
   BE_BIT rxf_wake_l1_l2_trans;                   // DWORD 0
   BE_BIT self_clr_lpcsoftrst;                    // DWORD 0
   BE_BIT BLB_intf_pre_cycle;                     // DWORD 0
   BE_BIT bme_wdma_purge_disable;                 // DWORD 0
   BE_BIT bme_wdma_purge_reqerr_disable;          // DWORD 0
   BE_BIT pme_trunoffack_enable;                  // DWORD 0
   BE_BIT ldma_wrb_factor[2];                     // DWORD 0
} SG_PACK BE_PCIE_PM_PME_SERDES_PLL_DMA_WRB_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_PM_PME_SERDES_PLL_DMA_WRB_V2_AMAP, *PPCIE_PM_PME_SERDES_PLL_DMA_WRB_V2_AMAP;


typedef struct {
   BE_BIT host_dbg_mux_data_core_d3_o_63_32[32];  // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_3_V2_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_3_V2_AMAP, *Phwdbg_cfgreg_i_3_V2_AMAP;


typedef struct {
   BE_BIT host_dbg_mux_data_pclk_o_31_0[32];      // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_4_V2_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_4_V2_AMAP, *Phwdbg_cfgreg_i_4_V2_AMAP;


typedef struct {
   BE_BIT dma_reqerr_status[4];                   // DWORD 0
   BE_BIT ndma_PURGE_err;                         // DWORD 0
   BE_BIT rdma_PURGE_err;                         // DWORD 0
   BE_BIT ldma_PURGE_err;                         // DWORD 0
   BE_BIT MOR_MALFORMED_SET;                      // DWORD 0
   BE_BIT host_dbg_mux_data_pclk_d3_o_63_40[24];  // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_5_V2_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_5_V2_AMAP, *Phwdbg_cfgreg_i_5_V2_AMAP;


typedef struct {
   BE_BIT dbg_all_reqs_31_0[32];                  // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_7_V2_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_7_V2_AMAP, *Phwdbg_cfgreg_i_7_V2_AMAP;


typedef struct {
   BE_BIT cust_pfs_vpd_intr_func_id_i[7];         // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT cust_pfs_pci_cap_ptr[8];                // DWORD 0
   BE_BIT first_ue_src_id[6];                     // DWORD 0
   BE_BIT first_ue_src_id_vld;                    // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT cust_pf_vpd_ddr_mode;                   // DWORD 0
   BE_BIT vf_group0_vpd_ddr_mode;                 // DWORD 0
   BE_BIT vf_group1_vpd_ddr_mode;                 // DWORD 0
   BE_BIT rsvd2[5];                               // DWORD 0
} SG_PACK BE_PCIE_cust_pfs_intr_info_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_cust_pfs_intr_info_V2_AMAP, *PPCIE_cust_pfs_intr_info_V2_AMAP;


typedef struct {
   BE_BIT teslave_state[4];                       // DWORD 0
   BE_BIT vfs_vpd_intr1_func_id_i[7];             // DWORD 0
   BE_BIT te_host_tlb_last_i;                     // DWORD 0
   BE_BIT vfs_pci_cap_ptr[8];                     // DWORD 0
   BE_BIT host_rrm_req_o;                         // DWORD 0
   BE_BIT host_rrm_type__o[2];                    // DWORD 0
   BE_BIT pfs_intx_msg_order;                     // DWORD 0
   BE_BIT vfs_intx_msg_order;                     // DWORD 0
   BE_BIT vfs_vpd_intr0_func_id_i[7];             // DWORD 0
} SG_PACK BE_PCIE_vfs_intr_info_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_vfs_intr_info_V2_AMAP, *PPCIE_vfs_intr_info_V2_AMAP;


typedef struct {
   BE_BIT prog_value[32];                         // DWORD 0
} SG_PACK BE_PCIE_SERDES_PROG_REG_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_PROG_REG_V2_AMAP, *PPCIE_SERDES_PROG_REG_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[31];                              // DWORD 0
   BE_BIT CPU_reset;                              // DWORD 0
} SG_PACK BE_PCICFG_MPU_CONTROL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MPU_CONTROL_CSR_V2_AMAP, *PPCICFG_MPU_CONTROL_CSR_V2_AMAP;


typedef struct {
   BE_BIT byte0[8];                               // DWORD 0
   BE_BIT byte1[8];                               // DWORD 0
   BE_BIT byte2[8];                               // DWORD 0
   BE_BIT byte3[8];                               // DWORD 0
} SG_PACK BE_PCICFG_D0_RESOURCE_ARBITER_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_D0_RESOURCE_ARBITER_V2_AMAP, *PPCICFG_D0_RESOURCE_ARBITER_V2_AMAP;


typedef struct {
   BE_BIT word0[16];                              // DWORD 0
   BE_BIT word1[16];                              // DWORD 0
} SG_PACK BE_PCICFG_D0_RESOURCE_ARBITER_WORD_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_D0_RESOURCE_ARBITER_WORD_V2_AMAP, *PPCICFG_D0_RESOURCE_ARBITER_WORD_V2_AMAP;


typedef struct {
   BE_BIT word0[16];                              // DWORD 0
   BE_BIT word1[16];                              // DWORD 0
} SG_PACK BE_PCICFG_D3_RESOURCE_ARBITER_WORD_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_D3_RESOURCE_ARBITER_WORD_V2_AMAP, *PPCICFG_D3_RESOURCE_ARBITER_WORD_V2_AMAP;


typedef struct {
   BE_BIT byte0[8];                               // DWORD 0
   BE_BIT byte1[8];                               // DWORD 0
   BE_BIT byte2[8];                               // DWORD 0
   BE_BIT byte3[8];                               // DWORD 0
} SG_PACK BE_PCICFG_D3_RESOURCE_ARBITER_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_D3_RESOURCE_ARBITER_V2_AMAP, *PPCICFG_D3_RESOURCE_ARBITER_V2_AMAP;


typedef struct {
   BE_BIT data_out[16];                           // DWORD 0
   BE_BIT data_in[8];                             // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_PCICFG_D3BLOCK_CTRL_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_D3BLOCK_CTRL_V2_AMAP, *PPCICFG_D3BLOCK_CTRL_V2_AMAP;


typedef struct {
   BE_BIT extfb;                                  // DWORD 0
   BE_BIT enarst;                                 // DWORD 0
   BE_BIT fbcnt[8];                               // DWORD 0
   BE_BIT z[3];                                   // DWORD 0
   BE_BIT p[2];                                   // DWORD 0
   BE_BIT rate;                                   // DWORD 0
   BE_BIT jitlmt[2];                              // DWORD 0
   BE_BIT cntlmt[2];                              // DWORD 0
   BE_BIT enouts;                                 // DWORD 0
   BE_BIT bgvr[2];                                // DWORD 0
   BE_BIT pllbypass;                              // DWORD 0
   BE_BIT spare[5];                               // DWORD 0
   BE_BIT lresetn;                                // DWORD 0
   BE_BIT load;                                   // DWORD 0
   BE_BIT en;                                     // DWORD 0
} SG_PACK BE_PCICFG_CPLL_CONFIG_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CPLL_CONFIG_V2_AMAP, *PPCICFG_CPLL_CONFIG_V2_AMAP;


typedef struct {
   BE_BIT extfb;                                  // DWORD 0
   BE_BIT enarst;                                 // DWORD 0
   BE_BIT fbcnt[8];                               // DWORD 0
   BE_BIT z[3];                                   // DWORD 0
   BE_BIT p[2];                                   // DWORD 0
   BE_BIT rate;                                   // DWORD 0
   BE_BIT jitlmt[2];                              // DWORD 0
   BE_BIT cntlmt[2];                              // DWORD 0
   BE_BIT enouts;                                 // DWORD 0
   BE_BIT bgvr[2];                                // DWORD 0
   BE_BIT pllbypass;                              // DWORD 0
   BE_BIT spare[5];                               // DWORD 0
   BE_BIT lresetn;                                // DWORD 0
   BE_BIT load;                                   // DWORD 0
   BE_BIT en;                                     // DWORD 0
} SG_PACK BE_PCICFG_EPLL_CONFIG_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_EPLL_CONFIG_V2_AMAP, *PPCICFG_EPLL_CONFIG_V2_AMAP;


typedef struct {
   BE_BIT extfb;                                  // DWORD 0
   BE_BIT enarst;                                 // DWORD 0
   BE_BIT fbcnt[8];                               // DWORD 0
   BE_BIT z[3];                                   // DWORD 0
   BE_BIT p[2];                                   // DWORD 0
   BE_BIT rate;                                   // DWORD 0
   BE_BIT jitlmt[2];                              // DWORD 0
   BE_BIT cntlmt[2];                              // DWORD 0
   BE_BIT enouts;                                 // DWORD 0
   BE_BIT bgvr[2];                                // DWORD 0
   BE_BIT pllbypass;                              // DWORD 0
   BE_BIT spare[5];                               // DWORD 0
   BE_BIT lresetn;                                // DWORD 0
   BE_BIT load;                                   // DWORD 0
   BE_BIT en;                                     // DWORD 0
} SG_PACK BE_PCICFG_MPLL_CONFIG_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MPLL_CONFIG_V2_AMAP, *PPCICFG_MPLL_CONFIG_V2_AMAP;


typedef struct {
   BE_BIT extfb;                                  // DWORD 0
   BE_BIT enarst;                                 // DWORD 0
   BE_BIT fbcnt[8];                               // DWORD 0
   BE_BIT z[3];                                   // DWORD 0
   BE_BIT p[2];                                   // DWORD 0
   BE_BIT rate;                                   // DWORD 0
   BE_BIT jitlmt[2];                              // DWORD 0
   BE_BIT cntlmt[2];                              // DWORD 0
   BE_BIT enouts;                                 // DWORD 0
   BE_BIT bgvr[2];                                // DWORD 0
   BE_BIT pllbypass;                              // DWORD 0
   BE_BIT spare[5];                               // DWORD 0
   BE_BIT lresetn;                                // DWORD 0
   BE_BIT load;                                   // DWORD 0
   BE_BIT en;                                     // DWORD 0
} SG_PACK BE_PCICFG_PPLL_CONFIG_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PPLL_CONFIG_V2_AMAP, *PPCICFG_PPLL_CONFIG_V2_AMAP;


typedef struct {
   BE_BIT xtal_rfckctrl[16];                      // DWORD 0
   BE_BIT diff_buf_ctrl[4];                       // DWORD 0
   BE_BIT pcie_buf_ctrl[4];                       // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_PCICFG_XTL_DIFF_PCIE_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_XTL_DIFF_PCIE_CSR_V2_AMAP, *PPCICFG_XTL_DIFF_PCIE_CSR_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_PCICFG_BE_BLOCK1_RST_DBG_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_BE_BLOCK1_RST_DBG_V2_AMAP, *PPCICFG_BE_BLOCK1_RST_DBG_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2_AMAP, *PPCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_PCICFG_GENERIC_SCRATCH_REG_V2_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GENERIC_SCRATCH_REG_V2_AMAP, *PPCICFG_GENERIC_SCRATCH_REG_V2_AMAP;


typedef struct {
   BE_BIT tx_margin_comm_bit31_0[32];             // DWORD 0
} SG_PACK BE_PCIE_SERDES_TX_MARGIN_COMM_0_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_TX_MARGIN_COMM_0_V2_AMAP, *PPCIE_SERDES_TX_MARGIN_COMM_0_V2_AMAP;


typedef struct {
   BE_BIT tx_margin_comm_bit59_32[28];            // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT force_tx_margin_comm;                   // DWORD 0
} SG_PACK BE_PCIE_SERDES_TX_MARGIN_COMM_1_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_TX_MARGIN_COMM_1_V2_AMAP, *PPCIE_SERDES_TX_MARGIN_COMM_1_V2_AMAP;


typedef struct {
   BE_BIT tx_param_bit31_0[32];                   // DWORD 0
} SG_PACK BE_PCIE_SERDES_TX_PARAM_0_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_TX_PARAM_0_V2_AMAP, *PPCIE_SERDES_TX_PARAM_0_V2_AMAP;


typedef struct {
   BE_BIT tx_param_bit58_32[27];                  // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT force_tx_param;                         // DWORD 0
} SG_PACK BE_PCIE_SERDES_TX_PARAM_1_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_TX_PARAM_1_V2_AMAP, *PPCIE_SERDES_TX_PARAM_1_V2_AMAP;


typedef struct {
   BE_BIT prog_value[32];                         // DWORD 0
} SG_PACK BE_PCIE_SERDES_RX_PARAM_0_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_RX_PARAM_0_V2_AMAP, *PPCIE_SERDES_RX_PARAM_0_V2_AMAP;


typedef struct {
   BE_BIT prog_value[32];                         // DWORD 0
} SG_PACK BE_PCIE_SERDES_RX_PARAM_1_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_RX_PARAM_1_V2_AMAP, *PPCIE_SERDES_RX_PARAM_1_V2_AMAP;


typedef struct {
   BE_BIT prog_value[32];                         // DWORD 0
} SG_PACK BE_PCIE_SERDES_RX_PARAM_2_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_RX_PARAM_2_V2_AMAP, *PPCIE_SERDES_RX_PARAM_2_V2_AMAP;


typedef struct {
   BE_BIT prog_value[32];                         // DWORD 0
} SG_PACK BE_PCIE_SERDES_RX_PARAM_3_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_RX_PARAM_3_V2_AMAP, *PPCIE_SERDES_RX_PARAM_3_V2_AMAP;


typedef struct {
   BE_BIT prog_value[32];                         // DWORD 0
} SG_PACK BE_PCIE_SERDES_RX_PARAM_4_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_RX_PARAM_4_V2_AMAP, *PPCIE_SERDES_RX_PARAM_4_V2_AMAP;


typedef struct {
   BE_BIT rx_param_bit175_160[16];                // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT force_rx_param;                         // DWORD 0
} SG_PACK BE_PCIE_SERDES_RX_PARAM_5_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_RX_PARAM_5_V2_AMAP, *PPCIE_SERDES_RX_PARAM_5_V2_AMAP;


typedef struct {
   BE_BIT rcv_det_override_value[8];              // DWORD 0
   BE_BIT rsvd0[23];                              // DWORD 0
   BE_BIT force_rcv_det;                          // DWORD 0
} SG_PACK BE_PCIE_SERDES_RCV_DET_V2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_RCV_DET_V2_AMAP, *PPCIE_SERDES_RCV_DET_V2_AMAP;


typedef struct {
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf0_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf1_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf3_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf2_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf4_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf5_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf6_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf7_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf8_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf9_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf10_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf11_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf12_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf13_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf14_pm_control;
   BE_PCICFG_PM_CONTROL_FOR_D3BLOCK_V2_AMAP pf15_pm_control;
} SG_PACK BE_PCICFG_PM_CONTROL_CSRMAP_V2_AMAP;
typedef struct { u32 dw[16]; } PCICFG_PM_CONTROL_CSRMAP_V2_AMAP, *PPCICFG_PM_CONTROL_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_FUNCTION_IDENTIFIER_F1_V2_AMAP func_id;
   BE_PCICFG_FLASH_GREED_CTRL_CSR_V2_AMAP flash_arb_control;
   BE_PCICFG_F1_HOST_DEBUG1_V2_AMAP host_debug1;
   BE_PCICFG_HOST_BAR_STATUS_PF1_CSR_V2_AMAP host_control1;
   BE_PCIE_SERDES_MDIO_COMMAND_V2_AMAP pcie_lltl_mdio_command;
   BE_PCIE_SERDES_MDIO_DATA_V2_AMAP pcie_lltl_mdio_data;
   BE_PCICFG_SLI_IF_TYPE_PROG_CSR_V2_AMAP sli4_if_type_prog_csr[2];
   BE_PCICFG_SLI_IF_TYPE_VAL1_PROG_CSR_V2_AMAP pf_31to16_sli4_if_type_prog_csr[2];
   BE_BIT rsvd0[128];                             // DWORD 10
   BE_PCICFG_HOST_CONTROL2_CSR_V2_AMAP host_control2;
   BE_BIT rsvd1[128];                             // DWORD 15
   BE_BIT rsvd2[1440];                            // DWORD 19
} SG_PACK BE_PCICFG_PF1_EXTEND1_CSRMAP_V2_AMAP;
typedef struct { u32 dw[64]; } PCICFG_PF1_EXTEND1_CSRMAP_V2_AMAP, *PPCICFG_PF1_EXTEND1_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_FUNCTION_IDENTIFIER_F0_V2_AMAP function_ctrl_identifier;
   BE_PCICFG_GCLK_CORE_EN0_CSR_V2_AMAP gclk_core_en0;
   BE_PCICFG_GCLK_CORE_EN1_CSR_V2_AMAP gclk_core_en1;
   BE_PCICFG_HOST_CONTROL1_CSR_V2_AMAP host_control1;
   BE_PCIE_SEC_PCIE_EXT_CAP_HDR_V2_AMAP secondary_pcie_cap;
   BE_PCIE_LINK_CTRL_3_REG_V2_AMAP link_control_3;
   BE_PCIE_LANE_ERROR_STATUS_REG_V2_AMAP lane_error_status;
   BE_PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2_AMAP lane_1_0_equalization_control;
   BE_PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2_AMAP lane_3_2_equalization_control;
   BE_PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2_AMAP lane_5_4_equalization_control;
   BE_PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2_AMAP lane_7_6_equalization_control;
   BE_PCICFG_VF_VPD_LOC_CSR_V2_AMAP vf_vpd_translation_addr;
   BE_PCICFG_CUST_PF_CONTROL_CSR_V2_AMAP cust_pf_control;
   BE_PCIE_cust_pfs_intr_info_V2_AMAP cust_pfs_vpd_intr_func_index;
   BE_PCICFG_PF0_HOST_CONTROL2_CSR_V2_AMAP host_control2;
   BE_PCICFG_HWDBG_MASK_0_CORE_V2_AMAP hwdbg_mask_0_core;
   BE_PCICFG_HWDBG_MASK_1_CORE_V2_AMAP hwdbg_mask_1_core;
   BE_PCICFG_D0_RESOURCE_ARBITER_V2_AMAP hostd0_resource_arbiter;
   BE_PCICFG_D0_RESOURCE_ARBITER_WORD_V2_AMAP hostd0_resource_arbiter_word;
   BE_PCICFG_VPD_PROTOCOL_CSR_V2_AMAP pf_vpd_protocol_selected;
   BE_PCICFG_VPD_PROTOCOL_CSR_V2_AMAP cust_pf_vpd_protocol_selected;
   BE_PCICFG_VPD_PROTOCOL_CSR_V2_AMAP vf_group0_vpd_protocol_selected;
   BE_PCICFG_VPD_PROTOCOL_CSR_V2_AMAP vf_group1_vpd_protocol_selected;
   BE_PCICFG_PF_24EQ_16EQ_CTRL_V2_AMAP pf_24eq_16eq_share;
   BE_PCICFG_PF_32EQ_CTRL_V2_AMAP pf_32eq_share;
   BE_PCICFG_DMTF_ATS_ERRORS_V2_AMAP dmtf_ats_errors;
   BE_PCICFG_VF_ROCE_BAR_CTRL_V2_AMAP vf_roce_bar_control;
   BE_PCICFG_SHARED_REG_FUNC_LIMIT_V2_AMAP shared_reg_func_limit;
   BE_PCICFG_PF_8VF_FLR_CONTROL_V2_AMAP pf_8vf_flr_control;
   BE_PCICFG_PF_8VF_BME_FLR_CONTROL_V2_AMAP pf_8vf_bme_flr_control;
   BE_BIT rsvd0[1088];                            // DWORD 30
} SG_PACK BE_PCICFG_PF0_EXTEND1_CSRMAP_V2_AMAP;
typedef struct { u32 dw[64]; } PCICFG_PF0_EXTEND1_CSRMAP_V2_AMAP, *PPCICFG_PF0_EXTEND1_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_DEBUG_CSR_V2_AMAP debug;
   BE_PCICFG_GPI_CSR_V2_AMAP gpi[2];
   BE_PCICFG_GPO_LOW_CSR_V2_AMAP gpo_low;
   BE_PCICFG_GPO_HI_CSR_V2_AMAP gpo_hi;
   BE_PCICFG_GPIOMAP_CSR_V2_AMAP gpiomap[8];
   BE_PCICFG_SERDES_IOGB_CTRL_V2_AMAP serdes_iogb_ctrl;
   BE_PCICFG_SERDES_PLL_CONTROL_V2_AMAP pcie_serdes_pll_cntl;
   BE_PCICFG_HOST_D3_CONTROL_CSR_V2_AMAP host_d3_control;
   BE_PCIE_SERDES_TX_MARGIN_COMM_0_V2_AMAP tx_margin_comm_0;
   BE_PCIE_SERDES_TX_MARGIN_COMM_1_V2_AMAP tx_margin_comm_1;
   BE_PCIE_SERDES_TX_PARAM_0_V2_AMAP tx_param_0;
   BE_PCIE_SERDES_TX_PARAM_1_V2_AMAP tx_param_1;
   BE_PCIE_SERDES_RX_PARAM_0_V2_AMAP rx_param_0;
   BE_PCIE_SERDES_RX_PARAM_1_V2_AMAP rx_param_1;
   BE_PCIE_SERDES_RX_PARAM_2_V2_AMAP rx_param_2;
   BE_PCIE_SERDES_RX_PARAM_3_V2_AMAP rx_param_3;
   BE_PCIE_SERDES_RX_PARAM_4_V2_AMAP rx_param_4;
   BE_PCIE_SERDES_RX_PARAM_5_V2_AMAP rx_param_5;
   BE_PCIE_SERDES_RCV_DET_V2_AMAP rcv_detect;
   BE_PCICFG_STRAPS_REG_V2_AMAP straps_reg;
   BE_PCICFG_D3_PM_CONTROL_MON_V2_AMAP f7_f0_d3_pm_mon[2];
   BE_PCICFG_REQ_PRESET_V2_AMAP serdes_lanes_preset;
   BE_PCICFG_EQUALIZATION_CTRL0_V2_AMAP serdes_equal_ctrl0;
   BE_PCICFG_BCA_CTRL0_V2_AMAP serdes_bca_ctrl0;
   BE_PCICFG_SERDES_LANE_CTRL_V2_AMAP serdes_lane_ctrl;
   BE_PCICFG_SLEW_RATE_CTRL_V2_AMAP pads_slew_rate_control;
   BE_PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2_AMAP mpu_scratchpad;
   BE_PCICFG_HOST_D3CONTROL_CSR_V2_AMAP host_d3control;
   BE_PCICFG_MPU_CONTROL_CSR_V2_AMAP mpu_control;
   BE_PCICFG_GPI_CSR_V2_AMAP gpi_rsvd;
   BE_PCICFG_GPO_LOW_CSR_V2_AMAP gpo_rsvd;
   BE_PCICFG_GPIOMAP_CSR_V2_AMAP gpiomap_rsvd[4];
   BE_PCICFG_GPIOMUX_CSR_V2_AMAP gpiomux_rsvd;
   BE_PCICFG_D3BLOCK_CTRL_V2_AMAP hostd3_ctrl;
   BE_PCICFG_D3_RESOURCE_ARBITER_V2_AMAP hostd3_resource_arbiter;
   BE_PCICFG_HOSTD3_INT_STATUS_CSR_V2_AMAP hostd3_int_status;
   BE_PCICFG_HOSTD3_INT_MASK_CSR_V2_AMAP hostd3_int_mask;
   BE_PCICFG_HOSTD3_INT_LIVE_CSR_V2_AMAP hostd3_int_live_signal;
   BE_PCICFG_GENERIC_SCRATCH_REG_V2_AMAP ncsi_scratchpad;
   BE_PCICFG_XTL_DIFF_PCIE_CSR_V2_AMAP xtl_diff_pcie_ctrl;
   BE_PCICFG_BE_BLOCK1_RST_DBG_V2_AMAP be_block1_rst_dbg;
   BE_PCICFG_HOSTD3_UE_MASK_CSR_V2_AMAP hostd3_ue_mask;
   BE_PCICFG_HOSTD3_UE_STATUS_CSR_V2_AMAP hostd3_ue_status;
   BE_PCICFG_CPLL_CONFIG_V2_AMAP cpll_cfg;
   BE_PCICFG_EPLL_CONFIG_V2_AMAP epll_cfg;
   BE_PCICFG_MPLL_CONFIG_V2_AMAP mpll_cfg;
   BE_PCICFG_PPLL_CONFIG_V2_AMAP ppll_cfg;
   BE_PCICFG_D3_RESOURCE_ARBITER_WORD_V2_AMAP hostd3_resource_arbiter_word;
   BE_PCICFG_GPIOMUX_CSR_V2_AMAP gpiomux;
   BE_BIT rsvd0[64];                              // DWORD 61
   BE_PCICFG_STRAP_PINS_REG_V2_AMAP strap_pins;
} SG_PACK BE_PCICFG_D3BLOCK_CSRMAP_V2_AMAP;
typedef struct { u32 dw[64]; } PCICFG_D3BLOCK_CSRMAP_V2_AMAP, *PPCICFG_D3BLOCK_CSRMAP_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[352];                             // DWORD 0
   BE_PCICFG_HOST_INT_STATUS2_CSR_V2_AMAP host_int_status2;
   BE_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP host_int_mask2;
   BE_BIT rsvd1[1376];                            // DWORD 13
   BE_PCIE_VSEC_CAP_HDR_V2_AMAP vsec_cap_hdr;
   BE_PCIE_VSEC_BAR_STRIDE_HDR_V2_AMAP vsec_bar_stride_hdr;
   BE_PCICFG_VF_BAR_STRIDE_V2_AMAP vf_bar_stride_0;
   BE_PCICFG_VF_BAR_STRIDE_SUPPORTED_V2_AMAP vf_bar_stride_0_supported;
   BE_PCICFG_VF_BAR_STRIDE_V2_AMAP vf_bar_stride_2;
   BE_PCICFG_VF_BAR_STRIDE_SUPPORTED_V2_AMAP vf_bar_stride_1_supported;
   BE_BIT rsvd2[64];                              // DWORD 62
} SG_PACK BE_PCICFG_PF1_EXTEND2_CSRMAP_V2_AMAP;
typedef struct { u32 dw[64]; } PCICFG_PF1_EXTEND2_CSRMAP_V2_AMAP, *PPCICFG_PF1_EXTEND2_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_DEBUG_CSR_V2_AMAP debug;
   BE_PCIE_SERDES_PROG_REG_V2_AMAP generic_reg;
   BE_PCICFG_SERDES_DBG_CTRL_V2_AMAP serdes_dbg_ctrl;
   BE_PCICFG_REQ_COEFF_V2_AMAP serdes_coeff_lane0;
   BE_PCICFG_REQ_COEFF_V2_AMAP serdes_coeff_lane1;
   BE_PCICFG_REQ_COEFF_V2_AMAP serdes_coeff_lane2;
   BE_PCICFG_REQ_COEFF_V2_AMAP serdes_coeff_lane3;
   BE_PCICFG_REQ_COEFF_V2_AMAP serdes_coeff_lane4;
   BE_PCICFG_REQ_COEFF_V2_AMAP serdes_coeff_lane5;
   BE_PCICFG_REQ_COEFF_V2_AMAP serdes_coeff_lane6;
   BE_PCICFG_REQ_COEFF_V2_AMAP serdes_coeff_lane7;
   BE_PCICFG_HOST_INT_STATUS2_CSR_V2_AMAP host_int_status2;
   BE_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP host_int_mask2;
   BE_BIT rsvd0[1376];                            // DWORD 13
   BE_PCIE_VSEC_CAP_HDR_V2_AMAP vsec_cap_hdr;
   BE_PCIE_VSEC_BAR_STRIDE_HDR_V2_AMAP vsec_bar_stride_hdr;
   BE_PCICFG_VF_BAR_STRIDE_V2_AMAP vf_bar_stride_0;
   BE_PCICFG_VF_BAR_STRIDE_SUPPORTED_V2_AMAP vf_bar_stride_0_supported;
   BE_PCICFG_VF_BAR_STRIDE_V2_AMAP vf_bar_stride_2;
   BE_PCICFG_VF_BAR_STRIDE_SUPPORTED_V2_AMAP vf_bar_stride_1_supported;
   BE_BIT rsvd1[64];                              // DWORD 62
} SG_PACK BE_PCICFG_PF0_EXTEND2_CSRMAP_V2_AMAP;
typedef struct { u32 dw[64]; } PCICFG_PF0_EXTEND2_CSRMAP_V2_AMAP, *PPCICFG_PF0_EXTEND2_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_ID_F0_CSR_V2_AMAP id;
   BE_PCICFG_COMMAND_STATUS_CSR_V2_AMAP cmd_status;
   BE_PCICFG_CLASS_REV_F0_CSR_V2_AMAP class_rev;
   BE_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2_AMAP cache;
   BE_PCICFG_MEMBAR0_LO_CSR_V2_AMAP membar0_lo;
   BE_PCICFG_MEMBAR0_HI_CSR_V2_AMAP membar0_hi;
   BE_PCICFG_MEMBAR1_LO_CSR_V2_AMAP membar1_lo;
   BE_PCICFG_MEMBAR1_HI_CSR_V2_AMAP membar1_hi;
   BE_PCICFG_MEMBAR2_LO_F0_CSR_V2_AMAP membar2_lo;
   BE_PCICFG_MEMBAR2_HI_CSR_V2_AMAP membar2_hi;
   BE_BIT rsvd0[32];                              // DWORD 10
   BE_PCICFG_SUBSYSTEM_ID_F0_CSR_V2_AMAP subsystem_id;
   BE_PCICFG_EXP_ROM_CSR_V2_AMAP exp_rom;
   BE_PCICFG_CAP_CSR_V2_AMAP cap;
   BE_BIT rsvd1[32];                              // DWORD 14
   BE_PCICFG_LATENCY_INT_F0_CSR_V2_AMAP latency_int;
   BE_PCICFG_PMC_CSR_V2_AMAP pmc;
   BE_PCICFG_PM_CONTROL_V2_AMAP pm_control;
   BE_PCICFG_MSIX_CSR_V2_AMAP msix;
   BE_PCICFG_MSIX_TABLE_CSR_V2_AMAP msix_table_offset;
   BE_PCICFG_MSIX_PBA_CSR_V2_AMAP msix_pba_offset;
   BE_PCICFG_HOST_CONTROL_STATUS_CSR_V2_AMAP host_control;
   BE_PCICFG_SCRATCHPAD_CSR_V2_AMAP scratchpad;
   BE_PCICFG_SOFT_RESET_CSR_V2_AMAP soft_reset;
   BE_PCICFG_LPC_ADDR_CSR_V2_AMAP lpc_addr;
   BE_PCICFG_LPC_DATA_CSR_V2_AMAP lpc_data;
   BE_PCICFG_LPC_COMMAND_CSR_V2_AMAP lpc_command;
   BE_PCICFG_TIMESTAMP_V2_AMAP timestamp_1ms;
   BE_PCICFG_TIMESTAMP_V2_AMAP timestamp_10ms;
   BE_PCICFG_SEMAPHORE_SCRATCH_CSR_V2_AMAP host_semaphore;
   BE_PCICFG_SEMAPHORE_SCRATCH_CSR_V2_AMAP vm_semaphore;
   BE_PCICFG_SCRATCHPAD_CSR_V2_AMAP scratchpad1;
   BE_PCICFG_GENERIC_SCRATCH_REG_V2_AMAP drv_hwdbg_scratchpad;
   BE_PCICFG_D0_RESOURCE_ARBITER_WORD_V2_AMAP hostd0_resource_arbiter_word;
   BE_PCICFG_GENERIC_SCRATCH_REG_V2_AMAP CSII_CONTROL;
   BE_PCICFG_GENERIC_SCRATCH_REG_V2_AMAP CSII_DATA;
   BE_BIT rsvd2[32];                              // DWORD 36
   BE_PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2_AMAP mpu_ep_semaphore;
   BE_PCICFG_OPTION_ROM_BIOS_CSR_V2_AMAP bios_status;
   BE_PCICFG_ASIC_ID_CSR_V2_AMAP asic_id;
   BE_PCICFG_UE_STATUS_LOW_CSR_V2_AMAP ue_status_low;
   BE_PCICFG_UE_STATUS_HI_CSR_V2_AMAP ue_status_hi;
   BE_PCICFG_UE_STATUS_LOW_MASK_CSR_V2_AMAP ue_status_low_mask;
   BE_PCICFG_UE_STATUS_HI_MASK_CSR_V2_AMAP ue_status_hi_mask;
   BE_PCICFG_ONLINE0_CSR_V2_AMAP online0;
   BE_PCICFG_ONLINE1_CSR_V2_AMAP online1;
   BE_PCICFG_VPD_CAP_CSR_V2_AMAP vpd_cap;
   BE_PCICFG_VPD_DATA_CSR_V2_AMAP vpd_data;
   BE_PCICFG_PCIE_CAP_CSR_V2_AMAP pcie_cap;
   BE_PCICFG_PCIE_DEVCAP_CSR_V2_AMAP pcie_devcap;
   BE_PCICFG_PCIE_CONTROL_STATUS_CSR_V2_AMAP pcie_control_status;
   BE_PCICFG_PCIE_LINK_CAP_CSR_V2_AMAP pcie_link_cap;
   BE_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP pcie_link_status;
   BE_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros[4];
   BE_PCICFG_PCIE_DEVCAP2_CSR_V2_AMAP pcie_devcap2;
   BE_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP pcie_control_status2;
   BE_PCICFG_PCIE_LINK_CAP2_CSR_V2_AMAP pcie_link_cap2;
   BE_PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP pcie_link_status2;
   BE_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros_1[2];
   BE_PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2_AMAP membar_ctrl_intr_ctrl;
   BE_PCIE_ERR_ENHANCED_CAP_V2_AMAP pcie_err_enhanced_cap;
   BE_PCIE_UNCORR_ERR_STATUS_V2_AMAP pcie_uncorr_err_status;
   BE_PCIE_UNCORR_ERR_MASK_V2_AMAP pcie_uncorr_err_mask;
   BE_PCIE_UNCORR_ERR_SEVERITY_V2_AMAP pcie_uncorr_err_severity;
   BE_PCIE_CORR_ERR_STATUS_V2_AMAP pcie_corr_err_status;
   BE_PCIE_CORR_ERR_MASK_V2_AMAP pcie_corr_err_mask;
   BE_PCIE_ERR_CAP_CONTROL_V2_AMAP pcie_err_cap_control;
   BE_PCIE_HEADER_REGISTER_V2_AMAP pcie_header_register0;
   BE_PCIE_HEADER_REGISTER_V2_AMAP pcie_header_register1;
   BE_PCIE_HEADER_REGISTER_V2_AMAP pcie_header_register2;
   BE_PCIE_HEADER_REGISTER_V2_AMAP pcie_header_register3;
   BE_PCIE_TPH_REQ_CAP_HDR_F0_V2_AMAP pcie_tph_req_caphdr;
   BE_PCIE_TPH_CAPABILITY_V2_AMAP pcie_tph_capability;
   BE_PCIE_TPH_CONTROL_V2_AMAP pcie_tph_control;
   BE_PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_V2_AMAP pcie_fcp_timer_beacon_en_pcicfg_override;
   BE_PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_V2_AMAP pcie_option_rom_flash_translation_f0;
   BE_PCICFG_IP_CONTROL_STATUS_3_CSR_V2_AMAP ip_control_status_3;
   BE_PCIE_ATS_ENHANCED_CAP_V2_AMAP pcie_ats_enhanced_hdr;
   BE_PCIE_ATS_CAPABILITY_V2_AMAP pcie_ats_capability;
   BE_PCIE_PM_PME_SERDES_PLL_DMA_WRB_V2_AMAP pcie_pm_pme_serdes_pll_dma_wrb;
   BE_hwdbg_cfgreg_i_5_V2_AMAP host_dbg_mux_data_pclk_d3_o_63_32;
   BE_PCIE_vfs_intr_info_V2_AMAP vfs_vpd_intr_func_index;
   BE_hwdbg_cfgreg_i_0_V2_AMAP host_dbg_mux_data_core_o_31_0;
   BE_hwdbg_cfgreg_i_1_V2_AMAP host_dbg_mux_data_core_o_63_32;
   BE_PCIE_ARI_ENHANCED_CAP_V2_AMAP pcie_ari_enhanced_hdr;
   BE_PCIE_ARI_CAPABILITY_V2_AMAP pcie_ari_capability;
   BE_PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP pcie_device_serial_hdr;
   BE_PCIE_DEV_SERIAL_NUM_LOW_V2_AMAP pcie_device_serial_number_low;
   BE_PCIE_DEV_SERIAL_NUM_HIGH_V2_AMAP pcie_device_serial_number_high;
   BE_PCICFG_HOST_INT_STATUS_CSR_V2_AMAP host_int_status;
   BE_PCICFG_HOST_INT_MASK_CSR_V2_AMAP host_int_mask;
   BE_PCICFG_HOST_TIMER_INT_CTRL_CSR_V2_AMAP host_timer_ctrl;
   BE_PCIE_SR_IOV_ENHANCED_CAP_V2_AMAP SR_IOV_capability_id;
   BE_PCIE_SR_IOV_CAPABILITIES_V2_AMAP SR_IOV_capabilities;
   BE_PCIE_SR_IOV_STATUS_CONTROL_V2_AMAP SR_IOV_status_control;
   BE_PCIE_TOTAL_INITIAL_VFs_V2_AMAP total_initial_VFs;
   BE_PCIE_NUM_VFs_V2_AMAP number_of_VFs;
   BE_PCIE_VF_STRIDE_OFFSET_V2_AMAP VF_stride_offset;
   BE_PCIE_VF_DEVICE_ID_V2_AMAP VF_device_id;
   BE_PCIE_VF_SYSTEM_PAGE_SUPPORTED_V2_AMAP PF_supported_page_size;
   BE_PCIE_VF_SYSTEM_PAGE_V2_AMAP PF_system_page;
   BE_PCICFG_VF_MEMBAR0_LO_V2_AMAP VF_membar0_low;
   BE_PCICFG_VF_MEMBAR0_HI_V2_AMAP VF_membar0_high;
   BE_PCICFG_VF_MEMBAR0_LO_V2_AMAP VF_membar1_low;
   BE_PCICFG_VF_MEMBAR0_HI_V2_AMAP VF_membar1_high;
   BE_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros_2_1[2];
   BE_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros_3;
   BE_PCICFG_IP_SPEED_WIDTH_CTRL_V2_AMAP ip_speed_width_control;
   BE_PCICFG_IP_CONTROL_STATUS_5_CSR_V2_AMAP ip_control_status_5;
   BE_PCICFG_VF_SLI4_CSR_V2_AMAP vf_sli4_reg;
   BE_PCICFG_ERR_REPLAY_MONITOR_V2_AMAP error_replay_monitor;
   BE_PCICFG_IP_CONTROL_STATUS_2_CSR_V2_AMAP ip_control_status_2;
   BE_PCICFG_IP_CONTROL_STATUS_0_CSR_V2_AMAP ip_control_status_0;
   BE_PCICFG_IP_CONTROL_STATUS_1_CSR_V2_AMAP ip_control_status_1;
   BE_PCICFG_HWDBG_SHIFT_V2_AMAP cfg_attr_hwdbg_shift;
   BE_PCIE_ATS_INVALID_ADDR_LOW_V2_AMAP ats_invalid_addr_low;
   BE_PCIE_ATS_INVALID_ADDR_V2_AMAP ats_invalid_addr_high;
   BE_PCIE_ATS_INVALID_REQUESTERID_DEVID_V2_AMAP ats_invalid_requesterid_deviceid;
   BE_PCIE_VSEC_CAP_HDR_V2_AMAP vsec_cap_hdr;
   BE_PCIE_VSEC_HDR_V2_AMAP vsec_hdr;
   BE_PCICFG_VF_BAR_STRIDE_V2_AMAP vf_bar_stride;
   BE_PCICFG_HWDBG_REGSEL_V2_AMAP hwdbg_regsel;
   BE_PCICFG_HWDBG_ENABLE_V2_AMAP hwdbg_enable;
   BE_PCICFG_PF0_EXTEND1_CSRMAP_V2_AMAP pciecfg_pf0_extend1;
   BE_PCICFG_PF0_EXTEND2_CSRMAP_V2_AMAP pciecfg_pf0_extend2;
   BE_PCICFG_D3BLOCK_CSRMAP_V2_AMAP pciecfg_d3block_csrmap;
   BE_BIT rsvd3[22528];                           // DWORD 320
} SG_PACK BE_PCICFG_PF0_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG_PF0_CSRMAP_V2_AMAP, *PPCICFG_PF0_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_ID_F1_CSR_V2_AMAP id;
   BE_PCICFG_COMMAND_STATUS_CSR_V2_AMAP cmd_status;
   BE_PCICFG_CLASS_REV_F1_CSR_V2_AMAP class_rev;
   BE_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2_AMAP cache;
   BE_PCICFG_MEMBAR0_LO_CSR_V2_AMAP membar0_lo;
   BE_PCICFG_MEMBAR0_HI_CSR_V2_AMAP membar0_hi;
   BE_PCICFG_MEMBAR1_LO_CSR_V2_AMAP membar1_lo;
   BE_PCICFG_MEMBAR1_HI_CSR_V2_AMAP membar1_hi;
   BE_PCICFG_MEMBAR2_LO_F1_CSR_V2_AMAP membar2_lo;
   BE_PCICFG_MEMBAR2_HI_CSR_V2_AMAP membar2_hi;
   BE_BIT rsvd0[32];                              // DWORD 10
   BE_PCICFG_SUBSYSTEM_ID_F1_CSR_V2_AMAP subsystem_id;
   BE_PCICFG_EXP_ROM_CSR_V2_AMAP exp_rom;
   BE_PCICFG_CAP_CSR_V2_AMAP cap;
   BE_BIT rsvd1[32];                              // DWORD 14
   BE_PCICFG_LATENCY_INT_F1_CSR_V2_AMAP latency_int;
   BE_PCICFG_PMC_CSR_V2_AMAP pmc;
   BE_PCICFG_PM_CONTROL_V2_AMAP pm_control;
   BE_PCICFG_MSIX_CSR_V2_AMAP msix;
   BE_PCICFG_MSIX_TABLE_CSR_V2_AMAP msix_table_offset;
   BE_PCICFG_MSIX_PBA_CSR_V2_AMAP msix_pba_offset;
   BE_PCICFG_HOST_CONTROL_STATUS_CSR_V2_AMAP host_control;
   BE_PCICFG_SCRATCHPAD_CSR_V2_AMAP scratchpad;
   BE_PCICFG_SOFT_RESET_CSR_V2_AMAP soft_reset;
   BE_PCICFG_LPC_ADDR_CSR_V2_AMAP lpc_addr;
   BE_PCICFG_LPC_DATA_CSR_V2_AMAP lpc_data;
   BE_PCICFG_LPC_COMMAND_CSR_V2_AMAP lpc_command;
   BE_PCICFG_TIMESTAMP_V2_AMAP timestamp_1ms;
   BE_PCICFG_TIMESTAMP_V2_AMAP timestamp_10ms;
   BE_PCICFG_SEMAPHORE_SCRATCH_CSR_V2_AMAP host_semaphore;
   BE_PCICFG_SEMAPHORE_SCRATCH_CSR_V2_AMAP vm_semaphore;
   BE_PCICFG_SCRATCHPAD_CSR_V2_AMAP scratchpad1;
   BE_PCICFG_GENERIC_SCRATCH_REG_V2_AMAP drv_hwdbg_scratchpad;
   BE_PCICFG_D0_RESOURCE_ARBITER_WORD_V2_AMAP hostd0_resource_arbiter_word;
   BE_BIT rsvd2[96];                              // DWORD 34
   BE_PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2_AMAP mpu_ep_semaphore;
   BE_PCICFG_OPTION_ROM_BIOS_CSR_V2_AMAP bios_status;
   BE_PCICFG_ASIC_ID_CSR_V2_AMAP asic_id;
   BE_PCICFG_UE_STATUS_LOW_CSR_V2_AMAP ue_status_low;
   BE_PCICFG_UE_STATUS_HI_CSR_V2_AMAP ue_status_hi;
   BE_PCICFG_UE_STATUS_LOW_MASK_CSR_V2_AMAP ue_status_low_mask;
   BE_PCICFG_UE_STATUS_HI_MASK_CSR_V2_AMAP ue_status_hi_mask;
   BE_PCICFG_ONLINE0_CSR_V2_AMAP online0;
   BE_PCICFG_ONLINE1_CSR_V2_AMAP online1;
   BE_PCICFG_VPD_CAP_CSR_V2_AMAP vpd_cap;
   BE_PCICFG_VPD_DATA_CSR_V2_AMAP vpd_data;
   BE_PCICFG_PCIE_CAP_CSR_V2_AMAP pcie_cap;
   BE_PCICFG_PCIE_DEVCAP_CSR_V2_AMAP pcie_devcap;
   BE_PCICFG_PCIE_CONTROL_STATUS_CSR_V2_AMAP pcie_control_status;
   BE_PCICFG_PCIE_LINK_CAP_CSR_V2_AMAP pcie_link_cap;
   BE_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP pcie_link_status;
   BE_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros[4];
   BE_PCICFG_PCIE_DEVCAP2_CSR_V2_AMAP pcie_devcap2;
   BE_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP pcie_control_status2;
   BE_PCICFG_PCIE_LINK_CAP2_CSR_V2_AMAP pcie_link_cap2;
   BE_PCICFG_PCIE_LINK_STATUS2_CSR_F1_V2_AMAP pcie_link_status2;
   BE_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros_1[2];
   BE_PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2_AMAP membar_ctrl_intr_ctrl;
   BE_PCIE_ERR_ENHANCED_CAP_V2_AMAP pcie_err_enhanced_cap;
   BE_PCIE_UNCORR_ERR_STATUS_V2_AMAP pcie_uncorr_err_status;
   BE_PCIE_UNCORR_ERR_MASK_V2_AMAP pcie_uncorr_err_mask;
   BE_PCIE_UNCORR_ERR_SEVERITY_V2_AMAP pcie_uncorr_err_severity;
   BE_PCIE_CORR_ERR_STATUS_V2_AMAP pcie_corr_err_status;
   BE_PCIE_CORR_ERR_MASK_V2_AMAP pcie_corr_err_mask;
   BE_PCIE_ERR_CAP_CONTROL_V2_AMAP pcie_err_cap_control;
   BE_PCIE_HEADER_REGISTER_V2_AMAP pcie_header_register0;
   BE_PCIE_HEADER_REGISTER_V2_AMAP pcie_header_register1;
   BE_PCIE_HEADER_REGISTER_V2_AMAP pcie_header_register2;
   BE_PCIE_HEADER_REGISTER_V2_AMAP pcie_header_register3;
   BE_PCIE_TPH_REQ_CAP_HDR_V2_AMAP pcie_tph_req_caphdr;
   BE_PCIE_TPH_CAPABILITY_V2_AMAP pcie_tph_capability;
   BE_PCIE_TPH_CONTROL_V2_AMAP pcie_tph_control;
   BE_PCIE_LTSSM_STAGES7_4_V2_AMAP pcie_ltssm_states7_4;
   BE_PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_V2_AMAP pcie_option_rom_flash_translation_f1;
   BE_PCIE_LTSSM_STAGES3_0_V2_AMAP pcie_ltssm_states3_0;
   BE_PCIE_ATS_ENHANCED_CAP_V2_AMAP pcie_ats_enhanced_hdr;
   BE_PCIE_ATS_CAPABILITY_V2_AMAP pcie_ats_capability;
   BE_BIT rsvd3[96];                              // DWORD 83
   BE_PCIE_SERDES_MDIO_COMMAND_V2_AMAP pcie_serdes_mdio_command;
   BE_PCIE_SERDES_MDIO_DATA_V2_AMAP pcie_serdes_mdio_data;
   BE_PCIE_ARI_ENHANCED_CAP_V2_AMAP pcie_ari_enhanced_hdr;
   BE_PCIE_ARI_CAPABILITY_V2_AMAP pcie_ari_capability;
   BE_PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP pcie_device_serial_hdr;
   BE_PCIE_DEV_SERIAL_NUM_LOW_V2_AMAP pcie_device_serial_number_low;
   BE_PCIE_DEV_SERIAL_NUM_HIGH_V2_AMAP pcie_device_serial_number_high;
   BE_PCICFG_HOST_INT_STATUS_CSR_V2_AMAP host_int_status;
   BE_PCICFG_HOST_INT_MASK_CSR_V2_AMAP host_int_mask;
   BE_PCICFG_HOST_TIMER_INT_CTRL_CSR_V2_AMAP host_timer_ctrl;
   BE_PCIE_SR_IOV_ENHANCED_CAP_V2_AMAP SR_IOV_capability_id;
   BE_PCIE_SR_IOV_CAPABILITIES_V2_AMAP SR_IOV_capabilities;
   BE_PCIE_SR_IOV_STATUS_CONTROL_V2_AMAP SR_IOV_status_control;
   BE_PCIE_TOTAL_INITIAL_VFs_V2_AMAP total_initial_VFs;
   BE_PCIE_NUM_VFs_V2_AMAP number_of_VFs;
   BE_PCIE_VF_STRIDE_OFFSET_V2_AMAP VF_stride_offset;
   BE_PCIE_VF_DEVICE_ID_V2_AMAP VF_device_id;
   BE_PCIE_VF_SYSTEM_PAGE_SUPPORTED_V2_AMAP PF_supported_page_size;
   BE_PCIE_VF_SYSTEM_PAGE_V2_AMAP PF_system_page;
   BE_PCICFG_VF_MEMBAR0_LO_V2_AMAP VF_membar0_low;
   BE_PCICFG_VF_MEMBAR0_HI_V2_AMAP VF_membar0_high;
   BE_PCICFG_VF_MEMBAR0_LO_V2_AMAP VF_membar1_low;
   BE_PCICFG_VF_MEMBAR0_HI_V2_AMAP VF_membar1_high;
   BE_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros_2_1[2];
   BE_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros_3;
   BE_PCIE_BME_TLP_COMMON_HDR0_V2_AMAP dma_tlp_hdr0;
   BE_PCIE_BME_TLP_COMMON_HDR1_V2_AMAP dma_tlp_hdr1;
   BE_PCIE_BME_ATS_REQ_TLP_ADDR_LOW_V2_AMAP dma_tlp_addr_low;
   BE_PCIE_BME_ATS_REQ_TLP_ADDR_HIGH_V2_AMAP dma_tlp_addr_high;
   BE_PCICFG_F1_HOST_DEBUG_V2_AMAP host_debug;
   BE_BIT rsvd4[96];                              // DWORD 117
   BE_PCIE_ATS_INVALID_ADDR_LOW_V2_AMAP ats_invalid_addr_low;
   BE_PCIE_ATS_INVALID_ADDR_V2_AMAP ats_invalid_addr_high;
   BE_PCIE_ATS_INVALID_REQUESTERID_DEVID_V2_AMAP ats_invalid_requesterid_deviceid;
   BE_PCIE_VSEC_CAP_HDR_V2_AMAP vsec_cap_hdr;
   BE_PCIE_VSEC_HDR_V2_AMAP vsec_hdr;
   BE_PCICFG_VF_BAR_STRIDE_V2_AMAP vf_bar_stride;
   BE_PCIE_MSIX_TBL_TO_CTX_CTRL_V2_AMAP msix_tbl_to_ctx_ctrl;
   BE_PCIE_MSIX_TBL_TO_CTX_V2_AMAP msix_tbl_to_ctx;
   BE_PCICFG_PF1_EXTEND1_CSRMAP_V2_AMAP pciecfg_pf1_extend1;
   BE_PCICFG_PF1_EXTEND2_CSRMAP_V2_AMAP pciecfg_pf1_extend2;
   BE_PCICFG_D3BLOCK_CSRMAP_V2_AMAP pciecfg_d3block_csrmap;
   BE_BIT rsvd5[22528];                           // DWORD 320
} SG_PACK BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG_PF1_PF7_CSRMAP_V2_AMAP, *PPCICFG_PF1_PF7_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF0_CSRMAP_V2_AMAP PCICFG_F0_CSRMAP;
} SG_PACK BE_PCICFG0_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG0_CSRMAP_V2_AMAP, *PPCICFG0_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F1_CSRMAP;
} SG_PACK BE_PCICFG1_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG1_CSRMAP_V2_AMAP, *PPCICFG1_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F2_CSRMAP;
} SG_PACK BE_PCICFG2_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG2_CSRMAP_V2_AMAP, *PPCICFG2_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F3_CSRMAP;
} SG_PACK BE_PCICFG3_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG3_CSRMAP_V2_AMAP, *PPCICFG3_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F4_CSRMAP;
} SG_PACK BE_PCICFG4_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG4_CSRMAP_V2_AMAP, *PPCICFG4_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F5_CSRMAP;
} SG_PACK BE_PCICFG5_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG5_CSRMAP_V2_AMAP, *PPCICFG5_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F6_CSRMAP;
} SG_PACK BE_PCICFG6_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG6_CSRMAP_V2_AMAP, *PPCICFG6_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F7_CSRMAP;
} SG_PACK BE_PCICFG7_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG7_CSRMAP_V2_AMAP, *PPCICFG7_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F8_CSRMAP;
} SG_PACK BE_PCICFG8_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG8_CSRMAP_V2_AMAP, *PPCICFG8_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F9_CSRMAP;
} SG_PACK BE_PCICFG9_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG9_CSRMAP_V2_AMAP, *PPCICFG9_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F10_CSRMAP;
} SG_PACK BE_PCICFG10_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG10_CSRMAP_V2_AMAP, *PPCICFG10_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F11_CSRMAP;
} SG_PACK BE_PCICFG11_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG11_CSRMAP_V2_AMAP, *PPCICFG11_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F12_CSRMAP;
} SG_PACK BE_PCICFG12_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG12_CSRMAP_V2_AMAP, *PPCICFG12_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F13_CSRMAP;
} SG_PACK BE_PCICFG13_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG13_CSRMAP_V2_AMAP, *PPCICFG13_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F14_CSRMAP;
} SG_PACK BE_PCICFG14_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG14_CSRMAP_V2_AMAP, *PPCICFG14_CSRMAP_V2_AMAP;


typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_V2_AMAP PCICFG_F15_CSRMAP;
} SG_PACK BE_PCICFG15_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PCICFG15_CSRMAP_V2_AMAP, *PPCICFG15_CSRMAP_V2_AMAP;


typedef struct {
   BE_BIT vendorid[16];                           // DWORD 0
   BE_BIT deviceid[16];                           // DWORD 0
} SG_PACK BE_VF_PCICFG_ID_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_ID_CSR_V2_AMAP, *PVF_PCICFG_ID_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT memen;                                  // DWORD 0
   BE_BIT bmen;                                   // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT perrsp;                                 // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT serren;                                 // DWORD 0
   BE_BIT rsvd3;                                  // DWORD 0
   BE_BIT intxdisable;                            // DWORD 0
   BE_BIT rsvd4[5];                               // DWORD 0
   BE_BIT rsvd5[3];                               // DWORD 0
   BE_BIT intstat;                                // DWORD 0
   BE_BIT cap;                                    // DWORD 0
   BE_BIT rsvd6;                                  // DWORD 0
   BE_BIT rsvd7;                                  // DWORD 0
   BE_BIT rsvd8;                                  // DWORD 0
   BE_BIT dpderr;                                 // DWORD 0
   BE_BIT rsvd9[2];                               // DWORD 0
   BE_BIT stabt;                                  // DWORD 0
   BE_BIT rtabt;                                  // DWORD 0
   BE_BIT rmabt;                                  // DWORD 0
   BE_BIT sserr;                                  // DWORD 0
   BE_BIT dperr;                                  // DWORD 0
} SG_PACK BE_CUST_PCICFG_COMMAND_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PCICFG_COMMAND_STATUS_CSR_V2_AMAP, *PCUST_PCICFG_COMMAND_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT bmen;                                   // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT perrsp;                                 // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT serren;                                 // DWORD 0
   BE_BIT rsvd3;                                  // DWORD 0
   BE_BIT rsvd4;                                  // DWORD 0
   BE_BIT rsvd5[5];                               // DWORD 0
   BE_BIT rsvd6[3];                               // DWORD 0
   BE_BIT rsvd7;                                  // DWORD 0
   BE_BIT cap;                                    // DWORD 0
   BE_BIT rsvd8[3];                               // DWORD 0
   BE_BIT dpderr;                                 // DWORD 0
   BE_BIT rsvd9[2];                               // DWORD 0
   BE_BIT stabt;                                  // DWORD 0
   BE_BIT rtabt;                                  // DWORD 0
   BE_BIT rmabt;                                  // DWORD 0
   BE_BIT sserr;                                  // DWORD 0
   BE_BIT dperr;                                  // DWORD 0
} SG_PACK BE_VF_PCICFG_COMMAND_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_COMMAND_STATUS_CSR_V2_AMAP, *PVF_PCICFG_COMMAND_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT rsvd2[5];                               // DWORD 0
   BE_BIT header_type[8];                         // DWORD 0
   BE_BIT rsvd3[8];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2_AMAP, *PVF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2_AMAP;


typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
   BE_BIT membar0[18];                            // DWORD 0
} SG_PACK BE_CUST_PCICFG_MEMBAR0_LO_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PCICFG_MEMBAR0_LO_CSR_V2_AMAP, *PCUST_PCICFG_MEMBAR0_LO_CSR_V2_AMAP;


typedef struct {
   BE_BIT membar0hi[32];                          // DWORD 0
} SG_PACK BE_CUST_PCICFG_MEMBAR0_HI_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PCICFG_MEMBAR0_HI_CSR_V2_AMAP, *PCUST_PCICFG_MEMBAR0_HI_CSR_V2_AMAP;


typedef struct {
   BE_BIT rev[8];                                 // DWORD 0
   BE_BIT prgintf[8];                             // DWORD 0
   BE_BIT subclass[8];                            // DWORD 0
   BE_BIT baseclass[8];                           // DWORD 0
} SG_PACK BE_VF_PCICFG_CLASS_REV_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_CLASS_REV_CSR_V2_AMAP, *PVF_PCICFG_CLASS_REV_CSR_V2_AMAP;


typedef struct {
   BE_BIT subsys_vendor_id[16];                   // DWORD 0
   BE_BIT subsys_id[16];                          // DWORD 0
} SG_PACK BE_VF_PCICFG_SUBSYSTEM_ID_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_SUBSYSTEM_ID_CSR_V2_AMAP, *PVF_PCICFG_SUBSYSTEM_ID_CSR_V2_AMAP;


typedef struct {
   BE_BIT capptr[8];                              // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_CAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_CAP_CSR_V2_AMAP, *PVF_PCICFG_CAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT int_line[8];                            // DWORD 0
   BE_BIT int_pin[8];                             // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_CUST_PF_PCICFG_LATENCY_INT_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_PCICFG_LATENCY_INT_CSR_V2_AMAP, *PCUST_PF_PCICFG_LATENCY_INT_CSR_V2_AMAP;


typedef struct {
   BE_BIT int_line[8];                            // DWORD 0
   BE_BIT int_pin[3];                             // DWORD 0
   BE_BIT int_pin_rsvd[5];                        // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_LATENCY_INT_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_LATENCY_INT_CSR_V2_AMAP, *PVF_PCICFG_LATENCY_INT_CSR_V2_AMAP;


typedef struct {
   BE_BIT capid[8];                               // DWORD 0
   BE_BIT nextptr[8];                             // DWORD 0
   BE_BIT tablesize[11];                          // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT funcmask;                               // DWORD 0
   BE_BIT en;                                     // DWORD 0
} SG_PACK BE_VF_PCICFG_MSIX_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_MSIX_CSR_V2_AMAP, *PVF_PCICFG_MSIX_CSR_V2_AMAP;


typedef struct {
   BE_BIT tablebir[3];                            // DWORD 0
   BE_BIT offset[29];                             // DWORD 0
} SG_PACK BE_VF_PCICFG_MSIX_TABLE_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_MSIX_TABLE_CSR_V2_AMAP, *PVF_PCICFG_MSIX_TABLE_CSR_V2_AMAP;


typedef struct {
   BE_BIT pbabir[3];                              // DWORD 0
   BE_BIT offset[29];                             // DWORD 0
} SG_PACK BE_VF_PCICFG_MSIX_PBA_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_MSIX_PBA_CSR_V2_AMAP, *PVF_PCICFG_MSIX_PBA_CSR_V2_AMAP;


typedef struct {
   BE_BIT vf_function_num[8];                     // DWORD 0
   BE_BIT pf_function_num[4];                     // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT sliport_error1[2];                      // DWORD 0
   BE_BIT SLI_STATUS_ERR;                         // DWORD 0
   BE_BIT SLI_STATUS_RN;                          // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
   BE_BIT drv_mpu_msg[2];                         // DWORD 0
   BE_BIT shadow_FLR;                             // DWORD 0
   BE_BIT hostintr;                               // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_INT_CTRL_FUNCTION_NUM_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_INT_CTRL_FUNCTION_NUM_V2_AMAP, *PVF_PCICFG_INT_CTRL_FUNCTION_NUM_V2_AMAP;


typedef struct {
   BE_BIT capid[8];                               // DWORD 0
   BE_BIT nextcap[8];                             // DWORD 0
   BE_BIT addr[15];                               // DWORD 0
   BE_BIT flag;                                   // DWORD 0
} SG_PACK BE_VF_PCICFG_VPD_CAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_VPD_CAP_CSR_V2_AMAP, *PVF_PCICFG_VPD_CAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_VPD_DATA_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_VPD_DATA_CSR_V2_AMAP, *PVF_PCICFG_VPD_DATA_CSR_V2_AMAP;


typedef struct {
   BE_BIT capid[8];                               // DWORD 0
   BE_BIT nextcap[8];                             // DWORD 0
   BE_BIT capver[4];                              // DWORD 0
   BE_BIT devport[4];                             // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_PCIE_CAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PCIE_CAP_CSR_V2_AMAP, *PVF_PCICFG_PCIE_CAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT payload[3];                             // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT lo_lat[3];                              // DWORD 0
   BE_BIT l1_lat[3];                              // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT ROLE_ERR_REP;                           // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
   BE_BIT rsvd3[10];                              // DWORD 0
   BE_BIT FLR;                                    // DWORD 0
   BE_BIT rsvd4[3];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_PCIE_DEVCAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PCIE_DEVCAP_CSR_V2_AMAP, *PVF_PCICFG_PCIE_DEVCAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT VFNUM[8];                               // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_FUNCTION_IDENTIFIER_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_FUNCTION_IDENTIFIER_V2_AMAP, *PVF_PCICFG_FUNCTION_IDENTIFIER_V2_AMAP;


typedef struct {
   BE_BIT scratchpad[32];                         // DWORD 0
} SG_PACK BE_VF_PCICFG_SCRATCHPAD_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_SCRATCHPAD_CSR_V2_AMAP, *PVF_PCICFG_SCRATCHPAD_CSR_V2_AMAP;


typedef struct {
   BE_BIT vf_msix_tbl_size[8];                    // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_VF_MSITBL_SIZE_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_MSITBL_SIZE_CSR_V2_AMAP, *PVF_MSITBL_SIZE_CSR_V2_AMAP;


typedef struct {
   BE_BIT CorrErrReportEn;                        // DWORD 0
   BE_BIT NonFatalErrReportEn;                    // DWORD 0
   BE_BIT FatalErrReportEn;                       // DWORD 0
   BE_BIT UnsuppReqReportEn;                      // DWORD 0
   BE_BIT EnableRelaxOrder;                       // DWORD 0
   BE_BIT Max_Payload_Size[3];                    // DWORD 0
   BE_BIT ExtendTagFieldEnable;                   // DWORD 0
   BE_BIT PhantomFnEnable;                        // DWORD 0
   BE_BIT AuxPwrPMEnable;                         // DWORD 0
   BE_BIT EnableNoSnoop;                          // DWORD 0
   BE_BIT Max_Read_Req_Size[3];                   // DWORD 0
   BE_BIT INITIATE_FLR;                           // DWORD 0
   BE_BIT CorrErrDetect;                          // DWORD 0
   BE_BIT NonFatalErrDetect;                      // DWORD 0
   BE_BIT FatalErrDetect;                         // DWORD 0
   BE_BIT UnsuppReqDetect;                        // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT TransPending;                           // DWORD 0
   BE_BIT rsvd1[10];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2_AMAP, *PVF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT MaxLinkSpeed[4];                        // DWORD 0
   BE_BIT MaxLinkWidth[6];                        // DWORD 0
   BE_BIT ASPMSupport[2];                         // DWORD 0
   BE_BIT L0sExitLat[3];                          // DWORD 0
   BE_BIT L1ExitLat[3];                           // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT PortNum[8];                             // DWORD 0
} SG_PACK BE_VF_PCICFG_PCIE_LINK_CAP_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PCIE_LINK_CAP_CSR_V2_AMAP, *PVF_PCICFG_PCIE_LINK_CAP_CSR_V2_AMAP;


typedef struct {
   BE_BIT ASPMCtl[2];                             // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
   BE_BIT LinkSpeed[4];                           // DWORD 0
   BE_BIT NegLinkWidth[6];                        // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
   BE_BIT SlotClkConfig;                          // DWORD 0
   BE_BIT rsvd2[3];                               // DWORD 0
} SG_PACK BE_CUST_PF_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP, *PCUST_PF_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT ASPMCtl[2];                             // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT ReadCmplBndry;                          // DWORD 0
   BE_BIT LinkDisable;                            // DWORD 0
   BE_BIT RetrainLink;                            // DWORD 0
   BE_BIT CommonClkConfig;                        // DWORD 0
   BE_BIT ExtendSync;                             // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT hw_autonomous_width_dis;                // DWORD 0
   BE_BIT rsvd2[6];                               // DWORD 0
   BE_BIT LinkSpeed[4];                           // DWORD 0
   BE_BIT NegLinkWidth[6];                        // DWORD 0
   BE_BIT LinkTrainErr;                           // DWORD 0
   BE_BIT LinkTrain;                              // DWORD 0
   BE_BIT SlotClkConfig;                          // DWORD 0
   BE_BIT rsvd3[3];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP, *PVF_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT cmpl_tmout_sup[4];                      // DWORD 0
   BE_BIT cmpl_tmout_dis_sup;                     // DWORD 0
   BE_BIT rsvd0[27];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_PCIE_DEVCAP2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PCIE_DEVCAP2_CSR_V2_AMAP, *PVF_PCICFG_PCIE_DEVCAP2_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT cmpl_tmout_disable;                     // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT IDO_request_en;                         // DWORD 0
   BE_BIT IDO_cmpl_en;                            // DWORD 0
   BE_BIT rsvd2[22];                              // DWORD 0
} SG_PACK BE_CUST_PF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP, *PCUST_PF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT cmpl_tmout_disable;                     // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT IDO_request_en;                         // DWORD 0
   BE_BIT IDO_cmpl_en;                            // DWORD 0
   BE_BIT rsvd2[22];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP, *PVF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT link_speed_vector[7];                   // DWORD 0
   BE_BIT rsvd1[24];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_PCIE_LINK_CAP2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PCIE_LINK_CAP2_CSR_V2_AMAP, *PVF_PCICFG_PCIE_LINK_CAP2_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT current_de_emphasis;                    // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP, *PVF_PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT current_de_emphasis;                    // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_CUST_PF_PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP, *PCUST_PF_PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_RETURN_ZEROS_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_RETURN_ZEROS_V2_AMAP, *PVF_PCICFG_RETURN_ZEROS_V2_AMAP;


typedef struct {
   BE_BIT err_intr[32];                           // DWORD 0
} SG_PACK BE_VF_PCICFG_PF_VF_ERR_A_INT_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PF_VF_ERR_A_INT_CSR_V2_AMAP, *PVF_PCICFG_PF_VF_ERR_A_INT_CSR_V2_AMAP;


typedef struct {
   BE_BIT err_intr[32];                           // DWORD 0
} SG_PACK BE_VF_PCICFG_PF_VF_ERR_B_INT_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PF_VF_ERR_B_INT_CSR_V2_AMAP, *PVF_PCICFG_PF_VF_ERR_B_INT_CSR_V2_AMAP;


typedef struct {
   BE_BIT FLR_intr[32];                           // DWORD 0
} SG_PACK BE_VF_PCICFG_PF_VF_FLR_INT_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PF_VF_FLR_INT_CSR_V2_AMAP, *PVF_PCICFG_PF_VF_FLR_INT_CSR_V2_AMAP;


typedef struct {
   BE_BIT cust_pf0_id_sel[4];                     // DWORD 0
   BE_BIT cust_pf1_id_sel[4];                     // DWORD 0
   BE_BIT cust_pf2_id_sel[4];                     // DWORD 0
   BE_BIT cust_pf3_id_sel[4];                     // DWORD 0
   BE_BIT cust_pf4_id_sel[4];                     // DWORD 0
   BE_BIT cust_pf5_id_sel[4];                     // DWORD 0
   BE_BIT cust_pf6_id_sel[4];                     // DWORD 0
   BE_BIT cust_pf7_id_sel[4];                     // DWORD 0
} SG_PACK BE_CUST_PF_PCICFG_ID_SEL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_PCICFG_ID_SEL_CSR_V2_AMAP, *PCUST_PF_PCICFG_ID_SEL_CSR_V2_AMAP;


typedef struct {
   BE_BIT sli4_if_type[16];                       // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_SLI4_IF_TYPE_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_SLI4_IF_TYPE_CSR_V2_AMAP, *PVF_PCICFG_SLI4_IF_TYPE_CSR_V2_AMAP;


typedef struct {
   BE_BIT tph_req_en_change_intr[32];             // DWORD 0
} SG_PACK BE_VF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2_AMAP, *PVF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2_AMAP;


typedef struct {
   BE_BIT ats_en_change_intr[32];                 // DWORD 0
} SG_PACK BE_VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2_AMAP, *PVF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2_AMAP;


typedef struct {
   BE_BIT req_bits[32];                           // DWORD 0
} SG_PACK BE_VF_PCICFG_VF_VPD_REQ_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_VF_VPD_REQ_CSR_V2_AMAP, *PVF_PCICFG_VF_VPD_REQ_CSR_V2_AMAP;


typedef struct {
   BE_BIT bmen_state_change[32];                  // DWORD 0
} SG_PACK BE_VF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2_AMAP, *PVF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2_AMAP;


typedef struct {
   BE_BIT bme[32];                                // DWORD 0
} SG_PACK BE_VF_PCICFG_BME_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_BME_CSR_V2_AMAP, *PVF_PCICFG_BME_CSR_V2_AMAP;


typedef struct {
   BE_BIT ats_en[32];                             // DWORD 0
} SG_PACK BE_VF_PCICFG_PF_ATS_EN_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PF_ATS_EN_CSR_V2_AMAP, *PVF_PCICFG_PF_ATS_EN_CSR_V2_AMAP;


typedef struct {
   BE_BIT bmen_state_change;                      // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT tph_disable;                            // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_CUST_PF_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP, *PCUST_PF_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP;


typedef struct {
   BE_BIT next_pf_num[32];                        // DWORD 0
} SG_PACK BE_CUST_PF_NEXT_PFNUM_REG0_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_NEXT_PFNUM_REG0_V2_AMAP, *PCUST_PF_NEXT_PFNUM_REG0_V2_AMAP;


typedef struct {
   BE_BIT next_pf_num[32];                        // DWORD 0
} SG_PACK BE_CUST_PF_NEXT_PFNUM_REG1_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_NEXT_PFNUM_REG1_V2_AMAP, *PCUST_PF_NEXT_PFNUM_REG1_V2_AMAP;


typedef struct {
   BE_BIT next_pf_valid[16];                      // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_CUST_PF_NEXT_PFNUM_VALID_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_NEXT_PFNUM_VALID_V2_AMAP, *PCUST_PF_NEXT_PFNUM_VALID_V2_AMAP;


typedef struct {
   BE_BIT bmen_state_change;                      // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT tph_disable;                            // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP, *PVF_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP;


typedef struct {
   BE_BIT bmen_state_change;                      // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT sliport_error2;                         // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_HOST_INT_STATUS2_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_HOST_INT_STATUS2_CSR_V2_AMAP, *PVF_PCICFG_HOST_INT_STATUS2_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT err_a;                                  // DWORD 0
   BE_BIT err_b;                                  // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
   BE_BIT FLR_intr;                               // DWORD 0
   BE_BIT ats_en_change_intr;                     // DWORD 0
   BE_BIT rsvd3[4];                               // DWORD 0
   BE_BIT tph_req_en_change_intr;                 // DWORD 0
   BE_BIT rsvd4[2];                               // DWORD 0
   BE_BIT rsvd5[16];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_HOST_INT_STATUS_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_HOST_INT_STATUS_CSR_V2_AMAP, *PVF_PCICFG_HOST_INT_STATUS_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT err_a;                                  // DWORD 0
   BE_BIT err_b;                                  // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT rsvd3;                                  // DWORD 0
   BE_BIT FLR_intr;                               // DWORD 0
   BE_BIT ats_en_change_intr;                     // DWORD 0
   BE_BIT rsvd4[5];                               // DWORD 0
   BE_BIT tph_req_en_change_intr;                 // DWORD 0
   BE_BIT rsvd5;                                  // DWORD 0
   BE_BIT rsvd6[16];                              // DWORD 0
} SG_PACK BE_CUST_PF_PCICFG_HOST_INT_MASK_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_PCICFG_HOST_INT_MASK_CSR_V2_AMAP, *PCUST_PF_PCICFG_HOST_INT_MASK_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT err_a;                                  // DWORD 0
   BE_BIT err_b;                                  // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT rsvd3;                                  // DWORD 0
   BE_BIT FLR_intr;                               // DWORD 0
   BE_BIT ats_en_change_intr;                     // DWORD 0
   BE_BIT rsvd4[5];                               // DWORD 0
   BE_BIT tph_req_en_change_intr;                 // DWORD 0
   BE_BIT rsvd5;                                  // DWORD 0
   BE_BIT rsvd6[16];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_HOST_INT_MASK_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_HOST_INT_MASK_CSR_V2_AMAP, *PVF_PCICFG_HOST_INT_MASK_CSR_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_CUST_PF_PCIE_ARI_ENHANCED_CAP_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_PCIE_ARI_ENHANCED_CAP_V2_AMAP, *PCUST_PF_PCIE_ARI_ENHANCED_CAP_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_VF_PCIE_ARI_ENHANCED_CAP_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCIE_ARI_ENHANCED_CAP_V2_AMAP, *PVF_PCIE_ARI_ENHANCED_CAP_V2_AMAP;


typedef struct {
   BE_BIT mfvc_fg_capability;                     // DWORD 0
   BE_BIT acs_fg_capability;                      // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT next_fun_num[8];                        // DWORD 0
   BE_BIT rsvd1[16];                              // DWORD 0
} SG_PACK BE_VF_PCIE_ARI_CAPABILITY_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCIE_ARI_CAPABILITY_V2_AMAP, *PVF_PCIE_ARI_CAPABILITY_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_CUST_PF_PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP, *PCUST_PF_PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_VF_PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP, *PVF_PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP;


typedef struct {
   BE_BIT slnum_low[32];                          // DWORD 0
} SG_PACK BE_VF_PCIE_DEV_SERIAL_NUM_LOW_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCIE_DEV_SERIAL_NUM_LOW_V2_AMAP, *PVF_PCIE_DEV_SERIAL_NUM_LOW_V2_AMAP;


typedef struct {
   BE_BIT slnum_high[32];                         // DWORD 0
} SG_PACK BE_VF_PCIE_DEV_SERIAL_NUM_HIGH_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCIE_DEV_SERIAL_NUM_HIGH_V2_AMAP, *PVF_PCIE_DEV_SERIAL_NUM_HIGH_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_VF_PCIE_TPH_REQ_CAP_HDR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCIE_TPH_REQ_CAP_HDR_V2_AMAP, *PVF_PCIE_TPH_REQ_CAP_HDR_V2_AMAP;


typedef struct {
   BE_BIT no_st_mode;                             // DWORD 0
   BE_BIT intr_vec_mode;                          // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT rsvd1[6];                               // DWORD 0
   BE_BIT st_tbl_loc[2];                          // DWORD 0
   BE_BIT rsvd2[5];                               // DWORD 0
   BE_BIT st_tbl_size[11];                        // DWORD 0
   BE_BIT rsvd3[5];                               // DWORD 0
} SG_PACK BE_VF_PCIE_TPH_CAPABILITY_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCIE_TPH_CAPABILITY_V2_AMAP, *PVF_PCIE_TPH_CAPABILITY_V2_AMAP;


typedef struct {
   BE_BIT st_mode_sel[3];                         // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT tph_req_enable[2];                      // DWORD 0
   BE_BIT rsvd1[22];                              // DWORD 0
} SG_PACK BE_VF_PCIE_TPH_CONTROL_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCIE_TPH_CONTROL_V2_AMAP, *PVF_PCIE_TPH_CONTROL_V2_AMAP;


typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_VF_PCIE_ATS_ENHANCED_CAP_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCIE_ATS_ENHANCED_CAP_V2_AMAP, *PVF_PCIE_ATS_ENHANCED_CAP_V2_AMAP;


typedef struct {
   BE_BIT inval_queue_depth[5];                   // DWORD 0
   BE_BIT page_align_request;                     // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
   BE_BIT stu[5];                                 // DWORD 0
   BE_BIT rsvd1[10];                              // DWORD 0
   BE_BIT ats_en;                                 // DWORD 0
} SG_PACK BE_CUST_PF_PCIE_ATS_CAPABILITY_V2_AMAP;
typedef struct { u32 dw[1]; } CUST_PF_PCIE_ATS_CAPABILITY_V2_AMAP, *PCUST_PF_PCIE_ATS_CAPABILITY_V2_AMAP;


typedef struct {
   BE_BIT inval_queue_depth[5];                   // DWORD 0
   BE_BIT page_align_request;                     // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
   BE_BIT stu[5];                                 // DWORD 0
   BE_BIT rsvd1[10];                              // DWORD 0
   BE_BIT ats_en;                                 // DWORD 0
} SG_PACK BE_VF_PCIE_ATS_CAPABILITY_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCIE_ATS_CAPABILITY_V2_AMAP, *PVF_PCIE_ATS_CAPABILITY_V2_AMAP;


typedef struct {
   BE_BIT pmcapid[8];                             // DWORD 0
   BE_BIT pmnextptr[8];                           // DWORD 0
   BE_BIT version[3];                             // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT dsi;                                    // DWORD 0
   BE_BIT aux_current[3];                         // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT rsvd3;                                  // DWORD 0
   BE_BIT rsvd4[5];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_PMC_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PMC_CSR_V2_AMAP, *PVF_PCICFG_PMC_CSR_V2_AMAP;


typedef struct {
   BE_BIT pwr_state[2];                           // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT device_specific;                        // DWORD 0
   BE_BIT rsvd1[4];                               // DWORD 0
   BE_BIT rsvd2[24];                              // DWORD 0
} SG_PACK BE_VF_PCICFG_PM_CONTROL_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PM_CONTROL_V2_AMAP, *PVF_PCICFG_PM_CONTROL_V2_AMAP;


typedef struct {
   BE_BIT mask;                                   // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT st_lower[8];                            // DWORD 0
   BE_BIT st_upper[8];                            // DWORD 0
} SG_PACK BE_VF_PCICFG_MSIX_VECTOR_CONTROL_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_MSIX_VECTOR_CONTROL_CSR_V2_AMAP, *PVF_PCICFG_MSIX_VECTOR_CONTROL_CSR_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_MSIX_MSG_DATA_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_MSIX_MSG_DATA_CSR_V2_AMAP, *PVF_PCICFG_MSIX_MSG_DATA_CSR_V2_AMAP;


typedef struct {
   BE_BIT addr[32];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_MSIX_MSG_ADDR_HI_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_MSIX_MSG_ADDR_HI_CSR_V2_AMAP, *PVF_PCICFG_MSIX_MSG_ADDR_HI_CSR_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT addr[30];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_MSIX_MSG_ADDR_LO_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_MSIX_MSG_ADDR_LO_CSR_V2_AMAP, *PVF_PCICFG_MSIX_MSG_ADDR_LO_CSR_V2_AMAP;


typedef struct {
   BE_BIT pba[32];                                // DWORD 0
} SG_PACK BE_VF_PCICFG_MSIX_PBA_STRUCT_CSR_V2_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_MSIX_PBA_STRUCT_CSR_V2_AMAP, *PVF_PCICFG_MSIX_PBA_STRUCT_CSR_V2_AMAP;


typedef struct {
   BE_VF_PCICFG_ID_CSR_V2_AMAP id;
   BE_CUST_PCICFG_COMMAND_STATUS_CSR_V2_AMAP cmd_status;
   BE_VF_PCICFG_CLASS_REV_CSR_V2_AMAP class_rev;
   BE_VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2_AMAP cache;
   BE_CUST_PCICFG_MEMBAR0_LO_CSR_V2_AMAP membar0_lo;
   BE_CUST_PCICFG_MEMBAR0_HI_CSR_V2_AMAP membar0_hi;
   BE_BIT rsvd0[128];                             // DWORD 6
   BE_BIT rsvd1[32];                              // DWORD 10
   BE_VF_PCICFG_SUBSYSTEM_ID_CSR_V2_AMAP subsystem_id;
   BE_BIT rsvd2[32];                              // DWORD 12
   BE_VF_PCICFG_CAP_CSR_V2_AMAP cap;
   BE_BIT rsvd3[32];                              // DWORD 14
   BE_CUST_PF_PCICFG_LATENCY_INT_CSR_V2_AMAP latency_int;
   BE_VF_PCICFG_PMC_CSR_V2_AMAP pmc;
   BE_VF_PCICFG_PM_CONTROL_V2_AMAP pm_control;
   BE_VF_PCICFG_MSIX_CSR_V2_AMAP msix;
   BE_VF_PCICFG_MSIX_TABLE_CSR_V2_AMAP msix_table_offset;
   BE_VF_PCICFG_MSIX_PBA_CSR_V2_AMAP msix_pba_offset;
   BE_BIT rsvd4[32];                              // DWORD 21
   BE_BIT rsvd5[32];                              // DWORD 22
   BE_BIT rsvd6[288];                             // DWORD 23
   BE_BIT rsvd7[448];                             // DWORD 32
   BE_VF_PCICFG_VPD_CAP_CSR_V2_AMAP vpd_cap;
   BE_VF_PCICFG_VPD_DATA_CSR_V2_AMAP vpd_data;
   BE_VF_PCICFG_PCIE_CAP_CSR_V2_AMAP pcie_cap;
   BE_VF_PCICFG_PCIE_DEVCAP_CSR_V2_AMAP pcie_devcap;
   BE_VF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2_AMAP pcie_control_status;
   BE_VF_PCICFG_PCIE_LINK_CAP_CSR_V2_AMAP pcie_link_cap;
   BE_CUST_PF_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP pcie_link_status;
   BE_VF_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros[4];
   BE_VF_PCICFG_PCIE_DEVCAP2_CSR_V2_AMAP pcie_devcap2;
   BE_CUST_PF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP pcie_control_status2;
   BE_VF_PCICFG_PCIE_LINK_CAP2_CSR_V2_AMAP pcie_link_cap2;
   BE_CUST_PF_PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP pcie_link_status2;
   BE_VF_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros_1[2];
   BE_VF_PCICFG_INT_CTRL_FUNCTION_NUM_V2_AMAP host_int_ctrl_vf_fnum;
   BE_CUST_PF_PCIE_ARI_ENHANCED_CAP_V2_AMAP pcie_ari_enhanced_hdr;
   BE_VF_PCIE_ARI_CAPABILITY_V2_AMAP pcie_ari_capability;
   BE_BIT rsvd8[288];                             // DWORD 66
   BE_VF_PCIE_TPH_REQ_CAP_HDR_V2_AMAP pcie_tph_req_caphdr;
   BE_VF_PCIE_TPH_CAPABILITY_V2_AMAP pcie_tph_capability;
   BE_VF_PCIE_TPH_CONTROL_V2_AMAP pcie_tph_control;
   BE_BIT rsvd9[96];                              // DWORD 78
   BE_VF_PCIE_ATS_ENHANCED_CAP_V2_AMAP pcie_ats_enhanced_hdr;
   BE_CUST_PF_PCIE_ATS_CAPABILITY_V2_AMAP pcie_ats_capability;
   BE_BIT rsvd10[224];                            // DWORD 83
   BE_CUST_PF_PCIE_DEV_SERIAL_CAP_HDR_V2_AMAP pcie_device_serial_hdr;
   BE_VF_PCIE_DEV_SERIAL_NUM_LOW_V2_AMAP pcie_device_serial_number_low;
   BE_VF_PCIE_DEV_SERIAL_NUM_HIGH_V2_AMAP pcie_device_serial_number_high;
   BE_VF_PCICFG_HOST_INT_STATUS_CSR_V2_AMAP host_int_status;
   BE_CUST_PF_PCICFG_HOST_INT_MASK_CSR_V2_AMAP host_int_mask;
   BE_VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2_AMAP host_pf_vf_ats_en_int;
   BE_VF_PCICFG_PF_VF_FLR_INT_CSR_V2_AMAP host_pf_vf_flr_int;
   BE_VF_PCICFG_PF_VF_ERR_A_INT_CSR_V2_AMAP host_pf_vf_err_a_int;
   BE_VF_PCICFG_PF_VF_ERR_B_INT_CSR_V2_AMAP host_pf_vf_err_b_int;
   BE_VF_PCICFG_VF_VPD_REQ_CSR_V2_AMAP host_pf_vf_vpd_req;
   BE_VF_PCICFG_BME_CSR_V2_AMAP host_pf_vf_bme;
   BE_VF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2_AMAP host_pf_vf_tph_req_en_int;
   BE_CUST_PF_PCICFG_ID_SEL_CSR_V2_AMAP id_sel[2];
   BE_VF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2_AMAP host_pf_vf_bmen_state_change_int;
   BE_BIT rsvd11[576];                            // DWORD 105
   BE_VF_PCICFG_SCRATCHPAD_CSR_V2_AMAP scratchpad;
   BE_BIT rsvd12[128];                            // DWORD 124
   BE_VF_PCICFG_FUNCTION_IDENTIFIER_V2_AMAP func_id;
   BE_BIT rsvd13[2016];                           // DWORD 129
   BE_BIT rsvd14[352];                            // DWORD 192
   BE_VF_PCICFG_HOST_INT_STATUS2_CSR_V2_AMAP host_int_status2;
   BE_CUST_PF_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP host_int_mask2;
   BE_CUST_PF_NEXT_PFNUM_REG0_V2_AMAP next_pfnum0;
   BE_CUST_PF_NEXT_PFNUM_REG1_V2_AMAP next_pfnum1;
   BE_CUST_PF_NEXT_PFNUM_VALID_V2_AMAP next_pf_valid;
   BE_BIT rsvd15[1536];                           // DWORD 208
   BE_BIT rsvd16[24576];                          // DWORD 256
} SG_PACK BE_CUST_PF_PCICFG_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } CUST_PF_PCICFG_CSRMAP_V2_AMAP, *PCUST_PF_PCICFG_CSRMAP_V2_AMAP;


typedef struct {
   BE_VF_PCICFG_ID_CSR_V2_AMAP id;
   BE_VF_PCICFG_COMMAND_STATUS_CSR_V2_AMAP cmd_status;
   BE_VF_PCICFG_CLASS_REV_CSR_V2_AMAP class_rev;
   BE_VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2_AMAP cache;
   BE_BIT rsvd0[192];                             // DWORD 4
   BE_BIT rsvd1[32];                              // DWORD 10
   BE_VF_PCICFG_SUBSYSTEM_ID_CSR_V2_AMAP subsystem_id;
   BE_BIT rsvd2[32];                              // DWORD 12
   BE_VF_PCICFG_CAP_CSR_V2_AMAP cap;
   BE_BIT rsvd3[32];                              // DWORD 14
   BE_BIT rsvd4[32];                              // DWORD 15
   BE_VF_PCICFG_PMC_CSR_V2_AMAP pmc;
   BE_VF_PCICFG_PM_CONTROL_V2_AMAP pm_control;
   BE_VF_PCICFG_MSIX_CSR_V2_AMAP msix;
   BE_VF_PCICFG_MSIX_TABLE_CSR_V2_AMAP msix_table_offset;
   BE_VF_PCICFG_MSIX_PBA_CSR_V2_AMAP msix_pba_offset;
   BE_BIT rsvd5[32];                              // DWORD 21
   BE_BIT rsvd6[32];                              // DWORD 22
   BE_BIT rsvd7[288];                             // DWORD 23
   BE_BIT rsvd8[448];                             // DWORD 32
   BE_VF_PCICFG_VPD_CAP_CSR_V2_AMAP vpd_cap;
   BE_VF_PCICFG_VPD_DATA_CSR_V2_AMAP vpd_data;
   BE_VF_PCICFG_PCIE_CAP_CSR_V2_AMAP pcie_cap;
   BE_VF_PCICFG_PCIE_DEVCAP_CSR_V2_AMAP pcie_devcap;
   BE_VF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2_AMAP pcie_control_status;
   BE_VF_PCICFG_PCIE_LINK_CAP_CSR_V2_AMAP pcie_link_cap;
   BE_VF_PCICFG_PCIE_LINK_STATUS_CSR_V2_AMAP pcie_link_status;
   BE_VF_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros[4];
   BE_VF_PCICFG_PCIE_DEVCAP2_CSR_V2_AMAP pcie_devcap2;
   BE_VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2_AMAP pcie_control_status2;
   BE_VF_PCICFG_PCIE_LINK_CAP2_CSR_V2_AMAP pcie_link_cap2;
   BE_VF_PCICFG_PCIE_LINK_STATUS2_CSR_V2_AMAP pcie_link_status2;
   BE_VF_PCICFG_RETURN_ZEROS_V2_AMAP return_zeros_1[2];
   BE_VF_PCICFG_INT_CTRL_FUNCTION_NUM_V2_AMAP host_int_ctrl_vf_fnum;
   BE_VF_PCIE_ARI_ENHANCED_CAP_V2_AMAP pcie_ari_enhanced_hdr;
   BE_VF_PCIE_ARI_CAPABILITY_V2_AMAP pcie_ari_capability;
   BE_BIT rsvd9[288];                             // DWORD 66
   BE_VF_PCIE_TPH_REQ_CAP_HDR_V2_AMAP pcie_tph_req_caphdr;
   BE_VF_PCIE_TPH_CAPABILITY_V2_AMAP pcie_tph_capability;
   BE_VF_PCIE_TPH_CONTROL_V2_AMAP pcie_tph_control;
   BE_BIT rsvd10[96];                             // DWORD 78
   BE_VF_PCIE_ATS_ENHANCED_CAP_V2_AMAP pcie_ats_enhanced_hdr;
   BE_VF_PCIE_ATS_CAPABILITY_V2_AMAP pcie_ats_capability;
   BE_BIT rsvd11[256];                            // DWORD 83
   BE_BIT rsvd12[64];                             // DWORD 91
   BE_VF_PCICFG_HOST_INT_STATUS_CSR_V2_AMAP host_int_status;
   BE_VF_PCICFG_HOST_INT_MASK_CSR_V2_AMAP host_int_mask;
   BE_VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2_AMAP host_pf_vf_ats_en_int;
   BE_VF_PCICFG_PF_VF_FLR_INT_CSR_V2_AMAP host_pf_vf_flr_int;
   BE_VF_PCICFG_PF_VF_ERR_A_INT_CSR_V2_AMAP host_pf_vf_err_a_int;
   BE_VF_PCICFG_PF_VF_ERR_B_INT_CSR_V2_AMAP host_pf_vf_err_b_int;
   BE_VF_PCICFG_VF_VPD_REQ_CSR_V2_AMAP host_pf_vf_vpd_req;
   BE_VF_PCICFG_BME_CSR_V2_AMAP host_pf_vf_bme;
   BE_VF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2_AMAP host_pf_vf_tph_req_en_int;
   BE_BIT rsvd13[64];                             // DWORD 102
   BE_VF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2_AMAP host_pf_vf_bmen_state_change_int;
   BE_BIT rsvd14[544];                            // DWORD 105
   BE_VF_PCICFG_SLI4_IF_TYPE_CSR_V2_AMAP vf_sli4_if_type;
   BE_VF_PCICFG_SCRATCHPAD_CSR_V2_AMAP scratchpad;
   BE_VF_MSITBL_SIZE_CSR_V2_AMAP msixtbl_size;
   BE_BIT rsvd15[96];                             // DWORD 125
   BE_VF_PCICFG_FUNCTION_IDENTIFIER_V2_AMAP func_id;
   BE_BIT rsvd16[2016];                           // DWORD 129
   BE_BIT rsvd17[352];                            // DWORD 192
   BE_VF_PCICFG_HOST_INT_STATUS2_CSR_V2_AMAP host_int_status2;
   BE_VF_PCICFG_HOST_INT_MASK2_CSR_V2_AMAP host_int_mask2;
   BE_BIT rsvd18[1632];                           // DWORD 205
   BE_BIT rsvd19[24576];                          // DWORD 256
} SG_PACK BE_VF_PCICFG_CSRMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } VF_PCICFG_CSRMAP_V2_AMAP, *PVF_PCICFG_CSRMAP_V2_AMAP;


typedef struct {
   BE_VF_PCICFG_CSRMAP_V2_AMAP pf_8vfs[8];
} SG_PACK BE_VF_PCICFG_CSRMAP_PF_8VF_V2_AMAP;
typedef struct { u32 dw[8192]; } VF_PCICFG_CSRMAP_PF_8VF_V2_AMAP, *PVF_PCICFG_CSRMAP_PF_8VF_V2_AMAP;


typedef struct {
   BE_CUST_PF_PCICFG_CSRMAP_V2_AMAP cust_8pfs[8];
} SG_PACK BE_CUST_PF_PCICFG_CSRMAP_8PF_V2_AMAP;
typedef struct { u32 dw[8192]; } CUST_PF_PCICFG_CSRMAP_8PF_V2_AMAP, *PCUST_PF_PCICFG_CSRMAP_8PF_V2_AMAP;


typedef struct {
   BE_BIT va_hi[32];                              // DWORD 0
   BE_BIT va_lo[32];                              // DWORD 1
   BE_BIT key[32];                                // DWORD 2
   BE_BIT length[32];                             // DWORD 3
} SG_PACK BE_ROCE_TX_SGE_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_TX_SGE_V2_AMAP, *PROCE_TX_SGE_V2_AMAP;


typedef struct {
   BE_BIT dest_qp_no[24];                         // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT QKey[32];                               // DWORD 1
   BE_BIT addr_handle_id[32];                     // DWORD 2
   BE_BIT rsvd1[32];                              // DWORD 3
} SG_PACK BE_ROCE_UD_FIRST_SGE_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_UD_FIRST_SGE_V2_AMAP, *PROCE_UD_FIRST_SGE_V2_AMAP;


typedef struct {
   BE_BIT opcode[5];                              // DWORD 0
   BE_BIT flags[11];                              // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT posting_size[7];                        // DWORD 0
   BE_BIT next_posting_size[7];                   // DWORD 0
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_BIT memkey_or_imm_data[32];                 // DWORD 2
   BE_BIT total_byte_count[32];                   // DWORD 3
} SG_PACK BE_ROCE_RC_TX_CONTROL_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_RC_TX_CONTROL_V2_AMAP, *PROCE_RC_TX_CONTROL_V2_AMAP;


typedef struct {
   BE_ROCE_RC_TX_CONTROL_V2_AMAP control;
   BE_ROCE_TX_SGE_V2_AMAP remote_address;
   BE_ROCE_TX_SGE_V2_AMAP sge[2];
} SG_PACK BE_ROCE_RC_OPERATION_RDMA_WRITE_V2_AMAP;
typedef struct { u32 dw[16]; } ROCE_RC_OPERATION_RDMA_WRITE_V2_AMAP, *PROCE_RC_OPERATION_RDMA_WRITE_V2_AMAP;


typedef struct {
   BE_ROCE_RC_TX_CONTROL_V2_AMAP control;
   BE_ROCE_TX_SGE_V2_AMAP remote_address;
   BE_ROCE_TX_SGE_V2_AMAP sge[2];
} SG_PACK BE_ROCE_RC_OPERATION_READ_REQ_V2_AMAP;
typedef struct { u32 dw[16]; } ROCE_RC_OPERATION_READ_REQ_V2_AMAP, *PROCE_RC_OPERATION_READ_REQ_V2_AMAP;


typedef struct {
   BE_ROCE_RC_TX_CONTROL_V2_AMAP control;
   BE_ROCE_TX_SGE_V2_AMAP local_address;
} SG_PACK BE_ROCE_RC_OPERATION_READ_RESP_V2_AMAP;
typedef struct { u32 dw[8]; } ROCE_RC_OPERATION_READ_RESP_V2_AMAP, *PROCE_RC_OPERATION_READ_RESP_V2_AMAP;


typedef struct {
   BE_ROCE_RC_TX_CONTROL_V2_AMAP control;
   BE_ROCE_TX_SGE_V2_AMAP sge[3];
} SG_PACK BE_ROCE_RC_OPERATION_SEND_V2_AMAP;
typedef struct { u32 dw[16]; } ROCE_RC_OPERATION_SEND_V2_AMAP, *PROCE_RC_OPERATION_SEND_V2_AMAP;


typedef struct {
   BE_ROCE_RC_TX_CONTROL_V2_AMAP control;
   BE_ROCE_TX_SGE_V2_AMAP local_address;
} SG_PACK BE_ROCE_RC_OPERATION_BIND_MEMORY_WINDOW_V2_AMAP;
typedef struct { u32 dw[8]; } ROCE_RC_OPERATION_BIND_MEMORY_WINDOW_V2_AMAP, *PROCE_RC_OPERATION_BIND_MEMORY_WINDOW_V2_AMAP;


typedef struct {
   BE_ROCE_RC_TX_CONTROL_V2_AMAP control;
} SG_PACK BE_ROCE_RC_OPERATION_FAST_REGISTER_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_RC_OPERATION_FAST_REGISTER_V2_AMAP, *PROCE_RC_OPERATION_FAST_REGISTER_V2_AMAP;


typedef struct {
   BE_ROCE_RC_TX_CONTROL_V2_AMAP control;
} SG_PACK BE_ROCE_RC_OPERATION_LOCAL_INVALIDATE_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_RC_OPERATION_LOCAL_INVALIDATE_V2_AMAP, *PROCE_RC_OPERATION_LOCAL_INVALIDATE_V2_AMAP;


typedef struct {
   BE_BIT opcode[4];                              // DWORD 0
   BE_BIT flags[10];                              // DWORD 0
   BE_BIT next_length[5];                         // DWORD 0
   BE_BIT type[3];                                // DWORD 0
   BE_BIT num_words[5];                           // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT address_handle[32];                     // DWORD 1
   BE_BIT immediate_data[32];                     // DWORD 2
   BE_BIT total_byte_count[32];                   // DWORD 3
   BE_BIT remote_qpn[24];                         // DWORD 4
   BE_BIT rsvd1[8];                               // DWORD 4
   BE_BIT remote_qkey[32];                        // DWORD 5
   BE_BIT rsvd2[64];                              // DWORD 6
} SG_PACK BE_ROCE_UD_TX_CONTROL_V2_AMAP;
typedef struct { u32 dw[8]; } ROCE_UD_TX_CONTROL_V2_AMAP, *PROCE_UD_TX_CONTROL_V2_AMAP;


typedef struct {
   BE_ROCE_UD_TX_CONTROL_V2_AMAP control;
   BE_ROCE_TX_SGE_V2_AMAP sge[2];
} SG_PACK BE_ROCE_UD_OPERATION_SEND_V2_AMAP;
typedef struct { u32 dw[16]; } ROCE_UD_OPERATION_SEND_V2_AMAP, *PROCE_UD_OPERATION_SEND_V2_AMAP;


typedef struct {
   BE_BIT wqe_index[16];                          // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT bytes_transferred[32];                  // DWORD 1
   BE_BIT qpn[16];                                // DWORD 2
   BE_BIT rsvd1[16];                              // DWORD 2
   BE_BIT rsvd2[16];                              // DWORD 3
   BE_BIT status[8];                              // DWORD 3
   BE_BIT rsvd3[5];                               // DWORD 3
   BE_BIT q;                                      // DWORD 3
   BE_BIT rsvd4;                                  // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_ROCE_TX_CQE_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_TX_CQE_V2_AMAP, *PROCE_TX_CQE_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_BIT qpn[16];                                // DWORD 2
   BE_BIT wqe_index[16];                          // DWORD 2
   BE_BIT cc[2];                                  // DWORD 3
   BE_BIT rsvd2[14];                              // DWORD 3
   BE_BIT status[8];                              // DWORD 3
   BE_BIT rsvd3[7];                               // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_ROCE_TX_UD_CQE_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_TX_UD_CQE_V2_AMAP, *PROCE_TX_UD_CQE_V2_AMAP;


typedef struct {
   BE_BIT valid;                                  // DWORD 0
   BE_BIT rsvd0[7];                               // DWORD 0
   BE_BIT qpn[24];                                // DWORD 0
   BE_BIT dpp_count[32];                          // DWORD 1
   BE_BIT rsvd1[64];                              // DWORD 2
} SG_PACK BE_ROCE_DPP_CQE_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_DPP_CQE_V2_AMAP, *PROCE_DPP_CQE_V2_AMAP;


typedef struct {
   BE_BIT Opcode[4];                              // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
   BE_BIT NumCont[7];                             // DWORD 0
   BE_BIT rsvd1[7];                               // DWORD 0
   BE_BIT Tag[16];                                // DWORD 1
   BE_BIT rsvd2[16];                              // DWORD 1
   BE_BIT rsvd3[32];                              // DWORD 2
   BE_BIT rsvd4[32];                              // DWORD 3
} SG_PACK BE_ROCE_RX_CONTROL_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_RX_CONTROL_V2_AMAP, *PROCE_RX_CONTROL_V2_AMAP;


typedef struct {
   BE_ROCE_RX_CONTROL_V2_AMAP control;
   BE_ROCE_TX_SGE_V2_AMAP sge[3];
} SG_PACK BE_ROCE_RX_WQE_V2_AMAP;
typedef struct { u32 dw[16]; } ROCE_RX_WQE_V2_AMAP, *PROCE_RX_WQE_V2_AMAP;


typedef struct {
   BE_BIT immed_data[32];                         // DWORD 0
   BE_BIT bytes_transferred[32];                  // DWORD 1
   BE_BIT qp_id[16];                              // DWORD 2
   BE_BIT srq_buff_tag[16];                       // DWORD 2
   BE_BIT srq_buff_tag_fw[16];                    // DWORD 3
   BE_BIT status[8];                              // DWORD 3
   BE_BIT rsvd0[3];                               // DWORD 3
   BE_BIT w;                                      // DWORD 3
   BE_BIT i;                                      // DWORD 3
   BE_BIT q;                                      // DWORD 3
   BE_BIT s;                                      // DWORD 3
   BE_BIT v;                                      // DWORD 3
} SG_PACK BE_ROCE_RX_COMPL_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_RX_COMPL_V2_AMAP, *PROCE_RX_COMPL_V2_AMAP;


typedef struct {
   BE_BIT immed_data[32];                         // DWORD 0
   BE_BIT pkey[16];                               // DWORD 1
   BE_BIT bytes_transferred[16];                  // DWORD 1
   BE_BIT qp_id[16];                              // DWORD 2
   BE_BIT srq_buff_tag[16];                       // DWORD 2
   BE_BIT src_qp_id[24];                          // DWORD 3
   BE_BIT status[3];                              // DWORD 3
   BE_BIT w;                                      // DWORD 3
   BE_BIT i;                                      // DWORD 3
   BE_BIT q;                                      // DWORD 3
   BE_BIT s;                                      // DWORD 3
   BE_BIT v;                                      // DWORD 3
} SG_PACK BE_ROCE_RX_UD_COMPL_V2_AMAP;
typedef struct { u32 dw[4]; } ROCE_RX_UD_COMPL_V2_AMAP, *PROCE_RX_UD_COMPL_V2_AMAP;


typedef struct {
   BE_BIT wr_start;                               // DWORD 0
   BE_BIT wr_len[8];                              // DWORD 0
   BE_BIT rsvd0[23];                              // DWORD 0
} SG_PACK BE_ROCE_FP_DATA_HEADER_V2_AMAP;
typedef struct { u32 dw[1]; } ROCE_FP_DATA_HEADER_V2_AMAP, *PROCE_FP_DATA_HEADER_V2_AMAP;


typedef struct {
   BE_BIT opcode[5];                              // DWORD 0
   BE_BIT flags[11];                              // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT posting_size[7];                        // DWORD 0
   BE_BIT next_posting_size[7];                   // DWORD 0
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_BIT memkey_or_imm_data[32];                 // DWORD 2
   BE_BIT total_byte_count[32];                   // DWORD 3
} SG_PACK BE_LL_ROCE_HDR_WRB_V2_AMAP;
typedef struct { u32 dw[4]; } LL_ROCE_HDR_WRB_V2_AMAP, *PLL_ROCE_HDR_WRB_V2_AMAP;


typedef struct {
   BE_BIT dst_mac_hi[32];                         // DWORD 0
   BE_BIT src_mac_hi[16];                         // DWORD 1
   BE_BIT dst_mac_lo[16];                         // DWORD 1
   BE_BIT src_mac_lo[32];                         // DWORD 2
   BE_BIT flow_label_hi[4];                       // DWORD 3
   BE_BIT traffic_class[8];                       // DWORD 3
   BE_BIT ip_ver[4];                              // DWORD 3
   BE_BIT eth_type[16];                           // DWORD 3
   BE_BIT payload_len[16];                        // DWORD 4
   BE_BIT flow_label_lo[16];                      // DWORD 4
   BE_BIT sgid0[16];                              // DWORD 5
   BE_BIT hop_limit[8];                           // DWORD 5
   BE_BIT nxt_header[8];                          // DWORD 5
   BE_BIT sgid1[32];                              // DWORD 6
   BE_BIT sgid2[32];                              // DWORD 7
   BE_BIT sgid3[32];                              // DWORD 8
   BE_BIT dgid0[16];                              // DWORD 9
   BE_BIT sgid4[16];                              // DWORD 9
   BE_BIT dgid1[32];                              // DWORD 10
   BE_BIT dgid2[32];                              // DWORD 11
   BE_BIT dgid3[32];                              // DWORD 12
   BE_BIT rsvd0[16];                              // DWORD 13
   BE_BIT dgid4[16];                              // DWORD 13
   BE_BIT rsvd1[32];                              // DWORD 14
   BE_BIT rsvd2[31];                              // DWORD 15
   BE_BIT valid;                                  // DWORD 15
} SG_PACK BE_ROCE_AHR_ENTRY_V2_AMAP;
typedef struct { u32 dw[16]; } ROCE_AHR_ENTRY_V2_AMAP, *PROCE_AHR_ENTRY_V2_AMAP;


typedef struct {
   BE_BIT dst_mac_hi[32];                         // DWORD 0
   BE_BIT src_mac_hi[16];                         // DWORD 1
   BE_BIT dst_mac_lo[16];                         // DWORD 1
   BE_BIT src_mac_lo[32];                         // DWORD 2
   BE_BIT eth_type1[16];                          // DWORD 3
   BE_BIT vlan_id[16];                            // DWORD 3
   BE_BIT flow_label_hi[4];                       // DWORD 4
   BE_BIT traffic_class[8];                       // DWORD 4
   BE_BIT ip_ver[4];                              // DWORD 4
   BE_BIT eth_type2[16];                          // DWORD 4
   BE_BIT payload_len[16];                        // DWORD 5
   BE_BIT flow_label_lo[16];                      // DWORD 5
   BE_BIT sgid0[16];                              // DWORD 6
   BE_BIT hop_limit[8];                           // DWORD 6
   BE_BIT nxt_header[8];                          // DWORD 6
   BE_BIT sgid1[32];                              // DWORD 7
   BE_BIT sgid2[32];                              // DWORD 8
   BE_BIT sgid3[32];                              // DWORD 9
   BE_BIT dgid0[16];                              // DWORD 10
   BE_BIT sgid4[16];                              // DWORD 10
   BE_BIT dgid1[32];                              // DWORD 11
   BE_BIT dgid2[32];                              // DWORD 12
   BE_BIT dgid3[32];                              // DWORD 13
   BE_BIT rsvd0[16];                              // DWORD 14
   BE_BIT dgid4[16];                              // DWORD 14
   BE_BIT rsvd1[31];                              // DWORD 15
   BE_BIT valid;                                  // DWORD 15
} SG_PACK BE_ROCE_AHR_ENTRY2_V2_AMAP;
typedef struct { u32 dw[16]; } ROCE_AHR_ENTRY2_V2_AMAP, *PROCE_AHR_ENTRY2_V2_AMAP;


typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_GENERIC_DB_V2_AMAP;
typedef struct { u32 dw[1]; } GENERIC_DB_V2_AMAP, *PGENERIC_DB_V2_AMAP;


typedef struct {
   BE_BIT ring[16];                               // DWORD 0
   BE_BIT rsvd0[7];                               // DWORD 0
   BE_BIT kill;                                   // DWORD 0
   BE_BIT numPosted[8];                           // DWORD 0
} SG_PACK BE_ERX_DB_V2_AMAP;
typedef struct { u32 dw[1]; } ERX_DB_V2_AMAP, *PERX_DB_V2_AMAP;


typedef struct {
   BE_BIT rid[11];                                // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT numPosted[14];                          // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
} SG_PACK BE_MCC_DB_V2_AMAP;
typedef struct { u32 dw[1]; } MCC_DB_V2_AMAP, *PMCC_DB_V2_AMAP;


typedef struct {
   BE_BIT ready;                                  // DWORD 0
   BE_BIT hi;                                     // DWORD 0
   BE_BIT address[30];                            // DWORD 0
} SG_PACK BE_MPU_MAILBOX_DB_V2_AMAP;
typedef struct { u32 dw[1]; } MPU_MAILBOX_DB_V2_AMAP, *PMPU_MAILBOX_DB_V2_AMAP;


typedef struct {
   BE_BIT data0[16];                              // DWORD 0
   BE_BIT data1[16];                              // DWORD 0
} SG_PACK BE_MPU_SCRATCHPAD0_DB_V2_AMAP;
typedef struct { u32 dw[1]; } MPU_SCRATCHPAD0_DB_V2_AMAP, *PMPU_SCRATCHPAD0_DB_V2_AMAP;


typedef struct {
   BE_BIT rsvd0[16][32];                          // DWORD 0
   BE_GENERIC_DB_V2_AMAP txulp0_db;
   BE_BIT rsvd1[7][32];                           // DWORD 17
   BE_GENERIC_DB_V2_AMAP txulp1_db;
   BE_BIT rsvd2[15][32];                          // DWORD 25
   BE_GENERIC_DB_V2_AMAP rxulp0_db;
   BE_BIT rsvd3[7][32];                           // DWORD 41
   BE_GENERIC_DB_V2_AMAP rxulp1_db;
   BE_BIT rsvd4[15][32];                          // DWORD 49
   BE_ERX_DB_V2_AMAP erx_db;
   BE_BIT rsvd5[7][32];                           // DWORD 65
   BE_GENERIC_DB_V2_AMAP cq_db;
   BE_BIT rsvd6[7][32];                           // DWORD 73
   BE_MCC_DB_V2_AMAP mpu_mcc_db;
   BE_BIT rsvd7[7][32];                           // DWORD 81
   BE_MPU_MAILBOX_DB_V2_AMAP mpu_mailbox_db;
   BE_BIT rsvd8[7][32];                           // DWORD 89
   BE_MPU_SCRATCHPAD0_DB_V2_AMAP mpu_scratch0;
   BE_BIT rsvd9[15][32];                          // DWORD 97
   BE_GENERIC_DB_V2_AMAP lltxulp_db;
   BE_BIT rsvd10[911][32];                        // DWORD 113
} SG_PACK BE_PROTECTION_DOMAIN_DBMAP_V2_AMAP;
typedef struct { u32 dw[1024]; } PROTECTION_DOMAIN_DBMAP_V2_AMAP, *PPROTECTION_DOMAIN_DBMAP_V2_AMAP;


typedef struct {
   BE_BIT tcp_timestamp_val[32];                  // DWORD 0
   BE_BIT tcp_timestamp_ecr[32];                  // DWORD 1
   BE_BIT rss_flush;                              // DWORD 2
   BE_BIT rq_flush;                               // DWORD 2
   BE_BIT rsvd0;                                  // DWORD 2
   BE_BIT QnQ;                                    // DWORD 2
   BE_BIT rss_bank;                               // DWORD 2
   BE_BIT lro_timer_pop;                          // DWORD 2
   BE_BIT lro_desc;                               // DWORD 2
   BE_BIT rsvd1;                                  // DWORD 2
   BE_BIT data_offset[8];                         // DWORD 2
   BE_BIT rsvd2[2];                               // DWORD 2
   BE_BIT rss_policy[4];                          // DWORD 2
   BE_BIT debug1[7];                              // DWORD 2
   BE_BIT type[2];                                // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT rsshash[32];                            // DWORD 3
} SG_PACK BE_SH_HW_LRO_COMPL_V1_PART1_V2_AMAP;
typedef struct { u32 dw[4]; } SH_HW_LRO_COMPL_V1_PART1_V2_AMAP, *PSH_HW_LRO_COMPL_V1_PART1_V2_AMAP;


typedef struct {
   BE_BIT vlan_tag[16];                           // DWORD 0
   BE_BIT pktsize[14];                            // DWORD 0
   BE_BIT vtp;                                    // DWORD 0
   BE_BIT ip_opt;                                 // DWORD 0
   BE_BIT coalesced_size[16];                     // DWORD 1
   BE_BIT tcp_window[16];                         // DWORD 1
   BE_BIT err;                                    // DWORD 2
   BE_BIT rsshp;                                  // DWORD 2
   BE_BIT ipf;                                    // DWORD 2
   BE_BIT tcpf;                                   // DWORD 2
   BE_BIT udpf;                                   // DWORD 2
   BE_BIT ipcksm;                                 // DWORD 2
   BE_BIT l4_cksm;                                // DWORD 2
   BE_BIT ip_version;                             // DWORD 2
   BE_BIT frame_lifespan[8];                      // DWORD 2
   BE_BIT segment_count[8];                       // DWORD 2
   BE_BIT threshold;                              // DWORD 2
   BE_BIT ts_opt;                                 // DWORD 2
   BE_BIT push;                                   // DWORD 2
   BE_BIT rsvd0[2];                               // DWORD 2
   BE_BIT type_LRO[2];                            // DWORD 2
   BE_BIT valid_LRO;                              // DWORD 2
   BE_BIT tcp_ack_number[32];                     // DWORD 3
} SG_PACK BE_SH_HW_LRO_COMPL_V1_PART2_V2_AMAP;
typedef struct { u32 dw[4]; } SH_HW_LRO_COMPL_V1_PART2_V2_AMAP, *PSH_HW_LRO_COMPL_V1_PART2_V2_AMAP;


typedef struct {
   BE_BIT tcp_timestamp_val[32];                  // DWORD 0
   BE_BIT tcp_timestamp_ecr[32];                  // DWORD 1
   BE_BIT rss_flush;                              // DWORD 2
   BE_BIT rq_flush;                               // DWORD 2
   BE_BIT rsvd0;                                  // DWORD 2
   BE_BIT QnQ;                                    // DWORD 2
   BE_BIT rss_bank;                               // DWORD 2
   BE_BIT lro_timer_pop;                          // DWORD 2
   BE_BIT lro_desc;                               // DWORD 2
   BE_BIT rsvd1;                                  // DWORD 2
   BE_BIT data_offset[8];                         // DWORD 2
   BE_BIT rsvd2[2];                               // DWORD 2
   BE_BIT rss_policy[4];                          // DWORD 2
   BE_BIT debug1[7];                              // DWORD 2
   BE_BIT type[2];                                // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT rsshash[32];                            // DWORD 3
   BE_BIT vlan_tag[16];                           // DWORD 4
   BE_BIT pktsize[14];                            // DWORD 4
   BE_BIT vtp;                                    // DWORD 4
   BE_BIT ip_opt;                                 // DWORD 4
   BE_BIT coalesced_size[16];                     // DWORD 5
   BE_BIT tcp_window[16];                         // DWORD 5
   BE_BIT err;                                    // DWORD 6
   BE_BIT rsshp;                                  // DWORD 6
   BE_BIT ipf;                                    // DWORD 6
   BE_BIT tcpf;                                   // DWORD 6
   BE_BIT udpf;                                   // DWORD 6
   BE_BIT ipcksm;                                 // DWORD 6
   BE_BIT l4_cksm;                                // DWORD 6
   BE_BIT ip_version;                             // DWORD 6
   BE_BIT frame_lifespan[8];                      // DWORD 6
   BE_BIT segment_count[8];                       // DWORD 6
   BE_BIT threshold;                              // DWORD 6
   BE_BIT ts_opt;                                 // DWORD 6
   BE_BIT push;                                   // DWORD 6
   BE_BIT rsvd3[2];                               // DWORD 6
   BE_BIT type_LRO[2];                            // DWORD 6
   BE_BIT valid_LRO;                              // DWORD 6
   BE_BIT tcp_ack_number[32];                     // DWORD 7
} SG_PACK BE_SH_HW_LRO_COMPL_V1_V2_AMAP;
typedef struct { u32 dw[8]; } SH_HW_LRO_COMPL_V1_V2_AMAP, *PSH_HW_LRO_COMPL_V1_V2_AMAP;


typedef struct {
   BE_BIT vlan_tag[16];                           // DWORD 0
   BE_BIT pktsize[14];                            // DWORD 0
   BE_BIT vtp;                                    // DWORD 0
   BE_BIT ip_opt;                                 // DWORD 0
   BE_BIT err;                                    // DWORD 1
   BE_BIT rsshp;                                  // DWORD 1
   BE_BIT ipf;                                    // DWORD 1
   BE_BIT tcpf;                                   // DWORD 1
   BE_BIT udpf;                                   // DWORD 1
   BE_BIT ipcksm;                                 // DWORD 1
   BE_BIT l4_cksm;                                // DWORD 1
   BE_BIT ip_version;                             // DWORD 1
   BE_BIT rsvd0[16];                              // DWORD 1
   BE_BIT rsvd1[5];                               // DWORD 1
   BE_BIT rsvd2[2];                               // DWORD 1
   BE_BIT rsvd3;                                  // DWORD 1
   BE_BIT rss_flush;                              // DWORD 2
   BE_BIT rq_flush;                               // DWORD 2
   BE_BIT rsvd4;                                  // DWORD 2
   BE_BIT QnQ;                                    // DWORD 2
   BE_BIT rss_bank;                               // DWORD 2
   BE_BIT lro_timer_pop;                          // DWORD 2
   BE_BIT lro_desc;                               // DWORD 2
   BE_BIT rsvd5;                                  // DWORD 2
   BE_BIT data_offset[8];                         // DWORD 2
   BE_BIT rsvd6[2];                               // DWORD 2
   BE_BIT rss_policy[4];                          // DWORD 2
   BE_BIT debug1[7];                              // DWORD 2
   BE_BIT type[2];                                // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT rsshash[32];                            // DWORD 3
} SG_PACK BE_SH_HW_ERX_COMPL_V1_V2_AMAP;
typedef struct { u32 dw[4]; } SH_HW_ERX_COMPL_V1_V2_AMAP, *PSH_HW_ERX_COMPL_V1_V2_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __sh_nic_v2_amap_h__

