/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// manufacture, use,or sell anything that it may describe, in whole or in part, without   
// thespecific written consent of  EMULEX CORPORATION.  Any reproduction of thissource    
// code without the express written consent of EMULEX CORPORATION is aviolation of the    
// copyrights laws and may subject you to criminal prosecution.                           

// Autogenerated file. Do not edit!
// srcgen version: 0165
#ifndef __sh_nic_v2_bmap_h__
#define __sh_nic_v2_bmap_h__

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif


typedef struct _PHYS_ADDR_V2 {
   union {
      struct { 
         u32 lo;                                  // DWORD 0
         u32 hi;                                  // DWORD 1
      } SG_PACK ; // unnamed struct
      u32 dw[2]; // dword union
   }; // unnamed union
} SG_PACK PHYS_ADDR_V2, *PPHYS_ADDR_V2;

SG_C_ASSERT(__sizeof__PHYS_ADDR, sizeof (PHYS_ADDR_V2) == 8);


// --- IOCTL_SUBSYSTEMS ---
#define IOCTL_SUBSYSTEM_RSVD_V2         (0)       
#define IOCTL_SUBSYSTEM_COMMON_V2       (1)       
#define IOCTL_SUBSYSTEM_COMMON_ISCSI_V2 (2)       
#define IOCTL_SUBSYSTEM_ETH_V2          (3)       
#define IOCTL_SUBSYSTEM_TOE_V2          (4)       
#define IOCTL_SUBSYSTEM_PXE_UNDI_V2     (5)       
#define IOCTL_SUBSYSTEM_ISCSI_INI_V2    (6)       
#define IOCTL_SUBSYSTEM_ISCSI_TGT_V2    (7)       
#define IOCTL_SUBSYSTEM_MILI_PTL_V2     (8)       
#define IOCTL_SUBSYSTEM_MILI_TMD_V2     (9)       
#define IOCTL_SUBSYSTEM_RDMA_V2         (10)      
#define IOCTL_SUBSYSTEM_LOWLEVEL_V2     (11)      
#define IOCTL_SUBSYSTEM_COMMON_FCOE_V2  (12)      
#define IOCTL_SUBSYSTEM_LRO_V2          (13)      
#define IOCTL_SUBSYSTEM_DAL_V2          (14)      
#define IOCTL_SUBSYSTEM_LLDP_V2         (15)      
#define IOCTL_SUBSYSTEM_DCBX_V2         (16)      
#define IOCTL_SUBSYSTEM_DMTF_V2         (17)      
#define IOCTL_SUBSYSTEM_DIAG_V2         (18)      
#define IOCTL_SUBSYSTEM_VENDOR_V2       (19)      
#define IOCTL_SUBSYSTEM_VNTAG_V2        (20)      
#define IOCTL_SUBSYSTEM_OEM_V2          (21)      
#define IOCTL_SUBSYSTEM_SURF_V2         (22)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* ioctl_subsystems_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case IOCTL_SUBSYSTEM_RSVD_V2:
            return "IOCTL_SUBSYSTEM_RSVD_V2";
         case IOCTL_SUBSYSTEM_COMMON_V2:
            return "IOCTL_SUBSYSTEM_COMMON_V2";
         case IOCTL_SUBSYSTEM_COMMON_ISCSI_V2:
            return "IOCTL_SUBSYSTEM_COMMON_ISCSI_V2";
         case IOCTL_SUBSYSTEM_ETH_V2:
            return "IOCTL_SUBSYSTEM_ETH_V2";
         case IOCTL_SUBSYSTEM_TOE_V2:
            return "IOCTL_SUBSYSTEM_TOE_V2";
         case IOCTL_SUBSYSTEM_PXE_UNDI_V2:
            return "IOCTL_SUBSYSTEM_PXE_UNDI_V2";
         case IOCTL_SUBSYSTEM_ISCSI_INI_V2:
            return "IOCTL_SUBSYSTEM_ISCSI_INI_V2";
         case IOCTL_SUBSYSTEM_ISCSI_TGT_V2:
            return "IOCTL_SUBSYSTEM_ISCSI_TGT_V2";
         case IOCTL_SUBSYSTEM_MILI_PTL_V2:
            return "IOCTL_SUBSYSTEM_MILI_PTL_V2";
         case IOCTL_SUBSYSTEM_MILI_TMD_V2:
            return "IOCTL_SUBSYSTEM_MILI_TMD_V2";
         case IOCTL_SUBSYSTEM_RDMA_V2:
            return "IOCTL_SUBSYSTEM_RDMA_V2";
         case IOCTL_SUBSYSTEM_LOWLEVEL_V2:
            return "IOCTL_SUBSYSTEM_LOWLEVEL_V2";
         case IOCTL_SUBSYSTEM_COMMON_FCOE_V2:
            return "IOCTL_SUBSYSTEM_COMMON_FCOE_V2";
         case IOCTL_SUBSYSTEM_LRO_V2:
            return "IOCTL_SUBSYSTEM_LRO_V2";
         case IOCTL_SUBSYSTEM_DAL_V2:
            return "IOCTL_SUBSYSTEM_DAL_V2";
         case IOCTL_SUBSYSTEM_LLDP_V2:
            return "IOCTL_SUBSYSTEM_LLDP_V2";
         case IOCTL_SUBSYSTEM_DCBX_V2:
            return "IOCTL_SUBSYSTEM_DCBX_V2";
         case IOCTL_SUBSYSTEM_DMTF_V2:
            return "IOCTL_SUBSYSTEM_DMTF_V2";
         case IOCTL_SUBSYSTEM_DIAG_V2:
            return "IOCTL_SUBSYSTEM_DIAG_V2";
         case IOCTL_SUBSYSTEM_VENDOR_V2:
            return "IOCTL_SUBSYSTEM_VENDOR_V2";
         case IOCTL_SUBSYSTEM_VNTAG_V2:
            return "IOCTL_SUBSYSTEM_VNTAG_V2";
         case IOCTL_SUBSYSTEM_OEM_V2:
            return "IOCTL_SUBSYSTEM_OEM_V2";
         case IOCTL_SUBSYSTEM_SURF_V2:
            return "IOCTL_SUBSYSTEM_SURF_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_SUBSYSTEM_OPCODES ---
#define OPCODE_COMMON_NTWK_MAC_QUERY_V2 (1)       
#define SUBSYSTEM_COMMON_NTWK_MAC_QUERY_V2 (1)    
#define SUBSYSTEM_COMMON_NTWK_MAC_SET_V2 (1)      
#define SUBSYSTEM_COMMON_NTWK_MULTICAST_SET_V2 (1) 
#define SUBSYSTEM_COMMON_NTWK_VLAN_CONFIG_V2 (1)  
#define SUBSYSTEM_COMMON_NTWK_LINK_STATUS_QUERY_V2 (1) 
#define SUBSYSTEM_COMMON_READ_FLASHROM_V2 (1)     
#define SUBSYSTEM_COMMON_WRITE_FLASHROM_V2 (1)    
#define SUBSYSTEM_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_V2 (1) 
#define SUBSYSTEM_COMMON_ADD_PAGE_TABLES_V2 (1)   
#define SUBSYSTEM_COMMON_REMOVE_PAGE_TABLES_V2 (1) 
#define SUBSYSTEM_COMMON_CQ_CREATE_V2   (1)       
#define SUBSYSTEM_COMMON_EQ_CREATE_V2   (1)       
#define SUBSYSTEM_COMMON_MCC_CREATE_V2  (1)       
#define SUBSYSTEM_COMMON_JELL_CONFIG_V2 (1)       
#define SUBSYSTEM_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_V2 (1) 
#define SUBSYSTEM_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_V2 (1) 
#define SUBSYSTEM_COMMON_POST_ZERO_BUFFER_V2 (1)  
#define SUBSYSTEM_COMMON_GET_QOS_V2     (1)       
#define SUBSYSTEM_COMMON_SET_QOS_V2     (1)       
#define SUBSYSTEM_COMMON_TCP_GET_STATISTICS_V2 (1) 
#define SUBSYSTEM_COMMON_SEEPROM_READ_V2 (1)      
#define SUBSYSTEM_COMMON_TCP_STATE_QUERY_V2 (1)   
#define SUBSYSTEM_COMMON_GET_CNTL_ATTRIBUTES_V2 (1) 
#define SUBSYSTEM_COMMON_NOP_V2         (1)       
#define SUBSYSTEM_COMMON_NTWK_RX_FILTER_V2 (1)    
#define SUBSYSTEM_COMMON_GET_FW_VERSION_V2 (1)    
#define SUBSYSTEM_COMMON_SET_FLOW_CONTROL_V2 (1)  
#define SUBSYSTEM_COMMON_GET_FLOW_CONTROL_V2 (1)  
#define SUBSYSTEM_COMMON_SET_TCP_PARAMETERS_V2 (1) 
#define SUBSYSTEM_COMMON_SET_FRAME_SIZE_V2 (1)    
#define SUBSYSTEM_COMMON_GET_FAT_V2     (1)       
#define SUBSYSTEM_COMMON_MODIFY_EQ_DELAY_V2 (1)   
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_DOMAINS_V2 (1) 
#define SUBSYSTEM_COMMON_GET_DOMAIN_CONFIG_V2 (1) 
#define SUBSYSTEM_COMMON_GET_PORT_EQUALIZATION_V2 (1) 
#define SUBSYSTEM_COMMON_SET_PORT_EQUALIZATION_V2 (1) 
#define SUBSYSTEM_COMMON_RED_CONFIG_V2  (1)       
#define SUBSYSTEM_COMMON_NTWK_INTERFACE_CREATE_V2 (1) 
#define SUBSYSTEM_COMMON_NTWK_INTERFACE_DESTROY_V2 (1) 
#define SUBSYSTEM_COMMON_CEV_MODIFY_MSI_MESSAGES_V2 (1) 
#define SUBSYSTEM_COMMON_MCC_DESTROY_V2 (1)       
#define SUBSYSTEM_COMMON_CQ_DESTROY_V2  (1)       
#define SUBSYSTEM_COMMON_EQ_DESTROY_V2  (1)       
#define SUBSYSTEM_COMMON_TCP_UPLOAD_V2  (1)       
#define SUBSYSTEM_COMMON_NTWK_SET_LINK_SPEED_V2 (1) 
#define SUBSYSTEM_COMMON_QUERY_FIRMWARE_CONFIG_V2 (1) 
#define SUBSYSTEM_COMMON_NTWK_PMAC_ADD_V2 (1)     
#define SUBSYSTEM_COMMON_NTWK_PMAC_DEL_V2 (1)     
#define SUBSYSTEM_COMMON_FUNCTION_RESET_V2 (1)    
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_PORT_V2 (1) 
#define SUBSYSTEM_COMMON_GET_PORT_CAPABILITY_V2 (1) 
#define SUBSYSTEM_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_V2 (1) 
#define SUBSYSTEM_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_V2 (1) 
#define SUBSYSTEM_COMMON_GET_BOOT_CONFIG_V2 (1)   
#define SUBSYSTEM_COMMON_SET_BOOT_CONFIG_V2 (1)   
#define SUBSYSTEM_COMMON_MANAGE_FAT_V2  (1)       
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_BEACON_V2 (1) 
#define SUBSYSTEM_COMMON_GET_BEACON_STATE_V2 (1)  
#define SUBSYSTEM_COMMON_GET_PORT_STATUS_V2 (1)   
#define SUBSYSTEM_COMMON_READ_PCI_CONFIG_SPACE_V2 (1) 
#define SUBSYSTEM_COMMON_READ_TRANSRECEIVER_DATA_V2 (1) 
#define SUBSYSTEM_COMMON_GET_OEM_ATTRIBUTES_V2 (1) 
#define SUBSYSTEM_COMMON_GET_PORT_NAME_V2 (1)     
#define SUBSYSTEM_COMMON_GET_CONFIG_SIGNATURE_V2 (1) 
#define SUBSYSTEM_COMMON_SET_CONFIG_SIGNATURE_V2 (1) 
#define SUBSYSTEM_COMMON_FUNCTION_LINK_CONFIG_V2 (1) 
#define SUBSYSTEM_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V2 (1) 
#define SUBSYSTEM_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V2 (1) 
#define SUBSYSTEM_COMMON_GET_PCI_FUNCTION_MAPPING_V2 (1) 
#define SUBSYSTEM_COMMON_QUERY_PERSONALITY_CHANGE_V2 (1) 
#define SUBSYSTEM_COMMON_QUERY_CHIP_SERIAL_NUMBER_V2 (1) 
#define SUBSYSTEM_COMMON_GET_NCSI_CONFIGURATION_V2 (1) 
#define SUBSYSTEM_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_V2 (1) 
#define SUBSYSTEM_COMMON_START_MANAGEMENT_SERVICE_V2 (1) 
#define SUBSYSTEM_COMMON_SET_INTERRUPT_ENABLE_V2 (1) 
#define SUBSYSTEM_COMMON_MCC_CREATE_EXT_V2 (1)    
#define SUBSYSTEM_COMMON_GET_VPD_DATA_V2 (1)      
#define SUBSYSTEM_COMMON_SET_VPD_DATA_V2 (1)      
#define SUBSYSTEM_COMMON_SET_FUNCTION_PRIVILEGES_V2 (1) 
#define SUBSYSTEM_COMMON_SET_VF_PORT_TYPE_V2 (1)  
#define SUBSYSTEM_COMMON_GET_PHY_DETAILS_V2 (1)   
#define SUBSYSTEM_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2 (1) 
#define SUBSYSTEM_COMMON_GET_ADAPTER_ID_V2 (1)    
#define SUBSYSTEM_COMMON_GET_UPGRADE_FEATURES_V2 (1) 
#define SUBSYSTEM_COMMON_GET_INSTALLED_FEATURES_V2 (1) 
#define SUBSYSTEM_COMMON_GET_AVAILABLE_PERSONALITIES_V2 (1) 
#define SUBSYSTEM_COMMON_GET_CONFIGURED_PERSONALITY_V2 (1) 
#define SUBSYSTEM_COMMON_SEND_ACTIVATION_V2 (1)   
#define SUBSYSTEM_COMMON_RESET_LICENSES_V2 (1)    
#define SUBSYSTEM_COMMON_GET_FUNCTION_NAME_INFO_V2 (1) 
#define SUBSYSTEM_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_V2 (1) 
#define SUBSYSTEM_COMMON_GET_CAPABILITY_V2 (1)    
#define SUBSYSTEM_COMMON_SET_SWITCH_TYPE_V2 (1)   
#define SUBSYSTEM_COMMON_GET_EXT_FAT_CAPABILITES_V2 (1) 
#define SUBSYSTEM_COMMON_SET_EXT_FAT_CAPABILITES_V2 (1) 
#define SUBSYSTEM_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_V2 (1) 
#define SUBSYSTEM_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_V2 (1) 
#define SUBSYSTEM_COMMON_DMA_HOST_BUFFERS_V2 (1)  
#define SUBSYSTEM_COMMON_EXT_FAT_READ_STRING_TABLE_V2 (1) 
#define SUBSYSTEM_COMMON_POPULATE_SENSOR_CFG_INFO_V2 (1) 
#define SUBSYSTEM_COMMON_SET_TX_THROTTLE_V2 (1)   
#define SUBSYSTEM_COMMON_GET_TX_THROTTLE_V2 (1)   
#define SUBSYSTEM_COMMON_NTWK_GET_LINK_SPEED_V2 (1) 
#define SUBSYSTEM_COMMON_NTWK_GET_MAC_LIST_V2 (1) 
#define SUBSYSTEM_COMMON_NTWK_SET_MAC_LIST_V2 (1) 
#define SUBSYSTEM_COMMON_MODIFY_CQ_V2   (1)       
#define SUBSYSTEM_COMMON_NTWK_GET_VLAN_LIST_V2 (1) 
#define SUBSYSTEM_COMMON_NTWK_SET_VLAN_LIST_V2 (1) 
#define SUBSYSTEM_COMMON_GET_HSW_CONFIG_V2 (1)    
#define SUBSYSTEM_COMMON_SET_HSW_CONFIG_V2 (1)    
#define SUBSYSTEM_COMMON_GET_FUNCTION_CONFIG_V2 (1) 
#define SUBSYSTEM_COMMON_GET_PROFILE_CAPACITIES_V2 (1) 
#define SUBSYSTEM_COMMON_GET_PROFILE_CONFIG_V2 (1) 
#define SUBSYSTEM_COMMON_SET_PROFILE_CONFIG_V2 (1) 
#define SUBSYSTEM_COMMON_GET_PROFILE_LIST_V2 (1)  
#define SUBSYSTEM_COMMON_GET_ACTIVE_PROFILE_V2 (1) 
#define SUBSYSTEM_COMMON_SET_ACTIVE_PROFILE_V2 (1) 
#define SUBSYSTEM_COMMON_SET_FACTORY_PROFILE_CONFIG_V2 (1) 
#define SUBSYSTEM_COMMON_GET_FUNCTION_PRIVILEGES_V2 (1) 
#define SUBSYSTEM_COMMON_READ_OBJECT_V2 (1)       
#define SUBSYSTEM_COMMON_WRITE_OBJECT_V2 (1)      
#define SUBSYSTEM_COMMON_GET_DEVICE_UTILIZATION_V2 (1) 
#define SUBSYSTEM_COMMON_GET_SLI4_PARAMETERS_V2 (1) 
#define SUBSYSTEM_COMMON_POPULATE_OCBB_CFG_INFO_V2 (1) 
#define SUBSYSTEM_COMMON_MODIFY_ASYNC_EVENTS_V2 (1) 
#define SUBSYSTEM_COMMON_MANAGE_FFV_V2  (1)       
#define SUBSYSTEM_COMMON_NTWK_MANAGE_IFACE_FILTERS_V2 (1) 
#define SUBSYSTEM_COMMON_GET_IFACE_LIST_V2 (1)    
#define SUBSYSTEM_COMMON_WQ_CONTROL_V2  (1)       
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_VF_V2 (1) 
#define SUBSYSTEM_COMMON_ALLOC_PD_V2    (1)       
#define SUBSYSTEM_COMMON_DEALLOC_PD_V2  (1)       
#define SUBSYSTEM_COMMON_REGISTER_NSMR_V2 (1)     
#define SUBSYSTEM_COMMON_REGISTER_NSMR_CONT_V2 (1) 
#define SUBSYSTEM_COMMON_REREGISTER_NSMR_V2 (1)   
#define OPCODE_COMMON_NTWK_MAC_SET_V2   (2)       
#define OPCODE_COMMON_NTWK_MULTICAST_SET_V2 (3)   
#define OPCODE_COMMON_NTWK_VLAN_CONFIG_V2 (4)     
#define OPCODE_COMMON_NTWK_LINK_STATUS_QUERY_V2 (5) 
#define OPCODE_COMMON_READ_FLASHROM_V2  (6)       
#define OPCODE_COMMON_WRITE_FLASHROM_V2 (7)       
#define OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_V2 (8) 
#define OPCODE_COMMON_ADD_PAGE_TABLES_V2 (9)      
#define OPCODE_COMMON_REMOVE_PAGE_TABLES_V2 (10)  
#define OPCODE_COMMON_CQ_CREATE_V2      (12)      
#define OPCODE_COMMON_EQ_CREATE_V2      (13)      
#define OPCODE_COMMON_MCC_CREATE_V2     (21)      
#define OPCODE_COMMON_JELL_CONFIG_V2    (22)      
#define OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_V2 (24) 
#define OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_V2 (25) 
#define OPCODE_COMMON_POST_ZERO_BUFFER_V2 (26)    
#define OPCODE_COMMON_GET_QOS_V2        (27)      
#define OPCODE_COMMON_SET_QOS_V2        (28)      
#define OPCODE_COMMON_TCP_GET_STATISTICS_V2 (29)  
#define OPCODE_COMMON_SEEPROM_READ_V2   (30)      
#define OPCODE_COMMON_TCP_STATE_QUERY_V2 (31)     
#define OPCODE_COMMON_GET_CNTL_ATTRIBUTES_V2 (32) 
#define OPCODE_COMMON_NOP_V2            (33)      
#define OPCODE_COMMON_NTWK_RX_FILTER_V2 (34)      
#define OPCODE_COMMON_GET_FW_VERSION_V2 (35)      
#define OPCODE_COMMON_SET_FLOW_CONTROL_V2 (36)    
#define OPCODE_COMMON_GET_FLOW_CONTROL_V2 (37)    
#define OPCODE_COMMON_SET_TCP_PARAMETERS_V2 (38)  
#define OPCODE_COMMON_SET_FRAME_SIZE_V2 (39)      
#define OPCODE_COMMON_GET_FAT_V2        (40)      
#define OPCODE_COMMON_MODIFY_EQ_DELAY_V2 (41)     
#define OPCODE_COMMON_ENABLE_DISABLE_DOMAINS_V2 (43) 
#define OPCODE_COMMON_GET_DOMAIN_CONFIG_V2 (44)   
#define OPCODE_COMMON_GET_PORT_EQUALIZATION_V2 (47) 
#define OPCODE_COMMON_SET_PORT_EQUALIZATION_V2 (48) 
#define OPCODE_COMMON_RED_CONFIG_V2     (49)      
#define OPCODE_COMMON_NTWK_INTERFACE_CREATE_V2 (50) 
#define OPCODE_COMMON_NTWK_INTERFACE_DESTROY_V2 (51) 
#define OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES_V2 (52) 
#define OPCODE_COMMON_MCC_DESTROY_V2    (53)      
#define OPCODE_COMMON_CQ_DESTROY_V2     (54)      
#define OPCODE_COMMON_EQ_DESTROY_V2     (55)      
#define OPCODE_COMMON_TCP_UPLOAD_V2     (56)      
#define OPCODE_COMMON_NTWK_SET_LINK_SPEED_V2 (57) 
#define OPCODE_COMMON_QUERY_FIRMWARE_CONFIG_V2 (58) 
#define OPCODE_COMMON_NTWK_PMAC_ADD_V2  (59)      
#define OPCODE_COMMON_NTWK_PMAC_DEL_V2  (60)      
#define OPCODE_COMMON_FUNCTION_RESET_V2 (61)      
#define OPCODE_COMMON_ENABLE_DISABLE_PORT_V2 (62) 
#define OPCODE_COMMON_GET_PORT_CAPABILITY_V2 (63) 
#define OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_V2 (64) 
#define OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_V2 (65) 
#define OPCODE_COMMON_GET_BOOT_CONFIG_V2 (66)     
#define OPCODE_COMMON_SET_BOOT_CONFIG_V2 (67)     
#define OPCODE_COMMON_MANAGE_FAT_V2     (68)      
#define OPCODE_COMMON_ENABLE_DISABLE_BEACON_V2 (69) 
#define OPCODE_COMMON_GET_BEACON_STATE_V2 (70)    
#define OPCODE_COMMON_GET_PORT_STATUS_V2 (71)     
#define OPCODE_COMMON_READ_PCI_CONFIG_SPACE_V2 (72) 
#define OPCODE_COMMON_READ_TRANSRECEIVER_DATA_V2 (73) 
#define OPCODE_COMMON_GET_OEM_ATTRIBUTES_V2 (76)  
#define OPCODE_COMMON_GET_PORT_NAME_V2  (77)      
#define OPCODE_COMMON_GET_CONFIG_SIGNATURE_V2 (78) 
#define OPCODE_COMMON_SET_CONFIG_SIGNATURE_V2 (79) 
#define OPCODE_COMMON_FUNCTION_LINK_CONFIG_V2 (80) 
#define OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V2 (81) 
#define OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V2 (82) 
#define OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING_V2 (83) 
#define OPCODE_COMMON_QUERY_PERSONALITY_CHANGE_V2 (84) 
#define OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER_V2 (85) 
#define OPCODE_COMMON_GET_NCSI_CONFIGURATION_V2 (86) 
#define OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_V2 (87) 
#define OPCODE_COMMON_START_MANAGEMENT_SERVICE_V2 (88) 
#define OPCODE_COMMON_SET_INTERRUPT_ENABLE_V2 (89) 
#define OPCODE_COMMON_MCC_CREATE_EXT_V2 (90)      
#define OPCODE_COMMON_GET_VPD_DATA_V2   (91)      
#define OPCODE_COMMON_SET_VPD_DATA_V2   (92)      
#define OPCODE_COMMON_SET_FUNCTION_PRIVILEGES_V2 (100) 
#define OPCODE_COMMON_SET_VF_PORT_TYPE_V2 (101)   
#define OPCODE_COMMON_GET_PHY_DETAILS_V2 (102)    
#define OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2 (103) 
#define OPCODE_COMMON_GET_ADAPTER_ID_V2 (110)     
#define OPCODE_COMMON_GET_UPGRADE_FEATURES_V2 (111) 
#define OPCODE_COMMON_GET_INSTALLED_FEATURES_V2 (112) 
#define OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES_V2 (113) 
#define OPCODE_COMMON_GET_CONFIGURED_PERSONALITY_V2 (114) 
#define OPCODE_COMMON_SEND_ACTIVATION_V2 (115)    
#define OPCODE_COMMON_RESET_LICENSES_V2 (116)     
#define OPCODE_COMMON_GET_FUNCTION_NAME_INFO_V2 (120) 
#define OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_V2 (121) 
#define OPCODE_COMMON_GET_CAPABILITY_V2 (123)     
#define OPCODE_COMMON_SET_SWITCH_TYPE_V2 (124)    
#define OPCODE_COMMON_GET_EXT_FAT_CAPABILITES_V2 (125) 
#define OPCODE_COMMON_SET_EXT_FAT_CAPABILITES_V2 (126) 
#define OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_V2 (127) 
#define OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_V2 (128) 
#define OPCODE_COMMON_DMA_HOST_BUFFERS_V2 (129)   
#define OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE_V2 (130) 
#define OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO_V2 (131) 
#define OPCODE_COMMON_SET_TX_THROTTLE_V2 (132)    
#define OPCODE_COMMON_GET_TX_THROTTLE_V2 (133)    
#define OPCODE_COMMON_NTWK_GET_LINK_SPEED_V2 (134) 
#define OPCODE_COMMON_NTWK_GET_MAC_LIST_V2 (147)  
#define OPCODE_COMMON_NTWK_SET_MAC_LIST_V2 (148)  
#define OPCODE_COMMON_MODIFY_CQ_V2      (149)     
#define OPCODE_COMMON_NTWK_GET_VLAN_LIST_V2 (150) 
#define OPCODE_COMMON_NTWK_SET_VLAN_LIST_V2 (151) 
#define OPCODE_COMMON_GET_HSW_CONFIG_V2 (152)     
#define OPCODE_COMMON_SET_HSW_CONFIG_V2 (153)     
#define OPCODE_COMMON_GET_FUNCTION_CONFIG_V2 (160) 
#define OPCODE_COMMON_GET_PROFILE_CAPACITIES_V2 (161) 
#define OPCODE_COMMON_GET_PROFILE_CONFIG_V2 (164) 
#define OPCODE_COMMON_SET_PROFILE_CONFIG_V2 (165) 
#define OPCODE_COMMON_GET_PROFILE_LIST_V2 (166)   
#define OPCODE_COMMON_GET_ACTIVE_PROFILE_V2 (167) 
#define OPCODE_COMMON_SET_ACTIVE_PROFILE_V2 (168) 
#define OPCODE_COMMON_SET_FACTORY_PROFILE_CONFIG_V2 (169) 
#define OPCODE_COMMON_GET_FUNCTION_PRIVILEGES_V2 (170) 
#define OPCODE_COMMON_READ_OBJECT_V2    (171)     
#define OPCODE_COMMON_WRITE_OBJECT_V2   (172)     
#define OPCODE_COMMON_GET_DEVICE_UTILIZATION_V2 (178) 
#define OPCODE_COMMON_GET_SLI4_PARAMETERS_V2 (181) 
#define OPCODE_COMMON_POPULATE_OCBB_CFG_INFO_V2 (182) 
#define OPCODE_COMMON_MODIFY_ASYNC_EVENTS_V2 (185) 
#define OPCODE_COMMON_MANAGE_FFV_V2     (192)     
#define OPCODE_COMMON_NTWK_MANAGE_IFACE_FILTERS_V2 (193) 
#define OPCODE_COMMON_GET_IFACE_LIST_V2 (194)     
#define OPCODE_COMMON_WQ_CONTROL_V2     (195)     
#define OPCODE_COMMON_ENABLE_DISABLE_VF_V2 (196)  
#define OPCODE_COMMON_ALLOC_PD_V2       (197)     
#define OPCODE_COMMON_DEALLOC_PD_V2     (198)     
#define OPCODE_COMMON_REGISTER_NSMR_V2  (199)     
#define OPCODE_COMMON_REGISTER_NSMR_CONT_V2 (200) 
#define OPCODE_COMMON_REREGISTER_NSMR_V2 (201)    

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_NTWK_MAC_QUERY_V2:
            return "OPCODE_COMMON_NTWK_MAC_QUERY_V2";
         case OPCODE_COMMON_NTWK_MAC_SET_V2:
            return "OPCODE_COMMON_NTWK_MAC_SET_V2";
         case OPCODE_COMMON_NTWK_MULTICAST_SET_V2:
            return "OPCODE_COMMON_NTWK_MULTICAST_SET_V2";
         case OPCODE_COMMON_NTWK_VLAN_CONFIG_V2:
            return "OPCODE_COMMON_NTWK_VLAN_CONFIG_V2";
         case OPCODE_COMMON_NTWK_LINK_STATUS_QUERY_V2:
            return "OPCODE_COMMON_NTWK_LINK_STATUS_QUERY_V2";
         case OPCODE_COMMON_READ_FLASHROM_V2:
            return "OPCODE_COMMON_READ_FLASHROM_V2";
         case OPCODE_COMMON_WRITE_FLASHROM_V2:
            return "OPCODE_COMMON_WRITE_FLASHROM_V2";
         case OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_V2:
            return "OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_V2";
         case OPCODE_COMMON_ADD_PAGE_TABLES_V2:
            return "OPCODE_COMMON_ADD_PAGE_TABLES_V2";
         case OPCODE_COMMON_REMOVE_PAGE_TABLES_V2:
            return "OPCODE_COMMON_REMOVE_PAGE_TABLES_V2";
         case OPCODE_COMMON_CQ_CREATE_V2:
            return "OPCODE_COMMON_CQ_CREATE_V2";
         case OPCODE_COMMON_EQ_CREATE_V2:
            return "OPCODE_COMMON_EQ_CREATE_V2";
         case OPCODE_COMMON_MCC_CREATE_V2:
            return "OPCODE_COMMON_MCC_CREATE_V2";
         case OPCODE_COMMON_JELL_CONFIG_V2:
            return "OPCODE_COMMON_JELL_CONFIG_V2";
         case OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_V2:
            return "OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_V2";
         case OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_V2:
            return "OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_V2";
         case OPCODE_COMMON_POST_ZERO_BUFFER_V2:
            return "OPCODE_COMMON_POST_ZERO_BUFFER_V2";
         case OPCODE_COMMON_GET_QOS_V2:
            return "OPCODE_COMMON_GET_QOS_V2";
         case OPCODE_COMMON_SET_QOS_V2:
            return "OPCODE_COMMON_SET_QOS_V2";
         case OPCODE_COMMON_TCP_GET_STATISTICS_V2:
            return "OPCODE_COMMON_TCP_GET_STATISTICS_V2";
         case OPCODE_COMMON_SEEPROM_READ_V2:
            return "OPCODE_COMMON_SEEPROM_READ_V2";
         case OPCODE_COMMON_TCP_STATE_QUERY_V2:
            return "OPCODE_COMMON_TCP_STATE_QUERY_V2";
         case OPCODE_COMMON_GET_CNTL_ATTRIBUTES_V2:
            return "OPCODE_COMMON_GET_CNTL_ATTRIBUTES_V2";
         case OPCODE_COMMON_NOP_V2:
            return "OPCODE_COMMON_NOP_V2";
         case OPCODE_COMMON_NTWK_RX_FILTER_V2:
            return "OPCODE_COMMON_NTWK_RX_FILTER_V2";
         case OPCODE_COMMON_GET_FW_VERSION_V2:
            return "OPCODE_COMMON_GET_FW_VERSION_V2";
         case OPCODE_COMMON_SET_FLOW_CONTROL_V2:
            return "OPCODE_COMMON_SET_FLOW_CONTROL_V2";
         case OPCODE_COMMON_GET_FLOW_CONTROL_V2:
            return "OPCODE_COMMON_GET_FLOW_CONTROL_V2";
         case OPCODE_COMMON_SET_TCP_PARAMETERS_V2:
            return "OPCODE_COMMON_SET_TCP_PARAMETERS_V2";
         case OPCODE_COMMON_SET_FRAME_SIZE_V2:
            return "OPCODE_COMMON_SET_FRAME_SIZE_V2";
         case OPCODE_COMMON_GET_FAT_V2:
            return "OPCODE_COMMON_GET_FAT_V2";
         case OPCODE_COMMON_MODIFY_EQ_DELAY_V2:
            return "OPCODE_COMMON_MODIFY_EQ_DELAY_V2";
         case OPCODE_COMMON_ENABLE_DISABLE_DOMAINS_V2:
            return "OPCODE_COMMON_ENABLE_DISABLE_DOMAINS_V2";
         case OPCODE_COMMON_GET_DOMAIN_CONFIG_V2:
            return "OPCODE_COMMON_GET_DOMAIN_CONFIG_V2";
         case OPCODE_COMMON_GET_PORT_EQUALIZATION_V2:
            return "OPCODE_COMMON_GET_PORT_EQUALIZATION_V2";
         case OPCODE_COMMON_SET_PORT_EQUALIZATION_V2:
            return "OPCODE_COMMON_SET_PORT_EQUALIZATION_V2";
         case OPCODE_COMMON_RED_CONFIG_V2:
            return "OPCODE_COMMON_RED_CONFIG_V2";
         case OPCODE_COMMON_NTWK_INTERFACE_CREATE_V2:
            return "OPCODE_COMMON_NTWK_INTERFACE_CREATE_V2";
         case OPCODE_COMMON_NTWK_INTERFACE_DESTROY_V2:
            return "OPCODE_COMMON_NTWK_INTERFACE_DESTROY_V2";
         case OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES_V2:
            return "OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES_V2";
         case OPCODE_COMMON_MCC_DESTROY_V2:
            return "OPCODE_COMMON_MCC_DESTROY_V2";
         case OPCODE_COMMON_CQ_DESTROY_V2:
            return "OPCODE_COMMON_CQ_DESTROY_V2";
         case OPCODE_COMMON_EQ_DESTROY_V2:
            return "OPCODE_COMMON_EQ_DESTROY_V2";
         case OPCODE_COMMON_TCP_UPLOAD_V2:
            return "OPCODE_COMMON_TCP_UPLOAD_V2";
         case OPCODE_COMMON_NTWK_SET_LINK_SPEED_V2:
            return "OPCODE_COMMON_NTWK_SET_LINK_SPEED_V2";
         case OPCODE_COMMON_QUERY_FIRMWARE_CONFIG_V2:
            return "OPCODE_COMMON_QUERY_FIRMWARE_CONFIG_V2";
         case OPCODE_COMMON_NTWK_PMAC_ADD_V2:
            return "OPCODE_COMMON_NTWK_PMAC_ADD_V2";
         case OPCODE_COMMON_NTWK_PMAC_DEL_V2:
            return "OPCODE_COMMON_NTWK_PMAC_DEL_V2";
         case OPCODE_COMMON_FUNCTION_RESET_V2:
            return "OPCODE_COMMON_FUNCTION_RESET_V2";
         case OPCODE_COMMON_ENABLE_DISABLE_PORT_V2:
            return "OPCODE_COMMON_ENABLE_DISABLE_PORT_V2";
         case OPCODE_COMMON_GET_PORT_CAPABILITY_V2:
            return "OPCODE_COMMON_GET_PORT_CAPABILITY_V2";
         case OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_V2:
            return "OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_V2";
         case OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_V2:
            return "OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_V2";
         case OPCODE_COMMON_GET_BOOT_CONFIG_V2:
            return "OPCODE_COMMON_GET_BOOT_CONFIG_V2";
         case OPCODE_COMMON_SET_BOOT_CONFIG_V2:
            return "OPCODE_COMMON_SET_BOOT_CONFIG_V2";
         case OPCODE_COMMON_MANAGE_FAT_V2:
            return "OPCODE_COMMON_MANAGE_FAT_V2";
         case OPCODE_COMMON_ENABLE_DISABLE_BEACON_V2:
            return "OPCODE_COMMON_ENABLE_DISABLE_BEACON_V2";
         case OPCODE_COMMON_GET_BEACON_STATE_V2:
            return "OPCODE_COMMON_GET_BEACON_STATE_V2";
         case OPCODE_COMMON_GET_PORT_STATUS_V2:
            return "OPCODE_COMMON_GET_PORT_STATUS_V2";
         case OPCODE_COMMON_READ_PCI_CONFIG_SPACE_V2:
            return "OPCODE_COMMON_READ_PCI_CONFIG_SPACE_V2";
         case OPCODE_COMMON_READ_TRANSRECEIVER_DATA_V2:
            return "OPCODE_COMMON_READ_TRANSRECEIVER_DATA_V2";
         case OPCODE_COMMON_GET_OEM_ATTRIBUTES_V2:
            return "OPCODE_COMMON_GET_OEM_ATTRIBUTES_V2";
         case OPCODE_COMMON_GET_PORT_NAME_V2:
            return "OPCODE_COMMON_GET_PORT_NAME_V2";
         case OPCODE_COMMON_GET_CONFIG_SIGNATURE_V2:
            return "OPCODE_COMMON_GET_CONFIG_SIGNATURE_V2";
         case OPCODE_COMMON_SET_CONFIG_SIGNATURE_V2:
            return "OPCODE_COMMON_SET_CONFIG_SIGNATURE_V2";
         case OPCODE_COMMON_FUNCTION_LINK_CONFIG_V2:
            return "OPCODE_COMMON_FUNCTION_LINK_CONFIG_V2";
         case OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V2:
            return "OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V2";
         case OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V2:
            return "OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V2";
         case OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING_V2:
            return "OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING_V2";
         case OPCODE_COMMON_QUERY_PERSONALITY_CHANGE_V2:
            return "OPCODE_COMMON_QUERY_PERSONALITY_CHANGE_V2";
         case OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER_V2:
            return "OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER_V2";
         case OPCODE_COMMON_GET_NCSI_CONFIGURATION_V2:
            return "OPCODE_COMMON_GET_NCSI_CONFIGURATION_V2";
         case OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_V2:
            return "OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_V2";
         case OPCODE_COMMON_START_MANAGEMENT_SERVICE_V2:
            return "OPCODE_COMMON_START_MANAGEMENT_SERVICE_V2";
         case OPCODE_COMMON_SET_INTERRUPT_ENABLE_V2:
            return "OPCODE_COMMON_SET_INTERRUPT_ENABLE_V2";
         case OPCODE_COMMON_MCC_CREATE_EXT_V2:
            return "OPCODE_COMMON_MCC_CREATE_EXT_V2";
         case OPCODE_COMMON_GET_VPD_DATA_V2:
            return "OPCODE_COMMON_GET_VPD_DATA_V2";
         case OPCODE_COMMON_SET_VPD_DATA_V2:
            return "OPCODE_COMMON_SET_VPD_DATA_V2";
         case OPCODE_COMMON_SET_FUNCTION_PRIVILEGES_V2:
            return "OPCODE_COMMON_SET_FUNCTION_PRIVILEGES_V2";
         case OPCODE_COMMON_SET_VF_PORT_TYPE_V2:
            return "OPCODE_COMMON_SET_VF_PORT_TYPE_V2";
         case OPCODE_COMMON_GET_PHY_DETAILS_V2:
            return "OPCODE_COMMON_GET_PHY_DETAILS_V2";
         case OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2:
            return "OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2";
         case OPCODE_COMMON_GET_ADAPTER_ID_V2:
            return "OPCODE_COMMON_GET_ADAPTER_ID_V2";
         case OPCODE_COMMON_GET_UPGRADE_FEATURES_V2:
            return "OPCODE_COMMON_GET_UPGRADE_FEATURES_V2";
         case OPCODE_COMMON_GET_INSTALLED_FEATURES_V2:
            return "OPCODE_COMMON_GET_INSTALLED_FEATURES_V2";
         case OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES_V2:
            return "OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES_V2";
         case OPCODE_COMMON_GET_CONFIGURED_PERSONALITY_V2:
            return "OPCODE_COMMON_GET_CONFIGURED_PERSONALITY_V2";
         case OPCODE_COMMON_SEND_ACTIVATION_V2:
            return "OPCODE_COMMON_SEND_ACTIVATION_V2";
         case OPCODE_COMMON_RESET_LICENSES_V2:
            return "OPCODE_COMMON_RESET_LICENSES_V2";
         case OPCODE_COMMON_GET_FUNCTION_NAME_INFO_V2:
            return "OPCODE_COMMON_GET_FUNCTION_NAME_INFO_V2";
         case OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_V2:
            return "OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_V2";
         case OPCODE_COMMON_GET_CAPABILITY_V2:
            return "OPCODE_COMMON_GET_CAPABILITY_V2";
         case OPCODE_COMMON_SET_SWITCH_TYPE_V2:
            return "OPCODE_COMMON_SET_SWITCH_TYPE_V2";
         case OPCODE_COMMON_GET_EXT_FAT_CAPABILITES_V2:
            return "OPCODE_COMMON_GET_EXT_FAT_CAPABILITES_V2";
         case OPCODE_COMMON_SET_EXT_FAT_CAPABILITES_V2:
            return "OPCODE_COMMON_SET_EXT_FAT_CAPABILITES_V2";
         case OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_V2:
            return "OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_V2";
         case OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_V2:
            return "OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_V2";
         case OPCODE_COMMON_DMA_HOST_BUFFERS_V2:
            return "OPCODE_COMMON_DMA_HOST_BUFFERS_V2";
         case OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE_V2:
            return "OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE_V2";
         case OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO_V2:
            return "OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO_V2";
         case OPCODE_COMMON_SET_TX_THROTTLE_V2:
            return "OPCODE_COMMON_SET_TX_THROTTLE_V2";
         case OPCODE_COMMON_GET_TX_THROTTLE_V2:
            return "OPCODE_COMMON_GET_TX_THROTTLE_V2";
         case OPCODE_COMMON_NTWK_GET_LINK_SPEED_V2:
            return "OPCODE_COMMON_NTWK_GET_LINK_SPEED_V2";
         case OPCODE_COMMON_NTWK_GET_MAC_LIST_V2:
            return "OPCODE_COMMON_NTWK_GET_MAC_LIST_V2";
         case OPCODE_COMMON_NTWK_SET_MAC_LIST_V2:
            return "OPCODE_COMMON_NTWK_SET_MAC_LIST_V2";
         case OPCODE_COMMON_MODIFY_CQ_V2:
            return "OPCODE_COMMON_MODIFY_CQ_V2";
         case OPCODE_COMMON_NTWK_GET_VLAN_LIST_V2:
            return "OPCODE_COMMON_NTWK_GET_VLAN_LIST_V2";
         case OPCODE_COMMON_NTWK_SET_VLAN_LIST_V2:
            return "OPCODE_COMMON_NTWK_SET_VLAN_LIST_V2";
         case OPCODE_COMMON_GET_HSW_CONFIG_V2:
            return "OPCODE_COMMON_GET_HSW_CONFIG_V2";
         case OPCODE_COMMON_SET_HSW_CONFIG_V2:
            return "OPCODE_COMMON_SET_HSW_CONFIG_V2";
         case OPCODE_COMMON_GET_FUNCTION_CONFIG_V2:
            return "OPCODE_COMMON_GET_FUNCTION_CONFIG_V2";
         case OPCODE_COMMON_GET_PROFILE_CAPACITIES_V2:
            return "OPCODE_COMMON_GET_PROFILE_CAPACITIES_V2";
         case OPCODE_COMMON_GET_PROFILE_CONFIG_V2:
            return "OPCODE_COMMON_GET_PROFILE_CONFIG_V2";
         case OPCODE_COMMON_SET_PROFILE_CONFIG_V2:
            return "OPCODE_COMMON_SET_PROFILE_CONFIG_V2";
         case OPCODE_COMMON_GET_PROFILE_LIST_V2:
            return "OPCODE_COMMON_GET_PROFILE_LIST_V2";
         case OPCODE_COMMON_GET_ACTIVE_PROFILE_V2:
            return "OPCODE_COMMON_GET_ACTIVE_PROFILE_V2";
         case OPCODE_COMMON_SET_ACTIVE_PROFILE_V2:
            return "OPCODE_COMMON_SET_ACTIVE_PROFILE_V2";
         case OPCODE_COMMON_SET_FACTORY_PROFILE_CONFIG_V2:
            return "OPCODE_COMMON_SET_FACTORY_PROFILE_CONFIG_V2";
         case OPCODE_COMMON_GET_FUNCTION_PRIVILEGES_V2:
            return "OPCODE_COMMON_GET_FUNCTION_PRIVILEGES_V2";
         case OPCODE_COMMON_READ_OBJECT_V2:
            return "OPCODE_COMMON_READ_OBJECT_V2";
         case OPCODE_COMMON_WRITE_OBJECT_V2:
            return "OPCODE_COMMON_WRITE_OBJECT_V2";
         case OPCODE_COMMON_GET_DEVICE_UTILIZATION_V2:
            return "OPCODE_COMMON_GET_DEVICE_UTILIZATION_V2";
         case OPCODE_COMMON_GET_SLI4_PARAMETERS_V2:
            return "OPCODE_COMMON_GET_SLI4_PARAMETERS_V2";
         case OPCODE_COMMON_POPULATE_OCBB_CFG_INFO_V2:
            return "OPCODE_COMMON_POPULATE_OCBB_CFG_INFO_V2";
         case OPCODE_COMMON_MODIFY_ASYNC_EVENTS_V2:
            return "OPCODE_COMMON_MODIFY_ASYNC_EVENTS_V2";
         case OPCODE_COMMON_MANAGE_FFV_V2:
            return "OPCODE_COMMON_MANAGE_FFV_V2";
         case OPCODE_COMMON_NTWK_MANAGE_IFACE_FILTERS_V2:
            return "OPCODE_COMMON_NTWK_MANAGE_IFACE_FILTERS_V2";
         case OPCODE_COMMON_GET_IFACE_LIST_V2:
            return "OPCODE_COMMON_GET_IFACE_LIST_V2";
         case OPCODE_COMMON_WQ_CONTROL_V2:
            return "OPCODE_COMMON_WQ_CONTROL_V2";
         case OPCODE_COMMON_ENABLE_DISABLE_VF_V2:
            return "OPCODE_COMMON_ENABLE_DISABLE_VF_V2";
         case OPCODE_COMMON_ALLOC_PD_V2:
            return "OPCODE_COMMON_ALLOC_PD_V2";
         case OPCODE_COMMON_DEALLOC_PD_V2:
            return "OPCODE_COMMON_DEALLOC_PD_V2";
         case OPCODE_COMMON_REGISTER_NSMR_V2:
            return "OPCODE_COMMON_REGISTER_NSMR_V2";
         case OPCODE_COMMON_REGISTER_NSMR_CONT_V2:
            return "OPCODE_COMMON_REGISTER_NSMR_CONT_V2";
         case OPCODE_COMMON_REREGISTER_NSMR_V2:
            return "OPCODE_COMMON_REREGISTER_NSMR_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_ISCSI_SUBSYSTEM_OPCODES ---
#define OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_V2 (1) 
#define SUBSYSTEM_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_V2 (2) 
#define OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_POST_SGL_PAGES_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_PING_V2 (2)   
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ARP_TABLE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_ARP_TABLE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_IFACE_CREATE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_IFACE_DELETE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_VLAN_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_PING_STATE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_PING_STATE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_IF_INFO_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CLEANUP_V2 (2)     
#define SUBSYSTEM_COMMON_ISCSI_ADD_8BYTE_LUN_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_READ_EVENT_LOG_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_DEFQ_CREATE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_DEFQ_DESTROY_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_WRBQ_CREATE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_WRBQ_DESTROY_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_MTU_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_MTU_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_TCP_DISCONNECT_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_SET_TCP_PARAMETERS_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CONNECTION_UPDATE_V2 (2) 
#define SUBSYSTEM_COMMON_ISCSI_GET_CONNECTION_INFO_V2 (2) 
#define OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_V2 (3) 
#define OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_V2 (4) 
#define OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_V2 (5) 
#define OPCODE_COMMON_ISCSI_NTWK_PING_V2 (6)      
#define OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_V2 (7) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE_V2 (8) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE_V2 (9) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_V2 (10) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_V2 (11) 
#define OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE_V2 (12) 
#define OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE_V2 (13) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_VLAN_V2 (14) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE_V2 (15) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE_V2 (16) 
#define OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_V2 (17) 
#define OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_V2 (18) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_V2 (19) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_V2 (20) 
#define OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_V2 (21) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_V2 (22) 
#define OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_V2 (23) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_V2 (24) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO_V2 (25) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_V2 (26) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_V2 (27) 
#define OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_V2 (28) 
#define OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_V2 (29) 
#define OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_V2 (30) 
#define OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_V2 (31) 
#define OPCODE_COMMON_ISCSI_CLEANUP_V2  (59)      
#define OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN_V2 (60) 
#define OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_V2 (61) 
#define OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_V2 (62) 
#define OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG_V2 (63) 
#define OPCODE_COMMON_ISCSI_DEFQ_CREATE_V2 (64)   
#define OPCODE_COMMON_ISCSI_DEFQ_DESTROY_V2 (65)  
#define OPCODE_COMMON_ISCSI_WRBQ_CREATE_V2 (66)   
#define OPCODE_COMMON_ISCSI_WRBQ_DESTROY_V2 (67)  
#define OPCODE_COMMON_ISCSI_NTWK_SET_MTU_V2 (68)  
#define OPCODE_COMMON_ISCSI_NTWK_GET_MTU_V2 (69)  
#define OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_V2 (70) 
#define OPCODE_COMMON_ISCSI_TCP_DISCONNECT_V2 (71) 
#define OPCODE_COMMON_ISCSI_SET_TCP_PARAMETERS_V2 (72) 
#define OPCODE_COMMON_ISCSI_CONNECTION_UPDATE_V2 (73) 
#define OPCODE_COMMON_ISCSI_GET_CONNECTION_INFO_V2 (74) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_iscsi_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_V2:
            return "OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_V2";
         case OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES_V2:
            return "OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES_V2";
         case OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_V2:
            return "OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_V2";
         case OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_V2:
            return "OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_V2";
         case OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_V2:
            return "OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_V2";
         case OPCODE_COMMON_ISCSI_NTWK_PING_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_PING_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE_V2";
         case OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_V2";
         case OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_V2";
         case OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE_V2";
         case OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE_V2";
         case OPCODE_COMMON_ISCSI_NTWK_SET_VLAN_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_VLAN_V2";
         case OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE_V2";
         case OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_V2";
         case OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_V2";
         case OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_V2";
         case OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_V2";
         case OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_V2";
         case OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_V2:
            return "OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_V2";
         case OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_V2:
            return "OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_V2";
         case OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_V2:
            return "OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_V2";
         case OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_V2:
            return "OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_V2";
         case OPCODE_COMMON_ISCSI_CLEANUP_V2:
            return "OPCODE_COMMON_ISCSI_CLEANUP_V2";
         case OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN_V2:
            return "OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN_V2";
         case OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_V2:
            return "OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_V2";
         case OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_V2:
            return "OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_V2";
         case OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG_V2:
            return "OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG_V2";
         case OPCODE_COMMON_ISCSI_DEFQ_CREATE_V2:
            return "OPCODE_COMMON_ISCSI_DEFQ_CREATE_V2";
         case OPCODE_COMMON_ISCSI_DEFQ_DESTROY_V2:
            return "OPCODE_COMMON_ISCSI_DEFQ_DESTROY_V2";
         case OPCODE_COMMON_ISCSI_WRBQ_CREATE_V2:
            return "OPCODE_COMMON_ISCSI_WRBQ_CREATE_V2";
         case OPCODE_COMMON_ISCSI_WRBQ_DESTROY_V2:
            return "OPCODE_COMMON_ISCSI_WRBQ_DESTROY_V2";
         case OPCODE_COMMON_ISCSI_NTWK_SET_MTU_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_MTU_V2";
         case OPCODE_COMMON_ISCSI_NTWK_GET_MTU_V2:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_MTU_V2";
         case OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_V2:
            return "OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_V2";
         case OPCODE_COMMON_ISCSI_TCP_DISCONNECT_V2:
            return "OPCODE_COMMON_ISCSI_TCP_DISCONNECT_V2";
         case OPCODE_COMMON_ISCSI_SET_TCP_PARAMETERS_V2:
            return "OPCODE_COMMON_ISCSI_SET_TCP_PARAMETERS_V2";
         case OPCODE_COMMON_ISCSI_CONNECTION_UPDATE_V2:
            return "OPCODE_COMMON_ISCSI_CONNECTION_UPDATE_V2";
         case OPCODE_COMMON_ISCSI_GET_CONNECTION_INFO_V2:
            return "OPCODE_COMMON_ISCSI_GET_CONNECTION_INFO_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ISCSI_INI_SUBSYSTEM_OPCODES ---
#define OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_V2 (1) 
#define OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_V2 (2) 
#define OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_V2 (4) 
#define OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT_V2 (5) 
#define SUBSYSTEM_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_COUNT_V2 (6) 
#define OPCODE_ISCSI_INI_CFG_GET_HBA_NAME_V2 (6)  
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_NAME_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_SET_HBA_NAME_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_SET_HBA_TIME_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_CHAP_SECRET_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_SET_CHAP_SECRET_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_STATUS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_SESSIONS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_SESSION_LIST_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_A_SESSION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_CONFIGURATION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_SET_CONFIGURATION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_CLOSE_CONNECTION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_LOGIN_TARGET_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_LOGOUT_TARGET_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_SEND_TARGETS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_A_SESSION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_A_CONN_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_OFFLOAD_SESSION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_OFFLOAD_CONN_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BOOT_TARGET_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BOOT_TARGET_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BOOT_LUN_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BOOT_LUN_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_READ_WRITE_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SCSI_PASS_THRU_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_V2 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_PCIE_INFO_V2 (6) 
#define OPCODE_ISCSI_INI_CFG_SET_HBA_NAME_V2 (7)  
#define OPCODE_ISCSI_INI_CFG_SET_HBA_TIME_V2 (8)  
#define OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET_V2 (9) 
#define OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET_V2 (10) 
#define OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS_V2 (11) 
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS_V2 (12) 
#define OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST_V2 (13) 
#define OPCODE_ISCSI_INI_SESSION_GET_A_SESSION_V2 (14) 
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_V2 (15) 
#define OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_V2 (16) 
#define OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION_V2 (17) 
#define OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_V2 (18) 
#define OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_V2 (19) 
#define OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_V2 (20) 
#define OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_V2 (21) 
#define OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION_V2 (22) 
#define OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET_V2 (23) 
#define OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET_V2 (24) 
#define OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_V2 (25) 
#define OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_V2 (26) 
#define OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_V2 (27) 
#define OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_V2 (28) 
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_V2 (29) 
#define OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_V2 (30) 
#define OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_V2 (31) 
#define OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_V2 (32) 
#define OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS_V2 (33) 
#define OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_V2 (34) 
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION_V2 (35) 
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_V2 (36) 
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN_V2 (37) 
#define OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_V2 (38) 
#define OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_V2 (39) 
#define OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_V2 (40) 
#define OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION_V2 (41) 
#define OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_V2 (42) 
#define OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN_V2 (43) 
#define OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_V2 (44) 
#define OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_V2 (45) 
#define OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_V2 (46) 
#define OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_V2 (47) 
#define OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_V2 (48) 
#define OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_V2 (49) 
#define OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_V2 (50) 
#define OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_V2 (51) 
#define OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET_V2 (52) 
#define OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET_V2 (53) 
#define OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN_V2 (54) 
#define OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN_V2 (55) 
#define OPCODE_ISCSI_INI_BOOT_READ_WRITE_V2 (56)  
#define OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_V2 (57) 
#define OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_V2 (58) 
#define OPCODE_ISCSI_INI_SCSI_PASS_THRU_V2 (59)   
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_V2 (60) 
#define OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_V2 (61) 
#define OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO_V2 (62) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* iscsi_ini_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_V2:
            return "OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_V2";
         case OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_V2:
            return "OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_V2";
         case OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_V2:
            return "OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_V2";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT_V2:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT_V2";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_NAME_V2:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_NAME_V2";
         case OPCODE_ISCSI_INI_CFG_SET_HBA_NAME_V2:
            return "OPCODE_ISCSI_INI_CFG_SET_HBA_NAME_V2";
         case OPCODE_ISCSI_INI_CFG_SET_HBA_TIME_V2:
            return "OPCODE_ISCSI_INI_CFG_SET_HBA_TIME_V2";
         case OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET_V2:
            return "OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET_V2";
         case OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET_V2:
            return "OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET_V2";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS_V2:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS_V2";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS_V2:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS_V2";
         case OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST_V2:
            return "OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST_V2";
         case OPCODE_ISCSI_INI_SESSION_GET_A_SESSION_V2:
            return "OPCODE_ISCSI_INI_SESSION_GET_A_SESSION_V2";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_V2:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_V2";
         case OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_V2:
            return "OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_V2";
         case OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION_V2:
            return "OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION_V2";
         case OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_V2:
            return "OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_V2";
         case OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_V2:
            return "OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_V2";
         case OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_V2:
            return "OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_V2";
         case OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_V2:
            return "OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_V2";
         case OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION_V2:
            return "OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION_V2";
         case OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET_V2:
            return "OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET_V2";
         case OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET_V2:
            return "OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET_V2";
         case OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_V2:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_V2";
         case OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_V2:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_V2";
         case OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_V2:
            return "OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_V2";
         case OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_V2:
            return "OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_V2";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_V2:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_V2";
         case OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_V2:
            return "OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_V2";
         case OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_V2:
            return "OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_V2";
         case OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_V2:
            return "OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_V2";
         case OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS_V2:
            return "OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS_V2";
         case OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_V2:
            return "OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_V2";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION_V2:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION_V2";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_V2:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_V2";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN_V2:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN_V2";
         case OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_V2:
            return "OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_V2";
         case OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_V2:
            return "OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_V2";
         case OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_V2:
            return "OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_V2";
         case OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION_V2:
            return "OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION_V2";
         case OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_V2:
            return "OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_V2";
         case OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN_V2:
            return "OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN_V2";
         case OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_V2:
            return "OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_V2";
         case OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_V2:
            return "OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_V2";
         case OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_V2:
            return "OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_V2";
         case OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_V2:
            return "OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_V2";
         case OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_V2:
            return "OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_V2";
         case OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_V2:
            return "OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_V2";
         case OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_V2:
            return "OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_V2";
         case OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_V2:
            return "OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_V2";
         case OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET_V2:
            return "OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET_V2";
         case OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET_V2:
            return "OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET_V2";
         case OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN_V2:
            return "OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN_V2";
         case OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN_V2:
            return "OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN_V2";
         case OPCODE_ISCSI_INI_BOOT_READ_WRITE_V2:
            return "OPCODE_ISCSI_INI_BOOT_READ_WRITE_V2";
         case OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_V2:
            return "OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_V2";
         case OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_V2:
            return "OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_V2";
         case OPCODE_ISCSI_INI_SCSI_PASS_THRU_V2:
            return "OPCODE_ISCSI_INI_SCSI_PASS_THRU_V2";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_V2:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_V2";
         case OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_V2:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_V2";
         case OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO_V2:
            return "OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ISCSI_TGT_SUBSYSTEM_OPCODES ---
#define OPCODE_ISCSI_TGT_START_LISTEN_SERVER_V2 (1) 
#define OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER_V2 (2) 
#define OPCODE_ISCSI_TGT_GET_CONNECTION_INFO_V2 (3) 
#define OPCODE_ISCSI_TGT_CONNECTION_REJECT_V2 (4) 
#define OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION_V2 (5) 
#define OPCODE_ISCSI_TGT_ISNS_SEND_PACKET_V2 (6)  
#define SUBSYSTEM_ISCSI_TGT_START_LISTEN_SERVER_V2 (7) 
#define SUBSYSTEM_ISCSI_TGT_STOP_LISTEN_SERVER_V2 (7) 
#define SUBSYSTEM_ISCSI_TGT_GET_CONNECTION_INFO_V2 (7) 
#define SUBSYSTEM_ISCSI_TGT_CONNECTION_REJECT_V2 (7) 
#define SUBSYSTEM_ISCSI_TGT_OFFLOAD_CONNECTION_V2 (7) 
#define SUBSYSTEM_ISCSI_TGT_ISNS_SEND_PACKET_V2 (7) 
#define OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION_V2 (7) 
#define SUBSYSTEM_ISCSI_TGT_INVALIDATE_CONNECTION_V2 (7) 
#define SUBSYSTEM_ISCSI_TGT_ADD_IP_ADDR_V2 (7)    
#define SUBSYSTEM_ISCSI_TGT_DELETE_IP_ADDR_V2 (7) 
#define SUBSYSTEM_ISCSI_TGT_LIST_IP_ADDR_V2 (7)   
#define SUBSYSTEM_ISCSI_TGT_START_ESI_LISTEN_V2 (7) 
#define SUBSYSTEM_ISCSI_TGT_STOP_ESI_LISTEN_V2 (7) 
#define SUBSYSTEM_ISCSI_TGT_SLP_REGISTER_V2 (7)   
#define SUBSYSTEM_ISCSI_TGT_SLP_DEREGISTER_V2 (7) 
#define OPCODE_ISCSI_TGT_ADD_IP_ADDR_V2 (8)       
#define OPCODE_ISCSI_TGT_DELETE_IP_ADDR_V2 (9)    
#define OPCODE_ISCSI_TGT_LIST_IP_ADDR_V2 (10)     
#define OPCODE_ISCSI_TGT_START_ESI_LISTEN_V2 (11) 
#define OPCODE_ISCSI_TGT_STOP_ESI_LISTEN_V2 (12)  
#define OPCODE_ISCSI_TGT_SLP_REGISTER_V2 (13)     
#define OPCODE_ISCSI_TGT_SLP_DEREGISTER_V2 (14)   

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* iscsi_tgt_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ISCSI_TGT_START_LISTEN_SERVER_V2:
            return "OPCODE_ISCSI_TGT_START_LISTEN_SERVER_V2";
         case OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER_V2:
            return "OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER_V2";
         case OPCODE_ISCSI_TGT_GET_CONNECTION_INFO_V2:
            return "OPCODE_ISCSI_TGT_GET_CONNECTION_INFO_V2";
         case OPCODE_ISCSI_TGT_CONNECTION_REJECT_V2:
            return "OPCODE_ISCSI_TGT_CONNECTION_REJECT_V2";
         case OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION_V2:
            return "OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION_V2";
         case OPCODE_ISCSI_TGT_ISNS_SEND_PACKET_V2:
            return "OPCODE_ISCSI_TGT_ISNS_SEND_PACKET_V2";
         case OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION_V2:
            return "OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION_V2";
         case OPCODE_ISCSI_TGT_ADD_IP_ADDR_V2:
            return "OPCODE_ISCSI_TGT_ADD_IP_ADDR_V2";
         case OPCODE_ISCSI_TGT_DELETE_IP_ADDR_V2:
            return "OPCODE_ISCSI_TGT_DELETE_IP_ADDR_V2";
         case OPCODE_ISCSI_TGT_LIST_IP_ADDR_V2:
            return "OPCODE_ISCSI_TGT_LIST_IP_ADDR_V2";
         case OPCODE_ISCSI_TGT_START_ESI_LISTEN_V2:
            return "OPCODE_ISCSI_TGT_START_ESI_LISTEN_V2";
         case OPCODE_ISCSI_TGT_STOP_ESI_LISTEN_V2:
            return "OPCODE_ISCSI_TGT_STOP_ESI_LISTEN_V2";
         case OPCODE_ISCSI_TGT_SLP_REGISTER_V2:
            return "OPCODE_ISCSI_TGT_SLP_REGISTER_V2";
         case OPCODE_ISCSI_TGT_SLP_DEREGISTER_V2:
            return "OPCODE_ISCSI_TGT_SLP_DEREGISTER_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- MILI_PTL_SUBSYSTEM_OPCODES ---
#define OPCODE_MILI_PTL_CREATE_PORTAL_V2 (1)      
#define OPCODE_MILI_PTL_DELETE_PORTAL_V2 (2)      
#define OPCODE_MILI_PTL_CREATE_PORTAL_GROUP_V2 (3) 
#define OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_V2 (4) 
#define OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_V2 (5) 
#define OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_V2 (6) 
#define OPCODE_MILI_PTL_ADD_TARGET_V2   (7)       
#define SUBSYSTEM_MILI_PTL_CREATE_PORTAL_V2 (8)   
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_V2 (8)   
#define SUBSYSTEM_MILI_PTL_CREATE_PORTAL_GROUP_V2 (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_GROUP_V2 (8) 
#define SUBSYSTEM_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_V2 (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_V2 (8) 
#define SUBSYSTEM_MILI_PTL_ADD_TARGET_V2 (8)      
#define OPCODE_MILI_PTL_DELETE_TARGET_V2 (8)      
#define SUBSYSTEM_MILI_PTL_DELETE_TARGET_V2 (8)   
#define SUBSYSTEM_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_V2 (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_V2 (8) 
#define SUBSYSTEM_MILI_PTL_SET_TARGET_LOGIN_PARAMS_V2 (8) 
#define SUBSYSTEM_MILI_PTL_START_LISTEN_SERVER_V2 (8) 
#define SUBSYSTEM_MILI_PTL_STOP_LISTEN_SERVER_V2 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_V2 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_V2 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_V2 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_V2 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_V2 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_V2 (8) 
#define SUBSYSTEM_MILI_PTL_GET_ISCSI_SESSION_LIST_V2 (8) 
#define SUBSYSTEM_MILI_PTL_KILL_SESSION_V2 (8)    
#define OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_V2 (9) 
#define OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_V2 (10) 
#define OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS_V2 (11) 
#define OPCODE_MILI_PTL_START_LISTEN_SERVER_V2 (12) 
#define OPCODE_MILI_PTL_STOP_LISTEN_SERVER_V2 (13) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_V2 (14) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_V2 (15) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_V2 (16) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_V2 (17) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_V2 (18) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_V2 (19) 
#define OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST_V2 (20) 
#define OPCODE_MILI_PTL_KILL_SESSION_V2 (21)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mili_ptl_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_MILI_PTL_CREATE_PORTAL_V2:
            return "OPCODE_MILI_PTL_CREATE_PORTAL_V2";
         case OPCODE_MILI_PTL_DELETE_PORTAL_V2:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_V2";
         case OPCODE_MILI_PTL_CREATE_PORTAL_GROUP_V2:
            return "OPCODE_MILI_PTL_CREATE_PORTAL_GROUP_V2";
         case OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_V2:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_V2";
         case OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_V2:
            return "OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_V2";
         case OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_V2:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_V2";
         case OPCODE_MILI_PTL_ADD_TARGET_V2:
            return "OPCODE_MILI_PTL_ADD_TARGET_V2";
         case OPCODE_MILI_PTL_DELETE_TARGET_V2:
            return "OPCODE_MILI_PTL_DELETE_TARGET_V2";
         case OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_V2:
            return "OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_V2";
         case OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_V2:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_V2";
         case OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS_V2:
            return "OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS_V2";
         case OPCODE_MILI_PTL_START_LISTEN_SERVER_V2:
            return "OPCODE_MILI_PTL_START_LISTEN_SERVER_V2";
         case OPCODE_MILI_PTL_STOP_LISTEN_SERVER_V2:
            return "OPCODE_MILI_PTL_STOP_LISTEN_SERVER_V2";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_V2:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_V2";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_V2:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_V2";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_V2:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_V2";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_V2:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_V2";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_V2:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_V2";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_V2:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_V2";
         case OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST_V2:
            return "OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST_V2";
         case OPCODE_MILI_PTL_KILL_SESSION_V2:
            return "OPCODE_MILI_PTL_KILL_SESSION_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- MILI_TMD_SUBSYSTEM_OPCODES ---
#define OPCODE_MILI_TMD_ADD_TARGET_V2   (1)       
#define OPCODE_MILI_TMD_DELETE_TARGET_V2 (2)      
#define OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_V2 (3) 
#define OPCODE_MILI_TMD_ADD_INITIATOR_V2 (4)      
#define OPCODE_MILI_TMD_DELETE_INITIATOR_V2 (5)   
#define OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_V2 (6) 
#define OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET_V2 (7) 
#define OPCODE_MILI_TMD_DELETE_IT_BINDING_V2 (8)  
#define SUBSYSTEM_MILI_TMD_ADD_TARGET_V2 (9)      
#define SUBSYSTEM_MILI_TMD_DELETE_TARGET_V2 (9)   
#define SUBSYSTEM_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_V2 (9) 
#define SUBSYSTEM_MILI_TMD_ADD_INITIATOR_V2 (9)   
#define SUBSYSTEM_MILI_TMD_DELETE_INITIATOR_V2 (9) 
#define SUBSYSTEM_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_V2 (9) 
#define SUBSYSTEM_MILI_TMD_BIND_INITIATOR_TO_TARGET_V2 (9) 
#define SUBSYSTEM_MILI_TMD_DELETE_IT_BINDING_V2 (9) 
#define OPCODE_MILI_TMD_ACTIVATE_TARGET_V2 (9)    
#define SUBSYSTEM_MILI_TMD_ACTIVATE_TARGET_V2 (9) 
#define SUBSYSTEM_MILI_TMD_DEACTIVATE_TARGET_V2 (9) 
#define SUBSYSTEM_MILI_TMD_SET_INITIATOR_QOS_V2 (9) 
#define OPCODE_MILI_TMD_DEACTIVATE_TARGET_V2 (10) 
#define OPCODE_MILI_TMD_SET_INITIATOR_QOS_V2 (11) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mili_tmd_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_MILI_TMD_ADD_TARGET_V2:
            return "OPCODE_MILI_TMD_ADD_TARGET_V2";
         case OPCODE_MILI_TMD_DELETE_TARGET_V2:
            return "OPCODE_MILI_TMD_DELETE_TARGET_V2";
         case OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_V2:
            return "OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_V2";
         case OPCODE_MILI_TMD_ADD_INITIATOR_V2:
            return "OPCODE_MILI_TMD_ADD_INITIATOR_V2";
         case OPCODE_MILI_TMD_DELETE_INITIATOR_V2:
            return "OPCODE_MILI_TMD_DELETE_INITIATOR_V2";
         case OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_V2:
            return "OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_V2";
         case OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET_V2:
            return "OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET_V2";
         case OPCODE_MILI_TMD_DELETE_IT_BINDING_V2:
            return "OPCODE_MILI_TMD_DELETE_IT_BINDING_V2";
         case OPCODE_MILI_TMD_ACTIVATE_TARGET_V2:
            return "OPCODE_MILI_TMD_ACTIVATE_TARGET_V2";
         case OPCODE_MILI_TMD_DEACTIVATE_TARGET_V2:
            return "OPCODE_MILI_TMD_DEACTIVATE_TARGET_V2";
         case OPCODE_MILI_TMD_SET_INITIATOR_QOS_V2:
            return "OPCODE_MILI_TMD_SET_INITIATOR_QOS_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- VNTAG_SUBSYSTEM_OPCODES ---
#define OPCODE_VNTAG_GET_CAPABILITY_V2  (1)       
#define OPCODE_VNTAG_SET_CAPABILITY_V2  (2)       
#define OPCODE_VNTAG_GET_PROVISIONING_INFO_V2 (3) 
#define OPCODE_VNTAG_SET_PROVISIONING_INFO_V2 (4) 
#define SUBSYSTEM_VNTAG_GET_CAPABILITY_V2 (20)    
#define SUBSYSTEM_VNTAG_SET_CAPABILITY_V2 (20)    
#define SUBSYSTEM_VNTAG_GET_PROVISIONING_INFO_V2 (20) 
#define SUBSYSTEM_VNTAG_SET_PROVISIONING_INFO_V2 (20) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* vntag_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_VNTAG_GET_CAPABILITY_V2:
            return "OPCODE_VNTAG_GET_CAPABILITY_V2";
         case OPCODE_VNTAG_SET_CAPABILITY_V2:
            return "OPCODE_VNTAG_SET_CAPABILITY_V2";
         case OPCODE_VNTAG_GET_PROVISIONING_INFO_V2:
            return "OPCODE_VNTAG_GET_PROVISIONING_INFO_V2";
         case OPCODE_VNTAG_SET_PROVISIONING_INFO_V2:
            return "OPCODE_VNTAG_SET_PROVISIONING_INFO_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ETH_SUBSYSTEM_OPCODES ---
#define OPCODE_ETH_RSS_CONFIG_V2        (1)       
#define OPCODE_ETH_ACPI_CONFIG_V2       (2)       
#define SUBSYSTEM_ETH_RSS_CONFIG_V2     (3)       
#define SUBSYSTEM_ETH_ACPI_CONFIG_V2    (3)       
#define OPCODE_ETH_PROMISCUOUS_V2       (3)       
#define SUBSYSTEM_ETH_PROMISCUOUS_V2    (3)       
#define SUBSYSTEM_ETH_GET_STATISTICS_V2 (3)       
#define SUBSYSTEM_ETH_TX_CREATE_V2      (3)       
#define SUBSYSTEM_ETH_RX_CREATE_V2      (3)       
#define SUBSYSTEM_ETH_TX_DESTROY_V2     (3)       
#define SUBSYSTEM_ETH_RX_DESTROY_V2     (3)       
#define SUBSYSTEM_ETH_GET_QPGE_STATISTICS_V2 (3)  
#define SUBSYSTEM_ETH_ACPI_WOL_MAGIC_CONFIG_V2 (3) 
#define SUBSYSTEM_ETH_NETWORK_STATS_V2  (3)       
#define SUBSYSTEM_ETH_GET_PPORT_STATS_V2 (3)      
#define SUBSYSTEM_ETH_PG_FEATURE_QUERY_REQUEST_V2 (3) 
#define SUBSYSTEM_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_V2 (3) 
#define SUBSYSTEM_ETH_QUERY_LRO_CONFIG_V2 (3)     
#define SUBSYSTEM_ETH_GET_IFACE_LRO_CONFIG_V2 (3) 
#define SUBSYSTEM_ETH_OFFLOAD_PLRO_V2   (3)       
#define SUBSYSTEM_ETH_UPLOAD_PLRO_V2    (3)       
#define SUBSYSTEM_ETH_SET_IFACE_LRO_CONFIG_V2 (3) 
#define SUBSYSTEM_ETH_GET_LRO_STATS_V2  (3)       
#define OPCODE_ETH_GET_STATISTICS_V2    (4)       
#define OPCODE_ETH_TX_CREATE_V2         (7)       
#define OPCODE_ETH_RX_CREATE_V2         (8)       
#define OPCODE_ETH_TX_DESTROY_V2        (9)       
#define OPCODE_ETH_RX_DESTROY_V2        (10)      
#define OPCODE_ETH_GET_QPGE_STATISTICS_V2 (11)    
#define OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG_V2 (12)  
#define OPCODE_ETH_NETWORK_STATS_V2     (13)      
#define OPCODE_ETH_GET_PPORT_STATS_V2   (18)      
#define OPCODE_ETH_PG_FEATURE_QUERY_REQUEST_V2 (23) 
#define OPCODE_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_V2 (24) 
#define OPCODE_ETH_QUERY_LRO_CONFIG_V2  (32)      
#define OPCODE_ETH_GET_IFACE_LRO_CONFIG_V2 (35)   
#define OPCODE_ETH_OFFLOAD_PLRO_V2      (36)      
#define OPCODE_ETH_UPLOAD_PLRO_V2       (37)      
#define OPCODE_ETH_SET_IFACE_LRO_CONFIG_V2 (38)   
#define OPCODE_ETH_GET_LRO_STATS_V2     (39)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* eth_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ETH_RSS_CONFIG_V2:
            return "OPCODE_ETH_RSS_CONFIG_V2";
         case OPCODE_ETH_ACPI_CONFIG_V2:
            return "OPCODE_ETH_ACPI_CONFIG_V2";
         case OPCODE_ETH_PROMISCUOUS_V2:
            return "OPCODE_ETH_PROMISCUOUS_V2";
         case OPCODE_ETH_GET_STATISTICS_V2:
            return "OPCODE_ETH_GET_STATISTICS_V2";
         case OPCODE_ETH_TX_CREATE_V2:
            return "OPCODE_ETH_TX_CREATE_V2";
         case OPCODE_ETH_RX_CREATE_V2:
            return "OPCODE_ETH_RX_CREATE_V2";
         case OPCODE_ETH_TX_DESTROY_V2:
            return "OPCODE_ETH_TX_DESTROY_V2";
         case OPCODE_ETH_RX_DESTROY_V2:
            return "OPCODE_ETH_RX_DESTROY_V2";
         case OPCODE_ETH_GET_QPGE_STATISTICS_V2:
            return "OPCODE_ETH_GET_QPGE_STATISTICS_V2";
         case OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG_V2:
            return "OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG_V2";
         case OPCODE_ETH_NETWORK_STATS_V2:
            return "OPCODE_ETH_NETWORK_STATS_V2";
         case OPCODE_ETH_GET_PPORT_STATS_V2:
            return "OPCODE_ETH_GET_PPORT_STATS_V2";
         case OPCODE_ETH_PG_FEATURE_QUERY_REQUEST_V2:
            return "OPCODE_ETH_PG_FEATURE_QUERY_REQUEST_V2";
         case OPCODE_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_V2:
            return "OPCODE_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_V2";
         case OPCODE_ETH_QUERY_LRO_CONFIG_V2:
            return "OPCODE_ETH_QUERY_LRO_CONFIG_V2";
         case OPCODE_ETH_GET_IFACE_LRO_CONFIG_V2:
            return "OPCODE_ETH_GET_IFACE_LRO_CONFIG_V2";
         case OPCODE_ETH_OFFLOAD_PLRO_V2:
            return "OPCODE_ETH_OFFLOAD_PLRO_V2";
         case OPCODE_ETH_UPLOAD_PLRO_V2:
            return "OPCODE_ETH_UPLOAD_PLRO_V2";
         case OPCODE_ETH_SET_IFACE_LRO_CONFIG_V2:
            return "OPCODE_ETH_SET_IFACE_LRO_CONFIG_V2";
         case OPCODE_ETH_GET_LRO_STATS_V2:
            return "OPCODE_ETH_GET_LRO_STATS_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LRO_SUBSYSTEM_OPCODES ---
#define OPCODE_LRO_RING_CREATE_V2       (1)       
#define OPCODE_LRO_CONFIG_V2            (2)       
#define OPCODE_LRO_GET_STATISTICS_V2    (3)       
#define OPCODE_LRO_RING_DESTROY_V2      (4)       
#define SUBSYSTEM_LRO_RING_CREATE_V2    (13)      
#define SUBSYSTEM_LRO_CONFIG_V2         (13)      
#define SUBSYSTEM_LRO_GET_STATISTICS_V2 (13)      
#define SUBSYSTEM_LRO_RING_DESTROY_V2   (13)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lro_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LRO_RING_CREATE_V2:
            return "OPCODE_LRO_RING_CREATE_V2";
         case OPCODE_LRO_CONFIG_V2:
            return "OPCODE_LRO_CONFIG_V2";
         case OPCODE_LRO_GET_STATISTICS_V2:
            return "OPCODE_LRO_GET_STATISTICS_V2";
         case OPCODE_LRO_RING_DESTROY_V2:
            return "OPCODE_LRO_RING_DESTROY_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DAL_SUBSYSTEM_OPCODES ---
#define OPCODE_DAL_GET_PARAMETERS_V2    (1)       
#define OPCODE_DAL_DRIVER_LOAD_V2       (2)       
#define OPCODE_DAL_DRIVER_UNLOAD_V2     (3)       
#define OPCODE_DAL_QP_CREATE_V2         (4)       
#define OPCODE_DAL_QP_DESTROY_V2        (5)       
#define OPCODE_DAL_MR_REGISTER_V2       (6)       
#define OPCODE_DAL_MR_UNREGISTER_V2     (7)       
#define OPCODE_DAL_QP_MODIFY_RTS_V2     (8)       
#define OPCODE_DAL_QP_MODIFY_RTR_V2     (9)       
#define OPCODE_DAL_MULTICAST_JOIN_V2    (10)      
#define OPCODE_DAL_MULTICAST_LEAVE_V2   (11)      
#define SUBSYSTEM_DAL_GET_PARAMETERS_V2 (14)      
#define SUBSYSTEM_DAL_DRIVER_LOAD_V2    (14)      
#define SUBSYSTEM_DAL_DRIVER_UNLOAD_V2  (14)      
#define SUBSYSTEM_DAL_QP_CREATE_V2      (14)      
#define SUBSYSTEM_DAL_QP_DESTROY_V2     (14)      
#define SUBSYSTEM_DAL_MR_REGISTER_V2    (14)      
#define SUBSYSTEM_DAL_MR_UNREGISTER_V2  (14)      
#define SUBSYSTEM_DAL_QP_MODIFY_RTS_V2  (14)      
#define SUBSYSTEM_DAL_QP_MODIFY_RTR_V2  (14)      
#define SUBSYSTEM_DAL_MULTICAST_JOIN_V2 (14)      
#define SUBSYSTEM_DAL_MULTICAST_LEAVE_V2 (14)     

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dal_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DAL_GET_PARAMETERS_V2:
            return "OPCODE_DAL_GET_PARAMETERS_V2";
         case OPCODE_DAL_DRIVER_LOAD_V2:
            return "OPCODE_DAL_DRIVER_LOAD_V2";
         case OPCODE_DAL_DRIVER_UNLOAD_V2:
            return "OPCODE_DAL_DRIVER_UNLOAD_V2";
         case OPCODE_DAL_QP_CREATE_V2:
            return "OPCODE_DAL_QP_CREATE_V2";
         case OPCODE_DAL_QP_DESTROY_V2:
            return "OPCODE_DAL_QP_DESTROY_V2";
         case OPCODE_DAL_MR_REGISTER_V2:
            return "OPCODE_DAL_MR_REGISTER_V2";
         case OPCODE_DAL_MR_UNREGISTER_V2:
            return "OPCODE_DAL_MR_UNREGISTER_V2";
         case OPCODE_DAL_QP_MODIFY_RTS_V2:
            return "OPCODE_DAL_QP_MODIFY_RTS_V2";
         case OPCODE_DAL_QP_MODIFY_RTR_V2:
            return "OPCODE_DAL_QP_MODIFY_RTR_V2";
         case OPCODE_DAL_MULTICAST_JOIN_V2:
            return "OPCODE_DAL_MULTICAST_JOIN_V2";
         case OPCODE_DAL_MULTICAST_LEAVE_V2:
            return "OPCODE_DAL_MULTICAST_LEAVE_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- TOE_SUBSYSTEM_OPCODES ---
#define OPCODE_TOE_CONNECTION_OFFLOAD_V2 (1)      
#define OPCODE_TOE_CONNECTION_UPDATE_V2 (3)       
#define SUBSYSTEM_TOE_CONNECTION_OFFLOAD_V2 (4)   
#define SUBSYSTEM_TOE_CONNECTION_UPDATE_V2 (4)    
#define OPCODE_TOE_GET_STATISTICS_V2    (4)       
#define SUBSYSTEM_TOE_GET_STATISTICS_V2 (4)       
#define SUBSYSTEM_TOE_CONNECTION_QUERY_V2 (4)     
#define SUBSYSTEM_TOE_WRBQ_CREATE_V2    (4)       
#define SUBSYSTEM_TOE_RQ_CREATE_V2      (4)       
#define SUBSYSTEM_TOE_DEFQ_CREATE_V2    (4)       
#define SUBSYSTEM_TOE_WRBQ_DESTROY_V2   (4)       
#define SUBSYSTEM_TOE_RQ_DESTROY_V2     (4)       
#define SUBSYSTEM_TOE_DEFQ_DESTROY_V2   (4)       
#define OPCODE_TOE_CONNECTION_QUERY_V2  (5)       
#define OPCODE_TOE_WRBQ_CREATE_V2       (6)       
#define OPCODE_TOE_RQ_CREATE_V2         (7)       
#define OPCODE_TOE_DEFQ_CREATE_V2       (8)       
#define OPCODE_TOE_WRBQ_DESTROY_V2      (9)       
#define OPCODE_TOE_RQ_DESTROY_V2        (10)      
#define OPCODE_TOE_DEFQ_DESTROY_V2      (11)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* toe_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_TOE_CONNECTION_OFFLOAD_V2:
            return "OPCODE_TOE_CONNECTION_OFFLOAD_V2";
         case OPCODE_TOE_CONNECTION_UPDATE_V2:
            return "OPCODE_TOE_CONNECTION_UPDATE_V2";
         case OPCODE_TOE_GET_STATISTICS_V2:
            return "OPCODE_TOE_GET_STATISTICS_V2";
         case OPCODE_TOE_CONNECTION_QUERY_V2:
            return "OPCODE_TOE_CONNECTION_QUERY_V2";
         case OPCODE_TOE_WRBQ_CREATE_V2:
            return "OPCODE_TOE_WRBQ_CREATE_V2";
         case OPCODE_TOE_RQ_CREATE_V2:
            return "OPCODE_TOE_RQ_CREATE_V2";
         case OPCODE_TOE_DEFQ_CREATE_V2:
            return "OPCODE_TOE_DEFQ_CREATE_V2";
         case OPCODE_TOE_WRBQ_DESTROY_V2:
            return "OPCODE_TOE_WRBQ_DESTROY_V2";
         case OPCODE_TOE_RQ_DESTROY_V2:
            return "OPCODE_TOE_RQ_DESTROY_V2";
         case OPCODE_TOE_DEFQ_DESTROY_V2:
            return "OPCODE_TOE_DEFQ_DESTROY_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- PXE_UNDI_SUBSYSTEM_OPCODES ---
#define OPCODE_PXE_UNDI_CONTROL_V2      (1)       
#define OPCODE_PXE_UNDI_TRANSMIT_V2     (2)       
#define OPCODE_PXE_UNDI_RECEIVE_V2      (3)       
#define OPCODE_PXE_UNDI_GET_STATISTICS_V2 (4)     
#define SUBSYSTEM_PXE_UNDI_CONTROL_V2   (5)       
#define SUBSYSTEM_PXE_UNDI_TRANSMIT_V2  (5)       
#define SUBSYSTEM_PXE_UNDI_RECEIVE_V2   (5)       
#define SUBSYSTEM_PXE_UNDI_GET_STATISTICS_V2 (5)  
#define OPCODE_PXE_UNDI_SET_VLAN_V2     (5)       
#define SUBSYSTEM_PXE_UNDI_SET_VLAN_V2  (5)       
#define SUBSYSTEM_PXE_UNDI_GET_VLAN_V2  (5)       
#define OPCODE_PXE_UNDI_GET_VLAN_V2     (6)       

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* pxe_undi_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_PXE_UNDI_CONTROL_V2:
            return "OPCODE_PXE_UNDI_CONTROL_V2";
         case OPCODE_PXE_UNDI_TRANSMIT_V2:
            return "OPCODE_PXE_UNDI_TRANSMIT_V2";
         case OPCODE_PXE_UNDI_RECEIVE_V2:
            return "OPCODE_PXE_UNDI_RECEIVE_V2";
         case OPCODE_PXE_UNDI_GET_STATISTICS_V2:
            return "OPCODE_PXE_UNDI_GET_STATISTICS_V2";
         case OPCODE_PXE_UNDI_SET_VLAN_V2:
            return "OPCODE_PXE_UNDI_SET_VLAN_V2";
         case OPCODE_PXE_UNDI_GET_VLAN_V2:
            return "OPCODE_PXE_UNDI_GET_VLAN_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- RDMA_SUBSYSTEM_OPCODES ---
#define OPCODE_RDMA_QUERY_CONFIG_V2     (1)       
#define OPCODE_RDMA_ALLOC_PD_V2         (2)       
#define OPCODE_RDMA_DEALLOC_PD_V2       (3)       
#define OPCODE_RDMA_CREATE_AHR_V2       (4)       
#define OPCODE_RDMA_DESTROY_AHR_V2      (5)       
#define OPCODE_RDMA_CREATE_QP_V2        (6)       
#define OPCODE_RDMA_QUERY_QP_V2         (7)       
#define OPCODE_RDMA_MODIFY_QP_V2        (8)       
#define OPCODE_RDMA_DESTROY_QP_V2       (9)       
#define SUBSYSTEM_RDMA_QUERY_CONFIG_V2  (10)      
#define SUBSYSTEM_RDMA_ALLOC_PD_V2      (10)      
#define SUBSYSTEM_RDMA_DEALLOC_PD_V2    (10)      
#define SUBSYSTEM_RDMA_CREATE_AHR_V2    (10)      
#define SUBSYSTEM_RDMA_DESTROY_AHR_V2   (10)      
#define SUBSYSTEM_RDMA_CREATE_QP_V2     (10)      
#define SUBSYSTEM_RDMA_QUERY_QP_V2      (10)      
#define SUBSYSTEM_RDMA_MODIFY_QP_V2     (10)      
#define SUBSYSTEM_RDMA_DESTROY_QP_V2    (10)      
#define OPCODE_RDMA_MODIFY_CQ_V2        (10)      
#define SUBSYSTEM_RDMA_MODIFY_CQ_V2     (10)      
#define SUBSYSTEM_RDMA_ALLOC_STAG_V2    (10)      
#define SUBSYSTEM_RDMA_DEALLOC_STAG_V2  (10)      
#define SUBSYSTEM_RDMA_REGISTER_NSMR_V2 (10)      
#define SUBSYSTEM_RDMA_REREGISTER_NSMR_V2 (10)    
#define SUBSYSTEM_RDMA_REGISTER_NSMR_CONT_V2 (10) 
#define SUBSYSTEM_RDMA_QUERY_NSMR_V2    (10)      
#define SUBSYSTEM_RDMA_ALLOC_MW_V2      (10)      
#define SUBSYSTEM_RDMA_QUERY_MW_V2      (10)      
#define SUBSYSTEM_RDMA_CREATE_SRQ_V2    (10)      
#define SUBSYSTEM_RDMA_QUERY_SRQ_V2     (10)      
#define SUBSYSTEM_RDMA_MODIFY_SRQ_V2    (10)      
#define SUBSYSTEM_RDMA_DESTROY_SRQ_V2   (10)      
#define SUBSYSTEM_RDMA_ATTACH_MGID_V2   (10)      
#define SUBSYSTEM_RDMA_DETACH_MGID_V2   (10)      
#define SUBSYSTEM_RDMA_CREATE_RBQ_V2    (10)      
#define SUBSYSTEM_RDMA_DESTROY_RBQ_V2   (10)      
#define OPCODE_RDMA_ALLOC_STAG_V2       (11)      
#define OPCODE_RDMA_DEALLOC_STAG_V2     (12)      
#define OPCODE_RDMA_REGISTER_NSMR_V2    (13)      
#define OPCODE_RDMA_REREGISTER_NSMR_V2  (14)      
#define OPCODE_RDMA_REGISTER_NSMR_CONT_V2 (15)    
#define OPCODE_RDMA_QUERY_NSMR_V2       (16)      
#define OPCODE_RDMA_ALLOC_MW_V2         (17)      
#define OPCODE_RDMA_QUERY_MW_V2         (18)      
#define OPCODE_RDMA_CREATE_SRQ_V2       (19)      
#define OPCODE_RDMA_QUERY_SRQ_V2        (20)      
#define OPCODE_RDMA_MODIFY_SRQ_V2       (21)      
#define OPCODE_RDMA_DESTROY_SRQ_V2      (22)      
#define OPCODE_RDMA_ATTACH_MGID_V2      (23)      
#define OPCODE_RDMA_DETACH_MGID_V2      (24)      
#define OPCODE_RDMA_CREATE_RBQ_V2       (25)      
#define OPCODE_RDMA_DESTROY_RBQ_V2      (26)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* rdma_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_RDMA_QUERY_CONFIG_V2:
            return "OPCODE_RDMA_QUERY_CONFIG_V2";
         case OPCODE_RDMA_ALLOC_PD_V2:
            return "OPCODE_RDMA_ALLOC_PD_V2";
         case OPCODE_RDMA_DEALLOC_PD_V2:
            return "OPCODE_RDMA_DEALLOC_PD_V2";
         case OPCODE_RDMA_CREATE_AHR_V2:
            return "OPCODE_RDMA_CREATE_AHR_V2";
         case OPCODE_RDMA_DESTROY_AHR_V2:
            return "OPCODE_RDMA_DESTROY_AHR_V2";
         case OPCODE_RDMA_CREATE_QP_V2:
            return "OPCODE_RDMA_CREATE_QP_V2";
         case OPCODE_RDMA_QUERY_QP_V2:
            return "OPCODE_RDMA_QUERY_QP_V2";
         case OPCODE_RDMA_MODIFY_QP_V2:
            return "OPCODE_RDMA_MODIFY_QP_V2";
         case OPCODE_RDMA_DESTROY_QP_V2:
            return "OPCODE_RDMA_DESTROY_QP_V2";
         case OPCODE_RDMA_MODIFY_CQ_V2:
            return "OPCODE_RDMA_MODIFY_CQ_V2";
         case OPCODE_RDMA_ALLOC_STAG_V2:
            return "OPCODE_RDMA_ALLOC_STAG_V2";
         case OPCODE_RDMA_DEALLOC_STAG_V2:
            return "OPCODE_RDMA_DEALLOC_STAG_V2";
         case OPCODE_RDMA_REGISTER_NSMR_V2:
            return "OPCODE_RDMA_REGISTER_NSMR_V2";
         case OPCODE_RDMA_REREGISTER_NSMR_V2:
            return "OPCODE_RDMA_REREGISTER_NSMR_V2";
         case OPCODE_RDMA_REGISTER_NSMR_CONT_V2:
            return "OPCODE_RDMA_REGISTER_NSMR_CONT_V2";
         case OPCODE_RDMA_QUERY_NSMR_V2:
            return "OPCODE_RDMA_QUERY_NSMR_V2";
         case OPCODE_RDMA_ALLOC_MW_V2:
            return "OPCODE_RDMA_ALLOC_MW_V2";
         case OPCODE_RDMA_QUERY_MW_V2:
            return "OPCODE_RDMA_QUERY_MW_V2";
         case OPCODE_RDMA_CREATE_SRQ_V2:
            return "OPCODE_RDMA_CREATE_SRQ_V2";
         case OPCODE_RDMA_QUERY_SRQ_V2:
            return "OPCODE_RDMA_QUERY_SRQ_V2";
         case OPCODE_RDMA_MODIFY_SRQ_V2:
            return "OPCODE_RDMA_MODIFY_SRQ_V2";
         case OPCODE_RDMA_DESTROY_SRQ_V2:
            return "OPCODE_RDMA_DESTROY_SRQ_V2";
         case OPCODE_RDMA_ATTACH_MGID_V2:
            return "OPCODE_RDMA_ATTACH_MGID_V2";
         case OPCODE_RDMA_DETACH_MGID_V2:
            return "OPCODE_RDMA_DETACH_MGID_V2";
         case OPCODE_RDMA_CREATE_RBQ_V2:
            return "OPCODE_RDMA_CREATE_RBQ_V2";
         case OPCODE_RDMA_DESTROY_RBQ_V2:
            return "OPCODE_RDMA_DESTROY_RBQ_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LOWLEVEL_SUBSYSTEM_OPCODES ---
#define OPCODE_LOWLEVEL_CONFIG_DT_ENTRY_V2 (1)    
#define OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY_V2 (2) 
#define OPCODE_LOWLEVEL_ACCESS_MEMORY_V2 (3)      
#define OPCODE_LOWLEVEL_ACCESS_REGISTERS_V2 (4)   
#define OPCODE_LOWLEVEL_OFFLOAD_ENABLE_V2 (5)     
#define OPCODE_LOWLEVEL_CONFIG_TCP_STATE_V2 (6)   
#define OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER_V2 (7) 
#define OPCODE_LOWLEVEL_CONFIG_ISCSI_V2 (8)       
#define OPCODE_LOWLEVEL_CONFIG_TOE_V2   (9)       
#define OPCODE_LOWLEVEL_ISCSI_OFFLOAD_V2 (10)     
#define SUBSYSTEM_LOWLEVEL_CONFIG_DT_ENTRY_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_INVALIDATE_PT_ENTRY_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_ACCESS_MEMORY_V2 (11)  
#define SUBSYSTEM_LOWLEVEL_ACCESS_REGISTERS_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_OFFLOAD_ENABLE_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_CONFIG_TCP_STATE_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_CONFIG_TEMPLATE_HEADER_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_CONFIG_ISCSI_V2 (11)   
#define SUBSYSTEM_LOWLEVEL_CONFIG_TOE_V2 (11)     
#define SUBSYSTEM_LOWLEVEL_ISCSI_OFFLOAD_V2 (11)  
#define SUBSYSTEM_LOWLEVEL_MAP_UT_PAGES_V2 (11)   
#define SUBSYSTEM_LOWLEVEL_UNMAP_UT_PAGES_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_MGMT_DEBUG_LEVEL_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_MEASURE_DMA_BANDWIDTH_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_HOST_DDR_DMA_V2 (11)   
#define SUBSYSTEM_LOWLEVEL_LOOPBACK_TEST_V2 (11)  
#define SUBSYSTEM_LOWLEVEL_SET_LOOPBACK_MODE_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_GET_LOOPBACK_MODE_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_PROPERTIES_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_SEGMENT_V2 (11) 
#define SUBSYSTEM_LOWLEVEL_QUERY_SFP_SIGNALS_V2 (11) 
#define OPCODE_LOWLEVEL_MAP_UT_PAGES_V2 (13)      
#define OPCODE_LOWLEVEL_UNMAP_UT_PAGES_V2 (14)    
#define OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL_V2 (15)  
#define OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH_V2 (16) 
#define OPCODE_LOWLEVEL_HOST_DDR_DMA_V2 (17)      
#define OPCODE_LOWLEVEL_LOOPBACK_TEST_V2 (18)     
#define OPCODE_LOWLEVEL_SET_LOOPBACK_MODE_V2 (19) 
#define OPCODE_LOWLEVEL_GET_LOOPBACK_MODE_V2 (20) 
#define OPCODE_LOWLEVEL_GET_COREDUMP_PROPERTIES_V2 (21) 
#define OPCODE_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_V2 (22) 
#define OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_V2 (23) 
#define OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_V2 (24) 
#define OPCODE_LOWLEVEL_QUERY_SFP_SIGNALS_V2 (25) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lowlevel_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LOWLEVEL_CONFIG_DT_ENTRY_V2:
            return "OPCODE_LOWLEVEL_CONFIG_DT_ENTRY_V2";
         case OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY_V2:
            return "OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY_V2";
         case OPCODE_LOWLEVEL_ACCESS_MEMORY_V2:
            return "OPCODE_LOWLEVEL_ACCESS_MEMORY_V2";
         case OPCODE_LOWLEVEL_ACCESS_REGISTERS_V2:
            return "OPCODE_LOWLEVEL_ACCESS_REGISTERS_V2";
         case OPCODE_LOWLEVEL_OFFLOAD_ENABLE_V2:
            return "OPCODE_LOWLEVEL_OFFLOAD_ENABLE_V2";
         case OPCODE_LOWLEVEL_CONFIG_TCP_STATE_V2:
            return "OPCODE_LOWLEVEL_CONFIG_TCP_STATE_V2";
         case OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER_V2:
            return "OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER_V2";
         case OPCODE_LOWLEVEL_CONFIG_ISCSI_V2:
            return "OPCODE_LOWLEVEL_CONFIG_ISCSI_V2";
         case OPCODE_LOWLEVEL_CONFIG_TOE_V2:
            return "OPCODE_LOWLEVEL_CONFIG_TOE_V2";
         case OPCODE_LOWLEVEL_ISCSI_OFFLOAD_V2:
            return "OPCODE_LOWLEVEL_ISCSI_OFFLOAD_V2";
         case OPCODE_LOWLEVEL_MAP_UT_PAGES_V2:
            return "OPCODE_LOWLEVEL_MAP_UT_PAGES_V2";
         case OPCODE_LOWLEVEL_UNMAP_UT_PAGES_V2:
            return "OPCODE_LOWLEVEL_UNMAP_UT_PAGES_V2";
         case OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL_V2:
            return "OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL_V2";
         case OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH_V2:
            return "OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH_V2";
         case OPCODE_LOWLEVEL_HOST_DDR_DMA_V2:
            return "OPCODE_LOWLEVEL_HOST_DDR_DMA_V2";
         case OPCODE_LOWLEVEL_LOOPBACK_TEST_V2:
            return "OPCODE_LOWLEVEL_LOOPBACK_TEST_V2";
         case OPCODE_LOWLEVEL_SET_LOOPBACK_MODE_V2:
            return "OPCODE_LOWLEVEL_SET_LOOPBACK_MODE_V2";
         case OPCODE_LOWLEVEL_GET_LOOPBACK_MODE_V2:
            return "OPCODE_LOWLEVEL_GET_LOOPBACK_MODE_V2";
         case OPCODE_LOWLEVEL_GET_COREDUMP_PROPERTIES_V2:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_PROPERTIES_V2";
         case OPCODE_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_V2:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_V2";
         case OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_V2:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_V2";
         case OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_V2:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_V2";
         case OPCODE_LOWLEVEL_QUERY_SFP_SIGNALS_V2:
            return "OPCODE_LOWLEVEL_QUERY_SFP_SIGNALS_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_FCOE_SUBSYSTEM_OPCODES ---
#define OPCODE_COMMON_FCOE_WRBQ_CREATE_V2 (1)     
#define OPCODE_COMMON_FCOE_WRBQ_DESTROY_V2 (2)    
#define OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES_V2 (3) 
#define OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_V2 (4) 
#define OPCODE_COMMON_FCOE_DEFQ_CREATE_V2 (5)     
#define OPCODE_COMMON_FCOE_DEFQ_DESTROY_V2 (6)    
#define OPCODE_COMMON_FCOE_READ_FCF_TABLE_V2 (8)  
#define OPCODE_COMMON_FCOE_ADD_FCF_V2   (9)       
#define OPCODE_COMMON_FCOE_DELETE_FCF_V2 (10)     
#define OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES_V2 (11) 
#define SUBSYSTEM_COMMON_FCOE_WRBQ_CREATE_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_WRBQ_DESTROY_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_CFG_POST_SGL_PAGES_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_DEFQ_CREATE_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_DEFQ_DESTROY_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_READ_FCF_TABLE_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_ADD_FCF_V2 (12)     
#define SUBSYSTEM_COMMON_FCOE_DELETE_FCF_V2 (12)  
#define SUBSYSTEM_COMMON_FCOE_POST_HDR_TEMPLATES_V2 (12) 
#define OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_REMOVE_HDR_TEMPLATES_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_IO_INIT_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_REQUEST_COMPLETION_V2 (12) 
#define SUBSYSTEM_COMMON_FCOE_REDISCOVER_FCF_V2 (12) 
#define OPCODE_COMMON_FCOE_MBOX_IO_INIT_V2 (13)   
#define OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_V2 (14) 
#define OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION_V2 (15) 
#define OPCODE_COMMON_FCOE_REDISCOVER_FCF_V2 (16) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_fcoe_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_FCOE_WRBQ_CREATE_V2:
            return "OPCODE_COMMON_FCOE_WRBQ_CREATE_V2";
         case OPCODE_COMMON_FCOE_WRBQ_DESTROY_V2:
            return "OPCODE_COMMON_FCOE_WRBQ_DESTROY_V2";
         case OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES_V2:
            return "OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES_V2";
         case OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_V2:
            return "OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_V2";
         case OPCODE_COMMON_FCOE_DEFQ_CREATE_V2:
            return "OPCODE_COMMON_FCOE_DEFQ_CREATE_V2";
         case OPCODE_COMMON_FCOE_DEFQ_DESTROY_V2:
            return "OPCODE_COMMON_FCOE_DEFQ_DESTROY_V2";
         case OPCODE_COMMON_FCOE_READ_FCF_TABLE_V2:
            return "OPCODE_COMMON_FCOE_READ_FCF_TABLE_V2";
         case OPCODE_COMMON_FCOE_ADD_FCF_V2:
            return "OPCODE_COMMON_FCOE_ADD_FCF_V2";
         case OPCODE_COMMON_FCOE_DELETE_FCF_V2:
            return "OPCODE_COMMON_FCOE_DELETE_FCF_V2";
         case OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES_V2:
            return "OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES_V2";
         case OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES_V2:
            return "OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES_V2";
         case OPCODE_COMMON_FCOE_MBOX_IO_INIT_V2:
            return "OPCODE_COMMON_FCOE_MBOX_IO_INIT_V2";
         case OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_V2:
            return "OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_V2";
         case OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION_V2:
            return "OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION_V2";
         case OPCODE_COMMON_FCOE_REDISCOVER_FCF_V2:
            return "OPCODE_COMMON_FCOE_REDISCOVER_FCF_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LLDP_SUBSYSTEM_OPCODES ---
#define OPCODE_LLDP_GET_LLDP_CFG_V2     (1)       
#define OPCODE_LLDP_SET_LLDP_CFG_V2     (2)       
#define OPCODE_LLDP_GET_LLDP_STATS_V2   (3)       
#define SUBSYSTEM_LLDP_GET_LLDP_CFG_V2  (15)      
#define SUBSYSTEM_LLDP_SET_LLDP_CFG_V2  (15)      
#define SUBSYSTEM_LLDP_GET_LLDP_STATS_V2 (15)     

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lldp_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LLDP_GET_LLDP_CFG_V2:
            return "OPCODE_LLDP_GET_LLDP_CFG_V2";
         case OPCODE_LLDP_SET_LLDP_CFG_V2:
            return "OPCODE_LLDP_SET_LLDP_CFG_V2";
         case OPCODE_LLDP_GET_LLDP_STATS_V2:
            return "OPCODE_LLDP_GET_LLDP_STATS_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DCBX_SUBSYSTEM_OPCODES ---
#define OPCODE_DCBX_GET_DCBX_CFG_V2     (1)       
#define OPCODE_DCBX_SET_DCBX_CFG_V2     (2)       
#define OPCODE_DCBX_GET_DCBX_MIB_INFO_V2 (3)      
#define OPCODE_DCBX_GET_DCBX_MODE_V2    (4)       
#define OPCODE_DCBX_SET_DCBX_MODE_V2    (5)       
#define SUBSYSTEM_DCBX_GET_DCBX_CFG_V2  (16)      
#define SUBSYSTEM_DCBX_SET_DCBX_CFG_V2  (16)      
#define SUBSYSTEM_DCBX_GET_DCBX_MIB_INFO_V2 (16)  
#define SUBSYSTEM_DCBX_GET_DCBX_MODE_V2 (16)      
#define SUBSYSTEM_DCBX_SET_DCBX_MODE_V2 (16)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dcbx_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DCBX_GET_DCBX_CFG_V2:
            return "OPCODE_DCBX_GET_DCBX_CFG_V2";
         case OPCODE_DCBX_SET_DCBX_CFG_V2:
            return "OPCODE_DCBX_SET_DCBX_CFG_V2";
         case OPCODE_DCBX_GET_DCBX_MIB_INFO_V2:
            return "OPCODE_DCBX_GET_DCBX_MIB_INFO_V2";
         case OPCODE_DCBX_GET_DCBX_MODE_V2:
            return "OPCODE_DCBX_GET_DCBX_MODE_V2";
         case OPCODE_DCBX_SET_DCBX_MODE_V2:
            return "OPCODE_DCBX_SET_DCBX_MODE_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DMTF_SUBSYSTEM_OPCODES ---
#define OPCODE_DMTF_EXECUTE_CMD_V2      (1)       
#define SUBSYSTEM_DMTF_EXECUTE_CMD_V2   (17)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dmtf_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DMTF_EXECUTE_CMD_V2:
            return "OPCODE_DMTF_EXECUTE_CMD_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DIAG_SUBSYSTEM_OPCODES ---
#define OPCODE_DIAG_DMA_V2              (1)       
#define OPCODE_DIAG_MDIO_V2             (2)       
#define OPCODE_DIAG_NLB_V2              (3)       
#define OPCODE_DIAG_ATT_V2              (4)       
#define OPCODE_DIAG_GETMAC_V2           (5)       
#define OPCODE_DIAG_8051_CMD_V2         (6)       
#define OPCODE_DIAG_RESET_PHY_V2        (7)       
#define OPCODE_DIAG_10GBASET_STATS_V2   (8)       
#define OPCODE_DIAG_RUN_10GBASET_SELFTEST_V2 (9)  
#define OPCODE_DIAG_SET_10GBASET_NVPVALUE_V2 (10) 
#define OPCODE_DIAG_RUN_TDR_V2          (11)      
#define OPCODE_DIAG_GET_10GBASET_NVPVALUE_V2 (12) 
#define OPCODE_DIAG_SET_EMI_CANCELLER_V2 (13)     
#define SUBSYSTEM_DIAG_DMA_V2           (18)      
#define SUBSYSTEM_DIAG_MDIO_V2          (18)      
#define SUBSYSTEM_DIAG_NLB_V2           (18)      
#define SUBSYSTEM_DIAG_ATT_V2           (18)      
#define SUBSYSTEM_DIAG_GETMAC_V2        (18)      
#define SUBSYSTEM_DIAG_8051_CMD_V2      (18)      
#define SUBSYSTEM_DIAG_RESET_PHY_V2     (18)      
#define SUBSYSTEM_DIAG_10GBASET_STATS_V2 (18)     
#define SUBSYSTEM_DIAG_RUN_10GBASET_SELFTEST_V2 (18) 
#define SUBSYSTEM_DIAG_SET_10GBASET_NVPVALUE_V2 (18) 
#define SUBSYSTEM_DIAG_RUN_TDR_V2       (18)      
#define SUBSYSTEM_DIAG_GET_10GBASET_NVPVALUE_V2 (18) 
#define SUBSYSTEM_DIAG_SET_EMI_CANCELLER_V2 (18)  

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* diag_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DIAG_DMA_V2:
            return "OPCODE_DIAG_DMA_V2";
         case OPCODE_DIAG_MDIO_V2:
            return "OPCODE_DIAG_MDIO_V2";
         case OPCODE_DIAG_NLB_V2:
            return "OPCODE_DIAG_NLB_V2";
         case OPCODE_DIAG_ATT_V2:
            return "OPCODE_DIAG_ATT_V2";
         case OPCODE_DIAG_GETMAC_V2:
            return "OPCODE_DIAG_GETMAC_V2";
         case OPCODE_DIAG_8051_CMD_V2:
            return "OPCODE_DIAG_8051_CMD_V2";
         case OPCODE_DIAG_RESET_PHY_V2:
            return "OPCODE_DIAG_RESET_PHY_V2";
         case OPCODE_DIAG_10GBASET_STATS_V2:
            return "OPCODE_DIAG_10GBASET_STATS_V2";
         case OPCODE_DIAG_RUN_10GBASET_SELFTEST_V2:
            return "OPCODE_DIAG_RUN_10GBASET_SELFTEST_V2";
         case OPCODE_DIAG_SET_10GBASET_NVPVALUE_V2:
            return "OPCODE_DIAG_SET_10GBASET_NVPVALUE_V2";
         case OPCODE_DIAG_RUN_TDR_V2:
            return "OPCODE_DIAG_RUN_TDR_V2";
         case OPCODE_DIAG_GET_10GBASET_NVPVALUE_V2:
            return "OPCODE_DIAG_GET_10GBASET_NVPVALUE_V2";
         case OPCODE_DIAG_SET_EMI_CANCELLER_V2:
            return "OPCODE_DIAG_SET_EMI_CANCELLER_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- VENDOR_SUBSYSTEM_OPCODES ---
#define OPCODE_VENDOR_SLI_V2            (1)       
#define OPCODE_VENDOR_MANAGE_FFV_V2     (2)       
#define OPCODE_VENDOR_READ_FRU_EEPROM_V2 (3)      
#define OPCODE_VENDOR_WRITE_FRU_EEPROM_V2 (4)     
#define SUBSYSTEM_VENDOR_SLI_V2         (19)      
#define SUBSYSTEM_VENDOR_MANAGE_FFV_V2  (19)      
#define SUBSYSTEM_VENDOR_READ_FRU_EEPROM_V2 (19)  
#define SUBSYSTEM_VENDOR_WRITE_FRU_EEPROM_V2 (19) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* vendor_subsystem_opcodes_v2_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_VENDOR_SLI_V2:
            return "OPCODE_VENDOR_SLI_V2";
         case OPCODE_VENDOR_MANAGE_FFV_V2:
            return "OPCODE_VENDOR_MANAGE_FFV_V2";
         case OPCODE_VENDOR_READ_FRU_EEPROM_V2:
            return "OPCODE_VENDOR_READ_FRU_EEPROM_V2";
         case OPCODE_VENDOR_WRITE_FRU_EEPROM_V2:
            return "OPCODE_VENDOR_WRITE_FRU_EEPROM_V2";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- OEM_SUBSYSTEM_OPCODES ---
#define OPCODE_OEM_QUERY_FOD_V2         (1)       
#define OPCODE_OEM_VALIDATE_FOD_LICENSE_KEYS_V2 (2) 
#define OPCODE_OEM_QUERY_OCSD_STATUS_V2 (3)       
#define SUBSYSTEM_OEM_QUERY_FOD_V2      (21)      
#define SUBSYSTEM_OEM_VALIDATE_FOD_LICENSE_KEYS_V2 (21) 
#define SUBSYSTEM_OEM_QUERY_OCSD_STATUS_V2 (21)   

// --- SURF_SUBSYSTEM_OPCODES ---
#define OPCODE_SURF_CREATE_CLIENT_V2    (1)       
#define OPCODE_SURF_DESTROY_CLIENT_V2   (2)       
#define OPCODE_SURF_CREATE_RQ_V2        (3)       
#define OPCODE_SURF_DESTROY_RQ_V2       (4)       
#define OPCODE_SURF_CREATE_TARGET_V2    (5)       
#define OPCODE_SURF_DESTROY_TARGET_V2   (6)       
#define OPCODE_SURF_MAKE_RULE_V2        (7)       
#define OPCODE_SURF_MOD_RULE_V2         (8)       
#define OPCODE_SURF_DEL_RULE_V2         (9)       
#define OPCODE_SURF_CREATE_WQ_V2        (10)      
#define OPCODE_SURF_CREATE_CQ_V2        (11)      
#define OPCODE_SURF_CREATE_EQ_V2        (12)      
#define OPCODE_SURF_CREATE_MQ_V2        (13)      
#define OPCODE_SURF_ALLOC_PD_V2         (14)      
#define OPCODE_SURF_DEALLOC_PD_V2       (15)      
#define OPCODE_SURF_QUERY_CONFIG_V2     (16)      
#define SUBSYSTEM_SURF_CREATE_CLIENT_V2 (22)      
#define SUBSYSTEM_SURF_DESTROY_CLIENT_V2 (22)     
#define SUBSYSTEM_SURF_CREATE_RQ_V2     (22)      
#define SUBSYSTEM_SURF_DESTROY_RQ_V2    (22)      
#define SUBSYSTEM_SURF_CREATE_TARGET_V2 (22)      
#define SUBSYSTEM_SURF_DESTROY_TARGET_V2 (22)     
#define SUBSYSTEM_SURF_MAKE_RULE_V2     (22)      
#define SUBSYSTEM_SURF_MOD_RULE_V2      (22)      
#define SUBSYSTEM_SURF_DEL_RULE_V2      (22)      
#define SUBSYSTEM_SURF_CREATE_WQ_V2     (22)      
#define SUBSYSTEM_SURF_CREATE_CQ_V2     (22)      
#define SUBSYSTEM_SURF_CREATE_EQ_V2     (22)      
#define SUBSYSTEM_SURF_CREATE_MQ_V2     (22)      
#define SUBSYSTEM_SURF_ALLOC_PD_V2      (22)      
#define SUBSYSTEM_SURF_DEALLOC_PD_V2    (22)      
#define SUBSYSTEM_SURF_QUERY_CONFIG_V2  (22)      


typedef struct _IOCTL_REQUEST_HEADER_V2 {
   union {
      struct { 
         u32 opcode : 8;                          // DWORD 0
         u32 subsystem : 8;                       // DWORD 0
         u32 port_number : 8;                     // DWORD 0
         u32 domain : 8;                          // DWORD 0
         u32 timeout;                             // DWORD 1
         u32 request_length;                      // DWORD 2
         u32 version : 8;                         // DWORD 3
         u32 rsvd0 : 8;                           // DWORD 3
         u32 pfnumber : 10;                       // DWORD 3
         u32 vhnumber : 6;                        // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_REQUEST_HEADER_V2, *PIOCTL_REQUEST_HEADER_V2;

SG_C_ASSERT(__sizeof__IOCTL_REQUEST_HEADER, sizeof (IOCTL_REQUEST_HEADER_V2) == 16);



typedef struct _IOCTL_RESPONSE_HEADER_V2 {
   union {
      struct { 
         u32 opcode : 8;                          // DWORD 0
         u32 subsystem : 8;                       // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 domain : 8;                          // DWORD 0
         u32 status : 8;                          // DWORD 1
         u32 additional_status : 16;              // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
         u32 response_length;                     // DWORD 2
         u32 actual_response_length;              // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_RESPONSE_HEADER_V2, *PIOCTL_RESPONSE_HEADER_V2;

SG_C_ASSERT(__sizeof__IOCTL_RESPONSE_HEADER, sizeof (IOCTL_RESPONSE_HEADER_V2) == 16);



typedef struct _IOCTL_HEADER_V2 {
   union {
      union { 
         IOCTL_REQUEST_HEADER_V2 request;
         IOCTL_RESPONSE_HEADER_V2 response;
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_HEADER_V2, *PIOCTL_HEADER_V2;

SG_C_ASSERT(__sizeof__IOCTL_HEADER, sizeof (IOCTL_HEADER_V2) == 16);



typedef struct _EQ_DB_V2 {
   union {
      struct { 
         u32 qid : 9;                             // DWORD 0
         u32 ClearInt : 1;                        // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 qid_msb : 1;                         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 num_popped : 13;                     // DWORD 0
         u32 rearm : 1;                           // DWORD 0
         u32 r2i_dly_mult_enc : 2;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK EQ_DB_V2, *PEQ_DB_V2;

SG_C_ASSERT(__sizeof__EQ_DB, sizeof (EQ_DB_V2) == 4);



typedef struct _CQ_DB_V2 {
   union {
      struct { 
         u32 qid : 10;                            // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 qid_msb : 1;                         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 num_popped : 13;                     // DWORD 0
         u32 rearm : 1;                           // DWORD 0
         u32 irpt : 1;                            // DWORD 0
         u32 db_solicited : 1;                    // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CQ_DB_V2, *PCQ_DB_V2;

SG_C_ASSERT(__sizeof__CQ_DB, sizeof (CQ_DB_V2) == 4);



typedef struct _ETH_RX_COMPL_V2 {
   union {
      struct { 
         u32 vlan_tag : 16;                       // DWORD 0
         u32 pktsize : 14;                        // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 ip_opt : 1;                          // DWORD 0
         u32 err : 1;                             // DWORD 1
         u32 rsshp : 1;                           // DWORD 1
         u32 ipf : 1;                             // DWORD 1
         u32 tcpf : 1;                            // DWORD 1
         u32 udpf : 1;                            // DWORD 1
         u32 ipcksm : 1;                          // DWORD 1
         u32 l4_cksm : 1;                         // DWORD 1
         u32 ip_version : 1;                      // DWORD 1
         u32 macdst : 8;                          // DWORD 1
         u32 fragndx : 10;                        // DWORD 1
         u32 ct : 2;                              // DWORD 1
         u32 sw : 1;                              // DWORD 1
         u32 numfrags : 3;                        // DWORD 1
         u32 rss_flush : 1;                       // DWORD 2
         u32 cast_enc : 2;                        // DWORD 2
         u32 QnQ : 1;                             // DWORD 2
         u32 rss_bank : 1;                        // DWORD 2
         u32 port : 2;                            // DWORD 2
         u32 vntagp : 1;                          // DWORD 2
         u32 header_len : 8;                      // DWORD 2
         u32 header_split : 2;                    // DWORD 2
         u32 rss_policy : 4;                      // DWORD 2
         u32 timestamp_present : 1;               // DWORD 2
         u32 push : 1;                            // DWORD 2
         u32 rsvd0 : 1;                           // DWORD 2
         u32 future_headers_present : 5;          // DWORD 2
         u32 tunneled : 1;                        // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 rsshash;                             // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ETH_RX_COMPL_V2, *PETH_RX_COMPL_V2;

SG_C_ASSERT(__sizeof__ETH_RX_COMPL, sizeof (ETH_RX_COMPL_V2) == 16);


// --- HEADER_DMA_ENUM ---
#define HEADER_DMA_TO_HEADER_V2         (1)       
#define HEADER_DMA_TO_DATA_V2           (2)       
#define HEADER_DMA_TO_HEADER_AND_DATA_V2 (3)      

// --- HEADER_SPLIT_LOCATION_ENUM ---
#define HEADER_SPLIT_LOCATION_BEFORE_ULP_HEADER_V2 (0) 
#define HEADER_SPLIT_LOCATION_AFTER_ULP_HEADER_V2 (1) 
#define HEADER_SPLIT_LOCATION_FIXED_V2  (2)       

// --- NTWK_RX_FILTER_IF_FLAGS_ENUM ---
#define NTWK_RX_FILTER_IF_PROMISCUOUS_V2 (8)      
#define NTWK_RX_FILTER_IF_BROADCAST_V2  (16)      
#define NTWK_RX_FILTER_IF_UNTAGGED_V2   (32)      
#define NTWK_RX_FILTER_IF_VLAN_PROMISCUOUS_V2 (128) 
#define NTWK_RX_FILTER_IF_MCAST_PROMISCUOUS_V2 (512) 
#define NTWK_RX_FILTER_IF_PASS_L2_ERRORS_V2 (1024) 
#define NTWK_RX_FILTER_IF_PASS_L3L4_ERRORS_V2 (2048) 
#define NTWK_RX_FILTER_IF_MULTICAST_V2  (4096)    
#define NTWK_RX_FILTER_IF_MULTICAST_HASH_V2 (8192) 
#define NTWK_RX_FILTER_IF_HEADER_SPLIT_V2 (16384) 
#define NTWK_RX_FILTER_IF_DIRECTED_V2   (32768)   
#define NTWK_RX_FILTER_IF_LRO_V2        (1048576) 


typedef struct _ETH_RX_CREATE_PARAMS_IN_V2 {
   union {
      struct { 
         UEXACT16 cq_id;
         UEXACT8 frag_size;
         UEXACT8 num_pages;
         PHYS_ADDR_V2 pages[2];
         UEXACT32 interface_id;
         UEXACT16 max_frame_size;
         UEXACT16 rsvd0;
         UEXACT32 rss_queue;
         UEXACT8 header_split;
         UEXACT8 header_dma;
         UEXACT8 split_location;
         UEXACT8 dca;
         UEXACT16 header_size;
         UEXACT16 backfill;
         UEXACT16 fixed_split_location;
         UEXACT16 rsvd1;
      } SG_PACK ; // unnamed struct
      u32 dw[11]; // dword union
   }; // unnamed union
} SG_PACK ETH_RX_CREATE_PARAMS_IN_V2, *PETH_RX_CREATE_PARAMS_IN_V2;

SG_C_ASSERT(__sizeof__ETH_RX_CREATE_PARAMS_IN, sizeof (ETH_RX_CREATE_PARAMS_IN_V2) == 44);



typedef struct _ETH_RX_CREATE_PARAMS_OUT_V2 {
   UEXACT16 id;
   UEXACT8 cpu_id;
   UEXACT8 ep_based_ring;
} SG_PACK ETH_RX_CREATE_PARAMS_OUT_V2, *PETH_RX_CREATE_PARAMS_OUT_V2;




typedef struct _ETH_RX_CREATE_PARAMS_V2 {
   union {
      union { 
         ETH_RX_CREATE_PARAMS_IN_V2 request;
         ETH_RX_CREATE_PARAMS_OUT_V2 response;
      } SG_PACK ; // unnamed struct
      u32 dw[11]; // dword union
   }; // unnamed union
} SG_PACK ETH_RX_CREATE_PARAMS_V2, *PETH_RX_CREATE_PARAMS_V2;

SG_C_ASSERT(__sizeof__ETH_RX_CREATE_PARAMS, sizeof (ETH_RX_CREATE_PARAMS_V2) == 44);



typedef struct _IOCTL_ETH_RX_CREATE_V2 {
   union {
      struct { 
         IOCTL_HEADER_V2 header;
         ETH_RX_CREATE_PARAMS_V2 params;
      } SG_PACK ; // unnamed struct
      u32 dw[15]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_RX_CREATE_V2, *PIOCTL_ETH_RX_CREATE_V2;

SG_C_ASSERT(__sizeof__IOCTL_ETH_RX_CREATE, sizeof (IOCTL_ETH_RX_CREATE_V2) == 60);



typedef struct _HW_PORT_RXF_STATS_V2_V2 {
   union {
      struct { 
         u32 rx_bytes_lsd;                        // DWORD 0
         u32 rx_bytes_msd;                        // DWORD 1
         u32 rx_ipv4_bytes_lsd;                   // DWORD 2
         u32 rx_ipv4_bytes_msd;                   // DWORD 3
         u32 rx_ipv6_bytes_lsd;                   // DWORD 4
         u32 rx_ipv6_bytes_msd;                   // DWORD 5
         u32 tx_bytes_lsd;                        // DWORD 6
         u32 tx_bytes_msd;                        // DWORD 7
         u32 fcoe_bytes_received_lsd;             // DWORD 8
         u32 fcoe_bytes_received_msd;             // DWORD 9
         u32 roce_bytes_received_lsd;             // DWORD 10
         u32 roce_bytes_received_msd;             // DWORD 11
         u32 rx_total_frames;                     // DWORD 12
         u32 rx_non_switched_unicast_frames;      // DWORD 13
         u32 rx_non_switched_multicast_frames;    // DWORD 14
         u32 rx_non_switched_broadcast_frames;    // DWORD 15
         u32 fcoe_frames_received;                // DWORD 16
         u32 roce_frames_received;                // DWORD 17
         u32 rx_crc_errors;                       // DWORD 18
         u32 rx_alignment_symbol_errors;          // DWORD 19
         u32 rx_pause_frames;                     // DWORD 20
         u32 rx_priority_pause_frames;            // DWORD 21
         u32 rx_control_frames;                   // DWORD 22
         u32 rx_in_range_errors;                  // DWORD 23
         u32 rx_out_range_errors;                 // DWORD 24
         u32 rx_frame_too_long;                   // DWORD 25
         u32 rx_address_match_errors;             // DWORD 26
         u32 rx_dropped_too_small;                // DWORD 27
         u32 rx_dropped_too_short;                // DWORD 28
         u32 rx_dropped_header_too_small;         // DWORD 29
         u32 rx_dropped_tcp_length;               // DWORD 30
         u32 rx_dropped_runt;                     // DWORD 31
         u32 rx_64_byte_packets;                  // DWORD 32
         u32 rx_65_127_byte_packets;              // DWORD 33
         u32 rx_128_256_byte_packets;             // DWORD 34
         u32 rx_256_511_byte_packets;             // DWORD 35
         u32 rx_512_1023_byte_packets;            // DWORD 36
         u32 rx_1024_1518_byte_packets;           // DWORD 37
         u32 rx_1519_2047_byte_packets;           // DWORD 38
         u32 rx_2048_4095_byte_packets;           // DWORD 39
         u32 rx_4096_8191_byte_packets;           // DWORD 40
         u32 rx_8192_9216_byte_packets;           // DWORD 41
         u32 rx_ip_checksum_errs;                 // DWORD 42
         u32 rx_tcp_checksum_errs;                // DWORD 43
         u32 rx_udp_checksum_errs;                // DWORD 44
         u32 rx_non_rss_packets;                  // DWORD 45
         u32 rx_ipv4_packets;                     // DWORD 46
         u32 rx_ipv6_packets;                     // DWORD 47
         u32 rx_chute1_packets;                   // DWORD 48
         u32 rx_chute2_packets;                   // DWORD 49
         u32 rx_chute3_packets;                   // DWORD 50
         u32 rx_management_packets;               // DWORD 51
         u32 rx_switched_unicast_packets;         // DWORD 52
         u32 rx_switched_multicast_packets;       // DWORD 53
         u32 rx_switched_broadcast_packets;       // DWORD 54
         u32 tx_unicastframes;                    // DWORD 55
         u32 tx_multicastframes;                  // DWORD 56
         u32 tx_broadcastframes;                  // DWORD 57
         u32 tx_pauseframes;                      // DWORD 58
         u32 tx_priority_pauseframes;             // DWORD 59
         u32 tx_controlframes;                    // DWORD 60
         u32 tx_64_byte_packets;                  // DWORD 61
         u32 tx_65_127_byte_packets;              // DWORD 62
         u32 tx_128_256_byte_packets;             // DWORD 63
         u32 tx_256_511_byteb_packets;            // DWORD 64
         u32 tx_512_1023_byte_packets;            // DWORD 65
         u32 tx_1024_1518_byte_packets;           // DWORD 66
         u32 tx_1519_2047_byte_packets;           // DWORD 67
         u32 tx_2048_4095_byte_packets;           // DWORD 68
         u32 tx_4096_8191_byte_packets;           // DWORD 69
         u32 tx_8192_9216_byte_packets;           // DWORD 70
         u32 rxpp_fifo_overflow_drop;             // DWORD 71
         u32 rx_input_fifo_overflow_drop;         // DWORD 72
         u32 pmem_fifo_overflow_drop;             // DWORD 73
         u32 jabber_events;                       // DWORD 74
         u32 vntag_wrong_dir;                     // DWORD 75
         u32 vntag_exceeds_vif;                   // DWORD 76
         u32 vntag_exceeds_vif_list;              // DWORD 77
         u32 rx_drops_payload_size;               // DWORD 78
         u32 rx_drops_clipped_header;             // DWORD 79
         u32 rx_drops_crc;                        // DWORD 80
         u32 roce_drops_payload_len;              // DWORD 81
         u32 roce_drops_crc;                      // DWORD 82
         u32 pfc0_xoff_since_last_xon;            // DWORD 83
         u32 pfc1_xoff_since_last_xon;            // DWORD 84
         u32 pfc2_xoff_since_last_xon;            // DWORD 85
         u32 pfc3_xoff_since_last_xon;            // DWORD 86
         u32 pfc4_xoff_since_last_xon;            // DWORD 87
         u32 pfc5_xoff_since_last_xon;            // DWORD 88
         u32 pfc6_xoff_since_last_xon;            // DWORD 89
         u32 pfc7_xoff_since_last_xon;            // DWORD 90
         u32 ptp_pkts_received;                   // DWORD 91
         u32 tunneled_pkts_received;              // DWORD 92
         u32 ethernet_tpre_pkts_received;         // DWORD 93
         u32 lroed_packets_received;              // DWORD 94
         u32 resrvd_stat0;                        // DWORD 95
         u32 resrvd_stat1;                        // DWORD 96
         u32 resrvd_stat2;                        // DWORD 97
         u32 resrvd_stat3;                        // DWORD 98
         u32 resrvd_stat4;                        // DWORD 99
         u32 resrvd_stat5;                        // DWORD 100
         u32 resrvd_stat6;                        // DWORD 101
      } SG_PACK ; // unnamed struct
      u32 dw[102]; // dword union
   }; // unnamed union
} SG_PACK HW_PORT_RXF_STATS_V2_V2, *PHW_PORT_RXF_STATS_V2_V2;

SG_C_ASSERT(__sizeof__HW_PORT_RXF_STATS_V2, sizeof (HW_PORT_RXF_STATS_V2_V2) == 408);



typedef struct _HW_RXF_STATS_V2_V2 {
   union {
      struct { 
         HW_PORT_RXF_STATS_V2_V2 port[4];
         u32 management_rx_port_bytes;            // DWORD 408
         u32 management_tx_port_bytes;            // DWORD 409
         u32 rx_drops_no_pbuf;                    // DWORD 410
         u32 rx_drops_no_txpb;                    // DWORD 411
         u32 rx_drops_no_erx_descr;               // DWORD 412
         u32 rx_drops_no_tpre_descr;              // DWORD 413
         u32 management_rx_port_packets;          // DWORD 414
         u32 management_rx_port_pause_frames;     // DWORD 415
         u32 management_rx_port_errors;           // DWORD 416
         u32 management_tx_port_packets;          // DWORD 417
         u32 management_tx_port_pause;            // DWORD 418
         u32 mgmt_rx_port_pmem_fifo_overflow;     // DWORD 419
         u32 rx_drops_too_many_frags;             // DWORD 420
         u32 rx_drops_invalid_ring;               // DWORD 421
         u32 forwarded_packets;                   // DWORD 422
         u32 rx_drops_mtu;                        // DWORD 423
         u32 mgmt_rx_port_rxpp_fifo_overflow;     // DWORD 424
         u32 rxpp_drops_too_big_for_mgmt;         // DWORD 425
         u32 overflow_fifo_part0_taildrop;        // DWORD 426
         u32 overflow_fifo_part1_taildrop;        // DWORD 427
         u32 overflow_fifo_part2_taildrop;        // DWORD 428
         u32 overflow_fifo_part3_taildrop;        // DWORD 429
         u32 overflow_fifo_part4_taildrop;        // DWORD 430
         u32 overflow_fifo_part5_taildrop;        // DWORD 431
         u32 overflow_fifo_part6_taildrop;        // DWORD 432
         u32 overflow_fifo_part7_taildrop;        // DWORD 433
         u32 overflow_fifo_part8_taildrop;        // DWORD 434
         u32 overflow_fifo_part9_taildrop;        // DWORD 435
         u32 overflow_fifo_part10_taildrop;       // DWORD 436
         u32 overflow_fifo_part11_taildrop;       // DWORD 437
         u32 overflow_fifo_part12_taildrop;       // DWORD 438
         u32 overflow_fifo_part13_taildrop;       // DWORD 439
         u32 overflow_fifo_part14_taildrop;       // DWORD 440
         u32 overflow_fifo_part15_taildrop;       // DWORD 441
         u32 overflow_pmem_part0;                 // DWORD 442
         u32 overflow_pmem_part1;                 // DWORD 443
         u32 overflow_pmem_part2;                 // DWORD 444
         u32 overflow_pmem_part3;                 // DWORD 445
         u32 overflow_pmem_part4;                 // DWORD 446
         u32 overflow_pmem_part5;                 // DWORD 447
         u32 overflow_pmem_part6;                 // DWORD 448
         u32 overflow_pmem_part7;                 // DWORD 449
         u32 overflow_pmem_part8;                 // DWORD 450
         u32 overflow_pmem_part9;                 // DWORD 451
         u32 overflow_pmem_part10;                // DWORD 452
         u32 overflow_pmem_part11;                // DWORD 453
         u32 overflow_pmem_part12;                // DWORD 454
         u32 overflow_pmem_part13;                // DWORD 455
         u32 overflow_pmem_part14;                // DWORD 456
         u32 overflow_pmem_part15;                // DWORD 457
         u32 mgmt_filter_mismtach;                // DWORD 458
      } SG_PACK ; // unnamed struct
      u32 dw[459]; // dword union
   }; // unnamed union
} SG_PACK HW_RXF_STATS_V2_V2, *PHW_RXF_STATS_V2_V2;

SG_C_ASSERT(__sizeof__HW_RXF_STATS_V2, sizeof (HW_RXF_STATS_V2_V2) == 1836);



typedef struct _HW_TXP_SW_STAT_V2 {
   union {
      struct { 
         u32 packets;                             // DWORD 0
         u32 lsd;                                 // DWORD 1
         u32 msd;                                 // DWORD 2
      } SG_PACK ; // unnamed struct
      u32 dw[3]; // dword union
   }; // unnamed union
} SG_PACK HW_TXP_SW_STAT_V2, *PHW_TXP_SW_STAT_V2;

SG_C_ASSERT(__sizeof__HW_TXP_SW_STAT, sizeof (HW_TXP_SW_STAT_V2) == 12);



typedef struct _HW_TXP_SW_COUNTERS_V2 {
   union {
      struct { 
         struct {
            struct {
               HW_TXP_SW_STAT_V2 xmt_ipv4_ctrs;
               HW_TXP_SW_STAT_V2 xmt_ipv6_ctrs;
               HW_TXP_SW_STAT_V2 rexmt_ipv4_ctrs;
               HW_TXP_SW_STAT_V2 rexmt_ipv6_ctrs;
            } port[2];
         } chute[2];
      } SG_PACK ; // unnamed struct
      u32 dw[48]; // dword union
   }; // unnamed union
} SG_PACK HW_TXP_SW_COUNTERS_V2, *PHW_TXP_SW_COUNTERS_V2;

SG_C_ASSERT(__sizeof__HW_TXP_SW_COUNTERS, sizeof (HW_TXP_SW_COUNTERS_V2) == 192);



typedef struct _HW_ERX_STATS_V2_V2 {
   union {
      struct { 
         u32 rx_drops_no_fragments[136];          // DWORDS 0 to 135
         u32 debug_wdma_sent_hold;                // DWORD 136
         u32 debug_wdma_pbfree_sent_hold;         // DWORD 137
         u32 debug_wdma_zerobyte_pbfree_sent_hold; // DWORD 138
      } SG_PACK ; // unnamed struct
      u32 dw[139]; // dword union
   }; // unnamed union
} SG_PACK HW_ERX_STATS_V2_V2, *PHW_ERX_STATS_V2_V2;

SG_C_ASSERT(__sizeof__HW_ERX_STATS_V2, sizeof (HW_ERX_STATS_V2_V2) == 556);



typedef struct _HW_PMEM_STATS_V2 {
   u32 eth_red_drops;
   u32 lro_red_drops;
   u32 ulp0_red_drops;
   u32 ulp1_red_drops;
   u32 rsvd0;
   u32 global_red_drops;
} SG_PACK HW_PMEM_STATS_V2, *PHW_PMEM_STATS_V2;




typedef struct _HW_EP_STATS_V2 {
   u16 perf_idle_average;
   u16 perf_loading_average;
   u16 perf_busy_average;
   u16 perf_unloading_average;
   u16 perf_wt4bank_average;
   u16 perf_wt4unload_average;
} SG_PACK HW_EP_STATS_V2, *PHW_EP_STATS_V2;




typedef struct _GET_STATISTICS_V2_PARAMS_IN_V2 {
   UEXACT32 rsvd0;
} SG_PACK GET_STATISTICS_V2_PARAMS_IN_V2, *PGET_STATISTICS_V2_PARAMS_IN_V2;




typedef struct _GET_STATISTICS_V2_PARAMS_OUT_V2 {
   union {
      struct { 
         HW_RXF_STATS_V2_V2 rxf;
         HW_TXP_SW_COUNTERS_V2 txp;
         HW_ERX_STATS_V2_V2 erx;
         HW_PMEM_STATS_V2 pmem;
         HW_EP_STATS_V2 ep[6];
      } SG_PACK ; // unnamed struct
      u32 dw[670]; // dword union
   }; // unnamed union
} SG_PACK GET_STATISTICS_V2_PARAMS_OUT_V2, *PGET_STATISTICS_V2_PARAMS_OUT_V2;

SG_C_ASSERT(__sizeof__GET_STATISTICS_V2_PARAMS_OUT, sizeof (GET_STATISTICS_V2_PARAMS_OUT_V2) == 2680);



typedef struct _GET_STATISTICS_V2_PARAMS_V2 {
   union {
      union { 
         GET_STATISTICS_V2_PARAMS_IN_V2 request;
         GET_STATISTICS_V2_PARAMS_OUT_V2 response;
      } SG_PACK ; // unnamed struct
      u32 dw[670]; // dword union
   }; // unnamed union
} SG_PACK GET_STATISTICS_V2_PARAMS_V2, *PGET_STATISTICS_V2_PARAMS_V2;

SG_C_ASSERT(__sizeof__GET_STATISTICS_V2_PARAMS, sizeof (GET_STATISTICS_V2_PARAMS_V2) == 2680);



typedef struct _IOCTL_ETH_GET_STATISTICS_V2_V2 {
   union {
      struct { 
         IOCTL_HEADER_V2 header;
         GET_STATISTICS_V2_PARAMS_V2 params;
      } SG_PACK ; // unnamed struct
      u32 dw[674]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_GET_STATISTICS_V2_V2, *PIOCTL_ETH_GET_STATISTICS_V2_V2;

SG_C_ASSERT(__sizeof__IOCTL_ETH_GET_STATISTICS_V2, sizeof (IOCTL_ETH_GET_STATISTICS_V2_V2) == 2696);


// --- DRIVER_FUNCTION_CAPABILITIES_ENUMS ---
#define DRIVER_FUNCTION_CAPABILITY_SW_TIMESTAMPS_V2 (2) 
#define DRIVER_FUNCTION_CAPABILITY_BE3_NATIVE_ERX_API_V2 (4) 
#define DRIVER_FUNCTION_CAPABILITY_IPV4_BIG_OPTION_WORKAROUND_V2 (8) 
#define DRIVER_FUNCTION_CAPABILITY_SKYHAWK_FW_ERX_COMP_FORMAT_1_V2 (16) 


typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V2 {
   UEXACT32 valid_capability_flags;
   UEXACT32 capability_flags;
   UEXACT8 sbz[212];
} SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V2, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V2;




typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V2 {
   UEXACT32 valid_capability_flags;
   UEXACT32 capability_flags;
   UEXACT8 sbz[212];
} SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V2, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V2;




typedef union _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V2 {
   SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V2 request;
   SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V2 response;
} SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V2, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V2;




typedef struct _IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2 {
   union {
      struct { 
         IOCTL_HEADER_V2 header;
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V2 params;
      } SG_PACK ; // unnamed struct
      u32 dw[59]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2, *PIOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES, sizeof (IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V2) == 236);


// --- SUPPORTED_MODES ---
#define TOE_MODE_V2                     (1)       
#define NIC_MODE_V2                     (2)       
#define RDMA_MODE_V2                    (4)       
#define VM_MODE_V2                      (8)       
#define ISCSI_INI_MODE_V2               (16)      
#define ISCSI_TGT_MODE_V2               (32)      
#define FCOE_INI_MODE_V2                (64)      
#define FCOE_TGT_MODE_V2                (128)     
#define DAL_MODE_V2                     (256)     
#define LRO_MODE_V2                     (512)     
#define FLEX10_MODE_V2                  (1024)    
#define QINQ_MODE_V2                    (1024)    
#define NCSI_MODE_V2                    (2048)    
#define DUA_MODE_V2                     (2048)    
#define IPV6_MODE_V2                    (4096)    
#define BE2_COMPAT_MODE_V2              (8192)    
#define SRIOV_MODE_V2                   (16384)   
#define INVALID_MODE_V2                 (32768)   
#define BE3_COMPAT_MODE_V2              (65536)   
#define VNIC_MODE_V2                    (131072)  
#define VNTAG_MODE_V2                   (262144)  
#define UMC_MODE_V2                     (524288)  
#define UMC_DEF_EN_V2                   (1048576) 
#define ONE_GB_DEF_EN_V2                (2097152) 
#define VNIC_DEF_VALID_V2               (4194304) 
#define VNIC_DEF_EN_V2                  (8388608) 
#define UMC_MODE_ENABLED_V2             (16777216) 
#define SUPERNIC_MODE_V2                (33554432) 
#define SUPERNIC_DEF_EN_V2              (67108864) 

// --- FUNCTION_PRIVILEGE_CATEGORY_ENUM ---
#define PRIV_DEFAULT_V2                 (1)       
#define PRIV_LNKQUERY_V2                (2)       
#define PRIV_LNKSTATS_V2                (4)       
#define PRIV_LNKMGMT_V2                 (8)       
#define PRIV_LNKDIAG_V2                 (16)      
#define PRIV_UTILQUERY_V2               (32)      
#define PRIV_FILTMGMT_V2                (64)      
#define PRIV_IFACEMGMT_V2               (128)     
#define PRIV_VHADM_V2                   (256)     
#define PRIV_DEVCFG_V2                  (512)     
#define PRIV_DEVSEC_V2                  (1024)    


typedef struct _GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2 {
   UEXACT32 rsvd0;
} SG_PACK GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2;




typedef struct _GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2 {
   UEXACT32 privilege_mask;
} SG_PACK GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2;




typedef union _GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2 {
   GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2 request;
   GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2 response;
} SG_PACK GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2;




typedef struct _IOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V2 {
   union {
      struct { 
         IOCTL_HEADER_V2 header;
         GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2 params;
      } SG_PACK ; // unnamed struct
      u32 dw[5]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V2, *PIOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V2;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_FUNCTION_PRIVILEGES, sizeof (IOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V2) == 20);



typedef struct _SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2 {
   UEXACT32 privilege_mask;
   UEXACT32 PRIVILEGE_MASK;
} SG_PACK SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2, *PSET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2;




typedef struct _SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2 {
   UEXACT32 old_privilege_mask;
} SG_PACK SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2, *PSET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2;




typedef union _SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2 {
   SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V2 request;
   SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V2 response;
} SG_PACK SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2, *PSET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2;




typedef struct _IOCTL_COMMON_SET_FUNCTION_PRIVILEGES_V2 {
   union {
      struct { 
         IOCTL_HEADER_V2 header;
         SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V2 params;
      } SG_PACK ; // unnamed struct
      u32 dw[6]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_SET_FUNCTION_PRIVILEGES_V2, *PIOCTL_COMMON_SET_FUNCTION_PRIVILEGES_V2;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_FUNCTION_PRIVILEGES, sizeof (IOCTL_COMMON_SET_FUNCTION_PRIVILEGES_V2) == 24);



typedef struct _SET_HSW_CONFIG_PARAMS_IN_V2 {
   union {
      struct { 
         u32 intf_pport_id : 16;                  // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 pvid_valid : 1;                      // DWORD 0
         u32 pport : 1;                           // DWORD 0
         u32 ingress_vlan_type : 3;               // DWORD 1
         u32 egress_vlan_type : 3;                // DWORD 1
         u32 port_fwd_type : 3;                   // DWORD 1
         u32 idp_valid : 1;                       // DWORD 1
         u32 rx_sniffer_valid : 1;                // DWORD 1
         u32 tx_sniffer_valid : 1;                // DWORD 1
         u32 promisc : 1;                         // DWORD 1
         u32 vlan_check : 1;                      // DWORD 1
         u32 mac_spoof_check : 1;                 // DWORD 1
         u32 uplink_port : 1;                     // DWORD 1
         u32 pvid : 16;                           // DWORD 1
         UEXACT16 rx_sniffer_cq_id;
         UEXACT16 rx_sniffer_iface_id;
         UEXACT16 tx_sniffer_cq_id;
         UEXACT16 tx_sniffer_iface_id;
         UEXACT16 idp_cq_id;
         UEXACT16 promisc_cq_id;
      } SG_PACK ; // unnamed struct
      u32 dw[5]; // dword union
   }; // unnamed union
} SG_PACK SET_HSW_CONFIG_PARAMS_IN_V2, *PSET_HSW_CONFIG_PARAMS_IN_V2;

SG_C_ASSERT(__sizeof__SET_HSW_CONFIG_PARAMS_IN, sizeof (SET_HSW_CONFIG_PARAMS_IN_V2) == 20);



typedef struct _SET_HSW_CONFIG_PARAMS_OUT_V2 {
   UEXACT32 rsvd0;
} SG_PACK SET_HSW_CONFIG_PARAMS_OUT_V2, *PSET_HSW_CONFIG_PARAMS_OUT_V2;




typedef struct _SET_HSW_CONFIG_PARAMS_V2 {
   union {
      union { 
         SET_HSW_CONFIG_PARAMS_IN_V2 request;
         SET_HSW_CONFIG_PARAMS_OUT_V2 response;
      } SG_PACK ; // unnamed struct
      u32 dw[5]; // dword union
   }; // unnamed union
} SG_PACK SET_HSW_CONFIG_PARAMS_V2, *PSET_HSW_CONFIG_PARAMS_V2;

SG_C_ASSERT(__sizeof__SET_HSW_CONFIG_PARAMS, sizeof (SET_HSW_CONFIG_PARAMS_V2) == 20);



typedef struct _IOCTL_COMMON_SET_HSW_CONFIG_V2 {
   union {
      struct { 
         IOCTL_HEADER_V2 header;
         SET_HSW_CONFIG_PARAMS_V2 params;
      } SG_PACK ; // unnamed struct
      u32 dw[9]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_SET_HSW_CONFIG_V2, *PIOCTL_COMMON_SET_HSW_CONFIG_V2;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_HSW_CONFIG, sizeof (IOCTL_COMMON_SET_HSW_CONFIG_V2) == 36);



typedef struct _GET_HSW_CONFIG_PARAMS_IN_V2 {
   union {
      struct { 
         u32 intf_pport_id : 16;                  // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 pvid_valid : 1;                      // DWORD 0
         u32 pport : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK GET_HSW_CONFIG_PARAMS_IN_V2, *PGET_HSW_CONFIG_PARAMS_IN_V2;

SG_C_ASSERT(__sizeof__GET_HSW_CONFIG_PARAMS_IN, sizeof (GET_HSW_CONFIG_PARAMS_IN_V2) == 4);



typedef struct _GET_HSW_CONFIG_PARAMS_OUT_V2 {
   union {
      struct { 
         u32 ingress_vlan_type : 3;               // DWORD 0
         u32 egress_vlan_type : 3;                // DWORD 0
         u32 port_fwd_type : 3;                   // DWORD 0
         u32 idp_valid : 1;                       // DWORD 0
         u32 rx_sniffer_valid : 1;                // DWORD 0
         u32 tx_sniffer_valid : 1;                // DWORD 0
         u32 promisc : 1;                         // DWORD 0
         u32 vlan_check : 1;                      // DWORD 0
         u32 mac_spoof_check : 1;                 // DWORD 0
         u32 uplink_port : 1;                     // DWORD 0
         u32 pvid : 16;                           // DWORD 0
         UEXACT16 rx_sniffer_cq_id;
         UEXACT16 rx_sniffer_iface_id;
         UEXACT16 tx_sniffer_cq_id;
         UEXACT16 tx_sniffer_iface_id;
         UEXACT16 idp_cq_id;
         UEXACT16 promisc_cq_id;
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK GET_HSW_CONFIG_PARAMS_OUT_V2, *PGET_HSW_CONFIG_PARAMS_OUT_V2;

SG_C_ASSERT(__sizeof__GET_HSW_CONFIG_PARAMS_OUT, sizeof (GET_HSW_CONFIG_PARAMS_OUT_V2) == 16);



typedef struct _GET_HSW_CONFIG_PARAMS_V2 {
   union {
      union { 
         GET_HSW_CONFIG_PARAMS_IN_V2 request;
         GET_HSW_CONFIG_PARAMS_OUT_V2 response;
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK GET_HSW_CONFIG_PARAMS_V2, *PGET_HSW_CONFIG_PARAMS_V2;

SG_C_ASSERT(__sizeof__GET_HSW_CONFIG_PARAMS, sizeof (GET_HSW_CONFIG_PARAMS_V2) == 16);



typedef struct _IOCTL_COMMON_GET_HSW_CONFIG_V2 {
   union {
      struct { 
         IOCTL_HEADER_V2 header;
         GET_HSW_CONFIG_PARAMS_V2 params;
      } SG_PACK ; // unnamed struct
      u32 dw[8]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_COMMON_GET_HSW_CONFIG_V2, *PIOCTL_COMMON_GET_HSW_CONFIG_V2;

SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_HSW_CONFIG, sizeof (IOCTL_COMMON_GET_HSW_CONFIG_V2) == 32);



typedef struct _RXFILT_D_V2 {
   union {
      struct { 
         u32 l2type : 2;                          // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 mac_id : 7;                          // DWORD 0
         u32 port : 2;                            // DWORD 0
         u32 tho : 1;                             // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 l3type : 2;                          // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 dest_id : 13;                        // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 sw : 1;                              // DWORD 0
         u32 vtag : 16;                           // DWORD 1
         u32 len : 14;                            // DWORD 1
         u32 ct : 2;                              // DWORD 1
         u32 mpacrc;                              // DWORD 2
         u32 fpe : 3;                             // DWORD 3
         u32 zeropayload : 1;                     // DWORD 3
         u32 ack_only : 1;                        // DWORD 3
         u32 ip_opt : 1;                          // DWORD 3
         u32 rsvd0 : 8;                           // DWORD 3
         u32 timestamp : 2;                       // DWORD 3
         u32 tcp_data_len : 16;                   // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK RXFILT_D_V2, *PRXFILT_D_V2;

SG_C_ASSERT(__sizeof__RXFILT_D, sizeof (RXFILT_D_V2) == 16);



typedef struct _PCICFG_ID_F0_CSR_V2 {
   union {
      struct { 
         u32 vendorid : 16;                       // DWORD 0
         u32 deviceid : 16;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_ID_F0_CSR_V2, *PPCICFG_ID_F0_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_ID_F0_CSR, sizeof (PCICFG_ID_F0_CSR_V2) == 4);



typedef struct _PCICFG_ID_F1_CSR_V2 {
   union {
      struct { 
         u32 vendorid : 16;                       // DWORD 0
         u32 deviceid : 16;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_ID_F1_CSR_V2, *PPCICFG_ID_F1_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_ID_F1_CSR, sizeof (PCICFG_ID_F1_CSR_V2) == 4);



typedef struct _PCICFG_COMMAND_STATUS_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 1;                           // DWORD 0
         u32 memen : 1;                           // DWORD 0
         u32 bmen : 1;                            // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 perrsp : 1;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 serren : 1;                          // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 intxdisable : 1;                     // DWORD 0
         u32 rsvd4 : 5;                           // DWORD 0
         u32 rsvd5 : 3;                           // DWORD 0
         u32 intstat : 1;                         // DWORD 0
         u32 cap : 1;                             // DWORD 0
         u32 rsvd6 : 1;                           // DWORD 0
         u32 rsvd7 : 1;                           // DWORD 0
         u32 rsvd8 : 1;                           // DWORD 0
         u32 dpderr : 1;                          // DWORD 0
         u32 rsvd9 : 2;                           // DWORD 0
         u32 stabt : 1;                           // DWORD 0
         u32 rtabt : 1;                           // DWORD 0
         u32 rmabt : 1;                           // DWORD 0
         u32 sserr : 1;                           // DWORD 0
         u32 dperr : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_COMMAND_STATUS_CSR_V2, *PPCICFG_COMMAND_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_COMMAND_STATUS_CSR, sizeof (PCICFG_COMMAND_STATUS_CSR_V2) == 4);



typedef struct _PCICFG_OPTION_ROM_BIOS_CSR_V2 {
   union {
      struct { 
         u32 dmtf_clp : 1;                        // DWORD 0
         u32 pxe_init : 1;                        // DWORD 0
         u32 iscsi_init : 1;                      // DWORD 0
         u32 arm_fw_hang : 1;                     // DWORD 0
         u32 bios_future_use : 4;                 // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_OPTION_ROM_BIOS_CSR_V2, *PPCICFG_OPTION_ROM_BIOS_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_OPTION_ROM_BIOS_CSR, sizeof (PCICFG_OPTION_ROM_BIOS_CSR_V2) == 4);



typedef struct _PCICFG_ASIC_ID_CSR_V2 {
   union {
      struct { 
         u32 asic_rev_num : 8;                    // DWORD 0
         u32 asic_gen_num : 8;                    // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_ASIC_ID_CSR_V2, *PPCICFG_ASIC_ID_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_ASIC_ID_CSR, sizeof (PCICFG_ASIC_ID_CSR_V2) == 4);



typedef struct _PCICFG_CLASS_REV_F0_CSR_V2 {
   union {
      struct { 
         u32 rev : 8;                             // DWORD 0
         u32 prgintf : 8;                         // DWORD 0
         u32 subclass : 8;                        // DWORD 0
         u32 baseclass : 8;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_CLASS_REV_F0_CSR_V2, *PPCICFG_CLASS_REV_F0_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_CLASS_REV_F0_CSR, sizeof (PCICFG_CLASS_REV_F0_CSR_V2) == 4);



typedef struct _PCICFG_CLASS_REV_F1_CSR_V2 {
   union {
      struct { 
         u32 rev : 8;                             // DWORD 0
         u32 prgintf : 8;                         // DWORD 0
         u32 subclass : 8;                        // DWORD 0
         u32 baseclass : 8;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_CLASS_REV_F1_CSR_V2, *PPCICFG_CLASS_REV_F1_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_CLASS_REV_F1_CSR, sizeof (PCICFG_CLASS_REV_F1_CSR_V2) == 4);



typedef struct _PCICFG_CACHE_TMR_HDR_BIST_CSR_V2 {
   union {
      struct { 
         u32 cache_size : 8;                      // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 header_type : 8;                     // DWORD 0
         u32 bist : 8;                            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_CACHE_TMR_HDR_BIST_CSR_V2, *PPCICFG_CACHE_TMR_HDR_BIST_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_CACHE_TMR_HDR_BIST_CSR, sizeof (PCICFG_CACHE_TMR_HDR_BIST_CSR_V2) == 4);



typedef struct _PCICFG_IOBAR_CSR_V2 {
   union {
      struct { 
         u32 iospace : 1;                         // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 iobar : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_IOBAR_CSR_V2, *PPCICFG_IOBAR_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_IOBAR_CSR, sizeof (PCICFG_IOBAR_CSR_V2) == 4);



typedef struct _PCICFG_MEMBAR0_LO_CSR_V2 {
   union {
      struct { 
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 membar0 : 18;                        // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MEMBAR0_LO_CSR_V2, *PPCICFG_MEMBAR0_LO_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MEMBAR0_LO_CSR, sizeof (PCICFG_MEMBAR0_LO_CSR_V2) == 4);



typedef struct _PCICFG_MEMBAR1_LO_CSR_V2 {
   union {
      struct { 
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 membar1lo : 15;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MEMBAR1_LO_CSR_V2, *PPCICFG_MEMBAR1_LO_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MEMBAR1_LO_CSR, sizeof (PCICFG_MEMBAR1_LO_CSR_V2) == 4);



typedef struct _PCICFG_MEMBAR0_HI_CSR_V2 {
   union {
      struct { 
         u32 membar0hi;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MEMBAR0_HI_CSR_V2, *PPCICFG_MEMBAR0_HI_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MEMBAR0_HI_CSR, sizeof (PCICFG_MEMBAR0_HI_CSR_V2) == 4);



typedef struct _PCICFG_MEMBAR1_HI_CSR_V2 {
   union {
      struct { 
         u32 membar1hi;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MEMBAR1_HI_CSR_V2, *PPCICFG_MEMBAR1_HI_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MEMBAR1_HI_CSR, sizeof (PCICFG_MEMBAR1_HI_CSR_V2) == 4);



typedef struct _PCICFG_MEMBAR2_LO_F0_CSR_V2 {
   union {
      struct { 
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 memsp_pgsize_0 : 1;                  // DWORD 0
         u32 memsp_pgsize_1 : 1;                  // DWORD 0
         u32 memsp_pgsize_2 : 1;                  // DWORD 0
         u32 memsp_pgsize_3 : 1;                  // DWORD 0
         u32 membar2lo : 11;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MEMBAR2_LO_F0_CSR_V2, *PPCICFG_MEMBAR2_LO_F0_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_LO_F0_CSR, sizeof (PCICFG_MEMBAR2_LO_F0_CSR_V2) == 4);



typedef struct _PCICFG_MEMBAR2_LO_F1_CSR_V2 {
   union {
      struct { 
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
         u32 memsp_pgsize_0 : 1;                  // DWORD 0
         u32 memsp_pgsize_1 : 1;                  // DWORD 0
         u32 memsp_pgsize_2 : 1;                  // DWORD 0
         u32 memsp_pgsize_3 : 1;                  // DWORD 0
         u32 membar2lo : 6;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MEMBAR2_LO_F1_CSR_V2, *PPCICFG_MEMBAR2_LO_F1_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_LO_F1_CSR, sizeof (PCICFG_MEMBAR2_LO_F1_CSR_V2) == 4);



typedef struct _PCICFG_MEMBAR2_HI_CSR_V2 {
   union {
      struct { 
         u32 membar2hi;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MEMBAR2_HI_CSR_V2, *PPCICFG_MEMBAR2_HI_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_HI_CSR, sizeof (PCICFG_MEMBAR2_HI_CSR_V2) == 4);



typedef struct _PCICFG_SUBSYSTEM_ID_F0_CSR_V2 {
   union {
      struct { 
         u32 subsys_vendor_id : 16;               // DWORD 0
         u32 subsys_id : 16;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SUBSYSTEM_ID_F0_CSR_V2, *PPCICFG_SUBSYSTEM_ID_F0_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_SUBSYSTEM_ID_F0_CSR, sizeof (PCICFG_SUBSYSTEM_ID_F0_CSR_V2) == 4);



typedef struct _PCICFG_SUBSYSTEM_ID_F1_CSR_V2 {
   union {
      struct { 
         u32 subsys_vendor_id : 16;               // DWORD 0
         u32 subsys_id : 16;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SUBSYSTEM_ID_F1_CSR_V2, *PPCICFG_SUBSYSTEM_ID_F1_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_SUBSYSTEM_ID_F1_CSR, sizeof (PCICFG_SUBSYSTEM_ID_F1_CSR_V2) == 4);



typedef struct _PCICFG_EXP_ROM_CSR_V2 {
   union {
      struct { 
         u32 exprombarenable : 1;                 // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 exprombar : 16;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_EXP_ROM_CSR_V2, *PPCICFG_EXP_ROM_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_EXP_ROM_CSR, sizeof (PCICFG_EXP_ROM_CSR_V2) == 4);



typedef struct _PCICFG_CAP_CSR_V2 {
   union {
      struct { 
         u32 capptr : 8;                          // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_CAP_CSR_V2, *PPCICFG_CAP_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_CAP_CSR, sizeof (PCICFG_CAP_CSR_V2) == 4);



typedef struct _PCICFG_LATENCY_INT_F0_CSR_V2 {
   union {
      struct { 
         u32 int_line : 8;                        // DWORD 0
         u32 int_pin : 8;                         // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_LATENCY_INT_F0_CSR_V2, *PPCICFG_LATENCY_INT_F0_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_LATENCY_INT_F0_CSR, sizeof (PCICFG_LATENCY_INT_F0_CSR_V2) == 4);



typedef struct _PCICFG_LATENCY_INT_F1_CSR_V2 {
   union {
      struct { 
         u32 int_line : 8;                        // DWORD 0
         u32 int_pin : 8;                         // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_LATENCY_INT_F1_CSR_V2, *PPCICFG_LATENCY_INT_F1_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_LATENCY_INT_F1_CSR, sizeof (PCICFG_LATENCY_INT_F1_CSR_V2) == 4);



typedef struct _PCICFG_SEMAPHORE_SCRATCH_CSR_V2 {
   union {
      struct { 
         u32 locked : 1;                          // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 scratchpad : 16;                     // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SEMAPHORE_SCRATCH_CSR_V2, *PPCICFG_SEMAPHORE_SCRATCH_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_SEMAPHORE_SCRATCH_CSR, sizeof (PCICFG_SEMAPHORE_SCRATCH_CSR_V2) == 4);



typedef struct _PCICFG_SEMAPHORE_CSR_V2 {
   union {
      struct { 
         u32 locked : 1;                          // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SEMAPHORE_CSR_V2, *PPCICFG_SEMAPHORE_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_SEMAPHORE_CSR, sizeof (PCICFG_SEMAPHORE_CSR_V2) == 4);



typedef struct _PCICFG_SOFT_RESET_CSR_V2 {
   union {
      struct { 
         u32 locked : 1;                          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 rrm_host_softack : 1;                // DWORD 0
         u32 ncsi_softreset_reqack : 1;           // DWORD 0
         u32 softreset : 1;                       // DWORD 0
         u32 ncsi_softreset_ctrl : 1;             // DWORD 0
         u32 wait_ncsi_softreset_reqack : 1;      // DWORD 0
         u32 exception_oe : 1;                    // DWORD 0
         u32 d3_softreset_ctrl : 1;               // DWORD 0
         u32 wait_rrm_softreset_reqack : 1;       // DWORD 0
         u32 dbg_all_reqs_62_48 : 11;             // DWORD 0
         u32 driver_ue : 1;                       // DWORD 0
         u32 future_scratchpad : 7;               // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SOFT_RESET_CSR_V2, *PPCICFG_SOFT_RESET_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_SOFT_RESET_CSR, sizeof (PCICFG_SOFT_RESET_CSR_V2) == 4);



typedef struct _PCICFG_DEBUG_CSR_V2 {
   union {
      struct { 
         u32 debugselect : 8;                     // DWORD 0
         u32 debugblock : 8;                      // DWORD 0
         u32 debugchain : 4;                      // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 rgpio_32bits : 1;                    // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
         u32 debugin : 1;                         // DWORD 0
         u32 debugout : 1;                        // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_DEBUG_CSR_V2, *PPCICFG_DEBUG_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_DEBUG_CSR, sizeof (PCICFG_DEBUG_CSR_V2) == 4);


// --- PCICFG_MEMBAR_CONTROL_WINSEL_ENUM ---
#define PCICFG_MEMBAR_CONTROL_WINSEL_DISABLE_V2 (0) 
#define PCICFG_MEMBAR_CONTROL_WINSEL_MEMBAR0_V2 (1) 
#define PCICFG_MEMBAR_CONTROL_WINSEL_MEMBAR1_V2 (2) 
#define PCICFG_MEMBAR_CONTROL_WINSEL_MEMBAR2_V2 (3) 


typedef struct _PCICFG_FUNCTION_IDENTIFIER_F1_V2 {
   union {
      struct { 
         u32 PFNUM : 8;                           // DWORD 0
         u32 periph_host_ctrl : 16;               // DWORD 0
         u32 host_periph_ctrl : 8;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_FUNCTION_IDENTIFIER_F1_V2, *PPCICFG_FUNCTION_IDENTIFIER_F1_V2;

SG_C_ASSERT(__sizeof__PCICFG_FUNCTION_IDENTIFIER_F1, sizeof (PCICFG_FUNCTION_IDENTIFIER_F1_V2) == 4);



typedef struct _PCICFG_FUNCTION_IDENTIFIER_F0_V2 {
   union {
      struct { 
         u32 PFNUM : 8;                           // DWORD 0
         u32 future_scratchpad : 1;               // DWORD 0
         u32 func15to8en : 8;                     // DWORD 0
         u32 id_based_routing_en : 1;             // DWORD 0
         u32 vf_256v_cev_int_line_en1 : 1;        // DWORD 0
         u32 msix_256v_funcnum1 : 4;              // DWORD 0
         u32 f15_f8_4MB_db_bar : 8;               // DWORD 0
         u32 ignore_ARI_for_pfs : 1;              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_FUNCTION_IDENTIFIER_F0_V2, *PPCICFG_FUNCTION_IDENTIFIER_F0_V2;

SG_C_ASSERT(__sizeof__PCICFG_FUNCTION_IDENTIFIER_F0, sizeof (PCICFG_FUNCTION_IDENTIFIER_F0_V2) == 4);



typedef struct _PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2 {
   union {
      struct { 
         u32 winmode : 1;                         // DWORD 0
         u32 membarwinen : 1;                     // DWORD 0
         u32 winaddr : 18;                        // DWORD 0
         u32 sliport_error1 : 2;                  // DWORD 0
         u32 SLI_STATUS_ERR : 1;                  // DWORD 0
         u32 SLI_STATUS_RN : 1;                   // DWORD 0
         u32 vf_256v_cev_int_line_en0 : 1;        // DWORD 0
         u32 vf_cev_int_line_en : 1;              // DWORD 0
         u32 drv_mpu_msg : 2;                     // DWORD 0
         u32 shadow_FLR : 1;                      // DWORD 0
         u32 hostintr : 1;                        // DWORD 0
         u32 winselect : 2;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2, *PPCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MEMBAR_CTRL_INT_CTRL_CSR, sizeof (PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2) == 4);



typedef struct _PCICFG_GPI_CSR_V2 {
   union {
      struct { 
         u32 gpi;                                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_GPI_CSR_V2, *PPCICFG_GPI_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_GPI_CSR, sizeof (PCICFG_GPI_CSR_V2) == 4);



typedef struct _PCICFG_GPO_LOW_CSR_V2 {
   union {
      struct { 
         u32 gpo;                                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_GPO_LOW_CSR_V2, *PPCICFG_GPO_LOW_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_GPO_LOW_CSR, sizeof (PCICFG_GPO_LOW_CSR_V2) == 4);



typedef struct _PCICFG_GPO_HI_CSR_V2 {
   union {
      struct { 
         u32 gpo;                                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_GPO_HI_CSR_V2, *PPCICFG_GPO_HI_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_GPO_HI_CSR, sizeof (PCICFG_GPO_HI_CSR_V2) == 4);



typedef struct _PCICFG_GPIOMUX_CSR_V2 {
   union {
      struct { 
         u32 gpiomux;                             // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_GPIOMUX_CSR_V2, *PPCICFG_GPIOMUX_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_GPIOMUX_CSR, sizeof (PCICFG_GPIOMUX_CSR_V2) == 4);



typedef struct _PCICFG_GPIOMAP_CSR_V2 {
   union {
      struct { 
         u32 gpomap;                              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_GPIOMAP_CSR_V2, *PPCICFG_GPIOMAP_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_GPIOMAP_CSR, sizeof (PCICFG_GPIOMAP_CSR_V2) == 4);



typedef struct _PCIECFG_BE_EXCEPTION_CTRL_CSR_V2 {
   union {
      struct { 
         u32 exception_oe : 1;                    // DWORD 0
         u32 host_dbg_mux_data_core_46_16 : 31;   // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIECFG_BE_EXCEPTION_CTRL_CSR_V2, *PPCIECFG_BE_EXCEPTION_CTRL_CSR_V2;

SG_C_ASSERT(__sizeof__PCIECFG_BE_EXCEPTION_CTRL_CSR, sizeof (PCIECFG_BE_EXCEPTION_CTRL_CSR_V2) == 4);



typedef struct _PCICFG_HOSTD3_INT_STATUS_CSR_V2 {
   union {
      struct { 
         u32 softrst : 1;                         // DWORD 0
         u32 softrst_d3 : 1;                      // DWORD 0
         u32 pcie_linkdn_change : 1;              // DWORD 0
         u32 gpiintr : 1;                         // DWORD 0
         u32 gpirsvd_intr : 1;                    // DWORD 0
         u32 pcie_linkdn : 1;                     // DWORD 0
         u32 pcie_speed_change : 1;               // DWORD 0
         u32 pcie_powerdown_change : 1;           // DWORD 0
         u32 func_pwr_state_reset : 1;            // DWORD 0
         u32 l2t_eval_phase_not_optimal : 1;      // DWORD 0
         u32 pf7_pf0_pm_change : 1;               // DWORD 0
         u32 pf15_pf8_pm_change : 1;              // DWORD 0
         u32 unplanned_shutdown_change : 1;       // DWORD 0
         u32 d3_clk_stop_change : 1;              // DWORD 0
         u32 d3_resource_word_intr : 1;           // DWORD 0
         u32 d3_resource_byte_intr : 1;           // DWORD 0
         u32 mask_d0_data_change_1to0 : 1;        // DWORD 0
         u32 mask_d0_data_change_0to1 : 1;        // DWORD 0
         u32 be_block1_rstgen_st_change : 1;      // DWORD 0
         u32 pad_rst_fund_n_change_1to0 : 1;      // DWORD 0
         u32 pad_rst_fund_n_change_0to1 : 1;      // DWORD 0
         u32 netc_issued_softrst : 1;             // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOSTD3_INT_STATUS_CSR_V2, *PPCICFG_HOSTD3_INT_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOSTD3_INT_STATUS_CSR, sizeof (PCICFG_HOSTD3_INT_STATUS_CSR_V2) == 4);



typedef struct _PCICFG_HOSTD3_INT_MASK_CSR_V2 {
   union {
      struct { 
         u32 softrst : 1;                         // DWORD 0
         u32 softrst_d3 : 1;                      // DWORD 0
         u32 pcie_linkdn_change : 1;              // DWORD 0
         u32 gpiintr : 1;                         // DWORD 0
         u32 gpirsvd_intr : 1;                    // DWORD 0
         u32 pcie_linkdn : 1;                     // DWORD 0
         u32 pcie_speed_change : 1;               // DWORD 0
         u32 pcie_powerdown_change : 1;           // DWORD 0
         u32 func_pwr_state_reset : 1;            // DWORD 0
         u32 l2t_eval_phase_not_optimal : 1;      // DWORD 0
         u32 pf7_pf0_pm_change : 1;               // DWORD 0
         u32 pf15_pf8_pm_change : 1;              // DWORD 0
         u32 unplanned_shutdown_change : 1;       // DWORD 0
         u32 d3_clk_stop_change : 1;              // DWORD 0
         u32 d3_resource_word : 1;                // DWORD 0
         u32 d3_resource_byte : 1;                // DWORD 0
         u32 mask_d0_data_change_1to0 : 1;        // DWORD 0
         u32 mask_d0_data_change : 1;             // DWORD 0
         u32 be_block1_rstgen_st_change : 1;      // DWORD 0
         u32 pad_rst_fund_n_change_1to0 : 1;      // DWORD 0
         u32 pad_rst_fund_n_change_0to1 : 1;      // DWORD 0
         u32 netc_issued_softrst : 1;             // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOSTD3_INT_MASK_CSR_V2, *PPCICFG_HOSTD3_INT_MASK_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOSTD3_INT_MASK_CSR, sizeof (PCICFG_HOSTD3_INT_MASK_CSR_V2) == 4);



typedef struct _PCICFG_HOSTD3_INT_LIVE_CSR_V2 {
   union {
      struct { 
         u32 softrst : 1;                         // DWORD 0
         u32 softrst_d3 : 1;                      // DWORD 0
         u32 pcie_linkdn : 1;                     // DWORD 0
         u32 gpiintr : 1;                         // DWORD 0
         u32 gpirsvd_intr : 1;                    // DWORD 0
         u32 pcie_speed : 2;                      // DWORD 0
         u32 pcie_powerdown : 2;                  // DWORD 0
         u32 unplanned_shutdown : 1;              // DWORD 0
         u32 d3_clk_stop : 1;                     // DWORD 0
         u32 mask_d0_data : 1;                    // DWORD 0
         u32 pad_rst_fund_n : 1;                  // DWORD 0
         u32 hostd3_ncsi_intr : 1;                // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOSTD3_INT_LIVE_CSR_V2, *PPCICFG_HOSTD3_INT_LIVE_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOSTD3_INT_LIVE_CSR, sizeof (PCICFG_HOSTD3_INT_LIVE_CSR_V2) == 4);



typedef struct _PCICFG_HOST_INT_MASK2_CSR_V2 {
   union {
      struct { 
         u32 bmen_state_change : 1;               // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 tph_disable : 1;                     // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 flr_intren_rst : 1;                  // DWORD 0
         u32 rsvd2 : 7;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_INT_MASK2_CSR_V2, *PPCICFG_HOST_INT_MASK2_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_MASK2_CSR, sizeof (PCICFG_HOST_INT_MASK2_CSR_V2) == 4);



typedef struct _PCICFG_HOST_INT_STATUS2_CSR_V2 {
   union {
      struct { 
         u32 bmen_state_change : 1;               // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 sliport_error2 : 1;                  // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_INT_STATUS2_CSR_V2, *PPCICFG_HOST_INT_STATUS2_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_STATUS2_CSR, sizeof (PCICFG_HOST_INT_STATUS2_CSR_V2) == 4);



typedef struct _PCICFG_HOST_INT_STATUS_CSR_V2 {
   union {
      struct { 
         u32 tmr : 1;                             // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 softrst : 1;                         // DWORD 0
         u32 pcie_linkdn : 1;                     // DWORD 0
         u32 pcie_replay_rollover : 1;            // DWORD 0
         u32 gpiintr : 1;                         // DWORD 0
         u32 pwrstate_change_intr : 1;            // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 ats_en_change_intr : 1;              // DWORD 0
         u32 msixtbl_perr_intr : 1;               // DWORD 0
         u32 link_error_max_intr : 1;             // DWORD 0
         u32 aspm_change_intr : 1;                // DWORD 0
         u32 LTSSM_L0_state_change_intr : 1;      // DWORD 0
         u32 tph_req_en_change_intr : 1;          // DWORD 0
         u32 ats_invalid_req_intr : 1;            // DWORD 0
         u32 ats_cmpl_avail : 1;                  // DWORD 0
         u32 pf_vpd_req_intr : 1;                 // DWORD 0
         u32 vfs_vpd_req_intr_0 : 1;              // DWORD 0
         u32 ARI_en_change_intr : 1;              // DWORD 0
         u32 msi_en_change_intr : 1;              // DWORD 0
         u32 tph_st_mdoe_sel_change_intr : 1;     // DWORD 0
         u32 cmpl_tmout_disable_change_intr : 1;  // DWORD 0
         u32 vfs_vpd_req_intr_1 : 1;              // DWORD 0
         u32 l2t_int : 1;                         // DWORD 0
         u32 TL_INT : 1;                          // DWORD 0
         u32 RXB_PERR : 1;                        // DWORD 0
         u32 TXB_PERR : 1;                        // DWORD 0
         u32 cust_pfs_vpd_req_intr : 1;           // DWORD 0
         u32 l2t_hotreset : 1;                    // DWORD 0
         u32 lltxulp_perr : 1;                    // DWORD 0
         u32 wdma_perr : 1;                       // DWORD 0
         u32 resource_arbiter_word_intr : 1;      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_INT_STATUS_CSR_V2, *PPCICFG_HOST_INT_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_STATUS_CSR, sizeof (PCICFG_HOST_INT_STATUS_CSR_V2) == 4);



typedef struct _PCICFG_HOST_INT_MASK_CSR_V2 {
   union {
      struct { 
         u32 tmr : 1;                             // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 softrst : 1;                         // DWORD 0
         u32 pcie_linkdn : 1;                     // DWORD 0
         u32 pcie_replay_rollover : 1;            // DWORD 0
         u32 gpiintr : 1;                         // DWORD 0
         u32 pwrstate_change : 1;                 // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 ats_en_change : 1;                   // DWORD 0
         u32 msixtbl_perr : 1;                    // DWORD 0
         u32 link_error_max : 1;                  // DWORD 0
         u32 aspm_change : 1;                     // DWORD 0
         u32 LTSSM_L0_state_change : 1;           // DWORD 0
         u32 tph_req_en_change : 1;               // DWORD 0
         u32 ats_invalid_req : 1;                 // DWORD 0
         u32 ats_cmpl_avail : 1;                  // DWORD 0
         u32 pf_vpd_req : 1;                      // DWORD 0
         u32 vfs_vpd_req_intr_0 : 1;              // DWORD 0
         u32 ARI_en_change : 1;                   // DWORD 0
         u32 msi_en_change : 1;                   // DWORD 0
         u32 tph_st_mdoe_sel_change : 1;          // DWORD 0
         u32 cmpl_tmout_disable_change : 1;       // DWORD 0
         u32 vfs_vpd_req_intr_1 : 1;              // DWORD 0
         u32 l2t_int : 1;                         // DWORD 0
         u32 TL_INT : 1;                          // DWORD 0
         u32 RXB_PERR : 1;                        // DWORD 0
         u32 TXB_PERR : 1;                        // DWORD 0
         u32 cust_pfs_vpd_req_intr : 1;           // DWORD 0
         u32 l2t_hotreset : 1;                    // DWORD 0
         u32 lltxulp_perr : 1;                    // DWORD 0
         u32 wdma_perr : 1;                       // DWORD 0
         u32 resource_arbiter_word_intr : 1;      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_INT_MASK_CSR_V2, *PPCICFG_HOST_INT_MASK_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_MASK_CSR, sizeof (PCICFG_HOST_INT_MASK_CSR_V2) == 4);



typedef struct _PCICFG_HOSTD3_UE_STATUS_CSR_V2 {
   union {
      struct { 
         u32 netc_mpu_ue : 1;                     // DWORD 0
         u32 rr_ue_err : 1;                       // DWORD 0
         u32 rr_ue_nomatch : 1;                   // DWORD 0
         u32 mgmt_ue : 1;                         // DWORD 0
         u32 periph_gpio_ue : 1;                  // DWORD 0
         u32 d0block_global_ue : 1;               // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOSTD3_UE_STATUS_CSR_V2, *PPCICFG_HOSTD3_UE_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOSTD3_UE_STATUS_CSR, sizeof (PCICFG_HOSTD3_UE_STATUS_CSR_V2) == 4);



typedef struct _PCICFG_HOSTD3_UE_MASK_CSR_V2 {
   union {
      struct { 
         u32 netc_mpu_ue : 1;                     // DWORD 0
         u32 rr_ue_err : 1;                       // DWORD 0
         u32 rr_ue_nomatch : 1;                   // DWORD 0
         u32 mgmt_ue : 1;                         // DWORD 0
         u32 periph_gpio_ue : 1;                  // DWORD 0
         u32 d0block_global_ue : 1;               // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOSTD3_UE_MASK_CSR_V2, *PPCICFG_HOSTD3_UE_MASK_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOSTD3_UE_MASK_CSR, sizeof (PCICFG_HOSTD3_UE_MASK_CSR_V2) == 4);



typedef struct _PCICFG_UE_STATUS_LOW_CSR_V2 {
   union {
      struct { 
         u32 cev_ue_status : 1;                   // DWORD 0
         u32 ctx_ue_status : 1;                   // DWORD 0
         u32 dbuf_ue_status : 1;                  // DWORD 0
         u32 erx_ue_status : 1;                   // DWORD 0
         u32 host_ue_status : 1;                  // DWORD 0
         u32 mpu_ue_status : 1;                   // DWORD 0
         u32 ndma_ue_status : 1;                  // DWORD 0
         u32 ptc_ue_status : 1;                   // DWORD 0
         u32 rdma_ue_status : 1;                  // DWORD 0
         u32 rxf_ue_status : 1;                   // DWORD 0
         u32 rxips_ue_status : 1;                 // DWORD 0
         u32 rxulp0_ue_status : 1;                // DWORD 0
         u32 rxulp1_ue_status : 1;                // DWORD 0
         u32 rxulp2_ue_status : 1;                // DWORD 0
         u32 tim_ue_status : 1;                   // DWORD 0
         u32 tpost_ue_status : 1;                 // DWORD 0
         u32 tpre_ue_status : 1;                  // DWORD 0
         u32 txips_ue_status : 1;                 // DWORD 0
         u32 txulp0_ue_status : 1;                // DWORD 0
         u32 txulp1_ue_status : 1;                // DWORD 0
         u32 uc_ue_status : 1;                    // DWORD 0
         u32 wdma_ue_status : 1;                  // DWORD 0
         u32 txulp2_ue_status : 1;                // DWORD 0
         u32 host1_ue_status : 1;                 // DWORD 0
         u32 p0_ob_link_ue_status : 1;            // DWORD 0
         u32 p1_ob_link_ue_status : 1;            // DWORD 0
         u32 host_gpio_ue_status : 1;             // DWORD 0
         u32 mbox_ue_status : 1;                  // DWORD 0
         u32 erx2_ue_status : 1;                  // DWORD 0
         u32 spare_ue_status : 1;                 // DWORD 0
         u32 jtag_ue_status : 1;                  // DWORD 0
         u32 mpu_intpend_ue_status : 1;           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_UE_STATUS_LOW_CSR_V2, *PPCICFG_UE_STATUS_LOW_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_LOW_CSR, sizeof (PCICFG_UE_STATUS_LOW_CSR_V2) == 4);



typedef struct _PCICFG_UE_STATUS_HI_CSR_V2 {
   union {
      struct { 
         u32 lpcmemhost_ue_status : 1;            // DWORD 0
         u32 mgmt_mac_ue_status : 1;              // DWORD 0
         u32 pcs0online_ue_status : 1;            // DWORD 0
         u32 mpu_iram_ue_status : 1;              // DWORD 0
         u32 pcs1online_ue_status : 1;            // DWORD 0
         u32 pctl0_ue_status : 1;                 // DWORD 0
         u32 pctl1_ue_status : 1;                 // DWORD 0
         u32 pmem_ue_status : 1;                  // DWORD 0
         u32 rr_ue_status : 1;                    // DWORD 0
         u32 txpb_ue_status : 1;                  // DWORD 0
         u32 rxpp_ue_status : 1;                  // DWORD 0
         u32 xaui_ue_status : 1;                  // DWORD 0
         u32 txp_ue_status : 1;                   // DWORD 0
         u32 arm_ue_status : 1;                   // DWORD 0
         u32 ipc_ue_status : 1;                   // DWORD 0
         u32 host2_ue_status : 1;                 // DWORD 0
         u32 host3_ue_status : 1;                 // DWORD 0
         u32 host4_ue_status : 1;                 // DWORD 0
         u32 host5_ue_status : 1;                 // DWORD 0
         u32 host6_ue_status : 1;                 // DWORD 0
         u32 host7_ue_status : 1;                 // DWORD 0
         u32 host8_ue_status : 1;                 // DWORD 0
         u32 host9_ue_status : 1;                 // DWORD 0
         u32 netc_ue_status : 1;                  // DWORD 0
         u32 periph_ue_status : 1;                // DWORD 0
         u32 lltxulp_ue_status : 1;               // DWORD 0
         u32 d2p_ue_status : 1;                   // DWORD 0
         u32 rcon_ue_status : 1;                  // DWORD 0
         u32 ldma_ue_status : 1;                  // DWORD 0
         u32 lltxp_ue_status : 1;                 // DWORD 0
         u32 lltxpb_ue_status : 1;                // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_UE_STATUS_HI_CSR_V2, *PPCICFG_UE_STATUS_HI_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_HI_CSR, sizeof (PCICFG_UE_STATUS_HI_CSR_V2) == 4);



typedef struct _PCICFG_UE_STATUS_LOW_MASK_CSR_V2 {
   union {
      struct { 
         u32 cev_ue_mask : 1;                     // DWORD 0
         u32 ctx_ue_mask : 1;                     // DWORD 0
         u32 dbuf_ue_mask : 1;                    // DWORD 0
         u32 erx_ue_mask : 1;                     // DWORD 0
         u32 host_ue_mask : 1;                    // DWORD 0
         u32 mpu_ue_mask : 1;                     // DWORD 0
         u32 ndma_ue_mask : 1;                    // DWORD 0
         u32 ptc_ue_mask : 1;                     // DWORD 0
         u32 rdma_ue_mask : 1;                    // DWORD 0
         u32 rxf_ue_mask : 1;                     // DWORD 0
         u32 rxips_ue_mask : 1;                   // DWORD 0
         u32 rxulp0_ue_mask : 1;                  // DWORD 0
         u32 rxulp1_ue_mask : 1;                  // DWORD 0
         u32 rxulp2_ue_mask : 1;                  // DWORD 0
         u32 tim_ue_mask : 1;                     // DWORD 0
         u32 tpost_ue_mask : 1;                   // DWORD 0
         u32 tpre_ue_mask : 1;                    // DWORD 0
         u32 txips_ue_mask : 1;                   // DWORD 0
         u32 txulp0_ue_mask : 1;                  // DWORD 0
         u32 txulp1_ue_mask : 1;                  // DWORD 0
         u32 uc_ue_mask : 1;                      // DWORD 0
         u32 wdma_ue_mask : 1;                    // DWORD 0
         u32 txulp2_ue_mask : 1;                  // DWORD 0
         u32 host1_ue_mask : 1;                   // DWORD 0
         u32 p0_ob_link_ue_mask : 1;              // DWORD 0
         u32 p1_ob_link_ue_mask : 1;              // DWORD 0
         u32 host_gpio_ue_mask : 1;               // DWORD 0
         u32 mbox_ue_mask : 1;                    // DWORD 0
         u32 erx2_ue_mask : 1;                    // DWORD 0
         u32 spare_ue_mask : 1;                   // DWORD 0
         u32 jtag_ue_mask : 1;                    // DWORD 0
         u32 mpu_intpend_ue_mask : 1;             // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_UE_STATUS_LOW_MASK_CSR_V2, *PPCICFG_UE_STATUS_LOW_MASK_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_LOW_MASK_CSR, sizeof (PCICFG_UE_STATUS_LOW_MASK_CSR_V2) == 4);



typedef struct _PCICFG_UE_STATUS_HI_MASK_CSR_V2 {
   union {
      struct { 
         u32 lpcmemhost_ue_mask : 1;              // DWORD 0
         u32 mgmt_mac_ue_mask : 1;                // DWORD 0
         u32 pcs0online_ue_mask : 1;              // DWORD 0
         u32 mpu_iram_ue_mask : 1;                // DWORD 0
         u32 pcs1online_ue_mask : 1;              // DWORD 0
         u32 pctl0_ue_mask : 1;                   // DWORD 0
         u32 pctl1_ue_mask : 1;                   // DWORD 0
         u32 pmem_ue_mask : 1;                    // DWORD 0
         u32 rr_ue_mask : 1;                      // DWORD 0
         u32 txpb_ue_mask : 1;                    // DWORD 0
         u32 rxpp_ue_mask : 1;                    // DWORD 0
         u32 xaui_ue_mask : 1;                    // DWORD 0
         u32 txp_ue_mask : 1;                     // DWORD 0
         u32 arm_ue_mask : 1;                     // DWORD 0
         u32 ipc_ue_mask : 1;                     // DWORD 0
         u32 host2_ue_mask : 1;                   // DWORD 0
         u32 host3_ue_mask : 1;                   // DWORD 0
         u32 host4_ue_mask : 1;                   // DWORD 0
         u32 host5_ue_mask : 1;                   // DWORD 0
         u32 host6_ue_mask : 1;                   // DWORD 0
         u32 host7_ue_mask : 1;                   // DWORD 0
         u32 host8_ue_mask : 1;                   // DWORD 0
         u32 host9_ue_mask : 1;                   // DWORD 0
         u32 netc_ue_mask : 1;                    // DWORD 0
         u32 periph_ue_mask : 1;                  // DWORD 0
         u32 lltxulp_ue_mask : 1;                 // DWORD 0
         u32 d2p_ue_mask : 1;                     // DWORD 0
         u32 rcon_ue_mask : 1;                    // DWORD 0
         u32 ldma_ue_mask : 1;                    // DWORD 0
         u32 lltxp_ue_mask : 1;                   // DWORD 0
         u32 lltxpb_ue_mask : 1;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_UE_STATUS_HI_MASK_CSR_V2, *PPCICFG_UE_STATUS_HI_MASK_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_HI_MASK_CSR, sizeof (PCICFG_UE_STATUS_HI_MASK_CSR_V2) == 4);



typedef struct _PCICFG_ONLINE0_CSR_V2 {
   union {
      struct { 
         u32 cev_online : 1;                      // DWORD 0
         u32 ctx_online : 1;                      // DWORD 0
         u32 dbuf_online : 1;                     // DWORD 0
         u32 erx_online : 1;                      // DWORD 0
         u32 host_online : 1;                     // DWORD 0
         u32 mpu_online : 1;                      // DWORD 0
         u32 ndma_online : 1;                     // DWORD 0
         u32 ptc_online : 1;                      // DWORD 0
         u32 rdma_online : 1;                     // DWORD 0
         u32 rxf_online : 1;                      // DWORD 0
         u32 rxips_online : 1;                    // DWORD 0
         u32 rxulp0_online : 1;                   // DWORD 0
         u32 rxulp1_online : 1;                   // DWORD 0
         u32 rxulp2_online : 1;                   // DWORD 0
         u32 tim_online : 1;                      // DWORD 0
         u32 tpost_online : 1;                    // DWORD 0
         u32 tpre_online : 1;                     // DWORD 0
         u32 txips_online : 1;                    // DWORD 0
         u32 txulp0_online : 1;                   // DWORD 0
         u32 txulp1_online : 1;                   // DWORD 0
         u32 uc_online : 1;                       // DWORD 0
         u32 wdma_online : 1;                     // DWORD 0
         u32 txulp2_online : 1;                   // DWORD 0
         u32 host1_online : 1;                    // DWORD 0
         u32 p0_ob_link_online : 1;               // DWORD 0
         u32 p1_ob_link_online : 1;               // DWORD 0
         u32 host_gpio_online : 1;                // DWORD 0
         u32 mbox_online : 1;                     // DWORD 0
         u32 erx2_online : 1;                     // DWORD 0
         u32 spare_online : 1;                    // DWORD 0
         u32 jtag_online : 1;                     // DWORD 0
         u32 mpu_intpend_online : 1;              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_ONLINE0_CSR_V2, *PPCICFG_ONLINE0_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_ONLINE0_CSR, sizeof (PCICFG_ONLINE0_CSR_V2) == 4);



typedef struct _PCICFG_ONLINE1_CSR_V2 {
   union {
      struct { 
         u32 lpcmemhost_online : 1;               // DWORD 0
         u32 mgmt_mac_online : 1;                 // DWORD 0
         u32 pcs0online_online : 1;               // DWORD 0
         u32 mpu_iram_online : 1;                 // DWORD 0
         u32 pcs1online_online : 1;               // DWORD 0
         u32 pctl0_online : 1;                    // DWORD 0
         u32 pctl1_online : 1;                    // DWORD 0
         u32 pmem_online : 1;                     // DWORD 0
         u32 rr_online : 1;                       // DWORD 0
         u32 txpb_online : 1;                     // DWORD 0
         u32 rxpp_online : 1;                     // DWORD 0
         u32 xaui_online : 1;                     // DWORD 0
         u32 txp_online : 1;                      // DWORD 0
         u32 arm_online : 1;                      // DWORD 0
         u32 ipc_online : 1;                      // DWORD 0
         u32 host2_online : 1;                    // DWORD 0
         u32 host3_online : 1;                    // DWORD 0
         u32 host4_online : 1;                    // DWORD 0
         u32 host5_online : 1;                    // DWORD 0
         u32 host6_online : 1;                    // DWORD 0
         u32 host7_online : 1;                    // DWORD 0
         u32 host8_online : 1;                    // DWORD 0
         u32 host9_online : 1;                    // DWORD 0
         u32 netc_online : 1;                     // DWORD 0
         u32 periph_online : 1;                   // DWORD 0
         u32 lltxulp_online : 1;                  // DWORD 0
         u32 d2p_online : 1;                      // DWORD 0
         u32 rcon_online : 1;                     // DWORD 0
         u32 ldma_online : 1;                     // DWORD 0
         u32 lltxp_online : 1;                    // DWORD 0
         u32 lltxpb_online : 1;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_ONLINE1_CSR_V2, *PPCICFG_ONLINE1_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_ONLINE1_CSR, sizeof (PCICFG_ONLINE1_CSR_V2) == 4);



typedef struct _PCICFG_GCLK_CORE_EN0_CSR_V2 {
   union {
      struct { 
         u32 cev_gclk_core_en : 1;                // DWORD 0
         u32 ctx_gclk_core_en : 1;                // DWORD 0
         u32 dbuf_gclk_core_en : 1;               // DWORD 0
         u32 erx_gclk_core_en : 1;                // DWORD 0
         u32 host_gclk_core_en : 1;               // DWORD 0
         u32 mpu_gclk_core_en : 1;                // DWORD 0
         u32 ndma_gclk_core_en : 1;               // DWORD 0
         u32 ptc_gclk_core_en : 1;                // DWORD 0
         u32 rdma_gclk_core_en : 1;               // DWORD 0
         u32 rxf_gclk_core_en : 1;                // DWORD 0
         u32 rxips_gclk_core_en : 1;              // DWORD 0
         u32 rxulp0_gclk_core_en : 1;             // DWORD 0
         u32 rxulp1_gclk_core_en : 1;             // DWORD 0
         u32 rxulp2_gclk_core_en : 1;             // DWORD 0
         u32 tim_gclk_core_en : 1;                // DWORD 0
         u32 tpost_gclk_core_en : 1;              // DWORD 0
         u32 tpre_gclk_core_en : 1;               // DWORD 0
         u32 txips_gclk_core_en : 1;              // DWORD 0
         u32 txulp0_gclk_core_en : 1;             // DWORD 0
         u32 txulp1_gclk_core_en : 1;             // DWORD 0
         u32 uc_gclk_core_en : 1;                 // DWORD 0
         u32 wdma_gclk_core_en : 1;               // DWORD 0
         u32 txulp2_gclk_core_en : 1;             // DWORD 0
         u32 host1_gclk_core_en : 1;              // DWORD 0
         u32 p0_ob_link_gclk_core_en : 1;         // DWORD 0
         u32 p1_ob_link_gclk_core_en : 1;         // DWORD 0
         u32 host_gpio_gclk_core_en : 1;          // DWORD 0
         u32 mbox_gclk_core_en : 1;               // DWORD 0
         u32 erx2_gclk_core_en : 1;               // DWORD 0
         u32 spare_gclk_core_en : 1;              // DWORD 0
         u32 jtag_gclk_core_en : 1;               // DWORD 0
         u32 mpu_intpend_gclk_core_en : 1;        // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_GCLK_CORE_EN0_CSR_V2, *PPCICFG_GCLK_CORE_EN0_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_GCLK_CORE_EN0_CSR, sizeof (PCICFG_GCLK_CORE_EN0_CSR_V2) == 4);



typedef struct _PCICFG_GCLK_CORE_EN1_CSR_V2 {
   union {
      struct { 
         u32 lpcmemhost_gclk_core_en : 1;         // DWORD 0
         u32 mgmt_mac_gclk_core_en : 1;           // DWORD 0
         u32 pcs0online_gclk_core_en : 1;         // DWORD 0
         u32 mpu_iram_gclk_core_en : 1;           // DWORD 0
         u32 pcs1online_gclk_core_en : 1;         // DWORD 0
         u32 pctl0_gclk_core_en : 1;              // DWORD 0
         u32 pctl1_gclk_core_en : 1;              // DWORD 0
         u32 pmem_gclk_core_en : 1;               // DWORD 0
         u32 rr_gclk_core_en : 1;                 // DWORD 0
         u32 txpb_gclk_core_en : 1;               // DWORD 0
         u32 rxpp_gclk_core_en : 1;               // DWORD 0
         u32 xaui_gclk_core_en : 1;               // DWORD 0
         u32 txp_gclk_core_en : 1;                // DWORD 0
         u32 arm_gclk_core_en : 1;                // DWORD 0
         u32 ipc_gclk_core_en : 1;                // DWORD 0
         u32 host2_gclk_core_en : 1;              // DWORD 0
         u32 host3_gclk_core_en : 1;              // DWORD 0
         u32 host4_gclk_core_en : 1;              // DWORD 0
         u32 host5_gclk_core_en : 1;              // DWORD 0
         u32 host6_gclk_core_en : 1;              // DWORD 0
         u32 host7_gclk_core_en : 1;              // DWORD 0
         u32 host8_gclk_core_en : 1;              // DWORD 0
         u32 host9_gclk_core_en : 1;              // DWORD 0
         u32 netc_gclk_core_en : 1;               // DWORD 0
         u32 periph_gclk_core_en : 1;             // DWORD 0
         u32 lltxulp_gclk_core_en : 1;            // DWORD 0
         u32 d2p_gclk_core_en : 1;                // DWORD 0
         u32 rcon_gclk_core_en : 1;               // DWORD 0
         u32 ldma_gclk_core_en : 1;               // DWORD 0
         u32 lltxp_gclk_core_en : 1;              // DWORD 0
         u32 lltxpb_gclk_core_en : 1;             // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_GCLK_CORE_EN1_CSR_V2, *PPCICFG_GCLK_CORE_EN1_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_GCLK_CORE_EN1_CSR, sizeof (PCICFG_GCLK_CORE_EN1_CSR_V2) == 4);



typedef struct _PCICFG_PHY_FLASH_OFFSET_CSR_V2 {
   union {
      struct { 
         u32 phy0_offset : 16;                    // DWORD 0
         u32 phy1_offset : 16;                    // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PHY_FLASH_OFFSET_CSR_V2, *PPCICFG_PHY_FLASH_OFFSET_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PHY_FLASH_OFFSET_CSR, sizeof (PCICFG_PHY_FLASH_OFFSET_CSR_V2) == 4);



typedef struct _PCICFG_SERDES_PLL_CONTROL_V2 {
   union {
      struct { 
         u32 PLL_TXCDREN : 1;                     // DWORD 0
         u32 PLL_TXCDRCH : 3;                     // DWORD 0
         u32 PLLB_SELI : 3;                       // DWORD 0
         u32 PLLA_SELI : 3;                       // DWORD 0
         u32 PLL_SLCTRL : 3;                      // DWORD 0
         u32 PLL_CMUVR : 3;                       // DWORD 0
         u32 PLL_BGTC : 3;                        // DWORD 0
         u32 PLL_BGSV : 3;                        // DWORD 0
         u32 PLL_RES : 3;                         // DWORD 0
         u32 PLL_RBCAP : 2;                       // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SERDES_PLL_CONTROL_V2, *PPCICFG_SERDES_PLL_CONTROL_V2;

SG_C_ASSERT(__sizeof__PCICFG_SERDES_PLL_CONTROL, sizeof (PCICFG_SERDES_PLL_CONTROL_V2) == 4);



typedef struct _PCICFG_FLASH_GREED_CTRL_CSR_V2 {
   union {
      struct { 
         u32 max_contiguous_count : 8;            // DWORD 0
         u32 disable_func0_hp : 1;                // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
         u32 greedy_flash_en : 1;                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_FLASH_GREED_CTRL_CSR_V2, *PPCICFG_FLASH_GREED_CTRL_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_FLASH_GREED_CTRL_CSR, sizeof (PCICFG_FLASH_GREED_CTRL_CSR_V2) == 4);



typedef struct _PCICFG_HOST_TIMER_INT_CTRL_CSR_V2 {
   union {
      struct { 
         u32 hosttimer : 24;                      // DWORD 0
         u32 vf_fun_shared_reg_wr_access : 1;     // DWORD 0
         u32 d3block_shared_reg_wr_access : 1;    // DWORD 0
         u32 clr_pcie_stats : 1;                  // DWORD 0
         u32 ui_enter_l1 : 1;                     // DWORD 0
         u32 lpcism_rrm_lpc : 1;                  // DWORD 0
         u32 membar1_cfg_alias_reg_wr_access : 1; // DWORD 0
         u32 ndma_wrb_factor : 2;                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_TIMER_INT_CTRL_CSR_V2, *PPCICFG_HOST_TIMER_INT_CTRL_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_TIMER_INT_CTRL_CSR, sizeof (PCICFG_HOST_TIMER_INT_CTRL_CSR_V2) == 4);


// --- SYS_PG_SIZE_ENUM ---
#define SYS_PG_4K_V2                    (0)       
#define SYS_PG_8K_V2                    (1)       
#define SYS_PG_16K_V2                   (2)       
#define SYS_PG_64K_V2                   (3)       


typedef struct _PCICFG_HOST_D3_CONTROL_CSR_V2 {
   union {
      struct { 
         u32 d3_PM_PME_en_D0 : 1;                 // DWORD 0
         u32 d3_PM_PME_en_D3 : 1;                 // DWORD 0
         u32 d3_PM_PME_en_openbox : 1;            // DWORD 0
         u32 ncss_softrst_ctrl : 1;               // DWORD 0
         u32 en_softrst_cleanup : 1;              // DWORD 0
         u32 en_default_pwr_save : 1;             // DWORD 0
         u32 ncss_softrst_qualify : 1;            // DWORD 0
         u32 rsvd0 : 17;                          // DWORD 0
         u32 pme_busnum : 8;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_D3_CONTROL_CSR_V2, *PPCICFG_HOST_D3_CONTROL_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_D3_CONTROL_CSR, sizeof (PCICFG_HOST_D3_CONTROL_CSR_V2) == 4);



typedef struct _PCICFG_HOST_D3CONTROL_CSR_V2 {
   union {
      struct { 
         u32 vf_fun_shared_reg_wr_access : 1;     // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 ddr_refresh_ctrl : 3;                // DWORD 0
         u32 ddr_refresh_status : 5;              // DWORD 0
         u32 host_d3_reg_access_func_limit : 8;   // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_D3CONTROL_CSR_V2, *PPCICFG_HOST_D3CONTROL_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_D3CONTROL_CSR, sizeof (PCICFG_HOST_D3CONTROL_CSR_V2) == 4);



typedef struct _PCICFG_HOST_BAR_STATUS_PF1_CSR_V2 {
   union {
      struct { 
         u32 single_bar_support : 1;              // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 roce_support : 1;                    // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_BAR_STATUS_PF1_CSR_V2, *PPCICFG_HOST_BAR_STATUS_PF1_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_BAR_STATUS_PF1_CSR, sizeof (PCICFG_HOST_BAR_STATUS_PF1_CSR_V2) == 4);



typedef struct _PCICFG_HOST_CONTROL1_CSR_V2 {
   union {
      struct { 
         u32 single_bar_support : 16;             // DWORD 0
         u32 roce_support : 16;                   // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_CONTROL1_CSR_V2, *PPCICFG_HOST_CONTROL1_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_CONTROL1_CSR, sizeof (PCICFG_HOST_CONTROL1_CSR_V2) == 4);



typedef struct _PCICFG_PF0_HOST_CONTROL2_CSR_V2 {
   union {
      struct { 
         u32 dpp_cfg_pgsize : 3;                  // DWORD 0
         u32 roce_dpp_bar_32MB : 1;               // DWORD 0
         u32 roce_db_bar_32MB : 1;                // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 pci_global_revid : 8;                // DWORD 0
         u32 pci_global_revid_valid : 1;          // DWORD 0
         u32 pci_sli4_revid_valid : 1;            // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 msix_256v_funcnum0 : 4;              // DWORD 0
         u32 pcicfg_all_extend_membar_wr_access : 1; // DWORD 0
         u32 vf_pcicfg_membar_wr_access : 1;      // DWORD 0
         u32 mask_rrm_host_nomatch : 1;           // DWORD 0
         u32 mask_rrm_host_error : 1;             // DWORD 0
         u32 mask_rrm_host_nomatch_vf_only : 1;   // DWORD 0
         u32 mask_rrm_host_error_vf_only : 1;     // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF0_HOST_CONTROL2_CSR_V2, *PPCICFG_PF0_HOST_CONTROL2_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF0_HOST_CONTROL2_CSR, sizeof (PCICFG_PF0_HOST_CONTROL2_CSR_V2) == 4);



typedef struct _PCICFG_HOST_CONTROL2_CSR_V2 {
   union {
      struct { 
         u32 dpp_cfg_pgsize : 3;                  // DWORD 0
         u32 roce_dpp_bar_32MB : 1;               // DWORD 0
         u32 roce_db_bar_32MB : 1;                // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_CONTROL2_CSR_V2, *PPCICFG_HOST_CONTROL2_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_CONTROL2_CSR, sizeof (PCICFG_HOST_CONTROL2_CSR_V2) == 4);



typedef struct _PCICFG_HOST_CONTROL_STATUS_CSR_V2 {
   union {
      struct { 
         u32 func4en : 1;                         // DWORD 0
         u32 func5en : 1;                         // DWORD 0
         u32 func6en : 1;                         // DWORD 0
         u32 func7en : 1;                         // DWORD 0
         u32 f3_f0_4MB_db_bar : 4;                // DWORD 0
         u32 hostoqdepth : 3;                     // DWORD 0
         u32 hostoqempty : 1;                     // DWORD 0
         u32 hostoqrdpasswren : 1;                // DWORD 0
         u32 driver_ue_en_pcie_error : 1;         // DWORD 0
         u32 func3en : 1;                         // DWORD 0
         u32 func2en : 1;                         // DWORD 0
         u32 f5_f4_4MB_db_bar : 2;                // DWORD 0
         u32 iqrdflushoqwren : 1;                 // DWORD 0
         u32 cev_swacken : 1;                     // DWORD 0
         u32 pcie_linkdn_ue_source : 1;           // DWORD 0
         u32 pcie_retry_buf_ecc_ue_source : 1;    // DWORD 0
         u32 pcie_linkdn_ue_mask : 1;             // DWORD 0
         u32 pcie_retry_buf_ecc_ue_mask : 1;      // DWORD 0
         u32 lpcismtranserr : 1;                  // DWORD 0
         u32 lpcismstaterr : 1;                   // DWORD 0
         u32 fwbootfail : 1;                      // DWORD 0
         u32 expromdisable : 1;                   // DWORD 0
         u32 ARI_spec_en : 1;                     // DWORD 0
         u32 f7_f6_4MB_db_bar : 2;                // DWORD 0
         u32 func1en : 1;                         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HOST_CONTROL_STATUS_CSR_V2, *PPCICFG_HOST_CONTROL_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_HOST_CONTROL_STATUS_CSR, sizeof (PCICFG_HOST_CONTROL_STATUS_CSR_V2) == 4);



typedef struct _PCICFG_LPC_ADDR_CSR_V2 {
   union {
      struct { 
         u32 lpc_addr;                            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_LPC_ADDR_CSR_V2, *PPCICFG_LPC_ADDR_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_LPC_ADDR_CSR, sizeof (PCICFG_LPC_ADDR_CSR_V2) == 4);



typedef struct _PCICFG_LPC_DATA_CSR_V2 {
   union {
      struct { 
         u32 lpc_data;                            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_LPC_DATA_CSR_V2, *PPCICFG_LPC_DATA_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_LPC_DATA_CSR, sizeof (PCICFG_LPC_DATA_CSR_V2) == 4);



typedef struct _PCICFG_LPC_COMMAND_CSR_V2 {
   union {
      struct { 
         u32 be : 4;                              // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 req : 1;                             // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 reg : 1;                             // DWORD 0
         u32 abort : 1;                           // DWORD 0
         u32 rst : 1;                             // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 bus_num : 8;                         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_LPC_COMMAND_CSR_V2, *PPCICFG_LPC_COMMAND_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_LPC_COMMAND_CSR, sizeof (PCICFG_LPC_COMMAND_CSR_V2) == 4);



typedef struct _PCICFG_SLEW_RATE_CTRL_V2 {
   union {
      struct { 
         u32 rmii : 3;                            // DWORD 0
         u32 eth : 3;                             // DWORD 0
         u32 gpio : 3;                            // DWORD 0
         u32 spi : 3;                             // DWORD 0
         u32 vport : 3;                           // DWORD 0
         u32 rmii_clk : 3;                        // DWORD 0
         u32 spi_clk : 3;                         // DWORD 0
         u32 DBG_CLK_OUT : 3;                     // DWORD 0
         u32 dvsr_pads : 3;                       // DWORD 0
         u32 scratchpad : 5;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SLEW_RATE_CTRL_V2, *PPCICFG_SLEW_RATE_CTRL_V2;

SG_C_ASSERT(__sizeof__PCICFG_SLEW_RATE_CTRL, sizeof (PCICFG_SLEW_RATE_CTRL_V2) == 4);



typedef struct _PCICFG_TIMESTAMP_V2 {
   union {
      struct { 
         u32 timestamp;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_TIMESTAMP_V2, *PPCICFG_TIMESTAMP_V2;

SG_C_ASSERT(__sizeof__PCICFG_TIMESTAMP, sizeof (PCICFG_TIMESTAMP_V2) == 4);



typedef struct _PCICFG_SCRATCHPAD_CSR_V2 {
   union {
      struct { 
         u32 VF_identifier : 1;                   // DWORD 0
         u32 scratchpad : 31;                     // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SCRATCHPAD_CSR_V2, *PPCICFG_SCRATCHPAD_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_SCRATCHPAD_CSR, sizeof (PCICFG_SCRATCHPAD_CSR_V2) == 4);



typedef struct _PCICFG_CUST_SCRATCHPAD_CSR_V2 {
   union {
      struct { 
         u32 scratchpad;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_CUST_SCRATCHPAD_CSR_V2, *PPCICFG_CUST_SCRATCHPAD_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_CUST_SCRATCHPAD_CSR, sizeof (PCICFG_CUST_SCRATCHPAD_CSR_V2) == 4);



typedef struct _PCICFG_VF_BAR_STRIDE_V2 {
   union {
      struct { 
         u32 stride : 31;                         // DWORD 0
         u32 stride_en : 1;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_VF_BAR_STRIDE_V2, *PPCICFG_VF_BAR_STRIDE_V2;

SG_C_ASSERT(__sizeof__PCICFG_VF_BAR_STRIDE, sizeof (PCICFG_VF_BAR_STRIDE_V2) == 4);



typedef struct _PCICFG_VF_BAR_STRIDE_SUPPORTED_V2 {
   union {
      struct { 
         u32 rsvd0 : 16;                          // DWORD 0
         u32 supported : 4;                       // DWORD 0
         u32 rsvd1 : 12;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_VF_BAR_STRIDE_SUPPORTED_V2, *PPCICFG_VF_BAR_STRIDE_SUPPORTED_V2;

SG_C_ASSERT(__sizeof__PCICFG_VF_BAR_STRIDE_SUPPORTED, sizeof (PCICFG_VF_BAR_STRIDE_SUPPORTED_V2) == 4);



typedef struct _PCICFG_PCIE_CAP_CSR_V2 {
   union {
      struct { 
         u32 capid : 8;                           // DWORD 0
         u32 nextcap : 8;                         // DWORD 0
         u32 capver : 4;                          // DWORD 0
         u32 devport : 4;                         // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PCIE_CAP_CSR_V2, *PPCICFG_PCIE_CAP_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PCIE_CAP_CSR, sizeof (PCICFG_PCIE_CAP_CSR_V2) == 4);



typedef struct _PCICFG_VPD_CAP_CSR_V2 {
   union {
      struct { 
         u32 capid : 8;                           // DWORD 0
         u32 nextcap : 8;                         // DWORD 0
         u32 addr : 15;                           // DWORD 0
         u32 flag : 1;                            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_VPD_CAP_CSR_V2, *PPCICFG_VPD_CAP_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_VPD_CAP_CSR, sizeof (PCICFG_VPD_CAP_CSR_V2) == 4);



typedef struct _PCICFG_VPD_DATA_CSR_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_VPD_DATA_CSR_V2, *PPCICFG_VPD_DATA_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_VPD_DATA_CSR, sizeof (PCICFG_VPD_DATA_CSR_V2) == 4);



typedef struct _PCICFG_PCIE_DEVCAP_CSR_V2 {
   union {
      struct { 
         u32 payload : 3;                         // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 tag : 1;                             // DWORD 0
         u32 lo_lat : 3;                          // DWORD 0
         u32 l1_lat : 3;                          // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 ROLE_ERR_REP : 1;                    // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 pwr_value : 8;                       // DWORD 0
         u32 pwr_scale : 2;                       // DWORD 0
         u32 FLR : 1;                             // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PCIE_DEVCAP_CSR_V2, *PPCICFG_PCIE_DEVCAP_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PCIE_DEVCAP_CSR, sizeof (PCICFG_PCIE_DEVCAP_CSR_V2) == 4);



typedef struct _PCICFG_PCIE_CONTROL_STATUS_CSR_V2 {
   union {
      struct { 
         u32 CorrErrReportEn : 1;                 // DWORD 0
         u32 NonFatalErrReportEn : 1;             // DWORD 0
         u32 FatalErrReportEn : 1;                // DWORD 0
         u32 UnsuppReqReportEn : 1;               // DWORD 0
         u32 EnableRelaxOrder : 1;                // DWORD 0
         u32 Max_Payload_Size : 3;                // DWORD 0
         u32 ExtendTagFieldEnable : 1;            // DWORD 0
         u32 PhantomFnEnable : 1;                 // DWORD 0
         u32 AuxPwrPMEnable : 1;                  // DWORD 0
         u32 EnableNoSnoop : 1;                   // DWORD 0
         u32 Max_Read_Req_Size : 3;               // DWORD 0
         u32 INITIATE_FLR : 1;                    // DWORD 0
         u32 CorrErrDetect : 1;                   // DWORD 0
         u32 NonFatalErrDetect : 1;               // DWORD 0
         u32 FatalErrDetect : 1;                  // DWORD 0
         u32 UnsuppReqDetect : 1;                 // DWORD 0
         u32 AuxPwrDetect : 1;                    // DWORD 0
         u32 TransPending : 1;                    // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PCIE_CONTROL_STATUS_CSR_V2, *PPCICFG_PCIE_CONTROL_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PCIE_CONTROL_STATUS_CSR, sizeof (PCICFG_PCIE_CONTROL_STATUS_CSR_V2) == 4);



typedef struct _PCICFG_PCIE_LINK_CAP_CSR_V2 {
   union {
      struct { 
         u32 MaxLinkSpeed : 4;                    // DWORD 0
         u32 MaxLinkWidth : 6;                    // DWORD 0
         u32 ASPMSupport : 2;                     // DWORD 0
         u32 L0sExitLat : 3;                      // DWORD 0
         u32 L1ExitLat : 3;                       // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 aspm_opt_cmp : 1;                    // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 PortNum : 8;                         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PCIE_LINK_CAP_CSR_V2, *PPCICFG_PCIE_LINK_CAP_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_CAP_CSR, sizeof (PCICFG_PCIE_LINK_CAP_CSR_V2) == 4);



typedef struct _PCICFG_PCIE_LINK_STATUS_CSR_V2 {
   union {
      struct { 
         u32 ASPMCtl : 2;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ReadCmplBndry : 1;                   // DWORD 0
         u32 LinkDisable : 1;                     // DWORD 0
         u32 RetrainLink : 1;                     // DWORD 0
         u32 CommonClkConfig : 1;                 // DWORD 0
         u32 ExtendSync : 1;                      // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 hw_autonomous_width_dis : 1;         // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 LinkSpeed : 4;                       // DWORD 0
         u32 NegLinkWidth : 6;                    // DWORD 0
         u32 LinkTrainErr : 1;                    // DWORD 0
         u32 LinkTrain : 1;                       // DWORD 0
         u32 SlotClkConfig : 1;                   // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PCIE_LINK_STATUS_CSR_V2, *PPCICFG_PCIE_LINK_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS_CSR, sizeof (PCICFG_PCIE_LINK_STATUS_CSR_V2) == 4);



typedef struct _PCICFG_PCIE_DEVCAP2_CSR_V2 {
   union {
      struct { 
         u32 cmpl_tmout_sup : 4;                  // DWORD 0
         u32 cmpl_tmout_dis_sup : 1;              // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PCIE_DEVCAP2_CSR_V2, *PPCICFG_PCIE_DEVCAP2_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PCIE_DEVCAP2_CSR, sizeof (PCICFG_PCIE_DEVCAP2_CSR_V2) == 4);



typedef struct _PCICFG_PCIE_CONTROL_STATUS2_CSR_V2 {
   union {
      struct { 
         u32 cmpl_tmout_value : 4;                // DWORD 0
         u32 cmpl_tmout_dis : 1;                  // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 IDO_request_en : 1;                  // DWORD 0
         u32 IDO_cmpl_en : 1;                     // DWORD 0
         u32 rsvd1 : 22;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PCIE_CONTROL_STATUS2_CSR_V2, *PPCICFG_PCIE_CONTROL_STATUS2_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PCIE_CONTROL_STATUS2_CSR, sizeof (PCICFG_PCIE_CONTROL_STATUS2_CSR_V2) == 4);



typedef struct _PCICFG_PCIE_LINK_CAP2_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 1;                           // DWORD 0
         u32 link_speed_vector : 7;               // DWORD 0
         u32 rsvd1 : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PCIE_LINK_CAP2_CSR_V2, *PPCICFG_PCIE_LINK_CAP2_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_CAP2_CSR, sizeof (PCICFG_PCIE_LINK_CAP2_CSR_V2) == 4);



typedef struct _PCICFG_PCIE_LINK_STATUS2_CSR_V2 {
   union {
      struct { 
         u32 link_speed : 4;                      // DWORD 0
         u32 enter_compliance : 1;                // DWORD 0
         u32 hw_autonomous_speed_dis : 1;         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 transmit_margin : 3;                 // DWORD 0
         u32 enter_mod_compliance : 1;            // DWORD 0
         u32 compliance_SOS : 1;                  // DWORD 0
         u32 compliance_preset_deemphasis : 4;    // DWORD 0
         u32 current_de_emphasis : 1;             // DWORD 0
         u32 equalization_complete : 1;           // DWORD 0
         u32 equalization_phase1_success : 1;     // DWORD 0
         u32 equalization_phase2_success : 1;     // DWORD 0
         u32 equalization_phase3_success : 1;     // DWORD 0
         u32 link_equalization_request : 1;       // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR_V2, *PPCICFG_PCIE_LINK_STATUS2_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS2_CSR, sizeof (PCICFG_PCIE_LINK_STATUS2_CSR_V2) == 4);



typedef struct _PCICFG_PCIE_LINK_STATUS2_CSR_F1_V2 {
   union {
      struct { 
         u32 rsvd0 : 16;                          // DWORD 0
         u32 current_de_emphasis : 1;             // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR_F1_V2, *PPCICFG_PCIE_LINK_STATUS2_CSR_F1_V2;

SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS2_CSR_F1, sizeof (PCICFG_PCIE_LINK_STATUS2_CSR_F1_V2) == 4);



typedef struct _PCICFG_RETURN_ZEROS_V2 {
   union {
      struct { 
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_RETURN_ZEROS_V2, *PPCICFG_RETURN_ZEROS_V2;

SG_C_ASSERT(__sizeof__PCICFG_RETURN_ZEROS, sizeof (PCICFG_RETURN_ZEROS_V2) == 4);



typedef struct _PCICFG_MSIX_CSR_V2 {
   union {
      struct { 
         u32 capid : 8;                           // DWORD 0
         u32 nextptr : 8;                         // DWORD 0
         u32 tablesize : 11;                      // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 funcmask : 1;                        // DWORD 0
         u32 en : 1;                              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MSIX_CSR_V2, *PPCICFG_MSIX_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MSIX_CSR, sizeof (PCICFG_MSIX_CSR_V2) == 4);



typedef struct _PCICFG_MSIX_TABLE_CSR_V2 {
   union {
      struct { 
         u32 tablebir : 3;                        // DWORD 0
         u32 offset : 29;                         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MSIX_TABLE_CSR_V2, *PPCICFG_MSIX_TABLE_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MSIX_TABLE_CSR, sizeof (PCICFG_MSIX_TABLE_CSR_V2) == 4);



typedef struct _PCICFG_MSIX_PBA_CSR_V2 {
   union {
      struct { 
         u32 pbabir : 3;                          // DWORD 0
         u32 offset : 29;                         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MSIX_PBA_CSR_V2, *PPCICFG_MSIX_PBA_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MSIX_PBA_CSR, sizeof (PCICFG_MSIX_PBA_CSR_V2) == 4);



typedef struct _PCICFG_MSIX_VECTOR_CONTROL_CSR_V2 {
   union {
      struct { 
         u32 mask : 1;                            // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 st_lower : 8;                        // DWORD 0
         u32 st_upper : 8;                        // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MSIX_VECTOR_CONTROL_CSR_V2, *PPCICFG_MSIX_VECTOR_CONTROL_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MSIX_VECTOR_CONTROL_CSR, sizeof (PCICFG_MSIX_VECTOR_CONTROL_CSR_V2) == 4);



typedef struct _PCICFG_MSIX_MSG_DATA_CSR_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MSIX_MSG_DATA_CSR_V2, *PPCICFG_MSIX_MSG_DATA_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_DATA_CSR, sizeof (PCICFG_MSIX_MSG_DATA_CSR_V2) == 4);



typedef struct _PCICFG_MSIX_MSG_ADDR_HI_CSR_V2 {
   union {
      struct { 
         u32 addr;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MSIX_MSG_ADDR_HI_CSR_V2, *PPCICFG_MSIX_MSG_ADDR_HI_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_ADDR_HI_CSR, sizeof (PCICFG_MSIX_MSG_ADDR_HI_CSR_V2) == 4);



typedef struct _PCICFG_MSIX_MSG_ADDR_LO_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 2;                           // DWORD 0
         u32 addr : 30;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MSIX_MSG_ADDR_LO_CSR_V2, *PPCICFG_MSIX_MSG_ADDR_LO_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_ADDR_LO_CSR, sizeof (PCICFG_MSIX_MSG_ADDR_LO_CSR_V2) == 4);



typedef struct _PCICFG_MSIX_PBA_STRUCT_CSR_V2 {
   union {
      struct { 
         u32 pba;                                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MSIX_PBA_STRUCT_CSR_V2, *PPCICFG_MSIX_PBA_STRUCT_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MSIX_PBA_STRUCT_CSR, sizeof (PCICFG_MSIX_PBA_STRUCT_CSR_V2) == 4);



typedef struct _PCICFG_IP_CONTROL_STATUS_0_CSR_V2 {
   union {
      struct { 
         u32 mode_loopback_bist_result_7_0 : 8;   // DWORD 0
         u32 ltssm_state : 7;                     // DWORD 0
         u32 wake_on_pme_tmr_expiry_en : 1;       // DWORD 0
         u32 future_scratchpad1 : 10;             // DWORD 0
         u32 future_scratchpad2 : 4;              // DWORD 0
         u32 BME_pf_to_vf_FLR : 1;                // DWORD 0
         u32 periph_host_d3ism_done : 1;          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_IP_CONTROL_STATUS_0_CSR_V2, *PPCICFG_IP_CONTROL_STATUS_0_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_0_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_0_CSR_V2) == 4);



typedef struct _PCICFG_IP_CONTROL_STATUS_1_CSR_V2 {
   union {
      struct { 
         u32 mode_tx_drv_en : 1;                  // DWORD 0
         u32 vc0_negotiation_pending : 1;         // DWORD 0
         u32 future_scratchpad1 : 2;              // DWORD 0
         u32 PCIE_mdio_phyadr : 5;                // DWORD 0
         u32 future_scratchpad3 : 3;              // DWORD 0
         u32 future_scratchpad2 : 17;             // DWORD 0
         u32 mode_loopback_master_enable : 1;     // DWORD 0
         u32 future_scratchpad0 : 2;              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_IP_CONTROL_STATUS_1_CSR_V2, *PPCICFG_IP_CONTROL_STATUS_1_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_1_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_1_CSR_V2) == 4);



typedef struct _PCICFG_ERR_REPLAY_MONITOR_V2 {
   union {
      struct { 
         u32 ERR_BADDLLP : 1;                     // DWORD 0
         u32 ERR_BADTLP : 1;                      // DWORD 0
         u32 ERR_RECEIVERERROR : 1;               // DWORD 0
         u32 ERR_DLPERR : 1;                      // DWORD 0
         u32 ERR_NULLTLP : 1;                     // DWORD 0
         u32 ERR_REPLAY : 1;                      // DWORD 0
         u32 ERR_REPLAY_NUM : 2;                  // DWORD 0
         u32 ERR_RPC_REPLAY_ROLLOVR : 1;          // DWORD 0
         u32 ERR_RPC_REPLAY_TIMEOUT : 1;          // DWORD 0
         u32 ERR_RPC_REPLAYFIFO_PERR : 1;         // DWORD 0
         u32 ERR_REPLAY_UPPER_UNCORRECTABLE_ERROR : 1; // DWORD 0
         u32 ERR_REPLAY_LOWER_UNCORRECTABLE_ERROR : 1; // DWORD 0
         u32 ERR_REPLAY_UPPER_CORRECTABLE_ERROR : 1; // DWORD 0
         u32 ERR_REPLAY_LOWER_CORRECTABLE_ERROR : 1; // DWORD 0
         u32 REPLAY_SYNDROME_UPPER : 8;           // DWORD 0
         u32 REPLAY_SYNDROME_LOWER : 8;           // DWORD 0
         u32 TXB_PARITY_ERR : 1;                  // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_ERR_REPLAY_MONITOR_V2, *PPCICFG_ERR_REPLAY_MONITOR_V2;

SG_C_ASSERT(__sizeof__PCICFG_ERR_REPLAY_MONITOR, sizeof (PCICFG_ERR_REPLAY_MONITOR_V2) == 4);



typedef struct _PCICFG_IP_SPEED_WIDTH_CTRL_V2 {
   union {
      struct { 
         u32 target_link_speed : 1;               // DWORD 0
         u32 target_link_speed_req : 1;           // DWORD 0
         u32 target_link_width : 8;               // DWORD 0
         u32 target_link_width_req : 1;           // DWORD 0
         u32 target_link_autonomous_req : 1;      // DWORD 0
         u32 clr_link_error_count : 1;            // DWORD 0
         u32 cfg_aspm_l1_dllp_interval_time_limit : 3; // DWORD 0
         u32 target_link_error_cnt : 16;          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_IP_SPEED_WIDTH_CTRL_V2, *PPCICFG_IP_SPEED_WIDTH_CTRL_V2;

SG_C_ASSERT(__sizeof__PCICFG_IP_SPEED_WIDTH_CTRL, sizeof (PCICFG_IP_SPEED_WIDTH_CTRL_V2) == 4);



typedef struct _PCICFG_IP_LINK_ERROR_V2 {
   union {
      struct { 
         u32 future_scratchpad0 : 1;              // DWORD 0
         u32 future_scratch_rw1c_0 : 1;           // DWORD 0
         u32 future_scratchpad1 : 8;              // DWORD 0
         u32 future_scratch_rw1c_1 : 1;           // DWORD 0
         u32 future_scratchpad2 : 1;              // DWORD 0
         u32 clr_link_error_count : 1;            // DWORD 0
         u32 cfg_aspm_l1_dllp_interval_time_limit : 3; // DWORD 0
         u32 target_link_error_cnt : 16;          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_IP_LINK_ERROR_V2, *PPCICFG_IP_LINK_ERROR_V2;

SG_C_ASSERT(__sizeof__PCICFG_IP_LINK_ERROR, sizeof (PCICFG_IP_LINK_ERROR_V2) == 4);



typedef struct _PCICFG_IP_CONTROL_STATUS_5_CSR_V2 {
   union {
      struct { 
         u32 LINK_STATE : 5;                      // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 STATE_LANE_ERROR : 8;                // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 COSPLLOCK : 1;                       // DWORD 0
         u32 EXT_PLL_LOCK : 1;                    // DWORD 0
         u32 logic_analyzer_cal : 1;              // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 LINK_ERROR_MAXED : 8;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_IP_CONTROL_STATUS_5_CSR_V2, *PPCICFG_IP_CONTROL_STATUS_5_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_5_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_5_CSR_V2) == 4);



typedef struct _PCICFG_VF_SLI4_CSR_V2 {
   union {
      struct { 
         u32 scratchpad : 28;                     // DWORD 0
         u32 pf0_sli4_if_type : 4;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_VF_SLI4_CSR_V2, *PPCICFG_VF_SLI4_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_VF_SLI4_CSR, sizeof (PCICFG_VF_SLI4_CSR_V2) == 4);



typedef struct _PCICFG_IP_CONTROL_STATUS_4_CSR_V2 {
   union {
      struct { 
         u32 STATE_NEGOTIATED_LANE_START : 4;     // DWORD 0
         u32 STATE_NEGOTIATED_LANE_END : 4;       // DWORD 0
         u32 STATE_DATA_RATE_IDENTIFIER_RECEIVED : 8; // DWORD 0
         u32 STATE_RECEIVER_DETECTED : 8;         // DWORD 0
         u32 STATE_ELECTRICAL_IDLE_BROKEN : 8;    // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_IP_CONTROL_STATUS_4_CSR_V2, *PPCICFG_IP_CONTROL_STATUS_4_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_4_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_4_CSR_V2) == 4);



typedef struct _PCICFG_IP_CONTROL_STATUS_2_CSR_V2 {
   union {
      struct { 
         u32 future_scratchpad : 29;              // DWORD 0
         u32 pad_fund_rst_n_sync : 1;             // DWORD 0
         u32 future_scratch_rw1c_0 : 2;           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_IP_CONTROL_STATUS_2_CSR_V2, *PPCICFG_IP_CONTROL_STATUS_2_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_2_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_2_CSR_V2) == 4);



typedef struct _PCICFG_IP_CONTROL_STATUS_3_CSR_V2 {
   union {
      struct { 
         u32 LTSSM_state_from_L0 : 7;             // DWORD 0
         u32 cfg_pgsize : 3;                      // DWORD 0
         u32 disable_ecrc : 1;                    // DWORD 0
         u32 disable_cfg_retry : 1;               // DWORD 0
         u32 cust_pf_ecrc_gen_en : 1;             // DWORD 0
         u32 dma_tph_disable : 1;                 // DWORD 0
         u32 dma_steering_disable : 1;            // DWORD 0
         u32 dpp_big_endian : 1;                  // DWORD 0
         u32 down_stream_write_count : 8;         // DWORD 0
         u32 down_stream_read_count : 8;          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_IP_CONTROL_STATUS_3_CSR_V2, *PPCICFG_IP_CONTROL_STATUS_3_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_3_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_3_CSR_V2) == 4);



typedef struct _PCICFG_PMC_CSR_V2 {
   union {
      struct { 
         u32 pmcapid : 8;                         // DWORD 0
         u32 pmnextptr : 8;                       // DWORD 0
         u32 version : 3;                         // DWORD 0
         u32 pme_clk : 1;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 dsi : 1;                             // DWORD 0
         u32 aux_current : 3;                     // DWORD 0
         u32 d1 : 1;                              // DWORD 0
         u32 d2 : 1;                              // DWORD 0
         u32 pme : 5;                             // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PMC_CSR_V2, *PPCICFG_PMC_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_PMC_CSR, sizeof (PCICFG_PMC_CSR_V2) == 4);



typedef struct _PCICFG_D3_PM_CONTROL_MON_V2 {
   union {
      struct { 
         u32 f0_pwr_state : 2;                    // DWORD 0
         u32 f0_pme_en : 1;                       // DWORD 0
         u32 f0_pme_status : 1;                   // DWORD 0
         u32 f1_pwr_state : 2;                    // DWORD 0
         u32 f1_pme_en : 1;                       // DWORD 0
         u32 f1_pme_status : 1;                   // DWORD 0
         u32 f2_pwr_state : 2;                    // DWORD 0
         u32 f2_pme_en : 1;                       // DWORD 0
         u32 f2_pme_status : 1;                   // DWORD 0
         u32 f3_pwr_state : 2;                    // DWORD 0
         u32 f3_pme_en : 1;                       // DWORD 0
         u32 f3_pme_status : 1;                   // DWORD 0
         u32 f4_pwr_state : 2;                    // DWORD 0
         u32 f4_pme_en : 1;                       // DWORD 0
         u32 f4_pme_status : 1;                   // DWORD 0
         u32 f5_pwr_state : 2;                    // DWORD 0
         u32 f5_pme_en : 1;                       // DWORD 0
         u32 f5_pme_status : 1;                   // DWORD 0
         u32 f6_pwr_state : 2;                    // DWORD 0
         u32 f6_pme_en : 1;                       // DWORD 0
         u32 f6_pme_status : 1;                   // DWORD 0
         u32 f7_pwr_state : 2;                    // DWORD 0
         u32 f7_pme_en : 1;                       // DWORD 0
         u32 f7_pme_status : 1;                   // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_D3_PM_CONTROL_MON_V2, *PPCICFG_D3_PM_CONTROL_MON_V2;

SG_C_ASSERT(__sizeof__PCICFG_D3_PM_CONTROL_MON, sizeof (PCICFG_D3_PM_CONTROL_MON_V2) == 4);



typedef struct _PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 {
   union {
      struct { 
         u32 pwr_state : 2;                       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 pme_en : 1;                          // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
         u32 rsvd3 : 2;                           // DWORD 0
         u32 pme_status : 1;                      // DWORD 0
         u32 rsvd4 : 6;                           // DWORD 0
         u32 rsvd5 : 1;                           // DWORD 0
         u32 rsvd6 : 1;                           // DWORD 0
         u32 rsvd7 : 8;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PM_CONTROL_FOR_D3BLOCK_V2, *PPCICFG_PM_CONTROL_FOR_D3BLOCK_V2;

SG_C_ASSERT(__sizeof__PCICFG_PM_CONTROL_FOR_D3BLOCK, sizeof (PCICFG_PM_CONTROL_FOR_D3BLOCK_V2) == 4);



typedef struct _PCICFG_PM_CONTROL_V2 {
   union {
      struct { 
         u32 pwr_state : 2;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 device_specific : 1;                 // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 pme_en : 1;                          // DWORD 0
         u32 data_select : 4;                     // DWORD 0
         u32 data_scale : 2;                      // DWORD 0
         u32 pme_status : 1;                      // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 b2_b3 : 1;                           // DWORD 0
         u32 bpcc_en : 1;                         // DWORD 0
         u32 pmdata : 8;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PM_CONTROL_V2, *PPCICFG_PM_CONTROL_V2;

SG_C_ASSERT(__sizeof__PCICFG_PM_CONTROL, sizeof (PCICFG_PM_CONTROL_V2) == 4);



typedef struct _PCIE_ERR_ENHANCED_CAP_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_ERR_ENHANCED_CAP_V2, *PPCIE_ERR_ENHANCED_CAP_V2;

SG_C_ASSERT(__sizeof__PCIE_ERR_ENHANCED_CAP, sizeof (PCIE_ERR_ENHANCED_CAP_V2) == 4);



typedef struct _PCIE_ARI_CAPABILITY_V2 {
   union {
      struct { 
         u32 mfvc_fg_capability : 1;              // DWORD 0
         u32 acs_fg_capability : 1;               // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 next_fun_num : 8;                    // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_ARI_CAPABILITY_V2, *PPCIE_ARI_CAPABILITY_V2;

SG_C_ASSERT(__sizeof__PCIE_ARI_CAPABILITY, sizeof (PCIE_ARI_CAPABILITY_V2) == 4);



typedef struct _PCIE_ARI_ENHANCED_CAP_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_ARI_ENHANCED_CAP_V2, *PPCIE_ARI_ENHANCED_CAP_V2;

SG_C_ASSERT(__sizeof__PCIE_ARI_ENHANCED_CAP, sizeof (PCIE_ARI_ENHANCED_CAP_V2) == 4);



typedef struct _PCIE_VSEC_CAP_HDR_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_VSEC_CAP_HDR_V2, *PPCIE_VSEC_CAP_HDR_V2;

SG_C_ASSERT(__sizeof__PCIE_VSEC_CAP_HDR, sizeof (PCIE_VSEC_CAP_HDR_V2) == 4);



typedef struct _PCIE_VSEC_BAR_STRIDE_HDR_V2 {
   union {
      struct { 
         u32 vsec_id : 16;                        // DWORD 0
         u32 vsec_rev : 4;                        // DWORD 0
         u32 vsec_length : 12;                    // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_VSEC_BAR_STRIDE_HDR_V2, *PPCIE_VSEC_BAR_STRIDE_HDR_V2;

SG_C_ASSERT(__sizeof__PCIE_VSEC_BAR_STRIDE_HDR, sizeof (PCIE_VSEC_BAR_STRIDE_HDR_V2) == 4);



typedef struct _PCIE_VSEC_HDR_V2 {
   union {
      struct { 
         u32 vsec_id : 16;                        // DWORD 0
         u32 vsec_rev : 4;                        // DWORD 0
         u32 vsec_length : 12;                    // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_VSEC_HDR_V2, *PPCIE_VSEC_HDR_V2;

SG_C_ASSERT(__sizeof__PCIE_VSEC_HDR, sizeof (PCIE_VSEC_HDR_V2) == 4);



typedef struct _PCIE_DEV_SERIAL_CAP_HDR_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_DEV_SERIAL_CAP_HDR_V2, *PPCIE_DEV_SERIAL_CAP_HDR_V2;

SG_C_ASSERT(__sizeof__PCIE_DEV_SERIAL_CAP_HDR, sizeof (PCIE_DEV_SERIAL_CAP_HDR_V2) == 4);



typedef struct _PCIE_DEV_SERIAL_NUM_LOW_V2 {
   union {
      struct { 
         u32 slnum_low;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_DEV_SERIAL_NUM_LOW_V2, *PPCIE_DEV_SERIAL_NUM_LOW_V2;

SG_C_ASSERT(__sizeof__PCIE_DEV_SERIAL_NUM_LOW, sizeof (PCIE_DEV_SERIAL_NUM_LOW_V2) == 4);



typedef struct _PCIE_DEV_SERIAL_NUM_HIGH_V2 {
   union {
      struct { 
         u32 slnum_high;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_DEV_SERIAL_NUM_HIGH_V2, *PPCIE_DEV_SERIAL_NUM_HIGH_V2;

SG_C_ASSERT(__sizeof__PCIE_DEV_SERIAL_NUM_HIGH, sizeof (PCIE_DEV_SERIAL_NUM_HIGH_V2) == 4);



typedef struct _PCIE_ATS_ENHANCED_CAP_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_ATS_ENHANCED_CAP_V2, *PPCIE_ATS_ENHANCED_CAP_V2;

SG_C_ASSERT(__sizeof__PCIE_ATS_ENHANCED_CAP, sizeof (PCIE_ATS_ENHANCED_CAP_V2) == 4);



typedef struct _PCIE_TPH_REQ_CAP_HDR_F0_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_TPH_REQ_CAP_HDR_F0_V2, *PPCIE_TPH_REQ_CAP_HDR_F0_V2;

SG_C_ASSERT(__sizeof__PCIE_TPH_REQ_CAP_HDR_F0, sizeof (PCIE_TPH_REQ_CAP_HDR_F0_V2) == 4);



typedef struct _PCIE_TPH_REQ_CAP_HDR_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_TPH_REQ_CAP_HDR_V2, *PPCIE_TPH_REQ_CAP_HDR_V2;

SG_C_ASSERT(__sizeof__PCIE_TPH_REQ_CAP_HDR, sizeof (PCIE_TPH_REQ_CAP_HDR_V2) == 4);



typedef struct _PCIE_TPH_CAPABILITY_V2 {
   union {
      struct { 
         u32 no_st_mode : 1;                      // DWORD 0
         u32 intr_vec_mode : 1;                   // DWORD 0
         u32 dev_specific_mode : 1;               // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 st_tbl_loc : 2;                      // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 st_tbl_size : 11;                    // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_TPH_CAPABILITY_V2, *PPCIE_TPH_CAPABILITY_V2;

SG_C_ASSERT(__sizeof__PCIE_TPH_CAPABILITY, sizeof (PCIE_TPH_CAPABILITY_V2) == 4);



typedef struct _PCIE_TPH_CONTROL_V2 {
   union {
      struct { 
         u32 st_mode_sel : 3;                     // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 tph_req_enable : 2;                  // DWORD 0
         u32 rsvd1 : 22;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_TPH_CONTROL_V2, *PPCIE_TPH_CONTROL_V2;

SG_C_ASSERT(__sizeof__PCIE_TPH_CONTROL, sizeof (PCIE_TPH_CONTROL_V2) == 4);



typedef struct _PCIE_ATS_CAPABILITY_V2 {
   union {
      struct { 
         u32 inval_queue_depth : 5;               // DWORD 0
         u32 page_align_request : 1;              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 stu : 5;                             // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
         u32 ats_enable : 1;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_ATS_CAPABILITY_V2, *PPCIE_ATS_CAPABILITY_V2;

SG_C_ASSERT(__sizeof__PCIE_ATS_CAPABILITY, sizeof (PCIE_ATS_CAPABILITY_V2) == 4);



typedef struct _PCIE_UNCORR_ERR_STATUS_V2 {
   union {
      struct { 
         u32 training_err : 1;                    // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 data_link_prot_err : 1;              // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 poison_tlp_err : 1;                  // DWORD 0
         u32 flow_ctl_prot_err : 1;               // DWORD 0
         u32 cpl_timeout_err : 1;                 // DWORD 0
         u32 cmpltr_abort_err : 1;                // DWORD 0
         u32 unexp_cpl_err : 1;                   // DWORD 0
         u32 rcvr_overflow_err : 1;               // DWORD 0
         u32 malformed_tlp_err : 1;               // DWORD 0
         u32 ecrc_err : 1;                        // DWORD 0
         u32 unsupp_req_err : 1;                  // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 internal_ue_err : 1;                 // DWORD 0
         u32 rsvd3 : 9;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_UNCORR_ERR_STATUS_V2, *PPCIE_UNCORR_ERR_STATUS_V2;

SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_STATUS, sizeof (PCIE_UNCORR_ERR_STATUS_V2) == 4);



typedef struct _PCIE_UNCORR_ERR_MASK_V2 {
   union {
      struct { 
         u32 training_err : 1;                    // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 data_link_prot_err : 1;              // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 poison_tlp_err : 1;                  // DWORD 0
         u32 flow_ctl_prot_err : 1;               // DWORD 0
         u32 cpl_timeout_err : 1;                 // DWORD 0
         u32 cmpltr_abort_err : 1;                // DWORD 0
         u32 unexp_cpl_err : 1;                   // DWORD 0
         u32 rcvr_overflow_err : 1;               // DWORD 0
         u32 malformed_tlp_err : 1;               // DWORD 0
         u32 ecrc_err : 1;                        // DWORD 0
         u32 unsupp_req_err : 1;                  // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 internal_ue_err : 1;                 // DWORD 0
         u32 rsvd3 : 9;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_UNCORR_ERR_MASK_V2, *PPCIE_UNCORR_ERR_MASK_V2;

SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_MASK, sizeof (PCIE_UNCORR_ERR_MASK_V2) == 4);



typedef struct _PCIE_UNCORR_ERR_SEVERITY_V2 {
   union {
      struct { 
         u32 training_err : 1;                    // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 data_link_prot_err : 1;              // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 poison_tlp_err : 1;                  // DWORD 0
         u32 flow_ctl_prot_err : 1;               // DWORD 0
         u32 cpl_timeout_err : 1;                 // DWORD 0
         u32 cmpltr_abort_err : 1;                // DWORD 0
         u32 unexp_cpl_err : 1;                   // DWORD 0
         u32 rcvr_overflow_err : 1;               // DWORD 0
         u32 malformed_tlp_err : 1;               // DWORD 0
         u32 ecrc_err : 1;                        // DWORD 0
         u32 unsupp_req_err : 1;                  // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 internal_ue_err : 1;                 // DWORD 0
         u32 rsvd3 : 9;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_UNCORR_ERR_SEVERITY_V2, *PPCIE_UNCORR_ERR_SEVERITY_V2;

SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_SEVERITY, sizeof (PCIE_UNCORR_ERR_SEVERITY_V2) == 4);



typedef struct _PCIE_CORR_ERR_STATUS_V2 {
   union {
      struct { 
         u32 rcvr_err : 1;                        // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 bad_tlp_err : 1;                     // DWORD 0
         u32 bad_dllp_err : 1;                    // DWORD 0
         u32 replay_num_rollover_err : 1;         // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 replay_timer_timeout_err : 1;        // DWORD 0
         u32 advisory_no_fatal_error_status : 1;  // DWORD 0
         u32 rsvd2 : 18;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_CORR_ERR_STATUS_V2, *PPCIE_CORR_ERR_STATUS_V2;

SG_C_ASSERT(__sizeof__PCIE_CORR_ERR_STATUS, sizeof (PCIE_CORR_ERR_STATUS_V2) == 4);



typedef struct _PCIE_CORR_ERR_MASK_V2 {
   union {
      struct { 
         u32 rcvr_err : 1;                        // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 bad_tlp_err : 1;                     // DWORD 0
         u32 bad_dllp_err : 1;                    // DWORD 0
         u32 replay_num_rollover_err : 1;         // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 replay_timer_timeout_err : 1;        // DWORD 0
         u32 advisory_no_fatal_error_mask : 1;    // DWORD 0
         u32 rsvd2 : 18;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_CORR_ERR_MASK_V2, *PPCIE_CORR_ERR_MASK_V2;

SG_C_ASSERT(__sizeof__PCIE_CORR_ERR_MASK, sizeof (PCIE_CORR_ERR_MASK_V2) == 4);



typedef struct _PCIE_ERR_CAP_CONTROL_V2 {
   union {
      struct { 
         u32 first_uncorr_err_ptr : 5;            // DWORD 0
         u32 ecrc_gen_cap : 1;                    // DWORD 0
         u32 ecrc_gen_en : 1;                     // DWORD 0
         u32 ecrc_chk_cap : 1;                    // DWORD 0
         u32 ecrc_chk_en : 1;                     // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_ERR_CAP_CONTROL_V2, *PPCIE_ERR_CAP_CONTROL_V2;

SG_C_ASSERT(__sizeof__PCIE_ERR_CAP_CONTROL, sizeof (PCIE_ERR_CAP_CONTROL_V2) == 4);



typedef struct _PCIE_HEADER_REGISTER_V2 {
   union {
      struct { 
         u32 failheader;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_HEADER_REGISTER_V2, *PPCIE_HEADER_REGISTER_V2;

SG_C_ASSERT(__sizeof__PCIE_HEADER_REGISTER, sizeof (PCIE_HEADER_REGISTER_V2) == 4);



typedef struct _PCIE_SR_IOV_ENHANCED_CAP_V2 {
   union {
      struct { 
         u32 sr_iov_capid : 16;                   // DWORD 0
         u32 sr_iov_capver : 4;                   // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SR_IOV_ENHANCED_CAP_V2, *PPCIE_SR_IOV_ENHANCED_CAP_V2;

SG_C_ASSERT(__sizeof__PCIE_SR_IOV_ENHANCED_CAP, sizeof (PCIE_SR_IOV_ENHANCED_CAP_V2) == 4);



typedef struct _PCIE_SR_IOV_CAPABILITIES_V2 {
   union {
      struct { 
         u32 vf_migration : 1;                    // DWORD 0
         u32 ARI_cap_hier : 1;                    // DWORD 0
         u32 rsvd0 : 19;                          // DWORD 0
         u32 vf_migration_intr_msg_no : 11;       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SR_IOV_CAPABILITIES_V2, *PPCIE_SR_IOV_CAPABILITIES_V2;

SG_C_ASSERT(__sizeof__PCIE_SR_IOV_CAPABILITIES, sizeof (PCIE_SR_IOV_CAPABILITIES_V2) == 4);



typedef struct _PCIE_SR_IOV_STATUS_CONTROL_V2 {
   union {
      struct { 
         u32 VF_enable : 1;                       // DWORD 0
         u32 VF_migration_enable : 1;             // DWORD 0
         u32 VF_migration_intr_enable : 1;        // DWORD 0
         u32 VF_memory_space_enable : 1;          // DWORD 0
         u32 VF_ARI_enable : 1;                   // DWORD 0
         u32 rsvd0 : 11;                          // DWORD 0
         u32 VF_migration_status : 1;             // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SR_IOV_STATUS_CONTROL_V2, *PPCIE_SR_IOV_STATUS_CONTROL_V2;

SG_C_ASSERT(__sizeof__PCIE_SR_IOV_STATUS_CONTROL, sizeof (PCIE_SR_IOV_STATUS_CONTROL_V2) == 4);



typedef struct _PCIE_TOTAL_INITIAL_VFs_V2 {
   union {
      struct { 
         u32 initial_VFs : 16;                    // DWORD 0
         u32 total_VFs : 16;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_TOTAL_INITIAL_VFs_V2, *PPCIE_TOTAL_INITIAL_VFs_V2;

SG_C_ASSERT(__sizeof__PCIE_TOTAL_INITIAL_VFs, sizeof (PCIE_TOTAL_INITIAL_VFs_V2) == 4);



typedef struct _PCIE_NUM_VFs_V2 {
   union {
      struct { 
         u32 num_VFs : 16;                        // DWORD 0
         u32 function_dependency_link : 8;        // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_NUM_VFs_V2, *PPCIE_NUM_VFs_V2;

SG_C_ASSERT(__sizeof__PCIE_NUM_VFs, sizeof (PCIE_NUM_VFs_V2) == 4);



typedef struct _PCIE_VF_STRIDE_OFFSET_V2 {
   union {
      struct { 
         u32 first_VF_offset : 16;                // DWORD 0
         u32 VF_stride : 16;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_VF_STRIDE_OFFSET_V2, *PPCIE_VF_STRIDE_OFFSET_V2;

SG_C_ASSERT(__sizeof__PCIE_VF_STRIDE_OFFSET, sizeof (PCIE_VF_STRIDE_OFFSET_V2) == 4);



typedef struct _PCIE_VF_DEVICE_ID_V2 {
   union {
      struct { 
         u32 rsvd0 : 16;                          // DWORD 0
         u32 VF_device_id : 16;                   // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_VF_DEVICE_ID_V2, *PPCIE_VF_DEVICE_ID_V2;

SG_C_ASSERT(__sizeof__PCIE_VF_DEVICE_ID, sizeof (PCIE_VF_DEVICE_ID_V2) == 4);



typedef struct _PCIE_VF_SYSTEM_PAGE_SUPPORTED_V2 {
   union {
      struct { 
         u32 VF_system_page_size_supported;       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_VF_SYSTEM_PAGE_SUPPORTED_V2, *PPCIE_VF_SYSTEM_PAGE_SUPPORTED_V2;

SG_C_ASSERT(__sizeof__PCIE_VF_SYSTEM_PAGE_SUPPORTED, sizeof (PCIE_VF_SYSTEM_PAGE_SUPPORTED_V2) == 4);



typedef struct _PCIE_VF_SYSTEM_PAGE_V2 {
   union {
      struct { 
         u32 VF_system_page_size : 11;            // DWORD 0
         u32 rsvd0 : 21;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_VF_SYSTEM_PAGE_V2, *PPCIE_VF_SYSTEM_PAGE_V2;

SG_C_ASSERT(__sizeof__PCIE_VF_SYSTEM_PAGE, sizeof (PCIE_VF_SYSTEM_PAGE_V2) == 4);



typedef struct _PCICFG_VF_MEMBAR0_LO_V2 {
   union {
      struct { 
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 system_page_decode_0 : 1;            // DWORD 0
         u32 system_page_decode_1 : 1;            // DWORD 0
         u32 system_page_decode_2 : 1;            // DWORD 0
         u32 system_page_decode_3 : 1;            // DWORD 0
         u32 system_page_decode_4 : 1;            // DWORD 0
         u32 system_page_decode_5 : 1;            // DWORD 0
         u32 system_page_decode_6 : 1;            // DWORD 0
         u32 system_page_decode_7 : 1;            // DWORD 0
         u32 system_page_decode_8 : 1;            // DWORD 0
         u32 system_page_decode_9 : 1;            // DWORD 0
         u32 membar1lo : 8;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_VF_MEMBAR0_LO_V2, *PPCICFG_VF_MEMBAR0_LO_V2;

SG_C_ASSERT(__sizeof__PCICFG_VF_MEMBAR0_LO, sizeof (PCICFG_VF_MEMBAR0_LO_V2) == 4);



typedef struct _PCICFG_VF_MEMBAR0_HI_V2 {
   union {
      struct { 
         u32 membar1hi;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_VF_MEMBAR0_HI_V2, *PPCICFG_VF_MEMBAR0_HI_V2;

SG_C_ASSERT(__sizeof__PCICFG_VF_MEMBAR0_HI, sizeof (PCICFG_VF_MEMBAR0_HI_V2) == 4);



typedef struct _PCIE_ATS_INVALID_REQUESTERID_DEVID_V2 {
   union {
      struct { 
         u32 deviceid : 16;                       // DWORD 0
         u32 requesterid : 16;                    // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_ATS_INVALID_REQUESTERID_DEVID_V2, *PPCIE_ATS_INVALID_REQUESTERID_DEVID_V2;

SG_C_ASSERT(__sizeof__PCIE_ATS_INVALID_REQUESTERID_DEVID, sizeof (PCIE_ATS_INVALID_REQUESTERID_DEVID_V2) == 4);



typedef struct _PCIE_ATS_INVALID_ADDR_LOW_V2 {
   union {
      struct { 
         u32 ITAG : 8;                            // DWORD 0
         u32 addr : 24;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_ATS_INVALID_ADDR_LOW_V2, *PPCIE_ATS_INVALID_ADDR_LOW_V2;

SG_C_ASSERT(__sizeof__PCIE_ATS_INVALID_ADDR_LOW, sizeof (PCIE_ATS_INVALID_ADDR_LOW_V2) == 4);



typedef struct _PCIE_ATS_INVALID_ADDR_V2 {
   union {
      struct { 
         u32 addr;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_ATS_INVALID_ADDR_V2, *PPCIE_ATS_INVALID_ADDR_V2;

SG_C_ASSERT(__sizeof__PCIE_ATS_INVALID_ADDR, sizeof (PCIE_ATS_INVALID_ADDR_V2) == 4);



typedef struct _PCIE_BME_TLP_COMMON_HDR0_V2 {
   union {
      struct { 
         u32 length : 13;                         // DWORD 0
         u32 AT : 2;                              // DWORD 0
         u32 type : 4;                            // DWORD 0
         u32 tag : 5;                             // DWORD 0
         u32 msgroute : 3;                        // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 th : 1;                              // DWORD 0
         u32 msix : 1;                            // DWORD 0
         u32 ats2bme_empty : 1;                   // DWORD 0
         u32 req : 1;                             // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_BME_TLP_COMMON_HDR0_V2, *PPCIE_BME_TLP_COMMON_HDR0_V2;

SG_C_ASSERT(__sizeof__PCIE_BME_TLP_COMMON_HDR0, sizeof (PCIE_BME_TLP_COMMON_HDR0_V2) == 4);



typedef struct _PCIE_BME_TLP_COMMON_HDR1_V2 {
   union {
      struct { 
         u32 msgcode : 8;                         // DWORD 0
         u32 tph_hint : 2;                        // DWORD 0
         u32 tph_st : 5;                          // DWORD 0
         u32 immdata_upper_valid : 1;             // DWORD 0
         u32 funcnum : 8;                         // DWORD 0
         u32 busnum : 8;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_BME_TLP_COMMON_HDR1_V2, *PPCIE_BME_TLP_COMMON_HDR1_V2;

SG_C_ASSERT(__sizeof__PCIE_BME_TLP_COMMON_HDR1, sizeof (PCIE_BME_TLP_COMMON_HDR1_V2) == 4);



typedef struct _PCIE_BME_ATS_REQ_TLP_ADDR_HIGH_V2 {
   union {
      struct { 
         u32 addr;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_BME_ATS_REQ_TLP_ADDR_HIGH_V2, *PPCIE_BME_ATS_REQ_TLP_ADDR_HIGH_V2;

SG_C_ASSERT(__sizeof__PCIE_BME_ATS_REQ_TLP_ADDR_HIGH, sizeof (PCIE_BME_ATS_REQ_TLP_ADDR_HIGH_V2) == 4);



typedef struct _PCIE_BME_ATS_REQ_TLP_ADDR_LOW_V2 {
   union {
      struct { 
         u32 W_R_NW : 2;                          // DWORD 0
         u32 U : 1;                               // DWORD 0
         u32 ats_cmpl_err : 1;                    // DWORD 0
         u32 ats_cmpl_err_status : 3;             // DWORD 0
         u32 ats2bme_reqerr : 1;                  // DWORD 0
         u32 dvsr_future : 2;                     // DWORD 0
         u32 N : 1;                               // DWORD 0
         u32 S : 1;                               // DWORD 0
         u32 addr : 20;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_BME_ATS_REQ_TLP_ADDR_LOW_V2, *PPCIE_BME_ATS_REQ_TLP_ADDR_LOW_V2;

SG_C_ASSERT(__sizeof__PCIE_BME_ATS_REQ_TLP_ADDR_LOW, sizeof (PCIE_BME_ATS_REQ_TLP_ADDR_LOW_V2) == 4);



typedef struct _PCICFG_HWDBG_SHIFT_V2 {
   union {
      struct { 
         u32 pclk : 8;                            // DWORD 0
         u32 core_d3 : 8;                         // DWORD 0
         u32 core : 8;                            // DWORD 0
         u32 future_scratchpad : 3;               // DWORD 0
         u32 cfg_attr_en : 1;                     // DWORD 0
         u32 cfg_msi_support : 1;                 // DWORD 0
         u32 msix_regen_dis : 1;                  // DWORD 0
         u32 future_scratchpad0 : 1;              // DWORD 0
         u32 sriov_pf_to_vf_bits : 1;             // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HWDBG_SHIFT_V2, *PPCICFG_HWDBG_SHIFT_V2;

SG_C_ASSERT(__sizeof__PCICFG_HWDBG_SHIFT, sizeof (PCICFG_HWDBG_SHIFT_V2) == 4);



typedef struct _PCICFG_HWDBG_MASK_0_PCLK_V2 {
   union {
      struct { 
         u32 value;                               // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HWDBG_MASK_0_PCLK_V2, *PPCICFG_HWDBG_MASK_0_PCLK_V2;

SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_PCLK, sizeof (PCICFG_HWDBG_MASK_0_PCLK_V2) == 4);



typedef struct _PCICFG_HWDBG_MASK_1_PCLK_V2 {
   union {
      struct { 
         u32 value;                               // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HWDBG_MASK_1_PCLK_V2, *PPCICFG_HWDBG_MASK_1_PCLK_V2;

SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_PCLK, sizeof (PCICFG_HWDBG_MASK_1_PCLK_V2) == 4);



typedef struct _PCICFG_HWDBG_MASK_0_CORE_D3_V2 {
   union {
      struct { 
         u32 value;                               // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HWDBG_MASK_0_CORE_D3_V2, *PPCICFG_HWDBG_MASK_0_CORE_D3_V2;

SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_CORE_D3, sizeof (PCICFG_HWDBG_MASK_0_CORE_D3_V2) == 4);



typedef struct _PCICFG_HWDBG_MASK_1_CORE_D3_V2 {
   union {
      struct { 
         u32 value;                               // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HWDBG_MASK_1_CORE_D3_V2, *PPCICFG_HWDBG_MASK_1_CORE_D3_V2;

SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_CORE_D3, sizeof (PCICFG_HWDBG_MASK_1_CORE_D3_V2) == 4);



typedef struct _PCICFG_HWDBG_MASK_0_CORE_V2 {
   union {
      struct { 
         u32 value;                               // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HWDBG_MASK_0_CORE_V2, *PPCICFG_HWDBG_MASK_0_CORE_V2;

SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_CORE, sizeof (PCICFG_HWDBG_MASK_0_CORE_V2) == 4);



typedef struct _PCICFG_HWDBG_MASK_1_CORE_V2 {
   union {
      struct { 
         u32 value;                               // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HWDBG_MASK_1_CORE_V2, *PPCICFG_HWDBG_MASK_1_CORE_V2;

SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_CORE, sizeof (PCICFG_HWDBG_MASK_1_CORE_V2) == 4);



typedef struct _PCICFG_HWDBG_REGSEL_V2 {
   union {
      struct { 
         u32 pclk : 8;                            // DWORD 0
         u32 core_d3 : 8;                         // DWORD 0
         u32 core : 8;                            // DWORD 0
         u32 up_stream_write_count : 8;           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HWDBG_REGSEL_V2, *PPCICFG_HWDBG_REGSEL_V2;

SG_C_ASSERT(__sizeof__PCICFG_HWDBG_REGSEL, sizeof (PCICFG_HWDBG_REGSEL_V2) == 4);



typedef struct _PCICFG_F1_HOST_DEBUG1_V2 {
   union {
      struct { 
         u32 ats_tag_num : 8;                     // DWORD 0
         u32 ats_tag_bit_5_6 : 2;                 // DWORD 0
         u32 ats_relaxorder : 1;                  // DWORD 0
         u32 ats_nosnoop : 1;                     // DWORD 0
         u32 ats_idorder_dis : 1;                 // DWORD 0
         u32 rsvd0 : 19;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_F1_HOST_DEBUG1_V2, *PPCICFG_F1_HOST_DEBUG1_V2;

SG_C_ASSERT(__sizeof__PCICFG_F1_HOST_DEBUG1, sizeof (PCICFG_F1_HOST_DEBUG1_V2) == 4);



typedef struct _PCICFG_F1_HOST_DEBUG_V2 {
   union {
      struct { 
         u32 cfg_extend_tag_en : 1;               // DWORD 0
         u32 ldma_hostoqdepth : 4;                // DWORD 0
         u32 pad_ismoff_i : 1;                    // DWORD 0
         u32 pad_core_ismoff_i : 1;               // DWORD 0
         u32 pad_crchashchkoff_i : 1;             // DWORD 0
         u32 pads_debugout_i : 1;                 // DWORD 0
         u32 pad_flashboot : 1;                   // DWORD 0
         u32 pads_host_fgen1_i : 1;               // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 mpu_host_server_int : 1;             // DWORD 0
         u32 dbg_ats2bme : 1;                     // DWORD 0
         u32 dma_tag_limit : 8;                   // DWORD 0
         u32 ndma_hostoqdepth : 4;                // DWORD 0
         u32 rdma_hostoqdepth : 4;                // DWORD 0
         u32 wdma_hostoqdepth_bit3 : 1;           // DWORD 0
         u32 pads_host_fgen2_i : 1;               // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_F1_HOST_DEBUG_V2, *PPCICFG_F1_HOST_DEBUG_V2;

SG_C_ASSERT(__sizeof__PCICFG_F1_HOST_DEBUG, sizeof (PCICFG_F1_HOST_DEBUG_V2) == 4);



typedef struct _PCICFG_STRAP_PINS_REG_V2 {
   union {
      struct { 
         u32 pad_straps;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_STRAP_PINS_REG_V2, *PPCICFG_STRAP_PINS_REG_V2;

SG_C_ASSERT(__sizeof__PCICFG_STRAP_PINS_REG, sizeof (PCICFG_STRAP_PINS_REG_V2) == 4);



typedef struct _PCICFG_STRAPS_REG_V2 {
   union {
      struct { 
         u32 pad_ismoff : 1;                      // DWORD 0
         u32 pad_core_ismoff : 1;                 // DWORD 0
         u32 pad_crchashchkoff : 1;               // DWORD 0
         u32 pads_debugout : 1;                   // DWORD 0
         u32 pad_flashboot : 1;                   // DWORD 0
         u32 pads_host_fgen1 : 1;                 // DWORD 0
         u32 STRAP_PCIE_IOGB40G_RST_CTRL : 1;     // DWORD 0
         u32 STRAP_PCIE_LINK_FUND_RST_CTRL : 1;   // DWORD 0
         u32 STRAP_PCIE_SER_FUND_RST_CTRL : 1;    // DWORD 0
         u32 STRAP_PCIE_MODE_SLOT_CLOCK_CONFIG : 1; // DWORD 0
         u32 STRAP_PCIE_MODE_WIDTH : 2;           // DWORD 0
         u32 pads_host_fgen2 : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 pads_host_wake_in_n : 1;             // DWORD 0
         u32 rsvd1 : 17;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_STRAPS_REG_V2, *PPCICFG_STRAPS_REG_V2;

SG_C_ASSERT(__sizeof__PCICFG_STRAPS_REG, sizeof (PCICFG_STRAPS_REG_V2) == 4);



typedef struct _PCICFG_HWDBG_ENABLE_V2 {
   union {
      struct { 
         u32 pclk : 1;                            // DWORD 0
         u32 mor_tag : 5;                         // DWORD 0
         u32 mor_ep_out : 1;                      // DWORD 0
         u32 mor_status_latch : 1;                // DWORD 0
         u32 core_d3 : 1;                         // DWORD 0
         u32 mor_err_status : 3;                  // DWORD 0
         u32 mor_tag_bits7_5 : 3;                 // DWORD 0
         u32 rdma_err : 1;                        // DWORD 0
         u32 core : 1;                            // DWORD 0
         u32 rdma_tag : 5;                        // DWORD 0
         u32 rdma_prty : 2;                       // DWORD 0
         u32 up_stream_read_count : 8;            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_HWDBG_ENABLE_V2, *PPCICFG_HWDBG_ENABLE_V2;

SG_C_ASSERT(__sizeof__PCICFG_HWDBG_ENABLE, sizeof (PCICFG_HWDBG_ENABLE_V2) == 4);



typedef struct _hwdbg_cfgreg_i_0_V2 {
   union {
      struct { 
         u32 host_dbg_mux_data_core_o_31_0;       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK hwdbg_cfgreg_i_0_V2, *Phwdbg_cfgreg_i_0_V2;

SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_0, sizeof (hwdbg_cfgreg_i_0_V2) == 4);



typedef struct _hwdbg_cfgreg_i_1_V2 {
   union {
      struct { 
         u32 host_dbg_mux_data_core_o_63_32;      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK hwdbg_cfgreg_i_1_V2, *Phwdbg_cfgreg_i_1_V2;

SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_1, sizeof (hwdbg_cfgreg_i_1_V2) == 4);



typedef struct _hwdbg_cfgreg_i_2_V2 {
   union {
      struct { 
         u32 host_dbg_mux_data_core_d3_o_31_0;    // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK hwdbg_cfgreg_i_2_V2, *Phwdbg_cfgreg_i_2_V2;

SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_2, sizeof (hwdbg_cfgreg_i_2_V2) == 4);



typedef struct _PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_V2 {
   union {
      struct { 
         u32 hw_ats_inv_en : 1;                   // DWORD 0
         u32 plbsel : 1;                          // DWORD 0
         u32 lane_rev : 1;                        // DWORD 0
         u32 beacon_en : 1;                       // DWORD 0
         u32 pcicfg_override : 1;                 // DWORD 0
         u32 fcp_timer : 13;                      // DWORD 0
         u32 fcp_timer_force : 1;                 // DWORD 0
         u32 mode_link_upcfg_cap_dis_force : 1;   // DWORD 0
         u32 mode_link_upcfg_cap_dis : 1;         // DWORD 0
         u32 future_scratpad0 : 3;                // DWORD 0
         u32 nec_ll_ui_enter_txl0s : 1;           // DWORD 0
         u32 future_scratpad1 : 2;                // DWORD 0
         u32 nec_ll_f0_mode_selectable_deemphasis : 1; // DWORD 0
         u32 enable_secondary_exception : 1;      // DWORD 0
         u32 secondary_exception : 1;             // DWORD 0
         u32 disable_auto_load_vf_funnum_offset : 1; // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_V2, *PPCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_V2;

SG_C_ASSERT(__sizeof__PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE, sizeof (PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_V2) == 4);



typedef struct _PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_V2 {
   union {
      struct { 
         u32 vpd_translation_addr : 13;           // DWORD 0
         u32 vpd_ddr_mode : 1;                    // DWORD 0
         u32 exprom_size : 2;                     // DWORD 0
         u32 exprom_translation_addr : 16;        // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_V2, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F0_V2;

SG_C_ASSERT(__sizeof__PCIE_OPTION_ROM_FLASH_TRANSLATION_F0, sizeof (PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_V2) == 4);



typedef struct _PCICFG_CUST_PF_CONTROL_CSR_V2 {
   union {
      struct { 
         u32 func_en : 16;                        // DWORD 0
         u32 vpd_translation_addr : 16;           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_CUST_PF_CONTROL_CSR_V2, *PPCICFG_CUST_PF_CONTROL_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_CUST_PF_CONTROL_CSR, sizeof (PCICFG_CUST_PF_CONTROL_CSR_V2) == 4);



typedef struct _PCICFG_VPD_PROTOCOL_CSR_V2 {
   union {
      struct { 
         u32 protocol;                            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_VPD_PROTOCOL_CSR_V2, *PPCICFG_VPD_PROTOCOL_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_VPD_PROTOCOL_CSR, sizeof (PCICFG_VPD_PROTOCOL_CSR_V2) == 4);



typedef struct _PCICFG_PF_24EQ_16EQ_CTRL_V2 {
   union {
      struct { 
         u32 cust_pf_24eq_to_pf_intrenable : 16;  // DWORD 0
         u32 cust_pf_16eq_to_pf_intrenable : 16;  // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF_24EQ_16EQ_CTRL_V2, *PPCICFG_PF_24EQ_16EQ_CTRL_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF_24EQ_16EQ_CTRL, sizeof (PCICFG_PF_24EQ_16EQ_CTRL_V2) == 4);



typedef struct _PCICFG_SHARED_REG_FUNC_LIMIT_V2 {
   union {
      struct { 
         u32 shared_reg_access_func_limit : 8;    // DWORD 0
         u32 cfg_membar_access_func_limit : 8;    // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SHARED_REG_FUNC_LIMIT_V2, *PPCICFG_SHARED_REG_FUNC_LIMIT_V2;

SG_C_ASSERT(__sizeof__PCICFG_SHARED_REG_FUNC_LIMIT, sizeof (PCICFG_SHARED_REG_FUNC_LIMIT_V2) == 4);



typedef struct _PCICFG_PF_8VF_BME_FLR_CONTROL_V2 {
   union {
      struct { 
         u32 mpu_assert_bme_vfgroup_no : 5;       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 mpu_assert_bme_pf_flr_to_vf : 1;     // DWORD 0
         u32 rsvd1 : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF_8VF_BME_FLR_CONTROL_V2, *PPCICFG_PF_8VF_BME_FLR_CONTROL_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF_8VF_BME_FLR_CONTROL, sizeof (PCICFG_PF_8VF_BME_FLR_CONTROL_V2) == 4);



typedef struct _PCICFG_PF_8VF_FLR_CONTROL_V2 {
   union {
      struct { 
         u32 pf_flr_to_8vfs_control : 28;         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF_8VF_FLR_CONTROL_V2, *PPCICFG_PF_8VF_FLR_CONTROL_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF_8VF_FLR_CONTROL, sizeof (PCICFG_PF_8VF_FLR_CONTROL_V2) == 4);



typedef struct _PCICFG_VF_ROCE_BAR_CTRL_V2 {
   union {
      struct { 
         u32 vf_roce_bar_control : 16;            // DWORD 0
         u32 vf_roce_pdid_control : 16;           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_VF_ROCE_BAR_CTRL_V2, *PPCICFG_VF_ROCE_BAR_CTRL_V2;

SG_C_ASSERT(__sizeof__PCICFG_VF_ROCE_BAR_CTRL, sizeof (PCICFG_VF_ROCE_BAR_CTRL_V2) == 4);



typedef struct _PCICFG_PF_32EQ_CTRL_V2 {
   union {
      struct { 
         u32 pf8to15_32eq_to_pf_intrenable : 8;   // DWORD 0
         u32 vf160to255_4eq_to_vf_intrenable : 1; // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF_32EQ_CTRL_V2, *PPCICFG_PF_32EQ_CTRL_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF_32EQ_CTRL, sizeof (PCICFG_PF_32EQ_CTRL_V2) == 4);



typedef struct _PCICFG_DMTF_ATS_ERRORS_V2 {
   union {
      struct { 
         u32 ats_invalid_cmpl_rd_error : 1;       // DWORD 0
         u32 ats_invalid_cmpl_wr_error : 1;       // DWORD 0
         u32 ats_invalid_cmpl_parity_error : 1;   // DWORD 0
         u32 dmtf_downstream_parity_error : 1;    // DWORD 0
         u32 dmtf_downstream_rd_error : 1;        // DWORD 0
         u32 dmtf_downstream_wr_error : 1;        // DWORD 0
         u32 dmtf_upstream_cmd_rd_error : 1;      // DWORD 0
         u32 dmtf_upstream_cmd_wr_error : 1;      // DWORD 0
         u32 dmtf_upstream_parity_error : 1;      // DWORD 0
         u32 dmtf_upstream_rd_error : 1;          // DWORD 0
         u32 dmtf_upstream_wr_error : 1;          // DWORD 0
         u32 rsvd0 : 21;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_DMTF_ATS_ERRORS_V2, *PPCICFG_DMTF_ATS_ERRORS_V2;

SG_C_ASSERT(__sizeof__PCICFG_DMTF_ATS_ERRORS, sizeof (PCICFG_DMTF_ATS_ERRORS_V2) == 4);



typedef struct _PCICFG_VF_VPD_LOC_CSR_V2 {
   union {
      struct { 
         u32 vpd_vf_group0_translation_addr : 16; // DWORD 0
         u32 vpd_vf_group1_translation_addr : 16; // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_VF_VPD_LOC_CSR_V2, *PPCICFG_VF_VPD_LOC_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_VF_VPD_LOC_CSR, sizeof (PCICFG_VF_VPD_LOC_CSR_V2) == 4);



typedef struct _PCIE_LTSSM_STAGES7_4_V2 {
   union {
      struct { 
         u32 ltssm_stage4 : 7;                    // DWORD 0
         u32 ltssm_stage5 : 7;                    // DWORD 0
         u32 ltssm_stage6 : 7;                    // DWORD 0
         u32 ltssm_stage7 : 7;                    // DWORD 0
         u32 periph_host_d3ism_done : 1;          // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ltssm_detect_latch : 1;              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_LTSSM_STAGES7_4_V2, *PPCIE_LTSSM_STAGES7_4_V2;

SG_C_ASSERT(__sizeof__PCIE_LTSSM_STAGES7_4, sizeof (PCIE_LTSSM_STAGES7_4_V2) == 4);



typedef struct _PCIE_LTSSM_STAGES3_0_V2 {
   union {
      struct { 
         u32 ltssm_stage0 : 7;                    // DWORD 0
         u32 ltssm_stage1 : 7;                    // DWORD 0
         u32 ltssm_stage2 : 7;                    // DWORD 0
         u32 ltssm_stage3 : 7;                    // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 ltssm_recovery_latch : 1;            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_LTSSM_STAGES3_0_V2, *PPCIE_LTSSM_STAGES3_0_V2;

SG_C_ASSERT(__sizeof__PCIE_LTSSM_STAGES3_0, sizeof (PCIE_LTSSM_STAGES3_0_V2) == 4);



typedef struct _PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_V2 {
   union {
      struct { 
         u32 disable_ecrc : 1;                    // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 exprom_size : 2;                     // DWORD 0
         u32 exprom_translation_addr : 16;        // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_V2, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F1_V2;

SG_C_ASSERT(__sizeof__PCIE_OPTION_ROM_FLASH_TRANSLATION_F1, sizeof (PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_V2) == 4);



typedef struct _PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_V2 {
   union {
      struct { 
         u32 ari_next_cap_offset : 12;            // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_V2, *PPCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_V2;

SG_C_ASSERT(__sizeof__PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET, sizeof (PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_V2) == 4);



typedef struct _PCIE_SERDES_MDIO_COMMAND_V2 {
   union {
      struct { 
         u32 req : 1;                             // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 ahb_phy : 1;                         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 ahb_done : 1;                        // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 0
         u32 address : 16;                        // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_MDIO_COMMAND_V2, *PPCIE_SERDES_MDIO_COMMAND_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_MDIO_COMMAND, sizeof (PCIE_SERDES_MDIO_COMMAND_V2) == 4);



typedef struct _PCIE_SERDES_MDIO_DATA_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_MDIO_DATA_V2, *PPCIE_SERDES_MDIO_DATA_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_MDIO_DATA, sizeof (PCIE_SERDES_MDIO_DATA_V2) == 4);



typedef struct _PCICFG_SLI_IF_TYPE_PROG_CSR_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SLI_IF_TYPE_PROG_CSR_V2, *PPCICFG_SLI_IF_TYPE_PROG_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_SLI_IF_TYPE_PROG_CSR, sizeof (PCICFG_SLI_IF_TYPE_PROG_CSR_V2) == 4);



typedef struct _PCICFG_SLI_IF_TYPE_VAL1_PROG_CSR_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SLI_IF_TYPE_VAL1_PROG_CSR_V2, *PPCICFG_SLI_IF_TYPE_VAL1_PROG_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_SLI_IF_TYPE_VAL1_PROG_CSR, sizeof (PCICFG_SLI_IF_TYPE_VAL1_PROG_CSR_V2) == 4);



typedef struct _PCIE_PF_MSIX_PBA_39_8_ZEROS_V2 {
   union {
      struct { 
         u32 pf_msix_pba_39_8 : 16;               // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_PF_MSIX_PBA_39_8_ZEROS_V2, *PPCIE_PF_MSIX_PBA_39_8_ZEROS_V2;

SG_C_ASSERT(__sizeof__PCIE_PF_MSIX_PBA_39_8_ZEROS, sizeof (PCIE_PF_MSIX_PBA_39_8_ZEROS_V2) == 4);



typedef struct _PCIE_PF_MSIX_TABLE_SIZE_SHARE_V2 {
   union {
      struct { 
         u32 pf0_vf_msix_tablesize_share : 2;     // DWORD 0
         u32 pf1_vf_msix_tablesize_share : 2;     // DWORD 0
         u32 pf2_vf_msix_tablesize_share : 2;     // DWORD 0
         u32 pf3_vf_msix_tablesize_share : 2;     // DWORD 0
         u32 pf4_vf_msix_tablesize_share : 2;     // DWORD 0
         u32 pf5_vf_msix_tablesize_share : 2;     // DWORD 0
         u32 pf6_vf_msix_tablesize_share : 2;     // DWORD 0
         u32 pf7_vf_msix_tablesize_share : 2;     // DWORD 0
         u32 pf8_vf_msix_tablesize_share : 2;     // DWORD 0
         u32 pf9_vf_msix_tablesize_share : 2;     // DWORD 0
         u32 pf10_vf_msix_tablesize_share : 2;    // DWORD 0
         u32 pf11_vf_msix_tablesize_share : 2;    // DWORD 0
         u32 pf12_vf_msix_tablesize_share : 2;    // DWORD 0
         u32 pf13_vf_msix_tablesize_share : 2;    // DWORD 0
         u32 pf14_vf_msix_tablesize_share : 2;    // DWORD 0
         u32 pf15_vf_msix_tablesize_share : 2;    // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_PF_MSIX_TABLE_SIZE_SHARE_V2, *PPCIE_PF_MSIX_TABLE_SIZE_SHARE_V2;

SG_C_ASSERT(__sizeof__PCIE_PF_MSIX_TABLE_SIZE_SHARE, sizeof (PCIE_PF_MSIX_TABLE_SIZE_SHARE_V2) == 4);



typedef struct _PCIE_MSIX_TBL_TO_CTX_CTRL_V2 {
   union {
      struct { 
         u32 vf_msix_tbl_size : 8;                // DWORD 0
         u32 pf_msix_tablesize_share_vf_cev : 8;  // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
         u32 vf_msix_tbl_to_ctx : 1;              // DWORD 0
         u32 pf_msix_tbl_to_ctx : 1;              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_MSIX_TBL_TO_CTX_CTRL_V2, *PPCIE_MSIX_TBL_TO_CTX_CTRL_V2;

SG_C_ASSERT(__sizeof__PCIE_MSIX_TBL_TO_CTX_CTRL, sizeof (PCIE_MSIX_TBL_TO_CTX_CTRL_V2) == 4);



typedef struct _PCIE_MSIX_TBL_TO_CTX_V2 {
   union {
      struct { 
         u32 pf_range_low : 8;                    // DWORD 0
         u32 pf_range_high : 8;                   // DWORD 0
         u32 vf_range_low : 8;                    // DWORD 0
         u32 vf_range_high : 8;                   // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_MSIX_TBL_TO_CTX_V2, *PPCIE_MSIX_TBL_TO_CTX_V2;

SG_C_ASSERT(__sizeof__PCIE_MSIX_TBL_TO_CTX, sizeof (PCIE_MSIX_TBL_TO_CTX_V2) == 4);



typedef struct _PCIE_SEC_PCIE_EXT_CAP_HDR_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SEC_PCIE_EXT_CAP_HDR_V2, *PPCIE_SEC_PCIE_EXT_CAP_HDR_V2;

SG_C_ASSERT(__sizeof__PCIE_SEC_PCIE_EXT_CAP_HDR, sizeof (PCIE_SEC_PCIE_EXT_CAP_HDR_V2) == 4);



typedef struct _PCIE_LINK_CTRL_3_REG_V2 {
   union {
      struct { 
         u32 perform_equalization : 1;            // DWORD 0
         u32 link_eq_int_enable : 1;              // DWORD 0
         u32 rsvd0 : 30;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_LINK_CTRL_3_REG_V2, *PPCIE_LINK_CTRL_3_REG_V2;

SG_C_ASSERT(__sizeof__PCIE_LINK_CTRL_3_REG, sizeof (PCIE_LINK_CTRL_3_REG_V2) == 4);



typedef struct _PCIE_LANE_ERROR_STATUS_REG_V2 {
   union {
      struct { 
         u32 lane0_error_status : 1;              // DWORD 0
         u32 lane1_error_status : 1;              // DWORD 0
         u32 lane2_error_status : 1;              // DWORD 0
         u32 lane3_error_status : 1;              // DWORD 0
         u32 lane4_error_status : 1;              // DWORD 0
         u32 lane5_error_status : 1;              // DWORD 0
         u32 lane6_error_status : 1;              // DWORD 0
         u32 lane7_error_status : 1;              // DWORD 0
         u32 lane0_RX_ESERRTRGR : 1;              // DWORD 0
         u32 lane1_RX_ESERRTRGR : 1;              // DWORD 0
         u32 lane2_RX_ESERRTRGR : 1;              // DWORD 0
         u32 lane3_RX_ESERRTRGR : 1;              // DWORD 0
         u32 lane4_RX_ESERRTRGR : 1;              // DWORD 0
         u32 lane5_RX_ESERRTRGR : 1;              // DWORD 0
         u32 lane6_RX_ESERRTRGR : 1;              // DWORD 0
         u32 lane7_RX_ESERRTRGR : 1;              // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_LANE_ERROR_STATUS_REG_V2, *PPCIE_LANE_ERROR_STATUS_REG_V2;

SG_C_ASSERT(__sizeof__PCIE_LANE_ERROR_STATUS_REG, sizeof (PCIE_LANE_ERROR_STATUS_REG_V2) == 4);



typedef struct _PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2 {
   union {
      struct { 
         u32 rsvd0 : 8;                           // DWORD 0
         u32 upstream_tx_preset_lane_n : 4;       // DWORD 0
         u32 upstream_rx_preset_hint_lane_n : 3;  // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 rsvd2 : 8;                           // DWORD 0
         u32 upstream_tx_preset_lane_nplus1 : 4;  // DWORD 0
         u32 upstream_rx_preset_hint_lane_nplus1 : 3; // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2, *PPCIE_LANE_1_0_EQUALIZATION_CONTROL_V2;

SG_C_ASSERT(__sizeof__PCIE_LANE_1_0_EQUALIZATION_CONTROL, sizeof (PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2) == 4);



typedef struct _PCICFG_BCA_CTRL0_V2 {
   union {
      struct { 
         u32 t2l_coeff_mf0_prec : 3;              // DWORD 0
         u32 t2l_coeff_mf1_prec : 3;              // DWORD 0
         u32 t2l_coeff_mf0_postc : 3;             // DWORD 0
         u32 t2l_coeff_mf1_postc : 3;             // DWORD 0
         u32 t2l_coeff_mf_method : 1;             // DWORD 0
         u32 t2l_eval_ph_fail_ena : 1;            // DWORD 0
         u32 t2l_eval_dither_count : 3;           // DWORD 0
         u32 t2l_eval_window_size : 5;            // DWORD 0
         u32 t2l_prec_update_count : 4;           // DWORD 0
         u32 t2l_postc_update_count : 4;          // DWORD 0
         u32 t2p_coeff_pingpong_disable : 1;      // DWORD 0
         u32 l2t_eval_phase_not_optimal : 1;      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_BCA_CTRL0_V2, *PPCICFG_BCA_CTRL0_V2;

SG_C_ASSERT(__sizeof__PCICFG_BCA_CTRL0, sizeof (PCICFG_BCA_CTRL0_V2) == 4);



typedef struct _PCICFG_SERDES_DBG_CTRL_V2 {
   union {
      struct { 
         u32 pcie_t2l_debug_sel : 16;             // DWORD 0
         u32 sys_lresetn : 1;                     // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SERDES_DBG_CTRL_V2, *PPCICFG_SERDES_DBG_CTRL_V2;

SG_C_ASSERT(__sizeof__PCICFG_SERDES_DBG_CTRL, sizeof (PCICFG_SERDES_DBG_CTRL_V2) == 4);



typedef struct _PCICFG_SERDES_LANE_CTRL_V2 {
   union {
      struct { 
         u32 SER_LPBK_ENA : 8;                    // DWORD 0
         u32 TX_INV : 8;                          // DWORD 0
         u32 MODE_RXPOL_INV_EN : 1;               // DWORD 0
         u32 MODE_SCRAMBLE_GEN12_DISABLE : 1;     // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SERDES_LANE_CTRL_V2, *PPCICFG_SERDES_LANE_CTRL_V2;

SG_C_ASSERT(__sizeof__PCICFG_SERDES_LANE_CTRL, sizeof (PCICFG_SERDES_LANE_CTRL_V2) == 4);



typedef struct _PCICFG_EQUALIZATION_CTRL0_V2 {
   union {
      struct { 
         u32 t2l_eq_fs : 6;                       // DWORD 0
         u32 t2l_eq_maxpre : 6;                   // DWORD 0
         u32 t2l_eq_lf : 6;                       // DWORD 0
         u32 t2l_g3_spare_in_default_preset : 4;  // DWORD 0
         u32 force_t2l_req_preset_vld : 8;        // DWORD 0
         u32 force_t2s_coeff_enbl : 1;            // DWORD 0
         u32 t2l_g3_spare_in_bca_disable : 1;     // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_EQUALIZATION_CTRL0_V2, *PPCICFG_EQUALIZATION_CTRL0_V2;

SG_C_ASSERT(__sizeof__PCICFG_EQUALIZATION_CTRL0, sizeof (PCICFG_EQUALIZATION_CTRL0_V2) == 4);



typedef struct _PCICFG_REQ_PRESET_V2 {
   union {
      struct { 
         u32 force_lane0_t2l_req_preset : 4;      // DWORD 0
         u32 force_lane1_t2l_req_preset : 4;      // DWORD 0
         u32 force_lane2_t2l_req_preset : 4;      // DWORD 0
         u32 force_lane3_t2l_req_preset : 4;      // DWORD 0
         u32 force_lane4_t2l_req_preset : 4;      // DWORD 0
         u32 force_lane5_t2l_req_preset : 4;      // DWORD 0
         u32 force_lane6_t2l_req_preset : 4;      // DWORD 0
         u32 force_lane7_t2l_req_preset : 4;      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_REQ_PRESET_V2, *PPCICFG_REQ_PRESET_V2;

SG_C_ASSERT(__sizeof__PCICFG_REQ_PRESET, sizeof (PCICFG_REQ_PRESET_V2) == 4);



typedef struct _PCICFG_REQ_COEFF_V2 {
   union {
      struct { 
         u32 rsvd0 : 4;                           // DWORD 0
         u32 force_t2sMaincCoeff : 6;             // DWORD 0
         u32 force_t2sPrecCoeff : 6;              // DWORD 0
         u32 force_t2sPostcCoeff : 6;             // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_REQ_COEFF_V2, *PPCICFG_REQ_COEFF_V2;

SG_C_ASSERT(__sizeof__PCICFG_REQ_COEFF, sizeof (PCICFG_REQ_COEFF_V2) == 4);



typedef struct _PCICFG_SERDES_IOGB_CTRL_V2 {
   union {
      struct { 
         u32 PCIE_IOGB40G_CNTPUP : 10;            // DWORD 0
         u32 PCIE_IOGB40G_CNTSET : 3;             // DWORD 0
         u32 PCIE_IOGB40G_PDDIS : 1;              // DWORD 0
         u32 PCIE_IOGB40G_TESTMODE : 1;           // DWORD 0
         u32 PCIE_IOGB40G_RTRIMFRC : 4;           // DWORD 0
         u32 PCIE_IOGB40G_RTRIM : 4;              // DWORD 0
         u32 PCIE_IOGB40G_TRIMDONE : 1;           // DWORD 0
         u32 PCIE_IOGB40G_RNGERR : 1;             // DWORD 0
         u32 PCIE_IOGB40G_SW_CTRL_RST_N : 1;      // DWORD 0
         u32 PCIE_LINK_SW_CTRL_FUND_RST_N : 1;    // DWORD 0
         u32 PCIE_SER_SW_CTRL_FUND_RST_N : 1;     // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_SERDES_IOGB_CTRL_V2, *PPCICFG_SERDES_IOGB_CTRL_V2;

SG_C_ASSERT(__sizeof__PCICFG_SERDES_IOGB_CTRL, sizeof (PCICFG_SERDES_IOGB_CTRL_V2) == 4);



typedef struct _PCIE_PM_PME_SERDES_PLL_DMA_WRB_V2 {
   union {
      struct { 
         u32 bme_ndma_purge_disable : 1;          // DWORD 0
         u32 bme_ndma_purge_reqerr_disable : 1;   // DWORD 0
         u32 bme_rdma_purge_disable : 1;          // DWORD 0
         u32 bme_rdma_purge_reqerr_disable : 1;   // DWORD 0
         u32 bme_ldma_purge_disable : 1;          // DWORD 0
         u32 bme_ldma_purge_reqerr_disable : 1;   // DWORD 0
         u32 en_softrst_cleanup : 1;              // DWORD 0
         u32 propagate_pf_flr_to_vf : 1;          // DWORD 0
         u32 bme_wdma_purge_loading_disable : 1;  // DWORD 0
         u32 bme_ndma_purge_loading_disable : 1;  // DWORD 0
         u32 bme_rdma_purge_loading_disable : 1;  // DWORD 0
         u32 bme_ldma_purge_loading_disable : 1;  // DWORD 0
         u32 relaxorder_disable : 1;              // DWORD 0
         u32 ro_tx_disable : 1;                   // DWORD 0
         u32 cfg_dma2bme_wropti_disable : 1;      // DWORD 0
         u32 wdma_len_err : 1;                    // DWORD 0
         u32 wdma_PURGE_err : 1;                  // DWORD 0
         u32 rdma_wrb_factor : 2;                 // DWORD 0
         u32 nec_blb0_digest : 1;                 // DWORD 0
         u32 nec_PM_PME_en_D0 : 1;                // DWORD 0
         u32 nec_PM_PME_en_D3 : 1;                // DWORD 0
         u32 cfg_bmearb_reqmsk_disable : 1;       // DWORD 0
         u32 PM_ARI_spec_en : 1;                  // DWORD 0
         u32 rxf_wake_l1_l2_trans : 1;            // DWORD 0
         u32 self_clr_lpcsoftrst : 1;             // DWORD 0
         u32 BLB_intf_pre_cycle : 1;              // DWORD 0
         u32 bme_wdma_purge_disable : 1;          // DWORD 0
         u32 bme_wdma_purge_reqerr_disable : 1;   // DWORD 0
         u32 pme_trunoffack_enable : 1;           // DWORD 0
         u32 ldma_wrb_factor : 2;                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_PM_PME_SERDES_PLL_DMA_WRB_V2, *PPCIE_PM_PME_SERDES_PLL_DMA_WRB_V2;

SG_C_ASSERT(__sizeof__PCIE_PM_PME_SERDES_PLL_DMA_WRB, sizeof (PCIE_PM_PME_SERDES_PLL_DMA_WRB_V2) == 4);



typedef struct _hwdbg_cfgreg_i_3_V2 {
   union {
      struct { 
         u32 host_dbg_mux_data_core_d3_o_63_32;   // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK hwdbg_cfgreg_i_3_V2, *Phwdbg_cfgreg_i_3_V2;

SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_3, sizeof (hwdbg_cfgreg_i_3_V2) == 4);



typedef struct _hwdbg_cfgreg_i_4_V2 {
   union {
      struct { 
         u32 host_dbg_mux_data_pclk_o_31_0;       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK hwdbg_cfgreg_i_4_V2, *Phwdbg_cfgreg_i_4_V2;

SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_4, sizeof (hwdbg_cfgreg_i_4_V2) == 4);



typedef struct _hwdbg_cfgreg_i_5_V2 {
   union {
      struct { 
         u32 dma_reqerr_status : 4;               // DWORD 0
         u32 ndma_PURGE_err : 1;                  // DWORD 0
         u32 rdma_PURGE_err : 1;                  // DWORD 0
         u32 ldma_PURGE_err : 1;                  // DWORD 0
         u32 MOR_MALFORMED_SET : 1;               // DWORD 0
         u32 host_dbg_mux_data_pclk_d3_o_63_40 : 24; // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK hwdbg_cfgreg_i_5_V2, *Phwdbg_cfgreg_i_5_V2;

SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_5, sizeof (hwdbg_cfgreg_i_5_V2) == 4);



typedef struct _hwdbg_cfgreg_i_7_V2 {
   union {
      struct { 
         u32 dbg_all_reqs_31_0;                   // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK hwdbg_cfgreg_i_7_V2, *Phwdbg_cfgreg_i_7_V2;

SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_7, sizeof (hwdbg_cfgreg_i_7_V2) == 4);



typedef struct _PCIE_cust_pfs_intr_info_V2 {
   union {
      struct { 
         u32 cust_pfs_vpd_intr_func_id_i : 7;     // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 cust_pfs_pci_cap_ptr : 8;            // DWORD 0
         u32 first_ue_src_id : 6;                 // DWORD 0
         u32 first_ue_src_id_vld : 1;             // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 cust_pf_vpd_ddr_mode : 1;            // DWORD 0
         u32 vf_group0_vpd_ddr_mode : 1;          // DWORD 0
         u32 vf_group1_vpd_ddr_mode : 1;          // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_cust_pfs_intr_info_V2, *PPCIE_cust_pfs_intr_info_V2;

SG_C_ASSERT(__sizeof__PCIE_cust_pfs_intr_info, sizeof (PCIE_cust_pfs_intr_info_V2) == 4);



typedef struct _PCIE_vfs_intr_info_V2 {
   union {
      struct { 
         u32 teslave_state : 4;                   // DWORD 0
         u32 vfs_vpd_intr1_func_id_i : 7;         // DWORD 0
         u32 te_host_tlb_last_i : 1;              // DWORD 0
         u32 vfs_pci_cap_ptr : 8;                 // DWORD 0
         u32 host_rrm_req_o : 1;                  // DWORD 0
         u32 host_rrm_type__o : 2;                // DWORD 0
         u32 pfs_intx_msg_order : 1;              // DWORD 0
         u32 vfs_intx_msg_order : 1;              // DWORD 0
         u32 vfs_vpd_intr0_func_id_i : 7;         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_vfs_intr_info_V2, *PPCIE_vfs_intr_info_V2;

SG_C_ASSERT(__sizeof__PCIE_vfs_intr_info, sizeof (PCIE_vfs_intr_info_V2) == 4);



typedef struct _PCIE_SERDES_PROG_REG_V2 {
   union {
      struct { 
         u32 prog_value;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_PROG_REG_V2, *PPCIE_SERDES_PROG_REG_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_PROG_REG, sizeof (PCIE_SERDES_PROG_REG_V2) == 4);



typedef struct _PCICFG_MPU_CONTROL_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 31;                          // DWORD 0
         u32 CPU_reset : 1;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MPU_CONTROL_CSR_V2, *PPCICFG_MPU_CONTROL_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_MPU_CONTROL_CSR, sizeof (PCICFG_MPU_CONTROL_CSR_V2) == 4);



typedef struct _PCICFG_D0_RESOURCE_ARBITER_V2 {
   union {
      struct { 
         u32 byte0 : 8;                           // DWORD 0
         u32 byte1 : 8;                           // DWORD 0
         u32 byte2 : 8;                           // DWORD 0
         u32 byte3 : 8;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_D0_RESOURCE_ARBITER_V2, *PPCICFG_D0_RESOURCE_ARBITER_V2;

SG_C_ASSERT(__sizeof__PCICFG_D0_RESOURCE_ARBITER, sizeof (PCICFG_D0_RESOURCE_ARBITER_V2) == 4);



typedef struct _PCICFG_D0_RESOURCE_ARBITER_WORD_V2 {
   union {
      struct { 
         u32 word0 : 16;                          // DWORD 0
         u32 word1 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_D0_RESOURCE_ARBITER_WORD_V2, *PPCICFG_D0_RESOURCE_ARBITER_WORD_V2;

SG_C_ASSERT(__sizeof__PCICFG_D0_RESOURCE_ARBITER_WORD, sizeof (PCICFG_D0_RESOURCE_ARBITER_WORD_V2) == 4);



typedef struct _PCICFG_D3_RESOURCE_ARBITER_WORD_V2 {
   union {
      struct { 
         u32 word0 : 16;                          // DWORD 0
         u32 word1 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_D3_RESOURCE_ARBITER_WORD_V2, *PPCICFG_D3_RESOURCE_ARBITER_WORD_V2;

SG_C_ASSERT(__sizeof__PCICFG_D3_RESOURCE_ARBITER_WORD, sizeof (PCICFG_D3_RESOURCE_ARBITER_WORD_V2) == 4);



typedef struct _PCICFG_D3_RESOURCE_ARBITER_V2 {
   union {
      struct { 
         u32 byte0 : 8;                           // DWORD 0
         u32 byte1 : 8;                           // DWORD 0
         u32 byte2 : 8;                           // DWORD 0
         u32 byte3 : 8;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_D3_RESOURCE_ARBITER_V2, *PPCICFG_D3_RESOURCE_ARBITER_V2;

SG_C_ASSERT(__sizeof__PCICFG_D3_RESOURCE_ARBITER, sizeof (PCICFG_D3_RESOURCE_ARBITER_V2) == 4);



typedef struct _PCICFG_D3BLOCK_CTRL_V2 {
   union {
      struct { 
         u32 data_out : 16;                       // DWORD 0
         u32 data_in : 8;                         // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_D3BLOCK_CTRL_V2, *PPCICFG_D3BLOCK_CTRL_V2;

SG_C_ASSERT(__sizeof__PCICFG_D3BLOCK_CTRL, sizeof (PCICFG_D3BLOCK_CTRL_V2) == 4);



typedef struct _PCICFG_CPLL_CONFIG_V2 {
   union {
      struct { 
         u32 extfb : 1;                           // DWORD 0
         u32 enarst : 1;                          // DWORD 0
         u32 fbcnt : 8;                           // DWORD 0
         u32 z : 3;                               // DWORD 0
         u32 p : 2;                               // DWORD 0
         u32 rate : 1;                            // DWORD 0
         u32 jitlmt : 2;                          // DWORD 0
         u32 cntlmt : 2;                          // DWORD 0
         u32 enouts : 1;                          // DWORD 0
         u32 bgvr : 2;                            // DWORD 0
         u32 pllbypass : 1;                       // DWORD 0
         u32 spare : 5;                           // DWORD 0
         u32 lresetn : 1;                         // DWORD 0
         u32 load : 1;                            // DWORD 0
         u32 en : 1;                              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_CPLL_CONFIG_V2, *PPCICFG_CPLL_CONFIG_V2;

SG_C_ASSERT(__sizeof__PCICFG_CPLL_CONFIG, sizeof (PCICFG_CPLL_CONFIG_V2) == 4);



typedef struct _PCICFG_EPLL_CONFIG_V2 {
   union {
      struct { 
         u32 extfb : 1;                           // DWORD 0
         u32 enarst : 1;                          // DWORD 0
         u32 fbcnt : 8;                           // DWORD 0
         u32 z : 3;                               // DWORD 0
         u32 p : 2;                               // DWORD 0
         u32 rate : 1;                            // DWORD 0
         u32 jitlmt : 2;                          // DWORD 0
         u32 cntlmt : 2;                          // DWORD 0
         u32 enouts : 1;                          // DWORD 0
         u32 bgvr : 2;                            // DWORD 0
         u32 pllbypass : 1;                       // DWORD 0
         u32 spare : 5;                           // DWORD 0
         u32 lresetn : 1;                         // DWORD 0
         u32 load : 1;                            // DWORD 0
         u32 en : 1;                              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_EPLL_CONFIG_V2, *PPCICFG_EPLL_CONFIG_V2;

SG_C_ASSERT(__sizeof__PCICFG_EPLL_CONFIG, sizeof (PCICFG_EPLL_CONFIG_V2) == 4);



typedef struct _PCICFG_MPLL_CONFIG_V2 {
   union {
      struct { 
         u32 extfb : 1;                           // DWORD 0
         u32 enarst : 1;                          // DWORD 0
         u32 fbcnt : 8;                           // DWORD 0
         u32 z : 3;                               // DWORD 0
         u32 p : 2;                               // DWORD 0
         u32 rate : 1;                            // DWORD 0
         u32 jitlmt : 2;                          // DWORD 0
         u32 cntlmt : 2;                          // DWORD 0
         u32 enouts : 1;                          // DWORD 0
         u32 bgvr : 2;                            // DWORD 0
         u32 pllbypass : 1;                       // DWORD 0
         u32 spare : 5;                           // DWORD 0
         u32 lresetn : 1;                         // DWORD 0
         u32 load : 1;                            // DWORD 0
         u32 en : 1;                              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_MPLL_CONFIG_V2, *PPCICFG_MPLL_CONFIG_V2;

SG_C_ASSERT(__sizeof__PCICFG_MPLL_CONFIG, sizeof (PCICFG_MPLL_CONFIG_V2) == 4);



typedef struct _PCICFG_PPLL_CONFIG_V2 {
   union {
      struct { 
         u32 extfb : 1;                           // DWORD 0
         u32 enarst : 1;                          // DWORD 0
         u32 fbcnt : 8;                           // DWORD 0
         u32 z : 3;                               // DWORD 0
         u32 p : 2;                               // DWORD 0
         u32 rate : 1;                            // DWORD 0
         u32 jitlmt : 2;                          // DWORD 0
         u32 cntlmt : 2;                          // DWORD 0
         u32 enouts : 1;                          // DWORD 0
         u32 bgvr : 2;                            // DWORD 0
         u32 pllbypass : 1;                       // DWORD 0
         u32 spare : 5;                           // DWORD 0
         u32 lresetn : 1;                         // DWORD 0
         u32 load : 1;                            // DWORD 0
         u32 en : 1;                              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PPLL_CONFIG_V2, *PPCICFG_PPLL_CONFIG_V2;

SG_C_ASSERT(__sizeof__PCICFG_PPLL_CONFIG, sizeof (PCICFG_PPLL_CONFIG_V2) == 4);



typedef struct _PCICFG_XTL_DIFF_PCIE_CSR_V2 {
   union {
      struct { 
         u32 xtal_rfckctrl : 16;                  // DWORD 0
         u32 diff_buf_ctrl : 4;                   // DWORD 0
         u32 pcie_buf_ctrl : 4;                   // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_XTL_DIFF_PCIE_CSR_V2, *PPCICFG_XTL_DIFF_PCIE_CSR_V2;

SG_C_ASSERT(__sizeof__PCICFG_XTL_DIFF_PCIE_CSR, sizeof (PCICFG_XTL_DIFF_PCIE_CSR_V2) == 4);



typedef struct _PCICFG_BE_BLOCK1_RST_DBG_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_BE_BLOCK1_RST_DBG_V2, *PPCICFG_BE_BLOCK1_RST_DBG_V2;

SG_C_ASSERT(__sizeof__PCICFG_BE_BLOCK1_RST_DBG, sizeof (PCICFG_BE_BLOCK1_RST_DBG_V2) == 4);



typedef struct _PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2, *PPCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2;

SG_C_ASSERT(__sizeof__PCICFG_GENERIC_SCRATCH_SOFTRST_REG, sizeof (PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2) == 4);



typedef struct _PCICFG_GENERIC_SCRATCH_REG_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCICFG_GENERIC_SCRATCH_REG_V2, *PPCICFG_GENERIC_SCRATCH_REG_V2;

SG_C_ASSERT(__sizeof__PCICFG_GENERIC_SCRATCH_REG, sizeof (PCICFG_GENERIC_SCRATCH_REG_V2) == 4);



typedef struct _PCIE_SERDES_TX_MARGIN_COMM_0_V2 {
   union {
      struct { 
         u32 tx_margin_comm_bit31_0;              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_TX_MARGIN_COMM_0_V2, *PPCIE_SERDES_TX_MARGIN_COMM_0_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_TX_MARGIN_COMM_0, sizeof (PCIE_SERDES_TX_MARGIN_COMM_0_V2) == 4);



typedef struct _PCIE_SERDES_TX_MARGIN_COMM_1_V2 {
   union {
      struct { 
         u32 tx_margin_comm_bit59_32 : 28;        // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 force_tx_margin_comm : 1;            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_TX_MARGIN_COMM_1_V2, *PPCIE_SERDES_TX_MARGIN_COMM_1_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_TX_MARGIN_COMM_1, sizeof (PCIE_SERDES_TX_MARGIN_COMM_1_V2) == 4);



typedef struct _PCIE_SERDES_TX_PARAM_0_V2 {
   union {
      struct { 
         u32 tx_param_bit31_0;                    // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_TX_PARAM_0_V2, *PPCIE_SERDES_TX_PARAM_0_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_TX_PARAM_0, sizeof (PCIE_SERDES_TX_PARAM_0_V2) == 4);



typedef struct _PCIE_SERDES_TX_PARAM_1_V2 {
   union {
      struct { 
         u32 tx_param_bit58_32 : 27;              // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 force_tx_param : 1;                  // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_TX_PARAM_1_V2, *PPCIE_SERDES_TX_PARAM_1_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_TX_PARAM_1, sizeof (PCIE_SERDES_TX_PARAM_1_V2) == 4);



typedef struct _PCIE_SERDES_RX_PARAM_0_V2 {
   union {
      struct { 
         u32 prog_value;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_RX_PARAM_0_V2, *PPCIE_SERDES_RX_PARAM_0_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_RX_PARAM_0, sizeof (PCIE_SERDES_RX_PARAM_0_V2) == 4);



typedef struct _PCIE_SERDES_RX_PARAM_1_V2 {
   union {
      struct { 
         u32 prog_value;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_RX_PARAM_1_V2, *PPCIE_SERDES_RX_PARAM_1_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_RX_PARAM_1, sizeof (PCIE_SERDES_RX_PARAM_1_V2) == 4);



typedef struct _PCIE_SERDES_RX_PARAM_2_V2 {
   union {
      struct { 
         u32 prog_value;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_RX_PARAM_2_V2, *PPCIE_SERDES_RX_PARAM_2_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_RX_PARAM_2, sizeof (PCIE_SERDES_RX_PARAM_2_V2) == 4);



typedef struct _PCIE_SERDES_RX_PARAM_3_V2 {
   union {
      struct { 
         u32 prog_value;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_RX_PARAM_3_V2, *PPCIE_SERDES_RX_PARAM_3_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_RX_PARAM_3, sizeof (PCIE_SERDES_RX_PARAM_3_V2) == 4);



typedef struct _PCIE_SERDES_RX_PARAM_4_V2 {
   union {
      struct { 
         u32 prog_value;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_RX_PARAM_4_V2, *PPCIE_SERDES_RX_PARAM_4_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_RX_PARAM_4, sizeof (PCIE_SERDES_RX_PARAM_4_V2) == 4);



typedef struct _PCIE_SERDES_RX_PARAM_5_V2 {
   union {
      struct { 
         u32 rx_param_bit175_160 : 16;            // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 force_rx_param : 1;                  // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_RX_PARAM_5_V2, *PPCIE_SERDES_RX_PARAM_5_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_RX_PARAM_5, sizeof (PCIE_SERDES_RX_PARAM_5_V2) == 4);



typedef struct _PCIE_SERDES_RCV_DET_V2 {
   union {
      struct { 
         u32 rcv_det_override_value : 8;          // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
         u32 force_rcv_det : 1;                   // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK PCIE_SERDES_RCV_DET_V2, *PPCIE_SERDES_RCV_DET_V2;

SG_C_ASSERT(__sizeof__PCIE_SERDES_RCV_DET, sizeof (PCIE_SERDES_RCV_DET_V2) == 4);



typedef struct _PCICFG_PM_CONTROL_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf0_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf1_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf3_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf2_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf4_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf5_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf6_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf7_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf8_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf9_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf10_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf11_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf12_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf13_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf14_pm_control;
         PCICFG_PM_CONTROL_FOR_D3BLOCK_V2 pf15_pm_control;
      } SG_PACK ; // unnamed struct
      u32 dw[16]; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PM_CONTROL_CSRMAP_V2, *PPCICFG_PM_CONTROL_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG_PM_CONTROL_CSRMAP, sizeof (PCICFG_PM_CONTROL_CSRMAP_V2) == 64);



typedef struct _PCICFG_PF1_EXTEND1_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_FUNCTION_IDENTIFIER_F1_V2 func_id;
         PCICFG_FLASH_GREED_CTRL_CSR_V2 flash_arb_control;
         PCICFG_F1_HOST_DEBUG1_V2 host_debug1;
         PCICFG_HOST_BAR_STATUS_PF1_CSR_V2 host_control1;
         PCIE_SERDES_MDIO_COMMAND_V2 pcie_lltl_mdio_command;
         PCIE_SERDES_MDIO_DATA_V2 pcie_lltl_mdio_data;
         PCICFG_SLI_IF_TYPE_PROG_CSR_V2 sli4_if_type_prog_csr[2];
         PCICFG_SLI_IF_TYPE_VAL1_PROG_CSR_V2 pf_31to16_sli4_if_type_prog_csr[2];
         u32 rsvd0[4];                            // DWORDS 10 to 13
         PCICFG_HOST_CONTROL2_CSR_V2 host_control2;
         u32 rsvd1[4];                            // DWORDS 15 to 18
         u32 rsvd2[45];                           // DWORDS 19 to 63
      } SG_PACK ; // unnamed struct
      u32 dw[64]; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF1_EXTEND1_CSRMAP_V2, *PPCICFG_PF1_EXTEND1_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF1_EXTEND1_CSRMAP, sizeof (PCICFG_PF1_EXTEND1_CSRMAP_V2) == 256);



typedef struct _PCICFG_PF0_EXTEND1_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_FUNCTION_IDENTIFIER_F0_V2 function_ctrl_identifier;
         PCICFG_GCLK_CORE_EN0_CSR_V2 gclk_core_en0;
         PCICFG_GCLK_CORE_EN1_CSR_V2 gclk_core_en1;
         PCICFG_HOST_CONTROL1_CSR_V2 host_control1;
         PCIE_SEC_PCIE_EXT_CAP_HDR_V2 secondary_pcie_cap;
         PCIE_LINK_CTRL_3_REG_V2 link_control_3;
         PCIE_LANE_ERROR_STATUS_REG_V2 lane_error_status;
         PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2 lane_1_0_equalization_control;
         PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2 lane_3_2_equalization_control;
         PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2 lane_5_4_equalization_control;
         PCIE_LANE_1_0_EQUALIZATION_CONTROL_V2 lane_7_6_equalization_control;
         PCICFG_VF_VPD_LOC_CSR_V2 vf_vpd_translation_addr;
         PCICFG_CUST_PF_CONTROL_CSR_V2 cust_pf_control;
         PCIE_cust_pfs_intr_info_V2 cust_pfs_vpd_intr_func_index;
         PCICFG_PF0_HOST_CONTROL2_CSR_V2 host_control2;
         PCICFG_HWDBG_MASK_0_CORE_V2 hwdbg_mask_0_core;
         PCICFG_HWDBG_MASK_1_CORE_V2 hwdbg_mask_1_core;
         PCICFG_D0_RESOURCE_ARBITER_V2 hostd0_resource_arbiter;
         PCICFG_D0_RESOURCE_ARBITER_WORD_V2 hostd0_resource_arbiter_word;
         PCICFG_VPD_PROTOCOL_CSR_V2 pf_vpd_protocol_selected;
         PCICFG_VPD_PROTOCOL_CSR_V2 cust_pf_vpd_protocol_selected;
         PCICFG_VPD_PROTOCOL_CSR_V2 vf_group0_vpd_protocol_selected;
         PCICFG_VPD_PROTOCOL_CSR_V2 vf_group1_vpd_protocol_selected;
         PCICFG_PF_24EQ_16EQ_CTRL_V2 pf_24eq_16eq_share;
         PCICFG_PF_32EQ_CTRL_V2 pf_32eq_share;
         PCICFG_DMTF_ATS_ERRORS_V2 dmtf_ats_errors;
         PCICFG_VF_ROCE_BAR_CTRL_V2 vf_roce_bar_control;
         PCICFG_SHARED_REG_FUNC_LIMIT_V2 shared_reg_func_limit;
         PCICFG_PF_8VF_FLR_CONTROL_V2 pf_8vf_flr_control;
         PCICFG_PF_8VF_BME_FLR_CONTROL_V2 pf_8vf_bme_flr_control;
         u32 rsvd0[34];                           // DWORDS 30 to 63
      } SG_PACK ; // unnamed struct
      u32 dw[64]; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF0_EXTEND1_CSRMAP_V2, *PPCICFG_PF0_EXTEND1_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF0_EXTEND1_CSRMAP, sizeof (PCICFG_PF0_EXTEND1_CSRMAP_V2) == 256);



typedef struct _PCICFG_D3BLOCK_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_DEBUG_CSR_V2 debug;
         PCICFG_GPI_CSR_V2 gpi[2];
         PCICFG_GPO_LOW_CSR_V2 gpo_low;
         PCICFG_GPO_HI_CSR_V2 gpo_hi;
         PCICFG_GPIOMAP_CSR_V2 gpiomap[8];
         PCICFG_SERDES_IOGB_CTRL_V2 serdes_iogb_ctrl;
         PCICFG_SERDES_PLL_CONTROL_V2 pcie_serdes_pll_cntl;
         PCICFG_HOST_D3_CONTROL_CSR_V2 host_d3_control;
         PCIE_SERDES_TX_MARGIN_COMM_0_V2 tx_margin_comm_0;
         PCIE_SERDES_TX_MARGIN_COMM_1_V2 tx_margin_comm_1;
         PCIE_SERDES_TX_PARAM_0_V2 tx_param_0;
         PCIE_SERDES_TX_PARAM_1_V2 tx_param_1;
         PCIE_SERDES_RX_PARAM_0_V2 rx_param_0;
         PCIE_SERDES_RX_PARAM_1_V2 rx_param_1;
         PCIE_SERDES_RX_PARAM_2_V2 rx_param_2;
         PCIE_SERDES_RX_PARAM_3_V2 rx_param_3;
         PCIE_SERDES_RX_PARAM_4_V2 rx_param_4;
         PCIE_SERDES_RX_PARAM_5_V2 rx_param_5;
         PCIE_SERDES_RCV_DET_V2 rcv_detect;
         PCICFG_STRAPS_REG_V2 straps_reg;
         PCICFG_D3_PM_CONTROL_MON_V2 f7_f0_d3_pm_mon[2];
         PCICFG_REQ_PRESET_V2 serdes_lanes_preset;
         PCICFG_EQUALIZATION_CTRL0_V2 serdes_equal_ctrl0;
         PCICFG_BCA_CTRL0_V2 serdes_bca_ctrl0;
         PCICFG_SERDES_LANE_CTRL_V2 serdes_lane_ctrl;
         PCICFG_SLEW_RATE_CTRL_V2 pads_slew_rate_control;
         PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2 mpu_scratchpad;
         PCICFG_HOST_D3CONTROL_CSR_V2 host_d3control;
         PCICFG_MPU_CONTROL_CSR_V2 mpu_control;
         PCICFG_GPI_CSR_V2 gpi_rsvd;
         PCICFG_GPO_LOW_CSR_V2 gpo_rsvd;
         PCICFG_GPIOMAP_CSR_V2 gpiomap_rsvd[4];
         PCICFG_GPIOMUX_CSR_V2 gpiomux_rsvd;
         PCICFG_D3BLOCK_CTRL_V2 hostd3_ctrl;
         PCICFG_D3_RESOURCE_ARBITER_V2 hostd3_resource_arbiter;
         PCICFG_HOSTD3_INT_STATUS_CSR_V2 hostd3_int_status;
         PCICFG_HOSTD3_INT_MASK_CSR_V2 hostd3_int_mask;
         PCICFG_HOSTD3_INT_LIVE_CSR_V2 hostd3_int_live_signal;
         PCICFG_GENERIC_SCRATCH_REG_V2 ncsi_scratchpad;
         PCICFG_XTL_DIFF_PCIE_CSR_V2 xtl_diff_pcie_ctrl;
         PCICFG_BE_BLOCK1_RST_DBG_V2 be_block1_rst_dbg;
         PCICFG_HOSTD3_UE_MASK_CSR_V2 hostd3_ue_mask;
         PCICFG_HOSTD3_UE_STATUS_CSR_V2 hostd3_ue_status;
         PCICFG_CPLL_CONFIG_V2 cpll_cfg;
         PCICFG_EPLL_CONFIG_V2 epll_cfg;
         PCICFG_MPLL_CONFIG_V2 mpll_cfg;
         PCICFG_PPLL_CONFIG_V2 ppll_cfg;
         PCICFG_D3_RESOURCE_ARBITER_WORD_V2 hostd3_resource_arbiter_word;
         PCICFG_GPIOMUX_CSR_V2 gpiomux;
         u32 rsvd0[2];                            // DWORDS 61 to 62
         PCICFG_STRAP_PINS_REG_V2 strap_pins;
      } SG_PACK ; // unnamed struct
      u32 dw[64]; // dword union
   }; // unnamed union
} SG_PACK PCICFG_D3BLOCK_CSRMAP_V2, *PPCICFG_D3BLOCK_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG_D3BLOCK_CSRMAP, sizeof (PCICFG_D3BLOCK_CSRMAP_V2) == 256);



typedef struct _PCICFG_PF1_EXTEND2_CSRMAP_V2 {
   union {
      struct { 
         u32 rsvd0[11];                           // DWORDS 0 to 10
         PCICFG_HOST_INT_STATUS2_CSR_V2 host_int_status2;
         PCICFG_HOST_INT_MASK2_CSR_V2 host_int_mask2;
         u32 rsvd1[43];                           // DWORDS 13 to 55
         PCIE_VSEC_CAP_HDR_V2 vsec_cap_hdr;
         PCIE_VSEC_BAR_STRIDE_HDR_V2 vsec_bar_stride_hdr;
         PCICFG_VF_BAR_STRIDE_V2 vf_bar_stride_0;
         PCICFG_VF_BAR_STRIDE_SUPPORTED_V2 vf_bar_stride_0_supported;
         PCICFG_VF_BAR_STRIDE_V2 vf_bar_stride_2;
         PCICFG_VF_BAR_STRIDE_SUPPORTED_V2 vf_bar_stride_1_supported;
         u32 rsvd2[2];                            // DWORDS 62 to 63
      } SG_PACK ; // unnamed struct
      u32 dw[64]; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF1_EXTEND2_CSRMAP_V2, *PPCICFG_PF1_EXTEND2_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF1_EXTEND2_CSRMAP, sizeof (PCICFG_PF1_EXTEND2_CSRMAP_V2) == 256);



typedef struct _PCICFG_PF0_EXTEND2_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_DEBUG_CSR_V2 debug;
         PCIE_SERDES_PROG_REG_V2 generic_reg;
         PCICFG_SERDES_DBG_CTRL_V2 serdes_dbg_ctrl;
         PCICFG_REQ_COEFF_V2 serdes_coeff_lane0;
         PCICFG_REQ_COEFF_V2 serdes_coeff_lane1;
         PCICFG_REQ_COEFF_V2 serdes_coeff_lane2;
         PCICFG_REQ_COEFF_V2 serdes_coeff_lane3;
         PCICFG_REQ_COEFF_V2 serdes_coeff_lane4;
         PCICFG_REQ_COEFF_V2 serdes_coeff_lane5;
         PCICFG_REQ_COEFF_V2 serdes_coeff_lane6;
         PCICFG_REQ_COEFF_V2 serdes_coeff_lane7;
         PCICFG_HOST_INT_STATUS2_CSR_V2 host_int_status2;
         PCICFG_HOST_INT_MASK2_CSR_V2 host_int_mask2;
         u32 rsvd0[43];                           // DWORDS 13 to 55
         PCIE_VSEC_CAP_HDR_V2 vsec_cap_hdr;
         PCIE_VSEC_BAR_STRIDE_HDR_V2 vsec_bar_stride_hdr;
         PCICFG_VF_BAR_STRIDE_V2 vf_bar_stride_0;
         PCICFG_VF_BAR_STRIDE_SUPPORTED_V2 vf_bar_stride_0_supported;
         PCICFG_VF_BAR_STRIDE_V2 vf_bar_stride_2;
         PCICFG_VF_BAR_STRIDE_SUPPORTED_V2 vf_bar_stride_1_supported;
         u32 rsvd1[2];                            // DWORDS 62 to 63
      } SG_PACK ; // unnamed struct
      u32 dw[64]; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF0_EXTEND2_CSRMAP_V2, *PPCICFG_PF0_EXTEND2_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF0_EXTEND2_CSRMAP, sizeof (PCICFG_PF0_EXTEND2_CSRMAP_V2) == 256);



typedef struct _PCICFG_PF0_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_ID_F0_CSR_V2 id;
         PCICFG_COMMAND_STATUS_CSR_V2 cmd_status;
         PCICFG_CLASS_REV_F0_CSR_V2 class_rev;
         PCICFG_CACHE_TMR_HDR_BIST_CSR_V2 cache;
         PCICFG_MEMBAR0_LO_CSR_V2 membar0_lo;
         PCICFG_MEMBAR0_HI_CSR_V2 membar0_hi;
         PCICFG_MEMBAR1_LO_CSR_V2 membar1_lo;
         PCICFG_MEMBAR1_HI_CSR_V2 membar1_hi;
         PCICFG_MEMBAR2_LO_F0_CSR_V2 membar2_lo;
         PCICFG_MEMBAR2_HI_CSR_V2 membar2_hi;
         u32 rsvd0[1];                            // DWORDS 10 to 10
         PCICFG_SUBSYSTEM_ID_F0_CSR_V2 subsystem_id;
         PCICFG_EXP_ROM_CSR_V2 exp_rom;
         PCICFG_CAP_CSR_V2 cap;
         u32 rsvd1[1];                            // DWORDS 14 to 14
         PCICFG_LATENCY_INT_F0_CSR_V2 latency_int;
         PCICFG_PMC_CSR_V2 pmc;
         PCICFG_PM_CONTROL_V2 pm_control;
         PCICFG_MSIX_CSR_V2 msix;
         PCICFG_MSIX_TABLE_CSR_V2 msix_table_offset;
         PCICFG_MSIX_PBA_CSR_V2 msix_pba_offset;
         PCICFG_HOST_CONTROL_STATUS_CSR_V2 host_control;
         PCICFG_SCRATCHPAD_CSR_V2 scratchpad;
         PCICFG_SOFT_RESET_CSR_V2 soft_reset;
         PCICFG_LPC_ADDR_CSR_V2 lpc_addr;
         PCICFG_LPC_DATA_CSR_V2 lpc_data;
         PCICFG_LPC_COMMAND_CSR_V2 lpc_command;
         PCICFG_TIMESTAMP_V2 timestamp_1ms;
         PCICFG_TIMESTAMP_V2 timestamp_10ms;
         PCICFG_SEMAPHORE_SCRATCH_CSR_V2 host_semaphore;
         PCICFG_SEMAPHORE_SCRATCH_CSR_V2 vm_semaphore;
         PCICFG_SCRATCHPAD_CSR_V2 scratchpad1;
         PCICFG_GENERIC_SCRATCH_REG_V2 drv_hwdbg_scratchpad;
         PCICFG_D0_RESOURCE_ARBITER_WORD_V2 hostd0_resource_arbiter_word;
         PCICFG_GENERIC_SCRATCH_REG_V2 CSII_CONTROL;
         PCICFG_GENERIC_SCRATCH_REG_V2 CSII_DATA;
         u32 rsvd2[1];                            // DWORDS 36 to 36
         PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2 mpu_ep_semaphore;
         PCICFG_OPTION_ROM_BIOS_CSR_V2 bios_status;
         PCICFG_ASIC_ID_CSR_V2 asic_id;
         PCICFG_UE_STATUS_LOW_CSR_V2 ue_status_low;
         PCICFG_UE_STATUS_HI_CSR_V2 ue_status_hi;
         PCICFG_UE_STATUS_LOW_MASK_CSR_V2 ue_status_low_mask;
         PCICFG_UE_STATUS_HI_MASK_CSR_V2 ue_status_hi_mask;
         PCICFG_ONLINE0_CSR_V2 online0;
         PCICFG_ONLINE1_CSR_V2 online1;
         PCICFG_VPD_CAP_CSR_V2 vpd_cap;
         PCICFG_VPD_DATA_CSR_V2 vpd_data;
         PCICFG_PCIE_CAP_CSR_V2 pcie_cap;
         PCICFG_PCIE_DEVCAP_CSR_V2 pcie_devcap;
         PCICFG_PCIE_CONTROL_STATUS_CSR_V2 pcie_control_status;
         PCICFG_PCIE_LINK_CAP_CSR_V2 pcie_link_cap;
         PCICFG_PCIE_LINK_STATUS_CSR_V2 pcie_link_status;
         PCICFG_RETURN_ZEROS_V2 return_zeros[4];
         PCICFG_PCIE_DEVCAP2_CSR_V2 pcie_devcap2;
         PCICFG_PCIE_CONTROL_STATUS2_CSR_V2 pcie_control_status2;
         PCICFG_PCIE_LINK_CAP2_CSR_V2 pcie_link_cap2;
         PCICFG_PCIE_LINK_STATUS2_CSR_V2 pcie_link_status2;
         PCICFG_RETURN_ZEROS_V2 return_zeros_1[2];
         PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2 membar_ctrl_intr_ctrl;
         PCIE_ERR_ENHANCED_CAP_V2 pcie_err_enhanced_cap;
         PCIE_UNCORR_ERR_STATUS_V2 pcie_uncorr_err_status;
         PCIE_UNCORR_ERR_MASK_V2 pcie_uncorr_err_mask;
         PCIE_UNCORR_ERR_SEVERITY_V2 pcie_uncorr_err_severity;
         PCIE_CORR_ERR_STATUS_V2 pcie_corr_err_status;
         PCIE_CORR_ERR_MASK_V2 pcie_corr_err_mask;
         PCIE_ERR_CAP_CONTROL_V2 pcie_err_cap_control;
         PCIE_HEADER_REGISTER_V2 pcie_header_register0;
         PCIE_HEADER_REGISTER_V2 pcie_header_register1;
         PCIE_HEADER_REGISTER_V2 pcie_header_register2;
         PCIE_HEADER_REGISTER_V2 pcie_header_register3;
         PCIE_TPH_REQ_CAP_HDR_F0_V2 pcie_tph_req_caphdr;
         PCIE_TPH_CAPABILITY_V2 pcie_tph_capability;
         PCIE_TPH_CONTROL_V2 pcie_tph_control;
         PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_V2 pcie_fcp_timer_beacon_en_pcicfg_override;
         PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_V2 pcie_option_rom_flash_translation_f0;
         PCICFG_IP_CONTROL_STATUS_3_CSR_V2 ip_control_status_3;
         PCIE_ATS_ENHANCED_CAP_V2 pcie_ats_enhanced_hdr;
         PCIE_ATS_CAPABILITY_V2 pcie_ats_capability;
         PCIE_PM_PME_SERDES_PLL_DMA_WRB_V2 pcie_pm_pme_serdes_pll_dma_wrb;
         hwdbg_cfgreg_i_5_V2 host_dbg_mux_data_pclk_d3_o_63_32;
         PCIE_vfs_intr_info_V2 vfs_vpd_intr_func_index;
         hwdbg_cfgreg_i_0_V2 host_dbg_mux_data_core_o_31_0;
         hwdbg_cfgreg_i_1_V2 host_dbg_mux_data_core_o_63_32;
         PCIE_ARI_ENHANCED_CAP_V2 pcie_ari_enhanced_hdr;
         PCIE_ARI_CAPABILITY_V2 pcie_ari_capability;
         PCIE_DEV_SERIAL_CAP_HDR_V2 pcie_device_serial_hdr;
         PCIE_DEV_SERIAL_NUM_LOW_V2 pcie_device_serial_number_low;
         PCIE_DEV_SERIAL_NUM_HIGH_V2 pcie_device_serial_number_high;
         PCICFG_HOST_INT_STATUS_CSR_V2 host_int_status;
         PCICFG_HOST_INT_MASK_CSR_V2 host_int_mask;
         PCICFG_HOST_TIMER_INT_CTRL_CSR_V2 host_timer_ctrl;
         PCIE_SR_IOV_ENHANCED_CAP_V2 SR_IOV_capability_id;
         PCIE_SR_IOV_CAPABILITIES_V2 SR_IOV_capabilities;
         PCIE_SR_IOV_STATUS_CONTROL_V2 SR_IOV_status_control;
         PCIE_TOTAL_INITIAL_VFs_V2 total_initial_VFs;
         PCIE_NUM_VFs_V2 number_of_VFs;
         PCIE_VF_STRIDE_OFFSET_V2 VF_stride_offset;
         PCIE_VF_DEVICE_ID_V2 VF_device_id;
         PCIE_VF_SYSTEM_PAGE_SUPPORTED_V2 PF_supported_page_size;
         PCIE_VF_SYSTEM_PAGE_V2 PF_system_page;
         PCICFG_VF_MEMBAR0_LO_V2 VF_membar0_low;
         PCICFG_VF_MEMBAR0_HI_V2 VF_membar0_high;
         PCICFG_VF_MEMBAR0_LO_V2 VF_membar1_low;
         PCICFG_VF_MEMBAR0_HI_V2 VF_membar1_high;
         PCICFG_RETURN_ZEROS_V2 return_zeros_2_1[2];
         PCICFG_RETURN_ZEROS_V2 return_zeros_3;
         PCICFG_IP_SPEED_WIDTH_CTRL_V2 ip_speed_width_control;
         PCICFG_IP_CONTROL_STATUS_5_CSR_V2 ip_control_status_5;
         PCICFG_VF_SLI4_CSR_V2 vf_sli4_reg;
         PCICFG_ERR_REPLAY_MONITOR_V2 error_replay_monitor;
         PCICFG_IP_CONTROL_STATUS_2_CSR_V2 ip_control_status_2;
         PCICFG_IP_CONTROL_STATUS_0_CSR_V2 ip_control_status_0;
         PCICFG_IP_CONTROL_STATUS_1_CSR_V2 ip_control_status_1;
         PCICFG_HWDBG_SHIFT_V2 cfg_attr_hwdbg_shift;
         PCIE_ATS_INVALID_ADDR_LOW_V2 ats_invalid_addr_low;
         PCIE_ATS_INVALID_ADDR_V2 ats_invalid_addr_high;
         PCIE_ATS_INVALID_REQUESTERID_DEVID_V2 ats_invalid_requesterid_deviceid;
         PCIE_VSEC_CAP_HDR_V2 vsec_cap_hdr;
         PCIE_VSEC_HDR_V2 vsec_hdr;
         PCICFG_VF_BAR_STRIDE_V2 vf_bar_stride;
         PCICFG_HWDBG_REGSEL_V2 hwdbg_regsel;
         PCICFG_HWDBG_ENABLE_V2 hwdbg_enable;
         PCICFG_PF0_EXTEND1_CSRMAP_V2 pciecfg_pf0_extend1;
         PCICFG_PF0_EXTEND2_CSRMAP_V2 pciecfg_pf0_extend2;
         PCICFG_D3BLOCK_CSRMAP_V2 pciecfg_d3block_csrmap;
         u32 rsvd3[704];                          // DWORDS 320 to 1023
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF0_CSRMAP_V2, *PPCICFG_PF0_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF0_CSRMAP, sizeof (PCICFG_PF0_CSRMAP_V2) == 4096);



typedef struct _PCICFG_PF1_PF7_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_ID_F1_CSR_V2 id;
         PCICFG_COMMAND_STATUS_CSR_V2 cmd_status;
         PCICFG_CLASS_REV_F1_CSR_V2 class_rev;
         PCICFG_CACHE_TMR_HDR_BIST_CSR_V2 cache;
         PCICFG_MEMBAR0_LO_CSR_V2 membar0_lo;
         PCICFG_MEMBAR0_HI_CSR_V2 membar0_hi;
         PCICFG_MEMBAR1_LO_CSR_V2 membar1_lo;
         PCICFG_MEMBAR1_HI_CSR_V2 membar1_hi;
         PCICFG_MEMBAR2_LO_F1_CSR_V2 membar2_lo;
         PCICFG_MEMBAR2_HI_CSR_V2 membar2_hi;
         u32 rsvd0[1];                            // DWORDS 10 to 10
         PCICFG_SUBSYSTEM_ID_F1_CSR_V2 subsystem_id;
         PCICFG_EXP_ROM_CSR_V2 exp_rom;
         PCICFG_CAP_CSR_V2 cap;
         u32 rsvd1[1];                            // DWORDS 14 to 14
         PCICFG_LATENCY_INT_F1_CSR_V2 latency_int;
         PCICFG_PMC_CSR_V2 pmc;
         PCICFG_PM_CONTROL_V2 pm_control;
         PCICFG_MSIX_CSR_V2 msix;
         PCICFG_MSIX_TABLE_CSR_V2 msix_table_offset;
         PCICFG_MSIX_PBA_CSR_V2 msix_pba_offset;
         PCICFG_HOST_CONTROL_STATUS_CSR_V2 host_control;
         PCICFG_SCRATCHPAD_CSR_V2 scratchpad;
         PCICFG_SOFT_RESET_CSR_V2 soft_reset;
         PCICFG_LPC_ADDR_CSR_V2 lpc_addr;
         PCICFG_LPC_DATA_CSR_V2 lpc_data;
         PCICFG_LPC_COMMAND_CSR_V2 lpc_command;
         PCICFG_TIMESTAMP_V2 timestamp_1ms;
         PCICFG_TIMESTAMP_V2 timestamp_10ms;
         PCICFG_SEMAPHORE_SCRATCH_CSR_V2 host_semaphore;
         PCICFG_SEMAPHORE_SCRATCH_CSR_V2 vm_semaphore;
         PCICFG_SCRATCHPAD_CSR_V2 scratchpad1;
         PCICFG_GENERIC_SCRATCH_REG_V2 drv_hwdbg_scratchpad;
         PCICFG_D0_RESOURCE_ARBITER_WORD_V2 hostd0_resource_arbiter_word;
         u32 rsvd2[3];                            // DWORDS 34 to 36
         PCICFG_GENERIC_SCRATCH_SOFTRST_REG_V2 mpu_ep_semaphore;
         PCICFG_OPTION_ROM_BIOS_CSR_V2 bios_status;
         PCICFG_ASIC_ID_CSR_V2 asic_id;
         PCICFG_UE_STATUS_LOW_CSR_V2 ue_status_low;
         PCICFG_UE_STATUS_HI_CSR_V2 ue_status_hi;
         PCICFG_UE_STATUS_LOW_MASK_CSR_V2 ue_status_low_mask;
         PCICFG_UE_STATUS_HI_MASK_CSR_V2 ue_status_hi_mask;
         PCICFG_ONLINE0_CSR_V2 online0;
         PCICFG_ONLINE1_CSR_V2 online1;
         PCICFG_VPD_CAP_CSR_V2 vpd_cap;
         PCICFG_VPD_DATA_CSR_V2 vpd_data;
         PCICFG_PCIE_CAP_CSR_V2 pcie_cap;
         PCICFG_PCIE_DEVCAP_CSR_V2 pcie_devcap;
         PCICFG_PCIE_CONTROL_STATUS_CSR_V2 pcie_control_status;
         PCICFG_PCIE_LINK_CAP_CSR_V2 pcie_link_cap;
         PCICFG_PCIE_LINK_STATUS_CSR_V2 pcie_link_status;
         PCICFG_RETURN_ZEROS_V2 return_zeros[4];
         PCICFG_PCIE_DEVCAP2_CSR_V2 pcie_devcap2;
         PCICFG_PCIE_CONTROL_STATUS2_CSR_V2 pcie_control_status2;
         PCICFG_PCIE_LINK_CAP2_CSR_V2 pcie_link_cap2;
         PCICFG_PCIE_LINK_STATUS2_CSR_F1_V2 pcie_link_status2;
         PCICFG_RETURN_ZEROS_V2 return_zeros_1[2];
         PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_V2 membar_ctrl_intr_ctrl;
         PCIE_ERR_ENHANCED_CAP_V2 pcie_err_enhanced_cap;
         PCIE_UNCORR_ERR_STATUS_V2 pcie_uncorr_err_status;
         PCIE_UNCORR_ERR_MASK_V2 pcie_uncorr_err_mask;
         PCIE_UNCORR_ERR_SEVERITY_V2 pcie_uncorr_err_severity;
         PCIE_CORR_ERR_STATUS_V2 pcie_corr_err_status;
         PCIE_CORR_ERR_MASK_V2 pcie_corr_err_mask;
         PCIE_ERR_CAP_CONTROL_V2 pcie_err_cap_control;
         PCIE_HEADER_REGISTER_V2 pcie_header_register0;
         PCIE_HEADER_REGISTER_V2 pcie_header_register1;
         PCIE_HEADER_REGISTER_V2 pcie_header_register2;
         PCIE_HEADER_REGISTER_V2 pcie_header_register3;
         PCIE_TPH_REQ_CAP_HDR_V2 pcie_tph_req_caphdr;
         PCIE_TPH_CAPABILITY_V2 pcie_tph_capability;
         PCIE_TPH_CONTROL_V2 pcie_tph_control;
         PCIE_LTSSM_STAGES7_4_V2 pcie_ltssm_states7_4;
         PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_V2 pcie_option_rom_flash_translation_f1;
         PCIE_LTSSM_STAGES3_0_V2 pcie_ltssm_states3_0;
         PCIE_ATS_ENHANCED_CAP_V2 pcie_ats_enhanced_hdr;
         PCIE_ATS_CAPABILITY_V2 pcie_ats_capability;
         u32 rsvd3[3];                            // DWORDS 83 to 85
         PCIE_SERDES_MDIO_COMMAND_V2 pcie_serdes_mdio_command;
         PCIE_SERDES_MDIO_DATA_V2 pcie_serdes_mdio_data;
         PCIE_ARI_ENHANCED_CAP_V2 pcie_ari_enhanced_hdr;
         PCIE_ARI_CAPABILITY_V2 pcie_ari_capability;
         PCIE_DEV_SERIAL_CAP_HDR_V2 pcie_device_serial_hdr;
         PCIE_DEV_SERIAL_NUM_LOW_V2 pcie_device_serial_number_low;
         PCIE_DEV_SERIAL_NUM_HIGH_V2 pcie_device_serial_number_high;
         PCICFG_HOST_INT_STATUS_CSR_V2 host_int_status;
         PCICFG_HOST_INT_MASK_CSR_V2 host_int_mask;
         PCICFG_HOST_TIMER_INT_CTRL_CSR_V2 host_timer_ctrl;
         PCIE_SR_IOV_ENHANCED_CAP_V2 SR_IOV_capability_id;
         PCIE_SR_IOV_CAPABILITIES_V2 SR_IOV_capabilities;
         PCIE_SR_IOV_STATUS_CONTROL_V2 SR_IOV_status_control;
         PCIE_TOTAL_INITIAL_VFs_V2 total_initial_VFs;
         PCIE_NUM_VFs_V2 number_of_VFs;
         PCIE_VF_STRIDE_OFFSET_V2 VF_stride_offset;
         PCIE_VF_DEVICE_ID_V2 VF_device_id;
         PCIE_VF_SYSTEM_PAGE_SUPPORTED_V2 PF_supported_page_size;
         PCIE_VF_SYSTEM_PAGE_V2 PF_system_page;
         PCICFG_VF_MEMBAR0_LO_V2 VF_membar0_low;
         PCICFG_VF_MEMBAR0_HI_V2 VF_membar0_high;
         PCICFG_VF_MEMBAR0_LO_V2 VF_membar1_low;
         PCICFG_VF_MEMBAR0_HI_V2 VF_membar1_high;
         PCICFG_RETURN_ZEROS_V2 return_zeros_2_1[2];
         PCICFG_RETURN_ZEROS_V2 return_zeros_3;
         PCIE_BME_TLP_COMMON_HDR0_V2 dma_tlp_hdr0;
         PCIE_BME_TLP_COMMON_HDR1_V2 dma_tlp_hdr1;
         PCIE_BME_ATS_REQ_TLP_ADDR_LOW_V2 dma_tlp_addr_low;
         PCIE_BME_ATS_REQ_TLP_ADDR_HIGH_V2 dma_tlp_addr_high;
         PCICFG_F1_HOST_DEBUG_V2 host_debug;
         u32 rsvd4[3];                            // DWORDS 117 to 119
         PCIE_ATS_INVALID_ADDR_LOW_V2 ats_invalid_addr_low;
         PCIE_ATS_INVALID_ADDR_V2 ats_invalid_addr_high;
         PCIE_ATS_INVALID_REQUESTERID_DEVID_V2 ats_invalid_requesterid_deviceid;
         PCIE_VSEC_CAP_HDR_V2 vsec_cap_hdr;
         PCIE_VSEC_HDR_V2 vsec_hdr;
         PCICFG_VF_BAR_STRIDE_V2 vf_bar_stride;
         PCIE_MSIX_TBL_TO_CTX_CTRL_V2 msix_tbl_to_ctx_ctrl;
         PCIE_MSIX_TBL_TO_CTX_V2 msix_tbl_to_ctx;
         PCICFG_PF1_EXTEND1_CSRMAP_V2 pciecfg_pf1_extend1;
         PCICFG_PF1_EXTEND2_CSRMAP_V2 pciecfg_pf1_extend2;
         PCICFG_D3BLOCK_CSRMAP_V2 pciecfg_d3block_csrmap;
         u32 rsvd5[704];                          // DWORDS 320 to 1023
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG_PF1_PF7_CSRMAP_V2, *PPCICFG_PF1_PF7_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG_PF1_PF7_CSRMAP, sizeof (PCICFG_PF1_PF7_CSRMAP_V2) == 4096);



typedef struct _PCICFG0_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF0_CSRMAP_V2 PCICFG_F0_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG0_CSRMAP_V2, *PPCICFG0_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG0_CSRMAP, sizeof (PCICFG0_CSRMAP_V2) == 4096);



typedef struct _PCICFG1_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F1_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG1_CSRMAP_V2, *PPCICFG1_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG1_CSRMAP, sizeof (PCICFG1_CSRMAP_V2) == 4096);



typedef struct _PCICFG2_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F2_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG2_CSRMAP_V2, *PPCICFG2_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG2_CSRMAP, sizeof (PCICFG2_CSRMAP_V2) == 4096);



typedef struct _PCICFG3_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F3_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG3_CSRMAP_V2, *PPCICFG3_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG3_CSRMAP, sizeof (PCICFG3_CSRMAP_V2) == 4096);



typedef struct _PCICFG4_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F4_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG4_CSRMAP_V2, *PPCICFG4_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG4_CSRMAP, sizeof (PCICFG4_CSRMAP_V2) == 4096);



typedef struct _PCICFG5_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F5_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG5_CSRMAP_V2, *PPCICFG5_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG5_CSRMAP, sizeof (PCICFG5_CSRMAP_V2) == 4096);



typedef struct _PCICFG6_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F6_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG6_CSRMAP_V2, *PPCICFG6_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG6_CSRMAP, sizeof (PCICFG6_CSRMAP_V2) == 4096);



typedef struct _PCICFG7_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F7_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG7_CSRMAP_V2, *PPCICFG7_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG7_CSRMAP, sizeof (PCICFG7_CSRMAP_V2) == 4096);



typedef struct _PCICFG8_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F8_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG8_CSRMAP_V2, *PPCICFG8_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG8_CSRMAP, sizeof (PCICFG8_CSRMAP_V2) == 4096);



typedef struct _PCICFG9_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F9_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG9_CSRMAP_V2, *PPCICFG9_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG9_CSRMAP, sizeof (PCICFG9_CSRMAP_V2) == 4096);



typedef struct _PCICFG10_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F10_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG10_CSRMAP_V2, *PPCICFG10_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG10_CSRMAP, sizeof (PCICFG10_CSRMAP_V2) == 4096);



typedef struct _PCICFG11_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F11_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG11_CSRMAP_V2, *PPCICFG11_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG11_CSRMAP, sizeof (PCICFG11_CSRMAP_V2) == 4096);



typedef struct _PCICFG12_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F12_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG12_CSRMAP_V2, *PPCICFG12_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG12_CSRMAP, sizeof (PCICFG12_CSRMAP_V2) == 4096);



typedef struct _PCICFG13_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F13_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG13_CSRMAP_V2, *PPCICFG13_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG13_CSRMAP, sizeof (PCICFG13_CSRMAP_V2) == 4096);



typedef struct _PCICFG14_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F14_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG14_CSRMAP_V2, *PPCICFG14_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG14_CSRMAP, sizeof (PCICFG14_CSRMAP_V2) == 4096);



typedef struct _PCICFG15_CSRMAP_V2 {
   union {
      struct { 
         PCICFG_PF1_PF7_CSRMAP_V2 PCICFG_F15_CSRMAP;
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PCICFG15_CSRMAP_V2, *PPCICFG15_CSRMAP_V2;

SG_C_ASSERT(__sizeof__PCICFG15_CSRMAP, sizeof (PCICFG15_CSRMAP_V2) == 4096);



typedef struct _VF_PCICFG_ID_CSR_V2 {
   union {
      struct { 
         u32 vendorid : 16;                       // DWORD 0
         u32 deviceid : 16;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_ID_CSR_V2, *PVF_PCICFG_ID_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_ID_CSR, sizeof (VF_PCICFG_ID_CSR_V2) == 4);



typedef struct _CUST_PCICFG_COMMAND_STATUS_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 1;                           // DWORD 0
         u32 memen : 1;                           // DWORD 0
         u32 bmen : 1;                            // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 perrsp : 1;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 serren : 1;                          // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 intxdisable : 1;                     // DWORD 0
         u32 rsvd4 : 5;                           // DWORD 0
         u32 rsvd5 : 3;                           // DWORD 0
         u32 intstat : 1;                         // DWORD 0
         u32 cap : 1;                             // DWORD 0
         u32 rsvd6 : 1;                           // DWORD 0
         u32 rsvd7 : 1;                           // DWORD 0
         u32 rsvd8 : 1;                           // DWORD 0
         u32 dpderr : 1;                          // DWORD 0
         u32 rsvd9 : 2;                           // DWORD 0
         u32 stabt : 1;                           // DWORD 0
         u32 rtabt : 1;                           // DWORD 0
         u32 rmabt : 1;                           // DWORD 0
         u32 sserr : 1;                           // DWORD 0
         u32 dperr : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PCICFG_COMMAND_STATUS_CSR_V2, *PCUST_PCICFG_COMMAND_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__CUST_PCICFG_COMMAND_STATUS_CSR, sizeof (CUST_PCICFG_COMMAND_STATUS_CSR_V2) == 4);



typedef struct _VF_PCICFG_COMMAND_STATUS_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 2;                           // DWORD 0
         u32 bmen : 1;                            // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 perrsp : 1;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 serren : 1;                          // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 rsvd4 : 1;                           // DWORD 0
         u32 rsvd5 : 5;                           // DWORD 0
         u32 rsvd6 : 3;                           // DWORD 0
         u32 rsvd7 : 1;                           // DWORD 0
         u32 cap : 1;                             // DWORD 0
         u32 rsvd8 : 3;                           // DWORD 0
         u32 dpderr : 1;                          // DWORD 0
         u32 rsvd9 : 2;                           // DWORD 0
         u32 stabt : 1;                           // DWORD 0
         u32 rtabt : 1;                           // DWORD 0
         u32 rmabt : 1;                           // DWORD 0
         u32 sserr : 1;                           // DWORD 0
         u32 dperr : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_COMMAND_STATUS_CSR_V2, *PVF_PCICFG_COMMAND_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_COMMAND_STATUS_CSR, sizeof (VF_PCICFG_COMMAND_STATUS_CSR_V2) == 4);



typedef struct _VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 8;                           // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
         u32 header_type : 8;                     // DWORD 0
         u32 rsvd3 : 8;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2, *PVF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_CACHE_TMR_HDR_BIST_CSR, sizeof (VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2) == 4);



typedef struct _CUST_PCICFG_MEMBAR0_LO_CSR_V2 {
   union {
      struct { 
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 membar0 : 18;                        // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PCICFG_MEMBAR0_LO_CSR_V2, *PCUST_PCICFG_MEMBAR0_LO_CSR_V2;

SG_C_ASSERT(__sizeof__CUST_PCICFG_MEMBAR0_LO_CSR, sizeof (CUST_PCICFG_MEMBAR0_LO_CSR_V2) == 4);



typedef struct _CUST_PCICFG_MEMBAR0_HI_CSR_V2 {
   union {
      struct { 
         u32 membar0hi;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PCICFG_MEMBAR0_HI_CSR_V2, *PCUST_PCICFG_MEMBAR0_HI_CSR_V2;

SG_C_ASSERT(__sizeof__CUST_PCICFG_MEMBAR0_HI_CSR, sizeof (CUST_PCICFG_MEMBAR0_HI_CSR_V2) == 4);



typedef struct _VF_PCICFG_CLASS_REV_CSR_V2 {
   union {
      struct { 
         u32 rev : 8;                             // DWORD 0
         u32 prgintf : 8;                         // DWORD 0
         u32 subclass : 8;                        // DWORD 0
         u32 baseclass : 8;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_CLASS_REV_CSR_V2, *PVF_PCICFG_CLASS_REV_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_CLASS_REV_CSR, sizeof (VF_PCICFG_CLASS_REV_CSR_V2) == 4);



typedef struct _VF_PCICFG_SUBSYSTEM_ID_CSR_V2 {
   union {
      struct { 
         u32 subsys_vendor_id : 16;               // DWORD 0
         u32 subsys_id : 16;                      // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_SUBSYSTEM_ID_CSR_V2, *PVF_PCICFG_SUBSYSTEM_ID_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_SUBSYSTEM_ID_CSR, sizeof (VF_PCICFG_SUBSYSTEM_ID_CSR_V2) == 4);



typedef struct _VF_PCICFG_CAP_CSR_V2 {
   union {
      struct { 
         u32 capptr : 8;                          // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_CAP_CSR_V2, *PVF_PCICFG_CAP_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_CAP_CSR, sizeof (VF_PCICFG_CAP_CSR_V2) == 4);



typedef struct _CUST_PF_PCICFG_LATENCY_INT_CSR_V2 {
   union {
      struct { 
         u32 int_line : 8;                        // DWORD 0
         u32 int_pin : 8;                         // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCICFG_LATENCY_INT_CSR_V2, *PCUST_PF_PCICFG_LATENCY_INT_CSR_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCICFG_LATENCY_INT_CSR, sizeof (CUST_PF_PCICFG_LATENCY_INT_CSR_V2) == 4);



typedef struct _VF_PCICFG_LATENCY_INT_CSR_V2 {
   union {
      struct { 
         u32 int_line : 8;                        // DWORD 0
         u32 int_pin : 3;                         // DWORD 0
         u32 int_pin_rsvd : 5;                    // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_LATENCY_INT_CSR_V2, *PVF_PCICFG_LATENCY_INT_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_LATENCY_INT_CSR, sizeof (VF_PCICFG_LATENCY_INT_CSR_V2) == 4);



typedef struct _VF_PCICFG_MSIX_CSR_V2 {
   union {
      struct { 
         u32 capid : 8;                           // DWORD 0
         u32 nextptr : 8;                         // DWORD 0
         u32 tablesize : 11;                      // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 funcmask : 1;                        // DWORD 0
         u32 en : 1;                              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_MSIX_CSR_V2, *PVF_PCICFG_MSIX_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_CSR, sizeof (VF_PCICFG_MSIX_CSR_V2) == 4);



typedef struct _VF_PCICFG_MSIX_TABLE_CSR_V2 {
   union {
      struct { 
         u32 tablebir : 3;                        // DWORD 0
         u32 offset : 29;                         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_MSIX_TABLE_CSR_V2, *PVF_PCICFG_MSIX_TABLE_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_TABLE_CSR, sizeof (VF_PCICFG_MSIX_TABLE_CSR_V2) == 4);



typedef struct _VF_PCICFG_MSIX_PBA_CSR_V2 {
   union {
      struct { 
         u32 pbabir : 3;                          // DWORD 0
         u32 offset : 29;                         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_MSIX_PBA_CSR_V2, *PVF_PCICFG_MSIX_PBA_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_PBA_CSR, sizeof (VF_PCICFG_MSIX_PBA_CSR_V2) == 4);



typedef struct _VF_PCICFG_INT_CTRL_FUNCTION_NUM_V2 {
   union {
      struct { 
         u32 vf_function_num : 8;                 // DWORD 0
         u32 pf_function_num : 4;                 // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 sliport_error1 : 2;                  // DWORD 0
         u32 SLI_STATUS_ERR : 1;                  // DWORD 0
         u32 SLI_STATUS_RN : 1;                   // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 drv_mpu_msg : 2;                     // DWORD 0
         u32 shadow_FLR : 1;                      // DWORD 0
         u32 hostintr : 1;                        // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_INT_CTRL_FUNCTION_NUM_V2, *PVF_PCICFG_INT_CTRL_FUNCTION_NUM_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_INT_CTRL_FUNCTION_NUM, sizeof (VF_PCICFG_INT_CTRL_FUNCTION_NUM_V2) == 4);



typedef struct _VF_PCICFG_VPD_CAP_CSR_V2 {
   union {
      struct { 
         u32 capid : 8;                           // DWORD 0
         u32 nextcap : 8;                         // DWORD 0
         u32 addr : 15;                           // DWORD 0
         u32 flag : 1;                            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_VPD_CAP_CSR_V2, *PVF_PCICFG_VPD_CAP_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_VPD_CAP_CSR, sizeof (VF_PCICFG_VPD_CAP_CSR_V2) == 4);



typedef struct _VF_PCICFG_VPD_DATA_CSR_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_VPD_DATA_CSR_V2, *PVF_PCICFG_VPD_DATA_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_VPD_DATA_CSR, sizeof (VF_PCICFG_VPD_DATA_CSR_V2) == 4);



typedef struct _VF_PCICFG_PCIE_CAP_CSR_V2 {
   union {
      struct { 
         u32 capid : 8;                           // DWORD 0
         u32 nextcap : 8;                         // DWORD 0
         u32 capver : 4;                          // DWORD 0
         u32 devport : 4;                         // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PCIE_CAP_CSR_V2, *PVF_PCICFG_PCIE_CAP_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CAP_CSR, sizeof (VF_PCICFG_PCIE_CAP_CSR_V2) == 4);



typedef struct _VF_PCICFG_PCIE_DEVCAP_CSR_V2 {
   union {
      struct { 
         u32 payload : 3;                         // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 lo_lat : 3;                          // DWORD 0
         u32 l1_lat : 3;                          // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 ROLE_ERR_REP : 1;                    // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 rsvd3 : 10;                          // DWORD 0
         u32 FLR : 1;                             // DWORD 0
         u32 rsvd4 : 3;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PCIE_DEVCAP_CSR_V2, *PVF_PCICFG_PCIE_DEVCAP_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_DEVCAP_CSR, sizeof (VF_PCICFG_PCIE_DEVCAP_CSR_V2) == 4);



typedef struct _VF_PCICFG_FUNCTION_IDENTIFIER_V2 {
   union {
      struct { 
         u32 VFNUM : 8;                           // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_FUNCTION_IDENTIFIER_V2, *PVF_PCICFG_FUNCTION_IDENTIFIER_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_FUNCTION_IDENTIFIER, sizeof (VF_PCICFG_FUNCTION_IDENTIFIER_V2) == 4);



typedef struct _VF_PCICFG_SCRATCHPAD_CSR_V2 {
   union {
      struct { 
         u32 scratchpad;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_SCRATCHPAD_CSR_V2, *PVF_PCICFG_SCRATCHPAD_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_SCRATCHPAD_CSR, sizeof (VF_PCICFG_SCRATCHPAD_CSR_V2) == 4);



typedef struct _VF_MSITBL_SIZE_CSR_V2 {
   union {
      struct { 
         u32 vf_msix_tbl_size : 8;                // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_MSITBL_SIZE_CSR_V2, *PVF_MSITBL_SIZE_CSR_V2;

SG_C_ASSERT(__sizeof__VF_MSITBL_SIZE_CSR, sizeof (VF_MSITBL_SIZE_CSR_V2) == 4);



typedef struct _VF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2 {
   union {
      struct { 
         u32 CorrErrReportEn : 1;                 // DWORD 0
         u32 NonFatalErrReportEn : 1;             // DWORD 0
         u32 FatalErrReportEn : 1;                // DWORD 0
         u32 UnsuppReqReportEn : 1;               // DWORD 0
         u32 EnableRelaxOrder : 1;                // DWORD 0
         u32 Max_Payload_Size : 3;                // DWORD 0
         u32 ExtendTagFieldEnable : 1;            // DWORD 0
         u32 PhantomFnEnable : 1;                 // DWORD 0
         u32 AuxPwrPMEnable : 1;                  // DWORD 0
         u32 EnableNoSnoop : 1;                   // DWORD 0
         u32 Max_Read_Req_Size : 3;               // DWORD 0
         u32 INITIATE_FLR : 1;                    // DWORD 0
         u32 CorrErrDetect : 1;                   // DWORD 0
         u32 NonFatalErrDetect : 1;               // DWORD 0
         u32 FatalErrDetect : 1;                  // DWORD 0
         u32 UnsuppReqDetect : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 TransPending : 1;                    // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2, *PVF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CONTROL_STATUS_CSR, sizeof (VF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2) == 4);



typedef struct _VF_PCICFG_PCIE_LINK_CAP_CSR_V2 {
   union {
      struct { 
         u32 MaxLinkSpeed : 4;                    // DWORD 0
         u32 MaxLinkWidth : 6;                    // DWORD 0
         u32 ASPMSupport : 2;                     // DWORD 0
         u32 L0sExitLat : 3;                      // DWORD 0
         u32 L1ExitLat : 3;                       // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 PortNum : 8;                         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PCIE_LINK_CAP_CSR_V2, *PVF_PCICFG_PCIE_LINK_CAP_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_CAP_CSR, sizeof (VF_PCICFG_PCIE_LINK_CAP_CSR_V2) == 4);



typedef struct _CUST_PF_PCICFG_PCIE_LINK_STATUS_CSR_V2 {
   union {
      struct { 
         u32 ASPMCtl : 2;                         // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 LinkSpeed : 4;                       // DWORD 0
         u32 NegLinkWidth : 6;                    // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 SlotClkConfig : 1;                   // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCICFG_PCIE_LINK_STATUS_CSR_V2, *PCUST_PF_PCICFG_PCIE_LINK_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCICFG_PCIE_LINK_STATUS_CSR, sizeof (CUST_PF_PCICFG_PCIE_LINK_STATUS_CSR_V2) == 4);



typedef struct _VF_PCICFG_PCIE_LINK_STATUS_CSR_V2 {
   union {
      struct { 
         u32 ASPMCtl : 2;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ReadCmplBndry : 1;                   // DWORD 0
         u32 LinkDisable : 1;                     // DWORD 0
         u32 RetrainLink : 1;                     // DWORD 0
         u32 CommonClkConfig : 1;                 // DWORD 0
         u32 ExtendSync : 1;                      // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 hw_autonomous_width_dis : 1;         // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 LinkSpeed : 4;                       // DWORD 0
         u32 NegLinkWidth : 6;                    // DWORD 0
         u32 LinkTrainErr : 1;                    // DWORD 0
         u32 LinkTrain : 1;                       // DWORD 0
         u32 SlotClkConfig : 1;                   // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PCIE_LINK_STATUS_CSR_V2, *PVF_PCICFG_PCIE_LINK_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_STATUS_CSR, sizeof (VF_PCICFG_PCIE_LINK_STATUS_CSR_V2) == 4);



typedef struct _VF_PCICFG_PCIE_DEVCAP2_CSR_V2 {
   union {
      struct { 
         u32 cmpl_tmout_sup : 4;                  // DWORD 0
         u32 cmpl_tmout_dis_sup : 1;              // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PCIE_DEVCAP2_CSR_V2, *PVF_PCICFG_PCIE_DEVCAP2_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_DEVCAP2_CSR, sizeof (VF_PCICFG_PCIE_DEVCAP2_CSR_V2) == 4);



typedef struct _CUST_PF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 4;                           // DWORD 0
         u32 cmpl_tmout_disable : 1;              // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 IDO_request_en : 1;                  // DWORD 0
         u32 IDO_cmpl_en : 1;                     // DWORD 0
         u32 rsvd2 : 22;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2, *PCUST_PF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCICFG_PCIE_CONTROL_STATUS2_CSR, sizeof (CUST_PF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2) == 4);



typedef struct _VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 4;                           // DWORD 0
         u32 cmpl_tmout_disable : 1;              // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 IDO_request_en : 1;                  // DWORD 0
         u32 IDO_cmpl_en : 1;                     // DWORD 0
         u32 rsvd2 : 22;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2, *PVF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CONTROL_STATUS2_CSR, sizeof (VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2) == 4);



typedef struct _VF_PCICFG_PCIE_LINK_CAP2_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 1;                           // DWORD 0
         u32 link_speed_vector : 7;               // DWORD 0
         u32 rsvd1 : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PCIE_LINK_CAP2_CSR_V2, *PVF_PCICFG_PCIE_LINK_CAP2_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_CAP2_CSR, sizeof (VF_PCICFG_PCIE_LINK_CAP2_CSR_V2) == 4);



typedef struct _VF_PCICFG_PCIE_LINK_STATUS2_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 16;                          // DWORD 0
         u32 current_de_emphasis : 1;             // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PCIE_LINK_STATUS2_CSR_V2, *PVF_PCICFG_PCIE_LINK_STATUS2_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_STATUS2_CSR, sizeof (VF_PCICFG_PCIE_LINK_STATUS2_CSR_V2) == 4);



typedef struct _CUST_PF_PCICFG_PCIE_LINK_STATUS2_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 16;                          // DWORD 0
         u32 current_de_emphasis : 1;             // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCICFG_PCIE_LINK_STATUS2_CSR_V2, *PCUST_PF_PCICFG_PCIE_LINK_STATUS2_CSR_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCICFG_PCIE_LINK_STATUS2_CSR, sizeof (CUST_PF_PCICFG_PCIE_LINK_STATUS2_CSR_V2) == 4);



typedef struct _VF_PCICFG_RETURN_ZEROS_V2 {
   union {
      struct { 
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_RETURN_ZEROS_V2, *PVF_PCICFG_RETURN_ZEROS_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_RETURN_ZEROS, sizeof (VF_PCICFG_RETURN_ZEROS_V2) == 4);



typedef struct _VF_PCICFG_PF_VF_ERR_A_INT_CSR_V2 {
   union {
      struct { 
         u32 err_intr;                            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PF_VF_ERR_A_INT_CSR_V2, *PVF_PCICFG_PF_VF_ERR_A_INT_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_ERR_A_INT_CSR, sizeof (VF_PCICFG_PF_VF_ERR_A_INT_CSR_V2) == 4);



typedef struct _VF_PCICFG_PF_VF_ERR_B_INT_CSR_V2 {
   union {
      struct { 
         u32 err_intr;                            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PF_VF_ERR_B_INT_CSR_V2, *PVF_PCICFG_PF_VF_ERR_B_INT_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_ERR_B_INT_CSR, sizeof (VF_PCICFG_PF_VF_ERR_B_INT_CSR_V2) == 4);



typedef struct _VF_PCICFG_PF_VF_FLR_INT_CSR_V2 {
   union {
      struct { 
         u32 FLR_intr;                            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PF_VF_FLR_INT_CSR_V2, *PVF_PCICFG_PF_VF_FLR_INT_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_FLR_INT_CSR, sizeof (VF_PCICFG_PF_VF_FLR_INT_CSR_V2) == 4);



typedef struct _CUST_PF_PCICFG_ID_SEL_CSR_V2 {
   union {
      struct { 
         u32 cust_pf0_id_sel : 4;                 // DWORD 0
         u32 cust_pf1_id_sel : 4;                 // DWORD 0
         u32 cust_pf2_id_sel : 4;                 // DWORD 0
         u32 cust_pf3_id_sel : 4;                 // DWORD 0
         u32 cust_pf4_id_sel : 4;                 // DWORD 0
         u32 cust_pf5_id_sel : 4;                 // DWORD 0
         u32 cust_pf6_id_sel : 4;                 // DWORD 0
         u32 cust_pf7_id_sel : 4;                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCICFG_ID_SEL_CSR_V2, *PCUST_PF_PCICFG_ID_SEL_CSR_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCICFG_ID_SEL_CSR, sizeof (CUST_PF_PCICFG_ID_SEL_CSR_V2) == 4);



typedef struct _VF_PCICFG_SLI4_IF_TYPE_CSR_V2 {
   union {
      struct { 
         u32 sli4_if_type : 16;                   // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_SLI4_IF_TYPE_CSR_V2, *PVF_PCICFG_SLI4_IF_TYPE_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_SLI4_IF_TYPE_CSR, sizeof (VF_PCICFG_SLI4_IF_TYPE_CSR_V2) == 4);



typedef struct _VF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2 {
   union {
      struct { 
         u32 tph_req_en_change_intr;              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2, *PVF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR, sizeof (VF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2) == 4);



typedef struct _VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2 {
   union {
      struct { 
         u32 ats_en_change_intr;                  // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2, *PVF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR, sizeof (VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2) == 4);



typedef struct _VF_PCICFG_VF_VPD_REQ_CSR_V2 {
   union {
      struct { 
         u32 req_bits;                            // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_VF_VPD_REQ_CSR_V2, *PVF_PCICFG_VF_VPD_REQ_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_VF_VPD_REQ_CSR, sizeof (VF_PCICFG_VF_VPD_REQ_CSR_V2) == 4);



typedef struct _VF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2 {
   union {
      struct { 
         u32 bmen_state_change;                   // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2, *PVF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_BME_STATE_CHANGE_INT_CSR, sizeof (VF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2) == 4);



typedef struct _VF_PCICFG_BME_CSR_V2 {
   union {
      struct { 
         u32 bme;                                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_BME_CSR_V2, *PVF_PCICFG_BME_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_BME_CSR, sizeof (VF_PCICFG_BME_CSR_V2) == 4);



typedef struct _VF_PCICFG_PF_ATS_EN_CSR_V2 {
   union {
      struct { 
         u32 ats_en;                              // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PF_ATS_EN_CSR_V2, *PVF_PCICFG_PF_ATS_EN_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PF_ATS_EN_CSR, sizeof (VF_PCICFG_PF_ATS_EN_CSR_V2) == 4);



typedef struct _CUST_PF_PCICFG_HOST_INT_MASK2_CSR_V2 {
   union {
      struct { 
         u32 bmen_state_change : 1;               // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 tph_disable : 1;                     // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCICFG_HOST_INT_MASK2_CSR_V2, *PCUST_PF_PCICFG_HOST_INT_MASK2_CSR_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCICFG_HOST_INT_MASK2_CSR, sizeof (CUST_PF_PCICFG_HOST_INT_MASK2_CSR_V2) == 4);



typedef struct _CUST_PF_NEXT_PFNUM_REG0_V2 {
   union {
      struct { 
         u32 next_pf_num;                         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_NEXT_PFNUM_REG0_V2, *PCUST_PF_NEXT_PFNUM_REG0_V2;

SG_C_ASSERT(__sizeof__CUST_PF_NEXT_PFNUM_REG0, sizeof (CUST_PF_NEXT_PFNUM_REG0_V2) == 4);



typedef struct _CUST_PF_NEXT_PFNUM_REG1_V2 {
   union {
      struct { 
         u32 next_pf_num;                         // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_NEXT_PFNUM_REG1_V2, *PCUST_PF_NEXT_PFNUM_REG1_V2;

SG_C_ASSERT(__sizeof__CUST_PF_NEXT_PFNUM_REG1, sizeof (CUST_PF_NEXT_PFNUM_REG1_V2) == 4);



typedef struct _CUST_PF_NEXT_PFNUM_VALID_V2 {
   union {
      struct { 
         u32 next_pf_valid : 16;                  // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_NEXT_PFNUM_VALID_V2, *PCUST_PF_NEXT_PFNUM_VALID_V2;

SG_C_ASSERT(__sizeof__CUST_PF_NEXT_PFNUM_VALID, sizeof (CUST_PF_NEXT_PFNUM_VALID_V2) == 4);



typedef struct _VF_PCICFG_HOST_INT_MASK2_CSR_V2 {
   union {
      struct { 
         u32 bmen_state_change : 1;               // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 tph_disable : 1;                     // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_HOST_INT_MASK2_CSR_V2, *PVF_PCICFG_HOST_INT_MASK2_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_MASK2_CSR, sizeof (VF_PCICFG_HOST_INT_MASK2_CSR_V2) == 4);



typedef struct _VF_PCICFG_HOST_INT_STATUS2_CSR_V2 {
   union {
      struct { 
         u32 bmen_state_change : 1;               // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 sliport_error2 : 1;                  // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_HOST_INT_STATUS2_CSR_V2, *PVF_PCICFG_HOST_INT_STATUS2_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_STATUS2_CSR, sizeof (VF_PCICFG_HOST_INT_STATUS2_CSR_V2) == 4);



typedef struct _VF_PCICFG_HOST_INT_STATUS_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 1;                           // DWORD 0
         u32 err_a : 1;                           // DWORD 0
         u32 err_b : 1;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 ats_en_change_intr : 1;              // DWORD 0
         u32 rsvd3 : 4;                           // DWORD 0
         u32 tph_req_en_change_intr : 1;          // DWORD 0
         u32 rsvd4 : 2;                           // DWORD 0
         u32 rsvd5 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_HOST_INT_STATUS_CSR_V2, *PVF_PCICFG_HOST_INT_STATUS_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_STATUS_CSR, sizeof (VF_PCICFG_HOST_INT_STATUS_CSR_V2) == 4);



typedef struct _CUST_PF_PCICFG_HOST_INT_MASK_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 1;                           // DWORD 0
         u32 err_a : 1;                           // DWORD 0
         u32 err_b : 1;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 ats_en_change_intr : 1;              // DWORD 0
         u32 rsvd4 : 5;                           // DWORD 0
         u32 tph_req_en_change_intr : 1;          // DWORD 0
         u32 rsvd5 : 1;                           // DWORD 0
         u32 rsvd6 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCICFG_HOST_INT_MASK_CSR_V2, *PCUST_PF_PCICFG_HOST_INT_MASK_CSR_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCICFG_HOST_INT_MASK_CSR, sizeof (CUST_PF_PCICFG_HOST_INT_MASK_CSR_V2) == 4);



typedef struct _VF_PCICFG_HOST_INT_MASK_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 1;                           // DWORD 0
         u32 err_a : 1;                           // DWORD 0
         u32 err_b : 1;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 ats_en_change_intr : 1;              // DWORD 0
         u32 rsvd4 : 5;                           // DWORD 0
         u32 tph_req_en_change_intr : 1;          // DWORD 0
         u32 rsvd5 : 1;                           // DWORD 0
         u32 rsvd6 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_HOST_INT_MASK_CSR_V2, *PVF_PCICFG_HOST_INT_MASK_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_MASK_CSR, sizeof (VF_PCICFG_HOST_INT_MASK_CSR_V2) == 4);



typedef struct _CUST_PF_PCIE_ARI_ENHANCED_CAP_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCIE_ARI_ENHANCED_CAP_V2, *PCUST_PF_PCIE_ARI_ENHANCED_CAP_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCIE_ARI_ENHANCED_CAP, sizeof (CUST_PF_PCIE_ARI_ENHANCED_CAP_V2) == 4);



typedef struct _VF_PCIE_ARI_ENHANCED_CAP_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCIE_ARI_ENHANCED_CAP_V2, *PVF_PCIE_ARI_ENHANCED_CAP_V2;

SG_C_ASSERT(__sizeof__VF_PCIE_ARI_ENHANCED_CAP, sizeof (VF_PCIE_ARI_ENHANCED_CAP_V2) == 4);



typedef struct _VF_PCIE_ARI_CAPABILITY_V2 {
   union {
      struct { 
         u32 mfvc_fg_capability : 1;              // DWORD 0
         u32 acs_fg_capability : 1;               // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 next_fun_num : 8;                    // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCIE_ARI_CAPABILITY_V2, *PVF_PCIE_ARI_CAPABILITY_V2;

SG_C_ASSERT(__sizeof__VF_PCIE_ARI_CAPABILITY, sizeof (VF_PCIE_ARI_CAPABILITY_V2) == 4);



typedef struct _CUST_PF_PCIE_DEV_SERIAL_CAP_HDR_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCIE_DEV_SERIAL_CAP_HDR_V2, *PCUST_PF_PCIE_DEV_SERIAL_CAP_HDR_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCIE_DEV_SERIAL_CAP_HDR, sizeof (CUST_PF_PCIE_DEV_SERIAL_CAP_HDR_V2) == 4);



typedef struct _VF_PCIE_DEV_SERIAL_CAP_HDR_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCIE_DEV_SERIAL_CAP_HDR_V2, *PVF_PCIE_DEV_SERIAL_CAP_HDR_V2;

SG_C_ASSERT(__sizeof__VF_PCIE_DEV_SERIAL_CAP_HDR, sizeof (VF_PCIE_DEV_SERIAL_CAP_HDR_V2) == 4);



typedef struct _VF_PCIE_DEV_SERIAL_NUM_LOW_V2 {
   union {
      struct { 
         u32 slnum_low;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCIE_DEV_SERIAL_NUM_LOW_V2, *PVF_PCIE_DEV_SERIAL_NUM_LOW_V2;

SG_C_ASSERT(__sizeof__VF_PCIE_DEV_SERIAL_NUM_LOW, sizeof (VF_PCIE_DEV_SERIAL_NUM_LOW_V2) == 4);



typedef struct _VF_PCIE_DEV_SERIAL_NUM_HIGH_V2 {
   union {
      struct { 
         u32 slnum_high;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCIE_DEV_SERIAL_NUM_HIGH_V2, *PVF_PCIE_DEV_SERIAL_NUM_HIGH_V2;

SG_C_ASSERT(__sizeof__VF_PCIE_DEV_SERIAL_NUM_HIGH, sizeof (VF_PCIE_DEV_SERIAL_NUM_HIGH_V2) == 4);



typedef struct _VF_PCIE_TPH_REQ_CAP_HDR_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCIE_TPH_REQ_CAP_HDR_V2, *PVF_PCIE_TPH_REQ_CAP_HDR_V2;

SG_C_ASSERT(__sizeof__VF_PCIE_TPH_REQ_CAP_HDR, sizeof (VF_PCIE_TPH_REQ_CAP_HDR_V2) == 4);



typedef struct _VF_PCIE_TPH_CAPABILITY_V2 {
   union {
      struct { 
         u32 no_st_mode : 1;                      // DWORD 0
         u32 intr_vec_mode : 1;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
         u32 st_tbl_loc : 2;                      // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
         u32 st_tbl_size : 11;                    // DWORD 0
         u32 rsvd3 : 5;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCIE_TPH_CAPABILITY_V2, *PVF_PCIE_TPH_CAPABILITY_V2;

SG_C_ASSERT(__sizeof__VF_PCIE_TPH_CAPABILITY, sizeof (VF_PCIE_TPH_CAPABILITY_V2) == 4);



typedef struct _VF_PCIE_TPH_CONTROL_V2 {
   union {
      struct { 
         u32 st_mode_sel : 3;                     // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 tph_req_enable : 2;                  // DWORD 0
         u32 rsvd1 : 22;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCIE_TPH_CONTROL_V2, *PVF_PCIE_TPH_CONTROL_V2;

SG_C_ASSERT(__sizeof__VF_PCIE_TPH_CONTROL, sizeof (VF_PCIE_TPH_CONTROL_V2) == 4);



typedef struct _VF_PCIE_ATS_ENHANCED_CAP_V2 {
   union {
      struct { 
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCIE_ATS_ENHANCED_CAP_V2, *PVF_PCIE_ATS_ENHANCED_CAP_V2;

SG_C_ASSERT(__sizeof__VF_PCIE_ATS_ENHANCED_CAP, sizeof (VF_PCIE_ATS_ENHANCED_CAP_V2) == 4);



typedef struct _CUST_PF_PCIE_ATS_CAPABILITY_V2 {
   union {
      struct { 
         u32 inval_queue_depth : 5;               // DWORD 0
         u32 page_align_request : 1;              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 stu : 5;                             // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
         u32 ats_en : 1;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCIE_ATS_CAPABILITY_V2, *PCUST_PF_PCIE_ATS_CAPABILITY_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCIE_ATS_CAPABILITY, sizeof (CUST_PF_PCIE_ATS_CAPABILITY_V2) == 4);



typedef struct _VF_PCIE_ATS_CAPABILITY_V2 {
   union {
      struct { 
         u32 inval_queue_depth : 5;               // DWORD 0
         u32 page_align_request : 1;              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 stu : 5;                             // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
         u32 ats_en : 1;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCIE_ATS_CAPABILITY_V2, *PVF_PCIE_ATS_CAPABILITY_V2;

SG_C_ASSERT(__sizeof__VF_PCIE_ATS_CAPABILITY, sizeof (VF_PCIE_ATS_CAPABILITY_V2) == 4);



typedef struct _VF_PCICFG_PMC_CSR_V2 {
   union {
      struct { 
         u32 pmcapid : 8;                         // DWORD 0
         u32 pmnextptr : 8;                       // DWORD 0
         u32 version : 3;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 dsi : 1;                             // DWORD 0
         u32 aux_current : 3;                     // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 rsvd4 : 5;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PMC_CSR_V2, *PVF_PCICFG_PMC_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PMC_CSR, sizeof (VF_PCICFG_PMC_CSR_V2) == 4);



typedef struct _VF_PCICFG_PM_CONTROL_V2 {
   union {
      struct { 
         u32 pwr_state : 2;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 device_specific : 1;                 // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 rsvd2 : 24;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_PM_CONTROL_V2, *PVF_PCICFG_PM_CONTROL_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_PM_CONTROL, sizeof (VF_PCICFG_PM_CONTROL_V2) == 4);



typedef struct _VF_PCICFG_MSIX_VECTOR_CONTROL_CSR_V2 {
   union {
      struct { 
         u32 mask : 1;                            // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 st_lower : 8;                        // DWORD 0
         u32 st_upper : 8;                        // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_MSIX_VECTOR_CONTROL_CSR_V2, *PVF_PCICFG_MSIX_VECTOR_CONTROL_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_VECTOR_CONTROL_CSR, sizeof (VF_PCICFG_MSIX_VECTOR_CONTROL_CSR_V2) == 4);



typedef struct _VF_PCICFG_MSIX_MSG_DATA_CSR_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_MSIX_MSG_DATA_CSR_V2, *PVF_PCICFG_MSIX_MSG_DATA_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_MSG_DATA_CSR, sizeof (VF_PCICFG_MSIX_MSG_DATA_CSR_V2) == 4);



typedef struct _VF_PCICFG_MSIX_MSG_ADDR_HI_CSR_V2 {
   union {
      struct { 
         u32 addr;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_MSIX_MSG_ADDR_HI_CSR_V2, *PVF_PCICFG_MSIX_MSG_ADDR_HI_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_MSG_ADDR_HI_CSR, sizeof (VF_PCICFG_MSIX_MSG_ADDR_HI_CSR_V2) == 4);



typedef struct _VF_PCICFG_MSIX_MSG_ADDR_LO_CSR_V2 {
   union {
      struct { 
         u32 rsvd0 : 2;                           // DWORD 0
         u32 addr : 30;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_MSIX_MSG_ADDR_LO_CSR_V2, *PVF_PCICFG_MSIX_MSG_ADDR_LO_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_MSG_ADDR_LO_CSR, sizeof (VF_PCICFG_MSIX_MSG_ADDR_LO_CSR_V2) == 4);



typedef struct _VF_PCICFG_MSIX_PBA_STRUCT_CSR_V2 {
   union {
      struct { 
         u32 pba;                                 // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_MSIX_PBA_STRUCT_CSR_V2, *PVF_PCICFG_MSIX_PBA_STRUCT_CSR_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_PBA_STRUCT_CSR, sizeof (VF_PCICFG_MSIX_PBA_STRUCT_CSR_V2) == 4);



typedef struct _CUST_PF_PCICFG_CSRMAP_V2 {
   union {
      struct { 
         VF_PCICFG_ID_CSR_V2 id;
         CUST_PCICFG_COMMAND_STATUS_CSR_V2 cmd_status;
         VF_PCICFG_CLASS_REV_CSR_V2 class_rev;
         VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2 cache;
         CUST_PCICFG_MEMBAR0_LO_CSR_V2 membar0_lo;
         CUST_PCICFG_MEMBAR0_HI_CSR_V2 membar0_hi;
         u32 rsvd0[4];                            // DWORDS 6 to 9
         u32 rsvd1[1];                            // DWORDS 10 to 10
         VF_PCICFG_SUBSYSTEM_ID_CSR_V2 subsystem_id;
         u32 rsvd2[1];                            // DWORDS 12 to 12
         VF_PCICFG_CAP_CSR_V2 cap;
         u32 rsvd3[1];                            // DWORDS 14 to 14
         CUST_PF_PCICFG_LATENCY_INT_CSR_V2 latency_int;
         VF_PCICFG_PMC_CSR_V2 pmc;
         VF_PCICFG_PM_CONTROL_V2 pm_control;
         VF_PCICFG_MSIX_CSR_V2 msix;
         VF_PCICFG_MSIX_TABLE_CSR_V2 msix_table_offset;
         VF_PCICFG_MSIX_PBA_CSR_V2 msix_pba_offset;
         u32 rsvd4[1];                            // DWORDS 21 to 21
         u32 rsvd5[1];                            // DWORDS 22 to 22
         u32 rsvd6[9];                            // DWORDS 23 to 31
         u32 rsvd7[14];                           // DWORDS 32 to 45
         VF_PCICFG_VPD_CAP_CSR_V2 vpd_cap;
         VF_PCICFG_VPD_DATA_CSR_V2 vpd_data;
         VF_PCICFG_PCIE_CAP_CSR_V2 pcie_cap;
         VF_PCICFG_PCIE_DEVCAP_CSR_V2 pcie_devcap;
         VF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2 pcie_control_status;
         VF_PCICFG_PCIE_LINK_CAP_CSR_V2 pcie_link_cap;
         CUST_PF_PCICFG_PCIE_LINK_STATUS_CSR_V2 pcie_link_status;
         VF_PCICFG_RETURN_ZEROS_V2 return_zeros[4];
         VF_PCICFG_PCIE_DEVCAP2_CSR_V2 pcie_devcap2;
         CUST_PF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2 pcie_control_status2;
         VF_PCICFG_PCIE_LINK_CAP2_CSR_V2 pcie_link_cap2;
         CUST_PF_PCICFG_PCIE_LINK_STATUS2_CSR_V2 pcie_link_status2;
         VF_PCICFG_RETURN_ZEROS_V2 return_zeros_1[2];
         VF_PCICFG_INT_CTRL_FUNCTION_NUM_V2 host_int_ctrl_vf_fnum;
         CUST_PF_PCIE_ARI_ENHANCED_CAP_V2 pcie_ari_enhanced_hdr;
         VF_PCIE_ARI_CAPABILITY_V2 pcie_ari_capability;
         u32 rsvd8[9];                            // DWORDS 66 to 74
         VF_PCIE_TPH_REQ_CAP_HDR_V2 pcie_tph_req_caphdr;
         VF_PCIE_TPH_CAPABILITY_V2 pcie_tph_capability;
         VF_PCIE_TPH_CONTROL_V2 pcie_tph_control;
         u32 rsvd9[3];                            // DWORDS 78 to 80
         VF_PCIE_ATS_ENHANCED_CAP_V2 pcie_ats_enhanced_hdr;
         CUST_PF_PCIE_ATS_CAPABILITY_V2 pcie_ats_capability;
         u32 rsvd10[7];                           // DWORDS 83 to 89
         CUST_PF_PCIE_DEV_SERIAL_CAP_HDR_V2 pcie_device_serial_hdr;
         VF_PCIE_DEV_SERIAL_NUM_LOW_V2 pcie_device_serial_number_low;
         VF_PCIE_DEV_SERIAL_NUM_HIGH_V2 pcie_device_serial_number_high;
         VF_PCICFG_HOST_INT_STATUS_CSR_V2 host_int_status;
         CUST_PF_PCICFG_HOST_INT_MASK_CSR_V2 host_int_mask;
         VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2 host_pf_vf_ats_en_int;
         VF_PCICFG_PF_VF_FLR_INT_CSR_V2 host_pf_vf_flr_int;
         VF_PCICFG_PF_VF_ERR_A_INT_CSR_V2 host_pf_vf_err_a_int;
         VF_PCICFG_PF_VF_ERR_B_INT_CSR_V2 host_pf_vf_err_b_int;
         VF_PCICFG_VF_VPD_REQ_CSR_V2 host_pf_vf_vpd_req;
         VF_PCICFG_BME_CSR_V2 host_pf_vf_bme;
         VF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2 host_pf_vf_tph_req_en_int;
         CUST_PF_PCICFG_ID_SEL_CSR_V2 id_sel[2];
         VF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2 host_pf_vf_bmen_state_change_int;
         u32 rsvd11[18];                          // DWORDS 105 to 122
         VF_PCICFG_SCRATCHPAD_CSR_V2 scratchpad;
         u32 rsvd12[4];                           // DWORDS 124 to 127
         VF_PCICFG_FUNCTION_IDENTIFIER_V2 func_id;
         u32 rsvd13[63];                          // DWORDS 129 to 191
         u32 rsvd14[11];                          // DWORDS 192 to 202
         VF_PCICFG_HOST_INT_STATUS2_CSR_V2 host_int_status2;
         CUST_PF_PCICFG_HOST_INT_MASK2_CSR_V2 host_int_mask2;
         CUST_PF_NEXT_PFNUM_REG0_V2 next_pfnum0;
         CUST_PF_NEXT_PFNUM_REG1_V2 next_pfnum1;
         CUST_PF_NEXT_PFNUM_VALID_V2 next_pf_valid;
         u32 rsvd15[48];                          // DWORDS 208 to 255
         u32 rsvd16[768];                         // DWORDS 256 to 1023
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCICFG_CSRMAP_V2, *PCUST_PF_PCICFG_CSRMAP_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCICFG_CSRMAP, sizeof (CUST_PF_PCICFG_CSRMAP_V2) == 4096);



typedef struct _VF_PCICFG_CSRMAP_V2 {
   union {
      struct { 
         VF_PCICFG_ID_CSR_V2 id;
         VF_PCICFG_COMMAND_STATUS_CSR_V2 cmd_status;
         VF_PCICFG_CLASS_REV_CSR_V2 class_rev;
         VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_V2 cache;
         u32 rsvd0[6];                            // DWORDS 4 to 9
         u32 rsvd1[1];                            // DWORDS 10 to 10
         VF_PCICFG_SUBSYSTEM_ID_CSR_V2 subsystem_id;
         u32 rsvd2[1];                            // DWORDS 12 to 12
         VF_PCICFG_CAP_CSR_V2 cap;
         u32 rsvd3[1];                            // DWORDS 14 to 14
         u32 rsvd4[1];                            // DWORDS 15 to 15
         VF_PCICFG_PMC_CSR_V2 pmc;
         VF_PCICFG_PM_CONTROL_V2 pm_control;
         VF_PCICFG_MSIX_CSR_V2 msix;
         VF_PCICFG_MSIX_TABLE_CSR_V2 msix_table_offset;
         VF_PCICFG_MSIX_PBA_CSR_V2 msix_pba_offset;
         u32 rsvd5[1];                            // DWORDS 21 to 21
         u32 rsvd6[1];                            // DWORDS 22 to 22
         u32 rsvd7[9];                            // DWORDS 23 to 31
         u32 rsvd8[14];                           // DWORDS 32 to 45
         VF_PCICFG_VPD_CAP_CSR_V2 vpd_cap;
         VF_PCICFG_VPD_DATA_CSR_V2 vpd_data;
         VF_PCICFG_PCIE_CAP_CSR_V2 pcie_cap;
         VF_PCICFG_PCIE_DEVCAP_CSR_V2 pcie_devcap;
         VF_PCICFG_PCIE_CONTROL_STATUS_CSR_V2 pcie_control_status;
         VF_PCICFG_PCIE_LINK_CAP_CSR_V2 pcie_link_cap;
         VF_PCICFG_PCIE_LINK_STATUS_CSR_V2 pcie_link_status;
         VF_PCICFG_RETURN_ZEROS_V2 return_zeros[4];
         VF_PCICFG_PCIE_DEVCAP2_CSR_V2 pcie_devcap2;
         VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_V2 pcie_control_status2;
         VF_PCICFG_PCIE_LINK_CAP2_CSR_V2 pcie_link_cap2;
         VF_PCICFG_PCIE_LINK_STATUS2_CSR_V2 pcie_link_status2;
         VF_PCICFG_RETURN_ZEROS_V2 return_zeros_1[2];
         VF_PCICFG_INT_CTRL_FUNCTION_NUM_V2 host_int_ctrl_vf_fnum;
         VF_PCIE_ARI_ENHANCED_CAP_V2 pcie_ari_enhanced_hdr;
         VF_PCIE_ARI_CAPABILITY_V2 pcie_ari_capability;
         u32 rsvd9[9];                            // DWORDS 66 to 74
         VF_PCIE_TPH_REQ_CAP_HDR_V2 pcie_tph_req_caphdr;
         VF_PCIE_TPH_CAPABILITY_V2 pcie_tph_capability;
         VF_PCIE_TPH_CONTROL_V2 pcie_tph_control;
         u32 rsvd10[3];                           // DWORDS 78 to 80
         VF_PCIE_ATS_ENHANCED_CAP_V2 pcie_ats_enhanced_hdr;
         VF_PCIE_ATS_CAPABILITY_V2 pcie_ats_capability;
         u32 rsvd11[8];                           // DWORDS 83 to 90
         u32 rsvd12[2];                           // DWORDS 91 to 92
         VF_PCICFG_HOST_INT_STATUS_CSR_V2 host_int_status;
         VF_PCICFG_HOST_INT_MASK_CSR_V2 host_int_mask;
         VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_V2 host_pf_vf_ats_en_int;
         VF_PCICFG_PF_VF_FLR_INT_CSR_V2 host_pf_vf_flr_int;
         VF_PCICFG_PF_VF_ERR_A_INT_CSR_V2 host_pf_vf_err_a_int;
         VF_PCICFG_PF_VF_ERR_B_INT_CSR_V2 host_pf_vf_err_b_int;
         VF_PCICFG_VF_VPD_REQ_CSR_V2 host_pf_vf_vpd_req;
         VF_PCICFG_BME_CSR_V2 host_pf_vf_bme;
         VF_PCICFG_TPH_REQ_EN_CHANGE_INT_CSR_V2 host_pf_vf_tph_req_en_int;
         u32 rsvd13[2];                           // DWORDS 102 to 103
         VF_PCICFG_BME_STATE_CHANGE_INT_CSR_V2 host_pf_vf_bmen_state_change_int;
         u32 rsvd14[17];                          // DWORDS 105 to 121
         VF_PCICFG_SLI4_IF_TYPE_CSR_V2 vf_sli4_if_type;
         VF_PCICFG_SCRATCHPAD_CSR_V2 scratchpad;
         VF_MSITBL_SIZE_CSR_V2 msixtbl_size;
         u32 rsvd15[3];                           // DWORDS 125 to 127
         VF_PCICFG_FUNCTION_IDENTIFIER_V2 func_id;
         u32 rsvd16[63];                          // DWORDS 129 to 191
         u32 rsvd17[11];                          // DWORDS 192 to 202
         VF_PCICFG_HOST_INT_STATUS2_CSR_V2 host_int_status2;
         VF_PCICFG_HOST_INT_MASK2_CSR_V2 host_int_mask2;
         u32 rsvd18[51];                          // DWORDS 205 to 255
         u32 rsvd19[768];                         // DWORDS 256 to 1023
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_CSRMAP_V2, *PVF_PCICFG_CSRMAP_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_CSRMAP, sizeof (VF_PCICFG_CSRMAP_V2) == 4096);



typedef struct _VF_PCICFG_CSRMAP_PF_8VF_V2 {
   union {
      struct { 
         VF_PCICFG_CSRMAP_V2 pf_8vfs[8];
      } SG_PACK ; // unnamed struct
      u32 dw[8192]; // dword union
   }; // unnamed union
} SG_PACK VF_PCICFG_CSRMAP_PF_8VF_V2, *PVF_PCICFG_CSRMAP_PF_8VF_V2;

SG_C_ASSERT(__sizeof__VF_PCICFG_CSRMAP_PF_8VF, sizeof (VF_PCICFG_CSRMAP_PF_8VF_V2) == 32768);



typedef struct _CUST_PF_PCICFG_CSRMAP_8PF_V2 {
   union {
      struct { 
         CUST_PF_PCICFG_CSRMAP_V2 cust_8pfs[8];
      } SG_PACK ; // unnamed struct
      u32 dw[8192]; // dword union
   }; // unnamed union
} SG_PACK CUST_PF_PCICFG_CSRMAP_8PF_V2, *PCUST_PF_PCICFG_CSRMAP_8PF_V2;

SG_C_ASSERT(__sizeof__CUST_PF_PCICFG_CSRMAP_8PF, sizeof (CUST_PF_PCICFG_CSRMAP_8PF_V2) == 32768);


// --- ROCE_OPERATION ---
#define ROCE_OPERATION_RDMA_WRITE_REQ_V2 (0)      
#define ROCE_OPERATION_RDMA_READ_REQ_V2 (1)       
#define ROCE_OPERATION_RDMA_READ_RESP_V2 (2)      
#define ROCE_OPERATION_SEND_V2          (3)       
#define ROCE_OPERATION_BIND_MEMORY_WINDOW_V2 (8)  
#define ROCE_OPERATION_FAST_REGISTER_V2 (9)       
#define ROCE_OPERATION_POST_RQ_V2       (10)      
#define ROCE_OPERATION_LOCAL_INVALIDATE_V2 (11)   

// --- ROCE_OPERATION_TYPE ---
#define ROCE_OPERATION_TYPE_SGE_V2      (0)       
#define ROCE_OPERATION_TYPE_IMMEDIATE_V2 (3)      


typedef struct _ROCE_TX_SGE_V2 {
   union {
      struct { 
         u32 va_hi;                               // DWORD 0
         u32 va_lo;                               // DWORD 1
         u32 key;                                 // DWORD 2
         u32 length;                              // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_TX_SGE_V2, *PROCE_TX_SGE_V2;

SG_C_ASSERT(__sizeof__ROCE_TX_SGE, sizeof (ROCE_TX_SGE_V2) == 16);



typedef struct _ROCE_UD_FIRST_SGE_V2 {
   union {
      struct { 
         u32 dest_qp_no : 24;                     // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 QKey;                                // DWORD 1
         u32 addr_handle_id;                      // DWORD 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_UD_FIRST_SGE_V2, *PROCE_UD_FIRST_SGE_V2;

SG_C_ASSERT(__sizeof__ROCE_UD_FIRST_SGE, sizeof (ROCE_UD_FIRST_SGE_V2) == 16);


// --- ROCE_OPERATION_FLAGS ---
#define ROCE_OPERATION_FLAG_SIGNALED_V2 (1)       
#define ROCE_OPERATION_FLAG_INVALIDATE_V2 (2)     
#define ROCE_OPERATION_FLAG_FENCE_LOCAL_V2 (4)    
#define ROCE_OPERATION_FLAG_FENCE_REMOTE_V2 (8)   
#define ROCE_OPERATION_FLAG_SE_V2       (16)      
#define ROCE_OPERATION_FLAG_IMMEDIATE_V2 (32)     

// --- ROCE_WRB_TYPE ---
#define ROCE_WRB_TYPE_INLINE_V2         (0)       
#define ROCE_WRB_TYPE_SGE_V2            (1)       
#define ROCE_WRB_TYPE_RSVD0_V2          (2)       
#define ROCE_WRB_TYPE_RSVD1_V2          (3)       

// --- ROCETX_OPCODE ---
#define ROCETX_OP_SEND_V2               (0)       
#define ROCETX_OP_RDMA_WRITE_V2         (6)       
#define ROCETX_OP_RDMA_READ_V2          (12)      
#define ROCETX_OP_RDMA_READ_RESP_V2     (13)      
#define ROCETX_OP_BIND_MEMORY_WIN_V2    (16)      
#define ROCETX_OP_FAST_REGISTER_V2      (17)      
#define ROCETX_OP_LOCAL_INVAL_V2        (21)      


typedef struct _ROCE_RC_TX_CONTROL_V2 {
   union {
      struct { 
         u32 opcode : 5;                          // DWORD 0
         u32 flags : 11;                          // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 posting_size : 7;                    // DWORD 0
         u32 next_posting_size : 7;               // DWORD 0
         u32 rsvd0[1];                            // DWORDS 1 to 1
         u32 memkey_or_imm_data;                  // DWORD 2
         u32 total_byte_count;                    // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RC_TX_CONTROL_V2, *PROCE_RC_TX_CONTROL_V2;

SG_C_ASSERT(__sizeof__ROCE_RC_TX_CONTROL, sizeof (ROCE_RC_TX_CONTROL_V2) == 16);



typedef struct _ROCE_RC_OPERATION_RDMA_WRITE_V2 {
   union {
      struct { 
         ROCE_RC_TX_CONTROL_V2 control;
         ROCE_TX_SGE_V2 remote_address;
         ROCE_TX_SGE_V2 sge[2];
      } SG_PACK ; // unnamed struct
      u32 dw[16]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RC_OPERATION_RDMA_WRITE_V2, *PROCE_RC_OPERATION_RDMA_WRITE_V2;

SG_C_ASSERT(__sizeof__ROCE_RC_OPERATION_RDMA_WRITE, sizeof (ROCE_RC_OPERATION_RDMA_WRITE_V2) == 64);



typedef struct _ROCE_RC_OPERATION_READ_REQ_V2 {
   union {
      struct { 
         ROCE_RC_TX_CONTROL_V2 control;
         ROCE_TX_SGE_V2 remote_address;
         ROCE_TX_SGE_V2 sge[2];
      } SG_PACK ; // unnamed struct
      u32 dw[16]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RC_OPERATION_READ_REQ_V2, *PROCE_RC_OPERATION_READ_REQ_V2;

SG_C_ASSERT(__sizeof__ROCE_RC_OPERATION_READ_REQ, sizeof (ROCE_RC_OPERATION_READ_REQ_V2) == 64);



typedef struct _ROCE_RC_OPERATION_READ_RESP_V2 {
   union {
      struct { 
         ROCE_RC_TX_CONTROL_V2 control;
         ROCE_TX_SGE_V2 local_address;
      } SG_PACK ; // unnamed struct
      u32 dw[8]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RC_OPERATION_READ_RESP_V2, *PROCE_RC_OPERATION_READ_RESP_V2;

SG_C_ASSERT(__sizeof__ROCE_RC_OPERATION_READ_RESP, sizeof (ROCE_RC_OPERATION_READ_RESP_V2) == 32);



typedef struct _ROCE_RC_OPERATION_SEND_V2 {
   union {
      struct { 
         ROCE_RC_TX_CONTROL_V2 control;
         ROCE_TX_SGE_V2 sge[3];
      } SG_PACK ; // unnamed struct
      u32 dw[16]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RC_OPERATION_SEND_V2, *PROCE_RC_OPERATION_SEND_V2;

SG_C_ASSERT(__sizeof__ROCE_RC_OPERATION_SEND, sizeof (ROCE_RC_OPERATION_SEND_V2) == 64);



typedef struct _ROCE_RC_OPERATION_BIND_MEMORY_WINDOW_V2 {
   union {
      struct { 
         ROCE_RC_TX_CONTROL_V2 control;
         ROCE_TX_SGE_V2 local_address;
      } SG_PACK ; // unnamed struct
      u32 dw[8]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RC_OPERATION_BIND_MEMORY_WINDOW_V2, *PROCE_RC_OPERATION_BIND_MEMORY_WINDOW_V2;

SG_C_ASSERT(__sizeof__ROCE_RC_OPERATION_BIND_MEMORY_WINDOW, sizeof (ROCE_RC_OPERATION_BIND_MEMORY_WINDOW_V2) == 32);



typedef struct _ROCE_RC_OPERATION_FAST_REGISTER_V2 {
   union {
      struct { 
         ROCE_RC_TX_CONTROL_V2 control;
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RC_OPERATION_FAST_REGISTER_V2, *PROCE_RC_OPERATION_FAST_REGISTER_V2;

SG_C_ASSERT(__sizeof__ROCE_RC_OPERATION_FAST_REGISTER, sizeof (ROCE_RC_OPERATION_FAST_REGISTER_V2) == 16);



typedef struct _ROCE_RC_OPERATION_LOCAL_INVALIDATE_V2 {
   union {
      struct { 
         ROCE_RC_TX_CONTROL_V2 control;
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RC_OPERATION_LOCAL_INVALIDATE_V2, *PROCE_RC_OPERATION_LOCAL_INVALIDATE_V2;

SG_C_ASSERT(__sizeof__ROCE_RC_OPERATION_LOCAL_INVALIDATE, sizeof (ROCE_RC_OPERATION_LOCAL_INVALIDATE_V2) == 16);



typedef struct _ROCE_UD_TX_CONTROL_V2 {
   union {
      struct { 
         u32 opcode : 4;                          // DWORD 0
         u32 flags : 10;                          // DWORD 0
         u32 next_length : 5;                     // DWORD 0
         u32 type : 3;                            // DWORD 0
         u32 num_words : 5;                       // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 address_handle;                      // DWORD 1
         u32 immediate_data;                      // DWORD 2
         u32 total_byte_count;                    // DWORD 3
         u32 remote_qpn : 24;                     // DWORD 4
         u32 rsvd1 : 8;                           // DWORD 4
         u32 remote_qkey;                         // DWORD 5
         u32 rsvd2[2];                            // DWORDS 6 to 7
      } SG_PACK ; // unnamed struct
      u32 dw[8]; // dword union
   }; // unnamed union
} SG_PACK ROCE_UD_TX_CONTROL_V2, *PROCE_UD_TX_CONTROL_V2;

SG_C_ASSERT(__sizeof__ROCE_UD_TX_CONTROL, sizeof (ROCE_UD_TX_CONTROL_V2) == 32);



typedef struct _ROCE_UD_OPERATION_SEND_V2 {
   union {
      struct { 
         ROCE_UD_TX_CONTROL_V2 control;
         ROCE_TX_SGE_V2 sge[2];
      } SG_PACK ; // unnamed struct
      u32 dw[16]; // dword union
   }; // unnamed union
} SG_PACK ROCE_UD_OPERATION_SEND_V2, *PROCE_UD_OPERATION_SEND_V2;

SG_C_ASSERT(__sizeof__ROCE_UD_OPERATION_SEND, sizeof (ROCE_UD_OPERATION_SEND_V2) == 64);


// --- ROCE_TX_STATUS ---
#define ROCE_TX_STATUS_SUCCESS_V2       (0)       
#define ROCE_TX_STATUS_LENGTH_ERROR_V2  (1)       
#define ROCE_TX_STATUS_LOCAL_OPERATION_ERROR_V2 (2) 
#define ROCE_TX_STATUS_LOCAL_PROTECTION_ERROR_V2 (3) 
#define ROCE_TX_STATUS_NAK_V2           (4)       
#define ROCE_TX_STATUS_TX_FLUSHED_V2    (5)       
#define ROCE_TX_STATUS_RNR_NAK_EXCEEDED_V2 (6)    
#define ROCE_TX_STATUS_RETRY_COUNT_EXCEEDED_V2 (7) 

// --- ROCE_NAK_CODE ---
#define ROCE_NAK_CODE_PSN_ERROR_V2      (0)       

// --- ROCE_TIMER_SET ---
#define ROCE_RNR_TIMER_SET_V2           (6)       
#define ROCE_RETRANSMIT_TIMER_SET_V2    (7)       

// --- ROCE_TIMER_CLEAR ---
#define ROCE_RETRANSMIT_TIMER_CLEAR_V2  (1)       
#define ROCE_RNR_TIMER_CLEAR_V2         (2)       


typedef struct _ROCE_TX_CQE_V2 {
   union {
      struct { 
         u32 wqe_index : 16;                      // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 bytes_transferred;                   // DWORD 1
         u32 qpn : 16;                            // DWORD 2
         u32 rsvd1 : 16;                          // DWORD 2
         u32 rsvd2 : 16;                          // DWORD 3
         u32 status : 8;                          // DWORD 3
         u32 rsvd3 : 5;                           // DWORD 3
         u32 q : 1;                               // DWORD 3
         u32 rsvd4 : 1;                           // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_TX_CQE_V2, *PROCE_TX_CQE_V2;

SG_C_ASSERT(__sizeof__ROCE_TX_CQE, sizeof (ROCE_TX_CQE_V2) == 16);



typedef struct _ROCE_TX_UD_CQE_V2 {
   union {
      struct { 
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 qpn : 16;                            // DWORD 2
         u32 wqe_index : 16;                      // DWORD 2
         u32 cc : 2;                              // DWORD 3
         u32 rsvd2 : 14;                          // DWORD 3
         u32 status : 8;                          // DWORD 3
         u32 rsvd3 : 7;                           // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_TX_UD_CQE_V2, *PROCE_TX_UD_CQE_V2;

SG_C_ASSERT(__sizeof__ROCE_TX_UD_CQE, sizeof (ROCE_TX_UD_CQE_V2) == 16);



typedef struct _ROCE_DPP_CQE_V2 {
   union {
      struct { 
         u32 valid : 1;                           // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 qpn : 24;                            // DWORD 0
         u32 dpp_count;                           // DWORD 1
         u32 rsvd1[2];                            // DWORDS 2 to 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_DPP_CQE_V2, *PROCE_DPP_CQE_V2;

SG_C_ASSERT(__sizeof__ROCE_DPP_CQE, sizeof (ROCE_DPP_CQE_V2) == 16);



typedef struct _ROCE_RX_CONTROL_V2 {
   union {
      struct { 
         u32 Opcode : 4;                          // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 NumCont : 7;                         // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 Tag : 16;                            // DWORD 1
         u32 rsvd2 : 16;                          // DWORD 1
         u32 rsvd3[1];                            // DWORDS 2 to 2
         u32 rsvd4[1];                            // DWORDS 3 to 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RX_CONTROL_V2, *PROCE_RX_CONTROL_V2;

SG_C_ASSERT(__sizeof__ROCE_RX_CONTROL, sizeof (ROCE_RX_CONTROL_V2) == 16);



typedef struct _ROCE_RX_WQE_V2 {
   union {
      struct { 
         ROCE_RX_CONTROL_V2 control;
         ROCE_TX_SGE_V2 sge[3];
      } SG_PACK ; // unnamed struct
      u32 dw[16]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RX_WQE_V2, *PROCE_RX_WQE_V2;

SG_C_ASSERT(__sizeof__ROCE_RX_WQE, sizeof (ROCE_RX_WQE_V2) == 64);


// --- ROCE_RX_STATUS ---
#define ROCE_RX_STATUS_SUCCESS_V2       (0)       
#define ROCE_RX_STATUS_LOCAL_LENGTH_ERROR_V2 (1)  
#define ROCE_RX_STATUS_LOCAL_OPERATION_ERROR_V2 (2) 
#define ROCE_RX_STATUS_LOCAL_PROTECTION_ERROR_V2 (3) 
#define ROCE_RX_STATUS_RX_FLUSH_V2      (4)       

// --- ROCE_DP_CQE_STATUS ---
#define ROCE_STATUS_SUCCESS_V2          (0)       
#define ROCE_STATUS_LOCAL_LENGTH_ERROR_V2 (1)     
#define ROCE_STATUS_LOCAL_OPERATION_ERROR_V2 (2)  
#define ROCE_STATUS_LOCAL_EEC_OPERATION_ERROR_V2 (3) 
#define ROCE_STATUS_LOCAL_PROTECTION_ERROR_V2 (4) 
#define ROCE_STATUS_WR_FLUSH_ERROR_V2   (5)       
#define ROCE_STATUS_MW_BIND_ERROR_V2    (6)       
#define ROCE_STATUS_BAD_RESP_ERROR_V2   (7)       
#define ROCE_STATUS_LOCAL_ACCESS_ERROR_V2 (8)     
#define ROCE_STATUS_REMOTE_INV_REQ_ERROR_V2 (9)   
#define ROCE_STATUS_REMOTE_ACCESS_ERROR_V2 (10)   
#define ROCE_STATUS_REMOTE_OP_ERROR_V2  (11)      
#define ROCE_STATUS_RETRY_EXCEED_ERROR_V2 (12)    
#define ROCE_STATUS_RNR_RETRY_EXCEED_ERROR_V2 (13) 
#define ROCE_STATUS_FATAL_ERROR_V2      (19)      
#define ROCE_STATUS_RESP_TIMEOUT_ERROR_V2 (20)    
#define ROCE_STATUS_GENERAL_ERROR_V2    (21)      


typedef struct _ROCE_RX_COMPL_V2 {
   union {
      struct { 
         u32 immed_data;                          // DWORD 0
         u32 bytes_transferred;                   // DWORD 1
         u32 qp_id : 16;                          // DWORD 2
         u32 srq_buff_tag : 16;                   // DWORD 2
         u32 srq_buff_tag_fw : 16;                // DWORD 3
         u32 status : 8;                          // DWORD 3
         u32 rsvd0 : 3;                           // DWORD 3
         u32 w : 1;                               // DWORD 3
         u32 i : 1;                               // DWORD 3
         u32 q : 1;                               // DWORD 3
         u32 s : 1;                               // DWORD 3
         u32 v : 1;                               // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RX_COMPL_V2, *PROCE_RX_COMPL_V2;

SG_C_ASSERT(__sizeof__ROCE_RX_COMPL, sizeof (ROCE_RX_COMPL_V2) == 16);



typedef struct _ROCE_RX_UD_COMPL_V2 {
   union {
      struct { 
         u32 immed_data;                          // DWORD 0
         u32 pkey : 16;                           // DWORD 1
         u32 bytes_transferred : 16;              // DWORD 1
         u32 qp_id : 16;                          // DWORD 2
         u32 srq_buff_tag : 16;                   // DWORD 2
         u32 src_qp_id : 24;                      // DWORD 3
         u32 status : 3;                          // DWORD 3
         u32 w : 1;                               // DWORD 3
         u32 i : 1;                               // DWORD 3
         u32 q : 1;                               // DWORD 3
         u32 s : 1;                               // DWORD 3
         u32 v : 1;                               // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ROCE_RX_UD_COMPL_V2, *PROCE_RX_UD_COMPL_V2;

SG_C_ASSERT(__sizeof__ROCE_RX_UD_COMPL, sizeof (ROCE_RX_UD_COMPL_V2) == 16);



typedef struct _ROCE_FP_DATA_HEADER_V2 {
   union {
      struct { 
         u32 wr_start : 1;                        // DWORD 0
         u32 wr_len : 8;                          // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK ROCE_FP_DATA_HEADER_V2, *PROCE_FP_DATA_HEADER_V2;

SG_C_ASSERT(__sizeof__ROCE_FP_DATA_HEADER, sizeof (ROCE_FP_DATA_HEADER_V2) == 4);


// --- ROCE_TX_OPCODE ---
#define ROCE_OP_SEND_V2                 (0)       
#define ROCE_OP_RDMA_WRITE_V2           (6)       
#define ROCE_OP_BIND_MEMORY_WIN_V2      (8)       
#define ROCE_OP_RDMA_READ_V2            (12)      
#define ROCE_OP_RDMA_READ_RESP_V2       (13)      
#define ROCE_OP_FAST_REGISTER_V2        (17)      
#define ROCE_OP_LOCAL_INVAL_V2          (21)      

// --- ROCE_OP_FLAGS ---
#define ROCE_OP_FLAG_SIGNAL_V2          (1)       
#define ROCE_OP_FLAG_INVALIDATE_V2      (2)       
#define ROCE_OP_FLAG_SE_V2              (16)      
#define ROCE_OP_FLAG_IMMEDIATE_V2       (32)      


typedef struct _LL_ROCE_HDR_WRB_V2 {
   union {
      struct { 
         u32 opcode : 5;                          // DWORD 0
         u32 flags : 11;                          // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 posting_size : 7;                    // DWORD 0
         u32 next_posting_size : 7;               // DWORD 0
         u32 rsvd0[1];                            // DWORDS 1 to 1
         u32 memkey_or_imm_data;                  // DWORD 2
         u32 total_byte_count;                    // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK LL_ROCE_HDR_WRB_V2, *PLL_ROCE_HDR_WRB_V2;

SG_C_ASSERT(__sizeof__LL_ROCE_HDR_WRB, sizeof (LL_ROCE_HDR_WRB_V2) == 16);



typedef struct _ROCE_AHR_ENTRY_V2 {
   union {
      struct { 
         u32 dst_mac_hi;                          // DWORD 0
         u32 src_mac_hi : 16;                     // DWORD 1
         u32 dst_mac_lo : 16;                     // DWORD 1
         u32 src_mac_lo;                          // DWORD 2
         u32 flow_label_hi : 4;                   // DWORD 3
         u32 traffic_class : 8;                   // DWORD 3
         u32 ip_ver : 4;                          // DWORD 3
         u32 eth_type : 16;                       // DWORD 3
         u32 payload_len : 16;                    // DWORD 4
         u32 flow_label_lo : 16;                  // DWORD 4
         u32 sgid0 : 16;                          // DWORD 5
         u32 hop_limit : 8;                       // DWORD 5
         u32 nxt_header : 8;                      // DWORD 5
         u32 sgid1;                               // DWORD 6
         u32 sgid2;                               // DWORD 7
         u32 sgid3;                               // DWORD 8
         u32 dgid0 : 16;                          // DWORD 9
         u32 sgid4 : 16;                          // DWORD 9
         u32 dgid1;                               // DWORD 10
         u32 dgid2;                               // DWORD 11
         u32 dgid3;                               // DWORD 12
         u32 rsvd0 : 16;                          // DWORD 13
         u32 dgid4 : 16;                          // DWORD 13
         u32 rsvd1[1];                            // DWORDS 14 to 14
         u32 rsvd2 : 31;                          // DWORD 15
         u32 valid : 1;                           // DWORD 15
      } SG_PACK ; // unnamed struct
      u32 dw[16]; // dword union
   }; // unnamed union
} SG_PACK ROCE_AHR_ENTRY_V2, *PROCE_AHR_ENTRY_V2;

SG_C_ASSERT(__sizeof__ROCE_AHR_ENTRY, sizeof (ROCE_AHR_ENTRY_V2) == 64);



typedef struct _ROCE_AHR_ENTRY2_V2 {
   union {
      struct { 
         u32 dst_mac_hi;                          // DWORD 0
         u32 src_mac_hi : 16;                     // DWORD 1
         u32 dst_mac_lo : 16;                     // DWORD 1
         u32 src_mac_lo;                          // DWORD 2
         u32 eth_type1 : 16;                      // DWORD 3
         u32 vlan_id : 16;                        // DWORD 3
         u32 flow_label_hi : 4;                   // DWORD 4
         u32 traffic_class : 8;                   // DWORD 4
         u32 ip_ver : 4;                          // DWORD 4
         u32 eth_type2 : 16;                      // DWORD 4
         u32 payload_len : 16;                    // DWORD 5
         u32 flow_label_lo : 16;                  // DWORD 5
         u32 sgid0 : 16;                          // DWORD 6
         u32 hop_limit : 8;                       // DWORD 6
         u32 nxt_header : 8;                      // DWORD 6
         u32 sgid1;                               // DWORD 7
         u32 sgid2;                               // DWORD 8
         u32 sgid3;                               // DWORD 9
         u32 dgid0 : 16;                          // DWORD 10
         u32 sgid4 : 16;                          // DWORD 10
         u32 dgid1;                               // DWORD 11
         u32 dgid2;                               // DWORD 12
         u32 dgid3;                               // DWORD 13
         u32 rsvd0 : 16;                          // DWORD 14
         u32 dgid4 : 16;                          // DWORD 14
         u32 rsvd1 : 31;                          // DWORD 15
         u32 valid : 1;                           // DWORD 15
      } SG_PACK ; // unnamed struct
      u32 dw[16]; // dword union
   }; // unnamed union
} SG_PACK ROCE_AHR_ENTRY2_V2, *PROCE_AHR_ENTRY2_V2;

SG_C_ASSERT(__sizeof__ROCE_AHR_ENTRY2, sizeof (ROCE_AHR_ENTRY2_V2) == 64);



typedef struct _GENERIC_DB_V2 {
   union {
      struct { 
         u32 data;                                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK GENERIC_DB_V2, *PGENERIC_DB_V2;

SG_C_ASSERT(__sizeof__GENERIC_DB, sizeof (GENERIC_DB_V2) == 4);



typedef struct _ERX_DB_V2 {
   union {
      struct { 
         u32 ring : 16;                           // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 kill : 1;                            // DWORD 0
         u32 numPosted : 8;                       // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK ERX_DB_V2, *PERX_DB_V2;

SG_C_ASSERT(__sizeof__ERX_DB, sizeof (ERX_DB_V2) == 4);



typedef struct _MCC_DB_V2 {
   union {
      struct { 
         u32 rid : 11;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 numPosted : 14;                      // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK MCC_DB_V2, *PMCC_DB_V2;

SG_C_ASSERT(__sizeof__MCC_DB, sizeof (MCC_DB_V2) == 4);



typedef struct _MPU_MAILBOX_DB_V2 {
   union {
      struct { 
         u32 ready : 1;                           // DWORD 0
         u32 hi : 1;                              // DWORD 0
         u32 address : 30;                        // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK MPU_MAILBOX_DB_V2, *PMPU_MAILBOX_DB_V2;

SG_C_ASSERT(__sizeof__MPU_MAILBOX_DB, sizeof (MPU_MAILBOX_DB_V2) == 4);



typedef struct _MPU_SCRATCHPAD0_DB_V2 {
   union {
      struct { 
         u32 data0 : 16;                          // DWORD 0
         u32 data1 : 16;                          // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK MPU_SCRATCHPAD0_DB_V2, *PMPU_SCRATCHPAD0_DB_V2;

SG_C_ASSERT(__sizeof__MPU_SCRATCHPAD0_DB, sizeof (MPU_SCRATCHPAD0_DB_V2) == 4);



typedef struct _PROTECTION_DOMAIN_DBMAP_V2 {
   union {
      struct { 
         u32 rsvd0[16];                           // DWORDS 0 to 15
         GENERIC_DB_V2 txulp0_db;
         u32 rsvd1[7];                            // DWORDS 17 to 23
         GENERIC_DB_V2 txulp1_db;
         u32 rsvd2[15];                           // DWORDS 25 to 39
         GENERIC_DB_V2 rxulp0_db;
         u32 rsvd3[7];                            // DWORDS 41 to 47
         GENERIC_DB_V2 rxulp1_db;
         u32 rsvd4[15];                           // DWORDS 49 to 63
         ERX_DB_V2 erx_db;
         u32 rsvd5[7];                            // DWORDS 65 to 71
         GENERIC_DB_V2 cq_db;
         u32 rsvd6[7];                            // DWORDS 73 to 79
         MCC_DB_V2 mpu_mcc_db;
         u32 rsvd7[7];                            // DWORDS 81 to 87
         MPU_MAILBOX_DB_V2 mpu_mailbox_db;
         u32 rsvd8[7];                            // DWORDS 89 to 95
         MPU_SCRATCHPAD0_DB_V2 mpu_scratch0;
         u32 rsvd9[15];                           // DWORDS 97 to 111
         GENERIC_DB_V2 lltxulp_db;
         u32 rsvd10[911];                         // DWORDS 113 to 1023
      } SG_PACK ; // unnamed struct
      u32 dw[1024]; // dword union
   }; // unnamed union
} SG_PACK PROTECTION_DOMAIN_DBMAP_V2, *PPROTECTION_DOMAIN_DBMAP_V2;

SG_C_ASSERT(__sizeof__PROTECTION_DOMAIN_DBMAP, sizeof (PROTECTION_DOMAIN_DBMAP_V2) == 4096);



typedef struct _SH_HW_LRO_COMPL_V1_PART1_V2 {
   union {
      struct { 
         u32 tcp_timestamp_val;                   // DWORD 0
         u32 tcp_timestamp_ecr;                   // DWORD 1
         u32 rss_flush : 1;                       // DWORD 2
         u32 rq_flush : 1;                        // DWORD 2
         u32 rsvd0 : 1;                           // DWORD 2
         u32 QnQ : 1;                             // DWORD 2
         u32 rss_bank : 1;                        // DWORD 2
         u32 lro_timer_pop : 1;                   // DWORD 2
         u32 lro_desc : 1;                        // DWORD 2
         u32 rsvd1 : 1;                           // DWORD 2
         u32 data_offset : 8;                     // DWORD 2
         u32 rsvd2 : 2;                           // DWORD 2
         u32 rss_policy : 4;                      // DWORD 2
         u32 debug1 : 7;                          // DWORD 2
         u32 type : 2;                            // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 rsshash;                             // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK SH_HW_LRO_COMPL_V1_PART1_V2, *PSH_HW_LRO_COMPL_V1_PART1_V2;

SG_C_ASSERT(__sizeof__SH_HW_LRO_COMPL_V1_PART1, sizeof (SH_HW_LRO_COMPL_V1_PART1_V2) == 16);



typedef struct _SH_HW_LRO_COMPL_V1_PART2_V2 {
   union {
      struct { 
         u32 vlan_tag : 16;                       // DWORD 0
         u32 pktsize : 14;                        // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 ip_opt : 1;                          // DWORD 0
         u32 coalesced_size : 16;                 // DWORD 1
         u32 tcp_window : 16;                     // DWORD 1
         u32 err : 1;                             // DWORD 2
         u32 rsshp : 1;                           // DWORD 2
         u32 ipf : 1;                             // DWORD 2
         u32 tcpf : 1;                            // DWORD 2
         u32 udpf : 1;                            // DWORD 2
         u32 ipcksm : 1;                          // DWORD 2
         u32 l4_cksm : 1;                         // DWORD 2
         u32 ip_version : 1;                      // DWORD 2
         u32 frame_lifespan : 8;                  // DWORD 2
         u32 segment_count : 8;                   // DWORD 2
         u32 threshold : 1;                       // DWORD 2
         u32 ts_opt : 1;                          // DWORD 2
         u32 push : 1;                            // DWORD 2
         u32 rsvd0 : 2;                           // DWORD 2
         u32 type_LRO : 2;                        // DWORD 2
         u32 valid_LRO : 1;                       // DWORD 2
         u32 tcp_ack_number;                      // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK SH_HW_LRO_COMPL_V1_PART2_V2, *PSH_HW_LRO_COMPL_V1_PART2_V2;

SG_C_ASSERT(__sizeof__SH_HW_LRO_COMPL_V1_PART2, sizeof (SH_HW_LRO_COMPL_V1_PART2_V2) == 16);



typedef struct _SH_HW_LRO_COMPL_V1_V2 {
   union {
      struct { 
         u32 tcp_timestamp_val;                   // DWORD 0
         u32 tcp_timestamp_ecr;                   // DWORD 1
         u32 rss_flush : 1;                       // DWORD 2
         u32 rq_flush : 1;                        // DWORD 2
         u32 rsvd0 : 1;                           // DWORD 2
         u32 QnQ : 1;                             // DWORD 2
         u32 rss_bank : 1;                        // DWORD 2
         u32 lro_timer_pop : 1;                   // DWORD 2
         u32 lro_desc : 1;                        // DWORD 2
         u32 rsvd1 : 1;                           // DWORD 2
         u32 data_offset : 8;                     // DWORD 2
         u32 rsvd2 : 2;                           // DWORD 2
         u32 rss_policy : 4;                      // DWORD 2
         u32 debug1 : 7;                          // DWORD 2
         u32 type : 2;                            // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 rsshash;                             // DWORD 3
         u32 vlan_tag : 16;                       // DWORD 4
         u32 pktsize : 14;                        // DWORD 4
         u32 vtp : 1;                             // DWORD 4
         u32 ip_opt : 1;                          // DWORD 4
         u32 coalesced_size : 16;                 // DWORD 5
         u32 tcp_window : 16;                     // DWORD 5
         u32 err : 1;                             // DWORD 6
         u32 rsshp : 1;                           // DWORD 6
         u32 ipf : 1;                             // DWORD 6
         u32 tcpf : 1;                            // DWORD 6
         u32 udpf : 1;                            // DWORD 6
         u32 ipcksm : 1;                          // DWORD 6
         u32 l4_cksm : 1;                         // DWORD 6
         u32 ip_version : 1;                      // DWORD 6
         u32 frame_lifespan : 8;                  // DWORD 6
         u32 segment_count : 8;                   // DWORD 6
         u32 threshold : 1;                       // DWORD 6
         u32 ts_opt : 1;                          // DWORD 6
         u32 push : 1;                            // DWORD 6
         u32 rsvd3 : 2;                           // DWORD 6
         u32 type_LRO : 2;                        // DWORD 6
         u32 valid_LRO : 1;                       // DWORD 6
         u32 tcp_ack_number;                      // DWORD 7
      } SG_PACK ; // unnamed struct
      u32 dw[8]; // dword union
   }; // unnamed union
} SG_PACK SH_HW_LRO_COMPL_V1_V2, *PSH_HW_LRO_COMPL_V1_V2;

SG_C_ASSERT(__sizeof__SH_HW_LRO_COMPL_V1, sizeof (SH_HW_LRO_COMPL_V1_V2) == 32);



typedef struct _SH_HW_ERX_COMPL_V1_V2 {
   union {
      struct { 
         u32 vlan_tag : 16;                       // DWORD 0
         u32 pktsize : 14;                        // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 ip_opt : 1;                          // DWORD 0
         u32 err : 1;                             // DWORD 1
         u32 rsshp : 1;                           // DWORD 1
         u32 ipf : 1;                             // DWORD 1
         u32 tcpf : 1;                            // DWORD 1
         u32 udpf : 1;                            // DWORD 1
         u32 ipcksm : 1;                          // DWORD 1
         u32 l4_cksm : 1;                         // DWORD 1
         u32 ip_version : 1;                      // DWORD 1
         u32 rsvd0 : 16;                          // DWORD 1
         u32 rsvd1 : 5;                           // DWORD 1
         u32 rsvd2 : 2;                           // DWORD 1
         u32 rsvd3 : 1;                           // DWORD 1
         u32 rss_flush : 1;                       // DWORD 2
         u32 rq_flush : 1;                        // DWORD 2
         u32 rsvd4 : 1;                           // DWORD 2
         u32 QnQ : 1;                             // DWORD 2
         u32 rss_bank : 1;                        // DWORD 2
         u32 lro_timer_pop : 1;                   // DWORD 2
         u32 lro_desc : 1;                        // DWORD 2
         u32 rsvd5 : 1;                           // DWORD 2
         u32 data_offset : 8;                     // DWORD 2
         u32 rsvd6 : 2;                           // DWORD 2
         u32 rss_policy : 4;                      // DWORD 2
         u32 debug1 : 7;                          // DWORD 2
         u32 type : 2;                            // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 rsshash;                             // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK SH_HW_ERX_COMPL_V1_V2, *PSH_HW_ERX_COMPL_V1_V2;

SG_C_ASSERT(__sizeof__SH_HW_ERX_COMPL_V1, sizeof (SH_HW_ERX_COMPL_V1_V2) == 16);


// --- ENZ_WORKAROUND ---
#define SUBSYSTEM_ETH_GET_STATISTICS_V2_V2 (3)    
#define OPCODE_ETH_GET_STATISTICS_V2_V2 (4)       


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __sh_nic_v2_bmap_h__

